# Fortran Standard Library

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.18346789.svg)](https://doi.org/10.5281/zenodo.18346789)
[![Actions Status](https://github.com/fortran-lang/stdlib/workflows/CI/badge.svg)](https://github.com/fortran-lang/stdlib/actions)
[![Actions Status](https://github.com/fortran-lang/stdlib/workflows/CI_windows/badge.svg)](https://github.com/fortran-lang/stdlib/actions)

* [Goals and Motivation](#goals-and-motivation)
* [Scope](#scope)
* [Getting started](#getting-started)
  - [Get the code](#get-the-code)
  - [Requirements](#requirements)
  - [Supported compilers](#supported-compilers)
  - [Build with CMake](#build-with-cmake)
  - [Build with fortran-lang/fpm](#build-with-fortran-langfpm)
* [Using stdlib in your project](#using-stdlib-in-your-project)
* [Documentation](#documentation)
* [Contributing](#contributing)
* [Links](#links)

## Goals and Motivation

The Fortran Standard, as published by the ISO (https://wg5-fortran.org/), does
not have a Standard Library. The goal of this project is to provide a community
driven and agreed upon *de facto* "standard" library for Fortran, called a
Fortran Standard Library (`stdlib`). We have a rigorous process how `stdlib` is
developed as documented in our [Workflow](WORKFLOW.md). `stdlib` is both a
specification and a reference implementation. We are cooperating with the
Fortran Standards Committee (e.g., the effort
[started](https://github.com/j3-fortran/fortran_proposals/issues/104) at the J3
committee repository) and the plan is to continue working with the Committee in
the future (such as in the step 5. in the [Workflow](WORKFLOW.md) document), so
that if the Committee wants to standardize some feature already available in `stdlib`, it would
base it on `stdlib`'s implementation.

## Scope

The goal of the Fortran Standard Library is to achieve the following general scope:

* Utilities (containers, strings, files, OS/environment integration, unit
  testing & assertions, logging,  ...)
* Algorithms (searching and sorting, merging, ...)
* Mathematics (linear algebra, sparse matrices, special functions, fast Fourier
  transform, random numbers, statistics, ordinary differential equations,
  numerical integration, optimization, ...)


## Getting started

### Get the code

```sh
git clone https://github.com/fortran-lang/stdlib
cd stdlib
```


### Requirements

To build the Fortran standard library you need

- a Fortran 2008 compliant compiler, or better, a Fortran 2018 compliant compiler
  (GCC Fortran and Intel Fortran compilers are known to work for stdlib)
- CMake version 3.14 or newer (alternatively Make can be used)
- a build backend for CMake, like Make or Ninja (the latter is recommended on Windows)
- the [fypp](https://github.com/aradi/fypp) preprocessor (used as meta-programming tool)

If your system package manager does not provide the required build tools, all build dependencies can be installed with the Python command line installer ``pip``:

```sh
pip install --user fypp cmake ninja
```

Alternatively, you can install the build tools from the conda-forge channel with the conda package manager:

```sh
conda config --add channels conda-forge
conda create -n stdlib-tools fypp cmake ninja
conda activate stdlib-tools
```

You can install conda using the [miniforge installer](https://github.com/conda-forge/miniforge/releases).
Also, you can install a Fortran compiler from conda-forge by installing the ``fortran-compiler`` package, which installs GFortran.


### Supported Compilers

The following combinations are tested on the default branch of stdlib:

Name | Version | Platform | Architecture
--- | --- | --- | ---
GCC Fortran | 10, 11, 12, 13, 14 | Ubuntu 24.04.3 LTS | x86_64
GCC Fortran | 11, 12, 13, 14, 15 | macOS 14.8.2 (23J126) | Arm64
GCC Fortran (MSYS) | 13 | Windows Server 2022 (10.0.20348 Build 1547) | x86_64
GCC Fortran (MinGW) | 13 | Windows Server 2022 (10.0.20348 Build 1547) | x86_64
Intel oneAPI LLVM | 2024.1 | Ubuntu 24.04.3 LTS | x86_64
Intel oneAPI classic | 2021.10 | Ubuntu 22.04.5 LTS | x86_64

The following combinations are known to work, but they are not tested in the CI:

Name | Version | Platform | Architecture
--- | --- | --- | ---
GCC Fortran (MinGW) | 9.3.0, 10.2.0, 11.2.0 | Windows 10 | x86_64

We try to test as many available compilers and platforms as possible.
A list of tested compilers which are currently not working and the respective issue are listed below.

Name | Version | Platform | Architecture | Status
--- | --- | --- | --- | ---
GCC Fortran | <9 | any | any | [#296](https://github.com/fortran-lang/stdlib/issues/296), [#430](https://github.com/fortran-lang/stdlib/pull/430)
NVIDIA HPC SDK | 20.7, 20.9, 20.11 | Manjaro Linux 20 | x86_64 | [#107](https://github.com/fortran-lang/stdlib/issues/107)
NAG | 7.0 | RHEL | x86_64 | [#108](https://github.com/fortran-lang/stdlib/issues/108)
Intel Parallel Studio XE | 16, 17, 18 | OpenSUSE | x86_64 | failed to compile

Please share your experience with successful and failing builds for compiler/platform/architecture combinations not covered above.


### Build with CMake

Configure the build with

```sh
cmake -B build
```

You can pass additional options to CMake to customize the build.
Important options are

- `-G Ninja` to use the Ninja backend instead of the default Make backend. Other build backends are available with a similar syntax.
- `-DCMAKE_INSTALL_PREFIX` is used to provide the install location for the library. If not provided the defaults will depend on your operating system, [see here](https://cmake.org/cmake/help/latest/variable/CMAKE_INSTALL_PREFIX.html). 
- `-DCMAKE_MAXIMUM_RANK` the maximum array rank procedures should be generated for.
  The default value is chosen as 4.
  The maximum is 15 for Fortran 2003 compliant compilers, otherwise 7 for compilers not supporting Fortran 2003 completely yet.
  The minimum required rank to compile this project is 4.
  Compiling with maximum rank 15 can be resource intensive and requires at least 16 GB of memory to allow parallel compilation or 4 GB memory for sequential compilation.
- `-DBUILD_SHARED_LIBS` set to `on` in case you want link your application dynamically against the standard library (default: `off`).
- `-DBUILD_TESTING` set to `off` in case you want to disable the stdlib tests (default: `on`).
- `-DCMAKE_VERBOSE_MAKEFILE` is by default set to `Off`, but if set to `On` will show commands used to compile the code.
- `-DCMAKE_BUILD_TYPE` is by default set to `RelWithDebInfo`, which uses compiler flags suitable for code development (but with only `-O2` optimization). Beware the compiler flags set this way will override any compiler flags specified via `FFLAGS`. To prevent this, use `-DCMAKE_BUILD_TYPE=NoConfig` in conjunction with `FFLAGS`.
- `-DFIND_BLAS` set to `off` in case you want to disable finding the external BLAS/LAPACK dependency (default: `on`).

For example, to configure a build using the Ninja backend while specifying compiler optimization via `FFLAGS`, generating procedures up to rank 7, installing to your home directory, using the `NoConfig` compiler flags, and printing the compiler commands, use

```sh
export FFLAGS="-O3"
cmake -B build -G Ninja -DCMAKE_MAXIMUM_RANK:String=7 -DCMAKE_INSTALL_PREFIX=$HOME/.local -DCMAKE_VERBOSE_MAKEFILE=On -DCMAKE_BUILD_TYPE=NoConfig
```

To build the standard library run

```sh
cmake --build build
```

To test your build, run the test suite and all example programs after the build has finished with

```sh
cmake --build build --target test
```

To test only the test suite, run
```sh
ctest --test-dir build/test
```

Please report failing tests on our [issue tracker](https://github.com/fortran-lang/stdlib/issues/new/choose) including details of the compiler used, the operating system and platform architecture.

To install the project to the declared prefix run

```sh
cmake --install build
```

Now you have a working version of stdlib you can use for your project.

If at some point you wish to recompile `stdlib` with different options, you might
want to delete the `build` folder. This will ensure that cached variables from
earlier builds do not affect the new build.

### Build with [fortran-lang/fpm](https://github.com/fortran-lang/fpm)

Fortran Package Manager (fpm) is a package manager and build system for Fortran.   
You can build `stdlib` using provided `fpm.toml`:

**Option 1**: From root folder

As `fpm` does not currently support `fypp` natively, `stdlib` now proposes a python script to preprocess and build it.
This script enables modification of the different `fypp` macros available in `stdlib`. The preprocessed files will be dumped at `<current_folder>/temp/*.f90` or `*.F90`.

Make sure to install the dependencies from the `requirement.txt`
```sh
pip install --upgrade -r config/requirements.txt
```

To build, you can use the following command line:

```sh
python config/fypp_deployment.py
fpm build --profile release
```

or the short-cut

```sh
python config/fypp_deployment.py --build
```

To modify the `maxrank` macro for instance:
```sh
python config/fypp_deployment.py --maxrank 7 --build
```

To see all the options:
```sh
python config/fypp_deployment.py --help
```

**Note**: If you use a compiler different than GNU compilers, the script will try to catch it from the environment variables `FPM_FC`, `FPM_CC`, `FPM_CXX`.

**Option 2**: From the `stdlib-fpm` branch which has already been preprocessed with default macros:
```sh
git checkout stdlib-fpm
fpm build --profile release
```


#### Installing with fpm

Either option you chose for building the `stdlib`, you can install it with:
```sh
fpm install --profile release
```
The command above will install the following files:
- `libstdlib.a` into `~/.local/lib/` (Unix) or `C:\Users\<username>\AppData\Roaming\local\lib\` (Windows)
- all the `.[s]mod` files produced by the compiler into `~/.local/include/` (Unix) or `C:\Users\<username>\AppData\Roaming\local\include\` (Windows)

You can change the installation path by setting the prefix option to `fpm`:
```sh
fpm install --profile release --prefix /my/custom/installation/path/
```

You can use the `stdlib` by adding the `-lstdlib` flag to your compiler.
If your prefix is a non standard path, add also:
- `-L/my/custom/installation/path/lib`
- `-I/my/custom/installation/path/include`

#### Running the examples
You can run the examples with `fpm` as:

```sh
fpm run --example prog
```

with `prog` being the name of the example program (e.g., `example_sort`).


### Preprocessing macros and flags

`stdlib` uses two preprocessing steps:

- *fypp* for meta-programming (templating and feature selection)
- *C* preprocessing (activated through compiler flags like `-cpp`(GNU) or `-fpp`(Intel) or use of uppercase file suffix .F90) for conditional compilation

*fypp* preprocessing macros and flags are supported through `CMake` or the `python` script `config/fypp_deployment.py`.
*C* preprocessing macros and flags are supported through `CMake` and `fpm`.

The table below lists all *fypp* preprocessing macros and flags currently used by `stdlib`:

| Macro/flag Name | Comments |
| --- | --- |
| `MAXRANK` |  Maximum array rank generated by templates. Set via CMake `-DCMAKE_MAXIMUM_RANK=<n>` (passed to fypp as `-DMAXRANK=<n>`), or via fypp deployment script `--maxrank <n>`. |
| `VERSION90` |  Defines the default maximum rank generated when `MAXRANK` is not defined. If defined, the maximum rank generated is 7; otherwise it is 15. Can be passed to fypp as `-DVERSION90` (CMake sets this automatically in some configurations). |
| `WITH_CBOOL` |  Enables `c_bool` logical support if available. CMake auto-detects this and passes it to fypp; can be overridden at configure time with `-DWITH_CBOOL=ON/OFF`. |
| `WITH_QP` |  Enables quadruple precision code generation (`real(qp)`, `complex(qp)`). CMake auto-detects this and passes it to fypp; can be overridden at configure time with `-DWITH_QP=ON/OFF`; fypp deployment script: `--with_qp`. |
| `WITH_XDP` |  Enables extended double precision code generation (`real(xdp)`, `complex(xdp)`). CMake auto-detects this and passes it to fypp; can be overridden at configure time with `-DWITH_XDP=ON/OFF`; fypp deployment script: `--with_xdp`. |
| `WITH_ILP64` |  Enables generation of 64-bit integer (ILP64) size interfaces for BLAS and LAPACK (in addition to the default 32-bit interface). Set via CMake `-DWITH_ILP64=True` or via  fypp deployment script `--with_ilp64`. |
| `PROJECT_VERSION_MAJOR` |  Part of the version string passed into fypp templates. Set automatically by CMake from the file `VERSION`. Can be overridden by passing `-DPROJECT_VERSION_MAJOR=<n>`, or via fypp deployment script `--vmajor <n>`. |
| `PROJECT_VERSION_MINOR` |  See `PROJECT_VERSION_MAJOR`. |
| `PROJECT_VERSION_PATCH` |  See `PROJECT_VERSION_MAJOR`. |


The table below lists all *C preprocessing* macros and flags currently used by `stdlib`:

| Macro/flag Name | Comments |
| --- | --- |
| `STDLIB_ANSI` | Enables compilation of the `stdlib_ansi` module when set to 1 (default). Set via CMake with `-DSTDLIB_ANSI=On/Off`. |
| `STDLIB_BITSETS` | Enables compilation of the `stdlib_bitsets` module when set to 1 (default). Set via CMake with `-DSTDLIB_BITSETS=On/Off`. |
| `STDLIB_EXTERNAL_BLAS` |  Links against an external BLAS (32-bit integer interface). Set automatically by CMake when external BLAS/LAPACK are found, or manually via `add_compile_definitions(STDLIB_EXTERNAL_BLAS)`. In fpm: `preprocess.cpp.macros=["STDLIB_EXTERNAL_BLAS"]`. |
| `STDLIB_EXTERNAL_LAPACK` |  Links against an external LAPACK (32-bit integer interface). Usually paired with `STDLIB_EXTERNAL_BLAS`. |
| `STDLIB_EXTERNAL_BLAS_I64` |  Links against an external BLAS with ILP64 (64-bit integer) interfaces. Usually paired with `STDLIB_EXTERNAL_LAPACK_I64`. |
| `STDLIB_EXTERNAL_LAPACK_I64` |  Links against an external LAPACK with ILP64 (64-bit integer) interfaces. |
| `STDLIB_HASHMAPS` | Enables compilation of the `stdlib_hashmaps` module when set to 1 (default). Set via CMake with `-DSTDLIB_HASHMAPS=On/Off`. |
| `STDLIB_IO` | Enables compilation of the `stdlib_io` module when set to 1 (default). Set via CMake with `-DSTDLIB_IO=On/Off`. |
| `STDLIB_LINALG_ITERATIVE` | Enables compilation of the `stdlib_linalg_iterative_solvers` module when set to 1 (default). Set via CMake with `-DSTDLIB_LINALG_ITERATIVE=On/Off`. |
| `STDLIB_LOGGER` | Enables compilation of the `stdlib_logger` module when set to 1 (default). Set via CMake with `-DSTDLIB_LOGGER=On/Off`. |
| `STDLIB_QUADRATURE` | Enables compilation of the `stdlib_quadrature` module when set to 1 (default). Set via CMake with `-DSTDLIB_QUADRATURE=On/Off`. |
| `STDLIB_SPECIALMATRICES` | Enables compilation of the `stdlib_specialmatrices` module when set to 1 (default). Set via CMake with `-DSTDLIB_SPECIALMATRICES=On/Off`. |
| `STDLIB_STATS` | Enables compilation of the `stdlib_stats` module when set to 1 (default). Set via CMake with `-DSTDLIB_STATS=On/Off`. |
| `STDLIB_STRINGLIST` | Enables compilation of the `stdlib_stringlist` module when set to 1 (default). Set via CMake with `-DSTDLIB_STRINGLIST=On/Off`. |
| `STDLIB_SYSTEM` | Enables compilation of the `stdlib_system` module when set to 1 (default). Set via CMake with `-DSTDLIB_SYSTEM=On/Off`. |

## Using stdlib in your project

### Using stdlib with CMake

The stdlib project exports CMake package files and pkg-config files to make stdlib usable for other projects.
The package files are located in the library directory in the installation prefix.

For CMake builds of stdlib you can find a local installation with

```cmake
find_package(fortran_stdlib REQUIRED)
...
target_link_libraries(
  ${PROJECT_NAME}
  PRIVATE
  fortran_stdlib::fortran_stdlib
)
```

To make the installed stdlib project discoverable add the stdlib directory to the ``CMAKE_PREFIX_PATH``.
The usual install location of the package files is ``$PREFIX/lib/cmake/fortran_stdlib``.

### Using stdlib with fpm

To use `stdlib` within your `fpm` project, add the following lines to your `fpm.toml` file:
```toml
[dependencies]
stdlib = { git="https://github.com/fortran-lang/stdlib", branch="stdlib-fpm" }
```

> **Warning**
> 
> Fpm 0.9.0 and later implements stdlib as a *metapackage*.
> To include the standard library metapackage, change the dependency to:
> `stdlib = "*"`.
> 
> [see also](https://fpm.fortran-lang.org/spec/metapackages.html)

### Using stdlib with a regular Makefile

After the library has been built, it can be included in a regular Makefile.
The recommended way to do this is using the [pkg-config](https://www.freedesktop.org/wiki/Software/pkg-config/) tool, for which an example is shown below.
```make
# Necessary if the installation directory is not in PKG_CONFIG_PATH
install_dir := path/to/install_dir
export PKG_CONFIG_PATH := $(install_dir)/lib/pkgconfig:$(PKG_CONFIG_PATH)
# On some OS the pkgconfig file could be installed in lib64 instead of lib
# export PKG_CONFIG_PATH := $(install_dir)/lib64/pkgconfig:$(PKG_CONFIG_PATH)

STDLIB_CFLAGS := `pkg-config --cflags fortran_stdlib`
STDLIB_LIBS := `pkg-config --libs fortran_stdlib`

# Example definition of Fortran compiler and flags
FC := gfortran
FFLAGS := -O2 -Wall -g

# Definition of targets etc.
...

# Example rule to compile object files from .f90 files
%.o: %.f90
    $(FC) -c -o $@ $< $(FFLAGS) $(STDLIB_CFLAGS)

# Example rule to link an executable from object files
%: %.o
    $(FC) -o $@ $^ $(FFLAGS) $(STDLIB_LIBS)

```

The same can also be achieved without pkg-config.
If the library has been installed in a directory inside the compiler's search path,
only a flag `-lfortran_stdlib` is required.
If the installation directory is not in the compiler's search path, one can add for example
```make
install_dir := path/to/install_dir
libdir := $(install_dir)/lib
moduledir := $(install_dir)/include/fortran_stdlib/<compiler name and version>
```
The linker should then look for libraries in `libdir` (using e.g.`-L$(libdir)`) and the compiler should look for module files in `moduledir` (using e.g. `-I$(moduledir)`).
Alternatively, the library can also be included from a build directory without installation with
```make
build_dir := path/to/build_dir
libdir := $(build_dir)/src
moduledir := $(build_dir)/src/mod_files
```

## Documentation

Documentation is a work in progress (see issue [#4](https://github.com/fortran-lang/stdlib/issues/4)) but already available at [stdlib.fortran-lang.org](https://stdlib.fortran-lang.org).
This includes API documentation automatically generated from static analysis and markup comments in the source files
using the [FORD](https://github.com/Fortran-FOSS-programmers/ford/wiki) tool,
as well as a specification document or ["spec"](https://stdlib.fortran-lang.org/page/specs/index.html) for each proposed feature.

Some discussions and prototypes of proposed APIs along with a list of popular open source Fortran projects are available on the
[wiki](https://github.com/fortran-lang/stdlib/wiki).

## BLAS and LAPACK

`stdlib` ships full versions of BLAS and LAPACK, for all `real` and `complex` kinds, through generalized interface modules `stdlib_linalg_blas` and `stdlib_linalg_lapack`.
The 32- and 64-bit implementations may be replaced by external optimized libraries if available, which may allow for faster code.
When linking against external BLAS/LAPACK libraries, the user should define macros `STDLIB_EXTERNAL_BLAS` and `STDLIB_EXTERNAL_LAPACK`, 
to ensure that the external library version is used instead of the internal implementation. 

- In case of a CMake build, the necessary configuration can be added by ensuring both macros are defined:
  ```
  add_compile_definitions(STDLIB_EXTERNAL_BLAS STDLIB_EXTERNAL_LAPACK)
  ```
- In case of an `fpm` build, the stdlib dependency should be set as follows:
  ```toml
  [dependencies]
  stdlib = { git="https://github.com/fortran-lang/stdlib", branch="stdlib-fpm", preprocess.cpp.macros=["STDLIB_EXTERNAL_BLAS", "STDLIB_EXTERNAL_LAPACK"] }
  ```

Support for 64-bit integer size interfaces of all BLAS and LAPACK procedures may also be enabled 
by setting the CMake flag `-DWITH_ILP64=True`. The 64-bit integer version is always built in addition to 
the 32-bit integer version, that is always available. Additional macros `STDLIB_EXTERNAL_BLAS_I64` and `STDLIB_EXTERNAL_LAPACK_I64`  
may be defined to link against an external 64-bit integer library, such as Intel MKL. 

- In case of an `fpm` build, 64-bit integer linear algebra support is given via branch `stdlib-fpm-ilp64`:
  ```toml
  [dependencies]
  stdlib = { git="https://github.com/fortran-lang/stdlib", branch="stdlib-fpm-ilp64", preprocess.cpp.macros=["STDLIB_EXTERNAL_BLAS_I64", "STDLIB_EXTERNAL_LAPACK"] }
  ```

## Contributing

* [Guidelines](CONTRIBUTING.md)
* [Issues](https://github.com/fortran-lang/stdlib/issues)
* [Workflow](WORKFLOW.md)
* [Style guide](STYLE_GUIDE.md)
* [Code of conduct](CODE_OF_CONDUCT.md)
* [License](LICENSE)

## Links

* [Proposals for the Fortran Standard Committee](https://github.com/j3-fortran/fortran_proposals/)
* [US Fortran Standards Committee](https://j3-fortran.org/)
* [International Fortran Standard Committee](https://wg5-fortran.org/)

The hash_functions directory contains code to validate the Fortran hash functions against the original C/C++ codes. It consists of one executable `test_hash_functions` that:

* creates a file containing 2048 random 8 bit integers using the subroutine
  `generate_key_array`.

* reads the file generated by the subroutine `generate_key_array` and uses its contents to generate 2049 hashes for each C/C++ hash algorithm and outputs files containing the hashes.

* reads the file generated by the subroutine `generate_key_array` and uses its contents to generate 2049 hashes for each Fortran hash algorithm and compares the result with the corresponding outputs of C/C++ hash algorithms.

! Eigenvalues of a real symmetric / complex hermitian matrix 
program example_eigvalsh
  use stdlib_linalg, only: eigvalsh
  implicit none

  real, allocatable :: A(:,:),lambda(:)
  complex, allocatable :: cA(:,:)

  ! Decomposition of this symmetric matrix
  ! NB Fortran is column-major -> transpose input
  A = transpose(reshape( [ [2, 1, 4], &
                           [1, 3, 5], &
                           [4, 5, 4] ], [3,3] )) 

  ! Note: real symmetric matrices have real (orthogonal) eigenvalues and eigenvectors
  lambda = eigvalsh(A)
  print *, 'Symmetric matrix eigenvalues: ',lambda
  
  ! Complex hermitian matrices have real (orthogonal) eigenvalues and complex eigenvectors
  cA = A
  lambda = eigvalsh(cA)
  print *, 'Hermitian matrix eigenvalues: ',lambda
  
end program example_eigvalsh

! SPDX-Identifier: MIT
module test_insert_at
    use stdlib_error, only: check
    use stdlib_string_type, only: string_type, operator(//), operator(==)
    use stdlib_stringlist_type, only: stringlist_type, fidx, bidx, list_head, list_tail, operator(==)
    use stdlib_strings, only: to_string
    implicit none

contains

    subroutine test_insert_at_string_1
        type(stringlist_type)           :: work_list
        integer                         :: i, current_length
        character(len=:), allocatable   :: string
        integer, parameter              :: first = -100
        integer, parameter              :: last = 1

        work_list = stringlist_type()
        call check( work_list%len() == 0, "test_insert_at_string_1: constructor" )

        write (*,*) "test_insert_at_string_1: Starting test case 1!"
        current_length = 0
        do i = first, last
            string = to_string( i )
            call work_list%insert_at( fidx(i), string )
            current_length = current_length + 1

            call check( work_list%get( fidx(1) ) == string, "test_insert_at_string_1:&
                                    & get fidx(1) " // string )
            call check( work_list%get( list_head ) == string, "test_insert_at_string_1:&
                                    & get list_head " // string )
            call check( work_list%get( bidx(current_length) ) == string, "test_insert_at_string_1: get&
                                    & bidx(current_length) " // string )
            call check( work_list%get( list_tail ) == to_string(first), "test_insert_at_string_1: get&
                                    & list_tail " // string )

            call check( work_list%len() == current_length, "test_insert_at_string_1: length check "&
                                    & // to_string( current_length ) )

        end do

        ! compare work_list with [1, 0, -1, ..., ..., -99, -100]
        call compare_list( work_list, last, first - 1, 1)

        call work_list%clear()
        call work_list%clear()
        current_length = 0

        write (*,*) "test_insert_at_string_1: Starting test case 2!"
        do i = first, last
            string = to_string( i )
            call work_list%insert_at( bidx(i), string )
            current_length = current_length + 1

            call check( work_list%get( bidx(1) ) == string, "test_insert_at_string_1:&
                                    & get bidx(1) " // string )
            call check( work_list%get( list_tail ) == string, "test_insert_at_string_1:&
                                    & get list_tail " // string )
            call check( work_list%get( fidx(current_length) ) == string, "test_insert_at_string_1: get&
                                    & fidx(current_length) " // string )
            call check( work_list%get( list_head ) == to_string(first), "test_insert_at_string_1: get&
                                    & list_head " // string )

            call check( work_list%len() == current_length, "test_insert_at_string_1: length check "&
                                    & // to_string( current_length ) )

        end do

        ! compare work_list with [-100, -99, ..., ..., 0, 1]
        call compare_list( work_list, first, last + 1, 2)

    end subroutine test_insert_at_string_1

    subroutine test_insert_at_string_2
        type(stringlist_type)           :: work_list
        integer                         :: i, current_length
        character(len=:), allocatable   :: string
        integer, parameter              :: first = 2
        integer, parameter              :: last = 200

        write (*,*) "test_insert_at_string_2: Starting test case 1!"

        current_length = 0
        do i = first, last, 2
            string = to_string( i )
            call work_list%insert_at( fidx(i), string )
            current_length = current_length + 1

            call check( work_list%get( fidx(current_length) ) == string, "test_insert_at_string_2:&
                                    & get fidx(current_length) " // string )
            call check( work_list%get( fidx(1) ) == to_string(first), "test_insert_at_string_2:&
                                    & get fidx(1) " // string )
            call check( work_list%get( list_head ) == to_string(first), "test_insert_at_string_2:&
                                    & get list_head " // string )
            call check( work_list%get( bidx(1) ) == string, "test_insert_at_string_2:&
                                    & get bidx(1) " // string )
            call check( work_list%get( bidx(current_length) ) == to_string(first), "test_insert_at_string_2: get&
                                    & bidx(current_length) " // string )
            call check( work_list%get( list_tail ) == string, "test_insert_at_string_2: get&
                                    & list_tail " // string )

            call check( work_list%len() == current_length, "test_insert_at_string_2: length check "&
                                    & // to_string( current_length ) )

        end do

        write (*,*) "test_insert_at_string_2: Starting test case 2!"

        do i = first - 1, last - 1, 2
            string = to_string( i )
            call work_list%insert_at( fidx(i), string )
            current_length = current_length + 1

            call check( work_list%get( fidx(i) ) == string, "test_insert_at_string_2:&
                                    & get fidx(current_length) " // string )
            call check( work_list%get( fidx(1) ) == to_string(first - 1), "test_insert_at_string_2:&
                                    & get fidx(1) " // string )
            call check( work_list%get( list_head ) == to_string(first - 1), "test_insert_at_string_2:&
                                    & get list_head " // string )
            call check( work_list%get( bidx(1) ) == to_string(last), "test_insert_at_string_2:&
                                    & get bidx(1) " // string )
            call check( work_list%get( bidx(current_length) ) == to_string(first - 1), "test_insert_at_string_2: get&
                                    & bidx(current_length) " // string )
            call check( work_list%get( list_tail ) == to_string(last), "test_insert_at_string_2: get&
                                    & list_tail " // string )

            call check( work_list%len() == current_length, "test_insert_at_string_2: length check "&
                                    & // to_string( current_length ) )

        end do

        ! compare work_list with [1, 2, ..., ..., 199, 200]
        call compare_list( work_list, first - 1, last + 1, 3 )

    end subroutine test_insert_at_string_2

    subroutine test_insert_at_string_3
        type(stringlist_type)           :: work_list
        integer                         :: i, current_length
        character(len=:), allocatable   :: string
        integer, parameter              :: first = 2
        integer, parameter              :: last = 200

        write (*,*) "test_insert_at_string_3: Starting test case 1!"

        current_length = 0
        do i = first, last, 2
            string = to_string( i )
            call work_list%insert_at( bidx(i), string )
            current_length = current_length + 1

            call check( work_list%get( bidx(current_length) ) == string, "test_insert_at_string_3:&
                                    & get bidx(current_length) " // string )
            call check( work_list%get( bidx(1) ) == to_string(first), "test_insert_at_string_3:&
                                    & get bidx(1) " // string )
            call check( work_list%get( list_tail ) == to_string(first), "test_insert_at_string_3:&
                                    & get list_tail " // string )
            call check( work_list%get( fidx(1) ) == string, "test_insert_at_string_3:&
                                    & get fidx(1) " // string )
            call check( work_list%get( fidx(current_length) ) == to_string(first), "test_insert_at_string_3: get&
                                    & fidx(current_length) " // string )
            call check( work_list%get( list_head ) == string, "test_insert_at_string_3: get&
                                    & list_head " // string )

            call check( work_list%len() == current_length, "test_insert_at_string_3: length check "&
                                    & // to_string( current_length ) )

        end do

        write (*,*) "test_insert_at_string_3: Starting test case 2!"

        do i = first - 1, last - 1, 2
            string = to_string( i )
            call work_list%insert_at( bidx(i), string )
            current_length = current_length + 1

            call check( work_list%get( bidx(i) ) == string, "test_insert_at_string_3:&
                                    & get bidx(current_length) " // string )
            call check( work_list%get( bidx(1) ) == to_string(first - 1), "test_insert_at_string_3:&
                                    & get bidx(1) " // string )
            call check( work_list%get( list_tail ) == to_string(first - 1), "test_insert_at_string_3:&
                                    & get list_tail " // string )
            call check( work_list%get( fidx(1) ) == to_string(last), "test_insert_at_string_3:&
                                    & get fidx(1) " // string )
            call check( work_list%get( fidx(current_length) ) == to_string(first - 1), "test_insert_at_string_3: get&
                                    & fidx(current_length) " // string )
            call check( work_list%get( list_head ) == to_string(last), "test_insert_at_string_3: get&
                                    & list_head " // string )

            call check( work_list%len() == current_length, "test_insert_at_string_3: length check "&
                                    & // to_string( current_length ) )

        end do

        ! compare work_list with [200, 199, ..., ..., 2, 1]
        call compare_list( work_list, last, first - 2, 4 )

    end subroutine test_insert_at_string_3

    subroutine test_insert_at_array
        type(stringlist_type)           :: work_list
        type(stringlist_type)           :: reference_list
        integer                         :: i, j
        integer, parameter              :: first = -100
        integer, parameter              :: last = 100
        integer, parameter              :: stride = 4
        type(string_type)               :: all_strings(first:last)

        write (*,*) "test_insert_at_array:    Starting work_list!"
        
        do concurrent (j=first:last)
            all_strings(j) = string_type( to_string(j) )
        end do

        call work_list%insert_at( list_head, all_strings(first:first+stride-1) )

        call compare_list( work_list, first, first + stride, 5 )

        call work_list%insert_at( list_tail, all_strings(last-stride:last-1) )

        do i = first + stride, last - stride - 1, stride
            call work_list%insert_at( fidx( i - first + 1 ), all_strings(i:i+stride-1) )
        end do

        call work_list%insert_at( list_tail, all_strings(last:last) )

        call compare_list( work_list, first, last + 1, 6 )

        write (*,*) "test_insert_at_array:    Starting reference_list!"

        call reference_list%insert_at( list_tail, all_strings (last-stride+1:last) )

        call compare_list( reference_list, last - stride + 1, last + 1, 7 )

        call reference_list%insert_at( list_head, all_strings(first+1:first+stride) )

        do i = last - stride, first + stride + 1, -1 * stride
            call reference_list%insert_at( bidx( last - i + 1 ), all_strings(i-stride+1:i) )
        end do

        call reference_list%insert_at( list_head, all_strings(first:first) )

        call compare_list( reference_list, first, last + 1, 8 )

    end subroutine test_insert_at_array

    subroutine test_insert_at_list
        type(stringlist_type)           :: work_list, reference_list
        type(stringlist_type)           :: temp_list
        integer                         :: i, j
        integer, parameter              :: first = -100
        integer, parameter              :: last = 100
        integer, parameter              :: stride = 4
        type(string_type)               :: all_strings(first:last)

        write (*,*) "test_insert_at_list:     Starting work_list!"
        
        do concurrent (j=first:last)
            all_strings(j) = string_type( to_string(j) )
        end do        

        call temp_list%clear()
        do j = first, first + stride - 1
            call temp_list%insert_at( list_tail, all_strings(j) )
        end do

        call work_list%insert_at(list_head, temp_list)
        call compare_list( work_list, first, first + stride, 9)

        call temp_list%clear()
        do j = last - 1, last - stride, -1
            call temp_list%insert_at( list_head, all_strings(j) )
        end do

        call work_list%insert_at(list_tail, temp_list)

        do i = first + stride, last - stride - 1, stride
            call temp_list%clear()
            do j = i, i + stride - 1
                call temp_list%insert_at( list_tail, to_string(j) )
            end do
            call work_list%insert_at( fidx( i - first + 1 ), temp_list )

        end do

        call temp_list%clear()
        call temp_list%insert_at( list_head, all_strings(last) )
        call work_list%insert_at( list_tail, temp_list )

        call compare_list( work_list, first, last + 1, 10 )

        write (*,*) "test_insert_at_list:     Starting reference_list!"

        call temp_list%clear()
        do j = last - stride + 1, last
            call temp_list%insert_at( list_tail, to_string(j) )
        end do

        call reference_list%insert_at( list_tail, temp_list )
        call compare_list( reference_list, last - stride + 1, last + 1, 11 )

        call temp_list%clear()
        do j = first + 1, first + stride
            call temp_list%insert_at( list_tail, string_type( to_string(j) ) )
        end do

        call reference_list%insert_at( list_head, temp_list )

        do i = last - stride, first + stride + 1, -1 * stride
            call temp_list%clear()
            do j = i - stride + 1, i
                call temp_list%insert_at( list_tail, to_string(j) )
            end do
            call reference_list%insert_at( bidx( last - i + 1 ), temp_list )

        end do

        call temp_list%clear()
        call temp_list%insert_at( list_tail, to_string(first) )
        call reference_list%insert_at( list_head, temp_list )

        call compare_list( reference_list, first, last + 1, 12 )

    end subroutine test_insert_at_list

    subroutine test_constructor
        type(stringlist_type)           :: work_list
        character(len=4), allocatable   :: carray(:)
        type(string_type), allocatable  :: sarray(:)

        write (*,*) "test_constructor:        Starting test case 1!"
        work_list = stringlist_type()
        allocate( carray(0) )
        allocate( sarray(0) )
        call check( work_list == carray, "test_constructor:&
            & test_case 1 work_list == carray" )
        call check( work_list == sarray, "test_constructor:&
            & test_case 1 work_list == sarray" )

        write (*,*) "test_constructor:        Starting test case 2!"
        carray = [ '#1', '#2', '#3', '#4' ]
        sarray = [ string_type('#1'), string_type('#2'), string_type('#3'), string_type('#4') ]
        work_list = stringlist_type( carray )
        call check( work_list == carray, "test_constructor:&
            & test_case 2 work_list == carray" )
        call check( work_list == sarray, "test_constructor:&
            & test_case 2 work_list == sarray" )

        write (*,*) "test_constructor:        Starting test case 3!"
        work_list = stringlist_type( sarray )
        call check( work_list == carray, "test_constructor:&
            & test_case 3 work_list == carray" )
        call check( work_list == sarray, "test_constructor:&
            & test_case 3 work_list == sarray" )

    end subroutine test_constructor

    ! compares input stringlist 'list' with an array of consecutive integers
    ! array is 'first' inclusive and 'last' exclusive
    subroutine compare_list(list, first, last, call_number)
        type(stringlist_type), intent(in)   :: list
        integer, intent(in)                 :: first, last, call_number
        integer                             :: i, j

        call check( abs( last - first ) == list%len(), "compare_list: length mis-match&
                                        & call_number " // to_string( call_number ) )

        j = merge(-1, 1, last < first)
        do i = 1, list%len()
            call check( list%get( fidx(i) ) == to_string( first + ( ( i - 1 ) * j ) ), &
                                    & "compare_list: call_number " // to_string( call_number ) &
                                    & // " fidx( " // to_string( i ) // " )")
            call check( list%get( bidx(i) ) == to_string( last - ( i * j ) ), &
                                    & "compare_list: call_number " // to_string( call_number ) &
                                    & // " bidx( " // to_string( i ) // " )")
        end do

    end subroutine compare_list

end module test_insert_at


program tester
    use test_insert_at
    implicit none

    call test_insert_at_string_1
    call test_insert_at_string_2
    call test_insert_at_string_3
    call test_insert_at_array
    call test_insert_at_list
    call test_constructor

end program tester

program example_fwrite
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: io
  string = "Important saved value"

  open (newunit=io, form="formatted", status="scratch")
  write (io, *) string
  write (io, *)

  rewind (io)

  read (io, *) string
  close (io)
end program example_fwrite

module test_hash_functions
    use testdrive, only : new_unittest, unittest_type, error_type, check, &
        skip_test
    use stdlib_kinds, only: int8, int32, int64, dp
    use stdlib_hash_32bit, only: little_endian &
        , nmhash32 &
        , nmhash32x &
        , water_hash
    use stdlib_hash_64bit, only: pengy_hash, spooky_hash
 
    implicit none
    private
    public :: collect_hash_functions
    public :: generate_key_array

    integer, parameter :: size_key_array = 2048

    integer(int32), parameter :: nm_seed = int( z'deadbeef', int32 )
    integer(int64), parameter :: water_seed = int( z'deadbeef1eadbeef', int64 )
    integer(int32), parameter :: pengy_seed = int( z'deadbeef', int32 )
    integer(int64), parameter :: spooky_seed(2) = [ water_seed, water_seed ]

    interface read_array
        module procedure read_array_int8
        module procedure read_array_int32
        module procedure read_array_int64
        module procedure read_2darray_int64
    end interface

contains

    !> Collect all exported unit tests
    subroutine collect_hash_functions(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("little_endian", test_little_endian) &
            , new_unittest("nmhash32", test_nmhash32) &
            , new_unittest("nmhash32x", test_nmhash32x) &
            , new_unittest("water_hash", test_water_hash) &
            , new_unittest("pengy_hash", test_pengy_hash) &
            , new_unittest("spooky_hash", test_spooky_hash) &
            ]

    end subroutine collect_hash_functions

    subroutine test_little_endian(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
 
        ! Test for endianness

        call check(error, little_endian, "The processor is not Little-Endian")
        if (allocated(error)) return

    end subroutine test_little_endian

    subroutine test_nmhash32(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: index
        integer(int8) :: key_array(size_key_array)
        integer(int32) :: c_hash(0:size_key_array)

        call read_array("key_array.bin", key_array )

        ! Read hash array generated from key array by the C version of nmhash32
        call read_array("c_nmhash32_array.bin", c_hash) 

        do index=0, size_key_array
            call check(error, c_hash(index) == nmhash32(key_array(1:index), nm_seed) &
                , "NMHASH32 failed")
            if (allocated(error)) return
         end do

    end subroutine test_nmhash32

    subroutine test_nmhash32x(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: index
        integer(int8) :: key_array(size_key_array)
        integer(int32) :: c_hash(0:size_key_array)

        call read_array("key_array.bin", key_array )

        ! Read hash array generated from key array by the C version of nmhash32x
        call read_array("c_nmhash32x_array.bin", c_hash) 

        do index=0, size_key_array
            call check(error, c_hash(index) == nmhash32x(key_array(1:index), nm_seed) &
                , "NMHASH32X failed")
            if (allocated(error)) return
         end do

    end subroutine test_nmhash32x

    subroutine test_water_hash(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: index
        integer(int8) :: key_array(size_key_array)
        integer(int32) :: c_hash(0:size_key_array)

        call read_array("key_array.bin", key_array )

        ! Read hash array generated from key array by the C version of water_hash
        call read_array("c_water_hash_array.bin", c_hash) 

        do index=0, size_key_array
            call check(error, c_hash(index) == water_hash(key_array(1:index), water_seed) &
                , "WATER_HASH failed")
            if (allocated(error)) return
         end do

    end subroutine test_water_hash

    subroutine test_pengy_hash(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: index
        integer(int8) :: key_array(size_key_array)
        integer(int64) :: c_hash(0:size_key_array)

        call read_array("key_array.bin", key_array )

        ! Read hash array generated from key array by the C version of pengy_hash
        call read_array("c_pengy_hash_array.bin", c_hash) 

        do index=0, size_key_array
            call check(error, c_hash(index) == pengy_hash(key_array(1:index), pengy_seed) &
                , "PENGY_HASH failed")
            if (allocated(error)) return
         end do

    end subroutine test_pengy_hash

    subroutine test_spooky_hash(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: index
        integer(int8) :: key_array(size_key_array)
        integer(int64) :: c_hash(0:1, 0:size_key_array)

        call read_array("key_array.bin", key_array )

        ! Read hash array generated from key array by the C version of spooky_hash
        call read_array("c_spooky_hash_array.bin", c_hash) 

        do index=0, size_key_array
            call check(error, all(c_hash(:, index) == spooky_hash(key_array(1:index), spooky_seed)) &
                , "SPOOKY_HASH failed")
            if (allocated(error)) return
         end do

    end subroutine test_spooky_hash


    subroutine generate_key_array()
    
        integer        :: i, lun
        integer(int8)  :: key_array(size_key_array)
        integer(int32) :: dummy(size_key_array/4)
        real(dp)   :: rand(size_key_array/4)
    
        ! Create key array
        call random_number( rand )
        do i=1, size_key_array/4
            dummy(i) = floor( rand(i) * 2_int64**32 - 2_int64**31, kind=int32 )
        end do
        key_array = transfer( dummy, 0_int8, size_key_array )
    
        open(newunit=lun, file="key_array.bin", form="unformatted", &
            access="stream", status="replace", action="write")
        write(lun) key_array
        close(lun)
    
    end subroutine generate_key_array


    subroutine read_array_int8(filename, res)
        character(*), intent(in) :: filename
        integer(int8), intent(out) :: res(:)

        integer :: lun

        open(newunit=lun, file=filename, form="unformatted", &
            access="stream", status="old", action="read", err = 9908)
        read(lun) res
        close(lun)

        return

9908    res =  0

    end subroutine read_array_int8

    subroutine read_array_int32(filename, res)
        character(*), intent(in) :: filename
        integer(int32), intent(out) :: res(:)

        integer :: lun

        open(newunit=lun, file=filename, form="unformatted", &
            access="stream", status="old", action="read", err = 9908)
        read(lun) res
        close(lun)

        return

9908    res =  0

    end subroutine read_array_int32

    subroutine read_array_int64(filename, res)
        character(*), intent(in) :: filename
        integer(int64), intent(out) :: res(:)

        integer :: lun

        open(newunit=lun, file=filename, form="unformatted", &
            access="stream", status="old", action="read", err = 9908)
        read(lun) res
        close(lun)

        return

9908    res =  0

    end subroutine read_array_int64

    subroutine read_2darray_int64(filename, res)
        character(*), intent(in) :: filename
        integer(int64), intent(out) :: res(:,:)

        integer :: lun

        open(newunit=lun, file=filename, form="unformatted", &
            access="stream", status="old", action="read", err = 9908)
        read(lun) res
        close(lun)

        return

9908    res =  0

    end subroutine read_2darray_int64

end module

module modchash
 use, intrinsic :: ISO_C_Binding
 implicit none
 private
 public :: generate_all_c_hash

 interface
  function generate_all_c_hash() result(error) bind(C,name = "generate_all_c_hash")
    import C_int
    integer(C_int) :: error
  end function
 end interface

end module

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use, intrinsic :: ISO_C_Binding, only : C_int
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_hash_functions, only : collect_hash_functions, generate_key_array
    use modchash, only: generate_all_c_hash
    implicit none
    integer(C_int) :: error
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'


    call generate_key_array()

    error = generate_all_c_hash()

    stat = 0

    testsuites = [ &
        new_testsuite("hash_functions", collect_hash_functions) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_fidx_bidx
  use stdlib_stringlist_type, only: stringlist_index_type, fidx, bidx
  implicit none

  type(stringlist_index_type) :: index

  index = fidx(1)
! forward index 1

  index = bidx(3)
! backward index 3

end program example_fidx_bidx

program example_pivoting_qr
   use stdlib_linalg, only: qr
   implicit none
   real :: A(104, 32), Q(104, 32), R(32, 32)
   integer :: pivots(32)

   ! Create a random matrix
   call random_number(A)

   ! Compute its QR factorization (reduced)
   call qr(A, Q, R, pivots)

   ! Test factorization: Q*R = A
   print *, maxval(abs(matmul(Q, R) - A(:, pivots)))

end program example_pivoting_qr

submodule (stdlib_system) stdlib_system_subprocess
    use iso_c_binding  
    use iso_fortran_env, only: int64, real64
    use stdlib_strings, only: join
    use stdlib_linalg_state, only: linalg_state_type, LINALG_ERROR, linalg_error_handling
    implicit none(type, external)
    
    ! Number of CPU ticks between status updates
    integer(TICKS), parameter :: CHECK_EVERY_TICKS = 100
    
    ! Interface to C support functions from stdlib_system_subprocess.c
    interface
        
        ! C wrapper to query process status
        subroutine process_query_status(pid, wait, is_running, exit_code) &
                   bind(C, name='process_query_status')
            import c_int, c_bool, process_ID
            implicit none
            ! Process ID
            integer(process_ID), value :: pid       
            ! Whether to wait for process completion      
            logical(c_bool), value :: wait     
            ! Whether the process is still running
            logical(c_bool), intent(out) :: is_running  
            ! Process exit code (or error code)
            integer(c_int), intent(out) :: exit_code     
        end subroutine process_query_status

        subroutine process_create(cmd, stdin_stream, stdin_file, stdout_file, stderr_file, pid) &
                   bind(C, name='process_create')
            import c_char, process_ID
            implicit none
            character(c_char), intent(in)           :: cmd(*)
            character(c_char), intent(in), optional :: stdin_stream(*)
            character(c_char), intent(in), optional :: stdin_file(*)
            character(c_char), intent(in), optional :: stdout_file(*)
            character(c_char), intent(in), optional :: stderr_file(*)
            integer(process_ID), intent(out)        :: pid
        end subroutine process_create
        
        logical(c_bool) function process_system_kill(pid) bind(C, name='process_kill')
            import c_bool, process_ID
            implicit none
            integer(process_ID), intent(in), value :: pid
        end function process_system_kill
        
        ! System implementation of a wait function
        subroutine process_wait(seconds) bind(C,name='process_wait')
            import c_float
            implicit none
            real(c_float), intent(in), value :: seconds
        end subroutine process_wait            
        
        ! Utility: check if _WIN32 is defined in the C compiler
        logical(c_bool) function process_is_windows() bind(C,name='process_is_windows')
            import c_bool
            implicit none
        end function process_is_windows
  
    end interface

    ! C boolean constants
    logical(c_bool), parameter :: C_FALSE = .false._c_bool
    logical(c_bool), parameter :: C_TRUE  = .true._c_bool

contains

    ! Call system-dependent wait implementation
    module subroutine sleep(millisec)
        integer, intent(in) :: millisec
        
        real(c_float) :: seconds
        
        seconds = 0.001_c_float*max(0,millisec)
                        
        call process_wait(seconds)
        
    end subroutine sleep

    module function run_async_cmd(cmd, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> The command line string to execute.
        character(*), intent(in) :: cmd
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload        
        !> The output process handler.
        type(process_type) :: process
        
        process = process_open([cmd],.false.,stdin,want_stdout,want_stderr,callback,payload)
        
    end function run_async_cmd

    module function run_async_args(args, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> List of arguments for the process to execute.
        character(*), intent(in) :: args(:)
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload        
        !> The output process handler.
        type(process_type) :: process  
        
        process = process_open(args,.false.,stdin,want_stdout,want_stderr,callback,payload)
              
    end function run_async_args

    module function run_sync_cmd(cmd, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> The command line string to execute.
        character(*), intent(in) :: cmd
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload                
        !> The output process handler.
        type(process_type) :: process
        
        process = process_open([cmd],.true.,stdin,want_stdout,want_stderr,callback,payload)
        
    end function run_sync_cmd

    module function run_sync_args(args, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> List of arguments for the process to execute.
        character(*), intent(in) :: args(:)
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload        
        !> The output process handler.
        type(process_type) :: process  
        
        process = process_open(args,.true.,stdin,want_stdout,want_stderr,callback,payload)
              
    end function run_sync_args

    !> Internal function: open a new process from a command line
    function process_open_cmd(cmd,wait,stdin,want_stdout,want_stderr,callback,payload) result(process)
        !> The command and arguments
        character(*), intent(in) :: cmd
        !> Optional character input to be sent to the process via pipe
        character(*), optional, intent(in) :: stdin
        !> Define if the process should be synchronous (wait=.true.), or asynchronous(wait=.false.)
        logical, intent(in) :: wait
        !> Require collecting output
        logical, optional, intent(in) :: want_stdout, want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload        
        !> The output process handler
        type(process_type) :: process        
        
        process = process_open([cmd],wait,stdin,want_stdout,want_stderr,callback,payload)
        
    end function process_open_cmd

    !> Internal function: open a new process from arguments
    function process_open(args,wait,stdin,want_stdout,want_stderr,callback,payload) result(process)
        !> The command and arguments
        character(*), intent(in) :: args(:)
        !> Optional character input to be sent to the process via pipe
        character(*), optional, intent(in) :: stdin
        !> Define if the process should be synchronous (wait=.true.), or asynchronous(wait=.false.)
        logical, intent(in) :: wait
        !> Require collecting output
        logical, optional, intent(in) :: want_stdout, want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload        
        !> The output process handler
        type(process_type) :: process
        
        real(RTICKS) :: count_rate
        logical :: asynchronous, collect_stdout, collect_stderr, has_stdin
        integer :: command_state, exit_state
        integer(TICKS) :: count_max
        
        ! Process user requests
        asynchronous   = .not.wait
        collect_stdout = .false.
        collect_stderr = .false.
        has_stdin      = present(stdin)
        if (present(want_stdout)) collect_stdout = want_stdout
        if (present(want_stderr)) collect_stderr = want_stderr
        
        ! Attach stdout to a scratch file (must be named)
        if (has_stdin)      process%stdin_file  = scratch_name('inp')
        if (collect_stdout) process%stdout_file = scratch_name('out')            
        if (collect_stderr) process%stderr_file = scratch_name('err')
        
        ! Attach callback function and payload
        if (present(callback)) then 
            process%oncomplete => callback
        else
            nullify(process%oncomplete)
        end if
        
        if (present(payload)) then 
            process%payload => payload
        else
            nullify(process%payload)            
        end if
        
        ! Save the process's generation time
        call system_clock(process%start_time,count_rate,count_max)
        process%last_update = process%start_time                
        
        if (asynchronous) then 
            
           ! Create or fork a new process, store pid 
           call launch_asynchronous(process, args, stdin)
           
        else

           ! No need to create an external process
           process%id = FORKED_PROCESS

        endif
        
        if (process%id == FORKED_PROCESS) then 
           
           ! Launch to completion from the local process
           call launch_synchronous(process, args, stdin)
           call save_completed_state(process,delete_files=.not.asynchronous)

           ! If the process was forked 
           ! Note: use `exit` rather than `stop` to prevent the mandatory stdout STOP message           
           if (asynchronous) then 
               if (command_state/=0) then 
                   ! Invalid command: didn't even start
                   call exit(command_state)
               else
                   ! Return exit state
                   call exit(exit_state)                   
               end if                   
           endif            
           
        endif
              
        ! Run a first update
        call update_process_state(process)   
           
    end function process_open
    
    subroutine launch_asynchronous(process, args, stdin)
        class(process_type), intent(inout) :: process
        !> The command and arguments
        character(*), intent(in) :: args(:)        
        !> Optional character input to be sent to the process via pipe
        character(*), optional, intent(in) :: stdin  
        
        character(c_char), dimension(:), allocatable, target :: c_cmd,c_stdin,c_stdin_file,c_stdout_file,c_stderr_file
        
        ! Assemble C strings 
                                            c_cmd   = to_c_char(join(args))
        if (present(stdin))                 c_stdin = to_c_char(stdin)
        if (allocated(process%stdin_file))  c_stdin_file  = to_c_char(process%stdin_file)
        if (allocated(process%stdout_file)) c_stdout_file = to_c_char(process%stdout_file)
        if (allocated(process%stderr_file)) c_stderr_file = to_c_char(process%stderr_file)
            
        ! On Windows, this 1) creates 2) launches an external process from C.
        ! On unix, this 1) forks an external process
        call process_create(c_cmd, c_stdin, c_stdin_file, c_stdout_file, c_stderr_file, process%id)
        
    end subroutine launch_asynchronous
    
    subroutine launch_synchronous(process, args, stdin)        
        class(process_type), intent(inout) :: process
        !> The command and arguments
        character(*), intent(in) :: args(:)        
        !> Optional character input to be sent to the process via pipe
        character(*), optional, intent(in) :: stdin        
        
        character(:), allocatable :: cmd
        character(4096) :: iomsg
        integer :: iostat,estat,cstat,stdin_unit
        logical :: has_stdin
        
        has_stdin      = present(stdin)
        
        ! Prepare stdin
        if (has_stdin) then 
            
            open(newunit=stdin_unit,file=process%stdin_file, &
                 access='stream',action='write',position='rewind', &
                 iostat=iostat,iomsg=iomsg)                      
            if (iostat/=0) error stop 'cannot open temporary stdin'               
               
            write(stdin_unit,iostat=iostat,iomsg=iomsg) stdin               
            if (iostat/=0) error stop trim(iomsg)
               
            close(stdin_unit,iostat=iostat,iomsg=iomsg,status='keep')
            if (iostat/=0) error stop 'cannot close temporary stdin'
               
        end if
                       
        ! Run command
        cmd = assemble_cmd(args,process%stdin_file,process%stdout_file,process%stderr_file)
           
        ! Execute command        
        call execute_command_line(cmd,wait=.true.,exitstat=estat,cmdstat=cstat)         
        
        ! Save state and output
        process%exit_code = merge(cstat,estat,cstat/=0)        
        
    end subroutine launch_synchronous
    
    !> Return the current (or total) process lifetime, in seconds
    real(RTICKS) module function process_lifetime(process) result(delta_t)
        class(process_type), intent(in) :: process 
        
        real(RTICKS) :: ticks_per_second
        integer(TICKS) :: current_time,count_max
        
        ! Get current time
        call system_clock(current_time,ticks_per_second,count_max)        
                
        if (process%completed) then 
            
            delta_t = real(process%last_update-process%start_time,RTICKS)/ticks_per_second
            
        else
            
            delta_t = real(current_time-process%start_time,RTICKS)/ticks_per_second
            
        end if
        
    end function process_lifetime
    
    !> Wait for a process to be completed
    module subroutine wait_for_completion(process, max_wait_time)
        class(process_type), intent(inout) :: process
        ! Optional max wait time in seconds
        real, optional, intent(in) :: max_wait_time

        integer :: sleep_interval
        real(RTICKS) :: wait_time, elapsed
        integer(TICKS) :: start_time, current_time, count_rate
        
        ! Sleep interval ms
        integer, parameter :: MIN_WAIT_MS = 1
        integer, parameter :: MAX_WAIT_MS = 100
        
        ! Starting sleep interval: 1ms
        sleep_interval = MIN_WAIT_MS

        ! Determine the wait time
        if (present(max_wait_time)) then
            wait_time = max(0.0_RTICKS, max_wait_time)
        else
            ! No limit if max_wait_time is not provided
            wait_time = huge(wait_time)  
        end if

        ! Get the system clock rate and the start time
        call system_clock(start_time, count_rate)
        elapsed = 0.0_real64

        ! Wait loop
        wait_loop: do while (process_is_running(process) .and. elapsed <= wait_time)
        
            ! Small sleep to avoid CPU hogging, with exponential backoff  (1 ms)
            ! from 1ms up to 100ms
            call sleep(millisec=sleep_interval)
            sleep_interval = min(sleep_interval*2, MAX_WAIT_MS)
            
            call system_clock(current_time)
            elapsed = real(current_time - start_time, RTICKS) / count_rate
            
        end do wait_loop

    end subroutine wait_for_completion

    !> Update a process's state, and save it to the process variable
    module subroutine update_process_state(process)
        class(process_type), intent(inout) :: process
        
        real(RTICKS) :: count_rate        
        integer(TICKS) :: count_max,current_time
        logical(c_bool) :: running
        integer(c_int) :: exit_code
        
        ! If the process has completed, should not be queried again
        if (process%completed) return
        
        ! Save the process's generation time
        call system_clock(current_time,count_rate,count_max)
        
        ! Only trigger an update after at least 100 count units
        if (abs(real(current_time-process%last_update,RTICKS))<CHECK_EVERY_TICKS) return
        
        ! Update check time
        process%last_update = current_time       
        
        if (process%id /= FORKED_PROCESS) then 
        
            ! Query process state
            call process_query_status(process%id, wait=C_FALSE, is_running=running, exit_code=exit_code)
            
            process%completed = .not.running
            
            if (process%completed) then 
               ! Process completed, may have returned an error code  
               process%exit_code = exit_code
               call save_completed_state(process,delete_files=.true.)                 
            end if
        
        endif
        
    end subroutine update_process_state
    
    ! Kill a process 
    module subroutine process_kill(process, success)
        class(process_type), intent(inout) :: process
        ! Return a boolean flag for successful operation
        logical, intent(out) :: success
        
        integer(c_int) :: exit_code
        logical(c_bool) :: running
        
        success = .true.
        
        ! No need to
        if (process%completed) return
        if (process%id == FORKED_PROCESS) return
        
        success = logical(process_system_kill(process%id))
        
        if (success) then 
            
            call process_query_status(process%id, wait=C_TRUE, is_running=running, exit_code=exit_code)
            
            process%completed = .not.running
            
            if (process%completed) then 
               ! Process completed, may have returned an error code  
               process%exit_code = exit_code
               call save_completed_state(process,delete_files=.true.)                 
            end if            
            
        end if
        
    end subroutine process_kill
    
    subroutine save_completed_state(process,delete_files)
        class(process_type), intent(inout) :: process
        logical, intent(in) :: delete_files
        
        logical(c_bool) :: running        
        integer(c_int) :: exit_code        
        integer :: delete
        
        ! Same as process ID: process exited
        process%completed = .true.
        
        ! Clean up process state using waitpid
        if (process%id/=FORKED_PROCESS) call process_query_status(process%id, C_TRUE, running, exit_code)
       
        ! Process is over: load stderr if requested
        if (allocated(process%stderr_file)) then 
           process%stderr = getfile(process%stderr_file,delete=delete_files)
           deallocate(process%stderr_file)
        endif
    
        ! Process is over: load stdout if requested
        if (allocated(process%stdout_file)) then 
           process%stdout = getfile(process%stdout_file,delete=delete_files)
           deallocate(process%stdout_file)
        endif         
        
        ! Process is over: delete stdin file if it was provided
        if (allocated(process%stdin_file)) then 
            process%stdin = getfile(process%stdin_file,delete=delete_files)
            deallocate(process%stdin_file)
        end if
        
        ! Process is over: invoke callback if requested
        if (associated(process%oncomplete)) &
            call process%oncomplete(process%id,        &
                                    process%exit_code, &
                                    process%stderr,    &
                                    process%stdout,    &
                                    process%stderr,    &
                                    process%payload)
        
    end subroutine save_completed_state

    !> Live check if a process is running
    logical module function process_is_running(process) result(is_running)
        class(process_type), intent(inout) :: process
        
        ! Each evaluation triggers a state update
        call update_process_state(process)

        is_running = .not.process%completed
        
    end function process_is_running
    
    !> Live check if a process has completed
    logical module function process_is_completed(process) result(is_completed)
        class(process_type), intent(inout) :: process
        
        ! Each evaluation triggers a state update
        call update_process_state(process)

        is_completed = process%completed
        
    end function process_is_completed    
            
    function scratch_name(prefix) result(temp_filename)
        character(*), optional, intent(in) :: prefix
        character(:), allocatable :: temp_filename
        character(len=8)  :: date
        character(len=10) :: time
        character(len=7)  :: rand_str
        real :: rrand
        integer :: rand_val

        ! Get the current date and time
        call date_and_time(date=date, time=time)

        ! Generate a random number for additional uniqueness
        call random_number(rrand)
        rand_val = nint(rrand * 1e6)  ! Scale random number
        write(rand_str,'(i7.7)') rand_val
        
        ! Construct the filename
        if (present(prefix)) then 
           temp_filename = trim(prefix)// '_' // date // '_' // time(1:6) // '_' // rand_str // '.tmp'
        else
           temp_filename = 'tmp_' // date // '_' // time(1:6) // '_' // rand_str // '.tmp'
        endif
        
    end function scratch_name
        
        
    !> Assemble a single-line proces command line from a list of arguments.
    !> 
    !> Version: Helper function.
    function assemble_cmd(args, stdin, stdout, stderr) result(cmd)
        !> Command to execute as a string
        character(len=*), intent(in) :: args(:)    
        !> [optional] File name standard input (stdin) should be taken from
        character(len=*), optional, intent(in) :: stdin    
        !> [optional] File name standard output (stdout) should be directed to
        character(len=*), optional, intent(in) :: stdout
        !> [optional] File name error output (stderr) should be directed to
        character(len=*), optional, intent(in) :: stderr
        
        character(:), allocatable :: cmd,stdout_file,input_file,stderr_file
        
        if (present(stdin)) then 
            input_file = stdin
        else
            input_file = null_device()        
        end if

        if (present(stdout)) then
            ! Redirect output to a file
            stdout_file = stdout
        else
            stdout_file = null_device()
        endif     
        
        if (present(stderr)) then 
            stderr_file = stderr
        else
            stderr_file = null_device()
        end if
        
        cmd = join(args)//" <"//input_file//" 1>"//stdout_file//" 2>"//stderr_file   
        
    end function assemble_cmd            
    
    !> Returns the file path of the null device for the current operating system.
    !>
    !> Version: Helper function.
    logical module function is_windows()
       is_windows = logical(process_is_windows())
    end function is_windows
    
    !> Reads a whole ASCII file and loads its contents into an allocatable character string..
    !> The function handles error states and optionally deletes the file after reading.
    !> Temporarily uses `linalg_state_type` in lieu of the generalized `state_type`.
    !> 
    !> Version: to be replaced after `getfile` is standardized in `stdlib_io`.
    function getfile(fileName,err,delete) result(file)
      !> Input file name
      character(*), intent(in) :: fileName
      !> [optional] State return flag. On error, if not requested, the code will stop.
      type(linalg_state_type), optional, intent(out) :: err
      !> [optional] Delete file after reading? Default: do not delete
      logical, optional, intent(in) :: delete
      !> Return as an allocatable string
      character(:), allocatable :: file
        
      ! Local variables
      character(*), parameter :: CRLF  = achar(13)//new_line('a')
      type(linalg_state_type) :: err0
      character(len=:), allocatable :: fileString
      character(len=512) :: iomsg
      character :: last_char
      integer :: lun,iostat
      integer(int64) :: errpos,fileSize
      logical :: is_present,want_deleted

      ! Initializations
      file = ""
      
      !> Check if the file should be deleted after reading
      if (present(delete)) then 
         want_deleted = delete
      else
         want_deleted = .false.   
      end if

      !> Check file existing
      inquire(file=fileName, exist=is_present)
      if (.not.is_present) then
         err0 = linalg_state_type('getfile',LINALG_ERROR,'File not present:',fileName)
         call linalg_error_handling(err0,err)
         return
      end if
      
      !> Retrieve file size
      inquire(file=fileName,size=fileSize)
      
      invalid_size: if (fileSize<0) then 

          err0 = linalg_state_type('getfile',LINALG_ERROR,fileName,'has invalid size=',fileSize)
          call linalg_error_handling(err0,err)
          return            
            
      endif invalid_size  
            
      ! Read file
      open(newunit=lun,file=fileName, &
           form='unformatted',action='read',access='stream',status='old', &
           iostat=iostat,iomsg=iomsg)
             
      if (iostat/=0) then 
         err0 = linalg_state_type('getfile',LINALG_ERROR,'Cannot open',fileName,'for read:',iomsg)
         call linalg_error_handling(err0,err)
         return
      end if     
      
      remove_trailing_newline: if (fileSize>0) then 
      
         last_char = CRLF(1:1)
         fileSize  = fileSize+1
      
         do while (scan(last_char,CRLF)>0 .and. fileSize>1)
            fileSize = fileSize-1
            read(lun, pos=fileSize, iostat=iostat, iomsg=iomsg) last_char
            
            ! Read error
            if (iostat/=0) then 
                    
                err0 = linalg_state_type('getfile',LINALG_ERROR,iomsg,'(',fileName,'at byte',fileSize,')')
                call linalg_error_handling(err0,err)
                return

            endif            
            
         end do
      endif remove_trailing_newline      
        
      allocate(character(len=fileSize) :: fileString)
        
      read_data: if (fileSize>0) then 
            
          read(lun, pos=1, iostat=iostat, iomsg=iomsg) fileString
            
          ! Read error
          if (iostat/=0) then 
                
              inquire(unit=lun,pos=errpos)                    
              err0 = linalg_state_type('getfile',LINALG_ERROR,iomsg,'(',fileName,'at byte',errpos,')')
              call linalg_error_handling(err0,err)
              return

          endif
            
      end if read_data
                   
      if (want_deleted) then 
         close(lun,iostat=iostat,status='delete')
         if (iostat/=0) err0 = linalg_state_type('getfile',LINALG_ERROR,'Cannot delete',fileName,'after reading')
      else
         close(lun,iostat=iostat)
         if (iostat/=0) err0 = linalg_state_type('getfile',LINALG_ERROR,'Cannot close',fileName,'after reading')
      endif 
      
      ! Process output
      call move_alloc(from=fileString,to=file)
      call linalg_error_handling(err0,err)

    end function getfile

    !> Return process ID
    module function process_get_ID(process) result(ID)
        class(process_type), intent(in) :: process
        !> Return a process ID
        integer(process_ID) :: ID        
        ID = process%id
    end function process_get_ID

end submodule stdlib_system_subprocess

program example_sort
  use stdlib_sorting, only: sort
  implicit none
  integer, allocatable :: array(:)

  array = [5, 4, 3, 1, 10, 4, 9]
  call sort(array)
  print *, array   !print [1, 3, 4, 4, 5, 9, 10]
end program example_sort

program example_math_rad2deg
    use stdlib_math, only: rad2deg
    use stdlib_constants, only: PI_sp
    implicit none
    print *, rad2deg(0.0)              ! 0.0
    print *, rad2deg(PI_sp / 2.0)      ! 90.0
    print *, rad2deg(-PI_sp)           ! -3.1416

end program example_math_rad2deg

! Pivoting QR example with pre-allocated storage
program example_pivoting_qr_space
   use stdlib_linalg_constants, only: ilp
   use stdlib_linalg, only: qr, qr_space, linalg_state_type
   implicit none
   real :: A(104, 32), Q(104, 32), R(32, 32)
   real, allocatable :: work(:)
   integer(ilp) :: lwork, pivots(32)
   type(linalg_state_type) :: err

   ! Create a random matrix
   call random_number(A)

   ! Prepare QR workspace
   call qr_space(A, lwork, pivoting=.true.)
   allocate (work(lwork))

   ! Compute its QR factorization (reduced)
   call qr(A, Q, R, pivots, storage=work, err=err)

   ! Test factorization: Q*R = A
   print *, maxval(abs(matmul(Q, R) - A(:, pivots)))
   print *, err%print()

end program example_pivoting_qr_space

program example_inequality_operator
  use stdlib_stringlist_type, only: stringlist_type, bidx, list_tail, operator(/=)
  use stdlib_string_type, only: string_type
  implicit none

  type(stringlist_type)          :: stringlist
  type(string_type), allocatable :: stringarray(:)
  logical                        :: res

!> inserting 4 elements to the stringlist
  call stringlist%insert_at(bidx(1), "#1")
  call stringlist%insert_at(list_tail, "#2")
  call stringlist%insert_at(bidx(1), "#3")
  call stringlist%insert_at(list_tail, "#4")
! stringlist <-- {"#1", "#2", "#3", "#4"}

!> creating an array of 4 string_type elements
  stringarray = [string_type("#1"), string_type("#2"), string_type("#3"), string_type("#4")]

  res = (stringarray /= stringlist)
! res <-- .false.

  res = (stringlist /= ["#111", "#222", "#333", "#444"])
! res <-- .true.

  print'(a)', stringlist /= ["#4", "#3", "#1"]
! .true.

end program example_inequality_operator

program example_meshgrid

    use stdlib_math, only: meshgrid, linspace, stdlib_meshgrid_ij
    use stdlib_kinds, only: sp

    implicit none

    integer, parameter :: nx = 3, ny = 2
    real(sp) :: x(nx), y(ny), &
            xm_cart(ny, nx), ym_cart(ny, nx), &
            xm_mat(nx, ny), ym_mat(nx, ny)

    x = linspace(0_sp, 1_sp, nx)
    y = linspace(0_sp, 1_sp, ny)

    call meshgrid(x, y, xm_cart, ym_cart)
    print *, "xm_cart = "
    call print_2d_array(xm_cart)
    print *, "ym_cart = "
    call print_2d_array(ym_cart)

    call meshgrid(x, y, xm_mat, ym_mat, indexing=stdlib_meshgrid_ij)
    print *, "xm_mat = "
    call print_2d_array(xm_mat)
    print *, "ym_mat = "
    call print_2d_array(ym_mat)

contains
    subroutine print_2d_array(array)
        real(sp), intent(in) :: array(:, :)
        integer :: i

        do i = 1, size(array, dim=1)
            print *, array(i, :)
        end do
    end subroutine
end program example_meshgrid

! stdlib_stringlist_type.f90 --
!     Module for storing and manipulating list of strings
!     The strings may have arbitrary lengths, not necessarily the same
!
!     insert AT:      Inserts an element BEFORE the element present currently at the asked index
!                       for forward indexes
!                     Inserts an element AFTER the element present currently at the asked index
!                       for backward indexes
!                     In other words, after insertion the element will be present at the asked index
!                       for both forward and backward indexes                    
!     insert BEFORE:  Inserts an element BEFORE the element present currently at the asked index
!     insert AFTER:   Inserts an element AFTER the element present currently at the asked index
!
!     Note the distinction between AT and BEFORE in the module. Care has been taken to keep it consistent
!     throughout the PR
!
module stdlib_stringlist_type
    use stdlib_string_type, only: string_type, operator(/=)
    use stdlib_math, only: clip
    implicit none
    private

    public :: stringlist_type, operator(//), operator(==), operator(/=)
    public :: list_head, list_tail, fidx, bidx, stringlist_index_type

    type stringlist_index_type
        private
        logical :: forward
        integer :: offset

    end type stringlist_index_type

    type(stringlist_index_type), parameter :: list_head     = stringlist_index_type( .true. , 1 )   ! fidx(1)
    type(stringlist_index_type), parameter :: list_tail     = stringlist_index_type( .false., 1 )   ! bidx(1)

    !> Version: experimental
    !> 
    !> Returns an instance of type 'stringlist_index_type' representing forward index
    !> [Specifications](../page/specs/stdlib_stringlist_type.html#fidx)
    interface fidx
        module procedure forward_index
    end interface

    !> Version: experimental
    !> 
    !> Returns an instance of type 'stringlist_index_type' representing backward index
    !> [Specifications](../page/specs/stdlib_stringlist_type.html#bidx)
    interface bidx
        module procedure backward_index
    end interface

    type stringlist_type
        private
        type(string_type), dimension(:), allocatable :: stringarray
    
    contains
        private

        procedure, public :: clear                          =>  clear_list

        procedure, public :: len                            =>  length_list

        procedure         :: to_future_at_idxn              =>  convert_to_future_at_idxn

        procedure         :: to_current_idxn                =>  convert_to_current_idxn

        procedure         :: insert_at_char_idx             =>  insert_at_char_idx_wrap
        procedure         :: insert_at_string_idx           =>  insert_at_string_idx_wrap
        procedure         :: insert_at_stringlist_idx       =>  insert_at_stringlist_idx_wrap
        procedure         :: insert_at_chararray_idx        =>  insert_at_chararray_idx_wrap
        procedure         :: insert_at_stringarray_idx      =>  insert_at_stringarray_idx_wrap
        generic, public   :: insert_at                      =>  insert_at_char_idx,         &
                                                                insert_at_string_idx,       &
                                                                insert_at_stringlist_idx,   &
                                                                insert_at_chararray_idx,    &
                                                                insert_at_stringarray_idx

        procedure         :: insert_before_string_int       =>  insert_before_string_int_impl
        procedure         :: insert_before_stringlist_int   =>  insert_before_stringlist_int_impl
        procedure         :: insert_before_chararray_int    =>  insert_before_chararray_int_impl
        procedure         :: insert_before_stringarray_int  =>  insert_before_stringarray_int_impl
        generic           :: insert_before                  =>  insert_before_string_int,       &
                                                                insert_before_stringlist_int,   &
                                                                insert_before_chararray_int,    &
                                                                insert_before_stringarray_int

        procedure         :: get_string_idx         => get_string_idx_wrap
        generic, public   :: get                    => get_string_idx

    end type stringlist_type

    !> Version: experimental
    !>
    !> Constructor for stringlist
    !> Returns an instance of type stringlist_type
    !> [Specifications](../page/specs/stdlib_stringlist_type.html#stringlist_type)
    interface stringlist_type
        module procedure new_stringlist
        module procedure new_stringlist_carray
        module procedure new_stringlist_sarray
    end interface

    !> Version: experimental
    !> 
    !> Concatenates stringlist with the input entity
    !> Returns a new stringlist
    !> [Specifications](../page/specs/stdlib_stringlist_type.html#append-operator)
    interface operator(//)
        module procedure append_char
        module procedure append_string
        module procedure prepend_char
        module procedure prepend_string
        module procedure append_stringlist
        module procedure append_carray
        module procedure append_sarray
        module procedure prepend_carray
        module procedure prepend_sarray
    end interface

    !> Version: experimental
    !> 
    !> Compares stringlist for equality with the input entity
    !> Returns a logical
    !> [Specifications](../page/specs/stdlib_stringlist_type.html#equality-operator)
    interface operator(==)
        module procedure eq_stringlist
        module procedure eq_stringlist_carray
        module procedure eq_stringlist_sarray
        module procedure eq_carray_stringlist
        module procedure eq_sarray_stringlist
    end interface

    !> Version: experimental
    !> 
    !> Compares stringlist for inequality with the input entity
    !> Returns a logical
    !> [Specifications](../page/specs/stdlib_stringlist_type.html#inequality-operator)
    interface operator(/=)
        module procedure ineq_stringlist
        module procedure ineq_stringlist_carray
        module procedure ineq_stringlist_sarray
        module procedure ineq_carray_stringlist
        module procedure ineq_sarray_stringlist
    end interface

contains

  ! constructor for stringlist_type:

    !> Constructor with no argument
    !> Returns a new instance of type stringlist 
    pure function new_stringlist()
        type(stringlist_type)                           :: new_stringlist

    end function new_stringlist

    !> Constructor to convert chararray to stringlist
    !> Returns a new instance of type stringlist
    pure function new_stringlist_carray( array )
        character(len=*), dimension(:), intent(in)      :: array
        type(stringlist_type)                           :: new_stringlist_carray
        type(string_type), dimension( size(array) )     :: sarray
        integer                                         :: i

        do i = 1, size(array)
            sarray(i) = string_type( array(i) )
        end do

        new_stringlist_carray = stringlist_type( sarray )
        
    end function new_stringlist_carray

    !> Constructor to convert stringarray to stringlist
    !> Returns a new instance of type stringlist
    pure function new_stringlist_sarray( array )
        type(string_type), dimension(:), intent(in)     :: array
        type(stringlist_type)                           :: new_stringlist_sarray

        new_stringlist_sarray = stringlist_type()
        new_stringlist_sarray%stringarray = array

    end function new_stringlist_sarray

  ! constructor for stringlist_index_type:

    !> Returns an instance of type 'stringlist_index_type' representing forward index 'idx'
    pure function forward_index( idx )
        integer, intent(in) :: idx
        type(stringlist_index_type) :: forward_index

        forward_index = stringlist_index_type( .true., idx )

    end function forward_index

    !> Returns an instance of type 'stringlist_index_type' representing backward index 'idx'
    pure function backward_index( idx )
        integer, intent(in) :: idx
        type(stringlist_index_type) :: backward_index

        backward_index = stringlist_index_type( .false., idx )

    end function backward_index

  ! concatenation operator:

    !> Appends character scalar 'rhs' to the stringlist 'list'
    !> Returns a new stringlist
    function append_char( lhs, rhs )
        type(stringlist_type), intent(in) :: lhs
        character(len=*), intent(in)      :: rhs
        type(stringlist_type)             :: append_char

        append_char = lhs // string_type( rhs )

    end function append_char

    !> Appends string 'rhs' to the stringlist 'list'
    !> Returns a new stringlist
    function append_string( lhs, rhs )
        type(stringlist_type), intent(in) :: lhs
        type(string_type), intent(in)     :: rhs
        type(stringlist_type)             :: append_string

        append_string = lhs ! Intent: creating a full, deep copy
        call append_string%insert_at( list_tail, rhs )

    end function append_string

    !> Prepends character scalar 'lhs' to the stringlist 'rhs'
    !> Returns a new stringlist
    function prepend_char( lhs, rhs )
        character(len=*), intent(in)      :: lhs
        type(stringlist_type), intent(in) :: rhs
        type(stringlist_type)             :: prepend_char

        prepend_char = string_type( lhs ) // rhs

    end function prepend_char

    !> Prepends string 'lhs' to the stringlist 'rhs'
    !> Returns a new stringlist
    function prepend_string( lhs, rhs )
        type(string_type), intent(in)     :: lhs
        type(stringlist_type), intent(in) :: rhs
        type(stringlist_type)             :: prepend_string

        prepend_string = rhs ! Intent: creating a full, deep copy
        call prepend_string%insert_at( list_head, lhs )

    end function prepend_string

    !> Appends stringlist 'rhs' to the stringlist 'lhs'
    !> Returns a new stringlist
    function append_stringlist( lhs, rhs )
        type(stringlist_type), intent(in) :: lhs
        type(stringlist_type), intent(in) :: rhs
        type(stringlist_type)             :: append_stringlist

        append_stringlist = lhs ! Intent: creating a full, deep copy
        call append_stringlist%insert_at( list_tail, rhs )

    end function append_stringlist

    !> Appends chararray 'rhs' to the stringlist 'lhs'
    !> Returns a new stringlist
    function append_carray( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        character(len=*), dimension(:), intent(in)  :: rhs
        type(stringlist_type)                       :: append_carray

        append_carray = lhs ! Intent: creating a full, deep copy
        call append_carray%insert_at( list_tail, rhs )

    end function append_carray

    !> Appends stringarray 'rhs' to the stringlist 'lhs'
    !> Returns a new stringlist
    function append_sarray( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        type(string_type), dimension(:), intent(in) :: rhs
        type(stringlist_type)                       :: append_sarray

        append_sarray = lhs ! Intent: creating a full, deep copy
        call append_sarray%insert_at( list_tail, rhs )

    end function append_sarray

    !> Prepends chararray 'lhs' to the stringlist 'rhs'
    !> Returns a new stringlist
    function prepend_carray( lhs, rhs )
        character(len=*), dimension(:), intent(in) :: lhs
        type(stringlist_type), intent(in)          :: rhs
        type(stringlist_type)                      :: prepend_carray

        prepend_carray = rhs ! Intent: creating a full, deep copy
        call prepend_carray%insert_at( list_head, lhs )

    end function prepend_carray

    !> Prepends stringarray 'lhs' to the stringlist 'rhs'
    !> Returns a new stringlist
    function prepend_sarray( lhs, rhs )
        type(string_type), dimension(:), intent(in) :: lhs
        type(stringlist_type), intent(in)           :: rhs
        type(stringlist_type)                       :: prepend_sarray

        prepend_sarray = rhs ! Intent: creating a full, deep copy
        call prepend_sarray%insert_at( list_head, lhs )

    end function prepend_sarray

  ! equality operator:

    !> Compares stringlist 'lhs' for equality with stringlist 'rhs'
    !> Returns a logical
    pure logical function eq_stringlist( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        type(stringlist_type), intent(in)           :: rhs
        integer                                     :: i

        eq_stringlist = .false.
        if ( lhs%len() == rhs%len() ) then
            eq_stringlist = .true.
            do i = 1, lhs%len()
                if ( lhs%stringarray(i) /= rhs%stringarray(i) ) then
                    eq_stringlist = .false.
                    exit
                end if
            end do
        end if

    end function eq_stringlist

    !> Compares stringlist 'lhs' for equality with chararray 'rhs'
    !> Returns a logical
    pure logical function eq_stringlist_carray( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        character(len=*), dimension(:), intent(in)  :: rhs
        integer                                     :: i

        eq_stringlist_carray = .false.
        if ( lhs%len() == size( rhs ) ) then
            eq_stringlist_carray = .true.
            do i = 1, lhs%len()
                if ( lhs%stringarray(i) /= rhs(i) ) then
                    eq_stringlist_carray = .false.
                    exit
                end if
            end do
        end if

    end function eq_stringlist_carray

    !> Compares stringlist 'lhs' for equality with stringarray 'rhs'
    !> Returns a logical
    pure logical function eq_stringlist_sarray( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        type(string_type), dimension(:), intent(in) :: rhs
        integer                                     :: i

        eq_stringlist_sarray = .false.
        if ( lhs%len() == size( rhs ) ) then
            eq_stringlist_sarray = .true.
            do i = 1, lhs%len()
                if ( lhs%stringarray(i) /= rhs(i) ) then
                    eq_stringlist_sarray = .false.
                    exit
                end if
            end do
        end if

    end function eq_stringlist_sarray

    !> Compares chararray 'lhs' for equality with stringlist 'rhs'
    !> Returns a logical
    pure logical function eq_carray_stringlist( lhs, rhs )
        character(len=*), dimension(:), intent(in)  :: lhs
        type(stringlist_type), intent(in)           :: rhs

        eq_carray_stringlist = ( rhs == lhs )

    end function eq_carray_stringlist

    !> Compares stringarray 'lhs' for equality with stringlist 'rhs'
    !> Returns a logical
    pure logical function eq_sarray_stringlist( lhs, rhs )
        type(string_type), dimension(:), intent(in) :: lhs
        type(stringlist_type), intent(in)           :: rhs

        eq_sarray_stringlist = ( rhs == lhs )

    end function eq_sarray_stringlist

  ! inequality operator:

    !> Compares stringlist 'lhs' for inequality with stringlist 'rhs'
    !> Returns a logical
    pure logical function ineq_stringlist( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        type(stringlist_type), intent(in)           :: rhs

        ineq_stringlist = .not.( lhs == rhs )

    end function ineq_stringlist

    !> Compares stringlist 'lhs' for inequality with chararray 'rhs'
    !> Returns a logical
    pure logical function ineq_stringlist_carray( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        character(len=*), dimension(:), intent(in)  :: rhs

        ineq_stringlist_carray = .not.( lhs == rhs ) 

    end function ineq_stringlist_carray

    !> Compares stringlist 'lhs' for inequality with stringarray 'rhs'
    !> Returns a logical
    pure logical function ineq_stringlist_sarray( lhs, rhs )
        type(stringlist_type), intent(in)           :: lhs
        type(string_type), dimension(:), intent(in) :: rhs

        ineq_stringlist_sarray = .not.( lhs == rhs ) 

    end function ineq_stringlist_sarray

    !> Compares chararray 'lhs' for inequality with stringlist 'rhs'
    !> Returns a logical
    pure logical function ineq_carray_stringlist( lhs, rhs )
        character(len=*), dimension(:), intent(in)  :: lhs
        type(stringlist_type), intent(in)           :: rhs

        ineq_carray_stringlist = .not.( lhs == rhs)

    end function ineq_carray_stringlist

    !> Compares stringarray 'lhs' for inequality with stringlist 'rhs'
    !> Returns a logical
    pure logical function ineq_sarray_stringlist( lhs, rhs )
        type(string_type), dimension(:), intent(in) :: lhs
        type(stringlist_type), intent(in)           :: rhs

        ineq_sarray_stringlist = .not.( lhs == rhs )

    end function ineq_sarray_stringlist

  ! clear:

    !> Version: experimental
    !>
    !> Resets stringlist 'list' to an empy stringlist of len 0
    !> Modifies the input stringlist 'list'
    subroutine clear_list( list )
        class(stringlist_type), intent(inout) :: list

        if ( allocated( list%stringarray ) ) then
            deallocate( list%stringarray )
        end if

    end subroutine clear_list

  ! len:

    !> Version: experimental
    !>
    !> Returns the len (length) of the list
    !> Returns an integer
    pure integer function length_list( list )
        class(stringlist_type), intent(in) :: list

        length_list = 0
        if ( allocated( list%stringarray ) ) then
            length_list = size( list%stringarray )
        end if

    end function length_list

  ! to_future_at_idxn:

    !> Version: experimental
    !>
    !> Converts a forward index OR a backward index to an integer index at
    !> which the new element will be present post insertion (i.e. in future)
    !> Returns an integer
    pure integer function convert_to_future_at_idxn( list, idx )
        !> Not a part of public API
        class(stringlist_type), intent(in)      :: list
        type(stringlist_index_type), intent(in) :: idx

        ! Formula: merge( fidx( x ) - ( list_head - 1 ), len - bidx( x ) + ( list_tail - 1 ) + 2, ... )
        convert_to_future_at_idxn = merge( idx%offset, list%len() - idx%offset + 2 , idx%forward )

    end function convert_to_future_at_idxn

  ! to_current_idxn:

    !> Version: experimental
    !>
    !> Converts a forward index OR backward index to its equivalent integer index idxn
    !> Returns an integer
    pure integer function convert_to_current_idxn( list, idx )
        !> Not a part of public API
        class(stringlist_type), intent(in)      :: list
        type(stringlist_index_type), intent(in) :: idx

        ! Formula: merge( fidx( x ) - ( list_head - 1 ), len + 1 - bidx( x ) + ( list_tail - 1 ), ... )
        convert_to_current_idxn = merge( idx%offset, list%len() - idx%offset + 1, idx%forward )

    end function convert_to_current_idxn

  ! insert_at:

    !> Version: experimental
    !>
    !> Inserts character scalar 'string' AT stringlist_index 'idx' in stringlist 'list'
    !> Modifies the input stringlist 'list'
    subroutine insert_at_char_idx_wrap( list, idx, string )
        class(stringlist_type), intent(inout)       :: list
        type(stringlist_index_type), intent(in)     :: idx
        character(len=*), intent(in)                :: string

        call list%insert_at( idx, string_type( string ) )

    end subroutine insert_at_char_idx_wrap

    !> Version: experimental
    !>
    !> Inserts string 'string' AT stringlist_index 'idx' in stringlist 'list'
    !> Modifies the input stringlist 'list'
    subroutine insert_at_string_idx_wrap( list, idx, string )
        class(stringlist_type), intent(inout)       :: list
        type(stringlist_index_type), intent(in)     :: idx
        type(string_type), intent(in)               :: string

        call list%insert_before( list%to_future_at_idxn( idx ), string )

    end subroutine insert_at_string_idx_wrap

    !> Version: experimental
    !>
    !> Inserts stringlist 'slist' AT stringlist_index 'idx' in stringlist 'list'
    !> Modifies the input stringlist 'list'
    subroutine insert_at_stringlist_idx_wrap( list, idx, slist )
        class(stringlist_type), intent(inout)       :: list
        type(stringlist_index_type), intent(in)     :: idx
        type(stringlist_type), intent(in)           :: slist

        call list%insert_before( list%to_future_at_idxn( idx ), slist )

    end subroutine insert_at_stringlist_idx_wrap

    !> Version: experimental
    !>
    !> Inserts chararray 'carray' AT stringlist_index 'idx' in stringlist 'list'
    !> Modifies the input stringlist 'list'
    subroutine insert_at_chararray_idx_wrap( list, idx, carray )
        class(stringlist_type), intent(inout)       :: list
        type(stringlist_index_type), intent(in)     :: idx
        character(len=*), dimension(:), intent(in)  :: carray

        call list%insert_before( list%to_future_at_idxn( idx ), carray )

    end subroutine insert_at_chararray_idx_wrap

    !> Version: experimental
    !>
    !> Inserts stringarray 'sarray' AT stringlist_index 'idx' in stringlist 'list'
    !> Modifies the input stringlist 'list'
    subroutine insert_at_stringarray_idx_wrap( list, idx, sarray )
        class(stringlist_type), intent(inout)       :: list
        type(stringlist_index_type), intent(in)     :: idx
        type(string_type), dimension(:), intent(in) :: sarray

        call list%insert_before( list%to_future_at_idxn( idx ), sarray )

    end subroutine insert_at_stringarray_idx_wrap

    !> Version: experimental
    !>
    !> Inserts 'positions' number of empty positions BEFORE integer index 'idxn'
    !> Modifies the input stringlist 'list'
    subroutine insert_before_empty_positions( list, idxn, positions )
        !> Not a part of public API
        class(stringlist_type), intent(inout)           :: list
        integer, intent(inout)                          :: idxn
        integer, intent(in)                             :: positions

        integer                                         :: i, inew
        integer                                         :: new_len, old_len
        type(string_type), dimension(:), allocatable    :: new_stringarray

        if (positions > 0) then

            idxn    = clip( idxn, 1, list%len() + 1 )
            old_len = list%len()
            new_len = old_len + positions

            allocate( new_stringarray(new_len) )

            do i = 1, idxn - 1
                ! TODO: can be improved by move
                new_stringarray(i) = list%stringarray(i)
            end do
            do i = idxn, old_len
                inew = i + positions
                ! TODO: can be improved by move
                new_stringarray(inew) = list%stringarray(i)
            end do

            call move_alloc( new_stringarray, list%stringarray )

        end if

    end subroutine insert_before_empty_positions

    !> Version: experimental
    !>
    !> Inserts string 'string' BEFORE integer index 'idxn' in the underlying stringarray
    !> Modifies the input stringlist 'list'
    subroutine insert_before_string_int_impl( list, idxn, string )
        !> Not a part of public API
        class(stringlist_type), intent(inout)           :: list
        integer, intent(in)                             :: idxn
        type(string_type), intent(in)                   :: string

        integer                                         :: work_idxn

        work_idxn = idxn
        call insert_before_empty_positions( list, work_idxn, 1 )

        list%stringarray(work_idxn) = string

    end subroutine insert_before_string_int_impl

    !> Version: experimental
    !>
    !> Inserts stringlist 'slist' BEFORE integer index 'idxn' in the underlying stringarray
    !> Modifies the input stringlist 'list'
    subroutine insert_before_stringlist_int_impl( list, idxn, slist )
        !> Not a part of public API
        class(stringlist_type), intent(inout)           :: list
        integer, intent(in)                             :: idxn
        type(stringlist_type), intent(in)               :: slist

        integer                                         :: i
        integer                                         :: work_idxn, idxnew
        integer                                         :: pre_length, post_length

        work_idxn   = idxn
        pre_length  = slist%len()
        call insert_before_empty_positions( list, work_idxn, pre_length )
        post_length = slist%len()

        do i = 1, min( work_idxn - 1, pre_length )
            idxnew = work_idxn + i - 1
            list%stringarray(idxnew) = slist%stringarray(i)
        end do

        do i = work_idxn + post_length - pre_length, post_length
            idxnew = work_idxn + i - post_length + pre_length - 1
            list%stringarray(idxnew) = slist%stringarray(i)
        end do

    end subroutine insert_before_stringlist_int_impl

    !> Version: experimental
    !>
    !> Inserts chararray 'carray' BEFORE integer index 'idxn' in the underlying stringarray
    !> Modifies the input stringlist 'list'
    subroutine insert_before_chararray_int_impl( list, idxn, carray )
        !> Not a part of public API
        class(stringlist_type), intent(inout)        :: list
        integer, intent(in)                          :: idxn
        character(len=*), dimension(:), intent(in)   :: carray

        integer                                      :: i
        integer                                      :: work_idxn, idxnew

        work_idxn = idxn
        call insert_before_empty_positions( list, work_idxn, size( carray ) )

        do i = 1, size( carray )
            idxnew = work_idxn + i - 1
            list%stringarray(idxnew) = string_type( carray(i) )
        end do

    end subroutine insert_before_chararray_int_impl

    !> Version: experimental
    !>
    !> Inserts stringarray 'sarray' BEFORE integer index 'idxn' in the underlying stringarray
    !> Modifies the input stringlist 'list'
    subroutine insert_before_stringarray_int_impl( list, idxn, sarray )
        !> Not a part of public API
        class(stringlist_type), intent(inout)        :: list
        integer, intent(in)                          :: idxn
        type(string_type), dimension(:), intent(in)  :: sarray

        integer                                      :: i
        integer                                      :: work_idxn, idxnew

        work_idxn = idxn
        call insert_before_empty_positions( list, work_idxn, size( sarray ) )

        do i = 1, size( sarray )
            idxnew = work_idxn + i - 1
            list%stringarray(idxnew) = sarray(i)
        end do

    end subroutine insert_before_stringarray_int_impl

  ! get:

    !> Version: experimental
    !>
    !> Returns the string present at stringlist_index 'idx' in stringlist 'list'
    !> Returns string_type instance
    pure function get_string_idx_wrap( list, idx )
        class(stringlist_type), intent(in)      :: list
        type(stringlist_index_type), intent(in) :: idx
        type(string_type)                       :: get_string_idx_wrap

        integer                                 :: idxn

        idxn = list%to_current_idxn( idx )

        ! if the index is out of bounds, return a string_type equivalent to empty string
        if ( 1 <= idxn .and. idxn <= list%len() ) then
            get_string_idx_wrap = list%stringarray(idxn)

        end if

    end function get_string_idx_wrap


end module stdlib_stringlist_type

program example_join
  use stdlib_strings, only: join
  implicit none

  character(len=:), allocatable :: line
  character(*), parameter :: words(3) = [character(7) :: "Hello", "World", "Fortran"]
  
  ! Default separator (space)
  line = join(words)
  print *, "'" // line // "'"   !! 'Hello World Fortran'

  ! Custom separator
  line = join(words, "_")
  print *, "'" // line // "'"  !! 'Hello_World_Fortran'

  ! Custom 2-character separator
  line = join(words, ", ")
  print *, "'" // line // "'"  !! 'Hello, World, Fortran'

end program example_join

program example_constructor_character
  use stdlib_string_type
  implicit none
  type(string_type) :: string
! len(string) == 0
  string = "Sequence"
! len(string) == 8
end program example_constructor_character

program example_mnorm
    use stdlib_linalg, only: mnorm
    use stdlib_kinds, only: sp
    implicit none
    real(sp) :: a(3,3), na
    real(sp) :: b(3,3,4), nb(4)  ! Array of 4 3x3 matrices
    
    ! Initialize example matrix
    a = reshape([1, 2, 3, 4, 5, 6, 7, 8, 9], [3, 3])
    
    ! Compute Euclidean norm of single matrix
    na = mnorm(a, 'Euclidean')
    print *, "Euclidean norm of matrix a:", na
    
    ! Initialize array of matrices
    b(:,:,1) = a
    b(:,:,2) = 2*a
    b(:,:,3) = 3*a
    b(:,:,4) = 4*a
    
    ! Compute infinity norm of each 3x3 matrix in b
    nb = mnorm(b, 'inf', dim=[1,2])

    ! 18.0000000       36.0000000       54.0000000       72.0000000
    print *, "Infinity norms of matrices in b:", nb
end program example_mnorm

! Demonstrate OS detection
program example_os_type
    use stdlib_system, only: OS_TYPE, OS_NAME
    implicit none

    integer :: current_os

    ! Cached OS detection
    current_os = OS_TYPE() 
    print *, "Current OS Type: ", OS_NAME(current_os) 

end program example_os_type

program example_llt
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  logical :: res

  string = "bcd"
  res = llt(string, "abc")
! res .eqv. .false.

  res = llt(string, "bcd")
! res .eqv. .false.

  res = llt(string, "cde")
! res .eqv. .true.
end program example_llt

program example_init
  use stdlib_hashmaps, only: chaining_hashmap_type, open_hashmap_type
  use stdlib_hashmap_wrappers, only: fnv_1_hasher
  implicit none
  type(chaining_hashmap_type) :: map
  logical :: present
  
  
  !If default values are used, then init can be typically be skipped as the first map_entry call will initialize the map using default values.  
  call map%map_entry('key', 'value')
  call map%key_test('key', present)
  print *, "Key exists without explicit init call =  ", present
  
  ! Init can be called to clear all items in a map. 
  call map%init()
  call map%key_test('key', present)
  print *, "Key exists after re-initalization =  ", present
  
  ! User can optional specify hasher type and slots_bits instead of using default values.  
  ! Number of slots in the hashmap will initially equal 2**slots_bits.   
  ! The hashmap will automatically re-size as needed; however for better performance, a rule of thumb is to size so that number of slots is ~2X expected number of entries.
  ! In this example with slots_bits=10, there will initially be 1024 slots in the map.  
  call map%init(hasher=fnv_1_hasher, slots_bits=10)
  call map%map_entry('key', 'value')
  
end program example_init

program example_sparse_data_accessors
   use stdlib_linalg_constants, only: dp
   use stdlib_sparse
   implicit none

   real(dp) :: mat(2, 2)
   real(dp), allocatable :: dense_matrix(:, :)
   type(CSR_dp_type) :: CSR
   type(COO_dp_type) :: COO
   integer :: i, j, locdof(2)

   ! Initial data
   mat(:, 1) = [1._dp, 2._dp]
   mat(:, 2) = [2._dp, 1._dp]
   allocate (dense_matrix(5, 5), source=0._dp)
   do i = 0, 3
      dense_matrix(1 + i:2 + i, 1 + i:2 + i) = dense_matrix(1 + i:2 + i, 1 + i:2 + i) + mat
   end do

   print *, 'Original Matrix'
   do j = 1, 5
      print '(5f8.1)', dense_matrix(j, :)
   end do

   ! Initialize CSR data and reset dense reference matrix
   call dense2coo(dense_matrix, COO)
   call coo2csr(COO, CSR)
   CSR%data = 0._dp
   dense_matrix = 0._dp

   ! Iteratively add blocks of data
   do i = 0, 3
      locdof(1:2) = [1 + i, 2 + i]
      call CSR%add(locdof, locdof, mat)
      ! lets print a dense view of every step
      call csr2dense(CSR, dense_matrix)
      print '(A,I2)', 'Add block :', i + 1
      do j = 1, 5
         print '(5f8.1)', dense_matrix(j, :)
      end do
   end do

   ! Request values from the matrix
   print *, ''
   print *, 'within sparse pattern  :', CSR%at(2, 1)
   print *, 'outside sparse pattern :', CSR%at(5, 2)
   print *, 'outside matrix pattern :', CSR%at(7, 7)

end program example_sparse_data_accessors

program example_check2
  use stdlib_error, only: check
  implicit none
  integer :: a = 1
! If a /= 5, stops the program with exit code 1 and prints  'a == 5 failed.'
  call check(a == 5, msg='a == 5 failed.')
end program example_check2

program example_to_c_char
  use stdlib_strings, only: to_c_char
  use stdlib_string_type, only: string_type
  use stdlib_kinds, only: c_char
  implicit none
  
  character(kind=c_char), allocatable :: cstr(:),cstr2(:)
  character(*), parameter :: hello = "Hello, World!"
  
  ! Convert character array
  cstr = to_c_char(hello)
  
  ! Convert string type  
  cstr2 = to_c_char(string_type(hello))
    
  if (size(cstr)/=size(cstr2) .or. .not.all(cstr==cstr2)) then 
     error stop 'String conversion error'
  end if
  
end program example_to_c_char

program example_adjustr
  use stdlib_string_type
  implicit none
  type(string_type) :: string

  string = "Whitespace                            "
  string = adjustr(string)
! char(string) == "                            Whitespace"
end program example_adjustr

program example_tridiagonal_matrix_cdp
    use stdlib_linalg_constants, only: dp
    use stdlib_specialmatrices, only: tridiagonal_cdp_type, tridiagonal, dense, spmv
    implicit none

    integer, parameter :: n = 5
    type(tridiagonal_cdp_type) :: A
    complex(dp) :: dl(n-1), dv(n), du(n-1)
    complex(dp) :: x(n), y(n), y_dense(n)
    integer :: i
    complex(dp) :: alpha, beta

    dl = [(cmplx(i,i, dp), i=1, n - 1)]
    dv = [(cmplx(2*i,2*i, dp), i=1, n)]
    du = [(cmplx(3*i,3*i, dp), i=1, n - 1)]

    A = tridiagonal(dl, dv, du)

    x = (1.0_dp, 0.0_dp)
    y = (3.0_dp, -7.0_dp)
    y_dense = (0.0_dp, 0.0_dp)
    alpha = cmplx(2.0_dp, 3.0_dp)
    beta = cmplx(-1.0_dp, 5.0_dp)

    y_dense = alpha * matmul(dense(A), x) + beta * y
    call spmv(A, x, y, alpha, beta)

    print *, 'dense       :', y_dense
    print *, 'Tridiagonal :', y
end program example_tridiagonal_matrix_cdp

program example_slice
  use stdlib_string_type
  use stdlib_strings, only: slice
  implicit none
  type(string_type) :: string
  character(len=10) :: chars

  string = "abcdefghij"
! string <-- "abcdefghij"

  chars = "abcdefghij"
! chars <-- "abcdefghij"

  print'(a)', slice("abcdefghij", 2, 6, 2)   ! "bdf"
  print'(a)', slice(chars, 2, 6, 2)           ! "bdf"

  string = slice(string, 2, 6, 2)
! string <-- "bdf"

end program example_slice

program example_is_diagonal
  use stdlib_linalg, only: is_diagonal
  implicit none
  real :: A(2, 2), B(2, 2)
  logical :: res
  A = reshape([1., 0., 0., 4.], shape(A))
  B = reshape([1., 0., 3., 4.], shape(B))
  res = is_diagonal(A) ! returns .true.
  res = is_diagonal(B) ! returns .false.
end program example_is_diagonal

program example_len
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: length

  string = "Some longer sentence for this example."
  length = len(string)
! length == 38

  string = "Whitespace                            "
  length = len(string)
! length == 38
end program example_len

! SPDX-Identifer: MIT
module test_string_intrinsic
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_string_type
    implicit none

    abstract interface
        !> Actual tester working on a string type and a fixed length character
        !> representing the same character sequence
        subroutine check1_interface(error, str1, chr1)
            import :: string_type, error_type
            type(error_type), allocatable, intent(out) :: error
            type(string_type), intent(in) :: str1
            character(len=*), intent(in) :: chr1
        end subroutine check1_interface

        !> Actual tester working on two pairs of string type and fixed length
        !> character representing the same character sequences
        subroutine check2_interface(error, str1, chr1, str2, chr2)
            import :: string_type, error_type
            type(error_type), allocatable, intent(out) :: error
            type(string_type), intent(in) :: str1, str2
            character(len=*), intent(in) :: chr1, chr2
        end subroutine check2_interface
    end interface

contains


    !> Collect all exported unit tests
    subroutine collect_string_intrinsic(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("lgt", test_lgt), &
            new_unittest("llt", test_llt), &
            new_unittest("lge", test_lge), &
            new_unittest("lle", test_lle), &
            new_unittest("trim", test_trim), &
            new_unittest("len", test_len), &
            new_unittest("len_trim", test_len_trim), &
            new_unittest("adjustl", test_adjustl), &
            new_unittest("adjustr", test_adjustr), &
            new_unittest("scan", test_scan), &
            new_unittest("verify", test_verify), &
            new_unittest("repeat", test_repeat), &
            new_unittest("index", test_index), &
            new_unittest("char", test_char), &
            new_unittest("ichar", test_ichar), &
            new_unittest("iachar", test_iachar), &
            new_unittest("move", test_move) &
            ]
    end subroutine collect_string_intrinsic

    !> Generate then checker both for the string type created from the character
    !> sequence by the contructor and the assignment operation
    subroutine check1(error, chr1, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1
        procedure(check1_interface) :: checker
        call constructor_check1(error, chr1, checker)
        if (allocated(error)) return
        call assignment_check1(error, chr1, checker)
    end subroutine check1

    !> Run the actual checker with a string type generated by the custom constructor
    subroutine constructor_check1(error, chr1, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1
        procedure(check1_interface) :: checker
        call checker(error, string_type(chr1), chr1)
    end subroutine constructor_check1

    !> Run the actual checker with a string type generated by assignment
    subroutine assignment_check1(error, chr1, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1
        type(string_type) :: str1
        procedure(check1_interface) :: checker
        str1 = chr1
        call checker(error, str1, chr1)
    end subroutine assignment_check1

    !> Generate then checker both for the string type created from the character
    !> sequence by the contructor and the assignment operation as well as the
    !> mixed assigment and constructor setup
    subroutine check2(error, chr1, chr2, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1, chr2
        procedure(check2_interface) :: checker
        call constructor_check2(error, chr1, chr2, checker)
        if (allocated(error)) return
        call assignment_check2(error, chr1, chr2, checker)
        if (allocated(error)) return
        call mixed_check2(error, chr1, chr2, checker)
    end subroutine check2

    !> Run the actual checker with both string types generated by the custom constructor
    subroutine constructor_check2(error, chr1, chr2, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1, chr2
        procedure(check2_interface) :: checker
        call checker(error, string_type(chr1), chr1, string_type(chr2), chr2)
    end subroutine constructor_check2

    !> Run the actual checker with one string type generated by the custom constructor
    !> and the other by assignment
    subroutine mixed_check2(error, chr1, chr2, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1, chr2
        type(string_type) :: str1, str2
        procedure(check2_interface) :: checker
        str1 = chr1
        str2 = chr2
        call checker(error, str1, chr1, string_type(chr2), chr2)
        if (allocated(error)) return
        call checker(error, string_type(chr1), chr1, str2, chr2)
    end subroutine mixed_check2

    !> Run the actual checker with both string types generated by assignment
    subroutine assignment_check2(error, chr1, chr2, checker)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: chr1, chr2
        type(string_type) :: str1, str2
        procedure(check2_interface) :: checker
        str1 = chr1
        str2 = chr2
        call checker(error, str1, chr1, str2, chr2)
    end subroutine assignment_check2

    !> Generator for checking the lexical comparison
    subroutine gen_lgt(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, lgt(str1, str2) .eqv. lgt(chr1, chr2))
        if (allocated(error)) return
        call check(error, lgt(str1, chr2) .eqv. lgt(chr1, chr2))
        if (allocated(error)) return
        call check(error, lgt(chr1, str2) .eqv. lgt(chr1, chr2))
    end subroutine gen_lgt

    subroutine test_lgt(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = lgt(string, "abc")
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = lgt(string, "bcd")
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = lgt(string, "cde")
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        call check2(error, "bcd", "abc", gen_lgt)
        if (allocated(error)) return
        call check2(error, "bcd", "bcd", gen_lgt)
        if (allocated(error)) return
        call check2(error, "bcd", "cde", gen_lgt)
    end subroutine test_lgt

    !> Generator for checking the lexical comparison
    subroutine gen_llt(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, llt(str1, str2) .eqv. llt(chr1, chr2))
        if (allocated(error)) return
        call check(error, llt(str1, chr2) .eqv. llt(chr1, chr2))
        if (allocated(error)) return
        call check(error, llt(chr1, str2) .eqv. llt(chr1, chr2))
    end subroutine gen_llt

    subroutine test_llt(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = llt(string, "abc")
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = llt(string, "bcd")
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = llt(string, "cde")
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        call check2(error, "bcd", "abc", gen_llt)
        if (allocated(error)) return
        call check2(error, "bcd", "bcd", gen_llt)
        if (allocated(error)) return
        call check2(error, "bcd", "cde", gen_llt)
    end subroutine test_llt

    !> Generator for checking the lexical comparison
    subroutine gen_lge(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, lge(str1, str2) .eqv. lge(chr1, chr2))
        if (allocated(error)) return
        call check(error, lge(str1, chr2) .eqv. lge(chr1, chr2))
        if (allocated(error)) return
        call check(error, lge(chr1, str2) .eqv. lge(chr1, chr2))
    end subroutine gen_lge

    subroutine test_lge(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = lge(string, "abc")
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = lge(string, "bcd")
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = lge(string, "cde")
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        call check2(error, "bcd", "abc", gen_lge)
        if (allocated(error)) return
        call check2(error, "bcd", "bcd", gen_lge)
        if (allocated(error)) return
        call check2(error, "bcd", "cde", gen_lge)
    end subroutine test_lge

    !> Generator for checking the lexical comparison
    subroutine gen_lle(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, lle(str1, str2) .eqv. lle(chr1, chr2))
        if (allocated(error)) return
        call check(error, lle(str1, chr2) .eqv. lle(chr1, chr2))
        if (allocated(error)) return
        call check(error, lle(chr1, str2) .eqv. lle(chr1, chr2))
    end subroutine gen_lle

    subroutine test_lle(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = lle(string, "abc")
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = lle(string, "bcd")
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = lle(string, "cde")
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        call check2(error, "bcd", "abc", gen_lle)
        if (allocated(error)) return
        call check2(error, "bcd", "bcd", gen_lle)
        if (allocated(error)) return
        call check2(error, "bcd", "cde", gen_lle)
    end subroutine test_lle

    !> Generator for checking the trimming of whitespace
    subroutine gen_trim(error, str1, chr1)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1
        character(len=*), intent(in) :: chr1
        call check(error, len(trim(str1)) == len(trim(chr1)))
    end subroutine gen_trim

    subroutine test_trim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

       type(string_type) :: string, trimmed_str

       string = "Whitespace                            "
       trimmed_str = trim(string)
       call check(error, len(trimmed_str) == 10)
       if (allocated(error)) return

       call check1(error, " Whitespace  ", gen_trim)
       if (allocated(error)) return
       call check1(error, " W h i t e s p a ce  ", gen_trim)
       if (allocated(error)) return
       call check1(error, "SPACE    SPACE", gen_trim)
       if (allocated(error)) return
       call check1(error, "                           ", gen_trim)
    end subroutine test_trim

    !> Generator for checking the length of the character sequence
    subroutine gen_len(error, str1, chr1)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1
        character(len=*), intent(in) :: chr1
        call check(error, len(str1) == len(chr1))
    end subroutine gen_len

    subroutine test_len(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: length

        string = "Some longer sentence for this example."
        length = len(string)
        call check(error, length == 38)
        if (allocated(error)) return

        string = "Whitespace                            "
        length = len(string)
        call check(error, length == 38)
        if (allocated(error)) return

        call check1(error, "Example string", gen_len)
        if (allocated(error)) return
        call check1(error, "S P A C E D   S T R I N G", gen_len)
        if (allocated(error)) return
        call check1(error, "With trailing whitespace               ", gen_len)
        if (allocated(error)) return
        call check1(error, "     centered      ", gen_len)
    end subroutine test_len

    !> Generator for checking the length of the character sequence without whitespace
    subroutine gen_len_trim(error, str1, chr1)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1
        character(len=*), intent(in) :: chr1
        call check(error, len_trim(str1) == len_trim(chr1))
    end subroutine gen_len_trim

    subroutine test_len_trim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: length

        string = "Some longer sentence for this example."
        length = len_trim(string)
        call check(error, length == 38)
        if (allocated(error)) return

        string = "Whitespace                            "
        length = len_trim(string)
        call check(error, length == 10)
        if (allocated(error)) return

        call check1(error, "Example string", gen_len_trim)
        if (allocated(error)) return
        call check1(error, "S P A C E D   S T R I N G", gen_len_trim)
        if (allocated(error)) return
        call check1(error, "With trailing whitespace               ", gen_len_trim)
        if (allocated(error)) return
        call check1(error, "     centered      ", gen_len_trim)
    end subroutine test_len_trim

    !> Generator for checking the left adjustment of the character sequence
    subroutine gen_adjustl(error, str1, chr1)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1
        character(len=*), intent(in) :: chr1
        call check(error, adjustl(str1) == adjustl(chr1))
    end subroutine gen_adjustl

    subroutine test_adjustl(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string

        string = "                            Whitespace"
        string = adjustl(string)
        call check(error, char(string) == "Whitespace                            ")
        if (allocated(error)) return

        call check1(error, "           B L A N K S        ", gen_adjustl)
    end subroutine test_adjustl

    !> Generator for checking the right adjustment of the character sequence
    subroutine gen_adjustr(error, str1, chr1)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1
        character(len=*), intent(in) :: chr1
        call check(error, adjustr(str1) == adjustr(chr1))
    end subroutine gen_adjustr

    subroutine test_adjustr(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string

        string = "Whitespace                            "
        string = adjustr(string)
        call check(error, char(string) == "                            Whitespace")
        if (allocated(error)) return

        call check1(error, "           B L A N K S        ", gen_adjustr)
    end subroutine test_adjustr

    !> Generator for checking the presence of a character set in a character sequence
    subroutine gen_scan(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, scan(str1, str2) == scan(chr1, chr2))
        if (allocated(error)) return
        call check(error, scan(str1, chr2) == scan(chr1, chr2))
        if (allocated(error)) return
        call check(error, scan(chr1, str2) == scan(chr1, chr2))
        if (allocated(error)) return
        call check(error, scan(str1, str2, back=.true.) == scan(chr1, chr2, back=.true.))
        if (allocated(error)) return
        call check(error, scan(str1, chr2, back=.true.) == scan(chr1, chr2, back=.true.))
        if (allocated(error)) return
        call check(error, scan(chr1, str2, back=.true.) == scan(chr1, chr2, back=.true.))
    end subroutine gen_scan

    subroutine test_scan(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: pos

        string = "fortran"
        pos = scan(string, "ao")
        call check(error, pos == 2)
        if (allocated(error)) return

        pos = scan(string, "ao", .true.)
        call check(error, pos == 6)
        if (allocated(error)) return

        pos = scan(string, "c++")
        call check(error, pos == 0)
        if (allocated(error)) return

        call check2(error, "fortran", "ao", gen_scan)
        if (allocated(error)) return
        call check2(error, "c++", "fortran", gen_scan)

    end subroutine test_scan

    !> Generator for checking the absence of a character set in a character sequence
    subroutine gen_verify(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, verify(str1, str2) == verify(chr1, chr2))
        if (allocated(error)) return
        call check(error, verify(str1, chr2) == verify(chr1, chr2))
        if (allocated(error)) return
        call check(error, verify(chr1, str2) == verify(chr1, chr2))
        if (allocated(error)) return
        call check(error, verify(str1, str2, back=.true.) == verify(chr1, chr2, back=.true.))
        if (allocated(error)) return
        call check(error, verify(str1, chr2, back=.true.) == verify(chr1, chr2, back=.true.))
        if (allocated(error)) return
        call check(error, verify(chr1, str2, back=.true.) == verify(chr1, chr2, back=.true.))
    end subroutine gen_verify

    subroutine test_verify(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: pos

        string = "fortran"
        pos = verify(string, "ao")
        call check(error, pos == 1)
        if (allocated(error)) return

        pos = verify(string, "fo")
        call check(error, pos == 3)
        if (allocated(error)) return

        pos = verify(string, "c++")
        call check(error, pos == 1)
        if (allocated(error)) return

        pos = verify(string, "c++", back=.true.)
        call check(error, pos == 7)
        if (allocated(error)) return

        pos = verify(string, string)
        call check(error, pos == 0)
        if (allocated(error)) return

        call check2(error, "fortran", "ao", gen_verify)
        if (allocated(error)) return
        call check2(error, "c++", "fortran", gen_verify)

    end subroutine test_verify

    !> Generator for the repeatition of a character sequence
    subroutine gen_repeat(error, str1, chr1)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1
        character(len=*), intent(in) :: chr1
        integer :: i
        do i = 12, 3, -2
            call check(error, repeat(str1, i) == repeat(chr1, i))
            if (allocated(error)) return
        end do
    end subroutine gen_repeat

    subroutine test_repeat(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string

        string = "What? "
        string = repeat(string, 3)
        call check(error, string == "What? What? What? ")
        if (allocated(error)) return

        call check1(error, "!!1!", gen_repeat)
        if (allocated(error)) return
        call check1(error, "This sentence is repeated multiple times. ", gen_repeat)

    end subroutine test_repeat

    !> Generator for checking the substring search in a character string
    subroutine gen_index(error, str1, chr1, str2, chr2)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type), intent(in) :: str1, str2
        character(len=*), intent(in) :: chr1, chr2
        call check(error, index(str1, str2) == index(chr1, chr2))
        if (allocated(error)) return
        call check(error, index(str1, chr2) == index(chr1, chr2))
        if (allocated(error)) return
        call check(error, index(chr1, str2) == index(chr1, chr2))
        if (allocated(error)) return
        call check(error, index(str1, str2, back=.true.) == index(chr1, chr2, back=.true.))
        if (allocated(error)) return
        call check(error, index(str1, chr2, back=.true.) == index(chr1, chr2, back=.true.))
        if (allocated(error)) return
        call check(error, index(chr1, str2, back=.true.) == index(chr1, chr2, back=.true.))
    end subroutine gen_index

    subroutine test_index(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: pos

        string = "Search this string for this expression"
        pos = index(string, "this")
        call check(error, pos == 8)
        if (allocated(error)) return

        pos = index(string, "this", back=.true.)
        call check(error, pos == 24)
        if (allocated(error)) return

        pos = index(string, "This")
        call check(error, pos == 0)
        if (allocated(error)) return

        call check2(error, "Search this string for this expression", "this", gen_index)
        if (allocated(error)) return
        call check2(error, "Search this string for this expression", "This", gen_index)

    end subroutine test_index

    subroutine test_char(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        character(len=:), allocatable :: dlc
        character(len=1), allocatable :: chars(:)

        string = "Character sequence"
        dlc = char(string)
        call check(error, dlc == "Character sequence")
        if (allocated(error)) return

        dlc = char(string, 3)
        call check(error, dlc == "a")
        if (allocated(error)) return
        chars = char(string, [3, 5, 8, 12, 14, 15, 18])
        call check(error, all(chars == ["a", "a", "e", "e", "u", "e", "e"]))
        if (allocated(error)) return

        string = "Fortran"
        dlc = char(string, 1, 4)
        call check(error, dlc == "Fort")
    end subroutine test_char

    subroutine test_ichar(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: code

        string = "Fortran"
        code = ichar(string)
        call check(error, code == ichar("F"))
    end subroutine test_ichar

    subroutine test_iachar(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: code

        string = "Fortran"
        code = iachar(string)
        call check(error, code == iachar("F"))
    end subroutine test_iachar

    subroutine test_move(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(string_type) :: from_string, to_string
        type(string_type) :: from_string_not
        type(string_type) :: from_strings(2), to_strings(2)
        character(len=:), allocatable :: from_char, to_char

        from_string = "Move This String"
        from_strings = "Move This String"
        from_char = "Move This Char"
        call check(error, from_string == "Move This String" .and. to_string == "" .and. &
            & from_char == "Move This Char" .and. .not. allocated(to_char), &
            & "move: test_case 1")
        if (allocated(error)) return

        ! string_type (allocated) --> string_type (not allocated)
        call move(from_string, to_string)
        call check(error, from_string == "" .and. to_string == "Move This String", "move: test_case 2")
        if (allocated(error)) return

        ! character (allocated) --> string_type (not allocated)
        call move(from_char, from_string)
        call check(error, .not. allocated(from_char) .and. from_string == "Move This Char", &
            & "move: test_case 3")
        if (allocated(error)) return

        ! string_type (allocated) --> character (not allocated)
        call move(to_string, to_char)
        call check(error, to_string == "" .and. to_char == "Move This String", "move: test_case 4")
        if (allocated(error)) return

        ! character (allocated) --> string_type (allocated)
        call move(to_char, from_string)
        call check(error, .not. allocated(to_char) .and. from_string == "Move This String", &
            & "move: test_case 5")
        if (allocated(error)) return

        from_char = "new char"
        ! character (allocated) --> string_type (allocated)
        call move(from_char, from_string)
        call check(error, .not. allocated(from_char) .and. from_string == "new char", "move: test_case 6")
        if (allocated(error)) return

        ! character (not allocated) --> string_type (allocated)
        call move(from_char, from_string)
        call check(error, from_string == "", "move: test_case 7")
        if (allocated(error)) return

        from_string = "moving to self"
        ! string_type (allocated) --> string_type (allocated)
        call move(from_string, from_string)
        call check(error, from_string == "moving to self", "move: test_case 8")
        if (allocated(error)) return
        
        ! elemental: string_type (allocated) --> string_type (not allocated)
        call move(from_strings, to_strings)
        call check(error, all(from_strings(:) == "") .and. all(to_strings(:) == "Move This String"), "move: test_case 9")

        ! string_type (not allocated) --> string_type (not allocated)
        call move(from_string_not, to_string)
        call check(error, from_string_not == "" .and. to_string == "", "move: test_case 10")
        if (allocated(error)) return

        ! string_type (not allocated) --> string_type (not allocated)
        to_string = "to be deallocated"
        call move(from_string_not, to_string)
        call check(error, from_string_not == "" .and. to_string == "", "move: test_case 11")
        if (allocated(error)) return

    end subroutine test_move

end module test_string_intrinsic


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_string_intrinsic, only : collect_string_intrinsic
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("string-intrinsic", collect_string_intrinsic) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

module test_path
    use testdrive, only : new_unittest, unittest_type, error_type, check, skip_test
    use stdlib_system, only: join_path, operator(/), split_path, OS_TYPE, OS_WINDOWS
    implicit none
contains
    !> Collect all exported unit tests
    subroutine collect_suite(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest('test_join_path', test_join_path), &
            new_unittest('test_join_path_operator', test_join_path_op), &
            new_unittest('test_split_path', test_split_path) &
        ]
    end subroutine collect_suite

    subroutine checkpath(error, funcname, expected, got)
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: funcname
        character(len=*), intent(in) :: expected
        character(len=:), allocatable :: got
        character(len=:), allocatable :: message

        message = "'"//funcname//"'"//" error: Expected '"// expected // "' but got '" // got // "'"
        call check(error, expected == got, message)

    end subroutine checkpath

    subroutine test_join_path(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=:), allocatable :: path
        character(len=20) :: paths(5)

        if (OS_TYPE() == OS_WINDOWS) then
            path = join_path('C:\Users', 'Alice')
            call checkpath(error, 'join_path', 'C:\Users\Alice', path)
            if (allocated(error)) return

            paths = [character(20) :: 'C:','Users','Bob','Pictures','2025']
            path = join_path(paths)

            call checkpath(error, 'join_path', 'C:\Users\Bob\Pictures\2025', path)
            if (allocated(error)) return

            path = join_path('"C:\Users\John Doe"', 'Pictures\2025') ! path with spaces
            call checkpath(error, 'join_path', '"C:\Users\John Doe"\Pictures\2025', path)
            if (allocated(error)) return
        else
            path = join_path('/home', 'Alice')
            call checkpath(error, 'join_path', '/home/Alice', path)
            if (allocated(error)) return

            paths = [character(20) :: '','home','Bob','Pictures','2025']
            path = join_path(paths)

            call checkpath(error, 'join_path', '/home/Bob/Pictures/2025', path)
            if (allocated(error)) return
        end if
    end subroutine test_join_path

    !> Test the operator
    subroutine test_join_path_op(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=:), allocatable :: path

        if (OS_TYPE() == OS_WINDOWS) then
            path = 'C:'/'Users'/'Alice'/'Desktop'
            call checkpath(error, 'join_path operator', 'C:\Users\Alice\Desktop', path)
            if (allocated(error)) return
        else
            path = ''/'home'/'Alice'/'.config'
            call checkpath(error, 'join_path operator', '/home/Alice/.config', path)
            if (allocated(error)) return
        end if
    end subroutine test_join_path_op

    subroutine test_split_path(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=:), allocatable :: head, tail

        call split_path('', head, tail)
        call checkpath(error, 'split_path-head', '.', head)
        if (allocated(error)) return
        call checkpath(error, 'split_path-tail', '', tail)
        if (allocated(error)) return

        if (OS_TYPE() == OS_WINDOWS) then
            call split_path('\\\\', head, tail)
            call checkpath(error, 'split_path-head', '\', head)
            if (allocated(error)) return
            call checkpath(error, 'split_path-tail', '', tail)
            if (allocated(error)) return

            call split_path('C:\', head, tail)
            call checkpath(error, 'split_path-head', 'C:\', head)
            if (allocated(error)) return
            call checkpath(error, 'split_path-tail', '', tail)
            if (allocated(error)) return

            call split_path('C:\Users\Alice\\\\\', head, tail)
            call checkpath(error, 'split_path-head', 'C:\Users', head)
            if (allocated(error)) return
            call checkpath(error, 'split_path-tail', 'Alice', tail)
            if (allocated(error)) return
        else
            call split_path('/////', head, tail)
            call checkpath(error, 'split_path-head', '/', head)
            if (allocated(error)) return
            call checkpath(error, 'split_path-tail', '', tail)
            if (allocated(error)) return

            call split_path('/home/Alice/foo/bar.f90///', head, tail)
            call checkpath(error, 'split_path-head', '/home/Alice/foo', head)
            if (allocated(error)) return
            call checkpath(error, 'split_path-tail', 'bar.f90', tail)
            if (allocated(error)) return
        end if
    end subroutine test_split_path

end module test_path

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_path, only : collect_suite

    implicit none

    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("path", collect_suite) &
    ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program tester

program example_check1
  use stdlib_error, only: check
  implicit none
  integer :: a = 1
! If a /= 5, stops the program with exit code 1 and prints 'Check failed.'
  call check(a == 5)
end program example_check1

module test_stdlib_bitset_64
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use :: stdlib_kinds, only : int8, int16, int32, int64
    use stdlib_bitsets
    implicit none
    private

    public :: collect_stdlib_bitset_64

    character(*), parameter :: &
        bitstring_0   = '000000000000000000000000000000000', &
        bitstring_33  = '100000000000000000000000000000000', &
        bitstring_all = '111111111111111111111111111111111'

contains

    !> Collect all exported unit tests
    subroutine collect_stdlib_bitset_64(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("string-operations-0", test_string_operations_0), &
            new_unittest("string-operations-1", test_string_operations_1), &
            new_unittest("string-operations-3", test_string_operations_3), &
            new_unittest("string-operations-4", test_string_operations_4), &
            new_unittest("io", test_io), &
            new_unittest("initialization", test_initialization), &
            new_unittest("bitset-inquiry", test_bitset_inquiry), &
            new_unittest("bit-operations", test_bit_operations), &
            new_unittest("bitset-comparisons", test_bitset_comparisons), &
            new_unittest("bitset-operations-and", test_bitset_operations_and), &
            new_unittest("bitset-operations-nand", test_bitset_operations_nand), &
            new_unittest("bitset-operations-or", test_bitset_operations_or), &
            new_unittest("bitset-operations-xor", test_bitset_operations_xor) &
            ]

    end subroutine collect_stdlib_bitset_64

    subroutine test_string_operations_0(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set
        character(:), allocatable :: string0

        call set%from_string(bitstring_0)

        call check(error, bits(set), 33)
        if (allocated(error)) return

        call check(error, set%none())
        if (allocated(error)) return

        call check(error, .not.set%any())
        if (allocated(error)) return

        call set%to_string(string0)

        call check(error, string0, bitstring_0)
        if (allocated(error)) return

        call set%write_bitset(string0)

        call check(error, string0, ('S33B' // bitstring_0))
        if (allocated(error)) return

    end subroutine test_string_operations_0

    subroutine test_string_operations_1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set
        character(:), allocatable :: string0

        call set%from_string(bitstring_all)

        call check(error, bits(set), 33)
        if (allocated(error)) return

        call check(error, .not.set%none() )
        if (allocated(error)) return

        call check(error, set%any() )
        if (allocated(error)) return

        call check(error, set%all() )
        if (allocated(error)) return

        call set%to_string(string0)

        call check(error, string0, bitstring_all)
        if (allocated(error)) return

        call set%write_bitset(string0)

        call check(error, string0, ('S33B' // bitstring_all))
        if (allocated(error)) return

    end subroutine test_string_operations_1

    subroutine test_string_operations_3(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set
        integer         :: status

        call set%read_bitset(bitstring_0, status)

        call check(error, status /= success)
        if (allocated(error)) return

        call set%read_bitset('s33b' // bitstring_0, status)

        call check(error, bits(set), 33)
        if (allocated(error)) return

        call check(error, set%none())
        if (allocated(error)) return

    end subroutine test_string_operations_3

    subroutine test_string_operations_4(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set

        call set%read_bitset('s33b' // bitstring_all )

        call check(error, bits(set), 33)
        if (allocated(error)) return

        call check(error, .not.set%none())
        if (allocated(error)) return

        call check(error, set%any())
        if (allocated(error)) return

        call check(error, set%all())
        if (allocated(error)) return

    end subroutine test_string_operations_4

    subroutine test_io(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: unit
        type(bitset_64) :: set0, set1, set2, set3, set4, set5

        call set0%from_string(bitstring_0)
        call set1%from_string(bitstring_all)
        call set2%from_string(bitstring_33)

        open( newunit=unit, status='scratch', form='formatted', &
              action='readwrite' )
        call set2%write_bitset(unit)
        call set1%write_bitset(unit)
        call set0%write_bitset(unit)
        rewind( unit )
        call set3%read_bitset(unit)
        call set5%read_bitset(unit)
        call set4%read_bitset(unit)

        call check(error, set4 == set0 .and. set5 == set1 .and. set3 == set2, &
            'transfer to and from units using bitset literals failed.')
        if (.not.allocated(error)) then
            rewind( unit )

            call set2%write_bitset(unit, advance='no')
            call set1%write_bitset(unit, advance='no')
            call set0%write_bitset(unit)
            rewind( unit )
            call set3%read_bitset(unit, advance='no')
            call set4%read_bitset(unit, advance='no')
            call set5%read_bitset(unit)

            call check(error, set5 == set0 .and. set4 == set1 .and. set3 == set2, &
                'transfer to and from units using bitset literals with advance="no" failed.')
        end if
        close(unit)
        if (allocated(error)) return

        open( newunit=unit, form='unformatted', status='scratch', &
              action='readwrite' )
        call set2%output(unit)
        call set1%output(unit)
        call set0%output(unit)
        rewind( unit )
        call set5%input(unit)
        call set4%input(unit)
        call set3%input(unit)
        close( unit )

        call check(error, set3 == set0 .and. set4 == set1 .and. set5 == set2, &
            'transfer to and from units using output and input failed.')
        if (allocated(error)) return

        open( newunit=unit, form='unformatted', access='stream', &
              status='scratch', action='readwrite' )
        call set2%output(unit)
        call set1%output(unit)
        call set0%output(unit)
        rewind( unit )
        call set5%input(unit)
        call set4%input(unit)
        call set3%input(unit)
        close( unit )

        call check(error, set3 == set0 .and. set4 == set1 .and. set5 == set2, &
            'transfer to and from units using stream output and input failed.')
        if (allocated(error)) return

    end subroutine test_io

    subroutine test_initialization(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        logical(int8)  :: log1(64) = .true.
        logical(int16) :: log2(31) = .false.
        logical(int32) :: log3(15) = .true.
        logical(int64) :: log4(33) = .false.
        logical(int8), allocatable  :: log5(:)
        logical(int16), allocatable :: log6(:)
        logical(int32), allocatable :: log7(:)
        logical(int64), allocatable :: log8(:)

        type(bitset_64) :: set4, set5

        !The following block triggers an issue in gfortran 11 and 12
        block
        type(bitset_64) :: set6
        call check(error, set6 % bits(), 0, &
            'set6 % bits() returned non-zero value '//&
            'even though set6 was not initialized.')
        if (allocated(error)) return
        end block

        set5 = log1
        call check(error, set5%bits(), 64, &
            'initialization with logical(int8) failed to set the right size.')
        if (allocated(error)) return
        call check(error, set5%all(), &
            'initialization with logical(int8) failed to set the right values.')
        if (allocated(error)) return

        set5 = log2
        call check(error, set5%bits(), 31, &
            'initialization with logical(int16) failed to set the right size.')
        if (allocated(error)) return
        call check(error, set5%none(), &
            'initialization with logical(int16) failed to set the right values.')
        if (allocated(error)) return

        set5 = log3
        call check(error, set5%bits(), 15, &
            'initialization with logical(int32) failed to set the right size.')
        if (allocated(error)) return
        call check(error, set5%all(), &
            'initialization with logical(int32) failed to set the right values.')
        if (allocated(error)) return

        set5 = log4
        call check(error, set5%bits(), 33, &
            'initialization with logical(int64) failed to set the right size.')
        if (allocated(error)) return
        call check(error, set5%none(), &
            'initialization with logical(int64) failed to set the right values.')
        if (allocated(error)) return

        set5 = log1
        call extract( set4, set5, 1_bits_kind, 33_bits_kind )
        call check(error, set4%bits(), 33, &
            'initialization with extract failed to set the right size.')
        if (allocated(error)) return
        call check(error, set4%all(), &
            'initialization with extract failed to set the right values.')
        if (allocated(error)) return

        set4 = set5
        call check(error, set4%bits(), 64, &
            'initialization with simple assignment failed to set the right size.')
        if (allocated(error)) return
        call check(error, set4%all(), &
            'initialization with simple assignment failed to set the right values.')
        if (allocated(error)) return

        log5 = set5
        call check(error, size(log5), 64, &
            'initialization of logical(int8) with assignment failed to set the right size.')
        if (allocated(error)) return
        call check(error, all(log5) .eqv. .true., &  ! FIXME
            'initialization of logical(int8) with assignment failed to set the right values.')
        if (allocated(error)) return

        log6 = set5
        call check(error, size(log6), 64, &
            'initialization of logical(int16) with assignment failed to set the right size.')
        if (allocated(error)) return
        call check(error, all(log6) .eqv. .true., &  ! FIXME
            'initialization of logical(int16) with assignment failed to set the right values.')
        if (allocated(error)) return

        log7 = set5
        call check(error, size(log7), 64, &
            'initialization of logical(int32) with assignment failed to set the right size.')
        if (allocated(error)) return
        call check(error, all(log7), &
            'initialization of logical(int32) with assignment failed to set the right values.')
        if (allocated(error)) return

        log8 = set5
        call check(error, size(log8), 64, &
            'initialization of logical(int64) with assignment failed to set the right size.')
        if (allocated(error)) return
        call check(error, merge(.true., .false., all(log8)), &  ! FIXME
            'initialization of logical(int64) with assignment failed to set the right values.')
        if (allocated(error)) return

    end subroutine test_initialization

    subroutine test_bitset_inquiry(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer(bits_kind) :: i

        type(bitset_64) :: set0, set1

        call set0%from_string(bitstring_0)
        call set1%from_string(bitstring_all)

        call check(error, set0%none(), 'set0 did not have none set which ' // &
            'was unexpected')
        if (allocated(error)) return
        call check(error, .not. set0%any(), 'set0 had some bits set which ' // &
            'was unexpected.')
        if (allocated(error)) return

        call set0%not()
        call check(error, set0%all(), 'set0 did not have all bits set ' // &
            'which was unexpected')
        if (allocated(error)) return
        call check(error, set0%any(), 'set0 had no bits set which ' // &
            'was unexpected.')
        if (allocated(error)) return

        call check(error, set1%any(), 'set1 had no bits set ' // &
            'which was unexpected')
        if (allocated(error)) return
        call check(error, set1%all(), 'set1 did not have all bits set ' // &
            'which was unexpected.')
        if (allocated(error)) return

        call set0%not()
        do i=0, set0%bits() - 1
            call check(error, .not. set0%test(i), &
                'against expectations set0 has at least 1 bit set.')
        end do

        do i=0, set1%bits() - 1
            call check(error, set1%test(i), &
                'against expectations set1 has at least 1 bit unset.')
        end do

        do i=0, set0%bits() - 1
            call check(error, .not.( set0%value(i) /= 0), &
                'against expectations set0 has at least 1 bit set.')
        end do

        do i=0, set1%bits() - 1
            call check(error, .not.( set1%value(i) /= 1), &
                'against expectations set1 has at least 1 bit unset.')
        end do

        call check(error, set0%bits() == 33, 'et0 unexpectedly does not have 33 bits.')
        if (allocated(error)) return

    end subroutine test_bitset_inquiry

    subroutine test_bit_operations(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set1

        call set1%from_string(bitstring_all)

        call check(error, set1%all(), 'set1 is not all set.')
        if (allocated(error)) return

        call set1%clear(0_bits_kind)
        call check(error, .not. set1%test(0_bits_kind), 'did not clear the first bit in set1.')
        if (allocated(error)) return
        call check(error, set1%test(1_bits_kind), 'cleared more than one bit in set1.')
        if (allocated(error)) return

        call set1%clear(1_bits_kind, 32_bits_kind)
        call check(error, set1%none(), 'did not clear remaining bits in set1.')
        if (allocated(error)) return

        call set1%flip(0_bits_kind)
        call check(error, set1%test(0_bits_kind), 'did not flip the first bit in set1.')
        if (allocated(error)) return
        call check(error, .not. set1%test(1_bits_kind), 'flipped more than one bit in set1.')
        if (allocated(error)) return

        call set1%flip(1_bits_kind, 32_bits_kind)
        call check(error, set1%all(), 'did not flip remaining bits in set1.')
        if (allocated(error)) return

        call set1%not()
        call check(error, set1%none(), 'did not unset bits in set1.')
        if (allocated(error)) return

        call set1%set(0_bits_kind)
        call check(error, set1%test(0_bits_kind), 'did not set the first bit in set1.')
        if (allocated(error)) return
        call check(error, .not. set1%test(1_bits_kind), 'set more than one bit in set1.')
        if (allocated(error)) return

        call set1%set(1_bits_kind, 32_bits_kind)
        call check(error, set1%all(), 'did not set the remaining bits in set1.')
        if (allocated(error)) return

    end subroutine test_bit_operations

    subroutine test_bitset_comparisons(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set0, set1, set2

        call set0%from_string(bitstring_0)
        call set1%from_string(bitstring_all)
        call set2%from_string(bitstring_33)

        call check(error, set0 == set0 .and. set1 == set1 .and. set2 == set2 .and. &
            .not. set0 == set1 .and. .not. set0 == set2 .and. .not.   &
            set1 == set2, 'failed 64 bit equality tests.')
        if (allocated(error)) return

        call check(error, set0 /= set1 .and. set1 /= set2 .and. set0 /= set2 .and. &
            .not. set0 /= set0 .and. .not. set1 /= set1 .and. .not.   &
            set2 /= set2, 'failed 64 bit inequality tests.')
        if (allocated(error)) return

        call check(error, set1 > set0 .and. set2 > set0 .and. set1 > set2 .and. &
            .not. set0 > set1 .and. .not. set1 > set1 .and. .not.  &
            set2 > set1, 'failed 64 bit greater than tests.')
        if (allocated(error)) return

        call check(error, set1 >= set0 .and. set1 >= set2 .and. set2 >= set2 .and. &
            .not. set0 >= set1 .and. .not. set0 >= set1 .and. .not.  &
            set2 >= set1, 'failed 64 bit greater than or equal tests.')
        if (allocated(error)) return

        call check(error, set0 < set1 .and. set0 < set1 .and. set2 < set1 .and. &
            .not. set1 < set0 .and. .not. set0 < set0 .and. .not.  &
            set1 < set2, 'failed 64 bit less than tests.')
        if (allocated(error)) return

        call check(error, set0 <= set1 .and. set2 <= set1 .and. set2 <= set2 .and. &
            .not. set1 <= set0 .and. .not. set2 <= set0 .and. .not.  &
            set1 <= set2, 'failed 64 bit less than or equal tests.')
        if (allocated(error)) return

    end subroutine test_bitset_comparisons

    subroutine test_bitset_operations_and(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set3, set4, set0

        call set0%from_string( bitstring_all )
        call set4%from_string( bitstring_all )
        call and( set0, set4 ) ! all all
        call check(error, set0%all(), 'first test of AND failed.')
        if (allocated(error)) return

        call set4%from_string( bitstring_0 )
        call set3%from_string( bitstring_all )
        call and( set3, set4 ) ! all none
        call check(error, set3%none(), 'second test of AND failed.')
        if (allocated(error)) return

        call set3%from_string( bitstring_all )
        call set4%from_string( bitstring_0 )
        call and( set4, set3 ) ! none all
        call check(error, set4%none(), 'third test of AND failed.')
        if (allocated(error)) return

        call set3%from_string( bitstring_0 )
        call and( set4, set3 ) ! none none
        call check(error, set4%none(), 'fourth test of AND failed.')
        if (allocated(error)) return

    end subroutine test_bitset_operations_and

    subroutine test_bitset_operations_nand(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set3, set4

        call set3%from_string( bitstring_all )
        call set4%from_string( bitstring_all )
        call and_not( set4, set3 ) ! all all
        call check(error, set4%none(), 'first test of AND_NOT failed.')
        if (allocated(error)) return

        call set4%from_string( bitstring_0 )
        call and_not( set4, set3 ) ! none all
        call check(error, set4%none(), 'second test of AND_NOT failed.')
        if (allocated(error)) return

        call set3%from_string( bitstring_all )
        call set4%from_string( bitstring_0 )
        call and_not( set3, set4 ) ! all none
        call check(error, set3%all(), 'third  test of AND_NOT failed.')
        if (allocated(error)) return

        call set3%from_string( bitstring_0 )
        call set4%from_string( bitstring_0 )
        call and_not( set3, set4 ) ! none none
        call check(error, set3%none(), 'fourth  test of AND_NOT failed.')
        if (allocated(error)) return

    end subroutine test_bitset_operations_nand

    subroutine test_bitset_operations_or(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set3, set4

        call set3%from_string( bitstring_all )
        call set4%from_string( bitstring_all )
        call or( set3, set4 ) ! all all
        call check(error, set3%all(), 'first test of OR failed.')
        if (allocated(error)) return

        call set3%from_string( bitstring_0 )
        call or( set4, set3 ) ! all none
        call check(error, set4%all(), 'second test of OR failed.')
        if (allocated(error)) return

        call or( set3, set4 ) ! none all
        call check(error, set3%all(), 'third test of OR failed.')
        if (allocated(error)) return

        call set3%from_string( bitstring_0 )
        call set4%from_string( bitstring_0 )
        call or( set4, set3 ) !none none
        call check(error, set4%none(), 'fourth test of OR failed.')
        if (allocated(error)) return

    end subroutine test_bitset_operations_or

    subroutine test_bitset_operations_xor(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_64) :: set3, set4

        call set3%from_string( bitstring_0 )
        call set4%from_string( bitstring_0 )
        call xor( set3, set4 ) ! none none
        call check(error, set3%none(), 'first test of XOR failed.')
        if (allocated(error)) return

        call set4%from_string( bitstring_all )
        call xor( set3, set4 ) ! none all
        call check(error, set3%all(), 'second test of XOR failed.')
        if (allocated(error)) return

        call set4%from_string( bitstring_0 )
        call xor( set3, set4 ) ! all none
        call check(error, set3%all(), 'third test of XOR failed.')
        if (allocated(error)) return

        call set4%from_string( bitstring_all )
        call xor( set3, set4 ) ! all all
        call check(error, set3%none(), 'fourth test of XOR failed.')
        if (allocated(error)) return

    end subroutine test_bitset_operations_xor


end module test_stdlib_bitset_64


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_stdlib_bitset_64, only : collect_stdlib_bitset_64
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("stdlib-bitset-64", collect_stdlib_bitset_64) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

! Usage of dir_name
program example_path_dir_name
    use stdlib_system, only: dir_name, OS_TYPE, OS_WINDOWS
    character(len=:), allocatable :: p1, head, tail

    if(OS_TYPE() == OS_WINDOWS) then
        p1 = 'C:\Users' ! C:\Users
    else
        p1 = '/home' ! /home
    endif 

    print *, 'dir_name of '// p1 // ' -> ' // dir_name(p1) 
    ! dir_name of C:\Users -> C:\
    ! OR
    ! dir_name of /home -> /
end program example_path_dir_name

module test_filesystem
    use testdrive, only : new_unittest, unittest_type, error_type, check, skip_test
    use stdlib_system, only: is_directory, delete_file, FS_ERROR, FS_ERROR_CODE, &
        make_directory, remove_directory, make_directory_all, is_windows, OS_TYPE, &
        OS_WINDOWS, get_cwd, set_cwd, operator(/), exists, fs_type_unknown, &
        fs_type_regular_file, fs_type_directory, fs_type_symlink, is_file
    use stdlib_error, only: state_type, STDLIB_FS_ERROR
    use stdlib_strings, only: to_string

    implicit none

contains

    !> Collect all exported unit tests
    subroutine collect_suite(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("fs_error", test_fs_error), &
            new_unittest("fs_exists_not_exists", test_exists_not_exists), &
            new_unittest("fs_exists_reg_file", test_exists_reg_file), &
            new_unittest("fs_exists_dir", test_exists_dir), &
            new_unittest("fs_exists_symlink", test_exists_symlink), &
            new_unittest("fs_is_file", test_is_file), &
            new_unittest("fs_is_directory_dir", test_is_directory_dir), &
            new_unittest("fs_is_directory_file", test_is_directory_file), &
            new_unittest("fs_delete_non_existent", test_delete_file_non_existent), &
            new_unittest("fs_delete_existing_file", test_delete_file_existing), &
            new_unittest("fs_delete_file_being_dir", test_delete_directory), &
            new_unittest("fs_make_dir", test_make_directory), &
            new_unittest("fs_make_dir_existing_dir", test_make_directory_existing), &
            new_unittest("fs_make_dir_all", test_make_directory_all), &
            new_unittest("fs_remove_dir", test_remove_directory), &
            new_unittest("fs_remove_dir_non_existent", test_remove_directory_nonexistent), &
            new_unittest("fs_cwd", test_cwd) &
        ]
    end subroutine collect_suite

    subroutine test_fs_error(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: s1, s2
        character(:), allocatable :: msg

        msg = "code - 10, Cannot create File temp.txt - File already exists"
        s1 = FS_ERROR_CODE(10, "Cannot create File temp.txt -", "File already exists")

        call check(error, s1%state == STDLIB_FS_ERROR .and. s1%message == msg, &
            "FS_ERROR_CODE: Could not construct the state with code correctly")
        if (allocated(error)) return

        msg = "Cannot create File temp.txt - File already exists"
        s2 = FS_ERROR("Cannot create File temp.txt -", "File already exists")

        call check(error, s2%state == STDLIB_FS_ERROR .and. s2%message == msg, &
            "FS_ERROR: Could not construct state without code correctly")
        if (allocated(error)) return
    end subroutine test_fs_error

    subroutine test_exists_not_exists(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err

        character(*), parameter :: path = "rand_name"
        integer :: t

        t = exists(path, err)
        call check(error, err%error(), "False positive for a non-existent path!")
    end subroutine test_exists_not_exists

    subroutine test_exists_reg_file(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: filename
        integer :: ios, iunit, t
        character(len=512) :: msg

        filename = "test_file.txt"

        ! Create a file
        open(newunit=iunit, file=filename, status="replace", iostat=ios, iomsg=msg)
        call check(error, ios == 0, "Cannot init test_exists_reg_file: " // trim(msg))
        if (allocated(error)) return

        t = exists(filename, err)
        call check(error, err%ok(), "exists failed for reg file: " // err%print())

        if (allocated(error)) then
            ! Clean up: remove the file
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message// " and cannot delete test file: " // trim(msg))
            return
        end if

        call check(error, t == fs_type_regular_file, "exists incorrectly identifies type of &
            reg files!: type=" // to_string(t))

        if (allocated(error)) then
            ! Clean up: remove the file
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message// " and cannot delete test file: " // trim(msg))
            return
        end if

        ! Clean up: remove the file
        close(iunit,status='delete',iostat=ios,iomsg=msg)
        call check(error, ios == 0, "Cannot delete test file: " // trim(msg))
        if (allocated(error)) return
    end subroutine test_exists_reg_file

    subroutine test_is_file(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=256) :: filename
        integer :: ios, iunit
        character(len=512) :: msg

        logical :: is_reg_file

        filename = "test_file.txt"

        ! Create a file
        open(newunit=iunit, file=filename, status="replace", iostat=ios, iomsg=msg)
        call check(error, ios == 0, "Cannot init test_is_file: " // trim(msg))
        if (allocated(error)) return

        is_reg_file = is_file(filename)
        call check(error, is_reg_file, "is_file could not identify a file")

        if (allocated(error)) then
            ! Clean up: remove the file
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message// " and cannot delete test file: " // trim(msg))
            return
        end if

        ! Clean up: remove the file
        close(iunit,status='delete',iostat=ios,iomsg=msg)
        call check(error, ios == 0, "Cannot delete test file: " // trim(msg))
        if (allocated(error)) return
    end subroutine test_is_file

    subroutine test_exists_dir(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: dirname
        integer :: ios, iocmd, t
        character(len=512) :: msg

        dirname = "temp_dir"

        ! Create a directory
        call execute_command_line("mkdir " // dirname, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios == 0 .and. iocmd == 0, "Cannot int test_exists_dir: " // trim(msg))
        if (allocated(error)) return

        t = exists(dirname, err)
        call check(error, err%ok(), "exists failed for directory: " // err%print())

        if (allocated(error)) then
            ! Clean up: remove the directory
            call execute_command_line("rmdir " // dirname, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
            call check(error, ios == 0 .and. iocmd == 0, error%message // " and &
                & cannot cleanup test_exists_dir: " // trim(msg))
            return
        end if

        call check(error, t == fs_type_directory, "exists incorrectly identifies type of &
            directories!: type=" // to_string(t))

        if (allocated(error)) then
            ! Clean up: remove the directory
            call execute_command_line("rmdir " // dirname, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
            call check(error, ios == 0 .and. iocmd == 0, error%message // " and &
                & cannot cleanup test_exists_dir: " // trim(msg))
            return
        end if

        ! Clean up: remove the directory
        call execute_command_line("rmdir " // dirname, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios == 0 .and. iocmd == 0, "Cannot cleanup test_exists_dir: " // trim(msg))
    end subroutine test_exists_dir

    subroutine test_exists_symlink(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=128) :: target_name, link_name
        integer :: ios, iunit, iocmd, t
        character(len=512) :: msg, cmd

        target_name = "test_file.txt"
        link_name = "symlink.txt"

        ! Create a file
        open(newunit=iunit, file=target_name, status="replace", iostat=ios, iomsg=msg)
        call check(error, ios == 0, "Cannot init test_exists_symlink: " // trim(msg))
        if (allocated(error)) return

        if (is_windows()) then
            cmd = 'mklink '//link_name//' '//target_name
            call execute_command_line(cmd, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        else
            cmd = 'ln -s '//target_name//' '//link_name
            call execute_command_line(cmd, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        end if

        call check(error, ios == 0 .and. iocmd == 0, "Cannot create symlink!: " // trim(msg))

        if (allocated(error)) then
            ! Clean up: remove the target
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message // " and cannot delete target: " // trim(msg))
            return
        end if

        t = exists(link_name, err)
        call check(error, err%ok(), "exists failed for symlink: " // err%print())

        if (allocated(error)) then
            ! Clean up: remove the link
            call execute_command_line("rm " // link_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
            call check(error, ios == 0 .and. iocmd == 0, error%message // " and &
                & cannot delete link: " // trim(msg))

            ! Clean up: remove the target
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message // " and cannot delete target: " // trim(msg))
            return
        end if

        call check(error, t == fs_type_symlink, "exists incorrectly identifies type of &
            symlinks!: type=" // to_string(t))

        if (allocated(error)) then
            ! Clean up: remove the link
            call execute_command_line("rm " // link_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
            call check(error, ios == 0 .and. iocmd == 0, error%message // " and &
                & cannot delete link: " // trim(msg))

            ! Clean up: remove the target
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message // " and cannot delete target: " // trim(msg))
            return
        end if

        ! Clean up: remove the link
        call execute_command_line("rm " // link_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios == 0 .and. iocmd == 0, "Cannot delete link: " // trim(msg))

        if (allocated(error)) then
            ! Clean up: remove the target
            close(iunit,status='delete',iostat=ios,iomsg=msg)
            call check(error, ios == 0, error%message // " and cannot delete target: " // trim(msg))
        end if

        ! Clean up: remove the target
        close(iunit,status='delete',iostat=ios,iomsg=msg)
        call check(error, ios == 0, "Cannot delete target: " // trim(msg))
    end subroutine test_exists_symlink

    ! Test `is_directory` for a directory
    subroutine test_is_directory_dir(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=256) :: dirname
        integer :: ios, iocmd
        character(len=512) :: msg

        dirname = "this_test_dir_tmp"

        ! Create a directory
        call execute_command_line("mkdir " // dirname, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios == 0 .and. iocmd == 0, "Cannot create test directory: " // trim(msg))
        if (allocated(error)) return

        ! Verify `is_directory` identifies it as a directory
        call check(error, is_directory(dirname), "is_directory did not recognize a valid directory")
        if (allocated(error)) return

        ! Clean up: remove the directory
        call execute_command_line("rmdir " // dirname, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios == 0 .and. iocmd == 0, "Cannot remove test directory: " // trim(msg))
    end subroutine test_is_directory_dir

    ! Test `is_directory` for a regular file
    subroutine test_is_directory_file(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=256) :: filename
        logical :: result
        integer :: ios, iunit
        character(len=512) :: msg

        filename = "test_file.txt"

        ! Create a file
        open(newunit=iunit, file=filename, status="replace", iostat=ios, iomsg=msg)
        call check(error, ios == 0, "Cannot create test file: " // trim(msg))
        if (allocated(error)) return

        ! Verify `is_directory` identifies it as not a directory
        result = is_directory(filename)
        call check(error, .not. result, "is_directory falsely recognized a regular file as a directory")
        if (allocated(error)) return

        ! Clean up: remove the file
        close(iunit,status='delete',iostat=ios,iomsg=msg)
        call check(error, ios == 0, "Cannot delete test file: " // trim(msg))
        if (allocated(error)) return

    end subroutine test_is_directory_file

    subroutine test_delete_file_non_existent(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: state

        ! Attempt to delete a file that doesn't exist
        call delete_file('non_existent_file.txt', state)

        call check(error, state%ok(), 'Error should not be triggered for non-existent file')
        if (allocated(error)) return

    end subroutine test_delete_file_non_existent

    subroutine test_delete_file_existing(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=256) :: filename
        type(state_type) :: state
        integer :: ios,iunit
        logical :: is_present
        character(len=512) :: msg

        filename = 'existing_file.txt'

        ! Create a file to be deleted
        open(newunit=iunit, file=filename, status='replace', iostat=ios, iomsg=msg)
        call check(error, ios==0, 'Failed to create test file')
        if (allocated(error)) return
        close(iunit)

        ! Attempt to delete the existing file
        call delete_file(filename, state)

        ! Check deletion successful
        call check(error, state%ok(), 'delete_file returned '//state%print())
        if (allocated(error)) return

        ! Check if the file was successfully deleted (should no longer exist)
        inquire(file=filename, exist=is_present)

        call check(error, .not.is_present, 'File still present after delete')
        if (allocated(error)) return

    end subroutine test_delete_file_existing

    subroutine test_delete_directory(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=256) :: filename
        type(state_type) :: state
        integer :: ios,iocmd
        character(len=512) :: msg

        filename = 'test_directory'

        ! The directory is not nested: it should be cross-platform to just call `mkdir`
        call execute_command_line('mkdir ' // filename, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot init delete_directory test: '//trim(msg))
        if (allocated(error)) return

        ! Attempt to delete a directory (which should fail)
        call delete_file(filename, state)

        ! Check that an error was raised since the target is a directory
        call check(error, state%error(), 'Error was not triggered trying to delete directory')
        if (allocated(error)) return

        ! Clean up: remove the empty directory
        call execute_command_line('rmdir ' // filename, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot cleanup delete_directory test: '//trim(msg))
        if (allocated(error)) return

    end subroutine test_delete_directory

    subroutine test_make_directory(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: dir_name
        integer :: ios,iocmd
        character(len=512) :: msg

        dir_name = "test_directory"

        call make_directory(dir_name, err=err)
        call check(error, err%ok(), 'Could not make directory: '//err%print())
        if (allocated(error)) return

        ! clean up: remove the empty directory
        call execute_command_line('rmdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot cleanup make_directory test: '//trim(msg))
    end subroutine test_make_directory

    subroutine test_make_directory_existing(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: dir_name
        integer :: ios,iocmd
        character(len=512) :: msg

        dir_name = "test_directory"

        call execute_command_line('mkdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot init make_directory_existing test: '//trim(msg))
        if (allocated(error)) return

        call make_directory(dir_name, err=err)
        call check(error, err%error(), 'Made an already existing directory somehow')

        ! clean up: remove the empty directory
        call execute_command_line('rmdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)

        if (allocated(error)) then
            ! if previous error is allocated as well
            call check(error, ios==0 .and. iocmd==0, error%message // ' and cannot cleanup make_directory test: '//trim(msg))
            return
        end if

        call check(error, ios==0 .and. iocmd==0, 'Cannot cleanup make_directory test: '//trim(msg))
    end subroutine test_make_directory_existing

    subroutine test_make_directory_all(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: dir_name
        integer :: ios,iocmd
        character(len=512) :: msg

        if (OS_TYPE() == OS_WINDOWS) then
            dir_name = "d1\d2\d3\d4\"
        else
            dir_name = "d1/d2/d3/d4/"
        end if

        call make_directory_all(dir_name, err=err)
        call check(error, err%ok(), 'Could not make all directories: '//err%print())
        if (allocated(error)) return

        ! clean up: remove the empty directory
        if (is_windows()) then
            call execute_command_line('rmdir /s /q d1', exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        else
            call execute_command_line('rm -rf d1', exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        end if

        call check(error, ios==0 .and. iocmd==0, 'Cannot cleanup make_directory_all test: '//trim(msg))
    end subroutine test_make_directory_all

    subroutine test_remove_directory(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: dir_name
        integer :: ios,iocmd
        character(len=512) :: msg

        dir_name = "test_directory"

        call execute_command_line('mkdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot init remove_directory test: '//trim(msg))
        if (allocated(error)) return

        call remove_directory(dir_name, err)
        call check(error, err%ok(), 'Could not remove directory: '//err%print())

        if (allocated(error)) then
            ! clean up: remove the empty directory
            call execute_command_line('rmdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
            call check(error, ios==0 .and. iocmd==0, error%message // ' and cannot cleanup make_directory test: '//trim(msg))
        end if
    end subroutine test_remove_directory

    subroutine test_remove_directory_nonexistent(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err

        call remove_directory("random_name", err)
        call check(error, err%error(), 'Somehow removed a non-existent directory')
        if (allocated(error)) return
    end subroutine test_remove_directory_nonexistent

    subroutine test_cwd(error)
        type(error_type), allocatable, intent(out) :: error
        type(state_type) :: err
        character(len=256) :: dir_name
        integer :: ios,iocmd
        character(len=512) :: msg

        character(:), allocatable :: pwd1, pwd2, abs_dir_name

        ! get the initial cwd
        call get_cwd(pwd1, err)
        call check(error, err%ok(), 'Could not get current working directory: '//err%print())
        if (allocated(error)) return

        ! create a temporary directory for use by `set_cwd`
        dir_name = "test_directory"

        call execute_command_line('mkdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot init cwd test: '//trim(msg))
        if (allocated(error)) return

        abs_dir_name = pwd1 / dir_name
        call set_cwd(abs_dir_name, err)
        call check(error, err%ok(), 'Could not set current working directory: '//err%print())
        if (allocated(error)) return

        ! get the new cwd -> should be same as (pwd1 / dir_name)
        call get_cwd(pwd2, err)
        call check(error, err%ok(), 'Could not get current working directory: '//err%print())
        if (allocated(error)) return

        call check(error, pwd2 == abs_dir_name, 'Working directory is wrong, &
            & expected: '//abs_dir_name//" got: "//pwd2)
        if (allocated(error)) return

        ! cleanup: set the cwd back to the initial value
        call set_cwd(pwd1, err)
        call check(error, err%ok(), 'Could not clean up cwd test, could not set the cwd back: '//err%print())
        if (allocated(error)) then
            ! our cwd now is `./test_directory`
            ! there is no way of removing the empty test directory
            return
        end if

        ! cleanup: remove the empty directory
        call execute_command_line('rmdir ' // dir_name, exitstat=ios, cmdstat=iocmd, cmdmsg=msg)
        call check(error, ios==0 .and. iocmd==0, 'Cannot cleanup cwd test, cannot remove empty dir: '//trim(msg))
        if (allocated(error)) return
    end subroutine test_cwd

end module test_filesystem

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_filesystem, only : collect_suite

    implicit none

    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("filesystem", collect_suite) &
    ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_diag3
  use stdlib_linalg, only: diag
  implicit none
  integer, parameter :: n = 10
  real :: c(n), ul(n - 1)
  real :: A(n, n)
  c = 2
  ul = -1
  A = diag(ul, -1) + diag(c) + diag(ul, 1) ! Gil Strang's favorite matrix
end program example_diag3

program example_solve_bicgstab_wilkinson
    use stdlib_kinds, only: dp
    use stdlib_linalg_iterative_solvers
    use stdlib_sparse
    use stdlib_sparse_spmv
    implicit none

    integer, parameter :: n = 21
    type(COO_dp_type) :: COO
    type(CSR_dp_type) :: A
    type(stdlib_solver_workspace_dp_type) :: workspace
    real(dp) :: b(n), x(n), norm_sq0
    integer :: i

    ! Construct the Wilkinson's matrix in COO format
    ! https://en.wikipedia.org/wiki/Wilkinson_matrix
    call COO%malloc(n, n, n + 2*(n-1))
    COO%data(1:n) = [( real(abs(i), kind=dp), i=-(n-1)/2, (n-1)/2)]
    COO%data(n+1:) = 1.0_dp
    do i = 1, n
        COO%index(1:2, i) = [i,i]
    end do
    do i = 1, n-1
        COO%index(1:2, n+i) = [i,i+1]
        COO%index(1:2, n+n-1+i) = [i+1,i]
    end do
    call coo2ordered(COO,sort_data=.true.)

    ! Convert COO to CSR format
    call coo2csr(COO, A)
    
    ! Set up the right-hand side for the solution to be ones
    b = 0.0_dp
    x = 1.0_dp
    call spmv(A, x, b) ! b = A * 1
    x = 0.0_dp ! initial guess

    ! Solve the system using BiCGSTAB
    workspace%callback => my_logger
    call stdlib_solve_bicgstab(A, b, x, rtol=1e-12_dp, maxiter=100, workspace=workspace)

contains 

    subroutine my_logger(x,norm_sq,iter)
        real(dp), intent(in) :: x(:)
        real(dp), intent(in) :: norm_sq
        integer, intent(in) :: iter
        if(iter == 0) norm_sq0 = norm_sq
        print *, "Iteration: ", iter, " Residual: ", norm_sq, " Relative: ", norm_sq/norm_sq0
    end subroutine

end program example_solve_bicgstab_wilkinson

program example_loading
  use stdlib_hashmaps, only: open_hashmap_type
  implicit none
  type(open_hashmap_type) :: map
  real :: ratio
  call map%init()
  ratio = map%loading()
  print *, "Initial loading =  ", ratio
end program example_loading

program example_log_io_error
  use stdlib_logger, global => global_logger
  implicit none

  character(*), parameter :: filename = 'nodummy.txt'
  integer                 :: iostat, lun
  character(128)          :: iomsg
  character(*), parameter :: message = &
                             'Failure in opening "nodummy.txt".'

  open (newunit=lun, file=filename, form='formatted', &
        status='old', iostat=iostat, iomsg=iomsg)
  if (iostat /= 0) then
    call global%log_io_error(message, &
                             procedure='EXAMPLE', &
                             iostat=iostat, &
                             iomsg=iomsg)
    error stop 'Error on opening a file'
  end if

end program example_log_io_error

! Demonstrate usage of `is_directory`
program example_is_directory
  use stdlib_system, only: is_directory
  implicit none
  ! Test a directory path
  if (is_directory("/path/to/check")) then 
    print *, "The specified path is a directory."
  else
    print *, "The specified path is not a directory."
  end if
end program example_is_directory

module test_rawmoment
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_kinds, only: sp, dp, int32
    use stdlib_stats, only: mean, moment
    use,intrinsic :: ieee_arithmetic, only : ieee_is_nan
    implicit none


    real(sp), parameter :: sptol = 1000 * epsilon(1._sp)
    real(dp), parameter :: dptol = 1000 * epsilon(1._dp)

    real(dp), parameter :: d1(5) = [1.0_dp, 2.0_dp, 3.0_dp, 4.0_dp, 5.0_dp]
    real(dp), parameter :: d(4, 3) = reshape([1._dp, 3._dp, 5._dp, 7._dp,&
                                   2._dp, 4._dp, 6._dp, 8._dp,&
                                   9._dp, 10._dp, 11._dp, 12._dp], [4, 3])


    complex(sp), parameter :: cs1(5) = [ cmplx(0.57706_sp, 0.00000_sp),&
                            cmplx(0.00000_sp, 1.44065_sp),&
                            cmplx(1.26401_sp, 0.00000_sp),&
                            cmplx(0.00000_sp, 0.88833_sp),&
                            cmplx(1.14352_sp, 0.00000_sp)]
    complex(sp), parameter :: cs(5,3) = reshape([cs1, cs1*3.0_sp, cs1*1.5_sp], shape(cs))




contains


    !> Collect all exported unit tests
    subroutine collect_rawmoment(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("sp", test_sp), &
            new_unittest("int32", test_int32), &
            new_unittest("csp", test_csp) &
            ]
    end subroutine collect_rawmoment

    subroutine test_sp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        real(sp), parameter :: x1(5) = d1
        real(sp), parameter :: x2(4, 3) = d

        integer :: order
        real(sp), allocatable :: x3(:, :, :)
        real(sp), allocatable :: zero2_1(:), zero2_2(:)
        real(sp), allocatable :: zero3_1(:,:), zero3_2(:,:), zero3_3(:,:)

        allocate(zero2_1(size(x2, 2)), zero2_2(size(x2, 1)))
        zero2_1 = 0
        zero2_2 = 0

        order = 1

        !1dim
        print*,' test_sp_1dim', order
        call check(error, abs(moment(x1, order, center = 0.) - mean(x1)) < sptol)
        call check(error, abs(moment(x1, order, 1, center = 0.) - mean(x1)) < sptol)

        print*,' test_sp_1dim_mask', order
        call check(error, ieee_is_nan(moment(x1, order, center = 0., mask = .false.)))
        call check(error, ieee_is_nan(moment(x1, order, dim = 1, center = 0., mask = .false.)))

        print*,' test_sp_1dim_mask_array', order
        call check(error, abs(moment(x1, order, center = 0., mask = (x1 < 5)) -&
                          mean(x1, mask = (x1 < 5)) ) < sptol)
        call check(error, abs(moment(x1, order, dim = 1, center = 0., mask = (x1 < 5)) -&
                          mean(x1, dim = 1, mask = (x1 < 5))) < sptol)

        !2dim
        print*,' test_sp_2dim', order
        call check(error, abs(moment(x2, order, center = 0.) - mean(x2)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0.) -&
                        mean(x2, dim = 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0.) -&
                        mean(x2, dim = 2)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1) -&
                        mean(x2, dim = 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2) -&
                        mean(x2, dim = 2)) < sptol))

        print*,' test_sp_2dim_mask', order
        call check(error, ieee_is_nan(moment(x2, order, center = 0., mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 1, center = zero2_1,&
                        mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 2, center = zero2_2,&
                        mask = .false.))))

        print*,' test_sp_2dim_mask_array', order
        call check(error, abs(moment(x2, order, center = 0., mask = (x2 < 11)) -&
                                mean(x2, x2 < 11)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0.,&
                                mask = (x2 < 11)) -&
                                mean(x2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0.,&
                                mask = (x2 < 11)) -&
                                mean(x2, 2, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                                mask = (x2 < 11)) -&
                                mean(x2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2,&
                                mask = (x2 < 11)) -&
                                mean(x2, 2, x2 < 11)) < sptol))

        !3dim
        allocate(x3(size(x2,1),size(x2,2),3))
        x3(:,:,1)=x2;
        x3(:,:,2)=x2*2;
        x3(:,:,3)=x2*4;

        allocate(zero3_1(size(x3, 2), size(x3, 3))&
                 ,zero3_2(size(x3, 1), size(x3, 3))&
                 ,zero3_3(size(x3, 1), size(x3, 2)))
        zero3_1 = 0
        zero3_2 = 0
        zero3_3 = 0

        print*,' test_sp_3dim', order
        call check(error, abs(moment(x3, order, center = 0.) - mean(x3)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0._sp) -&
                               mean(x3, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0._sp) -&
                               mean(x3, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0._sp) -&
                               mean(x3, 3)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1) -&
                               mean(x3, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2) -&
                               mean(x3, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3) -&
                               mean(x3, 3)) < sptol))

        print*,' test_sp_3dim_mask', order
        call check(error, ieee_is_nan(moment(x3, order, center = 0., mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 1, center = zero3_1,&
                         mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 2, center = zero3_2,&
                         mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 3, center = zero3_3,&
                         mask = .false.))))

        print*,' test_sp_3dim_mask_array', order
        call check(error, abs(moment(x3, order, center = 0., mask = (x3 < 11)) -&
                         mean(x3, x3 < 11)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0.,&
                                mask = (x3 < 45)) -&
                                mean(x3, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0.,&
                                mask = (x3 < 45)) -&
                                mean(x3, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0.,&
                                mask = (x3 < 45)) -&
                                mean(x3, 3, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1,&
                                mask = (x3 < 45)) -&
                                mean(x3, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2,&
                                mask = (x3 < 45)) -&
                                mean(x3, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3,&
                                mask = (x3 < 45)) -&
                                mean(x3, 3, x3 < 45)) < sptol ))


        order = 2

        !1dim
        print*,' test_sp_1dim', order
        call check(error, abs(moment(x1, order, center = 0.) - mean(x1**2)) < sptol)
        call check(error, abs(moment(x1, order, 1, center = 0.) - mean(x1**2, 1)) < sptol)

        print*,' test_sp_1dim_mask', order
        call check(error, ieee_is_nan(moment(x1, order, center = 0., mask = .false.)))
        call check(error, ieee_is_nan(moment(x1, order, dim = 1, center = 0., mask = .false.)))

        print*,' test_sp_1dim_mask_array', order
        call check(error, abs(moment(x1, order, center = 0., mask = (x1 < 5)) -&
                          mean(x1**2, x1 < 5)) < sptol)
        call check(error, abs(moment(x1, order, dim = 1, center = 0., mask = (x1 < 5)) -&
                          mean(x1**2, 1, x1 < 5)) < sptol)

        !2dim
        print*,' test_sp_2dim', order
        call check(error, abs(moment(x2, order, center = 0.) - mean(x2**2)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0.) -&
                               mean(x2**2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0.) - &
                               mean(x2**2, 2)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1) -&
                               mean(x2**2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2) - &
                               mean(x2**2, 2)) < sptol))

        print*,' test_sp_2dim_mask', order
        call check(error, ieee_is_nan(moment(x2, order, center = 0., mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 1, center = zero2_1, &
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 2, center = zero2_2, &
                               mask = .false.))))

        print*,' test_sp_2dim_mask_array', order
        call check(error, abs(moment(x2, order, center = 0., mask = (x2 < 11)) -&
                          mean(x2**2, x2 < 11)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0.,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0.,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 2, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 2, x2 < 11)) < sptol))

        !3dim
        print*,' test_sp_3dim', order
        call check(error, abs(moment(x3, order, center = 0.) - mean(x3**2)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0.) -&
                                mean(x3**2, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0.) -&
                                mean(x3**2, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0.) -&
                                mean(x3**2, 3)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1) -&
                                mean(x3**2, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2) -&
                                mean(x3**2, 2)) < 1.5_sp*sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3) -&
                                mean(x3**2, 3)) < sptol))

        print*,' test_sp_3dim_mask', order
        call check(error, ieee_is_nan(moment(x3, order, center = 0., mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 1, center = zero3_1,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 2, center = zero3_2,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 3, center = zero3_3,&
                               mask = .false.))))

        print*,' test_sp_3dim_mask_array', order
        call check(error, abs(moment(x3, order, center = 0., mask = (x3 < 11)) -&
                          mean(x3**2, x3 < 11)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0.,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0.,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0.,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 3, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 3, x3 < 45)) < sptol ))

    end subroutine

    subroutine test_int32(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer(int32), parameter :: x1(5) = d1
        integer(int32), parameter :: x2(4, 3) = d

        integer :: order
        integer(int32), allocatable :: x3(:, :, :)
        real(dp), allocatable :: zero2_1(:), zero2_2(:)
        real(dp), allocatable :: zero3_1(:,:), zero3_2(:,:), zero3_3(:,:)

        allocate(zero2_1(size(x2, 2)), zero2_2(size(x2, 1)))
        zero2_1 = 0
        zero2_2 = 0

        order = 1

        !1dim
        print*,' test_sp_1dim', order
        call check(error, abs(moment(x1, order, center = 0._dp) - mean(x1)) < sptol)
        call check(error, abs(moment(x1, order, 1, center = 0._dp) - mean(x1)) < sptol)

        print*,' test_sp_1dim_mask', order
        call check(error, ieee_is_nan(moment(x1, order, center = 0._dp, mask = .false.)))
        call check(error, ieee_is_nan(moment(x1, order, dim = 1, center = 0._dp,&
                               mask = .false.)))

        print*,' test_sp_1dim_mask_array', order
        call check(error, abs(moment(x1, order, center = 0._dp, mask = (x1 < 5)) -&
                          mean(x1, mask = (x1 < 5)) ) < sptol)
        call check(error, abs(moment(x1, order, dim = 1, center = 0._dp, mask = (x1 < 5)) -&
                          mean(x1, dim = 1, mask = (x1 < 5))) < sptol)

        !2dim
        print*,' test_sp_2dim', order
        call check(error, abs(moment(x2, order, center = 0._dp) - mean(x2)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0._dp) -&
                               mean(x2, dim = 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0._dp) -&
                               mean(x2, dim = 2)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1) -&
                               mean(x2, dim = 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2) -&
                               mean(x2, dim = 2)) < sptol))

        print*,' test_sp_2dim_mask', order
        call check(error, ieee_is_nan(moment(x2, order, center = 0._dp, mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 1, center = zero2_1,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 2, center = zero2_2,&
                               mask = .false.))))

        print*,' test_sp_2dim_mask_array', order
        call check(error, abs(moment(x2, order, center = 0._dp, mask = (x2 < 11)) -&
                               mean(x2, x2 < 11)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0._dp,&
                               mask = (x2 < 11)) -&
                               mean(x2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0._dp,&
                               mask = (x2 < 11)) -&
                               mean(x2, 2, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                               mask = (x2 < 11)) -&
                               mean(x2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2,&
                               mask = (x2 < 11)) -&
                               mean(x2, 2, x2 < 11)) < sptol))

        !3dim
        allocate(x3(size(x2,1),size(x2,2),3))
        x3(:,:,1)=x2;
        x3(:,:,2)=x2*2;
        x3(:,:,3)=x2*4;

        allocate(zero3_1(size(x3, 2), size(x3, 3))&
                 ,zero3_2(size(x3, 1), size(x3, 3))&
                 ,zero3_3(size(x3, 1), size(x3, 2)))
        zero3_1 = 0
        zero3_2 = 0
        zero3_3 = 0

        print*,' test_sp_3dim', order
        call check(error, abs(moment(x3, order, center = 0._dp) - mean(x3)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0._dp) -&
                               mean(x3, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0._dp) -&
                               mean(x3, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0._dp) -&
                               mean(x3, 3)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1) -&
                               mean(x3, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2) -&
                               mean(x3, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3) -&
                               mean(x3, 3)) < sptol))

        print*,' test_sp_3dim_mask', order
        call check(error, ieee_is_nan(moment(x3, order, center = 0._dp, mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 1, center = zero3_1,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 2, center = zero3_2,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 3, center = zero3_3,&
                               mask = .false.))))

        print*,' test_sp_3dim_mask_array', order
        call check(error, abs(moment(x3, order, center = 0._dp, mask = (x3 < 11)) -&
                               mean(x3, x3 < 11)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0._dp,&
                               mask = (x3 < 45)) -&
                               mean(x3, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0._dp,&
                               mask = (x3 < 45)) -&
                               mean(x3, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0._dp,&
                               mask = (x3 < 45)) -&
                               mean(x3, 3, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1,&
                               mask = (x3 < 45)) -&
                               mean(x3, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2,&
                               mask = (x3 < 45)) -&
                               mean(x3, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3,&
                               mask = (x3 < 45)) -&
                               mean(x3, 3, x3 < 45)) < sptol ))


        order = 2

        !1dim
        print*,' test_sp_1dim', order
        call check(error, abs(moment(x1, order, center = 0._dp) - mean(x1**2)) < sptol)
        call check(error, abs(moment(x1, order, 1, center = 0._dp) - mean(x1**2, 1)) < sptol)

        print*,' test_sp_1dim_mask', order
        call check(error, ieee_is_nan(moment(x1, order, center = 0._dp, mask = .false.)))
        call check(error, ieee_is_nan(moment(x1, order, dim = 1, center = 0._dp,&
                               mask = .false.)))

        print*,' test_sp_1dim_mask_array', order
        call check(error, abs(moment(x1, order, center = 0._dp, mask = (x1 < 5)) -&
                          mean(x1**2, x1 < 5)) < sptol)
        call check(error, abs(moment(x1, order, dim = 1, center = 0._dp, mask = (x1 < 5)) -&
                          mean(x1**2, 1, x1 < 5)) < sptol)

        !2dim
        print*,' test_sp_2dim', order
        call check(error, abs(moment(x2, order, center = 0._dp) - mean(x2**2)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0._dp) -&
                               mean(x2**2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0._dp) -&
                               mean(x2**2, 2)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1) -&
                               mean(x2**2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2) -&
                               mean(x2**2, 2)) < sptol))

        print*,' test_sp_2dim_mask', order
        call check(error, ieee_is_nan(moment(x2, order, center = 0._dp, mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 1, center = 0._dp,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 2, center = 0._dp,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 1, center = zero2_1,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, dim = 2, center = zero2_2,&
                               mask = .false.))))

        print*,' test_sp_2dim_mask_array', order
        call check(error, abs(moment(x2, order, center = 0._dp, mask = (x2 < 11)) -&
                          mean(x2**2, x2 < 11)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = 0._dp,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = 0._dp,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 2, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 1, x2 < 11)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2,&
                               mask = (x2 < 11)) -&
                               mean(x2**2, 2, x2 < 11)) < sptol))

        !3dim
        print*,' test_sp_3dim', order
        call check(error, abs(moment(x3, order, center = 0._dp) - mean(x3**2)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0._dp) -&
                                mean(x3**2, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0._dp) -&
                                mean(x3**2, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0._dp) -&
                                mean(x3**2, 3)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1) -&
                                mean(x3**2, 1)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2) -&
                                mean(x3**2, 2)) < sptol))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3) -&
                                mean(x3**2, 3)) < sptol))

        print*,' test_sp_3dim_mask', order
        call check(error, ieee_is_nan(moment(x3, order, center = 0._dp, mask = .false.)))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 1, center = 0._dp,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 2, center = 0._dp,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 3, center = 0._dp,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 1, center = zero3_1,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 2, center = zero3_2,&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, dim = 3, center = zero3_3,&
                               mask = .false.))))

        print*,' test_sp_3dim_mask_array', order
        call check(error, abs(moment(x3, order, center = 0._dp, mask = (x3 < 11)) -&
                          mean(x3**2, x3 < 11)) < sptol)
        call check(error, all( abs( moment(x3, order, dim = 1, center = 0._dp,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = 0._dp,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = 0._dp,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 3, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 1, center = zero3_1,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 1, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 2, center = zero3_2,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 2, x3 < 45)) < sptol ))
        call check(error, all( abs( moment(x3, order, dim = 3, center = zero3_3,&
                               mask = (x3 < 45)) -&
                               mean(x3**2, 3, x3 < 45)) < sptol ))

    end subroutine

    subroutine test_csp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        complex(sp), parameter :: x1(5) = cs1
        complex(sp), parameter :: x2(5, 3) = cs

        integer :: order
        complex(sp), allocatable :: zero2_1(:), zero2_2(:)

        allocate(zero2_1(size(x2, 2)), zero2_2(size(x2, 1)))
        zero2_1 = (0., 0.)
        zero2_2 = (0., 0.)

        order = 1

        !1dim
        print*,' test_sp_1dim', order
        call check(error, abs(moment(x1, order, center = (0., 0.)) - mean(x1)) < sptol)
        call check(error, abs(moment(x1, order, 1, center = (0., 0.)) - mean(x1, 1)) < sptol)

        print*,' test_sp_1dim_mask', order
        call check(error, ieee_is_nan(abs(moment(x1, order, center = (0., 0.),&
                               mask = .false.))))
        call check(error, ieee_is_nan(abs(moment(x1, order, dim = 1, center = (0., 0.),&
                               mask = .false.))))

        print*,' test_sp_1dim_mask_array', order
        call check(error, abs(moment(x1, order, center = (0., 0.), mask = (aimag(x1) == 0)) -&
                          mean(x1, aimag(x1) == 0)) < sptol)
        call check(error, abs(moment(x1, order, dim = 1, center = (0., 0.),&
                          mask = (aimag(x1) == 0)) -&
                          mean(x1, 1, aimag(x1) == 0)) < sptol)

        !2dim
        print*,' test_sp_2dim', order
        call check(error, abs(moment(x2, order, center = (0., 0.)) - mean(x2)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = (0., 0.)) -&
                               mean(x2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = (0., 0.)) -&
                               mean(x2, 2)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1) -&
                               mean(x2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2) -&
                               mean(x2, 2)) < sptol))

        print*,' test_sp_2dim_mask', order
        call check(error, ieee_is_nan(abs(moment(x2, order, center = (0., 0.),&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 1, center = (0., 0.),&
                               mask = .false.)))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 2, center = (0., 0.),&
                               mask = .false.)))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 1, center = zero2_1,&
                               mask = .false.)))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 2, center = zero2_2,&
                               mask = .false.)))))

        print*,' test_sp_2dim_mask_array', order
        call check(error, abs(moment(x2, order, center = (0., 0.), mask = (aimag(x2) == 0)) -&
                          mean(x2, aimag(x2) == 0)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = (0., 0.),&
                               mask = (aimag(x2) == 0)) -&
                               mean(x2, 1, aimag(x2) == 0)) < sptol))
        call check(error, any(ieee_is_nan( abs( moment(x2, order,&
                         dim = 2, center = (0., 0.), mask = (aimag(x2) == 0)) -&
                         mean(x2, 2, aimag(x2) == 0)))))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                               mask = (aimag(x2) == 0)) -&
                               mean(x2, 1, aimag(x2) == 0)) < sptol))
        call check(error, any(ieee_is_nan( abs( moment(x2, order,&
                         dim = 2, center = zero2_2, mask = (aimag(x2) == 0)) -&
                         mean(x2, 2, aimag(x2) == 0)))))

        order = 2

        !1dim
        print*,' test_sp_1dim', order
        call check(error, abs(moment(x1, order, center = (0., 0.)) - mean(x1**2)) < sptol)
        call check(error, abs(moment(x1, order, 1, center = (0., 0.)) -&
                          mean(x1**2, 1)) < sptol)

        print*,' test_sp_1dim_mask', order
        call check(error, ieee_is_nan(abs(moment(x1, order, center = (0., 0.),&
                               mask = .false.))))
        call check(error, ieee_is_nan(abs(moment(x1, order, dim = 1, center = (0., 0.),&
                               mask = .false.))))

        print*,' test_sp_1dim_mask_array', order
        call check(error, abs(moment(x1, order, center = (0., 0.), mask = (aimag(x1) == 0)) -&
                          mean(x1**2, aimag(x1) == 0)) < sptol)
        call check(error, abs(moment(x1, order, dim = 1, center = (0., 0.),&
                          mask = (aimag(x1) == 0)) -&
                          mean(x1**2, 1, aimag(x1) == 0)) < sptol)

        !2dim
        print*,' test_sp_2dim', order
        call check(error, abs(moment(x2, order, center = (0., 0.)) - mean(x2**2)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = (0., 0.)) -&
                               mean(x2**2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = (0., 0.)) -&
                               mean(x2**2, 2)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1) -&
                               mean(x2**2, 1)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 2, center = zero2_2) -&
                               mean(x2**2, 2)) < sptol))

        print*,' test_sp_2dim_mask', order
        call check(error, ieee_is_nan(abs(moment(x2, order, center = (0., 0.),&
                               mask = .false.))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 1, center = (0., 0.),&
                               mask = .false.)))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 2, center = (0., 0.),&
                               mask = .false.)))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 1, center = zero2_1,&
                               mask = .false.)))))
        call check(error, any(ieee_is_nan(abs(moment(x2, order, dim = 2, center = zero2_2,&
                               mask = .false.)))))

        print*,' test_sp_2dim_mask_array', order
        call check(error, abs(moment(x2, order, center = (0., 0.), mask = (aimag(x2) == 0)) -&
                          mean(x2**2, aimag(x2) == 0)) < sptol)
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                          mask = (aimag(x2)==0)) -&
                          mean(x2**2, 1, aimag(x2)==0)) < sptol))
        call check(error, all( abs( moment(x2, order, dim = 1, center = zero2_1,&
                          mask = (aimag(x2)==0)) -&
                          mean(x2**2, 1, aimag(x2)==0)) < sptol))

    end subroutine
end module


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_rawmoment, only : collect_rawmoment
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("rawmoment", collect_rawmoment) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_uwrite
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: io
  string = "Important saved value"

  open (newunit=io, form="unformatted", status="scratch")
  write (io) string

  rewind (io)

  read (io) string
  close (io)
end program example_uwrite

submodule(stdlib_sorting) stdlib_sorting_radix_sort
    implicit none

    integer, parameter :: radix_bits = 8
    integer, parameter :: radix_mask = 255
    integer(kind=int16), parameter :: radix_bits_i16 = 8_int16
    integer(kind=int16), parameter :: radix_mask_i16 = 255_int16
    integer(kind=int32), parameter :: radix_bits_i32 = 8_int32
    integer(kind=int32), parameter :: radix_mask_i32 = 255_int32
    integer(kind=int64), parameter :: radix_bits_i64 = 8_int64
    integer(kind=int64), parameter :: radix_mask_i64 = 255_int64

contains
! For int8, radix sort becomes counting sort, so buffer is not needed
    pure subroutine radix_sort_u8_helper(N, arr)
        integer(kind=int_index), intent(in) :: N
        integer(kind=int8), dimension(N), intent(inout) :: arr
        integer(kind=int_index) :: i
        integer :: bin_idx
        integer(kind=int_index), dimension(-128:127) :: counts
        counts(:) = 0
        do i = 1, N
            bin_idx = arr(i)
            counts(bin_idx) = counts(bin_idx) + 1
        end do
        i = 1
        do bin_idx = -128, 127
            do while (counts(bin_idx) > 0)
                arr(i) = int(bin_idx, kind=int8)
                i = i + 1
                counts(bin_idx) = counts(bin_idx) - 1
            end do
        end do
    end subroutine

    pure subroutine radix_sort_u16_helper(N, arr, buf)
        integer(kind=int_index), intent(in) :: N
        integer(kind=int16), dimension(N), intent(inout) :: arr
        integer(kind=int16), dimension(N), intent(inout) :: buf
        integer(kind=int_index) :: i
        integer :: b, b0, b1
        integer(kind=int_index), dimension(0:radix_mask) :: c0, c1
        c0(:) = 0
        c1(:) = 0
        do i = 1, N
            b0 = iand(arr(i), radix_mask_i16)
            b1 = ishft(arr(i), -radix_bits_i16)
            c0(b0) = c0(b0) + 1
            c1(b1) = c1(b1) + 1
        end do
        do b = 1, radix_mask
            c0(b) = c0(b) + c0(b - 1)
            c1(b) = c1(b) + c1(b - 1)
        end do
        do i = N, 1, -1
            b0 = iand(arr(i), radix_mask_i16)
            buf(c0(b0)) = arr(i)
            c0(b0) = c0(b0) - 1
        end do
        do i = N, 1, -1
            b1 = ishft(buf(i), -radix_bits_i16)
            arr(c1(b1)) = buf(i)
            c1(b1) = c1(b1) - 1
        end do
    end subroutine

    pure subroutine radix_sort_u32_helper(N, arr, buf)
        integer(kind=int_index), intent(in) :: N
        integer(kind=int32), dimension(N), intent(inout) :: arr
        integer(kind=int32), dimension(N), intent(inout) :: buf
        integer(kind=int_index) :: i
        integer :: b, b0, b1, b2, b3
        integer(kind=int_index), dimension(0:radix_mask) :: c0, c1, c2, c3
        c0(:) = 0
        c1(:) = 0
        c2(:) = 0
        c3(:) = 0
        do i = 1, N
            b0 = iand(arr(i), radix_mask_i32)
            b1 = iand(ishft(arr(i), -radix_bits_i32), radix_mask_i32)
            b2 = iand(ishft(arr(i), -2*radix_bits_i32), radix_mask_i32)
            b3 = ishft(arr(i), -3*radix_bits_i32)
            c0(b0) = c0(b0) + 1
            c1(b1) = c1(b1) + 1
            c2(b2) = c2(b2) + 1
            c3(b3) = c3(b3) + 1
        end do
        do b = 1, radix_mask
            c0(b) = c0(b) + c0(b - 1)
            c1(b) = c1(b) + c1(b - 1)
            c2(b) = c2(b) + c2(b - 1)
            c3(b) = c3(b) + c3(b - 1)
        end do
        do i = N, 1, -1
            b0 = iand(arr(i), radix_mask_i32)
            buf(c0(b0)) = arr(i)
            c0(b0) = c0(b0) - 1
        end do
        do i = N, 1, -1
            b1 = iand(ishft(buf(i), -radix_bits_i32), radix_mask_i32)
            arr(c1(b1)) = buf(i)
            c1(b1) = c1(b1) - 1
        end do
        do i = N, 1, -1
            b2 = iand(ishft(arr(i), -2*radix_bits_i32), radix_mask_i32)
            buf(c2(b2)) = arr(i)
            c2(b2) = c2(b2) - 1
        end do
        do i = N, 1, -1
            b3 = ishft(buf(i), -3*radix_bits_i32)
            arr(c3(b3)) = buf(i)
            c3(b3) = c3(b3) - 1
        end do
    end subroutine radix_sort_u32_helper

    pure subroutine radix_sort_u64_helper(N, arr, buffer)
        integer(kind=int_index), intent(in) :: N
        integer(kind=int64), dimension(N), intent(inout) :: arr
        integer(kind=int64), dimension(N), intent(inout) :: buffer
        integer(kind=int_index) :: i
        integer(kind=int64) :: b, b0, b1, b2, b3, b4, b5, b6, b7
        integer(kind=int_index), dimension(0:radix_mask) :: c0, c1, c2, c3, c4, c5, c6, c7
        c0(:) = 0
        c1(:) = 0
        c2(:) = 0
        c3(:) = 0
        c4(:) = 0
        c5(:) = 0
        c6(:) = 0
        c7(:) = 0
        do i = 1, N
            b0 = iand(arr(i), radix_mask_i64)
            b1 = iand(ishft(arr(i), -radix_bits_i64), radix_mask_i64)
            b2 = iand(ishft(arr(i), -2*radix_bits_i64), radix_mask_i64)
            b3 = iand(ishft(arr(i), -3*radix_bits_i64), radix_mask_i64)
            b4 = iand(ishft(arr(i), -4*radix_bits_i64), radix_mask_i64)
            b5 = iand(ishft(arr(i), -5*radix_bits_i64), radix_mask_i64)
            b6 = iand(ishft(arr(i), -6*radix_bits_i64), radix_mask_i64)
            b7 = ishft(arr(i), -7*radix_bits_i64)
            c0(b0) = c0(b0) + 1
            c1(b1) = c1(b1) + 1
            c2(b2) = c2(b2) + 1
            c3(b3) = c3(b3) + 1
            c4(b4) = c4(b4) + 1
            c5(b5) = c5(b5) + 1
            c6(b6) = c6(b6) + 1
            c7(b7) = c7(b7) + 1
        end do
        do b = 1, radix_mask
            c0(b) = c0(b) + c0(b - 1)
            c1(b) = c1(b) + c1(b - 1)
            c2(b) = c2(b) + c2(b - 1)
            c3(b) = c3(b) + c3(b - 1)
            c4(b) = c4(b) + c4(b - 1)
            c5(b) = c5(b) + c5(b - 1)
            c6(b) = c6(b) + c6(b - 1)
            c7(b) = c7(b) + c7(b - 1)
        end do
        do i = N, 1, -1
            b0 = iand(arr(i), radix_mask_i64)
            buffer(c0(b0)) = arr(i)
            c0(b0) = c0(b0) - 1
        end do
        do i = N, 1, -1
            b1 = iand(ishft(buffer(i), -radix_bits_i64), radix_mask_i64)
            arr(c1(b1)) = buffer(i)
            c1(b1) = c1(b1) - 1
        end do
        do i = N, 1, -1
            b2 = iand(ishft(arr(i), -2*radix_bits_i64), radix_mask_i64)
            buffer(c2(b2)) = arr(i)
            c2(b2) = c2(b2) - 1
        end do
        do i = N, 1, -1
            b3 = iand(ishft(buffer(i), -3*radix_bits_i64), radix_mask_i64)
            arr(c3(b3)) = buffer(i)
            c3(b3) = c3(b3) - 1
        end do
        do i = N, 1, -1
            b4 = iand(ishft(arr(i), -4*radix_bits_i64), radix_mask_i64)
            buffer(c4(b4)) = arr(i)
            c4(b4) = c4(b4) - 1
        end do
        do i = N, 1, -1
            b5 = iand(ishft(buffer(i), -5*radix_bits_i64), radix_mask_i64)
            arr(c5(b5)) = buffer(i)
            c5(b5) = c5(b5) - 1
        end do
        do i = N, 1, -1
            b6 = iand(ishft(arr(i), -6*radix_bits_i64), radix_mask_i64)
            buffer(c6(b6)) = arr(i)
            c6(b6) = c6(b6) - 1
        end do
        do i = N, 1, -1
            b7 = ishft(buffer(i), -7*radix_bits_i64)
            arr(c7(b7)) = buffer(i)
            c7(b7) = c7(b7) - 1
        end do
    end subroutine radix_sort_u64_helper

    pure module subroutine int8_radix_sort(array, reverse)
        integer(kind=int8), dimension(:), intent(inout) :: array
        logical, intent(in), optional :: reverse
        integer(kind=int8) :: item
        integer(kind=int_index) :: i, N
        N = size(array, kind=int_index)
        call radix_sort_u8_helper(N, array)
        if (optval(reverse, .false.)) then
            do i = 1, N/2
                item = array(i)
                array(i) = array(N - i + 1)
                array(N - i + 1) = item
            end do
        end if
    end subroutine int8_radix_sort

    pure module subroutine int16_radix_sort(array, work, reverse)
        integer(kind=int16), dimension(:), intent(inout) :: array
        integer(kind=int16), dimension(:), intent(inout), target, optional :: work
        logical, intent(in), optional :: reverse
        integer(kind=int_index) :: i, N, start, middle, end
        integer(kind=int16), dimension(:), pointer :: buffer
        integer(kind=int16) :: item
        logical :: use_internal_buffer
        N = size(array, kind=int_index)
        if (present(work)) then
            if (size(work, kind=int_index) < N) then
                error stop "int16_radix_sort: work array is too small."
            end if
            use_internal_buffer = .false.
            buffer => work
        else
            use_internal_buffer = .true.
            allocate (buffer(N))
        end if
        call radix_sort_u16_helper(N, array, buffer)
! After calling `radix_sort_u<width>_helper. The array is sorted as unsigned integers.
! In the view of signed array, the negative numbers are sorted but in the tail of the array.
! Use binary search to find the boundary, and move them to correct position.
        if (array(1) >= 0 .and. array(N) < 0) then
            start = 1
            end = N
            middle = (1 + N)/2
            do while (.true.)
                if (array(middle) >= 0) then
                    start = middle + 1
                else
                    end = middle
                end if
                middle = (start + end)/2
                if (start == end) exit
            end do
            buffer(1:(N - middle + 1)) = array(middle:N)
            buffer(N - middle + 2:N) = array(1:middle - 1)
            array(:) = buffer(:)
        end if
        if (optval(reverse, .false.)) then
            do i = 1, N/2
                item = array(i)
                array(i) = array(N - i + 1)
                array(N - i + 1) = item
            end do
        end if
        if (use_internal_buffer) then
            deallocate (buffer)
        end if
    end subroutine int16_radix_sort

    pure module subroutine int32_radix_sort(array, work, reverse)
        integer(kind=int32), dimension(:), intent(inout) :: array
        integer(kind=int32), dimension(:), intent(inout), target, optional :: work
        logical, intent(in), optional :: reverse
        integer(kind=int_index) :: i, N, start, middle, end
        integer(kind=int32), dimension(:), pointer :: buffer
        integer(kind=int32) :: item
        logical :: use_internal_buffer
        N = size(array, kind=int_index)
        if (present(work)) then
            if (size(work, kind=int_index) < N) then
                error stop "int32_radix_sort: work array is too small."
            end if
            use_internal_buffer = .false.
            buffer => work
        else
            use_internal_buffer = .true.
            allocate (buffer(N))
        end if
        call radix_sort_u32_helper(N, array, buffer)
        if (array(1) >= 0 .and. array(N) < 0) then
            start = 1
            end = N
            middle = (1 + N)/2
            do while (.true.)
                if (array(middle) >= 0) then
                    start = middle + 1
                else
                    end = middle
                end if
                middle = (start + end)/2
                if (start == end) exit
            end do
            buffer(1:(N - middle + 1)) = array(middle:N)
            buffer(N - middle + 2:N) = array(1:middle - 1)
            array(:) = buffer(:)
        end if
        if (optval(reverse, .false.)) then
            do i = 1, N/2
                item = array(i)
                array(i) = array(N - i + 1)
                array(N - i + 1) = item
            end do
        end if
        if (use_internal_buffer) then
            deallocate (buffer)
        end if
    end subroutine int32_radix_sort

    module subroutine sp_radix_sort(array, work, reverse)
        use iso_c_binding
        real(kind=sp), dimension(:), intent(inout), target :: array
        real(kind=sp), dimension(:), intent(inout), target, optional :: work
        logical, intent(in), optional :: reverse
        integer(kind=int_index) :: i, N, pos, rev_pos
        integer(kind=int32), dimension(:), pointer :: arri32
        integer(kind=int32), dimension(:), pointer :: buffer
        real(kind=sp) :: item
        logical :: use_internal_buffer
        N = size(array, kind=int_index)
        if (present(work)) then
            if (size(work, kind=int_index) < N) then
                error stop "sp_radix_sort: work array is too small."
            end if
            use_internal_buffer = .false.
            call c_f_pointer(c_loc(work), buffer, [N])
        else
            use_internal_buffer = .true.
            allocate (buffer(N))
        end if
        call c_f_pointer(c_loc(array), arri32, [N])
        call radix_sort_u32_helper(N, arri32, buffer)
! After calling `radix_sort_u<width>_helper. The array is sorted as unsigned integers.
! The positive real number is sorted, guaranteed by IEEE-754 standard.
! But the negative real number is sorted in a reversed order, and also in the tail of array.
! Remark that -0.0 is the minimum nagative integer, so using radix sort, -0.0 is naturally lesser than 0.0.
! In IEEE-754 standard, the bit representation of `Inf` is greater than all positive real numbers,
! and the `-Inf` is lesser than all negative real numbers. So the order of `Inf, -Inf` is ok.
! The bit representation of `NaN` may be positive or negative integers in different machine,
! thus if the array contains `NaN`, the result is undefined.
        if (arri32(1) >= 0 .and. arri32(N) < 0) then
            pos = 1
            rev_pos = N
            do while (arri32(rev_pos) < 0)
                buffer(pos) = arri32(rev_pos)
                pos = pos + 1
                rev_pos = rev_pos - 1
            end do
            buffer(pos:N) = arri32(1:rev_pos)
            arri32(:) = buffer(:)
        end if
        if (optval(reverse, .false.)) then
            do i = 1, N/2
                item = array(i)
                array(i) = array(N - i + 1)
                array(N - i + 1) = item
            end do
        end if
        if (use_internal_buffer) then
            deallocate (buffer)
        end if
    end subroutine sp_radix_sort

    pure module subroutine int64_radix_sort(array, work, reverse)
        integer(kind=int64), dimension(:), intent(inout) :: array
        integer(kind=int64), dimension(:), intent(inout), target, optional :: work
        logical, intent(in), optional :: reverse
        integer(kind=int_index) :: i, N, start, middle, end
        integer(kind=int64), dimension(:), pointer :: buffer
        integer(kind=int64) :: item
        logical :: use_internal_buffer
        N = size(array, kind=int_index)
        if (present(work)) then
            if (size(work, kind=int_index) < N) then
                error stop "int64_radix_sort: work array is too small."
            end if
            use_internal_buffer = .false.
            buffer => work
        else
            use_internal_buffer = .true.
            allocate (buffer(N))
        end if
        call radix_sort_u64_helper(N, array, buffer)
        if (array(1) >= 0 .and. array(N) < 0) then
            start = 1
            end = N
            middle = (1 + N)/2
            do while (.true.)
                if (array(middle) >= 0) then
                    start = middle + 1
                else
                    end = middle
                end if
                middle = (start + end)/2
                if (start == end) exit
            end do
            buffer(1:(N - middle + 1)) = array(middle:N)
            buffer(N - middle + 2:N) = array(1:middle - 1)
            array(:) = buffer(:)
        end if
        if (optval(reverse, .false.)) then
            do i = 1, N/2
                item = array(i)
                array(i) = array(N - i + 1)
                array(N - i + 1) = item
            end do
        end if
        if (use_internal_buffer) then
            deallocate (buffer)
        end if
    end subroutine int64_radix_sort

    module subroutine dp_radix_sort(array, work, reverse)
        use iso_c_binding
        real(kind=dp), dimension(:), intent(inout), target :: array
        real(kind=dp), dimension(:), intent(inout), target, optional :: work
        logical, intent(in), optional :: reverse
        integer(kind=int_index) :: i, N, pos, rev_pos
        integer(kind=int64), dimension(:), pointer :: arri64
        integer(kind=int64), dimension(:), pointer :: buffer
        real(kind=dp) :: item
        logical :: use_internal_buffer
        N = size(array, kind=int_index)
        if (present(work)) then
            if (size(work, kind=int_index) < N) then
                error stop "sp_radix_sort: work array is too small."
            end if
            use_internal_buffer = .false.
            call c_f_pointer(c_loc(work), buffer, [N])
        else
            use_internal_buffer = .true.
            allocate (buffer(N))
        end if
        call c_f_pointer(c_loc(array), arri64, [N])
        call radix_sort_u64_helper(N, arri64, buffer)
        if (arri64(1) >= 0 .and. arri64(N) < 0) then
            pos = 1
            rev_pos = N
            do while (arri64(rev_pos) < 0)
                buffer(pos) = arri64(rev_pos)
                pos = pos + 1
                rev_pos = rev_pos - 1
            end do
            buffer(pos:N) = arri64(1:rev_pos)
            arri64(:) = buffer(:)
        end if
        if (optval(reverse, .false.)) then
            do i = 1, N/2
                item = array(i)
                array(i) = array(N - i + 1)
                array(N - i + 1) = item
            end do
        end if
        if (use_internal_buffer) then
            deallocate (buffer)
        end if
    end subroutine dp_radix_sort
end submodule stdlib_sorting_radix_sort

module test_open
    use stdlib_io, only: open
    use testdrive, only: new_unittest, unittest_type, error_type, check
    implicit none

    private
    public :: collect_open
contains

    !> Collect all exported unit tests
    subroutine collect_open(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("io_read_write_text", test_io_read_write_text), &
            new_unittest("io_read_write_stream", test_io_read_write_stream), &
            new_unittest("io_open_error_flag", test_io_open_error_flag) &
        ]

    end subroutine collect_open

    function get_outpath() result(outpath)
        integer :: ierr
        character(256) :: argv
        character(:), allocatable :: outpath

        call get_command_argument(1, argv, status=ierr)
        if (ierr == 0) then
            outpath = trim(argv)
        else
            outpath = '.'
        end if
    end function get_outpath


    subroutine test_io_read_write_text(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(:), allocatable :: filename
        integer :: u, a(3)

        ! Text file
        filename = get_outpath() // "/io_open.dat"

        ! Test mode "w"
        u = open(filename, "w")
        write(u, *) 1, 2, 3
        close(u)

        ! Test mode "r"
        u = open(filename, "r")
        read(u, *) a
        call check(error, all(a == [1, 2, 3]))
        close(u)
        if (allocated(error)) return

        ! Test mode "a"
        u = open(filename, "a")
        write(u, *) 4, 5, 6
        close(u)
        u = open(filename, "r")
        read(u, *) a
        call check(error, all(a == [1, 2, 3]))
        read(u, *) a
        call check(error, all(a == [4, 5, 6]))
        close(u)
        if (allocated(error)) return

    end subroutine test_io_read_write_text


    subroutine test_io_read_write_stream(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(:), allocatable :: filename
        integer :: u, a(3)

        ! Stream file
        filename = get_outpath() // "/io_open.stream"

        ! Test mode "w"
        u = open(filename, "wb")
        write(u) 1, 2, 3
        close(u)

        ! Test mode "r"
        u = open(filename, "rb")
        read(u) a
        call check(error, all(a == [1, 2, 3]))
        close(u)
        if (allocated(error)) return

        ! Test mode "a"
        u = open(filename, "ab")
        write(u) 4, 5, 6
        close(u)
        u = open(filename, "rb")
        read(u) a
        call check(error, all(a == [1, 2, 3]))
        read(u) a
        if (allocated(error)) return
        call check(error, all(a == [4, 5, 6]))
        close(u)
        if (allocated(error)) return

    end subroutine test_io_read_write_stream


    subroutine test_io_open_error_flag(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(:), allocatable :: filename
        integer :: ierr, u

        filename = get_outpath() // "/io_open.stream"

        ! Write to file first to ensure that it exists
        u = open(filename, "wb")
        write(u) 1, 2, 3
        close(u)

        u = open(filename, "rb", ierr)
        call check(error, ierr == 0)
        if (ierr == 0) close(u)
        if (allocated(error)) return

        u = open(filename, "ab", ierr)
        call check(error, ierr == 0)
        if (ierr == 0) close(u)
        if (allocated(error)) return

        filename = get_outpath() // "/does_not_exist.error"

        u = open(filename, "a", ierr)
        call check(error, ierr /= 0)
        if (allocated(error)) return

        u = open(filename, "r", ierr)
        call check(error, ierr /= 0)
        if (allocated(error)) return

    end subroutine test_io_open_error_flag

end module test_open


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_open, only : collect_open
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("open", collect_open) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program tester

program example_padl
  use stdlib_string_type, only: string_type, assignment(=), write (formatted)
  use stdlib_strings, only: padl
  implicit none
  type(string_type) :: string

  string = "left pad this string"
! string <-- "left pad this string"

  print '(dt)', padl(string, 25, "$") ! "$$$$$left pad this string"

  string = padl(string, 25)
! string <-- "     left pad this string"

end program example_padl

program example_version
  use stdlib_version, only: get_stdlib_version
  implicit none
  character(len=:), allocatable :: version
  call get_stdlib_version(string=version)
  print '(a)', version
end program example_version

! This example demonstrates the Schur decomposition for a complex-valued matrix.
program example_schur_complex
  use stdlib_linalg, only: schur
  use stdlib_linalg_constants, only: dp
  implicit none
  
  integer, parameter :: n = 3
  complex(dp), dimension(n,n) :: A, T, Z

  ! Initialize a complex-valued square matrix
  A = reshape([ (1, 2), (3,-1), (4, 1), &
                (0,-1), (2, 0), (1,-2), &
                (2, 3), (1, 1), (0,-1) ], shape=[n,n])

  ! Compute the Schur decomposition: A = Z T Z^H
  call schur(A, T, Z)

  ! Output results
  print *, "Original Matrix A:"
  print *, A
  print *, "Schur Form Matrix T:"
  print *, T
  print *, "Unitary Matrix Z:"
  print *, Z

  ! Test factorization: Z*T*Z^H = A
  print *, "Max error in reconstruction:", maxval(abs(matmul(Z, matmul(T, conjg(transpose(Z)))) - A))

end program example_schur_complex

program example_entries
  use stdlib_hashmaps, only: open_hashmap_type, int_index
  implicit none
  type(open_hashmap_type) :: map
  integer(int_index) :: initial_entries
  call map%init()
  initial_entries = map%entries()
  print *, "INITIAL_ENTRIES =  ", initial_entries
end program example_entries

module test_stdlib_bitset_large
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use :: stdlib_kinds, only : int8, int16, int32, int64
    use stdlib_bitsets, only: bitset_large, bits_kind&
                              , bits &
                              , success &
                              , and, and_not, or, xor&
                              , extract&
                              , assignment(=)&
                              , operator(<), operator(<=)&
                              , operator(>), operator(>=)&
                              , operator(/=), operator(==)
    implicit none
    character(*), parameter :: &
        bitstring_0   = '000000000000000000000000000000000', &
        bitstring_33  = '100000000000000000000000000000000', &
        bitstring_all = '111111111111111111111111111111111'

contains


    !> Collect all exported unit tests
    subroutine collect_stdlib_bitset_large(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("string-operations", test_string_operations), &
            new_unittest("io", test_io), &
            new_unittest("initialization", test_initialization), &
            new_unittest("bitset-assignment-array", test_assignment_array), &
            new_unittest("bitset-inquiry", test_bitset_inquiry), &
            new_unittest("bit-operations", test_bit_operations), &
            new_unittest("bitset-comparisons", test_bitset_comparisons), &
            new_unittest("bitset-operations", test_bitset_operations) &
            ]

    end subroutine collect_stdlib_bitset_large


    subroutine test_string_operations(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer            :: status
        character(:), allocatable :: string0
        type(bitset_large) :: set0, set1, set3, set4
        type(bitset_large) :: set10, set11, set13, set14

        call set0 % from_string( bitstring_0 )
        call check(error, bits(set0), 33, &
            'from_string failed to interpret bitstring_0 size properly.')
        if (allocated(error)) return
        call check(error, set0 % none(), &
            'failed to interpret bitstring_0 value properly.')
        if (allocated(error)) return
        call check(error, .not. set0 % any(), &
            'failed to interpret bitstring_0 value properly.')
        if (allocated(error)) return

        call set10 % from_string( bitstring_0 // bitstring_0 )
        call check(error, bits(set10), 66, &
            'from_string failed to interpret bitstring_0 // bitstring_0 size properly.')
        if (allocated(error)) return
        call check(error, set10 % none(), &
            'failed to interpret bitstring_0 // bitstring_0 value properly.')
        if (allocated(error)) return
        call check(error, .not. set10 % any(), &
            'failed to interpret bitstring_0 // bitstring_0 value properly.')
        if (allocated(error)) return

        call set1 % from_string( bitstring_all )
        call check(error, bits(set1), 33, &
            'from_string failed to interpret bitstring_all size properly.')
        if (allocated(error)) return
        call check(error, .not. set1 % none(), &
            'failed to interpret bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set1 % any(), &
            'failed to interpret bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set1 % all(), &
            'failed to interpret bitstring_all value properly.')
        if (allocated(error)) return

        call set11 % from_string( bitstring_all // bitstring_all  )
        call check(error, bits(set11), 66, &
            'from_string failed to interpret bitstring_all // bitstring_all size properly.')
        if (allocated(error)) return
        call check(error, .not. set11 % none(), &
            'failed to interpret bitstring_all // bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set11 % any(), &
            'failed to interpret bitstring_all // bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set11 % all(), &
            'failed to interpret bitstring_all // bitstring_all value properly.')
        if (allocated(error)) return

        call set3 % read_bitset( bitstring_0, status )
        call check(error, status /= success, &
            'read_bitset_string did not fail with bitstring_0 as expected.')
        if (allocated(error)) return

        call set13 % read_bitset( bitstring_0 // bitstring_0, status )
        call check(error, status /= success, &
            'read_bitset_string did not fail with bitstring_0 // bitstring_0 as expected.')
        if (allocated(error)) return

        call set3 % read_bitset( 's33b' // bitstring_0, status )
        call check(error, bits(set3), 33, &
            'read_bitset_string failed to interpret "s33b" // bitstring_0 size properly.')
        if (allocated(error)) return
        call check(error, set3 % none(), &
            'failed to interpret "s33b" // bitstring_0 value properly.')
        if (allocated(error)) return

        call set13 % read_bitset( 's66b' // bitstring_0 // bitstring_0, &
            status )
        call check(error, bits(set13), 66, 'read_bitset_string failed to ' // &
            'interpret "s66b" // bitstring_0 // bitstring_0 size properly.')
        if (allocated(error)) return
        call check(error, set13 % none(), &
            'failed to interpret "s66b" // bitstring_0 // bitstring_0 value properly.')
        if (allocated(error)) return

        call set4 % read_bitset( 's33b' // bitstring_all )
        call check(error, bits(set4), 33, &
            'read_bitset_string failed to interpret "s33b" // bitstring_all size properly.')
        if (allocated(error)) return
        call check(error, .not. set4 % none(), &
            'read_bitset_string failed to interpret "s33b" // bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set4 % any(), &
            'read_bitset_string failed to // interpret "s33b" bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set4 % all(), &
            'read_bitset_string failed to // interpret "s33b" bitstring_all value properly.')
        if (allocated(error)) return

        call set14 % read_bitset( 's66b' // bitstring_all // bitstring_all )
        call check(error, bits(set14), 66, &
            'read_bitset_string failed to ' // &
            'interpret "s66b" // bitstring_all // bitstring_all size properly.')
        if (allocated(error)) return
        call check(error, .not. set14 % none(), 'read_bitset_string failed to ' // &
            'interpret "s66b" // bitstring_all // bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set14 % any(), 'read_bitset_string failed to // ' // &
            'interpret "s66b" bitstring_all // bitstring_all value properly.')
        if (allocated(error)) return
        call check(error, set14 % all(), 'read_bitset_string failed to // ' // &
            'interpret "s66b" bitstring_all // bitstring_all value properly.')
        if (allocated(error)) return

        call set0 % to_string( string0 )
        call check(error, bitstring_0, string0, &
            'to_string failed to convert set0 value properly.')
        if (allocated(error)) return

        call set10 % to_string( string0 )
        call check(error, bitstring_0 // bitstring_0, string0, &
            'to_string failed to convert set10 value properly.')
        if (allocated(error)) return

        call set1 % to_string( string0 )
        call check(error, bitstring_all, string0, &
            'to_string failed to convert set1 value properly.')
        if (allocated(error)) return

        call set11 % to_string( string0 )
        call check(error, bitstring_all // bitstring_all, string0, &
            'to_string failed to convert set11 value properly.')
        if (allocated(error)) return

        call set0 % write_bitset( string0 )
        call check(error, ('S33B' // bitstring_0), string0, &
            'write_bitset_string failed to convert set2 value properly.')
        if (allocated(error)) return

        call set10 % write_bitset( string0 )
        call check(error, ('S66B' // bitstring_0 // bitstring_0), string0, &
            'write_bitset_string failed to convert set10 value properly.')
        if (allocated(error)) return

        call set1 % write_bitset( string0 )
        call check(error, ('S33B' // bitstring_all), string0, &
            'write_bitset_string failed to convert set1 value properly.')
        if (allocated(error)) return

        call set11 % write_bitset( string0 )
        call check(error, ('S66B' // bitstring_all // bitstring_all), string0, &
            'write_bitset_string failed to convert set11 value properly.')
        if (allocated(error)) return

    end subroutine test_string_operations

    subroutine test_io(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: unit
        type(bitset_large) :: set0, set1, set2, set3, set4, set5
        type(bitset_large) :: set10, set11, set12, set13, set14, set15

        call set0 % from_string( bitstring_0 )
        call set1 % from_string( bitstring_all )
        call set2 % from_string( bitstring_33 )
        open( newunit=unit, status='scratch', form='formatted', &
              action='readwrite' )
        call set2 % write_bitset(unit)
        call set1 % write_bitset(unit)
        call set0 % write_bitset(unit)
        rewind( unit )
        call set3 % read_bitset(unit)
        call set5 % read_bitset(unit)
        call set4 % read_bitset(unit)
        call check(error, set4 == set0 .and. set5 == set1 .and. set3 == set2, &
            'transfer to and from units using bitset literals failed.')

        if (.not.allocated(error)) then
            rewind( unit )

            call set10 % from_string( bitstring_0 // bitstring_0 )
            call set11 % from_string( bitstring_all // bitstring_all  )
            call set12 % from_string( bitstring_33 // bitstring_33 )

            call set12 % write_bitset(unit)
            call set11 % write_bitset(unit)
            call set10 % write_bitset(unit)
            rewind( unit )
            call set13 % read_bitset(unit)
            call set15 % read_bitset(unit)
            call set14 % read_bitset(unit)
            call check(error, set14 == set10 .and. set15 == set11 .and. set3 == set12, &
                'transfer to and from units using bitset literals for bits > 64 failed.')
        end if
        if (.not.allocated(error)) then

            rewind( unit )

            call set2 % write_bitset(unit, advance='no')
            call set1 % write_bitset(unit, advance='no')
            call set0 % write_bitset(unit)
            rewind( unit )
            call set3 % read_bitset(unit, advance='no')
            call set4 % read_bitset(unit, advance='no')
            call set5 % read_bitset(unit)
            call check(error, set5 == set0 .and. set4 == set1 .and. set3 == set2, &
                'transfer to and from units using bitset literals with advance == "no" failed.')
        end if
        if (.not.allocated(error)) then

            rewind( unit )

            call set12 % write_bitset(unit, advance='no')
            call set11 % write_bitset(unit, advance='no')
            call set10 % write_bitset(unit)
            rewind( unit )
            call set13 % read_bitset(unit, advance='no')
            call set14 % read_bitset(unit, advance='no')
            call set15 % read_bitset(unit)
            call check(error, set15 == set10 .and. set14 == set11 .and. set13 == set12, &
                'transfer to and from units using  bitset literals for bitss > 64 with advance == "no" failed.')
        end if

        close(unit)
        if (allocated(error)) return

        open( newunit=unit, form='unformatted', status='scratch', &
            action='readwrite' )
        call set2 % output(unit)
        call set1 % output(unit)
        call set0 % output(unit)
        rewind( unit )
        call set5 % input(unit)
        call set4 % input(unit)
        call set3 % input(unit)
        call check(error, set3 == set0 .and. set4 == set1 .and. set5 == set2, &
            'transfer to and from units using output and input failed.')

        close( unit )
        if (allocated(error)) return

        open( newunit=unit, form='unformatted', access='stream', &
            status='scratch', action='readwrite' )
        call set2 % output(unit)
        call set1 % output(unit)
        call set0 % output(unit)
        rewind( unit )
        call set5 % input(unit)
        call set4 % input(unit)
        call set3 % input(unit)
        call check(error, set3 == set0 .and. set4 == set1 .and. set5 == set2, &
            'transfer to and from units using stream output and input failed.')

        close( unit )
        if (allocated(error)) return

        open( newunit=unit, form='unformatted', status='scratch', &
            action='readwrite' )
        call set12 % output(unit)
        call set11 % output(unit)
        call set10 % output(unit)
        rewind( unit )
        call set15 % input(unit)
        call set14 % input(unit)
        call set13 % input(unit)
        call check(error, set13 == set10 .and. set14 == set11 .and. set15 == set12, &
            'transfer to and from units using output and input failed for bits . 64.')
        close(unit)
        if (allocated(error)) return

        open( newunit=unit, form='unformatted', access='stream', &
            status='scratch', action='readwrite' )
        call set12 % output(unit)
        call set11 % output(unit)
        call set10 % output(unit)
        rewind( unit )
        call set15 % input(unit)
        call set14 % input(unit)
        call set13 % input(unit)
        call check(error, set13 == set10 .and. set14 == set11 .and. set15 == set12, &
            'transfer to and from units using stream output and input failed for bits . 64.')
        close(unit)
        if (allocated(error)) return

    end subroutine test_io

    subroutine test_initialization(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        logical(int8)  :: log1(64) = .true.
        logical(int16) :: log2(31) = .false.
        logical(int32) :: log3(15) = .true.
        logical(int64) :: log4(33) = .false.
        logical(int8)  :: log11(66) = .true.
        logical(int16) :: log12(99) = .false.
        logical(int32) :: log13(132) = .true.
        logical(int64) :: log14(165) = .false.
        logical(int8), allocatable  :: log5(:)
        logical(int16), allocatable :: log6(:)
        logical(int32), allocatable :: log7(:)
        logical(int64), allocatable :: log8(:)
        type(bitset_large) :: set4, set5

        !The following triggers an issue in gfortran 11 and 12
        block
        type(bitset_large) :: set6
        call check(error, set6 % bits(), 0, &
            'set6 % bits() returned non-zero value '//&
            'even though set6 was not initialized.')
        if (allocated(error)) return
        end block

        set5 = log1
        call check(error, set5 % bits(), 64, &
            ' initialization with logical(int8) failed to set' // &
            ' the right size.')
        if (allocated(error)) return
        call check(error, set5 % all(), &
            ' initialization with' // &
            ' logical(int8) failed to set the right values.')
        if (allocated(error)) return

        set5 = log11
        call check(error, set5 % bits(), 66, &
            ' initialization with logical(int8) failed to set' // &
            ' the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, set5 % all(), &
            ' initialization with' // &
            ' logical(int8) failed to set the right values.')
        if (allocated(error)) return

        set5 = log2
        call check(error, set5 % bits(), 31, &
            ' initialization with logical(int16) failed to set' // &
            ' the right size.')
        if (allocated(error)) return
        call check(error, set5 % none(), &
            ' initialization with logical(int16) failed to set' // &
            ' the right values.')
        if (allocated(error)) return

        set5 = log12
        call check(error, set5 % bits(), 99, &
            ' initialization with logical(int16) failed to set' // &
            ' the right size > 64 bits .')
        if (allocated(error)) return
        call check(error, set5 % none(), &
            ' initialization with logical(int16) failed to set' // &
            ' the right values > 64 bits .')
        if (allocated(error)) return

        set5 = log3
        call check(error, set5 % bits(), 15, &
            ' initialization with logical(int32) failed to set' // &
            ' the right size.')
        if (allocated(error)) return
        call check(error, set5 % all(), &
            ' initialization with logical(int32) failed to set' // &
            ' the right values.')
        if (allocated(error)) return

        set5 = log13
        call check(error, set5 % bits(), 132, &
            ' initialization with logical(int32) failed to set' // &
            ' the right size > 64 bits .')
        if (allocated(error)) return
        call check(error, set5 % all(), &
            ' initialization with logical(int32) failed to set' // &
            ' the right values > 64 bits .')
        if (allocated(error)) return

        set5 = log4
        call check(error, set5 % bits(), 33, &
            ' initialization with logical(int64) failed to set' // &
            ' the right size.')
        if (allocated(error)) return
        call check(error, set5 % none(), &
            ' initialization with logical(int64) failed to set' // &
            ' the right values.')
        if (allocated(error)) return

        set5 = log14
        call check(error, set5 % bits(), 165, &
            ' initialization with logical(int64) failed to set' // &
            ' the right size > 64 bits .')
        if (allocated(error)) return
        call check(error, set5 % none(), &
            ' initialization with logical(int64) failed to set' // &
            ' the right values > 64 bits .')
        if (allocated(error)) return

        set5 = log1
        call extract( set4, set5, 1_bits_kind, 33_bits_kind )
        call check(error, set4 % bits(), 33, &
            ' initialization with extract failed to set' // &
            ' the right size.')
        if (allocated(error)) return
        call check(error, set4 % all(), &
            ' initialization with extract failed to set' // &
            ' the right values.')
        if (allocated(error)) return

        set5 = log11
        call extract( set4, set5, 1_bits_kind, 65_bits_kind )
        call check(error, set4 % bits(), 65, &
            ' initialization with extract failed to set' // &
            ' the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, set4 % all(), &
            ' initialization with extract failed to set' // &
            ' the right values > 64 bits.')
        if (allocated(error)) return

        set5 = log1
        set4 = set5
        call check(error, set4 % bits(), 64, &
            ' initialization with simple assignment failed to set' // &
            ' the right size.')
        if (allocated(error)) return
        call check(error, set4 % all(), &
            ' initialization with simple assignment failed to set' // &
            ' the right values.')
        if (allocated(error)) return

        set5 = log11
        set4 = set5
        call check(error, set4 % bits(), 66, &
            ' initialization with simple assignment failed to set' // &
            ' the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, set4 % all(), &
            ' initialization with simple assignment failed to set' // &
            ' the right values > 64 bits.')
        if (allocated(error)) return

        set5 = log1
        log5 = set5
        call check(error, size(log5), 64, &
            ' initialization of logical(int8) with assignment failed' // &
            ' to set the right size.')
        if (allocated(error)) return
        call check(error, all(log5) .eqv. .true., &  ! FIXME
            ' initialization of logical(int8) with assignment failed' // &
            ' to set the right values.')
        if (allocated(error)) return

        set5 = log11
        log5 = set5
        call check(error, size(log5), 66, &
            ' initialization of logical(int8) with assignment failed' // &
            ' to set the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, all(log5) .eqv. .true., &  ! FIXME
            ' initialization of logical(int8) with assignment failed' // &
            ' to set the right values > 64 bits.')
        if (allocated(error)) return

        set5 = log1
        log6 = set5
        call check(error, size(log6), 64, &
            ' initialization of logical(int16) with assignment failed' // &
            ' to set the right size.')
        if (allocated(error)) return
        call check(error, all(log6) .eqv. .true., &  ! FIXME
            ' initialization of logical(int16) with assignment failed' // &
            ' to set the right values.')
        if (allocated(error)) return

        set5 = log11
        log6 = set5
        call check(error, size(log6), 66, &
            ' initialization of logical(int16) with assignment failed' // &
            ' to set the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, all(log6) .eqv. .true., &  ! FIXME
            ' initialization of logical(int16) with assignment failed' // &
            ' to set the right values > 64 bits.')
        if (allocated(error)) return

        set5 = log1
        log7 = set5
        call check(error, size(log7), 64, &
            ' initialization of logical(int32) with assignment failed' // &
            ' to set the right size.')
        if (allocated(error)) return
        call check(error, all(log7), &
            ' initialization of logical(int32) with assignment failed' // &
            ' to set the right values.')
        if (allocated(error)) return

        set5 = log11
        log7 = set5
        call check(error, size(log7), 66, &
            ' initialization of logical(int32) with assignment failed' // &
            ' to set the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, all(log7), &
            ' initialization of logical(int32) with assignment failed' // &
            ' to set the right values > 64 bits.')
        if (allocated(error)) return

        set5 = log1
        log8 = set5
        call check(error, size(log8), 64, &
            ' initialization of logical(int64) with assignment failed' // &
            ' to set the right size.')
        if (allocated(error)) return
        call check(error, merge(.true., .false., all(log8)), &  ! FIXME
            ' initialization of logical(int64) with assignment failed' // &
            ' to set the right values.')
        if (allocated(error)) return

        set5 = log11
        log8 = set5
        call check(error, size(log8), 66, &
            ' initialization of logical(int64) with assignment failed' // &
            ' to set the right size > 64 bits.')
        if (allocated(error)) return
        call check(error, merge(.true., .false., all(log8)), &  ! FIXME
            ' initialization of logical(int64) with assignment failed' // &
            ' to set the right values > 64 bits.')
        if (allocated(error)) return

    end subroutine test_initialization

    subroutine test_assignment_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        logical(int8)  :: log1(64) = .true.
        
        integer :: i
        type(bitset_large) :: set1(0:4)

        do i = 0, size(set1) - 1
           set1(i) = log1
        enddo

        do i = 0, size(set1) - 1
            call check(error, set1(i) % bits(), 64, &
                ' initialization with logical(int8) failed to set' // &
                ' the right size in a bitset array.')
            if (allocated(error)) return
        enddo

        !Test added following issue https://github.com/fortran-lang/stdlib/issues/726
        set1(0) = set1(0)

        call check(error, set1(0) % bits(), 64, &
            ' initialization from bitset_large failed to set' // &
            ' the right size in a bitset array.')
        if (allocated(error)) return

    end subroutine test_assignment_array

    subroutine test_bitset_inquiry(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer(bits_kind) :: i
        type(bitset_large) :: set0, set1
        type(bitset_large) :: set10, set11

        call set0 % from_string( bitstring_0 )
        call set1 % from_string( bitstring_all )

        call check(error, set0 % none(), &
            ' set0 did not have none set which was unexpected')
        if (allocated(error)) return

        call check(error, .not. set0 % any(), &
            ' set0 had some bits set which was unexpected.')
        if (allocated(error)) return

        call set0 % not()

        call check(error, set0 % all(), &
            ' set0 did not have all bits set which was unexpected')
        if (allocated(error)) return

        call check(error, set0 % any(), &
            ' set0 had no bits set which was unexpected.')
        if (allocated(error)) return

        call check(error, set1 % any(), &
            ' set1 had none bits set which was unexpected')
        if (allocated(error)) return

        call check(error, set1 % all(), &
            ' set1 did not have all bits set which was unexpected.')
        if (allocated(error)) return

        call set0 % not()
        do i=0, set0 % bits() - 1
            call check(error, .not. set0 % test(i), &
                'against expectations set0 has at least 1 bit set.')
            if (allocated(error)) return
        end do

        do i=0, set1 % bits() - 1
            call check(error, set1 % test(i), &
                'against expectations set0 has at least 1 bit unset.')
            if (allocated(error)) return
        end do

        do i=0, set0 % bits() - 1
            call check(error, set0 % value(i), 0, &
                'against expectations set0 has at least 1 bit set.')
            if (allocated(error)) return
        end do

        do i=0, set1 % bits() - 1
            call check(error, set1 % value(i), 1, &
                'against expectations set0 has at least 1 bit unset.')
            if (allocated(error)) return
        end do

        call check(error, set0 % bits() == 33, &
            'set0 unexpectedly does not have 33 bits.')
        if (allocated(error)) return

! > 64 bit inquiries
        call set10 % from_string( bitstring_0 // bitstring_0 // bitstring_0 )
        call check(error, set10 % none(), &
            ' set10 did not have none set which was unexpected')
        if (allocated(error)) return

        call check(error, .not. set10 % any(), &
            ' set10 had some bits set which was unexpected.')
        if (allocated(error)) return

        call set10 % not()

        call check(error, set10 % all(), &
            ' set10 did not have all bits set which was unexpected')
        if (allocated(error)) return

        call check(error, set10 % any(), &
            ' set10 had no bits set which was unexpected.')
        if (allocated(error)) return

        call set11 % from_string( bitstring_all // bitstring_all // &
            bitstring_all )
        call check(error, set11 % any(), &
            ' set11 had none bits set which was unexpected')
        if (allocated(error)) return

        call check(error, set11 % all(), &
            ' set11 did not have all bits set which was unexpected.')
        if (allocated(error)) return

        call set10 % not()
        do i=0, set10 % bits() - 1
            call check(error, .not. set10 % test(i), &
                'against expectations set10 has at least 1 bit set.')
            if (allocated(error)) return
        end do

        do i=0, set11 % bits() - 1
            call check(error, set11 % test(i), &
                'against expectations set11 has at least 1 bit unset.')
            if (allocated(error)) return
        end do

        do i=0, set10 % bits() - 1
            call check(error, set10 % value(i), 0, &
                'against expectations set10 has at least 1 bit set.')
            if (allocated(error)) return
        end do

        do i=0, set11 % bits() - 1
            call check(error, set11 % value(i), 1, &
                'against expectations set11 has at least 1 bit unset.')
            if (allocated(error)) return
        end do

        call check(error, set0 % bits() == 33, &
            'set0 unexpectedly does not have 33 bits.')
        if (allocated(error)) return

        call check(error, set10 % bits() == 99, &
            'set10 unexpectedly does not have 99 bits.')
        if (allocated(error)) return

    end subroutine test_bitset_inquiry

    subroutine test_bit_operations(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_large) :: set1, set11

        call set1 % from_string( bitstring_all )

        call check(error, set1 % all(), &
            'set1 is not all set.')
        if (allocated(error)) return

        call set1 % clear(0_bits_kind)
        call check(error, .not. set1 % test(0_bits_kind), &
            'did not clear the first bit in set1.')
        if (allocated(error)) return

        call check(error, set1 % test(1_bits_kind), &
            'cleared more than one bit in set1.')
        if (allocated(error)) return

        call set1 % clear(1_bits_kind, 32_bits_kind)
        call check(error, set1 % none(), &
            'did not clear remaining bits in set1.')
        if (allocated(error)) return

        call set1 % flip(0_bits_kind)
        call check(error, set1 % test(0_bits_kind), &
            'did not flip the first bit in set1.')
        if (allocated(error)) return

        call check(error, .not. set1 % test(1_bits_kind), &
            'flipped more than one bit in set1.')
        if (allocated(error)) return

        call set1 % flip(1_bits_kind, 32_bits_kind)
        call check(error, set1 % all(), &
            'did not flip remaining bits in set1.')
        if (allocated(error)) return

        call set1 % not()
        call check(error, set1 % none(), &
            'did not unset bits in set1.')
        if (allocated(error)) return

        call set1 % set(0_bits_kind)
        call check(error, set1 % test(0_bits_kind), &
            'did not set the first bit in set1.')
        if (allocated(error)) return

        call check(error, .not. set1 % test(1_bits_kind), &
            'set more than one bit in set1.')
        if (allocated(error)) return

        call set1 % set(1_bits_kind, 32_bits_kind)
        call check(error, set1 % all(), &
            'did not set the remaining bits in set1.')
        if (allocated(error)) return

        call set11 % init( 166_bits_kind )
        call set11 % not()
        call check(error, set11 % all(), &
            'set11 is not all set.')
        if (allocated(error)) return

        call set11 % clear(0_bits_kind)
        call check(error, .not. set11 % test(0_bits_kind), &
            'did not clear the first bit in set11.')
        if (allocated(error)) return

        call check(error, set11 % test(1_bits_kind), &
            'cleared more than one bit in set11.')
        if (allocated(error)) return

        call set11 % clear(165_bits_kind)
        call check(error, .not. set11 % test(165_bits_kind), &
            'did not clear the last bit in set11.')
        if (allocated(error)) return

        call check(error, set11 % test(164_bits_kind), &
            'cleared more than one bit in set11.')
        if (allocated(error)) return

        call set11 % clear(1_bits_kind, 164_bits_kind)
        call check(error, set11 % none(), &
            'did not clear remaining bits in set11.')
        if (allocated(error)) return

        call set11 % flip(0_bits_kind)
        call check(error, set11 % test(0_bits_kind), &
            'did not flip the first bit in set11.')
        if (allocated(error)) return

        call check(error, .not. set11 % test(1_bits_kind), &
            'flipped more than one bit in set11.')
        if (allocated(error)) return

        call set11 % flip(165_bits_kind)
        call check(error, set11 % test(165_bits_kind), &
            'did not flip the last bit in set11.')
        if (allocated(error)) return

        call check(error, .not. set11 % test(164_bits_kind), &
            'flipped more than one bit in set11.')
        if (allocated(error)) return

        call set11 % flip(1_bits_kind, 164_bits_kind)
        call check(error, set11 % all(), &
            'did not flip remaining bits in set11.')
        if (allocated(error)) return

        call set11 % not()
        call check(error, set11 % none(), &
            'did not unset bits in set11.')
        if (allocated(error)) return

        call set11 % set(0_bits_kind)
        call check(error, set11 % test(0_bits_kind), &
            'did not set the first bit in set11.')
        if (allocated(error)) return

        call check(error, .not. set11 % test(1_bits_kind), &
            'set more than one bit in set11.')
        if (allocated(error)) return

        call set11 % set(165_bits_kind)
        call check(error, set11 % test(165_bits_kind), &
            'did not set the last bit in set11.')
        if (allocated(error)) return

        call check(error, .not. set11 % test(164_bits_kind), &
            'set more than one bit in set11.')
        if (allocated(error)) return

        call set11 % set(1_bits_kind, 164_bits_kind)
        call check(error, set11 % all(), &
            'did not set the remaining bits in set11.')
        if (allocated(error)) return

    end subroutine test_bit_operations

    subroutine test_bitset_comparisons(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_large) :: set0, set1, set2
        type(bitset_large) :: set10, set11, set12, set13, set14

        call set0 % from_string( bitstring_0 )
        call set1 % from_string( bitstring_all )
        call set2 % from_string( bitstring_33 )

        call check(error, set0 == set0 .and. set1 == set1 .and. set2 == set2 .and. &
            .not. set0 == set1 .and. .not. set0 == set2 .and. .not.   &
            set1 == set2, 'failed 64 bit equality tests.')
        if (allocated(error)) return

        call check(error, set0 /= set1 .and. set1 /= set2 .and. set0 /= set2 .and. &
            .not. set0 /= set0 .and. .not. set1 /= set1 .and. .not.   &
            set2 /= set2, 'failed 64 bit inequality tests.')
        if (allocated(error)) return

        call check(error, set1 > set0 .and. set2 > set0 .and. set1 > set2 .and. &
            .not. set0 > set1 .and. .not. set1 > set1 .and. .not.  &
            set2 > set1, 'failed 64 bit greater than tests.')
        if (allocated(error)) return

        call check(error, set1 >= set0 .and. set1 >= set2 .and. set2 >= set2 .and. &
            .not. set0 >= set1 .and. .not. set0 >= set1 .and. .not.  &
            set2 >= set1, 'failed 64 bit greater than or equal tests.')
        if (allocated(error)) return

        call check(error, set0 < set1 .and. set0 < set1 .and. set2 < set1 .and. &
            .not. set1 < set0 .and. .not. set0 < set0 .and. .not.  &
            set1 < set2, 'failed 64 bit less than tests.')
        if (allocated(error)) return

        call check(error, set0 <= set1 .and. set2 <= set1 .and. set2 <= set2 .and. &
            .not. set1 <= set0 .and. .not. set2 <= set0 .and. .not.  &
            set1 <= set2, 'failed 64 bit less than or equal tests.')
        if (allocated(error)) return

        call set10 % init(166_bits_kind)
        call set11 % init(166_bits_kind)
        call set11 % not()
        call set12 % init(166_bits_kind)
        call set12 % set(165_bits_kind)
        call set13 % init(166_bits_kind)
        call set13 % set(65_bits_kind)
        call set14 % init(166_bits_kind)
        call set14 % set(0_bits_kind)
        call check(error, set10 == set10 .and. set11 == set11 .and. set12 == set12 .and. &
            set13 == set13 .and. set14 == set14 .and.                      &
            .not. set13 == set14 .and. .not. set12 == set13 .and.          &
            .not. set10 == set11 .and. .not. set10 == set12 .and. .not.    &
            set11 == set12, 'failed > 64 bit equality tests.')
        if (allocated(error)) return

        call check(error, set10 /= set11 .and. set11 /= set12 .and. set10 /= set12 .and. &
            set13 /= set12 .and. set14 /= set13 .and. set14 /= set12 .and. &
            .not. set13 /= set13 .and. .not. set12 /= set12 .and.          &
            .not. set10 /= set10 .and. .not. set11 /= set11 .and. .not.    &
            set12 /= set12, 'failed > 64 bit inequality tests.')
        if (allocated(error)) return

        call check(error, set11 > set10 .and. set12 > set10 .and. set11 > set12 .and. &
            set13 > set14 .and. set12 > set13 .and. set12 > set14 .and. &
            .not. set14 > set12 .and. .not. set12 > set11 .and.         &
            .not. set10 > set11 .and. .not. set11 > set11 .and. .not.   &
            set12 > set11, 'failed > 64 bit greater than tests.')
        if (allocated(error)) return

        call check(error, set11 >= set10 .and. set11 >= set12 .and. set12 >= set12 .and. &
            set13 >= set14 .and. set12 >= set13 .and. set12 >= set14 .and. &
            .not. set14 >= set12 .and. .not. set12 >= set11 .and.          &
            .not. set10 >= set11 .and. .not. set10 >= set11 .and. .not.    &
            set12 >= set11, 'failed 64 bit greater than or equal tests.')
        if (allocated(error)) return

        call check(error, set10 < set11 .and. set10 < set11 .and. set12 < set11 .and. &
            set14 < set13 .and. set13 < set12 .and. set14 < set12 .and. &
            .not. set12 < set14 .and. .not. set11 < set12 .and.         &
            .not. set11 < set10 .and. .not. set10 < set10 .and. .not.    &
            set11 < set12, 'failed > 64 bit less than tests.')
        if (allocated(error)) return

        call check(error, set10 <= set11 .and. set12 <= set11 .and. set12 <= set12 .and. &
            set14 <= set13 .and. set13 <= set12 .and. set14 <= set12 .and. &
            .not. set12 <= set14 .and. .not. set11 <= set12 .and.          &
            .not. set11 <= set10 .and. .not. set12 <= set10 .and. .not.     &
            set11 <= set12, 'failed > 64 bit less than or equal tests.')
        if (allocated(error)) return

    end subroutine test_bitset_comparisons

    subroutine test_bitset_operations(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(bitset_large) :: set0, set3, set4

        call set0 % from_string( bitstring_all )
        call set4 % from_string( bitstring_all )
        call and( set0, set4 ) ! all all
        call check(error, set0 % all(), 'first test of < 64 bit AND failed.')
        if (allocated(error)) return

        call set4 % from_string( bitstring_0 )
        call and( set0, set4 ) ! all none
        call check(error, set0 % none(), 'second test of < 64 bit AND failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_all )
        call set4 % from_string( bitstring_0 )
        call and( set4, set3 ) ! none all
        call check(error, set4 % none(), 'third test of < 64 bit AND failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_0 )
        call and( set4, set3 ) ! none none
        call check(error, set4 % none(), 'fourth test of < 64 bit AND failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_all )
        call set4 % from_string( bitstring_all )
        call and_not( set4, set3 ) ! all all
        call check(error, set4 % none(), 'first test of < 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call set4 % from_string( bitstring_0 )
        call and_not( set4, set3 ) ! none all
        call check(error, set4 % none(), 'second test of < 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_all )
        call set4 % from_string( bitstring_0 )
        call and_not( set3, set4 ) ! all none
        call check(error, set3 % all(), 'third  test of < 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_0 )
        call set4 % from_string( bitstring_0 )
        call and_not( set3, set4 ) ! none none
        call check(error, set3 % none(), 'fourth  test of < 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_all )
        call set4 % from_string( bitstring_all )
        call or( set3, set4 ) ! all all
        call check(error, set3 % all(), 'first test of < 64 bit OR failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_0 )
        call or( set4, set3 ) ! all none
        call check(error, set4 % all(), 'second test of < 64 bit OR failed.')
        if (allocated(error)) return

        call or( set3, set4 ) ! none all
        call check(error, set3 % all(), 'third test of < 64 bit OR failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_0 )
        call set4 % from_string( bitstring_0 )
        call or( set4, set3 ) !none none
        call check(error, set4 % none(), 'fourth test of < 64 bit OR failed.')
        if (allocated(error)) return

        call set3 % from_string( bitstring_0 )
        call set4 % from_string( bitstring_0 )
        call xor( set3, set4 ) ! none none
        call check(error, set3 % none(), 'first test of < 64 bit XOR failed.')
        if (allocated(error)) return

        call set4 % from_string( bitstring_all )
        call xor( set3, set4 ) ! none all
        call check(error, set3 % all(), 'second test of < 64 bit XOR failed.')
        if (allocated(error)) return

        call set4 % from_string( bitstring_0 )
        call xor( set3, set4 ) ! all none
        call check(error, set3 % all(), 'third test of < 64 bit XOR failed.')
        if (allocated(error)) return

        call set4 % from_string( bitstring_all )
        call xor( set3, set4 ) ! all all
        call check(error, set3 % none(), 'fourth test of < 64 bit XOR failed.')
        if (allocated(error)) return

        call set0 % init(166_bits_kind)
        call set0 % not()
        call set4 % init(166_bits_kind)
        call set4 % not()
        call and( set0, set4 ) ! all all
        call check(error, set0 % all(), 'first test of > 64 bit AND failed.')
        if (allocated(error)) return

        call set4 % init(166_bits_kind)
        call and( set0, set4 ) ! all none
        call check(error, set0 % none(), 'second test of > 64 bit AND failed.')
        if (allocated(error)) return

        call set3 % init(166_bits_kind)
        call set3 % not()
        call and( set4, set3 ) ! none all
        call check(error, set4 % none(), 'third test of > 64 bit AND failed.')
        if (allocated(error)) return

        call set3 % init(166_bits_kind)
        call and( set4, set3 ) ! none none
        call check(error, set4 % none(), 'fourth test of > 64 bit AND failed.')
        if (allocated(error)) return

        call set3 % not()
        call set4 % not()
        call and_not( set4, set3 ) ! all all
        call check(error, set4 % none(), 'first test of > 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call and_not( set4, set3 ) ! none all
        call check(error, set4 % none(), 'second test of > 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call and_not( set3, set4 ) ! all none
        call check(error, set3 % all(), 'third  test of > 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call set3 % not()
        call and_not( set3, set4 ) ! none none
        call check(error, set3 % none(), 'fourth  test of > 64 bit AND_NOT failed.')
        if (allocated(error)) return

        call set3 % init(166_bits_kind)
        call set3 % not()
        call set4 % init(166_bits_kind)
        call set4 % not()
        call or( set3, set4 ) ! all all
        call check(error, set3 % all(), 'first test of > 64 bit OR failed.')
        if (allocated(error)) return

        call set3 % init(166_bits_kind)
        call or( set4, set3 ) ! all none
        call check(error, set4 % all(), 'second test of > 64 bit OR failed.')
        if (allocated(error)) return

        call or( set3, set4 ) ! none all
        call check(error, set3 % all(), 'third test of > 64 bit OR failed.')
        if (allocated(error)) return

        call set3 % init(166_bits_kind)
        call set4 % init(166_bits_kind)
        call or( set4, set3 ) !none none
        call check(error, set4 % none(), 'fourth test of > 64 bit OR failed.')
        if (allocated(error)) return

        call xor( set3, set4 ) ! none none
        call check(error, set3 % none(), 'first test of > 64 bit XOR failed.')
        if (allocated(error)) return

        call set4 % not()
        call xor( set3, set4 ) ! none all
        call check(error, set3 % all(), 'second test of > 64 bit XOR failed.')
        if (allocated(error)) return

        call set4 % not()
        call xor( set3, set4 ) ! all none
        call check(error, set3 % all(), 'third test of > 64 bit XOR failed.')
        if (allocated(error)) return

        call set4 % not()
        call xor( set3, set4 ) ! all all
        call check(error, set3 % none(), 'fourth test of > 64 bit XOR failed.')
        if (allocated(error)) return

    end subroutine test_bitset_operations


end module test_stdlib_bitset_large


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_stdlib_bitset_large, only : collect_stdlib_bitset_large
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("stdlib-bitset-large", collect_stdlib_bitset_large) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_trapz_weights
  use stdlib_quadrature, only: trapz_weights
  implicit none
  real, parameter :: x(5) = [0., 1., 2., 3., 4.]
  real :: y(5) = x**2
  real :: w(5)
  w = trapz_weights(x)
  print *, sum(w*y)
! 22.0
end program example_trapz_weights

program example_is_hessenberg
  use stdlib_linalg, only: is_hessenberg
  implicit none
  real :: A(3, 3), B(3, 3)
  logical :: res
  A = reshape([1., 2., 0., 4., 5., 6., 7., 8., 9.], shape(A))
  B = reshape([1., 2., 3., 4., 5., 6., 7., 8., 9.], shape(B))
  res = is_hessenberg(A, 'u') ! returns .true.
  res = is_hessenberg(B, 'u') ! returns .false.
end program example_is_hessenberg

! Cholesky factorization: function interface 
program example_chol
  use stdlib_linalg, only: chol
  implicit none

  real, allocatable, dimension(:,:) :: A,L,U 

  ! Set real matrix
  A = reshape( [ [6, 15, 55], &
                 [15, 55, 225], &
                 [55, 225, 979] ], [3,3] )

  ! Decompose (lower)
  L = chol(A, lower=.true.)

  ! Compare decomposition 
  print *, maxval(abs(A-matmul(L,transpose(L))))

  ! Decompose (upper)
  U = chol(A, lower=.false.)
  
  ! Compare decomposition 
  print *, maxval(abs(A-matmul(transpose(U),U)))

end program example_chol

program example_map_entry
  use, intrinsic:: iso_fortran_env, only: int8, int64
  use stdlib_hashmaps, only: chaining_hashmap_type
  use stdlib_hashmap_wrappers, only: key_type, set
  implicit none
  type(chaining_hashmap_type) :: map
  type(key_type)      :: key
  logical             :: conflict
  integer             :: int_scalar
  
  type :: array_data_wrapper
      integer, allocatable :: array(:)
  end type
  
  type(array_data_wrapper) :: array_example
  
  ! Initialize hashmap with 2^10 slots.
  ! Hashmap will dynamically increase size if needed.
  call map%init(slots_bits=10)
  
  ! Explicitly set key using set function
  call set(key, [1, 2, 3])
  call map%map_entry(key, 4, conflict)
  print *, 'CONFLICT = ', conflict
  
  ! Using map_entry int32 array interface
  call map%map_entry( [4, 5, 6], 4, conflict)
  print *, 'CONFLICT = ', conflict
  
  ! Integer scalars need to be passed as an array.
  int_scalar = 1
  call map%map_entry( [int_scalar], 4, conflict)
  print *, 'CONFLICT = ', conflict
  
  ! Using map_entry character interface
  call map%map_entry( 'key_string', 4, conflict)
  print *, 'CONFLICT = ', conflict
  
  ! Transfer unsupported key types to int8 arrays.
  call map%map_entry( transfer( [1_int64, 2_int64, 3_int64], [0_int8] ), 4, conflict)
  print *, 'CONFLICT = ', conflict
  
! Keys can be mapped alone without a corresponding value (other) for 'Set' type functionality.
  call map%map_entry( [7, 8, 9], conflict=conflict)
  print *, 'CONFLICT = ', conflict
  
! Currently only scalar data can be mapped.   
! Arrays will need a wrapper.  
  array_example % array = [1,2,3,4,5]
  call map % map_entry( [10,11,12], array_example, conflict=conflict )
  print *, 'CONFLICT = ', conflict
  
end program example_map_entry

! SPDX-Identifier: MIT
module test_strip_chomp
    use stdlib_ascii, only : TAB, VT, NUL, LF, CR, FF
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_strings, only : strip, chomp
    use stdlib_string_type, only : string_type, operator(==), operator(//)
    implicit none

contains


    !> Collect all exported unit tests
    subroutine collect_strip_chomp(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("strip_char", test_strip_char), &
            new_unittest("strip_string", test_strip_string), &
            new_unittest("chomp_char", test_chomp_char), &
            new_unittest("chomp_string", test_chomp_string), &
            new_unittest("chomp_set_char", test_chomp_set_char), &
            new_unittest("chomp_set_string", test_chomp_set_string), &
            new_unittest("chomp_substring_char", test_chomp_substring_char), &
            new_unittest("chomp_substring_string", test_chomp_substring_string) &
            ]
    end subroutine collect_strip_chomp

    subroutine test_strip_char(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, strip("   hello   ") == "hello")
        if (allocated(error)) return
        call check(error, strip(TAB//"goodbye"//CR//LF) == "goodbye")
        if (allocated(error)) return
        call check(error, strip(NUL//TAB//LF//VT//FF//CR) == NUL)
        if (allocated(error)) return
        call check(error, strip(" "//TAB//LF//VT//FF//CR) == "")
        if (allocated(error)) return
        call check(error, strip("  !  ")//"!" == "!!")
        if (allocated(error)) return
        call check(error, strip("Hello") == "Hello")
    end subroutine test_strip_char

    subroutine test_strip_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, strip(string_type("   hello   ")) == "hello")
        if (allocated(error)) return
        call check(error, strip(string_type(TAB//"goodbye"//CR//LF)) == "goodbye")
        if (allocated(error)) return
        call check(error, strip(string_type(NUL//TAB//LF//VT//FF//CR)) == NUL)
        if (allocated(error)) return
        call check(error, strip(string_type(" "//TAB//LF//VT//FF//CR)) == "")
        if (allocated(error)) return
        call check(error, strip(string_type("  !  "))//"!" == "!!")
        if (allocated(error)) return
        call check(error, strip(string_type("Hello")) == "Hello")
    end subroutine test_strip_string

    subroutine test_chomp_char(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, chomp("hello") == "hello")
        if (allocated(error)) return
        call check(error, chomp("hello"//LF) == "hello", "1")
        if (allocated(error)) return
        call check(error, chomp("hello"//CR//LF) == "hello", "2")
        if (allocated(error)) return
        call check(error, chomp("hello"//LF//CR) == "hello", "3")
        if (allocated(error)) return
        call check(error, chomp("hello"//CR) == "hello", "4")
        if (allocated(error)) return
        call check(error, chomp("hello "//LF//" there") == "hello "//LF//" there")
        if (allocated(error)) return
        call check(error, chomp("hello"//CR//LF//CR//LF) == "hello")
        if (allocated(error)) return
        call check(error, chomp("hello"//CR//LF//CR//CR//LF) == "hello")
        if (allocated(error)) return
        call check(error, chomp(NUL//TAB//LF//VT//FF//CR) == NUL)
        if (allocated(error)) return
        call check(error, chomp(" "//TAB//LF//VT//FF//CR) == "")
        if (allocated(error)) return
        call check(error, chomp("  !  ")//"!" == "  !!")
    end subroutine test_chomp_char

    subroutine test_chomp_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, chomp(string_type("hello")) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"//LF)) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"//CR//LF)) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"//LF//CR)) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"//CR)) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello "//LF//" there")) == "hello "//LF//" there")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"//CR//LF//CR//LF)) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"//CR//LF//CR//CR//LF)) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type(NUL//TAB//LF//VT//FF//CR)) == NUL)
        if (allocated(error)) return
        call check(error, chomp(string_type(" "//TAB//LF//VT//FF//CR)) == "")
        if (allocated(error)) return
        call check(error, chomp(string_type("  !  "))//"!" == "  !!")
    end subroutine test_chomp_string

    subroutine test_chomp_set_char(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, chomp("hello", ["l", "o"]) == "he")
        if (allocated(error)) return
        call check(error, chomp("hello", set=["l", "o"]) == "he")
    end subroutine test_chomp_set_char

    subroutine test_chomp_set_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, chomp(string_type("hello"), ["l", "o"]) == "he")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"), set=["l", "o"]) == "he")
        if (allocated(error)) return
        call check(error, chomp("hellooooo", ["o", "o"]) == "hell")
        if (allocated(error)) return
        call check(error, chomp("hellooooo", set=["o", "o"]) == "hell")
    end subroutine test_chomp_set_string

    subroutine test_chomp_substring_char(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, chomp("hello", "") == "hello")
        if (allocated(error)) return
        call check(error, chomp("hello", substring="") == "hello")
        if (allocated(error)) return
        call check(error, chomp("hello", "lo") == "hel")
        if (allocated(error)) return
        call check(error, chomp("hello", substring="lo") == "hel")
        if (allocated(error)) return
        call check(error, chomp("hellooooo", "oo") == "hello")
        if (allocated(error)) return
        call check(error, chomp("hellooooo", substring="oo") == "hello")
        if (allocated(error)) return
        call check(error, chomp("helhel", substring="hel") == "")
    end subroutine test_chomp_substring_char

    subroutine test_chomp_substring_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, chomp(string_type("hello"), "") == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"), substring="") == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"), "lo") == "hel")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"), substring="lo") == "hel")
        if (allocated(error)) return
        call check(error, chomp("hello", string_type("lo")) == "hel")
        if (allocated(error)) return
        call check(error, chomp("hello", substring=string_type("lo")) == "hel")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"), string_type("lo")) == "hel")
        if (allocated(error)) return
        call check(error, chomp(string_type("hello"), substring=string_type("lo")) == "hel")
        if (allocated(error)) return
        call check(error, chomp(string_type("hellooooo"), "oo") == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hellooooo"), substring="oo") == "hello")
        if (allocated(error)) return
        call check(error, chomp("hellooooo", string_type("oo")) == "hello")
        if (allocated(error)) return
        call check(error, chomp("hellooooo", substring=string_type("oo")) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hellooooo"), string_type("oo")) == "hello")
        if (allocated(error)) return
        call check(error, chomp(string_type("hellooooo"), substring=string_type("oo")) == "hello")
    end subroutine test_chomp_substring_string

end module test_strip_chomp


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_strip_chomp, only : collect_strip_chomp
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("strip-chomp", collect_strip_chomp) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_fibonacci_hash_64
  use stdlib_hash_64bit, only: fibonacci_hash
  use iso_fortran_env, only: int64
  implicit none
  integer, allocatable :: array1(:)
  integer(int64) :: hash, source
  allocate (array1(0:2**6 - 1))
  array1(:) = 0
  source = int(Z'1FFFFFFFF', int64)
  hash = fibonacci_hash(source, 6)
  array1(hash) = source
  print *, hash
end program example_fibonacci_hash_64

program example_ends_with
  use stdlib_strings, only: ends_with
  implicit none
  print'(l1)', ends_with("pattern", "ern")  ! T
  print'(l1)', ends_with("pattern", "pat")  ! F
end program example_ends_with

module test_ascii
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_ascii, only: lowercase, uppercase, digits, &
        octal_digits, fullhex_digits, hex_digits, lowerhex_digits, &
        whitespace, letters, is_alphanum, is_alpha, is_lower, is_upper, &
        is_digit, is_octal_digit, is_hex_digit, is_white, is_blank, &
        is_control, is_punctuation, is_graphical, is_printable, is_ascii, &
        to_lower, to_upper, to_title, to_sentence, reverse, LF, TAB, NUL, DEL
    use stdlib_kinds, only : int8, int16, int32, int64, lk
    implicit none
    private

    public :: collect_ascii

contains

    !> Collect all exported unit tests
    subroutine collect_ascii(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("is_alphanum_short", test_is_alphanum_short), &
            new_unittest("is_alphanum_long", test_is_alphanum_long), &
            new_unittest("is_alpha_short", test_is_alpha_short), &
            new_unittest("is_alpha_long", test_is_alpha_long), &
            new_unittest("is_lower_short", test_is_lower_short), &
            new_unittest("is_lower_long", test_is_lower_long), &
            new_unittest("is_upper_short", test_is_upper_short), &
            new_unittest("is_upper_long", test_is_upper_long), &
            new_unittest("is_digit_short", test_is_digit_short), &
            new_unittest("is_digit_long", test_is_digit_long), &
            new_unittest("is_octal_digit_short", test_is_octal_digit_short), &
            new_unittest("is_octal_digit_long", test_is_octal_digit_long), &
            new_unittest("is_hex_digit_short", test_is_hex_digit_short), &
            new_unittest("is_hex_digit_long", test_is_hex_digit_long), &
            new_unittest("is_white_short", test_is_white_short), &
            new_unittest("is_white_long", test_is_white_long), &
            new_unittest("is_blank_short", test_is_blank_short), &
            new_unittest("is_blank_long", test_is_blank_long), &
            new_unittest("is_control_short", test_is_control_short), &
            new_unittest("is_control_long", test_is_control_long), &
            new_unittest("is_punctuation_short", test_is_punctuation_short), &
            new_unittest("is_punctuation_long", test_is_punctuation_long), &
            new_unittest("is_graphical_short", test_is_graphical_short), &
            new_unittest("is_graphical_long", test_is_graphical_long), &
            new_unittest("is_printable_short", test_is_printable_short), &
            new_unittest("is_printable_long", test_is_printable_long), &
            new_unittest("is_ascii_short", test_is_ascii_short), &
            new_unittest("is_ascii_long", test_is_ascii_long), &
            new_unittest("to_lower_short", test_to_lower_short), &
            new_unittest("to_lower_long", test_to_lower_long), &
            new_unittest("to_upper_short", test_to_upper_short), &
            new_unittest("to_upper_long", test_to_upper_long), &
            new_unittest("ascii_table", test_ascii_table), &
            new_unittest("to_upper_string", test_to_upper_string), &
            new_unittest("to_lower_string", test_to_lower_string), &
            new_unittest("to_title_string", test_to_title_string), &
            new_unittest("to_sentence_string", test_to_sentence_string), &
            new_unittest("reverse_string", test_reverse_string) &
            ]
    end subroutine collect_ascii

    subroutine test_is_alphanum_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_alphanum('A'))
        if (allocated(error)) return

        call check(error, is_alphanum('1'))
        if (allocated(error)) return

        call check(error, .not. is_alphanum('#'))
        if (allocated(error)) return

        ! N.B.: does not return true for non-ASCII Unicode alphanumerics
        call check(error, .not. is_alphanum('á'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_alphanum_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        clist = digits//octal_digits//fullhex_digits//letters//lowercase//uppercase
        do i = 1, len(clist)
            call check(error, is_alphanum(clist(i:i)))
            if (allocated(error)) return
        end do

        clist = whitespace
        do i = 1, len(clist)
            call check(error, .not. is_alphanum(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_alpha_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_alpha('A'))
        if (allocated(error)) return

        call check(error, .not. is_alpha('1'))
        if (allocated(error)) return

        call check(error, .not. is_alpha('#'))
        if (allocated(error)) return

        ! N.B.: does not return true for non-ASCII Unicode alphabetic characters
        call check(error, .not. is_alpha('á'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_alpha_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        clist = letters//lowercase//uppercase
        do i = 1, len(clist)
            call check(error, is_alpha(clist(i:i)))
            if (allocated(error)) return
        end do

        clist = digits//octal_digits//whitespace
        do i = 1, len(clist)
            call check(error, .not. is_alpha(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_lower_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_lower('a'))
        if (allocated(error)) return

        call check(error, .not. is_lower('A'))
        if (allocated(error)) return

        call check(error, .not. is_lower('#'))
        if (allocated(error)) return

        ! N.B.: does not return true for non-ASCII Unicode lowercase letters
        call check(error, .not. is_lower('á'))
        if (allocated(error)) return

        call check(error, .not. is_lower('Á'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_lower_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(lowercase)
            call check(error, is_lower(lowercase(i:i)))
            if (allocated(error)) return
        end do

        clist = digits//uppercase//whitespace
        do i = 1, len(clist)
            call check(error, .not. is_lower(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_upper_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_upper('A'))
        if (allocated(error)) return

        call check(error, .not. is_upper('a'))
        if (allocated(error)) return

        call check(error, .not. is_upper('#'))
        if (allocated(error)) return

        ! N.B.: does not return true for non-ASCII Unicode uppercase letters
        call check(error, .not. is_upper('á'))
        if (allocated(error)) return

        call check(error, .not. is_upper('Á'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_upper_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(uppercase)
            call check(error, is_upper(uppercase(i:i)))
            if (allocated(error)) return
        end do

        clist = digits//lowercase//whitespace
        do i = 1, len(clist)
            call check(error, .not. is_upper(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine


    subroutine test_is_digit_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_digit('3'))
        if (allocated(error)) return

        call check(error, is_digit('8'))
        if (allocated(error)) return

        call check(error, .not. is_digit('B'))
        if (allocated(error)) return

        call check(error, .not. is_digit('#'))
        if (allocated(error)) return

        ! N.B.: does not return true for non-ASCII Unicode numbers
        call check(error, .not. is_digit('０')) ! full-width digit zero (U+FF10)
        if (allocated(error)) return

        call check(error, .not. is_digit('４')) ! full-width digit four (U+FF14))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_digit_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(digits)
            call check(error, is_digit(digits(i:i)))
            if (allocated(error)) return
        end do

        clist = letters//whitespace
        do i = 1, len(clist)
            call check(error, .not. is_digit(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_octal_digit_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_octal_digit('0'))
        if (allocated(error)) return

        call check(error, is_octal_digit('7'))
        if (allocated(error)) return

        call check(error, .not. is_octal_digit('8'))
        if (allocated(error)) return

        call check(error, .not. is_octal_digit('A'))
        if (allocated(error)) return

        call check(error, .not. is_octal_digit('#'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_octal_digit_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(octal_digits)
            call check(error, is_octal_digit(octal_digits(i:i)))
            if (allocated(error)) return
        end do
        clist = letters//'89'//whitespace
        do i = 1, len(clist)
            call check(error, .not. is_octal_digit(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_hex_digit_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_hex_digit('0'))
        if (allocated(error)) return

        call check(error, is_hex_digit('A'))
        if (allocated(error)) return

        call check(error, is_hex_digit('f')) !! lowercase hex digits are accepted
        if (allocated(error)) return

        call check(error, .not. is_hex_digit('g'))
        if (allocated(error)) return

        call check(error, .not. is_hex_digit('G'))
        if (allocated(error)) return

        call check(error, .not. is_hex_digit('#'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_hex_digit_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(fullhex_digits)
            call check(error, is_hex_digit(fullhex_digits(i:i)))
            if (allocated(error)) return
        end do
        clist = lowercase(7:)//uppercase(7:)//whitespace
        do i = 1, len(clist)
            call check(error, .not. is_hex_digit(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_white_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_white(' '))
        if (allocated(error)) return

        call check(error, is_white(TAB))
        if (allocated(error)) return

        call check(error, is_white(LF))
        if (allocated(error)) return

        call check(error, .not. is_white('1'))
        if (allocated(error)) return

        call check(error, .not. is_white('a'))
        if (allocated(error)) return

        call check(error, .not. is_white('#'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_white_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(whitespace)
            call check(error, is_white(whitespace(i:i)))
            if (allocated(error)) return
        end do
        clist = digits//letters
        do i = 1, len(clist)
            call check(error, .not. is_white(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_blank_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_blank(' '))
        if (allocated(error)) return

        call check(error, is_blank(TAB))
        if (allocated(error)) return

        call check(error, .not. is_blank('1'))
        if (allocated(error)) return

        call check(error, .not. is_blank('a'))
        if (allocated(error)) return

        call check(error, .not. is_blank('#'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_blank_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 1, len(whitespace)
            if (whitespace(i:i) == ' ' .or. whitespace(i:i) == TAB) then
                call check(error, is_blank(whitespace(i:i)))
            else
                call check(error, .not. is_blank(whitespace(i:i)))
            end if
            if (allocated(error)) return
        end do
        clist = digits//letters
        do i = 1, len(clist)
            call check(error, .not. is_blank(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_control_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        ! print *, is_control('\0')
        ! print *, is_control('\022')
        call check(error, is_control(new_line('a'))) ! newline is both whitespace and control
        if (allocated(error)) return

        call check(error, .not. is_control(' '))
        if (allocated(error)) return

        call check(error, .not. is_control('1'))
        if (allocated(error)) return

        call check(error, .not. is_control('a'))
        if (allocated(error)) return

        call check(error, .not. is_control('#'))
        if (allocated(error)) return

        ! N.B.: non-ASCII Unicode control characters are not recognized:
        ! print *, .not. is_control('\u0080')
        ! print *, .not. is_control('\u2028')
        ! print *, .not. is_control('\u2029')
    end subroutine

    subroutine test_is_control_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=:), allocatable :: clist

        do i = 0, 31
            call check(error, is_control(achar(i)))
            if (allocated(error)) return
        end do
        call check(error, is_control(DEL))
        if (allocated(error)) return

        clist = digits//letters//' '
        do i = 1, len(clist)
            call check(error, .not. is_control(clist(i:i)))
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_punctuation_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_punctuation('.'))
        if (allocated(error)) return

        call check(error, is_punctuation(','))
        if (allocated(error)) return

        call check(error, is_punctuation(':'))
        if (allocated(error)) return

        call check(error, is_punctuation('!'))
        if (allocated(error)) return

        call check(error, is_punctuation('#'))
        if (allocated(error)) return

        call check(error, is_punctuation('~'))
        if (allocated(error)) return

        call check(error, is_punctuation('+'))
        if (allocated(error)) return

        call check(error, is_punctuation('_'))
        if (allocated(error)) return

        call check(error, .not. is_punctuation('1'))
        if (allocated(error)) return

        call check(error, .not. is_punctuation('a'))
        if (allocated(error)) return

        call check(error, .not. is_punctuation(' '))
        if (allocated(error)) return

        call check(error, .not. is_punctuation(LF)) ! new line character
        if (allocated(error)) return

        call check(error, .not. is_punctuation(NUL))
        if (allocated(error)) return

        ! N.B.: Non-ASCII Unicode punctuation characters are not recognized.
        ! print *, is_punctuation('\u2012') ! (U+2012 = en-dash)
    end subroutine

    subroutine test_is_punctuation_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=1) :: c

        do i = 0, 127
            c = achar(i)
            if (is_control(c) .or. is_alphanum(c) .or. c == ' ') then
                call check(error, .not. is_punctuation(c))
            else
                call check(error, is_punctuation(c))
            end if
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_graphical_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_graphical('1'))
        if (allocated(error)) return

        call check(error, is_graphical('a'))
        if (allocated(error)) return

        call check(error, is_graphical('#'))
        if (allocated(error)) return

        call check(error, .not. is_graphical(' ')) ! whitespace is not graphical
        if (allocated(error)) return

        call check(error, .not. is_graphical(LF))
        if (allocated(error)) return

        call check(error, .not. is_graphical(NUL))
        if (allocated(error)) return

        ! N.B.: Unicode graphical characters are not regarded as such.
        call check(error, .not. is_graphical('ä'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_graphical_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=1) :: c

        do i = 0, 127
            c = achar(i)
            if (is_control(c) .or. c == ' ') then
                call check(error, .not. is_graphical(c))
            else
                call check(error, is_graphical(c))
            end if
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_printable_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_printable(' ')) ! whitespace is printable
        if (allocated(error)) return

        call check(error, is_printable('1'))
        if (allocated(error)) return

        call check(error, is_printable('a'))
        if (allocated(error)) return

        call check(error, is_printable('#'))
        if (allocated(error)) return

        call check(error, .not. is_printable(NUL)) ! control characters are not printable
        if (allocated(error)) return

        ! N.B.: Printable non-ASCII Unicode characters are not recognized.
        call check(error, .not. is_printable('ä'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_printable_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=1) :: c

        do i = 0, 127
            c = achar(i)
            if (is_control(c)) then
                call check(error, .not. is_printable(c))
            else
                call check(error, is_printable(c))
            end if
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_is_ascii_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, is_ascii('a'))
        if (allocated(error)) return

        call check(error, .not. is_ascii('ä'))
        if (allocated(error)) return
    end subroutine

    subroutine test_is_ascii_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i

        do i = 0, 127
            call check(error, is_ascii(achar(i)))
            if (allocated(error)) return
        end do
        call check(error, .not. is_ascii(achar(128))) ! raises compiler warning
        if (allocated(error)) return

    end subroutine

    subroutine test_to_lower_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, to_lower('a'), 'a')
        if (allocated(error)) return

        call check(error, to_lower('A'), 'a')
        if (allocated(error)) return

        call check(error, to_lower('#'), '#')
        if (allocated(error)) return
    end subroutine

    subroutine test_to_lower_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=1) :: c

        do i = 1, len(uppercase)
            call check(error, to_lower(uppercase(i:i)), lowercase(i:i))
            if (allocated(error)) return
        end do
        do i = 0, 127
            c = achar(i)
            if (c < 'A' .or. c > 'Z') then
                call check(error, to_lower(c), c)
            else
                call check(error, to_lower(c) /= c)
            end if
            if (allocated(error)) return
        end do
    end subroutine

    subroutine test_to_upper_short(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, to_upper('a'), 'A')
        if (allocated(error)) return

        call check(error, to_upper('A'), 'A')
        if (allocated(error)) return

        call check(error, to_upper('#'), '#')
        if (allocated(error)) return
    end subroutine

    subroutine test_to_upper_long(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: i
        character(len=1) :: c

        do i = 1, len(lowercase)
            call check(error, to_upper(lowercase(i:i)), uppercase(i:i))
            if (allocated(error)) return
        end do

        do i = 0, 127
            c = achar(i)
            if (c < 'a' .or. c > 'z') then
                call check(error, to_upper(c), c)
            else
                call check(error, to_upper(c) /= c)
            end if
            if (allocated(error)) return
        end do
    end subroutine

    !
    !   This test reproduces the true/false table found at
    !   https://en.cppreference.com/w/cpp/string/byte
    !
    subroutine ascii_table(table)
        logical, intent(out) :: table(15,12)
        integer :: i, j

        ! loop through functions
        do i = 1, 12
            table(1,i)  = all([(validate(j,i), j=0,8)])
            table(2,i)  = validate(9,i)
            table(3,i)  = all([(validate(j,i), j=10,13)])
            table(4,i)  = all([(validate(j,i), j=14,31)])
            table(5,i)  = validate(32,i)
            table(6,i)  = all([(validate(j,i), j=33,47)])
            table(7,i)  = all([(validate(j,i), j=48,57)])
            table(8,i)  = all([(validate(j,i), j=58,64)])
            table(9,i)  = all([(validate(j,i), j=65,70)])
            table(10,i) = all([(validate(j,i), j=71,90)])
            table(11,i) = all([(validate(j,i), j=91,96)])
            table(12,i) = all([(validate(j,i), j=97,102)])
            table(13,i) = all([(validate(j,i), j=103,122)])
            table(14,i) = all([(validate(j,i), j=123,126)])
            table(15,i) = validate(127,i)
        end do

        ! output table for verification
        write(*,'(5X,12(I4))') (i,i=1,12)
        do j = 1, 15
            write(*,'(I3,2X,12(L4),2X,I3)') j, (table(j,i),i=1,12), count(table(j,:))
        end do
        write(*,'(5X,12(I4))') (count(table(:,i)),i=1,12)
 
        contains

            elemental logical function validate(ascii_code, func)
                integer, intent(in) :: ascii_code, func
                character(len=1) :: c
            
                c = achar(ascii_code)
            
                select case (func)
                    case (1);     validate = is_control(c)
                    case (2);     validate = is_printable(c)
                    case (3);     validate = is_white(c)
                    case (4);     validate = is_blank(c)
                    case (5);     validate = is_graphical(c)
                    case (6);     validate = is_punctuation(c)
                    case (7);     validate = is_alphanum(c)
                    case (8);     validate = is_alpha(c)
                    case (9);     validate = is_upper(c)
                    case (10);    validate = is_lower(c)
                    case (11);    validate = is_digit(c)
                    case (12);    validate = is_hex_digit(c)
                    case default; validate = .false.
                end select
            end function validate
    
    end subroutine ascii_table

    subroutine test_ascii_table(error)
        type(error_type), allocatable, intent(out) :: error
        logical :: arr(15, 12)
        logical, parameter :: ascii_class_table(15,12) = transpose(reshape([ &
        ! iscntrl  isprint  isspace  isblank  isgraph  ispunct  isalnum  isalpha  isupper  islower  isdigit  isxdigit
        .true.,   .false., .false., .false., .false., .false., .false., .false., .false., .false., .false., .false., & ! 0–8
        .true.,   .false., .true.,  .true.,  .false., .false., .false., .false., .false., .false., .false., .false., & ! 9
        .true.,   .false., .true.,  .false., .false., .false., .false., .false., .false., .false., .false., .false., & ! 10–13
        .true.,   .false., .false., .false., .false., .false., .false., .false., .false., .false., .false., .false., & ! 14–31
        .false.,  .true.,  .true.,  .true.,  .false., .false., .false., .false., .false., .false., .false., .false., & ! 32 (space)
        .false.,  .true.,  .false., .false., .true.,  .true.,  .false., .false., .false., .false., .false., .false., & ! 33–47
        .false.,  .true.,  .false., .false., .true.,  .false., .true.,  .false., .false., .false., .true.,  .true.,  & ! 48–57
        .false.,  .true.,  .false., .false., .true.,  .true.,  .false., .false., .false., .false., .false., .false., & ! 58–64
        .false.,  .true.,  .false., .false., .true.,  .false., .true.,  .true.,  .true.,  .false., .false., .true.,  & ! 65–70
        .false.,  .true.,  .false., .false., .true.,  .false., .true.,  .true.,  .true.,  .false., .false., .false., & ! 71–90
        .false.,  .true.,  .false., .false., .true.,  .true.,  .false., .false., .false., .false., .false., .false., & ! 91–96
        .false.,  .true.,  .false., .false., .true.,  .false., .true.,  .true.,  .false., .true.,  .false., .true.,  & ! 97–102
        .false.,  .true.,  .false., .false., .true.,  .false., .true.,  .true.,  .false., .true.,  .false., .false., & ! 103–122
        .false.,  .true.,  .false., .false., .true.,  .true.,  .false., .false., .false., .false., .false., .false., & ! 123–126
        .true.,   .false., .false., .false., .false., .false., .false., .false., .false., .false., .false., .false.  & ! 127
        ], shape=[12,15]))

        call ascii_table(arr)
        call check(error, all(arr .eqv. ascii_class_table), "ascii table was not accurately generated")

    end subroutine test_ascii_table

    subroutine test_to_lower_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=:), allocatable :: dlc
        character(len=32), parameter :: input = "UPPERCASE"

        dlc = to_lower("UPPERCASE")
        call check(error, dlc, "uppercase")
        if (allocated(error)) return

        dlc = to_lower(input)
        call check(error, len(dlc), 32)
        if (allocated(error)) return

        call check(error, len_trim(dlc), 9)
        if (allocated(error)) return

        call check(error, trim(dlc), "uppercase")
        if (allocated(error)) return

        dlc = to_lower("0123456789ABCDE")
        call check(error, dlc, "0123456789abcde")
        if (allocated(error)) return
    end subroutine test_to_lower_string

    subroutine test_to_upper_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=:), allocatable :: dlc
        character(len=32), parameter :: input = "lowercase"

        dlc = to_upper("lowercase")
        call check(error, dlc, "LOWERCASE")
        if (allocated(error)) return

        dlc = to_upper(input)
        call check(error, len(dlc), 32)
        if (allocated(error)) return

        call check(error, len_trim(dlc), 9)
        if (allocated(error)) return

        call check(error, trim(dlc), "LOWERCASE")
        if (allocated(error)) return

        dlc = to_upper("0123456789abcde")
        call check(error, dlc, "0123456789ABCDE")
        if (allocated(error)) return
    end subroutine test_to_upper_string

    subroutine test_to_title_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=:), allocatable :: dlc
        character(len=32), parameter :: input = "tHis Is tO bE tiTlEd"

        dlc = to_title("tHis Is tO bE tiTlEd")
        call check(error, dlc, "This Is To Be Titled")
        if (allocated(error)) return

        dlc = to_title(input)
        call check(error, len(dlc), 32)
        if (allocated(error)) return

        call check(error, len_trim(dlc), 20)
        if (allocated(error)) return

        call check(error, trim(dlc), "This Is To Be Titled")
        if (allocated(error)) return

        dlc = to_title(" s P a C e D !")
        call check(error, dlc, " S P A C E D !")
        if (allocated(error)) return

        dlc = to_title("1st, 2nD, 3RD")
        call check(error, dlc, "1st, 2nd, 3rd")
        if (allocated(error)) return

        dlc = to_title("""quOTed""")
        call check(error, dlc, """Quoted""")
        if (allocated(error)) return
    end subroutine test_to_title_string

    subroutine test_to_sentence_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=:), allocatable :: dlc
        character(len=32), parameter :: input = "tHis iS A seNteNcE."

        dlc = to_sentence("tHis iS A seNteNcE.")
        call check(error, dlc, "This is a sentence.")
        if (allocated(error)) return

        dlc = to_sentence(input)
        call check(error, len(dlc), 32)
        if (allocated(error)) return

        call check(error, len_trim(dlc), 19)
        if (allocated(error)) return

        call check(error, trim(dlc), "This is a sentence.")
        if (allocated(error)) return

        dlc = to_sentence(" s P a C e D !")
        call check(error, dlc, " S p a c e d !")
        if (allocated(error)) return

        dlc = to_sentence("1st, 2nd, 3rd")
        call check(error, dlc, "1st, 2nd, 3rd")
        if (allocated(error)) return

        dlc = to_sentence("""quOTed""")
        call check(error, dlc, """Quoted""")
        if (allocated(error)) return
    end subroutine test_to_sentence_string

    subroutine test_reverse_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=:), allocatable :: dlc
        character(len=32), parameter :: input = "reversed"

        dlc = reverse("reversed")
        call check(error, dlc, "desrever")
        if (allocated(error)) return

        dlc = reverse(input)
        call check(error, len(dlc), 32)
        if (allocated(error)) return

        call check(error, len_trim(dlc), 32)
        if (allocated(error)) return

        call check(error, trim(dlc), "                        desrever")
        if (allocated(error)) return

        call check(error, trim(adjustl(dlc)), "desrever")
        if (allocated(error)) return
    end subroutine test_reverse_string


end module test_ascii


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_ascii, only : collect_ascii
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("ascii", collect_ascii) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_and
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0, set1
  call set0%init(166)
  call set1%init(166)
  call and(set0, set1) ! none none
  if (set0%none()) write (*, *) 'First test of AND worked.'
  call set0%not()
  call and(set0, set1) ! all none
  if (set0%none()) write (*, *) 'Second test of AND worked.'
  call set1%not()
  call and(set0, set1) ! none all
  if (set0%none()) write (*, *) 'Third test of AND worked.'
  call set0%not()
  call and(set0, set1) ! all all
  if (set0%all()) write (*, *) 'Fourth test of AND worked.'
end program example_and

program example_concatenate_operator
  use stdlib_stringlist_type, only: stringlist_type, operator(//)
  use stdlib_string_type, only: string_type
  implicit none

  type(stringlist_type)          :: first_stringlist, second_stringlist
  type(string_type), allocatable :: stringarray(:)

  first_stringlist = first_stringlist//"Element No. one"
! first_stringlist <-- {"Element No. one"}

  second_stringlist = string_type("Element No. two")//first_stringlist
! second_stringlist <-- {Element No. two, "Element No. one"}

!> Creating an array of 2 string_type elements
  stringarray = [string_type("Element No. three"), string_type("Element No. four")]

  second_stringlist = first_stringlist//stringarray
! second_stringlist <-- {"Element No. one", "Element No. three", "Element No. four"}

  second_stringlist = ["#1", "#2"]//second_stringlist
! second_stringlist <-- {"#1", "#2", "Element No. one", "Element No. three", "Element No. four"}

  first_stringlist = first_stringlist//second_stringlist
! first_stringlist <-- {"Element No. one", "#1", "#2", "Element No. one", "Element No. three", "Element No. four"}

end program example_concatenate_operator

program example_solve_bicgstab
    use stdlib_kinds, only: dp
    use stdlib_linalg_iterative_solvers
    implicit none
    
    integer, parameter :: n = 4
    real(dp) :: A(n,n), b(n), x(n)
    integer :: i
    
    ! Example matrix (same as SciPy documentation)
    A = reshape([4.0_dp, 2.0_dp, 0.0_dp, 1.0_dp, &
                 3.0_dp, 0.0_dp, 0.0_dp, 2.0_dp, &
                 0.0_dp, 1.0_dp, 1.0_dp, 1.0_dp, &
                 0.0_dp, 2.0_dp, 1.0_dp, 0.0_dp], [n,n])
    
    b = [-1.0_dp, -0.5_dp, -1.0_dp, 2.0_dp]
    
    x = 0.0_dp  ! Initial guess
    
    print *, 'Solving Ax = b using BiCGSTAB method:'
    print *, 'Matrix A:'
    do i = 1, n
        print '(4F8.2)', A(i,:)
    end do
    print *, 'Right-hand side b:'
    print '(4F8.2)', b
    
    ! Solve using BiCGSTAB
    call stdlib_solve_bicgstab(A, b, x, rtol=1e-10_dp, atol=1e-12_dp)
    
    print *, 'Solution x:'
    print '(4F10.6)', x
    
    ! Verify solution
    print *, 'Verification A*x:'
    print '(4F10.6)', matmul(A, x)
    
    print *, 'Residual ||b - A*x||:'
    print *, norm2(b - matmul(A, x))
    
end program 

program example_strip
  use stdlib_ascii, only: TAB, VT, LF, CR, FF
  use stdlib_strings, only: strip
  implicit none
  print'(a)', strip("   hello   ")             ! "hello"
  print'(a)', strip(TAB//"goodbye"//CR//LF)    ! "goodbye"
  print'(a)', strip(" "//TAB//LF//VT//FF//CR)  ! ""
  print'(a)', strip("  !  ")//"!"              ! "!!"
  print'(a)', strip("Hello")                   ! "Hello"
end program example_strip

module stdlib_io_aux
  implicit none(type, external)
  private
  public :: FMT_INT, FMT_REAL_SP, FMT_REAL_DP, FMT_REAL_XDP, FMT_REAL_QP
  public :: FMT_COMPLEX_SP, FMT_COMPLEX_DP, FMT_COMPLEX_XDP, FMT_COMPLEX_QP

  !> Version: experimental
  !>
  !> Format strings with edit descriptors for each type and kind
  !> ([Specification](../page/specs/stdlib_io.html))
  character(*), parameter :: &
    !> Format string for integers
    FMT_INT = '(i0)', &
    !> Format string for single precision real numbers
    FMT_REAL_SP = '(es15.8e2)', &
    !> Format string for souble precision real numbers
    FMT_REAL_DP = '(es24.16e3)', &
    !> Format string for extended double precision real numbers
    FMT_REAL_XDP = '(es26.18e3)', &
    !> Format string for quadruple precision real numbers
    FMT_REAL_QP = '(es44.35e4)', &
    !> Format string for single precision complex numbers
    FMT_COMPLEX_SP = '(es15.08e2,1x,es15.08e2)', &
    !> Format string for double precision complex numbers
    FMT_COMPLEX_DP = '(es24.16e3,1x,es24.16e3)', &
    !> Format string for extended double precision complex numbers
    FMT_COMPLEX_XDP = '(es26.18e3,1x,es26.18e3)', &
    !> Format string for quadruple precision complex numbers
    FMT_COMPLEX_QP = '(es44.35e4,1x,es44.35e4)'

end module stdlib_io_aux

program example_char_range
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  character(len=:), allocatable :: dlc

  string = "Fortran"
  dlc = char(string, 1, 4)
! dlc == "Fort"
end program example_char_range

! SPDX-Identifier: MIT

module test_logicalloc
  use stdlib_array, only : trueloc, falseloc
  use stdlib_kinds, only : dp, i8 => int64
  use stdlib_strings, only : to_string
  use testdrive, only : new_unittest, unittest_type, error_type, check
  implicit none
  private

  public :: collect_logicalloc

contains

  !> Collect all exported unit tests
  subroutine collect_logicalloc(testsuite)
    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)

    testsuite = [ &
      new_unittest("trueloc-empty", test_trueloc_empty), &
      new_unittest("trueloc-all", test_trueloc_all), &
      new_unittest("trueloc-where", test_trueloc_where), &
      new_unittest("trueloc-merge", test_trueloc_merge), &
      new_unittest("trueloc-pack", test_trueloc_pack), &
      new_unittest("falseloc-empty", test_falseloc_empty), &
      new_unittest("falseloc-all", test_falseloc_all), &
      new_unittest("falseloc-where", test_falseloc_where), &
      new_unittest("falseloc-merge", test_falseloc_merge), &
      new_unittest("falseloc-pack", test_falseloc_pack) &
      ]
  end subroutine collect_logicalloc

  subroutine test_trueloc_empty(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:)

    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)

      bvec = avec
      bvec(trueloc(bvec < 0)) = 0.0

      call check(error, all(bvec == avec))
      deallocate(avec, bvec)
      if (allocated(error)) exit
    end do
  end subroutine test_trueloc_empty

  subroutine test_trueloc_all(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:)

    do ndim = 100, 12000, 100
      allocate(avec(-ndim/2:ndim))

      call random_number(avec)

      avec(trueloc(avec > 0, lbound(avec, 1))) = 0.0

      call check(error, all(avec == 0.0))
      deallocate(avec)
      if (allocated(error)) exit
    end do
  end subroutine test_trueloc_all

  subroutine test_trueloc_where(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:), cvec(:)
    real(dp) :: tl, tw

    tl = 0.0_dp
    tw = 0.0_dp
    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)
      avec(:) = avec - 0.5

      bvec = avec
      tl = tl - timing()
      bvec(trueloc(bvec > 0)) = 0.0
      tl = tl + timing()

      cvec = avec
      tw = tw - timing()
      where(cvec > 0) cvec = 0.0
      tw = tw + timing()

      call check(error, all(bvec == cvec))
      deallocate(avec, bvec, cvec)
      if (allocated(error)) exit
    end do
    call report("trueloc", tl, "where", tw)
  end subroutine test_trueloc_where

  subroutine test_trueloc_merge(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:), cvec(:)
    real(dp) :: tl, tm

    tl = 0.0_dp
    tm = 0.0_dp
    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)
      avec(:) = avec - 0.5

      bvec = avec
      tl = tl - timing()
      bvec(trueloc(bvec > 0)) = 0.0
      tl = tl + timing()

      cvec = avec
      tm = tm - timing()
      cvec(:) = merge(0.0, cvec, cvec > 0)
      tm = tm + timing()

      call check(error, all(bvec == cvec))
      deallocate(avec, bvec, cvec)
      if (allocated(error)) exit
    end do
    call report("trueloc", tl, "merge", tm)
  end subroutine test_trueloc_merge

  subroutine test_trueloc_pack(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:), cvec(:)
    real(dp) :: tl, tp

    tl = 0.0_dp
    tp = 0.0_dp
    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)
      avec(:) = avec - 0.5

      bvec = avec
      tl = tl - timing()
      bvec(trueloc(bvec > 0)) = 0.0
      tl = tl + timing()

      cvec = avec
      tp = tp - timing()
      block
        integer :: i
        cvec(pack([(i, i=1, size(cvec))], cvec > 0)) = 0.0
      end block
      tp = tp + timing()

      call check(error, all(bvec == cvec))
      deallocate(avec, bvec, cvec)
      if (allocated(error)) exit
    end do
    call report("trueloc", tl, "pack", tp)
  end subroutine test_trueloc_pack

  subroutine test_falseloc_empty(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:)

    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)

      bvec = avec
      bvec(falseloc(bvec > 0)) = 0.0

      call check(error, all(bvec == avec))
      deallocate(avec, bvec)
      if (allocated(error)) exit
    end do
  end subroutine test_falseloc_empty

  subroutine test_falseloc_all(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:)

    do ndim = 100, 12000, 100
      allocate(avec(-ndim/2:ndim))

      call random_number(avec)

      avec(falseloc(avec < 0, lbound(avec, 1))) = 0.0

      call check(error, all(avec == 0.0))
      deallocate(avec)
      if (allocated(error)) exit
    end do
  end subroutine test_falseloc_all

  subroutine test_falseloc_where(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:), cvec(:)
    real(dp) :: tl, tw

    tl = 0.0_dp
    tw = 0.0_dp
    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)
      avec(:) = avec - 0.5

      bvec = avec
      tl = tl - timing()
      bvec(falseloc(bvec > 0)) = 0.0
      tl = tl + timing()

      cvec = avec
      tw = tw - timing()
      where(.not.(cvec > 0)) cvec = 0.0
      tw = tw + timing()

      call check(error, all(bvec == cvec))
      deallocate(avec, bvec, cvec)
      if (allocated(error)) exit
    end do
    call report("falseloc", tl, "where", tw)
  end subroutine test_falseloc_where

  subroutine test_falseloc_merge(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:), cvec(:)
    real(dp) :: tl, tm

    tl = 0.0_dp
    tm = 0.0_dp
    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)
      avec(:) = avec - 0.5

      bvec = avec
      tl = tl - timing()
      bvec(falseloc(bvec > 0)) = 0.0
      tl = tl + timing()

      cvec = avec
      tm = tm - timing()
      cvec(:) = merge(cvec, 0.0, cvec > 0)
      tm = tm + timing()

      call check(error, all(bvec == cvec))
      deallocate(avec, bvec, cvec)
      if (allocated(error)) exit
    end do
    call report("falseloc", tl, "merge", tm)
  end subroutine test_falseloc_merge

  subroutine test_falseloc_pack(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer :: ndim
    real, allocatable :: avec(:), bvec(:), cvec(:)
    real(dp) :: tl, tp

    tl = 0.0_dp
    tp = 0.0_dp
    do ndim = 100, 12000, 100
      allocate(avec(ndim))

      call random_number(avec)
      avec(:) = avec - 0.5

      bvec = avec
      tl = tl - timing()
      bvec(falseloc(bvec > 0)) = 0.0
      tl = tl + timing()

      cvec = avec
      tp = tp - timing()
      block
        integer :: i
        cvec(pack([(i, i=1, size(cvec))], cvec < 0)) = 0.0
      end block
      tp = tp + timing()

      call check(error, all(bvec == cvec))
      deallocate(avec, bvec, cvec)
      if (allocated(error)) exit
    end do
    call report("falseloc", tl, "pack", tp)
  end subroutine test_falseloc_pack

  subroutine report(l1, t1, l2, t2)
    character(len=*), intent(in) :: l1, l2
    real(dp), intent(in) :: t1, t2
    character(len=*), parameter :: fmt = "f6.4"

    !$omp critical
    print '(2x, "[Timing]", *(1x, g0))', &
      l1//":", to_string(t1, fmt)//"s", &
      l2//":", to_string(t2, fmt)//"s", &
      "ratio:", to_string(t1/t2, "f4.1")
    !$omp end critical
  end subroutine report

  function timing() result(time)
    real(dp) :: time

    integer(i8) :: time_count, time_rate, time_max
    call system_clock(time_count, time_rate, time_max)
    time = real(time_count, dp)/real(time_rate, dp)
  end function timing

end module test_logicalloc


program tester
  use, intrinsic :: iso_fortran_env, only : error_unit
  use testdrive, only : run_testsuite, new_testsuite, testsuite_type
  use test_logicalloc, only : collect_logicalloc
  implicit none
  integer :: stat, is
  type(testsuite_type), allocatable :: testsuites(:)
  character(len=*), parameter :: fmt = '("#", *(1x, a))'

  stat = 0

  testsuites = [ &
    new_testsuite("logicalloc", collect_logicalloc) &
    ]

  do is = 1, size(testsuites)
    write(error_unit, fmt) "Testing:", testsuites(is)%name
    call run_testsuite(testsuites(is)%collect, error_unit, stat)
  end do

  if (stat > 0) then
    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
    error stop
  end if
end program

program example_logspace_int
  use stdlib_math, only: logspace
  use stdlib_kinds, only: dp
  implicit none

  integer, parameter :: start = 10
  integer, parameter :: end = 23
  integer, parameter :: n = 15

  real(dp) :: r(n) ! Integer values raised to real powers results in real values

  r = logspace(start, end, n)
end program example_logspace_int

program example_get
  use stdlib_hashmap_wrappers, only: &
    get, key_type, set
  use iso_fortran_env, only: int8
  implicit none
  integer(int8), allocatable :: value(:), result(:)
  type(key_type) :: key
  integer(int8) :: i
  allocate (value(1:15))
  do i = 1, 15
    value(i) = i
  end do
  call set(key, value)
  call get(key, result)
  print *, 'RESULT == VALUE = ', all(value == result)
end program example_get

program example_global_logger
  use stdlib_logger, global => global_logger
  implicit none

  integer :: unit, stat

  call global%add_log_file('error_log.txt', unit, &
                           position='asis', stat=stat)
  if (stat /= success) then
    error stop 'Unable to open "error_log.txt".'
  end if

end program example_global_logger

submodule(stdlib_system) stdlib_system_path
    use stdlib_ascii, only: reverse
    use stdlib_strings, only: chomp, join
    use stdlib_string_type, only: string_type, char, move
contains
    module function join2_char_char(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1, p2

        path = trim(p1) // path_sep() // trim(p2)
    end function join2_char_char

    module function join2_char_string(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1
        type(string_type), intent(in) :: p2

        path = join_path(p1, char(p2))
    end function join2_char_string

    module function join2_string_char(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1
        character(*), intent(in) :: p2
        character(:), allocatable :: join_char

        join_char = join_path(char(p1), p2)

        call move(join_char, path)
    end function join2_string_char

    module function join2_string_string(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1, p2
        character(:), allocatable :: join_char

        join_char = join_path(char(p1), char(p2))

        call move(join_char, path)
    end function join2_string_string

    module function joinarr_char(p) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p(:)

        path = join(p, path_sep())
    end function joinarr_char

    module function joinarr_string(p) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p(:)

        path = join(p, path_sep())
    end function joinarr_string

    module function join_op_char_char(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1, p2

        path = join_path(p1, p2)
    end function join_op_char_char

    module function join_op_char_string(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1
        type(string_type), intent(in) :: p2

        path = join_path(p1, p2)
    end function join_op_char_string

    module function join_op_string_char(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1
        character(*), intent(in) :: p2

        path = join_path(p1, p2)
    end function join_op_string_char

    module function join_op_string_string(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1, p2

        path = join_path(p1, p2)
    end function join_op_string_string

    module subroutine split_path_char(p, head, tail)
        character(*), intent(in) :: p
        character(:), allocatable, intent(out) :: head, tail
        character(:), allocatable :: temp
        integer :: i
        character(len=1) :: sep
        sep = path_sep()

        ! Empty string, return (.,'')
        if (trim(p) == '') then
            head = '.'
            tail = ''
            return
        end if

        ! Remove trailing path separators
        temp = trim(chomp(trim(p), sep))

        if (temp == '') then
            head = sep
            tail = ''
            return
        end if

        i = find(reverse(temp), sep)

        ! if no `pathsep`, then it probably was a root dir like `C:\`
        if (i == 0) then
            head = temp // sep
            tail = ''
            return
        end if

        head = temp(:len(temp)-i)

        ! child of a root directory
        if (find(head, sep) == 0) then
            head = head // sep
        end if

        tail = temp(len(temp)-i+2:)
    end subroutine split_path_char

    module subroutine split_path_string(p, head, tail)
        type(string_type), intent(in) :: p
        type(string_type), intent(out) :: head, tail

        character(:), allocatable :: head_char, tail_char

        call split_path(char(p), head_char, tail_char)

        call move(head_char, head)
        call move(tail_char, tail)
    end subroutine split_path_string

    module function base_name_char(p) result(base)
        character(:), allocatable :: base, temp
        character(*), intent(in) :: p

        call split_path(p, temp, base)
    end function base_name_char

    module function base_name_string(p) result(base)
        type(string_type) :: base
        type(string_type), intent(in) :: p
        type(string_type) :: temp

        call split_path(p, temp, base)
    end function base_name_string

    module function dir_name_char(p) result(dir)
        character(:), allocatable :: dir, temp
        character(*), intent(in) :: p

        call split_path(p, dir, temp)
    end function dir_name_char

    module function dir_name_string(p) result(dir)
        type(string_type) :: dir
        type(string_type), intent(in) :: p
        type(string_type) :: temp

        call split_path(p, dir, temp)
    end function dir_name_string
end submodule stdlib_system_path

program demo_cross_product
    use stdlib_linalg, only: cross_product
    implicit none
    real :: a(3), b(3), c(3)
    a = [1., 0., 0.]
    b = [0., 1., 0.]
    c = cross_product(a, b)
    !c = [0., 0., 1.]
end program demo_cross_product

program example_len_trim
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: length

  string = "Some longer sentence for this example."
  length = len_trim(string)
! length == 38

  string = "Whitespace                            "
  length = len_trim(string)
! length == 10
end program example_len_trim

program example_exponential_rvs
  use stdlib_random, only: random_seed
  use stdlib_stats_distribution_exponential, only: rexp => rvs_exp

  implicit none
  complex :: cloc, cscale
  integer :: seed_put, seed_get

  seed_put = 1234567
  call random_seed(seed_put, seed_get)

  ! single standard exponential random variate
  print *, rexp()
  ! 0.358690143

  ! exponential random variate with loc=0 and scale=0.5 (lambda=2)
  print *, rexp(0.0, 0.5)
  ! 0.122672431

  ! exponential random variate with lambda=2
   print *, rexp(2.0)
  ! 0.204114929

  ! exponential random variate with loc=0.6 and scale=0.2 (lambda=5)
  print *, rexp(0.6, 0.2)
  ! 0.681645989

  ! an array of 10 variates with loc=0.0 and scale=3.0 (lambda=1/3)
  print *, rexp(0.0, 3.0, 10)
  ! 1.36567295       2.62772131      0.362352759       5.47133636       2.13591909
  ! 0.410784155      5.83882189      6.71128035        1.31730068       1.90963650

  ! single complex exponential random variate with real part of scale=0.5 (lambda=2.0);
  ! imagainary part of scale=1.6 (lambda=0.625)
  cloc   = (0.0, 0.0)
  cscale = (0.5, 1.6)
  print *, rexp(cloc, cscale)
  ! (0.426896989,2.56968451)

end program example_exponential_rvs

program example_math_all_close

  use stdlib_math, only: all_close
  implicit none
  real    :: y, NAN
  complex :: z(4, 4)

  y = -3
  NAN = sqrt(y)
  z = (1.0, 1.0)

  print *, all_close(z + cmplx(1.0e-11, 1.0e-11), z)     ! T
  print *, NAN, all_close([NAN], [NAN]), all_close([NAN], [NAN], equal_nan=.true.)
! NAN, F, T

end program example_math_all_close

! SPDX-Identifier: MIT

!> Module for index manipulation and general array handling
!>
!> The specification of this module is available [here](../page/specs/stdlib_array.html).
module stdlib_array
  implicit none
  private

  public :: trueloc, falseloc

contains

  !> Version: experimental
  !>
  !> Return the positions of the true elements in array.
  !> [Specification](../page/specs/stdlib_array.html#trueloc)
  pure function trueloc(array, lbound) result(loc)
    !> Mask of logicals
    logical, intent(in) :: array(:)
    !> Lower bound of array to index
    integer, intent(in), optional :: lbound
    !> Locations of true elements
    integer :: loc(count(array))

    call logicalloc(loc, array, .true., lbound)
  end function trueloc

  !> Version: experimental
  !>
  !> Return the positions of the false elements in array.
  !> [Specification](../page/specs/stdlib_array.html#falseloc)
  pure function falseloc(array, lbound) result(loc)
    !> Mask of logicals
    logical, intent(in) :: array(:)
    !> Lower bound of array to index
    integer, intent(in), optional :: lbound
    !> Locations of false elements
    integer :: loc(count(.not.array))

    call logicalloc(loc, array, .false., lbound)
  end function falseloc

  !> Return the positions of the truthy elements in array
  pure subroutine logicalloc(loc, array, truth, lbound)
    !> Locations of truthy elements
    integer, intent(out) :: loc(:)
    !> Mask of logicals
    logical, intent(in) :: array(:)
    !> Truthy value
    logical, intent(in) :: truth
    !> Lower bound of array to index
    integer, intent(in), optional :: lbound
    integer :: i, pos, offset

    offset = 0
    if (present(lbound)) offset = lbound - 1

    i = 0
    do pos = 1, size(array)
      if (array(pos).eqv.truth) then
        i = i + 1
        loc(i) = pos + offset
      end if
    end do
  end subroutine logicalloc

end module stdlib_array

program example_calls
  use stdlib_hashmaps, only: chaining_hashmap_type, int_calls
  implicit none
  type(chaining_hashmap_type) :: map
  integer(int_calls) :: initial_calls
  call map%init()
  initial_calls = map%calls()
  print *, "INITIAL_CALLS =  ", initial_calls
end program example_calls

program example_ge
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  logical :: res

  string = "bcd"
  res = string >= "abc"
! res .eqv. .true.

  res = string >= "bcd"
! res .eqv. .true.

  res = string >= "cde"
! res .eqv. .false.
end program example_ge

program example_gauss_legendre
  use iso_fortran_env, dp => real64
  use stdlib_quadrature, only: gauss_legendre
  implicit none

  integer, parameter :: N = 6
  real(dp), dimension(N) :: x, w
  call gauss_legendre(x, w)
  print *, "integral of x**2 from -1 to 1 is", sum(x**2*w)
end program example_gauss_legendre

! SPDX-Identifier: MIT
module test_string_match
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_ascii, only : reverse
    use stdlib_strings, only : starts_with, ends_with, join
    use stdlib_string_type, only : string_type
    implicit none

contains


    !> Collect all exported unit tests
    subroutine collect_string_match(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("starts_with", test_starts_with), &
            new_unittest("ends_with", test_ends_with), &
            new_unittest("join", test_join) &
            ]
    end subroutine collect_string_match

    subroutine check_starts_with(error, string, substring)
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: string
        character(len=*), intent(in) :: substring
        logical :: match
        character(len=:), allocatable :: message

        match = index(string, substring) == 1
        if (match) then
            message = "Failed to recognize that '"//string//"' starts with '"//substring//"'"
        else
            message = "Incorrectly found that '"//string//"' starts with '"//substring//"'"
        end if

        call check(error, starts_with(string, substring) .eqv. match, message)
        if (allocated(error)) return
        call check(error, starts_with(string_type(string), substring) .eqv. match, message)
        if (allocated(error)) return
        call check(error, starts_with(string, string_type(substring)) .eqv. match, message)
        if (allocated(error)) return
        call check(error, starts_with(string_type(string), string_type(substring)) .eqv. match, message)
    end subroutine check_starts_with

    subroutine test_starts_with(error)
        type(error_type), allocatable, intent(out) :: error
        call check_starts_with(error, "pattern", "pat")
        if (allocated(error)) return
        call check_starts_with(error, "pat", "pattern")
        if (allocated(error)) return
        call check_starts_with(error, "pattern", "ern")
        if (allocated(error)) return
        call check_starts_with(error, "ern", "pattern")
    end subroutine test_starts_with

    subroutine check_ends_with(error, string, substring)
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: string
        character(len=*), intent(in) :: substring
        logical :: match
        character(len=:), allocatable :: message

        match = index(reverse(string), reverse(substring)) == 1
        if (match) then
            message = "Failed to recognize that '"//string//"' ends with '"//substring//"'"
        else
            message = "Incorrectly found that '"//string//"' ends with '"//substring//"'"
        end if

        call check(error, ends_with(string, substring) .eqv. match, message)
        if (allocated(error)) return
        call check(error, ends_with(string_type(string), substring) .eqv. match, message)
        if (allocated(error)) return
        call check(error, ends_with(string, string_type(substring)) .eqv. match, message)
        if (allocated(error)) return
        call check(error, ends_with(string_type(string), string_type(substring)) .eqv. match, message)
    end subroutine check_ends_with

    subroutine test_join(error)
        type(error_type), allocatable, intent(out) :: error
        character(len=5) :: test_strings(3)

        test_strings = [character(5) :: "one", "two", "three"]
        call check_join(error, test_strings, " ", "one two three")
        if (allocated(error)) return
        call check_join(error, test_strings, ",", "one,two,three")
        if (allocated(error)) return
        call check_join(error, test_strings, "-", "one-two-three")
    end subroutine test_join

    subroutine check_join(error, strings, separator, expected)
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: strings(:)
        character(len=*), intent(in) :: separator
        character(len=*), intent(in) :: expected
        character(len=:), allocatable :: joined
        character(len=:), allocatable :: message

        joined = join(strings, separator)
        message = "'join' error: Expected '" // expected // "' but got '" // joined // "'"
        call check(error, joined == expected, message)

    end subroutine check_join

    subroutine test_ends_with(error)
        type(error_type), allocatable, intent(out) :: error
        call check_ends_with(error, "pattern", "pat")
        if (allocated(error)) return
        call check_ends_with(error, "pat", "pattern")
        if (allocated(error)) return
        call check_ends_with(error, "pattern", "ern")
        if (allocated(error)) return
        call check_ends_with(error, "ern", "pattern")
    end subroutine test_ends_with

end module test_string_match


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_string_match, only : collect_string_match
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("string-match", collect_string_match) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_pengy_hash
  use stdlib_hash_64bit, only: new_pengy_hash_seed, pengy_hash
  use iso_fortran_env, only: int32, int64
  implicit none
  integer, allocatable :: key(:)
  integer(int64) :: hash
  integer(int32)  ::  seed
  key = [0, 1, 2, 3]
  seed = 0_int32
  call new_pengy_hash_seed(seed)
  hash = pengy_hash(key, seed)
  print *, seed, hash
end program example_pengy_hash

program example_is_hermitian
  use stdlib_linalg, only: is_hermitian
  implicit none
  complex :: A(2, 2), B(2, 2)
  logical :: res
  A = reshape([cmplx(1., 0.), cmplx(3., -1.), cmplx(3., 1.), cmplx(4., 0.)], shape(A))
  B = reshape([cmplx(1., 0.), cmplx(3., 1.), cmplx(3., 1.), cmplx(4., 0.)], shape(B))
  res = is_hermitian(A) ! returns .true.
  res = is_hermitian(B) ! returns .false.
end program example_is_hermitian

program example_exponential_pdf
  use stdlib_random, only: random_seed
  use stdlib_stats_distribution_exponential, only: exp_pdf => pdf_exp, &
                                                    rexp => rvs_exp

  implicit none
  real, dimension(2, 3, 4) :: x, loc, scale
  real :: xsum
  complex :: cloc, cscale
  integer :: seed_put, seed_get, i

  seed_put = 1234567
  call random_seed(seed_put, seed_get)

  ! probability density at x=1.0 with loc=0 and scale=1.0
  print *, exp_pdf(1.0, 0.0, 1.0)
  ! 0.367879450

  ! probability density at x=1.0 with lambda=1.0
  print *, exp_pdf(1.0, 1.0)
  ! 0.367879450

  ! probability density at x=2.0 with lambda=2.0
  print *, exp_pdf(2.0, 2.0)
  ! 3.66312787E-02

  ! probability density at x=2.0 with loc=0.0 and scale=0.5 (lambda=2.0)
  print *, exp_pdf(2.0, 0.0, 0.5)
  ! 3.66312787E-02

  ! probability density at x=1.5 with loc=0.5 and scale=0.5 (lambda=2.0)
  print *, exp_pdf(2.5, 0.5, 0.5)
  ! 3.66312787E-02

  ! probability density at x=2.0 with loc=0.0 and scale=-1.0 (out of range)
  print *, exp_pdf(2.0, 0.0, -1.0)
  ! NaN

  ! standard exponential random variates array
  x = reshape(rexp(0.0, 2.0, 24), [2, 3, 4])

  ! a rank-3 exponential probability density
  loc(:, :, :)   = 0.0
  scale(:, :, :) = 2.0
  print *, exp_pdf(x, loc, scale)
  ! 0.349295378      0.332413018     0.470253497     0.443498343      0.317152828
  ! 0.208242029      0.443112582     8.07073265E-02  0.245337561      0.436016470
  ! 7.14025944E-02   5.33841923E-02  0.322308093     0.264558554      0.212898195
  ! 0.100339092      0.226891592     0.444002301     9.91026312E-02   3.87373678E-02
  ! 3.11400592E-02   0.349431813     0.482774824     0.432669312

  ! probability density array where scale<=0.0 for certain elements (loc = 0.0)
  print *, exp_pdf([1.0, 1.0, 1.0], [0.0, 0.0, 0.0], [1.0, 0.0, -1.0])
  ! 0.367879450  NaN NaN

  ! `pdf_exp` is pure and, thus, can be called concurrently
  xsum = 0.0
  do concurrent (i=1:size(x,3))
    xsum = xsum + sum(exp_pdf(x(:,:,i), loc(:,:,i), scale(:,:,i)))
  end do
  print *, xsum
  ! 6.45566940

  ! complex exponential probability density function at (1.5, 0.0, 1.0) with real part
  ! of scale=1.0 and imaginary part of scale=0.5
  cloc   = (0.0, 0.0)
  cscale = (1.0, 0.5)
  print *, exp_pdf((1.5, 1.0), cloc, cscale)
  ! 6.03947677E-02

  ! As above, but with scale%re < 0
  cloc   = (0.0, 0.0)
  cscale = (-1.0, 2.0)
  print *, exp_pdf((1.5, 1.0), cloc, cscale)
  ! NaN

end program example_exponential_pdf

program example_to_sentence
  use stdlib_string_type
  implicit none
  type(string_type) :: string, sentencecase_string

  string = "sentencecase this string."
! string <-- "sentencecase this string."

  sentencecase_string = to_sentence(string)
! string <-- "sentencecase this string."
! sentencecase_string <-- "Sentencecase this string."
end program example_to_sentence

program example_savetxt
  use stdlib_io, only: savetxt
  implicit none
  real :: x(3, 2) = 1
  call savetxt('example.dat', x)
  call savetxt('example.csv', x, delimiter=',')
end program example_savetxt

! Least-squares solver: functional interface
program example_lstsq1
  use stdlib_linalg_constants, only: dp
  use stdlib_linalg, only: lstsq
  implicit none

  integer, allocatable :: x(:),y(:)
  real(dp), allocatable :: A(:,:),b(:),coef(:)

  ! Data set
  x = [1, 2, 2]
  y = [5, 13, 25]

  ! Fit three points using a parabola, least squares method
  ! A = [1 x x**2]
  A = reshape([[1,1,1],x,x**2],[3,3])
  b = y

  ! Get coefficients of y = coef(1) + x*coef(2) + x^2*coef(3)
  coef = lstsq(A,b)

  print *, 'parabola: ',coef
  ! parabola:  -0.42857142857141695        1.1428571428571503        4.2857142857142811 


end program example_lstsq1

program test_stdlib_logger
!! A test code for most of stdlib_logger.f90.

    use, intrinsic ::           &
        iso_fortran_env, only : &
        error_unit,             &
        input_unit,             &
        output_unit

    use stdlib_logger, global => global_logger

    implicit none

    integer, allocatable :: log_units(:)
    integer              :: level, max_width, stat
    integer              :: unit1, unit2, unit3, unit4, unit5, unit6
    logical              :: add_blank_line, exist, indent, time_stamp

    if ( global % log_units_assigned() == 0 ) then
        write(*,*) 'Start off with 0 LOG_UNITS as expected.'

    else
        error stop 'Unexpected start off with non_zero LOG_UNITS.'

    end if

    call test_logging_configuration()

    call test_adding_log_files()

    print *
    print *, 'running test of log_error'
    call global % log_error( 'This message should be output to five ' //  &
        'files and not to OUTPUT_UNIT, limited to 72 columns width, ' //  &
        'preceded by no blank line, then by a time stamp, then by ' //    &
        'MODULE % PROCEDURE, be prefixed by ERROR and be indented on ' // &
        'subsequent lines by 4 columns, and finish with STAT and.' //     &
        'ERRMSG lines.',                                                  &
        module = 'N/A',                                                   &
        procedure = 'TEST_STDLIB_LOGGER',                                 &
        stat = 0,                                                         &
        errmsg = 'This is a long ERRMSG intended to test formatting ' //  &
        'of the ERRMSG when it is more than 72 columns wide.' )

    call test_removing_log_units()

    print *
    print *, 'running log_text_error'
    call global % log_text_error( 'This text should be written to UNIT1' // &
                                  ' and UNIT3 and not to OUTPUT_UNIT.',     &
                                  column = 25,                              &
                                  summary = 'There is no real error here.', &
                                  filename = 'dummy.txt',                   &
                                  line_number = 0,                          &
                                  caret = '1',                              &
                                  stat = stat )

!    call global % assert( 1 < 0, '1 < 0 ; Test of ASSERT', module='N/A', &
!        procedure = 'TEST_SDLIB_LOGGER' )

    call test_adding_log_units()

    print *
    print *, 'running log_text_error'
    call global % log_text_error( 'This text should be written to ' //      &
                                  'UNIT1, UNIT2, and OUTPUT_UNIT.',         &
                                  column = 25,                              &
                                  summary = 'There is no real error here.', &
                                  filename = 'dummy.txt',                   &
                                  line_number = 0,                          &
                                  caret = '^',                              &
                                  stat = stat )

    call test_level()

contains

    subroutine test_logging_configuration()

        print *, 'running test_logging_configuration'

        call global % configuration( add_blank_line=add_blank_line, &
            indent=indent, max_width=max_width, time_stamp=time_stamp, &
            log_units=log_units )

        if ( .not. add_blank_line ) then
            write(*,*) 'ADD_BLANK_LINE starts off as .FALSE. as expected.'

        else
            error stop 'ADD_BLANK_LINE starts off as .TRUE. contrary to ' // &
                'expectations.'

        end if

        if ( indent ) then
            write(*,*) 'INDENT starts off as .TRUE. as expected.'

        else
            error stop 'INDENT starts off as .FALSE. contrary to expectations.'

        end if

        if ( max_width == 0 ) then
            write(*,*) 'MAX_WIDTH starts off as 0 as expected.'

        else
            error stop 'MAX_WIDTH starts off as not equal to 0 contrary ' // &
                'to expectations.'

        end if

        if ( time_stamp ) then
            write(*,*) 'TIME_STAMP starts off as .TRUE. as expected.'

        else
            error stop 'TIME_STAMP starts off as .FALSE. contrary to ' // &
                'expectations.'

        end if

        if ( size(log_units) == 0 ) then
            write(*,*) 'SIZE(LOG_UNITS) starts off as 0 as expected.'

        else
            error stop 'SIZE(LOG_UNITS) starts off as non-zero contrary ' // &
                'to expectations.'

        end if

        !testing all calls independently
        call global % configuration( add_blank_line=add_blank_line )

        if ( .not. add_blank_line ) then
            write(*,*) 'ADD_BLANK_LINE starts off as .FALSE. as expected.'

        else
            error stop 'ADD_BLANK_LINE starts off as .TRUE. contrary to ' // &
                'expectations.'

        end if

        call global % configuration( indent=indent )

        if ( indent ) then
            write(*,*) 'INDENT starts off as .TRUE. as expected.'

        else
            error stop 'INDENT starts off as .FALSE. contrary to expectations.'

        end if

        call global % configuration( max_width=max_width )

        if ( max_width == 0 ) then
            write(*,*) 'MAX_WIDTH starts off as 0 as expected.'

        else
            error stop 'MAX_WIDTH starts off as not equal to 0 contrary ' // &
                'to expectations.'

        end if

        call global % configuration( time_stamp=time_stamp )

        if ( time_stamp ) then
            write(*,*) 'TIME_STAMP starts off as .TRUE. as expected.'

        else
            error stop 'TIME_STAMP starts off as .FALSE. contrary to ' // &
                'expectations.'

        end if

        call global % configuration( log_units=log_units )

        if ( size(log_units) == 0 ) then
            write(*,*) 'SIZE(LOG_UNITS) starts off as 0 as expected.'

        else
            error stop 'SIZE(LOG_UNITS) starts off as non-zero contrary ' // &
                'to expectations.'

        end if


        call global % log_information( 'This message should be output ' // &
            'to OUTPUT_UNIT, unlimited in width, not preceded by ' //      &
            'a blank line, then by a time stamp, then by MODULE % ' //     &
            'PROCEDURE, be prefixed by INFO and be indented on ' //        &
            'subsequent lines by 4 columns.',                              &
            module = 'N/A',                                                &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % log_information( 'This message should be output ' // &
            'to OUTPUT_UNIT, unlimited in width, not preceded by ' //      &
            'a blank line, then by a time stamp, then by MODULE % ' //     &
            'PROCEDURE, be prefixed by INFO. ' // new_line('a') //         &
            'This is a new line of the same log message.',                 &
            module = 'N/A',                                                &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % log_debug( 'This message should be output ' //       &
            'to OUTPUT_UNIT, unlimited in width, not preceded by ' //      &
            'a blank line, then by a time stamp, then by MODULE % ' //     &
            'PROCEDURE, be prefixed by DEBUG and be indented on ' //       &
            'subsequent lines by 4 columns.',                              &
            module = 'N/A',                                                &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % log_debug( 'This message should be output ' //       &
            'to OUTPUT_UNIT, unlimited in width, not preceded by ' //      &
            'a blank line, then by a time stamp, then by MODULE % ' //     &
            'PROCEDURE, be prefixed by DEBUG. ' // new_line('a') //        &
            'This is a new line of the same log message.',                 &
            module = 'N/A',                                                &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % configure( add_blank_line=.true., indent=.false., &
            max_width=72, time_stamp=.false. )

        call global % configuration( add_blank_line=add_blank_line,    &
            indent=indent, max_width=max_width, time_stamp=time_stamp, &
            log_units=log_units )

        if ( add_blank_line ) then
            write(*,*) 'ADD_BLANK_LINE is now .TRUE. as expected.'

        else
            error stop 'ADD_BLANKLINE is now .FALSE. contrary to expectations.'

        end if

        if ( .not. indent ) then
            write(*,*) 'INDENT is now .FALSE. as expected.'

        else
            error stop 'INDENT is now .TRUE. contrary to expectations.'

        end if

        if ( max_width == 72 ) then
            write(*,*) 'MAX_WIDTH is now 72 as expected.'

        else
            error stop 'MAX_WIDTH is not equal to 72 contrary to expectations.'

        end if

        if ( .not. time_stamp ) then
            write(*,*) 'TIME_STAMP is now .FALSE. as expected.'

        else
            error stop 'TIME_STAMP starts off as .FALSE. contrary to ' // &
                'expectations.'

        end if

        if ( size(log_units) == 0 ) then
            write(*,*) 'SIZE(LOG_UNITS) is still 0 as expected.'

        else
            error stop 'SIZE(LOG_UNITS) is now non-zero contrary to ' // &
                'expectations.'

        end if

        call global % log_message( 'This message should still be output ' // &
            'to OUTPUT_UNIT, limited to 72 columns width, preceded by ' //   &
            'a blank line, then by no time stamp, then by MODULE % ' //      &
            'PROCEDURE, have no prefix, and be unindented on subsequent ' // &
            'lines.', &
            module = 'N/A', &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % log_message( 'The last word of the first line ' //      &
            new_line('a')//'should be "line". "Line"' // new_line('a') //     &
            'is also the last word for the second line. The following ' //    &
            'lines should be limited to 72 columns width.' , &
            module = 'N/A', &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % configure( add_blank_line=.false., indent=.true., &
            max_width=72, time_stamp=.true. )

        call global % log_warning( 'This message should still be ' //   &
            'output to OUTPUT_UNIT, limited to 72 columns width, ' //   &
            'preceded by no blank line, then by a time stamp, then ' // &
            'by MODULE % PROCEDURE, have a prefix of WARN, and be ' //  &
            'indented by 4 columns on subsequent lines.',               &
            module = 'N/A',                                             &
            procedure = 'TEST_STDLIB_LOGGER' )

        call global % log_message( 'The last word of the first line ' //      &
            new_line('a')//'should be "the". "Line"' // new_line('a') //      &
            'should be the last word for the second line. The following ' //  &
            'lines should be limited to 72 columns width. From the second ' //&
            'line, all lines should be indented by 4 columns.' ,&
            module = 'N/A', &
            procedure = 'TEST_STDLIB_LOGGER' )

    end subroutine test_logging_configuration


    subroutine test_adding_log_files()

        print *
        print *, 'running test_adding_log_files'

        call global % add_log_file( 'first_log_file.txt', unit1, stat=stat )
        if ( stat == success ) then
            write(*,*) 'Able to open "first_log_file.txt" as expected'

        else
            error stop 'Unable to open "first_log_file.txt" contrary to ' // &
                'expectations.'

        end if

        if ( global % log_units_assigned() == 1 ) then
            write(*,*) 'Incremented to 1 LOG_UNITS as expected.'

        else
            error stop 'Unexpected increment to other than 1 LOG_UNITS.'

        end if

        call global % add_log_file( 'second_log_file.txt', unit2, &
            action='readwrite', stat=stat )
        if ( stat == success ) then
            write(*,*) 'Able to open "second_log_file.txt" as expected'

        else
            error stop 'Unable to open "second_log_file.txt" contrary to ' // &
                'expectations.'

        end if

        if ( global % log_units_assigned() == 2 ) then
            write(*,*) 'Incremented to 2 LOG_UNITS as expected.'

        else
            error stop 'Unexpected increment to other than 2 LOG_UNITS.'

        end if

        call global %add_log_file( 'third_log_file.txt', unit3, &
            position='asis', stat=stat )
        if ( stat == success ) then
            write(*,*) 'Able to open "third_log_file.txt" as expected'

        else
            error stop 'Unable to open "third_log_file.txt" as contrary ' // &
                'to expectations.'

        end if

        if ( global % log_units_assigned() == 3 ) then
            write(*,*) 'Incremented to 3 LOG_UNITS as expected.'

        else
            error stop 'Unexpected increment to other than 3 LOG_UNITS.'

        end if

        call global % add_log_file( 'fourth_log_file.txt', unit4, &
            status='new', stat=stat )
        if ( stat /= success ) then
            inquire( file='fourth_log_file.txt', exist=exist )
            write(*,*) 'Unable to OPEN "fourth_log_file.txt" as "NEW" ' // &
                'as it already exists, which is an expected result.'
            call global % add_log_file( 'fourth_log_file.txt', unit4, &
                status='old', position='rewind', stat=stat )

            if ( stat /= success ) then
                error stop 'Unable to open "fourth_log_file.txt" as "OLD".'

            end if

        end if

        if ( global % log_units_assigned() == 4 ) then
            write(*,*) 'Incremented to 4 LOG_UNITS as expected.'

        else
            error stop 'Unexpected increment to other than 4 LOG_UNITS.'

        end if

        call global % add_log_file( 'fifth_log_file.txt', unit5, &
            action='READ', stat=stat )
        if ( stat /= success ) then
            if ( stat == read_only_error ) then
                write(*,*) 'Unable to OPEN "fifth_log_file.txt" as ' // &
                    '"READ", as it makes it read only, which is an ' // &
                    'expected result.'
                call global % add_log_file( 'fifth_log_file.txt', unit5, &
                    action='write', stat=stat )
                if ( stat /= success ) then
                    error stop 'Unable to open "fifth_log_file.txt" as "WRITE".'

                end if

            end if

        end if

        if ( global % log_units_assigned() == 5 ) then
            write(*,*) 'Incremented to 5 LOG_UNITS as expected.'

        else
            error stop 'Unexpected increment to other than 5 LOG_UNITS.'

        end if

    end subroutine test_adding_log_files

    subroutine test_removing_log_units()

        logical :: opened
        integer :: istat

        print *
        print *, 'running test_removing_log_units'
        call global % remove_log_unit( unit5 )
        if ( global % log_units_assigned() == 4 ) then
            write(*,*) 'Decremented to 4 LOG_UNITS as expected.'

        else
            error stop 'Unexpected change to other than 4 LOG_UNITS.'

        end if

        call global % remove_log_unit( unit5 )
! Should do nothing as already removed
        if ( global % log_units_assigned() == 4 ) then
            write(*,*) 'Remained at 4 LOG_UNITS as expected.'

        else
            error stop 'Unexpected change to other than 4 LOG_UNITS.'

        end if

        inquire( unit4, opened=opened )
        if ( opened ) then
            write(*,*) 'UNIT4 is OPENED as expected.'

        else
            error stop 'UNIT4 is not OPENED contrary to expectations.'

        end if

        call global % remove_log_unit( unit4, close_unit=.true., stat=stat )
        if ( stat /= success ) then
            error stop 'Unable to close UNIT4 in REMOVE_LOG_UNIT.'

        end if

        if ( global % log_units_assigned() == 3 ) then
            write(*,*) 'Decremented to 3 LOG_UNITS as expected.'

        else
            error stop 'Unexpected change to other than 3 LOG_UNITS.'

        end if

        inquire( unit4, opened=opened, iostat=istat )
        if(istat /= 0) opened = .false.
        if ( opened ) then
            error stop 'UNIT4 is opened contrary to expectations.'

        else
            write(*,*) 'UNIT4 is not opened as expected.'

        end if

        call global % configuration( log_units=log_units )
        if ( unit1 == log_units(1) .and. unit2 == log_units(2) .and. &
             unit3 == log_units(3) ) then
            write(*,*) 'Units have retained their expected ordering'

        else
            error stop 'Units have not retained their expected ordering'

        end if

        call global % remove_log_unit( unit4, close_unit=.true., stat=stat )
        if ( stat /= success ) then
            error stop 'Attempted to close UNIT4 in REMOVE_LOG_UNIT and failed.'

        end if

        if ( global % log_units_assigned() == 3 ) then
            write(*,*) 'Remained at 3 LOG_UNITS as expected.'

        else
            error stop 'Unexpected change to other than 3 LOG_UNITS.'

        end if

        call global % configuration( log_units=log_units )
        if ( unit1 == log_units(1) .and. unit2 == log_units(2) .and. &
             unit3 == log_units(3) ) then
            write(*,*) 'Units have retained their expected ordering'

        else
            error stop 'Units have not retained their expected ordering'

        end if

        call global % remove_log_unit( unit2 )

        if ( global % log_units_assigned() == 2 ) then
            write(*,*) 'Decremented to 2 LOG_UNITS as expected.'

        else
            error stop 'Unexpected change to other than 2 LOG_UNITS.'

        end if
        call global % configuration( log_units=log_units )
        if ( unit1 == log_units(1) .and. unit3 == log_units(2) ) then
            write(*,*) 'Units have their expected placement'

        else
            error stop 'Units do not have their expected placement'

        end if

    end subroutine test_removing_log_units

    subroutine test_adding_log_units()

        print *
        print *, 'running test_adding_log_units'
        call global % add_log_unit( unit2, stat )
        if ( stat == success ) then
            if ( global % log_units_assigned() == 3 ) then
                write(*,*) 'Successfully added unit2 as expected'

            else
                error stop 'Adding unit2 failed to increase log_units to 3.'

            end if

        else
            error stop 'Unexpected problem adding unit2.'

        end if

        call global % add_log_unit( output_unit, stat )
        if ( stat == success ) then
            if ( global % log_units_assigned() == 4 ) then
                write(*,*) 'Successfully added output_unit as expected'

            else
                error stop 'Adding output_unit failed to increase ' // &
                    'log_units to 4.'

            end if

        else
            error stop 'Unexpected problem adding output_unit.'

        end if

        call global % add_log_unit( error_unit, stat )
        if ( stat == success ) then
            if ( global % log_units_assigned() == 5 ) then
                write(*,*) 'Successfully added error_unit as expected'

            else
                error stop 'Adding error_unit failed to increase ' // &
                    'log_units to 5.'

            end if

        else
            error stop 'Unexpected problem adding error_unit.'

        end if

        call global % add_log_unit( input_unit, stat )
        if ( stat /= success ) then
            if ( global % log_units_assigned() == 5 ) then
                write(*,*) 'Failed at adding input_unit as expected'

            else
                error stop 'Unsuccessfully adding input_unit failed to ' // &
                    'keep log_units to 5.'

            end if

        else
            error stop 'Unexpected success adding input_unit.'

        end if

        open( newunit=unit6, file='sixth_log_file.txt', form='formatted', &
            action='read', status='replace', position='rewind' )
        call global % add_log_unit( unit6, stat )
        if ( stat == read_only_error ) then
            write(*,*) 'Adding unit6 failed with a READ_ONLY_ERROR as expected'

        else
            error stop 'Adding unit6 did not fail with a READ_ONLY_ERROR.'

        end if
        close(unit6)
        call global % add_log_unit( unit6, stat )
        if ( stat == unopened_in_error ) then
            write(*,*) 'Adding unit6 failed with a UNOPENED_IN_ERROR as ' // &
                'expected'

        else
            error stop 'Adding unit6 did not fail with a UNOPENED_IN_ERROR.'

        end if
        open( newunit=unit6, file='sixth_log_file.txt', form='unformatted', &
            action='write', status='replace', position='rewind' )
        call global % add_log_unit( unit6, stat )
        if ( stat == unformatted_in_error ) then
            write(*,*) 'Adding unit6 failed with a UNFORMATTED_IN_ERROR ' // &
                'as expected'

        else
            write(*, *) 'STAT = ', stat
            error stop 'Adding unit6 did not fail with a UNFORMATTED_IN_ERROR.'

        end if
        close(unit6)
        open( newunit=unit6, file='sixth_log_file.txt', form='formatted', &
            action='write', status='replace', access='direct', recl=100 )
        call global % add_log_unit( unit6, stat )
        if ( stat == non_sequential_error ) then
            write(*,*) 'Adding unit6 failed with a ' // &
                'NON_SEQUENTIAL_ERROR as expected'

        else
            error stop 'Adding unit6 did not fail with a ' // &
                'NON_SEQUENTIAL_ERROR.'

        end if
        close(unit6)
        open( newunit=unit6, file='sixth_log_file.txt', form='formatted', &
            action='write', status='replace', position='rewind', &
            access='sequential' )
        call global % add_log_unit( unit6, stat )
        if ( stat == success ) then
            if ( global % log_units_assigned() == 6 ) then
                write(*,*) 'Successfully added unit6 as expected'

            else
                error stop 'Adding unit6 failed to increase log_units to 6.'

            end if

        else
            error stop 'Unexpected problem adding unit6.'

        end if

        call global % remove_log_unit( unit6, stat=stat )
        if ( stat /= success ) then
            error stop 'Unexpected problem removing unit6'

        else
            if ( global % log_units_assigned() /= 5 ) then
                error stop 'Removing unit6 did not decrement log_units to 5.'

            else
                write(*,*) 'Successfully removed unit6 as expected.'

            end if

        end if

        call global % remove_log_unit( error_unit, stat=stat )
        if ( stat /= success ) then
            error stop 'Unexpected problem removing error_unit'

        else
            if ( global % log_units_assigned() /= 4 ) then
                error stop 'Removing error_unit did not decrement ' // &
                    'log_units to 4.'

            else
                write(*,*) 'Successfully removed error_unit as expected.'

            end if

        end if

        call global % remove_log_unit( unit3, stat=stat )
        if ( stat /= success ) then
            error stop 'Unexpected problem removing unit3'

        else
            if ( global % log_units_assigned() /= 3 ) then
                error stop 'Removing unit3 did not decrement ' // &
                    'log_units to 3.'

            else
                write(*,*) 'Successfully removed unit3 as expected.'

            end if

        end if

        return
    end subroutine test_adding_log_units

    subroutine test_level()

        print *, 'running test_level'

        call global % configure( level = all_level )

        call global % configuration( level = level )
        if ( level == all_level ) then
            write(*,*) 'LEVEL is all_level as expected.'

        else
            error stop 'LEVEL starts off as not equal to all_level ' //&
            'contrary to expectations.'

        end if

        call global % log_message('This message should be always printed, &
             & irrespective of the severity level')

        call global % log_debug( 'This message should be printed')
        call global % log_information( 'This message should be printed')
        call global % log_warning( 'This message should be printed')
        call global % log_error( 'This message should be printed')
        call global % log_io_error( 'This message should be printed')

        call global % configure( level = debug_level )

        call global % configuration( level = level )
        if ( level == debug_level ) then
            write(*,*) 'LEVEL is debug_level as expected.'

        else
            error stop 'LEVEL starts off as not equal to debug_level ' //&
            'contrary to expectations.'

        end if

        call global % log_message('This message should be always printed, &
             & irrespective of the severity level')

        call global % log_debug( 'This message should be printed')
        call global % log_information( 'This message should be printed')
        call global % log_warning( 'This message should be printed')
        call global % log_error( 'This message should be printed')
        call global % log_io_error( 'This message should be printed')

        call global % configure( level = information_level )

        call global % configuration( level = level )
        if ( level == information_level ) then
            write(*,*) 'LEVEL is information_level as expected.'

        else
            error stop 'LEVEL starts off as not equal to information_level ' //&
            'contrary to expectations.'

        end if

        call global % log_message('This message should be always printed, &
             & irrespective of the severity level')

        call global % log_debug( 'This message should NOT be printed')
        call global % log_information( 'This message should be printed')
        call global % log_warning( 'This message should be printed')
        call global % log_error( 'This message should be printed')
        call global % log_io_error( 'This message should be printed')

        call global % configure( level = warning_level )

        call global % configuration( level = level )
        if ( level == warning_level ) then
            write(*,*) 'LEVEL is warning_level as expected.'

        else
            error stop 'LEVEL starts off as not equal to warning_level ' //&
            'contrary to expectations.'

        end if

        call global % log_message('This message should be always printed, &
             & irrespective of the severity level')

        call global % log_debug( 'This message should NOT be printed')
        call global % log_information( 'This message should NOT be printed')
        call global % log_warning( 'This message should be printed')
        call global % log_error( 'This message should be printed')
        call global % log_io_error( 'This message should be printed')

        call global % configure( level = error_level )

        call global % configuration( level = level )
        if ( level == error_level ) then
            write(*,*) 'LEVEL is error_level as expected.'

        else
            error stop 'LEVEL starts off as not equal to error_level ' //&
            'contrary to expectations.'

        end if

        call global % log_message('This message should be always printed, &
             & irrespective of the severity level')

        call global % log_debug( 'This message should NOT be printed')
        call global % log_information( 'This message should NOT be printed')
        call global % log_warning( 'This message should NOT be printed')
        call global % log_error( 'This message should be printed')
        call global % log_io_error( 'This message should be printed')

        call global % configure( level = none_level )

        call global % configuration( level = level )
        if ( level == none_level ) then
            write(*,*) 'LEVEL is none_level as expected.'

        else
            error stop 'LEVEL starts off as not equal to none_level ' //&
            'contrary to expectations.'

        end if

        call global % log_message('This message should be always printed, &
             & irrespective of the severity level')

        call global % log_debug( 'This message should NOT be printed')
        call global % log_information( 'This message should NOT be printed')
        call global % log_warning( 'This message should NOT be printed')
        call global % log_error( 'This message should NOT be printed')
        call global % log_io_error( 'This message should NOT be printed')

        print *, 'end of test_level'

    end subroutine test_level

end program test_stdlib_logger

program example_solve_cg
    use stdlib_kinds, only: int8, dp
    use stdlib_linalg_iterative_solvers, only: stdlib_solve_cg

    real(dp) :: matrix(2,2)
    real(dp) :: x(2), rhs(2)

    matrix = reshape( [4, 1,&
                       1, 3] , [2,2])

    x   = dble( [2,1] ) !> initial guess
    rhs = dble( [1,2] ) !> rhs vector

    call stdlib_solve_cg(matrix, rhs, x, restart=.false.)
    print *, x !> solution: [0.0909, 0.6364]

end program

program example_nmhash32
  use stdlib_hash_32bit, only: nmhash32, &
                               new_nmhash32_seed
  use iso_fortran_env, only: int32
  implicit none
  integer(int32) :: hash
  integer(int32) :: seed = 42_int32
  call new_nmhash32_seed(seed)
  hash = nmhash32([5, 4, 3, 1, 10, 4, 9], seed)
  print *, seed, hash
end program example_nmhash32

program example_total_depth
  use stdlib_hashmaps, only: chaining_hashmap_type, int_depth
  implicit none
  type(chaining_hashmap_type) :: map
  integer(int_depth) :: initial_depth
  call map%init()
  initial_depth = map%total_depth()
  print *, "Initial total depth =  ", initial_depth
end program example_total_depth

program example_lt
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  logical :: res

  string = "bcd"
  res = string < "abc"
! res .eqv. .false.

  res = string < "bcd"
! res .eqv. .false.

  res = string < "cde"
! res .eqv. .true.
end program example_lt

! Process example 6: Demonstrate callback 
program example_process_6
    use stdlib_system, only: process_type, process_ID, run, is_running, kill, elapsed, is_windows, sleep
    implicit none
    type(process_type) :: p
    integer, target :: nfiles

    ! Run process, attach callback function and some data
    if (is_windows()) then
        p = run("dir",want_stdout=.true.,callback=get_dir_nfiles)
    else
        p = run("ls -l",want_stdout=.true.,callback=get_dir_nfiles,payload=nfiles)
    endif

    ! On exit, the number of files should have been extracted by the callback function
    print *, "Current directory has ",nfiles," files"
    
    contains
        
       ! Custom callback function: retrieve number of files from ls output
       subroutine get_dir_nfiles(pid, exit_state, stdin, stdout, stderr, payload)
           integer(process_ID), intent(in) :: pid
           integer, intent(in) :: exit_state
           character(len=*), optional, intent(in) :: stdin, stdout, stderr
           class(*), optional, intent(inout) :: payload    
           
           integer :: i

           if (present(payload)) then 
            
               select type (nfiles => payload)
                   type is (integer)
                       if (present(stdout)) then 
                           nfiles = count([ (stdout(i:i) == char(10), i=1,len(stdout)) ])
                       else
                           nfiles = -1
                       endif 
                   class default
                       error stop 'Wrong payload passed to the process'
               end select            
            
           end if
       end subroutine get_dir_nfiles     

end program example_process_6

!! The module, STDLIB_HASH_MAPS, implements two hash maps:
!! CHAINING_HASH_MAP_TYPE, a separate chaining hash map; and OPEN_HASH_MAP_TYPE,
!! an open addressing hash map using linear addressing. The two hash maps are
!! implementations of the abstract type, HASH_MAP_TYPE.

module stdlib_hashmaps

    use, intrinsic :: iso_fortran_env, only: &
        character_storage_size,              &
        error_unit

    use stdlib_kinds, only: &
        dp,                 &
        int8,               &
        int16,              &
        int32,              &
        int64

    use stdlib_hashmap_wrappers, only: &
        copy_key,                &
        fibonacci_hash,          &
        default_hasher => fnv_1_hasher,            &
        hasher_fun,              &
        operator(==),            &
        set,                     &
        key_type,                &
        int_hash

    implicit none

    private

!! Public data_types
    public ::                  &
        chaining_hashmap_type, &
        open_hashmap_type

!! Values that parameterize David Chase's empirical SLOT expansion code
    integer, parameter ::        &
        inmap_probe_factor = 10, &
        map_probe_factor   =  5

!! Values that parameterize the SLOTS table size
    integer, parameter, public :: &
        default_bits =  6,        &
        max_bits     = 30

!! KIND values used to parameterixe the hash map and its procedures
    integer, parameter, public :: &
        int_calls  = int64,       &
        int_depth  = int64,       &
        int_index  = int32,       &
        int_probes = int64

!! Error codes returned by the hash map procedures
    integer, parameter, public ::  &
        success = 0,               &
        alloc_fault = 1,           &
        array_size_error = 2

! The number of bits used by various types
    integer, parameter ::             &
! Should be 8
        int8_bits = bit_size(0_int8), &
        char_bits = character_storage_size

!! The hash map load factor
    real, parameter, public ::      &
        load_factor = 0.5625

!! The size of the pools of allocated map entries
    integer(int32), parameter :: pool_size = 64

    character(*), parameter, private :: module_name = 'STDLIB_HASHMAPS'

    type, abstract :: hashmap_type
!! Version: Experimental
!!
!! Type implementing an abstract hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-hashmap_type-abstract-type))
        private
        integer(int_calls) :: call_count = 0
!! Number of calls
        integer(int_calls) :: probe_count = 0
!! Number of probes since last expansion
        integer(int_calls) :: total_probes = 0
!! Cumulative number of probes
        integer(int_index) :: num_entries = 0
!! Number of entries
        integer(int_index) :: num_free = 0
!! Number of elements in the free_list
        integer(int32)     :: nbits = default_bits
!! Number of bits used to address the slots
        procedure(hasher_fun), pointer, nopass :: hasher => default_hasher
!! Hash function
        logical            :: initialized = .false. 
        
    contains
        procedure, non_overridable, pass(map) :: calls
        procedure, non_overridable, pass(map) :: entries
        procedure, non_overridable, pass(map) :: map_probes
        procedure, non_overridable, pass(map) :: num_slots
        procedure, non_overridable, pass(map) :: slots_bits
        procedure(get_all_keys), deferred, pass(map)        :: get_all_keys
        procedure(init_map), deferred, pass(map)            :: init
        procedure(loading), deferred, pass(map)             :: loading
        procedure(rehash_map), deferred, pass(map)          :: rehash
        procedure(total_depth), deferred, pass(map)         :: total_depth
    
        !! Key_test procedures.
        procedure(key_key_test), deferred, pass(map) :: key_key_test
        procedure, non_overridable, pass(map) :: int8_key_test
        procedure, non_overridable, pass(map) :: int32_key_test
        procedure, non_overridable, pass(map) :: char_key_test
        generic, public :: key_test => key_key_test, int8_key_test, int32_key_test, char_key_test
        
        ! Map_entry procedures
        procedure(key_map_entry), deferred, pass(map) :: key_map_entry
        procedure, non_overridable, pass(map) :: int8_map_entry
        procedure, non_overridable, pass(map) :: int32_map_entry
        procedure, non_overridable, pass(map) :: char_map_entry
        generic, public :: map_entry => key_map_entry, int8_map_entry, int32_map_entry, char_map_entry
        
        ! Get_other_data procedures
        procedure(key_get_other_data), deferred, pass(map) :: key_get_other_data
        procedure, non_overridable, pass(map) :: int8_get_other_data
        procedure, non_overridable, pass(map) :: int32_get_other_data
        procedure, non_overridable, pass(map) :: char_get_other_data
        generic, public :: get_other_data => key_get_other_data, int8_get_other_data, int32_get_other_data, char_get_other_data
        
        ! Key_remove_entry procedures
        procedure(key_remove_entry), deferred, pass(map) :: key_remove_entry
        procedure, non_overridable, pass(map) :: int8_remove_entry
        procedure, non_overridable, pass(map) :: int32_remove_entry
        procedure, non_overridable, pass(map) :: char_remove_entry
        generic, public :: remove => key_remove_entry, int8_remove_entry, int32_remove_entry, char_remove_entry
        
        ! Set_other_data procedures
        procedure(key_set_other_data), deferred, pass(map)  :: key_set_other_data
        procedure, non_overridable, pass(map) :: int8_set_other_data
        procedure, non_overridable, pass(map) :: int32_set_other_data
        procedure, non_overridable, pass(map) :: char_set_other_data
        generic, public :: set_other_data => key_set_other_data, int8_set_other_data, int32_set_other_data, char_set_other_data
        
    end type hashmap_type


    abstract interface

        subroutine get_all_keys(map, all_keys)
!! Version: Experimental
!!
!! Returns the all keys contained in a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#get_all_keys-returns-all-the-keys-contained-in-a-map))
!!
!! Arguments:
!!     map - a hash map
!!     all_keys - all the keys contained in a hash map
!
            import hashmap_type, key_type
            class(hashmap_type), intent(in) :: map
            type(key_type), allocatable, intent(out) :: all_keys(:)
        end subroutine get_all_keys

        subroutine key_get_other_data( map, key, other, exists )
!! Version: Experimental
!!
!! Returns the other data associated with the inverse table index
!! Arguments:
!!     map    - a hash map
!!     key    - the key associated with a map entry
!!     other  - the other data associated with the key
!!     exists - a logical flag indicating whether an entry with that key exists
!
            import hashmap_type, key_type
            class(hashmap_type), intent(inout) :: map
            type(key_type), intent(in)         :: key
            class(*), allocatable, intent(out)      :: other
            logical, intent(out), optional     :: exists
        end subroutine key_get_other_data

        subroutine init_map( map,         &
                             hasher,      &
                             slots_bits,  &
                             status )
!! Version: Experimental
!!
!! Routine to allocate an empty map with HASHER as the hash function,
!! 2**SLOTS_BITS initial SIZE(map % slots), SIZE(map % slots) limited to a
!! maximum of 2**MAX_BITS, and with up to LOAD_FACTOR * SIZE(map % slots),
!! map % inverse elements. All fields are initialized.
!! Arguments:
!!     map         - the hash maap to be initialized
!!     hasher      - the hash function to be used to map keys to slots
!!     slots_bits   - the number of bits initially used to map to the slots
!!     status      - an integer error status flag with the allowed values:
!!         success - no problems were found
!!         alloc_fault - map % slots or map % inverse could not be allocated
!!         array_size_error - slots_bits or max_bits is less than
!!             default_bits or greater than strict_max_bits
!!         real_value_error - load_factor is less than 0.375 or greater than
!!             0.875
!
            import hashmap_type, hasher_fun, int32
            class(hashmap_type), intent(out)     :: map
            procedure(hasher_fun), optional      :: hasher
            integer, intent(in), optional         :: slots_bits
            integer(int32), intent(out), optional :: status
        end subroutine init_map

        subroutine key_key_test(map, key, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY exists in the hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#key_test-indicates-whether-key-is-present))
!!
!! Arguments:
!!     map     - the hash map of interest
!!     key     - the key of interest
!!     present - a flag indicating whether key is present in the map
!
            import hashmap_type, key_type
            class(hashmap_type), intent(inout) :: map
            type(key_type), intent(in)         :: key
            logical, intent(out)               :: present
        end subroutine key_key_test
        
                
        pure function loading( map )
!! Version: Experimental
!!
!! Returns the number of entries relative to slots in a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#loading-returns-the-ratio-of-entries-to-slots))
!!
!! Arguments:
!!       map - a hash map
            import hashmap_type
            class(hashmap_type), intent(in) :: map
            real :: loading
        end function loading

        subroutine key_map_entry(map, key, other, conflict)
!! Version: Experimental
!!
!! Inserts an entry into the hash table
!! ([Specifications](../page/specs/stdlib_hashmaps.html#map_entry-inserts-an-entry-into-the-hash-map))
!!
            import hashmap_type, key_type
            class(hashmap_type), intent(inout)     :: map
            type(key_type), intent(in)             :: key
            class(*), intent(in), optional         :: other
            logical, intent(out), optional         :: conflict
        end subroutine key_map_entry

        subroutine rehash_map( map, hasher )
!! Version: Experimental
!!
!! Changes the hashing method of the table entries to that of HASHER.
!! Arguments:
!!     map      the table to be rehashed
!!     hasher the hasher function to be used for the table
!
            import hashmap_type, hasher_fun
            class(hashmap_type), intent(inout) :: map
            procedure(hasher_fun)              :: hasher
        end subroutine rehash_map

        subroutine key_remove_entry(map, key, existed) ! Chase's delent
!! Version: Experimental
!!
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
            import hashmap_type, key_type
            class(hashmap_type), intent(inout) :: map
            type(key_type), intent(in)         :: key
            logical, intent(out), optional     :: existed
        end subroutine key_remove_entry

        subroutine key_set_other_data( map, key, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     key    - the key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!!
!
            import hashmap_type, key_type
            class(hashmap_type), intent(inout) :: map
            type(key_type), intent(in)         :: key
            class(*), intent(in)               :: other
            logical, intent(out), optional     :: exists
        end subroutine key_set_other_data

        function total_depth( map )
!! Version: Experimental
!!
!! Returns the total number of ones based offsets of slot entriesyy from
!! their slot index for a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#total_depth-returns-the-total-depth-of-the-hash-map-entries))
!! Arguments:
!!     map - a hash map
            import hashmap_type, int64
            class(hashmap_type), intent(in) :: map
            integer(int64)                  :: total_depth
        end function total_depth

    end interface

!! API for the chaining_hashmap_type

    type :: chaining_map_entry_type  ! Hash entry
!! Version: Experimental
!!
!! Chaining hash map entry type
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-chaining_map_entry_type-derived-type))
        private
        integer(int_hash)  :: hash_val
!! Full hash value
        type(key_type)     :: key
!! The entry's key
        class(*), allocatable :: other
!! Other entry data
        integer(int_index) :: inmap
!! Index into inverse table
        type(chaining_map_entry_type), pointer :: next => null()
!! Next bucket
    end type chaining_map_entry_type


    type chaining_map_entry_ptr
!! Version: Experimental
!!
!! Wrapper for a pointer to a chaining map entry type object
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-chaining_map_entry_type_ptr-derived-type))
        type(chaining_map_entry_type), pointer :: target => null()
    end type chaining_map_entry_ptr


    type :: chaining_map_entry_pool
!! Version: Experimental
!!
!! Type implementing a pool of allocated `chaining_map_entry_type`
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-chaining_map_entry_pool-derived-type))
        private
! Index of next bucket
        integer(int_index)                         :: next = 0
        type(chaining_map_entry_type), allocatable :: more_map_entries(:)
        type(chaining_map_entry_pool), pointer     :: lastpool => null()
    end type chaining_map_entry_pool


    type, extends(hashmap_type) :: chaining_hashmap_type
!! Version: Experimental
!!
!! Type implementing the `chaining_hashmap_type` types
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-chaining_hashmap_type-derived-type))
        private
        type(chaining_map_entry_pool), pointer    :: cache => null()
!! Pool of allocated chaining_map_entry_type objects
        type(chaining_map_entry_type), pointer    :: free_list => null()
!! free list of map entries
        type(chaining_map_entry_ptr), allocatable :: inverse(:)
!! Array of bucket lists (inverses) Note max_elts=size(inverse)
        type(chaining_map_entry_ptr), allocatable :: slots(:)
!! Array of bucket lists Note # slots=size(slots)
    contains
        procedure :: get_all_keys => get_all_chaining_keys
        procedure :: key_get_other_data => get_other_chaining_data
        procedure :: init => init_chaining_map
        procedure :: loading => chaining_loading
        procedure :: key_map_entry => map_chain_entry
        procedure :: rehash => rehash_chaining_map
        procedure :: key_remove_entry => remove_chaining_entry
        procedure :: key_set_other_data => set_other_chaining_data
        procedure :: total_depth => total_chaining_depth
        procedure :: key_key_test => chaining_key_test
        final     :: free_chaining_map
    end type chaining_hashmap_type


    interface

        module subroutine free_chaining_map( map )
!! Version: Experimental
!!
!! Frees internal memory of an chaining map
!! Arguments:
!!     map - the chaining hash map whose memory is to be freed
!
            type(chaining_hashmap_type), intent(inout) :: map
        end subroutine free_chaining_map


        module subroutine get_all_chaining_keys(map, all_keys)
!! Version: Experimental
!!
!! Returns all the keys contained in a hashmap
!! Arguments:
!!     map - an chaining hash map
!!     all_keys - all the keys contained in a hash map
!
            class(chaining_hashmap_type), intent(in) :: map
            type(key_type), allocatable, intent(out) :: all_keys(:)
        end subroutine get_all_chaining_keys


        module subroutine get_other_chaining_data( map, key, other, exists )
!! Version: Experimental
!!
!! Returns the other data associated with the inverse table index
!! Arguments:
!!     map   - a chaining hash table
!!     key   - the key associated with a map entry
!!     other - the other data associated with the key
!!     exists - a logical flag indicating whether an entry with that key exists
!
            class(chaining_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)                  :: key
            class(*), allocatable, intent(out)          :: other
            logical, intent(out), optional              :: exists
        end subroutine get_other_chaining_data


        module subroutine init_chaining_map( map,       &
                                             hasher,    &
                                             slots_bits, &
                                             status )
!! Version: Experimental
!!
!! Routine to allocate an empty map with HASHER as the hash function,
!! 2**SLOTS_BITS initial SIZE(map % slots), and SIZE(map % slots) limited
!! to a maximum of 2**MAX_BITS. All fields are initialized.
!! Arguments:
!!     map       - the chaining hash map to be initialized
!!     hasher    - the hash function to be used to map keys to slots
!!     slots_bits - the bits of two used to initialize the number of slots
!!     status    - an integer error status flag with the allowed values:
!!         success - no problems were found
!!         alloc_fault - map % slots or map % inverse could not be allocated
!!         array_size_error - slots_bits is less than default_bits or
!!             greater than max_bits
!
            class(chaining_hashmap_type), intent(out)  :: map
            procedure(hasher_fun), optional            :: hasher
            integer, intent(in), optional              :: slots_bits
            integer(int32), intent(out), optional      :: status
        end subroutine init_chaining_map


        module subroutine chaining_key_test(map, key, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY is present in the hash map
!! Arguments:
!!     map     - the hash map of interest
!!     key     - the key of interest
!!     present - a logical flag indicating whether key is present in map
!
            class(chaining_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)                  :: key
            logical, intent(out)                        :: present
        end subroutine chaining_key_test


        pure module function chaining_loading( map )
!! Version: Experimental
!!
!! Returns the number of entries relative to slots in a hash map
!! Arguments:
!!      map - a chaining hash map
            class(chaining_hashmap_type), intent(in) :: map
            real :: chaining_loading
        end function chaining_loading


        module subroutine map_chain_entry(map, key, other, conflict)
!
!     Inserts an entry innto the hash map
!     Arguments:
!!      map      - the hash table of interest
!!      key      - the key identifying the entry
!!      other    - other data associated with the key
!!      conflict - logical flag indicating whether the entry key conflicts
!!                 with an existing key
!
            class(chaining_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)             :: key
            class(*), intent(in), optional         :: other
            logical, intent(out), optional         :: conflict
        end subroutine map_chain_entry


        module subroutine rehash_chaining_map( map, hasher )
!! Version: Experimental
!!
!! Changes the hashing method of the table entries to that of HASHER.
!! Arguments:
!!     map    the table to be rehashed
!!     hasher the hasher function to be used for the table
!
            class(chaining_hashmap_type), intent(inout) :: map
            procedure(hasher_fun)                       :: hasher
        end subroutine rehash_chaining_map


        module subroutine remove_chaining_entry(map, key, existed)
!! Version: Experimental
!!
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
            class(chaining_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)                  :: key
            logical, intent(out), optional              :: existed
        end subroutine remove_chaining_entry


        module subroutine set_other_chaining_data( map, key, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     key    - the key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!
            class(chaining_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)                  :: key
            class(*), intent(in)                        :: other
            logical, intent(out), optional              :: exists
        end subroutine set_other_chaining_data


        module function total_chaining_depth( map ) result(total_depth)
!! Version: Experimental
!!
!! Returns the total number of ones based offsets of slot entries from
!! their slot index for a hash map
!! Arguments:
!!     map - an chaining hash map
            class(chaining_hashmap_type), intent(in) :: map
            integer(int_depth)                       :: total_depth
        end function total_chaining_depth

    end interface

!! API for the open_hashmap_type

    type :: open_map_entry_type
!! Version: Experimental
!!
!! Open hash map entry type
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-open_map_entry_type-derived-type))
        private
        integer(int_hash) :: hash_val
!! Full hash value
        type(key_type)    :: key
!! Hash entry key
        class(*), allocatable :: other
!! Other entry data
        integer(int_index) :: inmap
!! Index into inverse table
    end type open_map_entry_type

    type :: open_map_entry_list
!! Version: Experimental
!!
!! Open hash map entry type
        private
        type(open_map_entry_type), pointer :: target => null()
        type(open_map_entry_list), pointer :: next => null()
    end type open_map_entry_list


    type open_map_entry_ptr
!! Version: Experimental
!!
!! Wrapper for a pointer to an open hash map entry type object
!! ([Specifications](../page/specs/stdlib_hashmaps.html#the-open_map_entry_ptr-derived-type))
        type(open_map_entry_type), pointer :: target => null()
    end type open_map_entry_ptr


    type :: open_map_entry_pool
!! Version: Experimental
!!
!! Type implementing a pool of allocated `open_map_entry_type`
        private
        integer(int_index)                     :: next = 0
!! Index of next bucket
        type(open_map_entry_type), allocatable :: more_map_entries(:)
        type(open_map_entry_pool), pointer     :: lastpool => null()
    end type open_map_entry_pool


    type, extends(hashmap_type) :: open_hashmap_type
!! Version: Experimental
!!
!! Type implementing an "open" hash map
        private
        integer(int_index) :: index_mask = 2_int_index**default_bits-1
!! Mask used in linear addressing
        type(open_map_entry_pool), pointer    :: cache => null()
!! Pool of allocated open_map_entry_type objects
        type(open_map_entry_list), pointer    :: free_list => null()
!! free list of map entries
        type(open_map_entry_ptr), allocatable  :: inverse(:)
!! Array of bucket lists (inverses) Note max_elts=size(inverse)
        integer(int_index), allocatable        :: slots(:)
!! Array of indices to the inverse Note # slots=size(slots)
    contains
        procedure :: get_all_keys => get_all_open_keys
        procedure :: key_get_other_data => get_other_open_data
        procedure :: init => init_open_map
        procedure :: loading => open_loading
        procedure :: key_map_entry => map_open_entry
        procedure :: rehash => rehash_open_map
        procedure :: key_remove_entry => remove_open_entry
        procedure :: key_set_other_data => set_other_open_data
        procedure :: total_depth => total_open_depth
        procedure :: key_key_test => open_key_test
        final     :: free_open_map
    end type open_hashmap_type

    interface

        module subroutine free_open_map( map )
!! Version: Experimental
!!
!! Frees internal memory of an open map
!! Arguments:
!!     map - the open hash map whose memory is to be freed
!
            type(open_hashmap_type), intent(inout) :: map
        end subroutine free_open_map


        module subroutine get_all_open_keys(map, all_keys)
!! Version: Experimental
!!
!! Returns all the keys contained in a hashmap
!! Arguments:
!!     map - an open hash map
!!     all_keys - all the keys contained in a hash map
!
            class(open_hashmap_type), intent(in) :: map
            type(key_type), allocatable, intent(out) :: all_keys(:)
        end subroutine get_all_open_keys


        module subroutine get_other_open_data( map, key, other, exists )
!! Version: Experimental
!!
!! Returns the other data associated with the inverse table index
!! Arguments:
!!     map   - an open hash table
!!     key   - the key associated with a map entry
!!     other - the other data associated with the key
!!     exists - a logical flag indicating whether an entry with that key exists
!
            class(open_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)              :: key
            class(*), allocatable, intent(out)      :: other
            logical, intent(out), optional          :: exists
        end subroutine get_other_open_data


        module subroutine init_open_map( map,         &
                                         hasher,      &
                                         slots_bits,  &
                                         status )
!! Version: Experimental
!!
!! Routine to allocate an empty map with HASHER as the hash function,
!! 2**SLOTS_BITS initial SIZE(map % slots), and SIZE(map % slots) limited to a
!! maximum of 2**MAX_BITS. All fields are initialized.
!! Arguments:
!!     map         - the open hash maap to be initialized
!!     hasher      - the hash function to be used to map keys to slots
!!     slots_bits  - the number of bits used to map to the slots
!!     status      - an integer error status flag with the allowed values:
!!         success - no problems were found
!!         alloc_fault - map % slots or map % inverse could not be allocated
!!         array_size_error - slots_bits is less than default_bitd or
!!             greater than max_bits

            class(open_hashmap_type), intent(out)      :: map
            procedure(hasher_fun), optional            :: hasher
            integer, intent(in), optional              :: slots_bits
            integer(int32), intent(out), optional      :: status
        end subroutine init_open_map


        module subroutine open_key_test(map, key, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY exists in the hash map
!! Arguments:
!!     map     - the hash map of interest
!!     key     - the key of interest
!!     present - a logical flag indicating whether KEY exists in the hash map
!
            class(open_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)              :: key
            logical, intent(out)                    :: present
        end subroutine open_key_test


        pure module function open_loading( map )
!! Version: Experimental
!!
!! Returns the number of entries relative to slots in a hash map
!! Arguments:
!!       map - an open hash map
            class(open_hashmap_type), intent(in) :: map
            real :: open_loading
        end function open_loading


        module subroutine map_open_entry(map, key, other, conflict)
!! Version: Experimental
!!
!! Inserts an entry into the hash table
!! Arguments:
!!     map      - the hash table of interest
!!     key      - the key identifying the entry
!!     other    - other data associated with the key
!!     conflict - logical flag indicating whether the entry key conflicts
!!                 with an existing key
!
            class(open_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)              :: key
            class(*), intent(in), optional          :: other
            logical, intent(out), optional          :: conflict
        end subroutine map_open_entry


        module subroutine rehash_open_map( map, hasher )
!! Version: Experimental
!!
!! Changes the hashing method of the table entries to that of HASHER.
!! Arguments:
!!     map      the table to be rehashed
!!     hasher the hasher function to be used for the table
!
            class(open_hashmap_type), intent(inout) :: map
            procedure(hasher_fun)                   :: hasher
        end subroutine rehash_open_map


        module subroutine remove_open_entry(map, key, existed)
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
            class(open_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)              :: key
            logical, intent(out), optional          :: existed
        end subroutine remove_open_entry


        module subroutine set_other_open_data( map, key, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     key    - the key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!
            class(open_hashmap_type), intent(inout) :: map
            type(key_type), intent(in)              :: key
            class(*), intent(in)                    :: other
            logical, intent(out), optional          :: exists
        end subroutine set_other_open_data


        module function total_open_depth( map ) result(total_depth)
!! Version: Experimental
!!
!! Returns the total number of ones based offsets of slot entries from
!! their slot index for a hash map
!! Arguments:
!!     map - an open hash map
            class(open_hashmap_type), intent(in) :: map
            integer(int64) :: total_depth
        end function total_open_depth

    end interface

    
    contains
    
    
        subroutine int8_get_other_data( map, value, other, exists )
!! Version: Experimental
!!
!! Int8 key generic interface for get_other_data function

            class(hashmap_type), intent(inout) :: map
            integer(int8), intent(in)          :: value(:)
            class(*), allocatable, intent(out) :: other
            logical, intent(out), optional     :: exists
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_get_other_data( key, other, exists )
            
        end subroutine int8_get_other_data
        
        
        subroutine int32_get_other_data( map, value, other, exists )
!! Version: Experimental
!!
!! Int32 key generic interface for get_other_data function

            class(hashmap_type), intent(inout) :: map
            integer(int32), intent(in)         :: value(:)
            class(*), allocatable, intent(out) :: other
            logical, intent(out), optional     :: exists
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_get_other_data( key, other, exists )
            
        end subroutine int32_get_other_data

        
        subroutine char_get_other_data( map, value, other, exists )
!! Version: Experimental
!!
!! Character key generic interface for get_other_data function

            class(hashmap_type), intent(inout) :: map
            character(*), intent(in)           :: value
            class(*), allocatable, intent(out) :: other
            logical, intent(out), optional     :: exists
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_get_other_data( key, other, exists )
            
        end subroutine char_get_other_data
        
        
        subroutine int8_remove_entry(map, value, existed) ! Chase's delent
!! Version: Experimental
!!
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    value   - the int8 array key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
            class(hashmap_type), intent(inout) :: map
            integer(int8), intent(in)          :: value(:)
            logical, intent(out), optional     :: existed
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_remove_entry( key, existed )
            
        end subroutine int8_remove_entry
    
        
        subroutine int32_remove_entry(map, value, existed) ! Chase's delent
!! Version: Experimental
!!
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
            class(hashmap_type), intent(inout) :: map
            integer(int32), intent(in)         :: value(:)
            logical, intent(out), optional     :: existed
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_remove_entry( key, existed )
            
        end subroutine int32_remove_entry
    
        
        subroutine char_remove_entry(map, value, existed) ! Chase's delent
!! Version: Experimental
!!
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
            class(hashmap_type), intent(inout) :: map
            character(*), intent(in)           :: value
            logical, intent(out), optional     :: existed
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_remove_entry( key, existed )
            
        end subroutine char_remove_entry
        
        
        subroutine int8_map_entry(map, value, other, conflict)
    !! Version: Experimental
    !! Int8 generic interface for map entry
    !! ([Specifications](../page/specs/stdlib_hashmaps.html#map_entry-inserts-an-entry-into-the-hash-map))
    !!
                class(hashmap_type), intent(inout)     :: map
                integer(int8), intent(in)              :: value(:)
                class(*), intent(in), optional         :: other
                logical, intent(out), optional         :: conflict
            
                type(key_type)                         :: key
            
                call set( key, value )
            
                call map % key_map_entry( key, other, conflict )
            
        end subroutine int8_map_entry
        
        
        subroutine int32_map_entry(map, value, other, conflict)
!! Version: Experimental
!!
!! Inserts an entry into the hash table
!! ([Specifications](../page/specs/stdlib_hashmaps.html#map_entry-inserts-an-entry-into-the-hash-map))
!!
            class(hashmap_type), intent(inout)     :: map
            integer(int32), intent(in)             :: value(:)
            class(*), intent(in), optional         :: other
            logical, intent(out), optional         :: conflict
            
            type(key_type)                         :: key
            
            call set( key, value )
            
            call map % key_map_entry( key, other, conflict )
            
        end subroutine int32_map_entry
    
    
        subroutine char_map_entry(map, value, other, conflict)
!! Version: Experimental
!!
!! Inserts an entry into the hash table
!! ([Specifications](../page/specs/stdlib_hashmaps.html#map_entry-inserts-an-entry-into-the-hash-map))
!!
            class(hashmap_type), intent(inout)     :: map
            character(len=*), intent(in)           :: value
            class(*), intent(in), optional         :: other
            logical, intent(out), optional         :: conflict
            
            type(key_type)                         :: key
            
            call set( key, value )
            
            call map % key_map_entry( key, other, conflict )
            
        end subroutine char_map_entry
    
        
        subroutine int8_key_test(map, value, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY exists in the hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#key_test-indicates-whether-key-is-present))
!!
!! Arguments:
!!     map     - the hash map of interest
!!     value     - int8 array that is the key to lookup.  
!!     present - a flag indicating whether key is present in the map
!
            class(hashmap_type), intent(inout) :: map
            integer(int8), intent(in)          :: value(:)
            logical, intent(out)               :: present
            
            type(key_type)                     :: key
            
            ! Generate key from int8 array.
            call set( key, value )
            
            ! Call key test procedure.
            call map % key_key_test( key, present )

        end subroutine int8_key_test
    
    
        subroutine int32_key_test(map, value, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY exists in the hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#key_test-indicates-whether-key-is-present))
!!
!! Arguments:
!!     map     - the hash map of interest
!!     value     - int32 array that is the key to lookup.  
!!     present - a flag indicating whether key is present in the map
!
            class(hashmap_type), intent(inout) :: map
            integer(int32), intent(in)         :: value(:)
            logical, intent(out)               :: present
            
            type(key_type)                     :: key
            
            call set( key, value )

            call map % key_key_test( key, present )

        end subroutine int32_key_test
    
    
        subroutine char_key_test(map, value, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY exists in the hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#key_test-indicates-whether-key-is-present))
!!
!! Arguments:
!!     map     - the hash map of interest
!!     value     - char array that is the key to lookup.  
!!     present - a flag indicating whether key is present in the map
!
            class(hashmap_type), intent(inout) :: map
            character(*), intent(in)           :: value
            logical, intent(out)               :: present
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_key_test( key, present )

        end subroutine char_key_test
        
        
        subroutine int8_set_other_data( map, value, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     value  - the int8 array key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!!
!
            class(hashmap_type), intent(inout) :: map
            integer(int8), intent(in)          :: value(:)
            class(*), intent(in)               :: other
            logical, intent(out), optional     :: exists
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_set_other_data( key, other, exists )
            
        end subroutine int8_set_other_data
    
        
        subroutine int32_set_other_data( map, value, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     value  - the int32 array key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!!
!
            class(hashmap_type), intent(inout) :: map
            integer(int32), intent(in)         :: value(:)
            class(*), intent(in)               :: other
            logical, intent(out), optional     :: exists
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_set_other_data( key, other, exists )
            
        end subroutine int32_set_other_data
    
        
        subroutine char_set_other_data( map, value, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     value  - the char value key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!!
!
            class(hashmap_type), intent(inout) :: map
            character(*), intent(in)           :: value
            class(*), intent(in)               :: other
            logical, intent(out), optional     :: exists
            
            type(key_type)                     :: key
            
            call set( key, value )
            
            call map % key_set_other_data( key, other, exists )
            
        end subroutine char_set_other_data
                
                
        pure function calls( map )
!! Version: Experimental
!!
!! Returns the number of subroutine calls on an open hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#calls-returns-the-number-of-calls-on-the-hash-map))
!!
!! Arguments:
!!     map - an open hash map
            class(hashmap_type), intent(in) :: map
            integer(int_calls)              :: calls

            calls = map % call_count

        end function calls

        pure function entries( map )
!! Version: Experimental
!!
!! Returns the number of entries in a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#entries-returns-the-number-of-entries-in-the-hash-map))
!!
!! Arguments:
!!     map - an open hash map
            class(hashmap_type), intent(in) :: map
            integer(int_index) :: entries

            entries = map % num_entries

        end function entries


        pure function map_probes( map )
!! Version: Experimental
!!
!! Returns the total number of table probes on a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#map_probes-returns-the-number-of-hash-map-probes))
!!
!! Arguments:
!!     map - an open hash map
            class(hashmap_type), intent(in) :: map
            integer(int_calls) :: map_probes

            map_probes = map % total_probes + map % probe_count

        end function map_probes


        pure function num_slots( map )
!! Version: Experimental
!!
!! Returns the number of allocated slots in a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#num_slots-returns-the-number-of-hash-map-slots))
!!
!! Arguments:
!!     map - an open hash map
            class(hashmap_type), intent(in) :: map
            integer(int_index)              :: num_slots

            num_slots = 2**map % nbits

        end function num_slots


        pure function slots_bits( map )
!! Version: Experimental
!!
!! Returns the number of bits used to specify the number of allocated
!! slots in a hash map
!! ([Specifications](../page/specs/stdlib_hashmaps.html#slots_bits-returns-the-number-of-bits-used-to-address-the-hash-map-slots))
!!
!! Arguments:
!!     map - an open hash map
            class(hashmap_type), intent(in) :: map
            integer                         :: slots_bits

            slots_bits = map % nbits

        end function slots_bits


end module stdlib_hashmaps

program example_clip_integer
  use stdlib_math, only: clip
  use stdlib_kinds, only: int32
  implicit none
  integer(int32) :: x
  integer(int32) :: xmin
  integer(int32) :: xmax
  integer(int32) :: clipped_value

  xmin = -5_int32
  xmax = 5_int32
  x = 12_int32

  clipped_value = clip(x, xmin, xmax)
! clipped_value <- 5
end program example_clip_integer

program example_sparse_spmv
    use stdlib_linalg_constants, only: dp
    use stdlib_sparse
    implicit none

    integer, parameter :: m = 4, n = 2
    real(dp) :: A(m,n), x(n)
    real(dp) :: y_dense(m), y_coo(m), y_csr(m)
    real(dp) :: alpha, beta
    type(COO_dp_type) :: COO
    type(CSR_dp_type) :: CSR

    call random_number(A)
    ! Convert from dense to COO and CSR matrices
    call dense2coo( A , COO )
    call coo2csr( COO , CSR )
    
    ! Initialize vectors
    x       = 1._dp
    y_dense = 2._dp
    y_coo   = y_dense
    y_csr   = y_dense

    ! Perform matrix-vector product
    alpha = 3._dp; beta = 2._dp
    y_dense = alpha * matmul(A,x) + beta * y_dense
    call spmv( COO , x , y_coo , alpha = alpha, beta = beta )
    call spmv( CSR , x , y_csr , alpha = alpha, beta = beta )
    
    print *, 'dense :', y_dense
    print *, 'coo   :', y_coo
    print *, 'csr   :', y_csr
  
end program example_sparse_spmv

program example_clip_real
  use stdlib_math, only: clip
  use stdlib_kinds, only: sp
  implicit none
  real(sp) :: x
  real(sp) :: xmin
  real(sp) :: xmax
  real(sp) :: clipped_value

  xmin = -5.769_sp
  xmax = 3.025_sp
  x = 3.025_sp

  clipped_value = clip(x, xmin, xmax)
! clipped_value <- 3.02500010
end program example_clip_real

module stdlib_codata
    !! Codata Constants - Autogenerated
    use stdlib_kinds, only: dp, int32
    use stdlib_codata_type
    private

integer(int32), parameter, public :: YEAR = 2022 !! Year of release.

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_ELECTRON_MASS_RATIO = &
codata_constant_type("alpha particle-electron mass ratio", &
7294.29954171_dp, 0.00000017_dp, &
"") !! alpha particle-electron mass ratio

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_MASS = &
codata_constant_type("alpha particle mass", &
6.6446573450e-27_dp, 0.0000000021e-27_dp, &
"kg") !! alpha particle mass

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("alpha particle mass energy equivalent", &
5.9719201997e-10_dp, 0.0000000019e-10_dp, &
"J") !! alpha particle mass energy equivalent

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("alpha particle mass energy equivalent in MeV", &
3727.3794118_dp, 0.0000012_dp, &
"MeV") !! alpha particle mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_MASS_IN_U = &
codata_constant_type("alpha particle mass in u", &
4.001506179129_dp, 0.000000000062_dp, &
"u") !! alpha particle mass in u

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_MOLAR_MASS = &
codata_constant_type("alpha particle molar mass", &
4.0015061833e-3_dp, 0.0000000012e-3_dp, &
"kg mol^-1") !! alpha particle molar mass

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_PROTON_MASS_RATIO = &
codata_constant_type("alpha particle-proton mass ratio", &
3.972599690252_dp, 0.000000000070_dp, &
"") !! alpha particle-proton mass ratio

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_RELATIVE_ATOMIC_MASS = &
codata_constant_type("alpha particle relative atomic mass", &
4.001506179129_dp, 0.000000000062_dp, &
"") !! alpha particle relative atomic mass

type(codata_constant_type), parameter, public :: ALPHA_PARTICLE_RMS_CHARGE_RADIUS = &
codata_constant_type("alpha particle rms charge radius", &
1.6785e-15_dp, 0.0021e-15_dp, &
"m") !! alpha particle rms charge radius

type(codata_constant_type), parameter, public :: ANGSTROM_STAR = &
codata_constant_type("Angstrom star", &
1.00001495e-10_dp, 0.00000090e-10_dp, &
"m") !! Angstrom star

type(codata_constant_type), parameter, public :: ATOMIC_MASS_CONSTANT = &
codata_constant_type("atomic mass constant", &
1.66053906892e-27_dp, 0.00000000052e-27_dp, &
"kg") !! atomic mass constant

type(codata_constant_type), parameter, public :: ATOMIC_MASS_CONSTANT_ENERGY_EQUIVALENT = &
codata_constant_type("atomic mass constant energy equivalent", &
1.49241808768e-10_dp, 0.00000000046e-10_dp, &
"J") !! atomic mass constant energy equivalent

type(codata_constant_type), parameter, public :: ATOMIC_MASS_CONSTANT_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("atomic mass constant energy equivalent in MeV", &
931.49410372_dp, 0.00000029_dp, &
"MeV") !! atomic mass constant energy equivalent in MeV

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("atomic mass unit-electron volt relationship", &
9.3149410372e8_dp, 0.0000000029e8_dp, &
"eV") !! atomic mass unit-electron volt relationship

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_HARTREE_RELATIONSHIP = &
codata_constant_type("atomic mass unit-hartree relationship", &
3.4231776922e7_dp, 0.0000000011e7_dp, &
"E_h") !! atomic mass unit-hartree relationship

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_HERTZ_RELATIONSHIP = &
codata_constant_type("atomic mass unit-hertz relationship", &
2.25234272185e23_dp, 0.00000000070e23_dp, &
"Hz") !! atomic mass unit-hertz relationship

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("atomic mass unit-inverse meter relationship", &
7.5130066209e14_dp, 0.0000000023e14_dp, &
"m^-1") !! atomic mass unit-inverse meter relationship

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_JOULE_RELATIONSHIP = &
codata_constant_type("atomic mass unit-joule relationship", &
1.49241808768e-10_dp, 0.00000000046e-10_dp, &
"J") !! atomic mass unit-joule relationship

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_KELVIN_RELATIONSHIP = &
codata_constant_type("atomic mass unit-kelvin relationship", &
1.08095402067e13_dp, 0.00000000034e13_dp, &
"K") !! atomic mass unit-kelvin relationship

type(codata_constant_type), parameter, public :: ATOMIC_MASS_UNIT_KILOGRAM_RELATIONSHIP = &
codata_constant_type("atomic mass unit-kilogram relationship", &
1.66053906892e-27_dp, 0.00000000052e-27_dp, &
"kg") !! atomic mass unit-kilogram relationship

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_1ST_HYPERPOLARIZABILITY = &
codata_constant_type("atomic unit of 1st hyperpolarizability", &
3.2063612996e-53_dp, 0.0000000015e-53_dp, &
"C^3 m^3 J^-2") !! atomic unit of 1st hyperpolarizability

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_2ND_HYPERPOLARIZABILITY = &
codata_constant_type("atomic unit of 2nd hyperpolarizability", &
6.2353799735e-65_dp, 0.0000000039e-65_dp, &
"C^4 m^4 J^-3") !! atomic unit of 2nd hyperpolarizability

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ACTION = &
codata_constant_type("atomic unit of action", &
1.054571817e-34_dp, 0.0_dp, &
"J s") !! atomic unit of action

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_CHARGE = &
codata_constant_type("atomic unit of charge", &
1.602176634e-19_dp, 0.0_dp, &
"C") !! atomic unit of charge

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_CHARGE_DENSITY = &
codata_constant_type("atomic unit of charge density", &
1.08120238677e12_dp, 0.00000000051e12_dp, &
"C m^-3") !! atomic unit of charge density

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_CURRENT = &
codata_constant_type("atomic unit of current", &
6.6236182375082e-3_dp, 0.0000000000072e-3_dp, &
"A") !! atomic unit of current

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ELECTRIC_DIPOLE_MOM = &
codata_constant_type("atomic unit of electric dipole mom.", &
8.4783536198e-30_dp, 0.0000000013e-30_dp, &
"C m") !! atomic unit of electric dipole mom.

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ELECTRIC_FIELD = &
codata_constant_type("atomic unit of electric field", &
5.14220675112e11_dp, 0.00000000080e11_dp, &
"V m^-1") !! atomic unit of electric field

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ELECTRIC_FIELD_GRADIENT = &
codata_constant_type("atomic unit of electric field gradient", &
9.7173624424e21_dp, 0.0000000030e21_dp, &
"V m^-2") !! atomic unit of electric field gradient

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ELECTRIC_POLARIZABILITY = &
codata_constant_type("atomic unit of electric polarizability", &
1.64877727212e-41_dp, 0.00000000051e-41_dp, &
"C^2 m^2 J^-1") !! atomic unit of electric polarizability

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ELECTRIC_POTENTIAL = &
codata_constant_type("atomic unit of electric potential", &
27.211386245981_dp, 0.000000000030_dp, &
"V") !! atomic unit of electric potential

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ELECTRIC_QUADRUPOLE_MOM = &
codata_constant_type("atomic unit of electric quadrupole mom.", &
4.4865515185e-40_dp, 0.0000000014e-40_dp, &
"C m^2") !! atomic unit of electric quadrupole mom.

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_ENERGY = &
codata_constant_type("atomic unit of energy", &
4.3597447222060e-18_dp, 0.0000000000048e-18_dp, &
"J") !! atomic unit of energy

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_FORCE = &
codata_constant_type("atomic unit of force", &
8.2387235038e-8_dp, 0.0000000013e-8_dp, &
"N") !! atomic unit of force

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_LENGTH = &
codata_constant_type("atomic unit of length", &
5.29177210544e-11_dp, 0.00000000082e-11_dp, &
"m") !! atomic unit of length

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_MAG_DIPOLE_MOM = &
codata_constant_type("atomic unit of mag. dipole mom.", &
1.85480201315e-23_dp, 0.00000000058e-23_dp, &
"J T^-1") !! atomic unit of mag. dipole mom.

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_MAG_FLUX_DENSITY = &
codata_constant_type("atomic unit of mag. flux density", &
2.35051757077e5_dp, 0.00000000073e5_dp, &
"T") !! atomic unit of mag. flux density

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_MAGNETIZABILITY = &
codata_constant_type("atomic unit of magnetizability", &
7.8910365794e-29_dp, 0.0000000049e-29_dp, &
"J T^-2") !! atomic unit of magnetizability

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_MASS = &
codata_constant_type("atomic unit of mass", &
9.1093837139e-31_dp, 0.0000000028e-31_dp, &
"kg") !! atomic unit of mass

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_MOMENTUM = &
codata_constant_type("atomic unit of momentum", &
1.99285191545e-24_dp, 0.00000000031e-24_dp, &
"kg m s^-1") !! atomic unit of momentum

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_PERMITTIVITY = &
codata_constant_type("atomic unit of permittivity", &
1.11265005620e-10_dp, 0.00000000017e-10_dp, &
"F m^-1") !! atomic unit of permittivity

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_TIME = &
codata_constant_type("atomic unit of time", &
2.4188843265864e-17_dp, 0.0000000000026e-17_dp, &
"s") !! atomic unit of time

type(codata_constant_type), parameter, public :: ATOMIC_UNIT_OF_VELOCITY = &
codata_constant_type("atomic unit of velocity", &
2.18769126216e6_dp, 0.00000000034e6_dp, &
"m s^-1") !! atomic unit of velocity

type(codata_constant_type), parameter, public :: AVOGADRO_CONSTANT = &
codata_constant_type("Avogadro constant", &
6.02214076e23_dp, 0.0_dp, &
"mol^-1") !! Avogadro constant

type(codata_constant_type), parameter, public :: BOHR_MAGNETON = &
codata_constant_type("Bohr magneton", &
9.2740100657e-24_dp, 0.0000000029e-24_dp, &
"J T^-1") !! Bohr magneton

type(codata_constant_type), parameter, public :: BOHR_MAGNETON_IN_EV_T = &
codata_constant_type("Bohr magneton in eV/T", &
5.7883817982e-5_dp, 0.0000000018e-5_dp, &
"eV T^-1") !! Bohr magneton in eV/T

type(codata_constant_type), parameter, public :: BOHR_MAGNETON_IN_HZ_T = &
codata_constant_type("Bohr magneton in Hz/T", &
1.39962449171e10_dp, 0.00000000044e10_dp, &
"Hz T^-1") !! Bohr magneton in Hz/T

type(codata_constant_type), parameter, public :: BOHR_MAGNETON_IN_INVERSE_METER_PER_TESLA = &
codata_constant_type("Bohr magneton in inverse meter per tesla", &
46.686447719_dp, 0.000000015_dp, &
"m^-1 T^-1") !! Bohr magneton in inverse meter per tesla

type(codata_constant_type), parameter, public :: BOHR_MAGNETON_IN_K_T = &
codata_constant_type("Bohr magneton in K/T", &
0.67171381472_dp, 0.00000000021_dp, &
"K T^-1") !! Bohr magneton in K/T

type(codata_constant_type), parameter, public :: BOHR_RADIUS = &
codata_constant_type("Bohr radius", &
5.29177210544e-11_dp, 0.00000000082e-11_dp, &
"m") !! Bohr radius

type(codata_constant_type), parameter, public :: BOLTZMANN_CONSTANT = &
codata_constant_type("Boltzmann constant", &
1.380649e-23_dp, 0.0_dp, &
"J K^-1") !! Boltzmann constant

type(codata_constant_type), parameter, public :: BOLTZMANN_CONSTANT_IN_EV_K = &
codata_constant_type("Boltzmann constant in eV/K", &
8.617333262e-5_dp, 0.0_dp, &
"eV K^-1") !! Boltzmann constant in eV/K

type(codata_constant_type), parameter, public :: BOLTZMANN_CONSTANT_IN_HZ_K = &
codata_constant_type("Boltzmann constant in Hz/K", &
2.083661912e10_dp, 0.0_dp, &
"Hz K^-1") !! Boltzmann constant in Hz/K

type(codata_constant_type), parameter, public :: BOLTZMANN_CONSTANT_IN_INVERSE_METER_PER_KELVIN = &
codata_constant_type("Boltzmann constant in inverse meter per kelvin", &
69.50348004_dp, 0.0_dp, &
"m^-1 K^-1") !! Boltzmann constant in inverse meter per kelvin

type(codata_constant_type), parameter, public :: CHARACTERISTIC_IMPEDANCE_OF_VACUUM = &
codata_constant_type("characteristic impedance of vacuum", &
376.730313412_dp, 0.000000059_dp, &
"ohm") !! characteristic impedance of vacuum

type(codata_constant_type), parameter, public :: CLASSICAL_ELECTRON_RADIUS = &
codata_constant_type("classical electron radius", &
2.8179403205e-15_dp, 0.0000000013e-15_dp, &
"m") !! classical electron radius

type(codata_constant_type), parameter, public :: COMPTON_WAVELENGTH = &
codata_constant_type("Compton wavelength", &
2.42631023538e-12_dp, 0.00000000076e-12_dp, &
"m") !! Compton wavelength

type(codata_constant_type), parameter, public :: CONDUCTANCE_QUANTUM = &
codata_constant_type("conductance quantum", &
7.748091729e-5_dp, 0.0_dp, &
"S") !! conductance quantum

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_AMPERE_90 = &
codata_constant_type("conventional value of ampere-90", &
1.00000008887_dp, 0.0_dp, &
"A") !! conventional value of ampere-90

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_COULOMB_90 = &
codata_constant_type("conventional value of coulomb-90", &
1.00000008887_dp, 0.0_dp, &
"C") !! conventional value of coulomb-90

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_FARAD_90 = &
codata_constant_type("conventional value of farad-90", &
0.99999998220_dp, 0.0_dp, &
"F") !! conventional value of farad-90

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_HENRY_90 = &
codata_constant_type("conventional value of henry-90", &
1.00000001779_dp, 0.0_dp, &
"H") !! conventional value of henry-90

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_JOSEPHSON_CONSTANT = &
codata_constant_type("conventional value of Josephson constant", &
483597.9e9_dp, 0.0_dp, &
"Hz V^-1") !! conventional value of Josephson constant

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_OHM_90 = &
codata_constant_type("conventional value of ohm-90", &
1.00000001779_dp, 0.0_dp, &
"ohm") !! conventional value of ohm-90

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_VOLT_90 = &
codata_constant_type("conventional value of volt-90", &
1.00000010666_dp, 0.0_dp, &
"V") !! conventional value of volt-90

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_VON_KLITZING_CONSTANT = &
codata_constant_type("conventional value of von Klitzing constant", &
25812.807_dp, 0.0_dp, &
"ohm") !! conventional value of von Klitzing constant

type(codata_constant_type), parameter, public :: CONVENTIONAL_VALUE_OF_WATT_90 = &
codata_constant_type("conventional value of watt-90", &
1.00000019553_dp, 0.0_dp, &
"W") !! conventional value of watt-90

type(codata_constant_type), parameter, public :: COPPER_X_UNIT = &
codata_constant_type("Copper x unit", &
1.00207697e-13_dp, 0.00000028e-13_dp, &
"m") !! Copper x unit

type(codata_constant_type), parameter, public :: DEUTERON_ELECTRON_MAG_MOM_RATIO = &
codata_constant_type("deuteron-electron mag. mom. ratio", &
-4.664345550e-4_dp, 0.000000012e-4_dp, &
"") !! deuteron-electron mag. mom. ratio

type(codata_constant_type), parameter, public :: DEUTERON_ELECTRON_MASS_RATIO = &
codata_constant_type("deuteron-electron mass ratio", &
3670.482967655_dp, 0.000000063_dp, &
"") !! deuteron-electron mass ratio

type(codata_constant_type), parameter, public :: DEUTERON_G_FACTOR = &
codata_constant_type("deuteron g factor", &
0.8574382335_dp, 0.0000000022_dp, &
"") !! deuteron g factor

type(codata_constant_type), parameter, public :: DEUTERON_MAG_MOM = &
codata_constant_type("deuteron mag. mom.", &
4.330735087e-27_dp, 0.000000011e-27_dp, &
"J T^-1") !! deuteron mag. mom.

type(codata_constant_type), parameter, public :: DEUTERON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("deuteron mag. mom. to Bohr magneton ratio", &
4.669754568e-4_dp, 0.000000012e-4_dp, &
"") !! deuteron mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: DEUTERON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("deuteron mag. mom. to nuclear magneton ratio", &
0.8574382335_dp, 0.0000000022_dp, &
"") !! deuteron mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: DEUTERON_MASS = &
codata_constant_type("deuteron mass", &
3.3435837768e-27_dp, 0.0000000010e-27_dp, &
"kg") !! deuteron mass

type(codata_constant_type), parameter, public :: DEUTERON_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("deuteron mass energy equivalent", &
3.00506323491e-10_dp, 0.00000000094e-10_dp, &
"J") !! deuteron mass energy equivalent

type(codata_constant_type), parameter, public :: DEUTERON_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("deuteron mass energy equivalent in MeV", &
1875.61294500_dp, 0.00000058_dp, &
"MeV") !! deuteron mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: DEUTERON_MASS_IN_U = &
codata_constant_type("deuteron mass in u", &
2.013553212544_dp, 0.000000000015_dp, &
"u") !! deuteron mass in u

type(codata_constant_type), parameter, public :: DEUTERON_MOLAR_MASS = &
codata_constant_type("deuteron molar mass", &
2.01355321466e-3_dp, 0.00000000063e-3_dp, &
"kg mol^-1") !! deuteron molar mass

type(codata_constant_type), parameter, public :: DEUTERON_NEUTRON_MAG_MOM_RATIO = &
codata_constant_type("deuteron-neutron mag. mom. ratio", &
-0.44820652_dp, 0.00000011_dp, &
"") !! deuteron-neutron mag. mom. ratio

type(codata_constant_type), parameter, public :: DEUTERON_PROTON_MAG_MOM_RATIO = &
codata_constant_type("deuteron-proton mag. mom. ratio", &
0.30701220930_dp, 0.00000000079_dp, &
"") !! deuteron-proton mag. mom. ratio

type(codata_constant_type), parameter, public :: DEUTERON_PROTON_MASS_RATIO = &
codata_constant_type("deuteron-proton mass ratio", &
1.9990075012699_dp, 0.0000000000084_dp, &
"") !! deuteron-proton mass ratio

type(codata_constant_type), parameter, public :: DEUTERON_RELATIVE_ATOMIC_MASS = &
codata_constant_type("deuteron relative atomic mass", &
2.013553212544_dp, 0.000000000015_dp, &
"") !! deuteron relative atomic mass

type(codata_constant_type), parameter, public :: DEUTERON_RMS_CHARGE_RADIUS = &
codata_constant_type("deuteron rms charge radius", &
2.12778e-15_dp, 0.00027e-15_dp, &
"m") !! deuteron rms charge radius

type(codata_constant_type), parameter, public :: ELECTRON_CHARGE_TO_MASS_QUOTIENT = &
codata_constant_type("electron charge to mass quotient", &
-1.75882000838e11_dp, 0.00000000055e11_dp, &
"C kg^-1") !! electron charge to mass quotient

type(codata_constant_type), parameter, public :: ELECTRON_DEUTERON_MAG_MOM_RATIO = &
codata_constant_type("electron-deuteron mag. mom. ratio", &
-2143.9234921_dp, 0.0000056_dp, &
"") !! electron-deuteron mag. mom. ratio

type(codata_constant_type), parameter, public :: ELECTRON_DEUTERON_MASS_RATIO = &
codata_constant_type("electron-deuteron mass ratio", &
2.724437107629e-4_dp, 0.000000000047e-4_dp, &
"") !! electron-deuteron mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_G_FACTOR = &
codata_constant_type("electron g factor", &
-2.00231930436092_dp, 0.00000000000036_dp, &
"") !! electron g factor

type(codata_constant_type), parameter, public :: ELECTRON_GYROMAG_RATIO = &
codata_constant_type("electron gyromag. ratio", &
1.76085962784e11_dp, 0.00000000055e11_dp, &
"s^-1 T^-1") !! electron gyromag. ratio

type(codata_constant_type), parameter, public :: ELECTRON_GYROMAG_RATIO_IN_MHZ_T = &
codata_constant_type("electron gyromag. ratio in MHz/T", &
28024.9513861_dp, 0.0000087_dp, &
"MHz T^-1") !! electron gyromag. ratio in MHz/T

type(codata_constant_type), parameter, public :: ELECTRON_HELION_MASS_RATIO = &
codata_constant_type("electron-helion mass ratio", &
1.819543074649e-4_dp, 0.000000000053e-4_dp, &
"") !! electron-helion mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_MAG_MOM = &
codata_constant_type("electron mag. mom.", &
-9.2847646917e-24_dp, 0.0000000029e-24_dp, &
"J T^-1") !! electron mag. mom.

type(codata_constant_type), parameter, public :: ELECTRON_MAG_MOM_ANOMALY = &
codata_constant_type("electron mag. mom. anomaly", &
1.15965218046e-3_dp, 0.00000000018e-3_dp, &
"") !! electron mag. mom. anomaly

type(codata_constant_type), parameter, public :: ELECTRON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("electron mag. mom. to Bohr magneton ratio", &
-1.00115965218046_dp, 0.00000000000018_dp, &
"") !! electron mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: ELECTRON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("electron mag. mom. to nuclear magneton ratio", &
-1838.281971877_dp, 0.000000032_dp, &
"") !! electron mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: ELECTRON_MASS = &
codata_constant_type("electron mass", &
9.1093837139e-31_dp, 0.0000000028e-31_dp, &
"kg") !! electron mass

type(codata_constant_type), parameter, public :: ELECTRON_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("electron mass energy equivalent", &
8.1871057880e-14_dp, 0.0000000026e-14_dp, &
"J") !! electron mass energy equivalent

type(codata_constant_type), parameter, public :: ELECTRON_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("electron mass energy equivalent in MeV", &
0.51099895069_dp, 0.00000000016_dp, &
"MeV") !! electron mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: ELECTRON_MASS_IN_U = &
codata_constant_type("electron mass in u", &
5.485799090441e-4_dp, 0.000000000097e-4_dp, &
"u") !! electron mass in u

type(codata_constant_type), parameter, public :: ELECTRON_MOLAR_MASS = &
codata_constant_type("electron molar mass", &
5.4857990962e-7_dp, 0.0000000017e-7_dp, &
"kg mol^-1") !! electron molar mass

type(codata_constant_type), parameter, public :: ELECTRON_MUON_MAG_MOM_RATIO = &
codata_constant_type("electron-muon mag. mom. ratio", &
206.7669881_dp, 0.0000046_dp, &
"") !! electron-muon mag. mom. ratio

type(codata_constant_type), parameter, public :: ELECTRON_MUON_MASS_RATIO = &
codata_constant_type("electron-muon mass ratio", &
4.83633170e-3_dp, 0.00000011e-3_dp, &
"") !! electron-muon mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_NEUTRON_MAG_MOM_RATIO = &
codata_constant_type("electron-neutron mag. mom. ratio", &
960.92048_dp, 0.00023_dp, &
"") !! electron-neutron mag. mom. ratio

type(codata_constant_type), parameter, public :: ELECTRON_NEUTRON_MASS_RATIO = &
codata_constant_type("electron-neutron mass ratio", &
5.4386734416e-4_dp, 0.0000000022e-4_dp, &
"") !! electron-neutron mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_PROTON_MAG_MOM_RATIO = &
codata_constant_type("electron-proton mag. mom. ratio", &
-658.21068789_dp, 0.00000019_dp, &
"") !! electron-proton mag. mom. ratio

type(codata_constant_type), parameter, public :: ELECTRON_PROTON_MASS_RATIO = &
codata_constant_type("electron-proton mass ratio", &
5.446170214889e-4_dp, 0.000000000094e-4_dp, &
"") !! electron-proton mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_RELATIVE_ATOMIC_MASS = &
codata_constant_type("electron relative atomic mass", &
5.485799090441e-4_dp, 0.000000000097e-4_dp, &
"") !! electron relative atomic mass

type(codata_constant_type), parameter, public :: ELECTRON_TAU_MASS_RATIO = &
codata_constant_type("electron-tau mass ratio", &
2.87585e-4_dp, 0.00019e-4_dp, &
"") !! electron-tau mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_TO_ALPHA_PARTICLE_MASS_RATIO = &
codata_constant_type("electron to alpha particle mass ratio", &
1.370933554733e-4_dp, 0.000000000032e-4_dp, &
"") !! electron to alpha particle mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_TO_SHIELDED_HELION_MAG_MOM_RATIO = &
codata_constant_type("electron to shielded helion mag. mom. ratio", &
864.05823986_dp, 0.00000070_dp, &
"") !! electron to shielded helion mag. mom. ratio

type(codata_constant_type), parameter, public :: ELECTRON_TO_SHIELDED_PROTON_MAG_MOM_RATIO = &
codata_constant_type("electron to shielded proton mag. mom. ratio", &
-658.2275856_dp, 0.0000027_dp, &
"") !! electron to shielded proton mag. mom. ratio

type(codata_constant_type), parameter, public :: ELECTRON_TRITON_MASS_RATIO = &
codata_constant_type("electron-triton mass ratio", &
1.819200062327e-4_dp, 0.000000000068e-4_dp, &
"") !! electron-triton mass ratio

type(codata_constant_type), parameter, public :: ELECTRON_VOLT = &
codata_constant_type("electron volt", &
1.602176634e-19_dp, 0.0_dp, &
"J") !! electron volt

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("electron volt-atomic mass unit relationship", &
1.07354410083e-9_dp, 0.00000000033e-9_dp, &
"u") !! electron volt-atomic mass unit relationship

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_HARTREE_RELATIONSHIP = &
codata_constant_type("electron volt-hartree relationship", &
3.6749322175665e-2_dp, 0.0000000000040e-2_dp, &
"E_h") !! electron volt-hartree relationship

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_HERTZ_RELATIONSHIP = &
codata_constant_type("electron volt-hertz relationship", &
2.417989242e14_dp, 0.0_dp, &
"Hz") !! electron volt-hertz relationship

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("electron volt-inverse meter relationship", &
8.065543937e5_dp, 0.0_dp, &
"m^-1") !! electron volt-inverse meter relationship

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_JOULE_RELATIONSHIP = &
codata_constant_type("electron volt-joule relationship", &
1.602176634e-19_dp, 0.0_dp, &
"J") !! electron volt-joule relationship

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_KELVIN_RELATIONSHIP = &
codata_constant_type("electron volt-kelvin relationship", &
1.160451812e4_dp, 0.0_dp, &
"K") !! electron volt-kelvin relationship

type(codata_constant_type), parameter, public :: ELECTRON_VOLT_KILOGRAM_RELATIONSHIP = &
codata_constant_type("electron volt-kilogram relationship", &
1.782661921e-36_dp, 0.0_dp, &
"kg") !! electron volt-kilogram relationship

type(codata_constant_type), parameter, public :: ELEMENTARY_CHARGE = &
codata_constant_type("elementary charge", &
1.602176634e-19_dp, 0.0_dp, &
"C") !! elementary charge

type(codata_constant_type), parameter, public :: ELEMENTARY_CHARGE_OVER_H_BAR = &
codata_constant_type("elementary charge over h-bar", &
1.519267447e15_dp, 0.0_dp, &
"A J^-1") !! elementary charge over h-bar

type(codata_constant_type), parameter, public :: FARADAY_CONSTANT = &
codata_constant_type("Faraday constant", &
96485.33212_dp, 0.0_dp, &
"C mol^-1") !! Faraday constant

type(codata_constant_type), parameter, public :: FERMI_COUPLING_CONSTANT = &
codata_constant_type("Fermi coupling constant", &
1.1663787e-5_dp, 0.0000006e-5_dp, &
"GeV^-2") !! Fermi coupling constant

type(codata_constant_type), parameter, public :: FINE_STRUCTURE_CONSTANT = &
codata_constant_type("fine-structure constant", &
7.2973525643e-3_dp, 0.0000000011e-3_dp, &
"") !! fine-structure constant

type(codata_constant_type), parameter, public :: FIRST_RADIATION_CONSTANT = &
codata_constant_type("first radiation constant", &
3.741771852e-16_dp, 0.0_dp, &
"W m^2") !! first radiation constant

type(codata_constant_type), parameter, public :: FIRST_RADIATION_CONSTANT_FOR_SPECTRAL_RADIANCE = &
codata_constant_type("first radiation constant for spectral radiance", &
1.191042972e-16_dp, 0.0_dp, &
"W m^2 sr^-1") !! first radiation constant for spectral radiance

type(codata_constant_type), parameter, public :: HARTREE_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("hartree-atomic mass unit relationship", &
2.92126231797e-8_dp, 0.00000000091e-8_dp, &
"u") !! hartree-atomic mass unit relationship

type(codata_constant_type), parameter, public :: HARTREE_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("hartree-electron volt relationship", &
27.211386245981_dp, 0.000000000030_dp, &
"eV") !! hartree-electron volt relationship

type(codata_constant_type), parameter, public :: HARTREE_ENERGY = &
codata_constant_type("Hartree energy", &
4.3597447222060e-18_dp, 0.0000000000048e-18_dp, &
"J") !! Hartree energy

type(codata_constant_type), parameter, public :: HARTREE_ENERGY_IN_EV = &
codata_constant_type("Hartree energy in eV", &
27.211386245981_dp, 0.000000000030_dp, &
"eV") !! Hartree energy in eV

type(codata_constant_type), parameter, public :: HARTREE_HERTZ_RELATIONSHIP = &
codata_constant_type("hartree-hertz relationship", &
6.5796839204999e15_dp, 0.0000000000072e15_dp, &
"Hz") !! hartree-hertz relationship

type(codata_constant_type), parameter, public :: HARTREE_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("hartree-inverse meter relationship", &
2.1947463136314e7_dp, 0.0000000000024e7_dp, &
"m^-1") !! hartree-inverse meter relationship

type(codata_constant_type), parameter, public :: HARTREE_JOULE_RELATIONSHIP = &
codata_constant_type("hartree-joule relationship", &
4.3597447222060e-18_dp, 0.0000000000048e-18_dp, &
"J") !! hartree-joule relationship

type(codata_constant_type), parameter, public :: HARTREE_KELVIN_RELATIONSHIP = &
codata_constant_type("hartree-kelvin relationship", &
3.1577502480398e5_dp, 0.0000000000034e5_dp, &
"K") !! hartree-kelvin relationship

type(codata_constant_type), parameter, public :: HARTREE_KILOGRAM_RELATIONSHIP = &
codata_constant_type("hartree-kilogram relationship", &
4.8508702095419e-35_dp, 0.0000000000053e-35_dp, &
"kg") !! hartree-kilogram relationship

type(codata_constant_type), parameter, public :: HELION_ELECTRON_MASS_RATIO = &
codata_constant_type("helion-electron mass ratio", &
5495.88527984_dp, 0.00000016_dp, &
"") !! helion-electron mass ratio

type(codata_constant_type), parameter, public :: HELION_G_FACTOR = &
codata_constant_type("helion g factor", &
-4.2552506995_dp, 0.0000000034_dp, &
"") !! helion g factor

type(codata_constant_type), parameter, public :: HELION_MAG_MOM = &
codata_constant_type("helion mag. mom.", &
-1.07461755198e-26_dp, 0.00000000093e-26_dp, &
"J T^-1") !! helion mag. mom.

type(codata_constant_type), parameter, public :: HELION_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("helion mag. mom. to Bohr magneton ratio", &
-1.15874098083e-3_dp, 0.00000000094e-3_dp, &
"") !! helion mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: HELION_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("helion mag. mom. to nuclear magneton ratio", &
-2.1276253498_dp, 0.0000000017_dp, &
"") !! helion mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: HELION_MASS = &
codata_constant_type("helion mass", &
5.0064127862e-27_dp, 0.0000000016e-27_dp, &
"kg") !! helion mass

type(codata_constant_type), parameter, public :: HELION_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("helion mass energy equivalent", &
4.4995394185e-10_dp, 0.0000000014e-10_dp, &
"J") !! helion mass energy equivalent

type(codata_constant_type), parameter, public :: HELION_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("helion mass energy equivalent in MeV", &
2808.39161112_dp, 0.00000088_dp, &
"MeV") !! helion mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: HELION_MASS_IN_U = &
codata_constant_type("helion mass in u", &
3.014932246932_dp, 0.000000000074_dp, &
"u") !! helion mass in u

type(codata_constant_type), parameter, public :: HELION_MOLAR_MASS = &
codata_constant_type("helion molar mass", &
3.01493225010e-3_dp, 0.00000000094e-3_dp, &
"kg mol^-1") !! helion molar mass

type(codata_constant_type), parameter, public :: HELION_PROTON_MASS_RATIO = &
codata_constant_type("helion-proton mass ratio", &
2.993152671552_dp, 0.000000000070_dp, &
"") !! helion-proton mass ratio

type(codata_constant_type), parameter, public :: HELION_RELATIVE_ATOMIC_MASS = &
codata_constant_type("helion relative atomic mass", &
3.014932246932_dp, 0.000000000074_dp, &
"") !! helion relative atomic mass

type(codata_constant_type), parameter, public :: HELION_SHIELDING_SHIFT = &
codata_constant_type("helion shielding shift", &
5.9967029e-5_dp, 0.0000023e-5_dp, &
"") !! helion shielding shift

type(codata_constant_type), parameter, public :: HERTZ_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("hertz-atomic mass unit relationship", &
4.4398216590e-24_dp, 0.0000000014e-24_dp, &
"u") !! hertz-atomic mass unit relationship

type(codata_constant_type), parameter, public :: HERTZ_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("hertz-electron volt relationship", &
4.135667696e-15_dp, 0.0_dp, &
"eV") !! hertz-electron volt relationship

type(codata_constant_type), parameter, public :: HERTZ_HARTREE_RELATIONSHIP = &
codata_constant_type("hertz-hartree relationship", &
1.5198298460574e-16_dp, 0.0000000000017e-16_dp, &
"E_h") !! hertz-hartree relationship

type(codata_constant_type), parameter, public :: HERTZ_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("hertz-inverse meter relationship", &
3.335640951e-9_dp, 0.0_dp, &
"m^-1") !! hertz-inverse meter relationship

type(codata_constant_type), parameter, public :: HERTZ_JOULE_RELATIONSHIP = &
codata_constant_type("hertz-joule relationship", &
6.62607015e-34_dp, 0.0_dp, &
"J") !! hertz-joule relationship

type(codata_constant_type), parameter, public :: HERTZ_KELVIN_RELATIONSHIP = &
codata_constant_type("hertz-kelvin relationship", &
4.799243073e-11_dp, 0.0_dp, &
"K") !! hertz-kelvin relationship

type(codata_constant_type), parameter, public :: HERTZ_KILOGRAM_RELATIONSHIP = &
codata_constant_type("hertz-kilogram relationship", &
7.372497323e-51_dp, 0.0_dp, &
"kg") !! hertz-kilogram relationship

type(codata_constant_type), parameter, public :: HYPERFINE_TRANSITION_FREQUENCY_OF_CS_133 = &
codata_constant_type("hyperfine transition frequency of Cs-133", &
9192631770_dp, 0.0_dp, &
"Hz") !! hyperfine transition frequency of Cs-133

type(codata_constant_type), parameter, public :: INVERSE_FINE_STRUCTURE_CONSTANT = &
codata_constant_type("inverse fine-structure constant", &
137.035999177_dp, 0.000000021_dp, &
"") !! inverse fine-structure constant

type(codata_constant_type), parameter, public :: INVERSE_METER_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("inverse meter-atomic mass unit relationship", &
1.33102504824e-15_dp, 0.00000000041e-15_dp, &
"u") !! inverse meter-atomic mass unit relationship

type(codata_constant_type), parameter, public :: INVERSE_METER_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("inverse meter-electron volt relationship", &
1.239841984e-6_dp, 0.0_dp, &
"eV") !! inverse meter-electron volt relationship

type(codata_constant_type), parameter, public :: INVERSE_METER_HARTREE_RELATIONSHIP = &
codata_constant_type("inverse meter-hartree relationship", &
4.5563352529132e-8_dp, 0.0000000000050e-8_dp, &
"E_h") !! inverse meter-hartree relationship

type(codata_constant_type), parameter, public :: INVERSE_METER_HERTZ_RELATIONSHIP = &
codata_constant_type("inverse meter-hertz relationship", &
299792458_dp, 0.0_dp, &
"Hz") !! inverse meter-hertz relationship

type(codata_constant_type), parameter, public :: INVERSE_METER_JOULE_RELATIONSHIP = &
codata_constant_type("inverse meter-joule relationship", &
1.986445857e-25_dp, 0.0_dp, &
"J") !! inverse meter-joule relationship

type(codata_constant_type), parameter, public :: INVERSE_METER_KELVIN_RELATIONSHIP = &
codata_constant_type("inverse meter-kelvin relationship", &
1.438776877e-2_dp, 0.0_dp, &
"K") !! inverse meter-kelvin relationship

type(codata_constant_type), parameter, public :: INVERSE_METER_KILOGRAM_RELATIONSHIP = &
codata_constant_type("inverse meter-kilogram relationship", &
2.210219094e-42_dp, 0.0_dp, &
"kg") !! inverse meter-kilogram relationship

type(codata_constant_type), parameter, public :: INVERSE_OF_CONDUCTANCE_QUANTUM = &
codata_constant_type("inverse of conductance quantum", &
12906.40372_dp, 0.0_dp, &
"ohm") !! inverse of conductance quantum

type(codata_constant_type), parameter, public :: JOSEPHSON_CONSTANT = &
codata_constant_type("Josephson constant", &
483597.8484e9_dp, 0.0_dp, &
"Hz V^-1") !! Josephson constant

type(codata_constant_type), parameter, public :: JOULE_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("joule-atomic mass unit relationship", &
6.7005352471e9_dp, 0.0000000021e9_dp, &
"u") !! joule-atomic mass unit relationship

type(codata_constant_type), parameter, public :: JOULE_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("joule-electron volt relationship", &
6.241509074e18_dp, 0.0_dp, &
"eV") !! joule-electron volt relationship

type(codata_constant_type), parameter, public :: JOULE_HARTREE_RELATIONSHIP = &
codata_constant_type("joule-hartree relationship", &
2.2937122783969e17_dp, 0.0000000000025e17_dp, &
"E_h") !! joule-hartree relationship

type(codata_constant_type), parameter, public :: JOULE_HERTZ_RELATIONSHIP = &
codata_constant_type("joule-hertz relationship", &
1.509190179e33_dp, 0.0_dp, &
"Hz") !! joule-hertz relationship

type(codata_constant_type), parameter, public :: JOULE_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("joule-inverse meter relationship", &
5.034116567e24_dp, 0.0_dp, &
"m^-1") !! joule-inverse meter relationship

type(codata_constant_type), parameter, public :: JOULE_KELVIN_RELATIONSHIP = &
codata_constant_type("joule-kelvin relationship", &
7.242970516e22_dp, 0.0_dp, &
"K") !! joule-kelvin relationship

type(codata_constant_type), parameter, public :: JOULE_KILOGRAM_RELATIONSHIP = &
codata_constant_type("joule-kilogram relationship", &
1.112650056e-17_dp, 0.0_dp, &
"kg") !! joule-kilogram relationship

type(codata_constant_type), parameter, public :: KELVIN_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("kelvin-atomic mass unit relationship", &
9.2510872884e-14_dp, 0.0000000029e-14_dp, &
"u") !! kelvin-atomic mass unit relationship

type(codata_constant_type), parameter, public :: KELVIN_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("kelvin-electron volt relationship", &
8.617333262e-5_dp, 0.0_dp, &
"eV") !! kelvin-electron volt relationship

type(codata_constant_type), parameter, public :: KELVIN_HARTREE_RELATIONSHIP = &
codata_constant_type("kelvin-hartree relationship", &
3.1668115634564e-6_dp, 0.0000000000035e-6_dp, &
"E_h") !! kelvin-hartree relationship

type(codata_constant_type), parameter, public :: KELVIN_HERTZ_RELATIONSHIP = &
codata_constant_type("kelvin-hertz relationship", &
2.083661912e10_dp, 0.0_dp, &
"Hz") !! kelvin-hertz relationship

type(codata_constant_type), parameter, public :: KELVIN_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("kelvin-inverse meter relationship", &
69.50348004_dp, 0.0_dp, &
"m^-1") !! kelvin-inverse meter relationship

type(codata_constant_type), parameter, public :: KELVIN_JOULE_RELATIONSHIP = &
codata_constant_type("kelvin-joule relationship", &
1.380649e-23_dp, 0.0_dp, &
"J") !! kelvin-joule relationship

type(codata_constant_type), parameter, public :: KELVIN_KILOGRAM_RELATIONSHIP = &
codata_constant_type("kelvin-kilogram relationship", &
1.536179187e-40_dp, 0.0_dp, &
"kg") !! kelvin-kilogram relationship

type(codata_constant_type), parameter, public :: KILOGRAM_ATOMIC_MASS_UNIT_RELATIONSHIP = &
codata_constant_type("kilogram-atomic mass unit relationship", &
6.0221407537e26_dp, 0.0000000019e26_dp, &
"u") !! kilogram-atomic mass unit relationship

type(codata_constant_type), parameter, public :: KILOGRAM_ELECTRON_VOLT_RELATIONSHIP = &
codata_constant_type("kilogram-electron volt relationship", &
5.609588603e35_dp, 0.0_dp, &
"eV") !! kilogram-electron volt relationship

type(codata_constant_type), parameter, public :: KILOGRAM_HARTREE_RELATIONSHIP = &
codata_constant_type("kilogram-hartree relationship", &
2.0614857887415e34_dp, 0.0000000000022e34_dp, &
"E_h") !! kilogram-hartree relationship

type(codata_constant_type), parameter, public :: KILOGRAM_HERTZ_RELATIONSHIP = &
codata_constant_type("kilogram-hertz relationship", &
1.356392489e50_dp, 0.0_dp, &
"Hz") !! kilogram-hertz relationship

type(codata_constant_type), parameter, public :: KILOGRAM_INVERSE_METER_RELATIONSHIP = &
codata_constant_type("kilogram-inverse meter relationship", &
4.524438335e41_dp, 0.0_dp, &
"m^-1") !! kilogram-inverse meter relationship

type(codata_constant_type), parameter, public :: KILOGRAM_JOULE_RELATIONSHIP = &
codata_constant_type("kilogram-joule relationship", &
8.987551787e16_dp, 0.0_dp, &
"J") !! kilogram-joule relationship

type(codata_constant_type), parameter, public :: KILOGRAM_KELVIN_RELATIONSHIP = &
codata_constant_type("kilogram-kelvin relationship", &
6.509657260e39_dp, 0.0_dp, &
"K") !! kilogram-kelvin relationship

type(codata_constant_type), parameter, public :: LATTICE_PARAMETER_OF_SILICON = &
codata_constant_type("lattice parameter of silicon", &
5.431020511e-10_dp, 0.000000089e-10_dp, &
"m") !! lattice parameter of silicon

type(codata_constant_type), parameter, public :: LATTICE_SPACING_OF_IDEAL_SI_220 = &
codata_constant_type("lattice spacing of ideal Si (220)", &
1.920155716e-10_dp, 0.000000032e-10_dp, &
"m") !! lattice spacing of ideal Si (220)

type(codata_constant_type), parameter, public :: LOSCHMIDT_CONSTANT_273_15_K_100_KPA = &
codata_constant_type("Loschmidt constant (273.15 K, 100 kPa)", &
2.651645804e25_dp, 0.0_dp, &
"m^-3") !! Loschmidt constant (273.15 K, 100 kPa)

type(codata_constant_type), parameter, public :: LOSCHMIDT_CONSTANT_273_15_K_101_325_KPA = &
codata_constant_type("Loschmidt constant (273.15 K, 101.325 kPa)", &
2.686780111e25_dp, 0.0_dp, &
"m^-3") !! Loschmidt constant (273.15 K, 101.325 kPa)

type(codata_constant_type), parameter, public :: LUMINOUS_EFFICACY = &
codata_constant_type("luminous efficacy", &
683_dp, 0.0_dp, &
"lm W^-1") !! luminous efficacy

type(codata_constant_type), parameter, public :: MAG_FLUX_QUANTUM = &
codata_constant_type("mag. flux quantum", &
2.067833848e-15_dp, 0.0_dp, &
"Wb") !! mag. flux quantum

type(codata_constant_type), parameter, public :: MOLAR_GAS_CONSTANT = &
codata_constant_type("molar gas constant", &
8.314462618_dp, 0.0_dp, &
"J mol^-1 K^-1") !! molar gas constant

type(codata_constant_type), parameter, public :: MOLAR_MASS_CONSTANT = &
codata_constant_type("molar mass constant", &
1.00000000105e-3_dp, 0.00000000031e-3_dp, &
"kg mol^-1") !! molar mass constant

type(codata_constant_type), parameter, public :: MOLAR_MASS_OF_CARBON_12 = &
codata_constant_type("molar mass of carbon-12", &
12.0000000126e-3_dp, 0.0000000037e-3_dp, &
"kg mol^-1") !! molar mass of carbon-12

type(codata_constant_type), parameter, public :: MOLAR_PLANCK_CONSTANT = &
codata_constant_type("molar Planck constant", &
3.990312712e-10_dp, 0.0_dp, &
"J Hz^-1 mol^-1") !! molar Planck constant

type(codata_constant_type), parameter, public :: MOLAR_VOLUME_OF_IDEAL_GAS_273_15_K_100_KPA = &
codata_constant_type("molar volume of ideal gas (273.15 K, 100 kPa)", &
22.71095464e-3_dp, 0.0_dp, &
"m^3 mol^-1") !! molar volume of ideal gas (273.15 K, 100 kPa)

type(codata_constant_type), parameter, public :: MOLAR_VOLUME_OF_IDEAL_GAS_273_15_K_101_325_KPA = &
codata_constant_type("molar volume of ideal gas (273.15 K, 101.325 kPa)", &
22.41396954e-3_dp, 0.0_dp, &
"m^3 mol^-1") !! molar volume of ideal gas (273.15 K, 101.325 kPa)

type(codata_constant_type), parameter, public :: MOLAR_VOLUME_OF_SILICON = &
codata_constant_type("molar volume of silicon", &
1.205883199e-5_dp, 0.000000060e-5_dp, &
"m^3 mol^-1") !! molar volume of silicon

type(codata_constant_type), parameter, public :: MOLYBDENUM_X_UNIT = &
codata_constant_type("Molybdenum x unit", &
1.00209952e-13_dp, 0.00000053e-13_dp, &
"m") !! Molybdenum x unit

type(codata_constant_type), parameter, public :: MUON_COMPTON_WAVELENGTH = &
codata_constant_type("muon Compton wavelength", &
1.173444110e-14_dp, 0.000000026e-14_dp, &
"m") !! muon Compton wavelength

type(codata_constant_type), parameter, public :: MUON_ELECTRON_MASS_RATIO = &
codata_constant_type("muon-electron mass ratio", &
206.7682827_dp, 0.0000046_dp, &
"") !! muon-electron mass ratio

type(codata_constant_type), parameter, public :: MUON_G_FACTOR = &
codata_constant_type("muon g factor", &
-2.00233184123_dp, 0.00000000082_dp, &
"") !! muon g factor

type(codata_constant_type), parameter, public :: MUON_MAG_MOM = &
codata_constant_type("muon mag. mom.", &
-4.49044830e-26_dp, 0.00000010e-26_dp, &
"J T^-1") !! muon mag. mom.

type(codata_constant_type), parameter, public :: MUON_MAG_MOM_ANOMALY = &
codata_constant_type("muon mag. mom. anomaly", &
1.16592062e-3_dp, 0.00000041e-3_dp, &
"") !! muon mag. mom. anomaly

type(codata_constant_type), parameter, public :: MUON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("muon mag. mom. to Bohr magneton ratio", &
-4.84197048e-3_dp, 0.00000011e-3_dp, &
"") !! muon mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: MUON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("muon mag. mom. to nuclear magneton ratio", &
-8.89059704_dp, 0.00000020_dp, &
"") !! muon mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: MUON_MASS = &
codata_constant_type("muon mass", &
1.883531627e-28_dp, 0.000000042e-28_dp, &
"kg") !! muon mass

type(codata_constant_type), parameter, public :: MUON_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("muon mass energy equivalent", &
1.692833804e-11_dp, 0.000000038e-11_dp, &
"J") !! muon mass energy equivalent

type(codata_constant_type), parameter, public :: MUON_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("muon mass energy equivalent in MeV", &
105.6583755_dp, 0.0000023_dp, &
"MeV") !! muon mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: MUON_MASS_IN_U = &
codata_constant_type("muon mass in u", &
0.1134289257_dp, 0.0000000025_dp, &
"u") !! muon mass in u

type(codata_constant_type), parameter, public :: MUON_MOLAR_MASS = &
codata_constant_type("muon molar mass", &
1.134289258e-4_dp, 0.000000025e-4_dp, &
"kg mol^-1") !! muon molar mass

type(codata_constant_type), parameter, public :: MUON_NEUTRON_MASS_RATIO = &
codata_constant_type("muon-neutron mass ratio", &
0.1124545168_dp, 0.0000000025_dp, &
"") !! muon-neutron mass ratio

type(codata_constant_type), parameter, public :: MUON_PROTON_MAG_MOM_RATIO = &
codata_constant_type("muon-proton mag. mom. ratio", &
-3.183345146_dp, 0.000000071_dp, &
"") !! muon-proton mag. mom. ratio

type(codata_constant_type), parameter, public :: MUON_PROTON_MASS_RATIO = &
codata_constant_type("muon-proton mass ratio", &
0.1126095262_dp, 0.0000000025_dp, &
"") !! muon-proton mass ratio

type(codata_constant_type), parameter, public :: MUON_TAU_MASS_RATIO = &
codata_constant_type("muon-tau mass ratio", &
5.94635e-2_dp, 0.00040e-2_dp, &
"") !! muon-tau mass ratio

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_ACTION = &
codata_constant_type("natural unit of action", &
1.054571817e-34_dp, 0.0_dp, &
"J s") !! natural unit of action

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_ACTION_IN_EV_S = &
codata_constant_type("natural unit of action in eV s", &
6.582119569e-16_dp, 0.0_dp, &
"eV s") !! natural unit of action in eV s

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_ENERGY = &
codata_constant_type("natural unit of energy", &
8.1871057880e-14_dp, 0.0000000026e-14_dp, &
"J") !! natural unit of energy

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_ENERGY_IN_MEV = &
codata_constant_type("natural unit of energy in MeV", &
0.51099895069_dp, 0.00000000016_dp, &
"MeV") !! natural unit of energy in MeV

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_LENGTH = &
codata_constant_type("natural unit of length", &
3.8615926744e-13_dp, 0.0000000012e-13_dp, &
"m") !! natural unit of length

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_MASS = &
codata_constant_type("natural unit of mass", &
9.1093837139e-31_dp, 0.0000000028e-31_dp, &
"kg") !! natural unit of mass

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_MOMENTUM = &
codata_constant_type("natural unit of momentum", &
2.73092453446e-22_dp, 0.00000000085e-22_dp, &
"kg m s^-1") !! natural unit of momentum

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_MOMENTUM_IN_MEV_C = &
codata_constant_type("natural unit of momentum in MeV/c", &
0.51099895069_dp, 0.00000000016_dp, &
"MeV/c") !! natural unit of momentum in MeV/c

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_TIME = &
codata_constant_type("natural unit of time", &
1.28808866644e-21_dp, 0.00000000040e-21_dp, &
"s") !! natural unit of time

type(codata_constant_type), parameter, public :: NATURAL_UNIT_OF_VELOCITY = &
codata_constant_type("natural unit of velocity", &
299792458_dp, 0.0_dp, &
"m s^-1") !! natural unit of velocity

type(codata_constant_type), parameter, public :: NEUTRON_COMPTON_WAVELENGTH = &
codata_constant_type("neutron Compton wavelength", &
1.31959090382e-15_dp, 0.00000000067e-15_dp, &
"m") !! neutron Compton wavelength

type(codata_constant_type), parameter, public :: NEUTRON_ELECTRON_MAG_MOM_RATIO = &
codata_constant_type("neutron-electron mag. mom. ratio", &
1.04066884e-3_dp, 0.00000024e-3_dp, &
"") !! neutron-electron mag. mom. ratio

type(codata_constant_type), parameter, public :: NEUTRON_ELECTRON_MASS_RATIO = &
codata_constant_type("neutron-electron mass ratio", &
1838.68366200_dp, 0.00000074_dp, &
"") !! neutron-electron mass ratio

type(codata_constant_type), parameter, public :: NEUTRON_G_FACTOR = &
codata_constant_type("neutron g factor", &
-3.82608552_dp, 0.00000090_dp, &
"") !! neutron g factor

type(codata_constant_type), parameter, public :: NEUTRON_GYROMAG_RATIO = &
codata_constant_type("neutron gyromag. ratio", &
1.83247174e8_dp, 0.00000043e8_dp, &
"s^-1 T^-1") !! neutron gyromag. ratio

type(codata_constant_type), parameter, public :: NEUTRON_GYROMAG_RATIO_IN_MHZ_T = &
codata_constant_type("neutron gyromag. ratio in MHz/T", &
29.1646935_dp, 0.0000069_dp, &
"MHz T^-1") !! neutron gyromag. ratio in MHz/T

type(codata_constant_type), parameter, public :: NEUTRON_MAG_MOM = &
codata_constant_type("neutron mag. mom.", &
-9.6623653e-27_dp, 0.0000023e-27_dp, &
"J T^-1") !! neutron mag. mom.

type(codata_constant_type), parameter, public :: NEUTRON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("neutron mag. mom. to Bohr magneton ratio", &
-1.04187565e-3_dp, 0.00000025e-3_dp, &
"") !! neutron mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: NEUTRON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("neutron mag. mom. to nuclear magneton ratio", &
-1.91304276_dp, 0.00000045_dp, &
"") !! neutron mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: NEUTRON_MASS = &
codata_constant_type("neutron mass", &
1.67492750056e-27_dp, 0.00000000085e-27_dp, &
"kg") !! neutron mass

type(codata_constant_type), parameter, public :: NEUTRON_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("neutron mass energy equivalent", &
1.50534976514e-10_dp, 0.00000000076e-10_dp, &
"J") !! neutron mass energy equivalent

type(codata_constant_type), parameter, public :: NEUTRON_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("neutron mass energy equivalent in MeV", &
939.56542194_dp, 0.00000048_dp, &
"MeV") !! neutron mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: NEUTRON_MASS_IN_U = &
codata_constant_type("neutron mass in u", &
1.00866491606_dp, 0.00000000040_dp, &
"u") !! neutron mass in u

type(codata_constant_type), parameter, public :: NEUTRON_MOLAR_MASS = &
codata_constant_type("neutron molar mass", &
1.00866491712e-3_dp, 0.00000000051e-3_dp, &
"kg mol^-1") !! neutron molar mass

type(codata_constant_type), parameter, public :: NEUTRON_MUON_MASS_RATIO = &
codata_constant_type("neutron-muon mass ratio", &
8.89248408_dp, 0.00000020_dp, &
"") !! neutron-muon mass ratio

type(codata_constant_type), parameter, public :: NEUTRON_PROTON_MAG_MOM_RATIO = &
codata_constant_type("neutron-proton mag. mom. ratio", &
-0.68497935_dp, 0.00000016_dp, &
"") !! neutron-proton mag. mom. ratio

type(codata_constant_type), parameter, public :: NEUTRON_PROTON_MASS_DIFFERENCE = &
codata_constant_type("neutron-proton mass difference", &
2.30557461e-30_dp, 0.00000067e-30_dp, &
"kg") !! neutron-proton mass difference

type(codata_constant_type), parameter, public :: NEUTRON_PROTON_MASS_DIFFERENCE_ENERGY_EQUIVALENT = &
codata_constant_type("neutron-proton mass difference energy equivalent", &
2.07214712e-13_dp, 0.00000060e-13_dp, &
"J") !! neutron-proton mass difference energy equivalent

type(codata_constant_type), parameter, public :: NEUTRON_PROTON_MASS_DIFFERENCE_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("neutron-proton mass difference energy equivalent in MeV", &
1.29333251_dp, 0.00000038_dp, &
"MeV") !! neutron-proton mass difference energy equivalent in MeV

type(codata_constant_type), parameter, public :: NEUTRON_PROTON_MASS_DIFFERENCE_IN_U = &
codata_constant_type("neutron-proton mass difference in u", &
1.38844948e-3_dp, 0.00000040e-3_dp, &
"u") !! neutron-proton mass difference in u

type(codata_constant_type), parameter, public :: NEUTRON_PROTON_MASS_RATIO = &
codata_constant_type("neutron-proton mass ratio", &
1.00137841946_dp, 0.00000000040_dp, &
"") !! neutron-proton mass ratio

type(codata_constant_type), parameter, public :: NEUTRON_RELATIVE_ATOMIC_MASS = &
codata_constant_type("neutron relative atomic mass", &
1.00866491606_dp, 0.00000000040_dp, &
"") !! neutron relative atomic mass

type(codata_constant_type), parameter, public :: NEUTRON_TAU_MASS_RATIO = &
codata_constant_type("neutron-tau mass ratio", &
0.528779_dp, 0.000036_dp, &
"") !! neutron-tau mass ratio

type(codata_constant_type), parameter, public :: NEUTRON_TO_SHIELDED_PROTON_MAG_MOM_RATIO = &
codata_constant_type("neutron to shielded proton mag. mom. ratio", &
-0.68499694_dp, 0.00000016_dp, &
"") !! neutron to shielded proton mag. mom. ratio

type(codata_constant_type), parameter, public :: NEWTONIAN_CONSTANT_OF_GRAVITATION = &
codata_constant_type("Newtonian constant of gravitation", &
6.67430e-11_dp, 0.00015e-11_dp, &
"m^3 kg^-1 s^-2") !! Newtonian constant of gravitation

type(codata_constant_type), parameter, public :: NEWTONIAN_CONSTANT_OF_GRAVITATION_OVER_H_BAR_C = &
codata_constant_type("Newtonian constant of gravitation over h-bar c", &
6.70883e-39_dp, 0.00015e-39_dp, &
"(GeV/c^2)^-2") !! Newtonian constant of gravitation over h-bar c

type(codata_constant_type), parameter, public :: NUCLEAR_MAGNETON = &
codata_constant_type("nuclear magneton", &
5.0507837393e-27_dp, 0.0000000016e-27_dp, &
"J T^-1") !! nuclear magneton

type(codata_constant_type), parameter, public :: NUCLEAR_MAGNETON_IN_EV_T = &
codata_constant_type("nuclear magneton in eV/T", &
3.15245125417e-8_dp, 0.00000000098e-8_dp, &
"eV T^-1") !! nuclear magneton in eV/T

type(codata_constant_type), parameter, public :: NUCLEAR_MAGNETON_IN_INVERSE_METER_PER_TESLA = &
codata_constant_type("nuclear magneton in inverse meter per tesla", &
2.54262341009e-2_dp, 0.00000000079e-2_dp, &
"m^-1 T^-1") !! nuclear magneton in inverse meter per tesla

type(codata_constant_type), parameter, public :: NUCLEAR_MAGNETON_IN_K_T = &
codata_constant_type("nuclear magneton in K/T", &
3.6582677706e-4_dp, 0.0000000011e-4_dp, &
"K T^-1") !! nuclear magneton in K/T

type(codata_constant_type), parameter, public :: NUCLEAR_MAGNETON_IN_MHZ_T = &
codata_constant_type("nuclear magneton in MHz/T", &
7.6225932188_dp, 0.0000000024_dp, &
"MHz T^-1") !! nuclear magneton in MHz/T

type(codata_constant_type), parameter, public :: PLANCK_CONSTANT = &
codata_constant_type("Planck constant", &
6.62607015e-34_dp, 0.0_dp, &
"J Hz^-1") !! Planck constant

type(codata_constant_type), parameter, public :: PLANCK_CONSTANT_IN_EV_HZ = &
codata_constant_type("Planck constant in eV/Hz", &
4.135667696e-15_dp, 0.0_dp, &
"eV Hz^-1") !! Planck constant in eV/Hz

type(codata_constant_type), parameter, public :: PLANCK_LENGTH = &
codata_constant_type("Planck length", &
1.616255e-35_dp, 0.000018e-35_dp, &
"m") !! Planck length

type(codata_constant_type), parameter, public :: PLANCK_MASS = &
codata_constant_type("Planck mass", &
2.176434e-8_dp, 0.000024e-8_dp, &
"kg") !! Planck mass

type(codata_constant_type), parameter, public :: PLANCK_MASS_ENERGY_EQUIVALENT_IN_GEV = &
codata_constant_type("Planck mass energy equivalent in GeV", &
1.220890e19_dp, 0.000014e19_dp, &
"GeV") !! Planck mass energy equivalent in GeV

type(codata_constant_type), parameter, public :: PLANCK_TEMPERATURE = &
codata_constant_type("Planck temperature", &
1.416784e32_dp, 0.000016e32_dp, &
"K") !! Planck temperature

type(codata_constant_type), parameter, public :: PLANCK_TIME = &
codata_constant_type("Planck time", &
5.391247e-44_dp, 0.000060e-44_dp, &
"s") !! Planck time

type(codata_constant_type), parameter, public :: PROTON_CHARGE_TO_MASS_QUOTIENT = &
codata_constant_type("proton charge to mass quotient", &
9.5788331430e7_dp, 0.0000000030e7_dp, &
"C kg^-1") !! proton charge to mass quotient

type(codata_constant_type), parameter, public :: PROTON_COMPTON_WAVELENGTH = &
codata_constant_type("proton Compton wavelength", &
1.32140985360e-15_dp, 0.00000000041e-15_dp, &
"m") !! proton Compton wavelength

type(codata_constant_type), parameter, public :: PROTON_ELECTRON_MASS_RATIO = &
codata_constant_type("proton-electron mass ratio", &
1836.152673426_dp, 0.000000032_dp, &
"") !! proton-electron mass ratio

type(codata_constant_type), parameter, public :: PROTON_G_FACTOR = &
codata_constant_type("proton g factor", &
5.5856946893_dp, 0.0000000016_dp, &
"") !! proton g factor

type(codata_constant_type), parameter, public :: PROTON_GYROMAG_RATIO = &
codata_constant_type("proton gyromag. ratio", &
2.6752218708e8_dp, 0.0000000011e8_dp, &
"s^-1 T^-1") !! proton gyromag. ratio

type(codata_constant_type), parameter, public :: PROTON_GYROMAG_RATIO_IN_MHZ_T = &
codata_constant_type("proton gyromag. ratio in MHz/T", &
42.577478461_dp, 0.000000018_dp, &
"MHz T^-1") !! proton gyromag. ratio in MHz/T

type(codata_constant_type), parameter, public :: PROTON_MAG_MOM = &
codata_constant_type("proton mag. mom.", &
1.41060679545e-26_dp, 0.00000000060e-26_dp, &
"J T^-1") !! proton mag. mom.

type(codata_constant_type), parameter, public :: PROTON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("proton mag. mom. to Bohr magneton ratio", &
1.52103220230e-3_dp, 0.00000000045e-3_dp, &
"") !! proton mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: PROTON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("proton mag. mom. to nuclear magneton ratio", &
2.79284734463_dp, 0.00000000082_dp, &
"") !! proton mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: PROTON_MAG_SHIELDING_CORRECTION = &
codata_constant_type("proton mag. shielding correction", &
2.56715e-5_dp, 0.00041e-5_dp, &
"") !! proton mag. shielding correction

type(codata_constant_type), parameter, public :: PROTON_MASS = &
codata_constant_type("proton mass", &
1.67262192595e-27_dp, 0.00000000052e-27_dp, &
"kg") !! proton mass

type(codata_constant_type), parameter, public :: PROTON_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("proton mass energy equivalent", &
1.50327761802e-10_dp, 0.00000000047e-10_dp, &
"J") !! proton mass energy equivalent

type(codata_constant_type), parameter, public :: PROTON_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("proton mass energy equivalent in MeV", &
938.27208943_dp, 0.00000029_dp, &
"MeV") !! proton mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: PROTON_MASS_IN_U = &
codata_constant_type("proton mass in u", &
1.0072764665789_dp, 0.0000000000083_dp, &
"u") !! proton mass in u

type(codata_constant_type), parameter, public :: PROTON_MOLAR_MASS = &
codata_constant_type("proton molar mass", &
1.00727646764e-3_dp, 0.00000000031e-3_dp, &
"kg mol^-1") !! proton molar mass

type(codata_constant_type), parameter, public :: PROTON_MUON_MASS_RATIO = &
codata_constant_type("proton-muon mass ratio", &
8.88024338_dp, 0.00000020_dp, &
"") !! proton-muon mass ratio

type(codata_constant_type), parameter, public :: PROTON_NEUTRON_MAG_MOM_RATIO = &
codata_constant_type("proton-neutron mag. mom. ratio", &
-1.45989802_dp, 0.00000034_dp, &
"") !! proton-neutron mag. mom. ratio

type(codata_constant_type), parameter, public :: PROTON_NEUTRON_MASS_RATIO = &
codata_constant_type("proton-neutron mass ratio", &
0.99862347797_dp, 0.00000000040_dp, &
"") !! proton-neutron mass ratio

type(codata_constant_type), parameter, public :: PROTON_RELATIVE_ATOMIC_MASS = &
codata_constant_type("proton relative atomic mass", &
1.0072764665789_dp, 0.0000000000083_dp, &
"") !! proton relative atomic mass

type(codata_constant_type), parameter, public :: PROTON_RMS_CHARGE_RADIUS = &
codata_constant_type("proton rms charge radius", &
8.4075e-16_dp, 0.0064e-16_dp, &
"m") !! proton rms charge radius

type(codata_constant_type), parameter, public :: PROTON_TAU_MASS_RATIO = &
codata_constant_type("proton-tau mass ratio", &
0.528051_dp, 0.000036_dp, &
"") !! proton-tau mass ratio

type(codata_constant_type), parameter, public :: QUANTUM_OF_CIRCULATION = &
codata_constant_type("quantum of circulation", &
3.6369475467e-4_dp, 0.0000000011e-4_dp, &
"m^2 s^-1") !! quantum of circulation

type(codata_constant_type), parameter, public :: QUANTUM_OF_CIRCULATION_TIMES_2 = &
codata_constant_type("quantum of circulation times 2", &
7.2738950934e-4_dp, 0.0000000023e-4_dp, &
"m^2 s^-1") !! quantum of circulation times 2

type(codata_constant_type), parameter, public :: REDUCED_COMPTON_WAVELENGTH = &
codata_constant_type("reduced Compton wavelength", &
3.8615926744e-13_dp, 0.0000000012e-13_dp, &
"m") !! reduced Compton wavelength

type(codata_constant_type), parameter, public :: REDUCED_MUON_COMPTON_WAVELENGTH = &
codata_constant_type("reduced muon Compton wavelength", &
1.867594306e-15_dp, 0.000000042e-15_dp, &
"m") !! reduced muon Compton wavelength

type(codata_constant_type), parameter, public :: REDUCED_NEUTRON_COMPTON_WAVELENGTH = &
codata_constant_type("reduced neutron Compton wavelength", &
2.1001941520e-16_dp, 0.0000000011e-16_dp, &
"m") !! reduced neutron Compton wavelength

type(codata_constant_type), parameter, public :: REDUCED_PLANCK_CONSTANT = &
codata_constant_type("reduced Planck constant", &
1.054571817e-34_dp, 0.0_dp, &
"J s") !! reduced Planck constant

type(codata_constant_type), parameter, public :: REDUCED_PLANCK_CONSTANT_IN_EV_S = &
codata_constant_type("reduced Planck constant in eV s", &
6.582119569e-16_dp, 0.0_dp, &
"eV s") !! reduced Planck constant in eV s

type(codata_constant_type), parameter, public :: REDUCED_PLANCK_CONSTANT_TIMES_C_IN_MEV_FM = &
codata_constant_type("reduced Planck constant times c in MeV fm", &
197.3269804_dp, 0.0_dp, &
"MeV fm") !! reduced Planck constant times c in MeV fm

type(codata_constant_type), parameter, public :: REDUCED_PROTON_COMPTON_WAVELENGTH = &
codata_constant_type("reduced proton Compton wavelength", &
2.10308910051e-16_dp, 0.00000000066e-16_dp, &
"m") !! reduced proton Compton wavelength

type(codata_constant_type), parameter, public :: REDUCED_TAU_COMPTON_WAVELENGTH = &
codata_constant_type("reduced tau Compton wavelength", &
1.110538e-16_dp, 0.000075e-16_dp, &
"m") !! reduced tau Compton wavelength

type(codata_constant_type), parameter, public :: RYDBERG_CONSTANT = &
codata_constant_type("Rydberg constant", &
10973731.568157_dp, 0.000012_dp, &
"m^-1") !! Rydberg constant

type(codata_constant_type), parameter, public :: RYDBERG_CONSTANT_TIMES_C_IN_HZ = &
codata_constant_type("Rydberg constant times c in Hz", &
3.2898419602500e15_dp, 0.0000000000036e15_dp, &
"Hz") !! Rydberg constant times c in Hz

type(codata_constant_type), parameter, public :: RYDBERG_CONSTANT_TIMES_HC_IN_EV = &
codata_constant_type("Rydberg constant times hc in eV", &
13.605693122990_dp, 0.000000000015_dp, &
"eV") !! Rydberg constant times hc in eV

type(codata_constant_type), parameter, public :: RYDBERG_CONSTANT_TIMES_HC_IN_J = &
codata_constant_type("Rydberg constant times hc in J", &
2.1798723611030e-18_dp, 0.0000000000024e-18_dp, &
"J") !! Rydberg constant times hc in J

type(codata_constant_type), parameter, public :: SACKUR_TETRODE_CONSTANT_1_K_100_KPA = &
codata_constant_type("Sackur-Tetrode constant (1 K, 100 kPa)", &
-1.15170753496_dp, 0.00000000047_dp, &
"") !! Sackur-Tetrode constant (1 K, 100 kPa)

type(codata_constant_type), parameter, public :: SACKUR_TETRODE_CONSTANT_1_K_101_325_KPA = &
codata_constant_type("Sackur-Tetrode constant (1 K, 101.325 kPa)", &
-1.16487052149_dp, 0.00000000047_dp, &
"") !! Sackur-Tetrode constant (1 K, 101.325 kPa)

type(codata_constant_type), parameter, public :: SECOND_RADIATION_CONSTANT = &
codata_constant_type("second radiation constant", &
1.438776877e-2_dp, 0.0_dp, &
"m K") !! second radiation constant

type(codata_constant_type), parameter, public :: SHIELDED_HELION_GYROMAG_RATIO = &
codata_constant_type("shielded helion gyromag. ratio", &
2.0378946078e8_dp, 0.0000000018e8_dp, &
"s^-1 T^-1") !! shielded helion gyromag. ratio

type(codata_constant_type), parameter, public :: SHIELDED_HELION_GYROMAG_RATIO_IN_MHZ_T = &
codata_constant_type("shielded helion gyromag. ratio in MHz/T", &
32.434100033_dp, 0.000000028_dp, &
"MHz T^-1") !! shielded helion gyromag. ratio in MHz/T

type(codata_constant_type), parameter, public :: SHIELDED_HELION_MAG_MOM = &
codata_constant_type("shielded helion mag. mom.", &
-1.07455311035e-26_dp, 0.00000000093e-26_dp, &
"J T^-1") !! shielded helion mag. mom.

type(codata_constant_type), parameter, public :: SHIELDED_HELION_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("shielded helion mag. mom. to Bohr magneton ratio", &
-1.15867149457e-3_dp, 0.00000000094e-3_dp, &
"") !! shielded helion mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: SHIELDED_HELION_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("shielded helion mag. mom. to nuclear magneton ratio", &
-2.1274977624_dp, 0.0000000017_dp, &
"") !! shielded helion mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: SHIELDED_HELION_TO_PROTON_MAG_MOM_RATIO = &
codata_constant_type("shielded helion to proton mag. mom. ratio", &
-0.76176657721_dp, 0.00000000066_dp, &
"") !! shielded helion to proton mag. mom. ratio

type(codata_constant_type), parameter, public :: SHIELDED_HELION_TO_SHIELDED_PROTON_MAG_MOM_RATIO = &
codata_constant_type("shielded helion to shielded proton mag. mom. ratio", &
-0.7617861334_dp, 0.0000000031_dp, &
"") !! shielded helion to shielded proton mag. mom. ratio

type(codata_constant_type), parameter, public :: SHIELDED_PROTON_GYROMAG_RATIO = &
codata_constant_type("shielded proton gyromag. ratio", &
2.675153194e8_dp, 0.000000011e8_dp, &
"s^-1 T^-1") !! shielded proton gyromag. ratio

type(codata_constant_type), parameter, public :: SHIELDED_PROTON_GYROMAG_RATIO_IN_MHZ_T = &
codata_constant_type("shielded proton gyromag. ratio in MHz/T", &
42.57638543_dp, 0.00000017_dp, &
"MHz T^-1") !! shielded proton gyromag. ratio in MHz/T

type(codata_constant_type), parameter, public :: SHIELDED_PROTON_MAG_MOM = &
codata_constant_type("shielded proton mag. mom.", &
1.4105705830e-26_dp, 0.0000000058e-26_dp, &
"J T^-1") !! shielded proton mag. mom.

type(codata_constant_type), parameter, public :: SHIELDED_PROTON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("shielded proton mag. mom. to Bohr magneton ratio", &
1.5209931551e-3_dp, 0.0000000062e-3_dp, &
"") !! shielded proton mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: SHIELDED_PROTON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("shielded proton mag. mom. to nuclear magneton ratio", &
2.792775648_dp, 0.000000011_dp, &
"") !! shielded proton mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: SHIELDING_DIFFERENCE_OF_D_AND_P_IN_HD = &
codata_constant_type("shielding difference of d and p in HD", &
1.98770e-8_dp, 0.00010e-8_dp, &
"") !! shielding difference of d and p in HD

type(codata_constant_type), parameter, public :: SHIELDING_DIFFERENCE_OF_T_AND_P_IN_HT = &
codata_constant_type("shielding difference of t and p in HT", &
2.39450e-8_dp, 0.00020e-8_dp, &
"") !! shielding difference of t and p in HT

type(codata_constant_type), parameter, public :: SPEED_OF_LIGHT_IN_VACUUM = &
codata_constant_type("speed of light in vacuum", &
299792458_dp, 0.0_dp, &
"m s^-1") !! speed of light in vacuum

type(codata_constant_type), parameter, public :: STANDARD_ACCELERATION_OF_GRAVITY = &
codata_constant_type("standard acceleration of gravity", &
9.80665_dp, 0.0_dp, &
"m s^-2") !! standard acceleration of gravity

type(codata_constant_type), parameter, public :: STANDARD_ATMOSPHERE = &
codata_constant_type("standard atmosphere", &
101325_dp, 0.0_dp, &
"Pa") !! standard atmosphere

type(codata_constant_type), parameter, public :: STANDARD_STATE_PRESSURE = &
codata_constant_type("standard-state pressure", &
100000_dp, 0.0_dp, &
"Pa") !! standard-state pressure

type(codata_constant_type), parameter, public :: STEFAN_BOLTZMANN_CONSTANT = &
codata_constant_type("Stefan-Boltzmann constant", &
5.670374419e-8_dp, 0.0_dp, &
"W m^-2 K^-4") !! Stefan-Boltzmann constant

type(codata_constant_type), parameter, public :: TAU_COMPTON_WAVELENGTH = &
codata_constant_type("tau Compton wavelength", &
6.97771e-16_dp, 0.00047e-16_dp, &
"m") !! tau Compton wavelength

type(codata_constant_type), parameter, public :: TAU_ELECTRON_MASS_RATIO = &
codata_constant_type("tau-electron mass ratio", &
3477.23_dp, 0.23_dp, &
"") !! tau-electron mass ratio

type(codata_constant_type), parameter, public :: TAU_ENERGY_EQUIVALENT = &
codata_constant_type("tau energy equivalent", &
1776.86_dp, 0.12_dp, &
"MeV") !! tau energy equivalent

type(codata_constant_type), parameter, public :: TAU_MASS = &
codata_constant_type("tau mass", &
3.16754e-27_dp, 0.00021e-27_dp, &
"kg") !! tau mass

type(codata_constant_type), parameter, public :: TAU_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("tau mass energy equivalent", &
2.84684e-10_dp, 0.00019e-10_dp, &
"J") !! tau mass energy equivalent

type(codata_constant_type), parameter, public :: TAU_MASS_IN_U = &
codata_constant_type("tau mass in u", &
1.90754_dp, 0.00013_dp, &
"u") !! tau mass in u

type(codata_constant_type), parameter, public :: TAU_MOLAR_MASS = &
codata_constant_type("tau molar mass", &
1.90754e-3_dp, 0.00013e-3_dp, &
"kg mol^-1") !! tau molar mass

type(codata_constant_type), parameter, public :: TAU_MUON_MASS_RATIO = &
codata_constant_type("tau-muon mass ratio", &
16.8170_dp, 0.0011_dp, &
"") !! tau-muon mass ratio

type(codata_constant_type), parameter, public :: TAU_NEUTRON_MASS_RATIO = &
codata_constant_type("tau-neutron mass ratio", &
1.89115_dp, 0.00013_dp, &
"") !! tau-neutron mass ratio

type(codata_constant_type), parameter, public :: TAU_PROTON_MASS_RATIO = &
codata_constant_type("tau-proton mass ratio", &
1.89376_dp, 0.00013_dp, &
"") !! tau-proton mass ratio

type(codata_constant_type), parameter, public :: THOMSON_CROSS_SECTION = &
codata_constant_type("Thomson cross section", &
6.6524587051e-29_dp, 0.0000000062e-29_dp, &
"m^2") !! Thomson cross section

type(codata_constant_type), parameter, public :: TRITON_ELECTRON_MASS_RATIO = &
codata_constant_type("triton-electron mass ratio", &
5496.92153551_dp, 0.00000021_dp, &
"") !! triton-electron mass ratio

type(codata_constant_type), parameter, public :: TRITON_G_FACTOR = &
codata_constant_type("triton g factor", &
5.957924930_dp, 0.000000012_dp, &
"") !! triton g factor

type(codata_constant_type), parameter, public :: TRITON_MAG_MOM = &
codata_constant_type("triton mag. mom.", &
1.5046095178e-26_dp, 0.0000000030e-26_dp, &
"J T^-1") !! triton mag. mom.

type(codata_constant_type), parameter, public :: TRITON_MAG_MOM_TO_BOHR_MAGNETON_RATIO = &
codata_constant_type("triton mag. mom. to Bohr magneton ratio", &
1.6223936648e-3_dp, 0.0000000032e-3_dp, &
"") !! triton mag. mom. to Bohr magneton ratio

type(codata_constant_type), parameter, public :: TRITON_MAG_MOM_TO_NUCLEAR_MAGNETON_RATIO = &
codata_constant_type("triton mag. mom. to nuclear magneton ratio", &
2.9789624650_dp, 0.0000000059_dp, &
"") !! triton mag. mom. to nuclear magneton ratio

type(codata_constant_type), parameter, public :: TRITON_MASS = &
codata_constant_type("triton mass", &
5.0073567512e-27_dp, 0.0000000016e-27_dp, &
"kg") !! triton mass

type(codata_constant_type), parameter, public :: TRITON_MASS_ENERGY_EQUIVALENT = &
codata_constant_type("triton mass energy equivalent", &
4.5003878119e-10_dp, 0.0000000014e-10_dp, &
"J") !! triton mass energy equivalent

type(codata_constant_type), parameter, public :: TRITON_MASS_ENERGY_EQUIVALENT_IN_MEV = &
codata_constant_type("triton mass energy equivalent in MeV", &
2808.92113668_dp, 0.00000088_dp, &
"MeV") !! triton mass energy equivalent in MeV

type(codata_constant_type), parameter, public :: TRITON_MASS_IN_U = &
codata_constant_type("triton mass in u", &
3.01550071597_dp, 0.00000000010_dp, &
"u") !! triton mass in u

type(codata_constant_type), parameter, public :: TRITON_MOLAR_MASS = &
codata_constant_type("triton molar mass", &
3.01550071913e-3_dp, 0.00000000094e-3_dp, &
"kg mol^-1") !! triton molar mass

type(codata_constant_type), parameter, public :: TRITON_PROTON_MASS_RATIO = &
codata_constant_type("triton-proton mass ratio", &
2.99371703403_dp, 0.00000000010_dp, &
"") !! triton-proton mass ratio

type(codata_constant_type), parameter, public :: TRITON_RELATIVE_ATOMIC_MASS = &
codata_constant_type("triton relative atomic mass", &
3.01550071597_dp, 0.00000000010_dp, &
"") !! triton relative atomic mass

type(codata_constant_type), parameter, public :: TRITON_TO_PROTON_MAG_MOM_RATIO = &
codata_constant_type("triton to proton mag. mom. ratio", &
1.0666399189_dp, 0.0000000021_dp, &
"") !! triton to proton mag. mom. ratio

type(codata_constant_type), parameter, public :: UNIFIED_ATOMIC_MASS_UNIT = &
codata_constant_type("unified atomic mass unit", &
1.66053906892e-27_dp, 0.00000000052e-27_dp, &
"kg") !! unified atomic mass unit

type(codata_constant_type), parameter, public :: VACUUM_ELECTRIC_PERMITTIVITY = &
codata_constant_type("vacuum electric permittivity", &
8.8541878188e-12_dp, 0.0000000014e-12_dp, &
"F m^-1") !! vacuum electric permittivity

type(codata_constant_type), parameter, public :: VACUUM_MAG_PERMEABILITY = &
codata_constant_type("vacuum mag. permeability", &
1.25663706127e-6_dp, 0.00000000020e-6_dp, &
"N A^-2") !! vacuum mag. permeability

type(codata_constant_type), parameter, public :: VON_KLITZING_CONSTANT = &
codata_constant_type("von Klitzing constant", &
25812.80745_dp, 0.0_dp, &
"ohm") !! von Klitzing constant

type(codata_constant_type), parameter, public :: WEAK_MIXING_ANGLE = &
codata_constant_type("weak mixing angle", &
0.22305_dp, 0.00023_dp, &
"") !! weak mixing angle

type(codata_constant_type), parameter, public :: WIEN_FREQUENCY_DISPLACEMENT_LAW_CONSTANT = &
codata_constant_type("Wien frequency displacement law constant", &
5.878925757e10_dp, 0.0_dp, &
"Hz K^-1") !! Wien frequency displacement law constant

type(codata_constant_type), parameter, public :: WIEN_WAVELENGTH_DISPLACEMENT_LAW_CONSTANT = &
codata_constant_type("Wien wavelength displacement law constant", &
2.897771955e-3_dp, 0.0_dp, &
"m K") !! Wien wavelength displacement law constant

type(codata_constant_type), parameter, public :: W_TO_Z_MASS_RATIO = &
codata_constant_type("W to Z mass ratio", &
0.88145_dp, 0.00013_dp, &
"") !! W to Z mass ratio

end module stdlib_codata

! Vector norm: demonstrate usage of the function interface
program example_norm
  use stdlib_linalg, only: norm, linalg_state_type
  implicit none
  
  real :: a(3,3),na
  integer :: j
  type(linalg_state_type) :: err
    
  ! a = [   -3.00000000   0.00000000   3.00000000
  !         -2.00000000   1.00000000   4.00000000
  !         -1.00000000   2.00000000   5.00000000   ]  
  a = reshape([(j-4,j=1,9)], [3,3])
  
  print "(' a = [   ',3(g0,3x),2(/9x,3(g0,3x)),']')", transpose(a)
    
  ! Norm with integer input
  print *, 'Euclidean norm      = ',norm(a, 2)        ! 8.30662346
  
  ! Norm with character input
  print *, 'Euclidean norm      = ',norm(a, '2')      ! 8.30662346
  
  ! Euclidean norm of row arrays, a(i,:)
  print *, 'Rows norms          = ',norm(a, 2, dim=2) ! 4.24264050       4.58257580       5.47722578  
  
  ! Euclidean norm of columns arrays, a(:,i)
  print *, 'Columns norms       = ',norm(a, 2, dim=1) ! 3.74165750       2.23606801       7.07106781 
  
  ! Infinity norms
  print *, 'maxval(||a||)       = ',norm(a, 'inf')          ! 5.00000000
  print *, 'maxval(||a(i,:)||)  = ',norm(a, 'inf', dim=2)   ! 3.00000000       4.00000000       5.00000000
  print *, 'minval(||a||)       = ',norm(a, '-inf')         ! 0.00000000
  print *, 'minval(||a(:,i)||)  = ',norm(a, '-inf', dim=1)  ! 1.00000000       0.00000000       3.00000000 
  
  ! Catch Error: 
  ! [norm] returned Value Error: dimension 4 is out of rank for shape(a)= [3, 3]
  print *, 'invalid: ',norm(a,'inf', dim=4, err=err)
  print *, 'error =  ',err%print()  

end program example_norm

! Process example 2: Run an Asynchronous Command and check its status
program run_async
    use stdlib_system, only: process_type, runasync, is_running, wait
    implicit none

    type(process_type) :: p

    ! Run an asynchronous process to sleep for 1 second
    p = runasync("sleep 1")

    ! Check if the process is running
    if (is_running(p)) then
        print *, "Process is running."
    else
        print *, "Process has already completed."
    end if

    ! Wait for the process to complete
    call wait(p, max_wait_time = 5.0)
    print *, "Process has now completed."
end program run_async

program example_set
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0
  call set0%init(166)
  if (set0%none()) write (*, *) 'SET0 is properly initialized.'
  call set0%set(165)
  if (set0%test(165)) write (*, *) 'Bit 165 is set.'
  call set0%set(0, 164)
  if (set0%all()) write (*, *) 'All bits are set.'
end program example_set

program example_ge
  use stdlib_bitsets
  implicit none
  type(bitset_64) :: set0, set1, set2
  call set0%init(33)
  call set1%init(33)
  call set2%init(33)
  call set1%set(0)
  call set2%set(32)
  if (set1 >= set0 .and. set2 >= set1 .and. set2 >= set0 .and. &
      set0 >= set0 .and. set1 >= set1 .and. set2 >= set2 .and. &
      .not. set0 >= set1 .and. .not. set0 >= set2 .and. .not. &
      set1 >= set2) then
    write (*, *) 'Passed 64 bit greater than or equals tests.'
  else
    error stop 'Failed 64 bit greater than or equals tests.'
  end if
end program example_ge

program example_find
  use stdlib_string_type, only: string_type, assignment(=)
  use stdlib_strings, only: find
  implicit none
  type(string_type) :: string

  string = "needle in the character-stack"

  print *, find(string, "needle")                       ! 1
  print *, find(string, ["a", "c"], [3, 2])             ! [27, 20]
  print *, find("qwqwqwq", "qwq", 3, [.false., .true.]) ! [0, 5]

end program example_find

program example_hasher_fun
  use stdlib_hashmap_wrappers, only: fnv_1a_hasher, hasher_fun, set, key_type
  use stdlib_kinds, only: int8, int32
  implicit none
  procedure(hasher_fun), pointer :: hasher_pointer
  integer(int8), allocatable :: array1(:)
  integer(int32) :: hash
  type(key_type) :: key
  hasher_pointer => fnv_1a_hasher
  array1 = [5_int8, 4_int8, 3_int8, 1_int8, 10_int8, 4_int8]
  call set(key, array1)
  hash = hasher_pointer(key)
  print *, hash
end program example_hasher_fun

program test_chaining_maps
!! Test various aspects of the runtime system.
!! Running this program may require increasing the stack size to above 48 MBytes
!! or decreasing rand_power to 20 or less

    use stdlib_kinds, only: &
        dp,                 &
        int8,               &
        int32
 
    use stdlib_hashmaps, only : chaining_hashmap_type, int_depth, int_index
    use stdlib_hashmap_wrappers

    implicit none

    type dummy_type
        integer(int8), allocatable :: value(:)
    end type dummy_type

    integer(int32), parameter :: huge32 = huge(0_int32)
    real(dp), parameter       :: hugep1 = real(huge32, dp) + 1.0_dp
    integer, parameter        :: rand_power = 18
    integer, parameter        :: rand_size = 2**rand_power
    integer, parameter        :: test_size = rand_size*4
    integer, parameter        :: test_16 = 2**4
    integer, parameter        :: test_256 = 2**8

    integer                     :: index
    integer                     :: lun
    type(chaining_hashmap_type) :: map
    real(dp)                    :: rand2(2)
    integer(int32)              :: rand_object(rand_size)
    integer(int8)               :: test_8_bits(test_size)

    open( newunit=lun, file="test_chaining_maps.txt", access="sequential", &
        action="write", form="formatted", position="rewind" )
    write(lun, '("| ", a17, " | ", a12, " | ", a15, " | ", a10, " |")') &
        'Algorithm', 'Process', 'Data Set', 'Time (s)'

    do index=1, rand_size
        call random_number(rand2)
        if (rand2(1) < 0.5_dp) then
            rand_object(index) = ceiling(-rand2(2)*hugep1, int32) - 1
        else
            rand_object(index) = floor(rand2(2)*hugep1, int32)
        end if
    end do

    test_8_bits(:) = transfer( rand_object, 0_int8, test_size )

    ! Test implicit initalization by skipping init call for first test.
    call input_random_data( map, test_16, 'FNV-1', "16 byte words" )
    call test_inquire_data( map, test_16, 'FNV-1', "16 byte words" )
    call test_get_all_keys( map, test_16, 'FNV-1', '16 byte words' )
    call test_get_data( map, test_16, 'FNV-1', '16 byte words' )
    call report_rehash_times( map, fnv_1_hasher, 'FNV-1', '16 byte words' )
    call report_hash_statistics( map, 'FNV-1', '16 byte words' )
    call report_removal_times( map, test_16, 'FNV-1', '16 byte words' )

    call map % init()   ! Test default options
    call input_random_data( map, test_256, 'FNV-1', "256 byte words" )
    call test_inquire_data( map, test_256, 'FNV-1', "256 byte words" )
    call test_get_data( map, test_256, 'FNV-1', '256 byte words' )
    call test_get_all_keys( map, test_256, 'FNV-1', '256 byte words' )
    call report_rehash_times( map, fnv_1_hasher, 'FNV-1', '256 byte words' )
    call report_hash_statistics( map, 'FNV-1', '256 byte words' )
    call report_removal_times( map, test_256, 'FNV-1', '256 byte words' )

    call map % init( fnv_1a_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'FNV-1A', "16 byte words" )
    call test_inquire_data( map, test_16, 'FNV-1A', "16 byte words" )
    call test_get_data( map, test_16, 'FNV-1A', '16 byte words' )
    call test_get_all_keys( map, test_16, 'FNV-1A', '16 byte words' )
    call report_rehash_times( map, fnv_1a_hasher, 'FNV-1', '16 byte words' )
    call report_hash_statistics( map, 'FNV-1A', '16 byte words' )
    call report_removal_times( map, test_16, 'FNV-1a', '16 byte words' )

    call map % init( fnv_1a_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'FNV-1A', "256 byte words" )
    call test_inquire_data( map, test_256, 'FNV-1A', "256 byte words" )
    call test_get_data( map, test_256, 'FNV-1A', '256 byte words' )
    call test_get_all_keys( map, test_256, 'FNV-1A', '256 byte words' )
    call report_rehash_times( map, fnv_1_hasher, 'FNV-1A', '256 byte words' )
    call report_hash_statistics( map, 'FNV-1A', '256 byte words' )
    call report_removal_times( map, test_256, 'FNV-1A', '256 byte words' )

    call map % init( seeded_nmhash32_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'Seeded_Nmhash32', "16 byte words" )
    call test_inquire_data( map, test_16, 'Seeded_Nmhash32', "16 byte words" )
    call test_get_data( map, test_16, 'Seeded_Nmhash32', '16 byte words' )
    call test_get_all_keys( map, test_16, 'Seeded_Nmhash32', '16 byte words' )
    call report_rehash_times( map, seeded_nmhash32_hasher, 'Seeded_Nmhash32', &
        '16 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32', '16 byte words' )
    call report_removal_times( map, test_16, 'Seeded_Nmhash32', &
        '16 byte words' )

    call map % init( seeded_nmhash32_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'Seeded_Nmhash32', "256 byte words" )
    call test_inquire_data( map, test_256, 'Seeded_Nmhash32', "256 byte words" )
    call test_get_data( map, test_256, 'Seeded_Nmhash32', '256 byte words' )
    call test_get_all_keys( map, test_256, 'Seeded_Nmhash32', '256 byte words' )
    call report_rehash_times( map, seeded_nmhash32_hasher, 'Seeded_Nmhash32', &
        '256 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32', '256 byte words' )
    call report_removal_times( map, test_256, 'Seeded_Nmhash32', &
        '256 byte words' )

    call map % init( seeded_nmhash32x_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'Seeded_Nmhash32x', "16 byte words" )
    call test_inquire_data( map, test_16, 'Seeded_Nmhash32x', "16 byte words" )
    call test_get_data( map, test_16, 'Seeded_Nmhash32x', '16 byte words' )
    call test_get_all_keys( map, test_16, 'Seeded_Nmhash32x', '16 byte words' )
    call report_rehash_times( map, seeded_nmhash32x_hasher, &
        'Seeded_Nmhash32x', '16 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32x', '16 byte words' )
    call report_removal_times( map, test_16, 'Seeded_Nmhash32x', &
        '16 byte words' )

    call map % init( seeded_nmhash32x_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'Seeded_Nmhash32x', &
        "256 byte words" )
    call test_inquire_data( map, test_256, 'Seeded_Nmhash32x', &
        "256 byte words" )
    call test_get_data( map, test_256, 'Seeded_Nmhash32x', '256 byte words' )
    call test_get_all_keys( map, test_256, 'Seeded_Nmhash32x', '256 byte words' )
    call report_rehash_times( map, seeded_nmhash32x_hasher, &
        'Seeded_Nmhash32x', '256 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32x', '256 byte words' )
    call report_removal_times( map, test_256, 'Seeded_Nmhash32x', &
        '256 byte words' )

    call map % init( seeded_water_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'Seeded_Water', "16 byte words" )
    call test_inquire_data( map, test_16, 'Seeded_Water', "16 byte words" )
    call test_get_data( map, test_16, 'Seeded_Water', '16 byte words' )
    call test_get_all_keys( map, test_16, 'Seeded_Water', '16 byte words' )
    call report_rehash_times( map, seeded_water_hasher, &
        'Seeded_Water', '16 byte words' )
    call report_hash_statistics( map, 'Seeded_Water', '16 byte words' )
    call report_removal_times( map, test_16, 'Seeded_Water', &
        '16 byte words' )

    call map % init( seeded_water_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'Seeded_Water', &
        "256 byte words" )
    call test_inquire_data( map, test_256, 'Seeded_Water', &
        "256 byte words" )
    call test_get_data( map, test_256, 'Seeded_Water', '256 byte words' )
    call test_get_all_keys( map, test_256, 'Seeded_Water', '256 byte words' )
    call report_rehash_times( map, seeded_water_hasher, &
        'Seeded_Water', '256 byte words' )
    call report_hash_statistics( map, 'Seeded_Water', '256 byte words' )
    call report_removal_times( map, test_256, 'Seeded_Water', &
        '256 byte words' )

contains

    subroutine input_random_data( map, test_block, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in) :: test_block
        character(*), intent(in) :: hash_name
        character(*), intent(in) :: size_name
        type(dummy_type) :: dummy_val
        integer :: index2
        type(key_type) :: key
        real :: t1, t2, tdiff
        logical :: conflict

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            dummy_val % value = test_8_bits( index2:index2+test_block-1 )
            call map % map_entry( key, dummy_val, conflict )
            if (conflict) &
                error stop "Unable to map entry because of a key conflict."
        end do
        call cpu_time(t2)
        tdiff = t2-t1
        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Enter data', size_name, tdiff

    end subroutine input_random_data


    subroutine test_inquire_data( map, test_block, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        integer :: index2
        logical :: present
        type(key_type) :: key
        real :: t1, t2, tdiff

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            call map % key_test( key, present )
            if (.not. present) &
                error stop "KEY not found in map KEY_TEST."
        end do
        call cpu_time(t2)
        tdiff = t2-t1
        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Inquire data', size_name, tdiff

    end subroutine test_inquire_data


    subroutine test_get_data( map, test_block, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        integer :: index2
        type(key_type) :: key
        class(*), allocatable :: data
        logical :: exists
        real :: t1, t2, tdiff

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            call map % get_other_data( key, data, exists )
            if (.not. exists) &
                error stop "Unable to get data because key not found in map."
        end do
        call cpu_time(t2)
        tdiff = t2-t1
        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Get data', size_name, tdiff

    end subroutine test_get_data


    subroutine test_get_all_keys( map, test_block, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        integer :: index2, key_idx
        type(key_type) :: key
        type(key_type), allocatable :: all_keys(:)
        real :: t1, t2, tdiff

        call cpu_time(t1)
        call map % get_all_keys(all_keys)
        call cpu_time(t2)
        tdiff = t2-t1

        if (size( all_keys ) /= size( test_8_bits )/test_block) &
            error stop "Number of keys is different from that of keys in a map."

        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )

            key_idx = ( index2/test_block ) + 1
            if (.not. ( all_keys(key_idx) == key )) &
                error stop "Invalid value of a key."
        end do

        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Get all keys', size_name, tdiff

    end subroutine test_get_all_keys


    subroutine report_rehash_times( map, hasher, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        procedure(hasher_fun)                   :: hasher
        character(*), intent(in)                :: hash_name, size_name
        real :: t1, t2, tdiff

        call cpu_time(t1)
        call map % rehash( hasher )
        call cpu_time(t2)
        tdiff = t2-t1

        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Rehash data', size_name, tdiff

    end subroutine report_rehash_times


    subroutine report_removal_times( map, test_block, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        real :: t1, t2, tdiff
        type(key_type) :: key
        integer(int_index) :: index2
        logical :: existed

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            call map % remove(key, existed)
            if ( .not. existed ) &
                error stop "Key not found in entry removal."
        end do
        call cpu_time(t2)
        tdiff = t2-t1

        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Remove data', size_name, tdiff
        flush(lun)

    end subroutine report_removal_times


    subroutine report_hash_statistics( map, hash_name, size_name )
        type(chaining_hashmap_type), intent(inout) :: map
        character(*), intent(in)                :: hash_name, size_name
        integer(int_depth) :: depth

        write(lun, *)
        write(lun, '("Statistics for chaining hash table with ",' // &
              'A, " hasher on ", A, ".")' ) hash_name, size_name
        write(lun, '("Slots = ", I0)' ) map % num_slots()
        write(lun, '("Calls = ", I0)' ) map % calls()
        write(lun, '("Entries = ", I0)' ) map % entries()
        write(lun, '("Total probes = ", I0)' ) map % map_probes()
        write(lun, '("Loading = ", ES10.3)' ) map % loading()
        depth = map % total_depth()
        write(lun, '("Total depth = ", I0)' ) depth
        write(lun, '("Relative depth = ", ES10.3)') &
            real( depth ) / real( map % entries() )

    end subroutine report_hash_statistics


end program test_chaining_maps

program example_num_slots
  use stdlib_hashmaps, only: chaining_hashmap_type, int_index
  implicit none
  type(chaining_hashmap_type) :: map
  integer(int_index) :: initial_slots
  call map%init()
  initial_slots = map%num_slots()
  print *, "Initial slots =  ", initial_slots
end program example_num_slots

program example_to_title
  use stdlib_ascii, only: to_title
  implicit none
  print *, to_title("hello there!") ! returns "Hello There!"
  print *, to_title("'enquoted'") ! returns "'Enquoted'"
  print *, to_title("1st")  ! returns "1st"
end program example_to_title

program example_key_test
  use stdlib_kinds, only: int8
  use stdlib_hashmaps, only: chaining_hashmap_type
  use stdlib_hashmap_wrappers, only: key_type, set
  implicit none
  type(chaining_hashmap_type) :: map
  type(key_type) :: key
  logical :: present
  
  call map%init()
  call set(key, [0_int8, 1_int8])
  call map%key_test(key, present)
  print *, "Initial key of 10 present for empty map =  ", present
  
end program example_key_test

program example_char_position
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  character(len=:), allocatable :: dlc
  character(len=1), allocatable :: chars(:)

  string = "Character sequence"
  dlc = char(string, 3)
! dlc == "a"
  chars = char(string, [3, 5, 8, 12, 14, 15, 18])
! chars == ["a", "a", "e", "e", "u", "e", "e"]
end program example_char_position

submodule (stdlib_error) f08estop

implicit none

contains

module procedure error_stop
! Aborts the program with nonzero exit code
! this is a fallback for Fortran 2008 error stop (e.g. Intel 19.1/2020 compiler)
!
! The "stop <character>" statement generally has return code 0.
! To allow non-zero return code termination with character message,
! error_stop() uses the statement "error stop", which by default
! has exit code 1 and prints the message to stderr.
! An optional integer return code "code" may be specified.
!
! Example
! -------
!
! call error_stop("Invalid argument")

write(stderr,*) msg

if(present(code)) then
  select case (code)
  case (1)
    error stop 1
  case (2)
    error stop 2
  case (77)
    error stop 77
  case default
    write(stderr,*) 'ERROR: code ',code,' was specified.'
    error stop
  end select
else
  error stop
endif
end procedure

end submodule f08estop

program example_nmhash32x
  use stdlib_hash_32bit, only: nmhash32x, &
                               new_nmhash32x_seed
  use iso_fortran_env, only: int32
  implicit none
  integer(int32) :: hash
  integer(int32) :: seed = 42_int32
  call new_nmhash32x_seed(seed)
  hash = nmhash32x([5, 4, 3, 1, 10, 4, 9], seed)
  print *, seed, hash
end program example_nmhash32x

program example_trim
  use stdlib_string_type
  implicit none
  type(string_type) :: string

  string = "Whitespace                            "
  string = trim(string)
! len(string) == 10
end program example_trim

! Demonstrate usage of `FS_ERROR`, `FS_ERROR_CODE`
program example_fs_error
    use stdlib_system, only: FS_ERROR, FS_ERROR_CODE
    use stdlib_error, only: state_type, STDLIB_FS_ERROR
    implicit none

    type(state_type) :: err0, err1

    err0 = FS_ERROR("Could not create directory", "`temp.dir`", "- Already exists")

    if (err0%state == STDLIB_FS_ERROR) then
        ! Error encountered: Filesystem Error: Could not create directory `temp.dir` - Already exists
        print *, err0%print() 
    end if

    err1 = FS_ERROR_CODE(1, "Could not create directory", "`temp.dir`", "- Already exists")

    if (err1%state == STDLIB_FS_ERROR) then
        ! Error encountered: Filesystem Error: code - 1, Could not create directory `temp.dir` - Already exists
        print *, err1%print()
    end if

end program example_fs_error

program example_state2
  !! This example shows how to set a `type(linalg_state_type)` variable to process output conditions 
  !! out of a simple division routine. The example is meant to highlight: 
  !! 1) the different mechanisms that can be used to initialize the `linalg_state` variable providing 
  !!    strings, scalars, or arrays, on input to it; 
  !! 2) `pure` setup of the error control
  use stdlib_linalg_state, only: linalg_state_type, LINALG_VALUE_ERROR, LINALG_SUCCESS, &
          linalg_error_handling
  implicit none
  type(linalg_state_type) :: err
  real :: a_div_b
  
  ! OK
  call very_simple_division(0.0,2.0,a_div_b,err)
  print *, err%print()
  
  ! Division by zero
  call very_simple_division(1.0,0.0,a_div_b,err)
  print *, err%print()  

  ! Out of bounds
  call very_simple_division(huge(0.0),0.001,a_div_b,err)
  print *, err%print()  
  
  contains
  
     !> Simple division returning an integer flag (LAPACK style)
     elemental subroutine very_simple_division(a,b,a_div_b,err)
        real, intent(in) :: a,b
        real, intent(out) :: a_div_b
        type(linalg_state_type), optional, intent(out) :: err
        
        type(linalg_state_type) :: err0
        real, parameter :: MAXABS = huge(0.0)
        character(*), parameter :: this = 'simple division'
        
        !> Check a
        if (b==0.0) then 
            ! Division by zero
            err0 = linalg_state_type(this,LINALG_VALUE_ERROR,'Division by zero trying ',a,'/',b)
        elseif (.not.abs(b)<MAXABS) then 
            ! B is out of bounds
            err0 = linalg_state_type(this,LINALG_VALUE_ERROR,'B is infinity in a/b: ',[a,b]) ! use an array
        elseif (.not.abs(a)<MAXABS) then 
            ! A is out of bounds
            err0 = linalg_state_type(this,LINALG_VALUE_ERROR,'A is infinity in a/b: a=',a,' b=',b)
        else
            a_div_b = a/b
            if (.not.abs(a_div_b)<MAXABS) then 
                ! Result is out of bounds
                err0 = linalg_state_type(this,LINALG_VALUE_ERROR,'A/B is infinity in a/b: a=',a,' b=',b)
            else
                err0%state = LINALG_SUCCESS
            end if
        end if
        
        ! Return error flag, or hard stop on failure
        call linalg_error_handling(err0,err)
                
     end subroutine very_simple_division


end program example_state2

program example_fread
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: io
  string = "Important saved value"

  open (newunit=io, form="formatted", status="scratch")
  write (io, *) string
  write (io, *)

  rewind (io)

  read (io, *) string
  close (io)
end program example_fread

! QR example with pre-allocated storage
program example_qr_space
  use stdlib_linalg_constants, only: ilp
  use stdlib_linalg, only: qr, qr_space, linalg_state_type
  implicit none
  real :: A(104, 32), Q(104,32), R(32,32)
  real, allocatable :: work(:)
  integer(ilp) :: lwork
  type(linalg_state_type) :: err
  
  ! Create a random matrix
  call random_number(A)

  ! Prepare QR workspace
  call qr_space(A,lwork)
  allocate(work(lwork))

  ! Compute its QR factorization (reduced)
  call qr(A,Q,R,storage=work,err=err)

  ! Test factorization: Q*R = A 
  print *, maxval(abs(matmul(Q,R)-A))
  print *, err%print() 

end program example_qr_space

program example_constructor_logical
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  string = string_type(.true.)
! len(string) == 1
  string = string_type(.false.)
! len(string) == 1
end program example_constructor_logical

program example_diag4
  use stdlib_linalg, only: diag
  implicit none
  integer, parameter :: n = 12
  real :: A(n, n)
  real :: v(n)
  call random_number(A)
  v = diag(A) ! v contains diagonal elements of A
end program example_diag4

program example_to_title
  use stdlib_string_type
  implicit none
  type(string_type) :: string, titlecase_string

  string = "titlecase this string."
! string <-- "titlecase this string."

  titlecase_string = to_title(string)
! string <-- "titlecase this string."
! titlecase_string <-- "Titlecase This String."
end program example_to_title

program example_stream_of_strings_to_numbers
    use stdlib_kinds, only: dp
    use stdlib_str2num, only: to_num_from_stream
    implicit none
    character(:), allocatable, target :: chain
    character(len=:), pointer :: cptr
    real(dp), allocatable :: r(:), p(:)
    integer :: i 

    chain = " 1.234   1.E1 1e0     0.1234E0  12.21e+001 -34.5E1"
    allocate( r(6), p(6) )
    !> Example for streamline conversion using `to_num_from_stream`
    cptr => chain
    do i =1, 6
        r(i) = to_num_from_stream( cptr , r(i) ) !> the pointer is shifted within the function
    end do
    read(chain,*) p
    print *, "Reading with to_num_from_stream"
    print *, r
    print *, "Reading with formatted read"
    print *, p

end program example_stream_of_strings_to_numbers

program test_open_maps
!! Test various aspects of the runtime system.
!! Running this program may require increasing the stack size to above 48 MBytes
!! or decreasing rand_power to 20 or less

    use stdlib_kinds, only: &
        dp,                 &
        int8,               &
        int32

    use stdlib_hashmaps, only : open_hashmap_type, int_depth, int_index
    use stdlib_hashmap_wrappers

    implicit none

    type dummy_type
        integer(int8), allocatable :: value(:)
    end type dummy_type

    integer(int32), parameter :: huge32 = huge(0_int32)
    real(dp), parameter       :: hugep1 = real(huge32, dp) + 1.0_dp
    integer, parameter        :: rand_power = 18
    integer, parameter        :: rand_size = 2**rand_power
    integer, parameter        :: test_size = rand_size*4
    integer, parameter        :: test_16 = 2**4
    integer, parameter        :: test_256 = 2**8

    integer                   :: index
    integer                   :: lun
    type(open_hashmap_type)   :: map
    real(dp)                  :: rand2(2)
    integer(int32)            :: rand_object(rand_size)
    integer(int8)             :: test_8_bits(test_size)


    open( newunit=lun, file="test_open_maps.txt", access="sequential", &
        action="write", form="formatted", position="rewind" )
    write(lun, '("| ", a17, " | ", a12, " | ", a15, " | ", a10, " |")') &
        'Algorithm', 'Process', 'Data Set', 'Time (s)'

    do index=1, rand_size
        call random_number(rand2)
        if (rand2(1) < 0.5_dp) then
            rand_object(index) = ceiling(-rand2(2)*hugep1, int32) - 1
        else
            rand_object(index) = floor(rand2(2)*hugep1, int32)
        end if
    end do

    test_8_bits(:) = transfer( rand_object, 0_int8, test_size )

    ! Test implicit initalization by skipping init call for first test.
    call input_random_data( map, test_16, 'FNV-1', "16 byte words" )
    call test_inquire_data( map, test_16, 'FNV-1', "16 byte words" )
    call test_get_data( map, test_16, 'FNV-1', '16 byte words' )
    call test_get_all_keys( map, test_16, 'FNV-1', '16 byte words' )
    call report_rehash_times( map, fnv_1_hasher, 'FNV-1', '16 byte words' )
    call report_hash_statistics( map, 'FNV-1', '16 byte words' )
    call report_removal_times( map, test_16, 'FNV-1', '16 byte words' )

    call map % init()   ! Test default options
    call input_random_data( map, test_256, 'FNV-1', "256 byte words" )
    call test_inquire_data( map, test_256, 'FNV-1', "256 byte words" )
    call test_get_data( map, test_256, 'FNV-1', '256 byte words' )
    call test_get_all_keys( map, test_256, 'FNV-1', '256 byte words' )
    call report_rehash_times( map, fnv_1_hasher, 'FNV-1', '256 byte words' )
    call report_hash_statistics( map, 'FNV-1', '256 byte words' )
    call report_removal_times( map, test_256, 'FNV-1', '256 byte words' )

    call map % init( fnv_1a_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'FNV-1A', "16 byte words" )
    call test_inquire_data( map, test_16, 'FNV-1A', "16 byte words" )
    call test_get_data( map, test_16, 'FNV-1A', '16 byte words' )
    call test_get_all_keys( map, test_16, 'FNV-1A', '16 byte words' )
    call report_rehash_times( map, fnv_1a_hasher, 'FNV-1', '16 byte words' )
    call report_hash_statistics( map, 'FNV-1A', '16 byte words' )
    call report_removal_times( map, test_16, 'FNV-1a', '16 byte words' )

    call map % init( fnv_1a_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'FNV-1A', "256 byte words" )
    call test_inquire_data( map, test_256, 'FNV-1A', "256 byte words" )
    call test_get_data( map, test_256, 'FNV-1A', '256 byte words' )
    call test_get_all_keys( map, test_256, 'FNV-1A', '256 byte words' )
    call report_rehash_times( map, fnv_1_hasher, 'FNV-1A', '256 byte words' )
    call report_hash_statistics( map, 'FNV-1A', '256 byte words' )
    call report_removal_times( map, test_256, 'FNV-1A', '256 byte words' )

    call map % init( seeded_nmhash32_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'Seeded_Nmhash32', "16 byte words" )
    call test_inquire_data( map, test_16, 'Seeded_Nmhash32', "16 byte words" )
    call test_get_data( map, test_16, 'Seeded_Nmhash32', '16 byte words' )
    call test_get_all_keys( map, test_16, 'Seeded_Nmhash32', '16 byte words' )
    call report_rehash_times( map, seeded_nmhash32_hasher, 'Seeded_Nmhash32', &
        '16 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32', '16 byte words' )
    call report_removal_times( map, test_16, 'Seeded_Nmhash32', &
        '16 byte words' )

    call map % init( seeded_nmhash32_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'Seeded_Nmhash32', "256 byte words" )
    call test_inquire_data( map, test_256, 'Seeded_Nmhash32', "256 byte words" )
    call test_get_data( map, test_256, 'Seeded_Nmhash32', '256 byte words' )
    call test_get_all_keys( map, test_256, 'Seeded_Nmhash32', '256 byte words' )
    call report_rehash_times( map, seeded_nmhash32_hasher, 'Seeded_Nmhash32', &
        '256 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32', '256 byte words' )
    call report_removal_times( map, test_256, 'Seeded_Nmhash32', &
        '256 byte words' )

    call map % init( seeded_nmhash32x_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'Seeded_Nmhash32x', "16 byte words" )
    call test_inquire_data( map, test_16, 'Seeded_Nmhash32x', "16 byte words" )
    call test_get_data( map, test_16, 'Seeded_Nmhash32x', '16 byte words' )
    call test_get_all_keys( map, test_16, 'Seeded_Nmhash32x', '16 byte words' )
    call report_rehash_times( map, seeded_nmhash32x_hasher, &
        'Seeded_Nmhash32x', '16 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32x', '16 byte words' )
    call report_removal_times( map, test_16, 'Seeded_Nmhash32x', &
        '16 byte words' )

    call map % init( seeded_nmhash32x_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'Seeded_Nmhash32x', &
        "256 byte words" )
    call test_inquire_data( map, test_256, 'Seeded_Nmhash32x', &
        "256 byte words" )
    call test_get_data( map, test_256, 'Seeded_Nmhash32x', '256 byte words' )
    call test_get_all_keys( map, test_256, 'Seeded_Nmhash32x', '256 byte words' )
    call report_rehash_times( map, seeded_nmhash32x_hasher, &
        'Seeded_Nmhash32x', '256 byte words' )
    call report_hash_statistics( map, 'Seeded_Nmhash32x', '256 byte words' )
    call report_removal_times( map, test_256, 'Seeded_Nmhash32x', &
        '256 byte words' )

    call map % init( seeded_water_hasher, slots_bits=10 )
    call input_random_data( map, test_16, 'Seeded_Water', "16 byte words" )
    call test_inquire_data( map, test_16, 'Seeded_Water', "16 byte words" )
    call test_get_data( map, test_16, 'Seeded_Water', '16 byte words' )
    call test_get_all_keys( map, test_16, 'Seeded_Water', '16 byte words' )
    call report_rehash_times( map, seeded_water_hasher, &
        'Seeded_Water', '16 byte words' )
    call report_hash_statistics( map, 'Seeded_Water', '16 byte words' )
    call report_removal_times( map, test_16, 'Seeded_Water', &
        '16 byte words' )

    call map % init( seeded_water_hasher, slots_bits=10 )
    call input_random_data( map, test_256, 'Seeded_Water', &
        "256 byte words" )
    call test_inquire_data( map, test_256, 'Seeded_Water', &
        "256 byte words" )
    call test_get_data( map, test_256, 'Seeded_Water', '256 byte words' )
    call test_get_all_keys( map, test_256, 'Seeded_Water', '256 byte words' )
    call report_rehash_times( map, seeded_water_hasher, &
        'Seeded_Water', '256 byte words' )
    call report_hash_statistics( map, 'Seeded_Water', '256 byte words' )
    call report_removal_times( map, test_256, 'Seeded_Water', &
        '256 byte words' )

contains

    subroutine input_random_data( map, test_block, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in) :: test_block
        character(*), intent(in) :: hash_name
        character(*), intent(in) :: size_name
       
        type(dummy_type) :: dummy_val
        integer :: index2
        type(key_type) :: key
        real :: t1, t2, tdiff
        logical :: conflict

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            
            dummy_val % value = test_8_bits( index2:index2+test_block-1 )
            
            call map % map_entry( key, dummy_val, conflict )
            if (conflict) &
                error stop "Unable to map entry because of a key conflict."
        end do
        call cpu_time(t2)
        tdiff = t2-t1
        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Enter data', size_name, tdiff

    end subroutine input_random_data


    subroutine test_inquire_data( map, test_block, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        integer :: index2
        logical :: present
        type(key_type) :: key
        real :: t1, t2, tdiff

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            call map % key_test( key, present )
            if (.not. present) &
                error stop "KEY not found in map KEY_TEST."
        end do
        call cpu_time(t2)
        tdiff = t2-t1
        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Inquire data', size_name, tdiff

    end subroutine test_inquire_data


    subroutine test_get_data( map, test_block, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        integer :: index2
        type(key_type) :: key
        class(*), allocatable :: data
        logical :: exists
        real :: t1, t2, tdiff

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            call map % get_other_data( key, data, exists )
            if (.not. exists) &
                error stop "Unable to get data because key not found in map."
        end do
        call cpu_time(t2)
        tdiff = t2-t1
        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Get data', size_name, tdiff

    end subroutine test_get_data


    subroutine test_get_all_keys( map, test_block, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        integer :: index2, key_idx
        type(key_type) :: key
        type(key_type), allocatable :: all_keys(:)
        real :: t1, t2, tdiff

        call cpu_time(t1)
        call map % get_all_keys(all_keys)
        call cpu_time(t2)
        tdiff = t2-t1

        if (size( all_keys ) /= size( test_8_bits )/test_block) &
            error stop "Number of keys is different from that of keys in a map."

        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )

            key_idx = ( index2/test_block ) + 1
            if (.not. ( all_keys(key_idx) == key )) &
                error stop "Invalid value of a key."
        end do

        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Get all keys', size_name, tdiff

    end subroutine test_get_all_keys


    subroutine report_rehash_times( map, hasher, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        procedure(hasher_fun)                   :: hasher
        character(*), intent(in)                :: hash_name, size_name
        real :: t1, t2, tdiff

        call cpu_time(t1)
        call map % rehash( hasher )
        call cpu_time(t2)
        tdiff = t2-t1

        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Rehash data', size_name, tdiff

    end subroutine report_rehash_times


    subroutine report_removal_times( map, test_block, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        integer(int_index), intent(in)          :: test_block
        character(*), intent(in)                :: hash_name, size_name
        real :: t1, t2, tdiff
        type(key_type) :: key
        integer(int_index) :: index2
        logical :: existed

        call cpu_time(t1)
        do index2=1, size(test_8_bits), test_block
            call set( key, test_8_bits( index2:index2+test_block-1 ) )
            call map % remove(key, existed)
            if ( .not. existed ) &
                error stop "Key not found in entry removal."
        end do
        call cpu_time(t2)
        tdiff = t2-t1

        write(lun, '("|", a18, " | ", a12, " | ", a15, " | ", f10.5, " |")') &
            trim(hash_name), 'Remove data', size_name, tdiff
        flush(lun)

    end subroutine report_removal_times


    subroutine report_hash_statistics( map, hash_name, size_name )
        type(open_hashmap_type), intent(inout) :: map
        character(*), intent(in)               :: hash_name, size_name
        integer(int_depth) :: depth

        write(lun, *)
        write(lun, '("Statistics for open hash table with ",' // &
              'A, " hasher on ", A, ".")' ) hash_name, size_name
        write(lun, '("Slots = ", I0)' ) map % num_slots()
        write(lun, '("Calls = ", I0)' ) map % calls()
        write(lun, '("Entries = ", I0)' ) map % entries()
        write(lun, '("Total probes = ", I0)' ) map % map_probes()
        write(lun, '("Loading = ", ES10.3)' ) map % loading()
        depth = map % total_depth()
        write(lun, '("Total depth = ", I0)' ) depth
        write(lun, '("Relative depth = ", ES10.3)') &
            real( depth ) / real( map % entries() )

    end subroutine report_hash_statistics


end program test_open_maps

! Usage of split_path
program example_path_split_path
    use stdlib_system, only: join_path, split_path, OS_TYPE, OS_WINDOWS
    character(len=:), allocatable :: p1, head, tail

    if(OS_TYPE() == OS_WINDOWS) then
        p1 = join_path('C:\Users\User1', 'Desktop') ! C:\Users\User1\Desktop
    else
        p1 = join_path('/home/User1', 'Desktop') ! /home/User1/Desktop
    endif 
    
    call split_path(p1, head, tail)
    ! head = /home/User1 OR C:\Users\User1, tail = Desktop
    print *, p1 // " -> " // head // " + " // tail 
    ! C:\Users\User1\Desktop -> C:\Users\User1 + Desktop
    ! OR
    ! /home/User1/Desktop -> /home/User1 + Desktop

    call split_path(head, p1, tail)
    ! p1 = /home OR C:\Users, tail = User1
    print *, head // " -> " // p1 // " + " // tail 
    ! C:\Users\User1 -> C:\Users + User1
    ! OR
    ! /home/User1 -> /home + User1
end program example_path_split_path

program example_init
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0
  call set0%init(166)
  if (set0%bits() == 166) &
    write (*, *) 'SET0 has the proper size.'
  if (set0%none()) write (*, *) 'SET0 is properly initialized.'
end program example_init

program example_fibonacci_hash
  use stdlib_hash_32bit, only: fibonacci_hash
  use iso_fortran_env, only: int32
  implicit none
  integer, allocatable :: array1(:)
  integer(int32) :: hash, source
  allocate (array1(0:2**6 - 1))
  array1(:) = 0
  source = 42_int32
  hash = fibonacci_hash(source, 6)
  array1(hash) = source
  print *, hash
end program example_fibonacci_hash

program example_trueloc
  use stdlib_array, only: trueloc
  implicit none
  real, allocatable :: array(:)
  allocate (array(500))
  call random_number(array)
  array(trueloc(array > 0.5)) = 0.0
end program example_trueloc

program example_equality_operator
  use stdlib_stringlist_type, only: stringlist_type, fidx, list_head, operator(==)
  use stdlib_string_type, only: string_type
  implicit none

  type(stringlist_type)          :: stringlist
  type(string_type), allocatable :: stringarray(:)
  logical                        :: res

!> inserting 4 elements to the stringlist
  call stringlist%insert_at(fidx(1), "#1")
  call stringlist%insert_at(list_head, "#2")
  call stringlist%insert_at(fidx(1), "#3")
  call stringlist%insert_at(list_head, "#4")
! stringlist <-- {"#4", "#3", "#2", "#1"}

!> creating an array of 4 string_type elements
  stringarray = [string_type("#4"), string_type("#3"), string_type("#2"), string_type("#1")]

  res = (stringarray == stringlist)
! res <-- .true.

  res = (stringlist == ["#4", "#3", "#2", "#1"])
! res <-- .true.

  print'(a)', stringlist == ["#4", "#3", "#1"]
! .false.

end program example_equality_operator

program example_tridiagonal_matrix
   use stdlib_linalg_constants, only: dp
   use stdlib_specialmatrices, only: tridiagonal_dp_type, tridiagonal, dense, spmv
   implicit none

   integer, parameter :: n = 5
   type(tridiagonal_dp_type) :: A
   real(dp) :: dl(n - 1), dv(n), du(n - 1)
   real(dp) :: x(n), y(n), y_dense(n)
   integer :: i

   ! Create an arbitrary tridiagonal matrix.
   dl = [(i, i=1, n - 1)]; dv = [(2*i, i=1, n)]; du = [(3*i, i=1, n - 1)]
   A = tridiagonal(dl, dv, du)

   ! Initialize vectors.
   x = 1.0_dp; y = 0.0_dp; y_dense = 0.0_dp

   ! Perform matrix-vector products.
   call spmv(A, x, y)
   y_dense = matmul(dense(A), x)

   print *, 'dense       :', y_dense
   print *, 'Tridiagonal :', y

end program example_tridiagonal_matrix

program example_flip
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0
  call set0%init(166)
  if (set0%none()) write (*, *) 'SET0 is properly initialized.'
  call set0%flip(165)
  if (set0%test(165)) write (*, *) 'Bit 165 is flipped.'
  call set0%flip(0, 164)
  if (set0%all()) write (*, *) 'All bits are flipped.'
end program example_flip

! Eigendecomposition of a real square matrix 
program example_eig
  use stdlib_linalg, only: eig
  implicit none

  integer :: i
  real, allocatable :: A(:,:)
  complex, allocatable :: lambda(:),vectors(:,:)

  ! Decomposition of this square matrix
  ! NB Fortran is column-major -> transpose input
  A = transpose(reshape( [ [2, 2, 4], &
                           [1, 3, 5], &
                           [2, 3, 4] ], [3,3] )) 

  ! Get eigenvalues and right eigenvectors
  allocate(lambda(3),vectors(3,3))
  
  call eig(A, lambda, right=vectors)
  
  do i=1,3
     print *, 'eigenvalue  ',i,': ',lambda(i)
     print *, 'eigenvector ',i,': ',vectors(:,i)
  end do
  
end program example_eig

program example_sort_bitset
  use stdlib_kinds, only: int32
  use stdlib_sorting, only: sort
  use stdlib_bitsets, only: bitset_large
  implicit none
  type(bitset_large), allocatable :: array(:)
  integer(int32) :: i

  array = [bitset_l("0101"), & ! 5
           bitset_l("0100"), & ! 4
           bitset_l("0011"), & ! 3
           bitset_l("0001"), & ! 1
           bitset_l("1010"), & ! 10
           bitset_l("0100"), & ! 4
           bitset_l("1001")]   ! 9

  call sort(array)

  do i = 1, size(array)
    print *, to_string(array(i))
    ! 0001
    ! 0011
    ! 0100
    ! 0100
    ! 0101
    ! 1001
    ! 1010
  end do

  deallocate(array)
contains
    function bitset_l(str) result(new_bitsetl)
      character(*), intent(in) :: str
      type(bitset_large) :: new_bitsetl

      call new_bitsetl%from_string(str)
    end function bitset_l

    function to_string(bitset) result(str)
      type(bitset_large), intent(in) :: bitset
      character(:), allocatable :: str

      call bitset%to_string(str)
    end function to_string
end program example_sort_bitset

program example_set_other_data
  use stdlib_kinds, only: int8
  use stdlib_hashmaps, only: open_hashmap_type, chaining_hashmap_type
  use stdlib_hashmap_wrappers, only: key_type, set
  
  implicit none
  logical :: exists
  type(chaining_hashmap_type) :: map
  class(*), allocatable   :: data
  type(key_type) :: key
    
  ! Initialize hashmap with 2^10 slots.
  ! Hashmap will dynamically increase size if needed.
  call map%init(slots_bits=10)

  call set(key, [5, 7, 4, 13])
  
  call map%map_entry(key, 'A value')
  
  call map%set_other_data(key, 'Another value', exists)
  
  print *, 'The entry to have its other data replaced exists = ', exists
  
  call map%get_other_data(key, data, exists)
  
  print *, 'Get_other_data was successful = ', exists
  
  ! Hashmaps return an unlimited polymorphic type as other.  
  ! Must be included in a select type operation to do further operations.
  select type (data)
  type is (character(*))
    print *, 'Value is = ', data
  class default
    print *, 'Invalid data type in other'
  end select
  
end program example_set_other_data

program example_outer_product
  use stdlib_linalg, only: outer_product
  implicit none
  real, allocatable :: A(:, :), u(:), v(:)
  u = [1., 2., 3.]
  v = [3., 4.]
  A = outer_product(u, v)
!A = reshape([3., 6., 9., 4., 8., 12.], [3,2])
end program example_outer_product

program example_count
  use stdlib_string_type, only: string_type, assignment(=)
  use stdlib_strings, only: count
  implicit none
  type(string_type) :: string

  string = "How much wood would a woodchuck chuck if a woodchuck could chuck wood?"

  print *, count(string, "wood")                                  ! 4
  print *, count(string, ["would", "chuck", "could"])             ! [1, 4, 1]
  print *, count("a long queueueueue", "ueu", [.false., .true.])  ! [2, 4]

end program example_count

! Eigendecomposition of a real symmetric matrix 
program example_eigh
  use stdlib_linalg, only: eigh
  implicit none

  integer :: i
  real, allocatable :: A(:,:),lambda(:),vectors(:,:)
  complex, allocatable :: cA(:,:),cvectors(:,:)

  ! Decomposition of this symmetric matrix
  ! NB Fortran is column-major -> transpose input
  A = transpose(reshape( [ [2, 1, 4], &
                           [1, 3, 5], &
                           [4, 5, 4] ], [3,3] )) 

  ! Note: real symmetric matrices have real (orthogonal) eigenvalues and eigenvectors
  allocate(lambda(3),vectors(3,3))  
  call eigh(A, lambda, vectors=vectors)
  
  print *, 'Real matrix'
  do i=1,3
     print *, 'eigenvalue  ',i,': ',lambda(i)
     print *, 'eigenvector ',i,': ',vectors(:,i)
  end do
  
  ! Complex hermitian matrices have real (orthogonal) eigenvalues and complex eigenvectors
  cA = A
  
  allocate(cvectors(3,3))  
  call eigh(cA, lambda, vectors=cvectors)
  
  print *, 'Complex matrix'
  do i=1,3
     print *, 'eigenvalue  ',i,': ',lambda(i)
     print *, 'eigenvector ',i,': ',cvectors(:,i)
  end do  
  
end program example_eigh

program example_expm
   use stdlib_linalg, only: expm
   implicit none
   real :: A(3, 3), E(3, 3)
   integer :: i
   A = reshape([1, 2, 3, 4, 5, 6, 7, 8, 9], [3, 3])
   E = expm(A)

   print *, "Matrix A :"
   do i = 1, 3
      print *, A(i, :)
   end do

   print *, "Matrix exponential E = exp(A):"
   do i = 1, 3
      print *, E(i, :)
   end do
end program example_expm

program example_gemv
  use stdlib_linalg, only: eye
  use stdlib_linalg_blas, only: sp,gemv
  implicit none
  real(sp) :: A(2, 2), B(2), C(2)
  B = [1.0,2.0]
  A = eye(2)
  
  ! Use legacy BLAS interface 
  call gemv('No transpose',m=size(A,1),n=size(A,2),alpha=1.0,a=A,lda=size(A,1),x=B,incx=1,beta=0.0,y=C,incy=1)

  print *, C ! returns 1.0 2.0

end program example_gemv

program example_fnv_1a_hash_64
  use stdlib_hash_64bit, only: fnv_1a_hash
  use iso_fortran_env, only: int64
  implicit none
  integer, allocatable :: array1(:)
  integer(int64) :: hash
  array1 = [5, 4, 3, 1, 10, 4, 9]
  hash = fnv_1a_hash(array1)
  print *, hash
end program example_fnv_1a_hash_64

module test_get_line
    use stdlib_io, only : get_line, get_file
    use stdlib_error, only: state_type
    use stdlib_string_type, only : string_type, len, len_trim
    use testdrive, only : new_unittest, unittest_type, error_type, check
    implicit none
    private

    public :: collect_get_line

contains

    !> Collect all exported unit tests
    subroutine collect_get_line(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("read-char", test_read_char), &
            new_unittest("read-string", test_read_string), &
            new_unittest("pad-no", test_pad_no), &
            new_unittest("iostat-end", test_iostat_end), &
            new_unittest("closed-unit", test_closed_unit, should_fail=.true.), &
            new_unittest("no-unit", test_no_unit, should_fail=.true.), &
            new_unittest("get_file-no", test_get_file_missing), &
            new_unittest("get_file-empty", test_get_file_empty), &
            new_unittest("get_file-non-empty", test_get_file_non_empty) &
            ]
    end subroutine collect_get_line

    subroutine test_read_char(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: io, i, stat
        character(len=:), allocatable :: line

        open(newunit=io, status="scratch")
        write(io, "(a)") repeat("abc", 10), repeat("def", 100), repeat("ghi", 1000)
        rewind(io)

        do i = 1, 3
          call get_line(io, line, stat)
          call check(error, stat)
          if (allocated(error)) exit
          call check(error, len(line), 3*10**i)
          if (allocated(error)) exit
        end do
        close(io)
    end subroutine test_read_char

    subroutine test_read_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: io, i, stat
        type(string_type) :: line

        open(newunit=io, status="scratch")
        write(io, "(a)") repeat("abc", 10), repeat("def", 100), repeat("ghi", 1000)
        rewind(io)

        do i = 1, 3
          call get_line(io, line, stat)
          call check(error, stat)
          if (allocated(error)) exit
          call check(error, len(line), 3*10**i)
          if (allocated(error)) exit
        end do
        close(io)
    end subroutine test_read_string

    subroutine test_pad_no(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: io, i, stat
        character(len=:), allocatable :: line

        open(newunit=io, status="scratch", pad="no")
        write(io, "(a)") repeat("abc", 10), repeat("def", 100), repeat("ghi", 1000)
        rewind(io)

        do i = 1, 3
          call get_line(io, line, stat)
          call check(error, stat)
          if (allocated(error)) exit
          call check(error, len(line), 3*10**i)
          if (allocated(error)) exit
        end do
        close(io)
    end subroutine test_pad_no

    subroutine test_iostat_end(error)
        use, intrinsic :: iso_fortran_env, only : iostat_end
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: io, i, stat
        character(len=:), allocatable :: line

        open(newunit=io, status="scratch")
        write(io, "(a)") repeat("abc", 10), repeat("def", 100), repeat("ghi", 1000)
        rewind(io)

        do i = 1, 3
          call get_line(io, line, stat)
          call check(error, stat)
          if (allocated(error)) exit
          call check(error, len(line), 3*10**i)
          if (allocated(error)) exit
        end do
        if (.not.allocated(error)) then
          call get_line(io, line, stat)
          call check(error, stat, iostat_end)
        end if
        close(io)
    end subroutine test_iostat_end

    subroutine test_closed_unit(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: io, stat
        character(len=:), allocatable :: line, msg

        open(newunit=io, status="scratch")
        close(io)

        call get_line(io, line, stat, msg)
        call check(error, stat, msg)
    end subroutine test_closed_unit

    subroutine test_no_unit(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: io, stat
        character(len=:), allocatable :: line, msg

        io = -1
        call get_line(io, line, stat, msg)
        call check(error, stat, msg)
    end subroutine test_no_unit

    subroutine test_get_file_missing(error)
        !> Test for a missing file.
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: filecontents
        type(state_type) :: err

        call get_file("nonexistent_file.txt", fileContents, err)
        
        ! Check that an error was returned
        call check(error, err%error(), "Error not returned on a missing file")
        if (allocated(error)) return
        
    end subroutine test_get_file_missing

    subroutine test_get_file_empty(error)
        !> Test for an empty file.
        type(error_type), allocatable, intent(out) :: error

        integer :: ios
        character(len=:), allocatable :: filename
        type(string_type) :: filecontents
        type(state_type) :: err
        
        ! Get a temporary file name
        filename = "test_get_file_empty.txt"

        ! Create an empty file        
        open(newunit=ios, file=filename, action="write", form="formatted", access="sequential")        
        close(ios)

        ! Read and delete it
        call get_file(filename, filecontents, err, delete=.true.)

        call check(error, err%ok(), "Should not return error reading an empty file")
        if (allocated(error)) return
        
        call check(error, len_trim(filecontents) == 0, "String from empty file should be empty")
        if (allocated(error)) return
        
    end subroutine test_get_file_empty

    subroutine test_get_file_non_empty(error)
        !> Test for a non-empty file.
        type(error_type), allocatable, intent(out) :: error

        integer :: ios
        character(len=:), allocatable :: filename
        type(string_type) :: filecontents
        type(state_type) :: err
        
        ! Get a temporary file name
        filename = "test_get_file_size5.txt"

        ! Create a fixed-size file
        open(newunit=ios, file=filename, action="write", form="unformatted", access="stream")        
        write(ios) "12345"
        close(ios)

        ! Read and delete it
        call get_file(filename, filecontents, err, delete=.true.)

        call check(error, err%ok(), "Should not return error reading a non-empty file")
        if (allocated(error)) return
        
        call check(error, len_trim(filecontents) == 5, "Wrong string size returned")
        if (allocated(error)) return

    end subroutine test_get_file_non_empty


end module test_get_line


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_get_line, only : collect_get_line
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("get_line", collect_get_line) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_ansi_color
  use stdlib_ansi, only : fg_color_blue, style_bold, style_reset, ansi_code, &
    & operator(//), operator(+)
  implicit none
  type(ansi_code) :: highlight, reset

  print '(a)', highlight // "Dull text message" // reset

  highlight = fg_color_blue + style_bold
  reset = style_reset

  print '(a)', highlight // "Colorful text message" // reset
end program example_ansi_color

#include "macros.inc"
program example_math_swap
    use stdlib_math, only: swap
    implicit none
    
    block
        integer :: x, y
        x = 9
        y = 18
        call swap(x,y)
    end block

    block
        real :: x, y
        x = 4.0
        y = 8.0
        call swap(x,y)
    end block

    block
        real :: x(3), y(3)
        x = [1.0,2.0,3.0]
        y = [4.0,5.0,6.0]
        call swap(x,y)
    end block

    block
        character(4) :: x
        character(6) :: y
        x = 'abcd'
        y = 'efghij'
        call swap(x,y)      ! x=efgh,  y=abcd

        x = 'abcd'
        y = 'efghij'
        call swap(x,y(1:4)) ! x=efgh,  y=abcdij
    end block

    block
        use stdlib_string_type
        type(string_type) :: x, y
        x = 'abcde'
        y = 'fghij'
        call swap(x,y)
    end block

#if STDLIB_BITSETS == 1
    block
        use stdlib_bitsets
        type(bitset_64) :: x, y
        call x%from_string('0000')
        call y%from_string('1111')
        call swap(x,y)
    end block
#endif

end program example_math_swap  

program example_constructor
  use stdlib_stringlist_type, only: stringlist_type
  use stdlib_string_type, only: string_type
  implicit none

  type(stringlist_type) :: stringlist

  stringlist = stringlist_type()
! stringlist <-- { } (empty stringlist)

  stringlist = stringlist_type(["#1", "#2", "#3"])
! stringlist <-- {"#1", "#2", "#3"}

  stringlist = stringlist_type([string_type("#1"), string_type("#2")])
! stringlist <-- {"#1", "#2"}

end program example_constructor

! Eigendecomposition of a real square matrix for the generalized eigenproblem
program example_eig_generalized
  use stdlib_linalg, only: eig, eye
  implicit none

  integer :: i
  real, allocatable :: A(:,:), B(:,:)
  complex, allocatable :: lambda(:), vectors(:,:)

  ! Matrices for the generalized eigenproblem: A * v = lambda * B * v
  ! NB Fortran is column-major -> transpose input
  A = transpose(reshape([ [2, 2, 4], &
                          [1, 3, 5], &
                          [2, 3, 4] ], [3,3]))

  B = eye(3)

  ! Allocate eigenvalues and right eigenvectors
  allocate(lambda(3), vectors(3,3))

  ! Get eigenvalues and right eigenvectors for the generalized problem
  call eig(A, B, lambda, right=vectors)

  do i = 1, 3
     print *, 'Eigenvalue  ', i, ': ', lambda(i)
     print *, 'Eigenvector ', i, ': ', vectors(:,i)
  end do

end program example_eig_generalized

program example_scan
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: pos

  string = "fortran"
  pos = scan(string, "ao")
! pos == 2

  pos = scan(string, "ao", .true.)
! pos == 6

  pos = scan(string, "c++")
! pos == 0
end program example_scan

program example_sort_index
  use stdlib_sorting, only: sort_index
  implicit none
  integer, allocatable :: array(:)
  integer, allocatable :: index(:)

  array = [5, 4, 3, 1, 10, 4, 9]
  allocate(index, mold=array)

  call sort_index(array, index)

  print *, array   !print [1, 3, 4, 4, 5, 9, 10]
  print *, index   !print [4, 3, 2, 6, 1, 7, 5]

end program example_sort_index

program example_sparse_from_ijv
    use stdlib_linalg_constants, only: dp
    use stdlib_sparse
    implicit none

    integer :: row(10), col(10)
    real(dp) :: data(10)
    type(COO_dp_type) :: COO
    type(CSR_dp_type) :: CSR
    type(ELL_dp_type) :: ELL
    integer :: i, j

    ! Initial data
    row = [1,1,2,2,3,3,3,4,4,4]
    col = [1,5,1,2,2,3,4,1,3,4]
    data = real([9,-3,4,7,8,-1,8,4,5,6] , kind = dp )

    ! Create a COO matrix from triplet
    call from_ijv(COO,row,col,data)
    print *, 'COO'
    print *, '  i,  j,    v'
    do i = 1, COO%nnz
        print '(2I4,f8.1)', COO%index(:,i), COO%data(i)
    end do

    ! Create a CSR matrix from triplet
    call from_ijv(CSR,row,col,data)
    print *, 'CSR'
    print '(A,5I8)',    'rowptr :', CSR%rowptr
    print '(A,10I8)',   'col    :', CSR%col 
    print '(A,10f8.1)', 'data   :', CSR%data
    
    ! Create an ELL matrix from triplet
    call from_ijv(ELL,row,col,data)
    print *, 'ELL'
    print *, ' index        |         data'
    do i = 1, ELL%nrows
        print '(3I4,1x,3f8.1)', ELL%index(i,:) , ELL%data(i,:)
    end do
  
end program example_sparse_from_ijv

program example_adjustl
  use stdlib_string_type
  implicit none
  type(string_type) :: string

  string = "                            Whitespace"
  string = adjustl(string)
! char(string) == "Whitespace                            "
end program example_adjustl

program example_median
  use stdlib_stats, only: median
  implicit none
  real :: x(1:6) = [1., 2., 3., 4., 5., 6.]
  real :: y(1:2, 1:3) = reshape([1., 2., 3., 4., 5., 6.], [2, 3])
  print *, median(x)                                  !returns 3.5
  print *, median(y)                                  !returns 3.5
  print *, median(y, 1)                               !returns [ 1.5, 3.5, 5.5 ]
  print *, median(y, 1, y > 3.)                        !returns [ NaN, 4.0, 5.5 ]
end program example_median

program example_replace_all
  use stdlib_string_type, only: string_type, assignment(=), write (formatted)
  use stdlib_strings, only: replace_all
  implicit none
  type(string_type) :: string

  string = "hurdles here, hurdles there, hurdles everywhere"
! string <-- "hurdles here, hurdles there, hurdles everywhere"

  print'(dt)', replace_all(string, "hurdles", "learn from")
! "learn from here, learn from there, learn from everywhere"

  string = replace_all(string, "hurdles", "technology")
! string <-- "technology here, technology there, technology everywhere"

end program example_replace_all

program example_sort_adjoint
  use stdlib_sorting, only: sort_adjoint
  implicit none
  integer, allocatable :: array(:)
  real, allocatable :: adjoint(:)

  array = [5, 4, 3, 1, 10, 4, 9]
  allocate(adjoint, source=real(array))

  call sort_adjoint(array, adjoint)

  print *, array   !print [1, 3, 4, 4, 5, 9, 10]
  print *, adjoint   !print [1., 3., 4., 4., 5., 9., 10.]

end program example_sort_adjoint

program example_normal_pdf
  use stdlib_random, only: random_seed
  use stdlib_stats_distribution_normal, only: norm_pdf => pdf_normal, &
                                              norm => rvs_normal

  implicit none
  real, dimension(3, 4, 5) :: x, mu, sigma
  real :: xsum
  complex :: loc, scale
  integer :: seed_put, seed_get, i

  seed_put = 1234567
  call random_seed(seed_put, seed_get)

  ! probability density at x=1.0 in standard normal
  print *, norm_pdf(1.0, 0., 1.) 
  ! 0.241970733

  ! probability density at x=2.0 with mu=-1.0 and sigma=2.0 
  print *, norm_pdf(2.0, -1.0, 2.0)
  ! 6.47588000E-02

  ! probability density at x=1.0 with mu=1.0 and sigma=-1.0 (out of range) 
  print *, norm_pdf(1.0, 1.0, -1.0)
  ! NaN

  ! standard normal random variates array
  x = reshape(norm(0.0, 1.0, 60), [3, 4, 5])
  
  ! standard normal probability density array
  mu(:, :, :) = 0.0
  sigma(:, :, :) = 1.0
  print *, norm_pdf(x, mu, sigma)  
  !  0.340346158  0.285823315  0.398714304  0.391778737  0.389345556
  !  0.364551932  0.386712372  0.274370432  0.215250477  0.378006011
  !  0.215760440  0.177990928  0.278640658  0.223813817  0.356875211
  !  0.285167664  0.378533930  0.390739858  0.271684974  0.138273031
  !  0.135456234  0.331718773  0.398283750  0.383706540

  ! probability density array where sigma<=0.0 for certain elements 
  print *, norm_pdf([1.0, 1.0, 1.0], [1.0, 1.0, 1.0], [1.0, 0.0, -1.0])
  ! 0.398942292  NaN NaN

  ! `pdf_normal` is pure and, thus, can be called concurrently 
  xsum = 0.0
  do concurrent (i=1:size(x,3))
    xsum = xsum + sum(norm_pdf(x(:,:,i), mu(:,:,i), sigma(:,:,i)))
  end do
  print *, xsum
  ! 18.0754433

  ! complex normal probability density function at x=(1.5,1.0) with real part
  ! of mu=1.0, sigma=1.0 and imaginary part of mu=-0.5, sigma=2.0
  loc = (1.0, -0.5)
  scale = (1.0, 2.)
  print *, norm_pdf((1.5, 1.0), loc, scale)
  ! 5.30100204E-02

end program example_normal_pdf

submodule (stdlib_error) f18estop

implicit none

contains

module procedure error_stop
! Aborts the program with nonzero exit code
!
! The "stop <character>" statement generally has return code 0.
! To allow non-zero return code termination with character message,
! error_stop() uses the statement "error stop", which by default
! has exit code 1 and prints the message to stderr.
! An optional integer return code "code" may be specified.
!
! Example
! -------
!
! call error_stop("Invalid argument")

if(present(code)) then
  write(stderr,*) msg
  error stop code
else
  error stop msg
endif
end procedure

end submodule f18estop

module test_logspace
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_kinds, only: sp, dp, int8, int16, int32, int64
    use stdlib_math, only: logspace, DEFAULT_LOGSPACE_BASE, DEFAULT_LOGSPACE_LENGTH

    implicit none

    ! Testing logspace
    !
    ! logspace should return a rank 1 array of values equally logarithmically spaced
    ! from the base**start to base**end, using 10 as the base. If no length
    ! is specified, return a rank 1 array with 50 elements.
    !
    ! Also test to verify that the proportion between adjacent elements is constant within
    ! a certain tolerance

    real(sp), parameter :: TOLERANCE_SP = 1000 * epsilon(1.0_sp)
    real(dp), parameter :: TOLERANCE_DP = 1000 * epsilon(1.0_dp) ! Percentage of the range for which the actual gap must not exceed


contains

    !> Collect all exported unit tests
    subroutine collect_logspace(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("logspace_sp", test_logspace_sp), &
            new_unittest("logspace_dp", test_logspace_dp), &
            new_unittest("logspace_default", test_logspace_default), &
            new_unittest("logspace_base_2", test_logspace_base_2), &
            new_unittest("logspace_base_2_cmplx_start", test_logspace_base_2_cmplx_start), &
            new_unittest("logspace_base_i_int_start", test_logspace_base_i_int_start) &
            ]

    end subroutine collect_logspace

    subroutine test_logspace_sp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer, parameter :: n = 20
        real(sp), parameter :: start = 0.0_sp
        real(sp), parameter :: end = 2.0_sp

        real(sp) :: expected_proportion
        integer :: i

        real(sp), allocatable :: x(:)

        x = logspace(start, end, n)

        expected_proportion = 10 ** ( ( end - start ) / ( n - 1 ) )

        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return
        call check(error, x(1), DEFAULT_LOGSPACE_BASE ** start, "Initial value of array is not equal to 10^start")
        if (allocated(error)) return
        call check(error, x(n), DEFAULT_LOGSPACE_BASE ** end, "Final value of array is not equal to 10^end")
        if (allocated(error)) return

        do i = 1, n-1

            call check(error, x(i + 1) / x(i), expected_proportion, &
                & thr=abs(expected_proportion) * TOLERANCE_SP)
            if (allocated(error)) return

        end do


    end subroutine

    subroutine test_logspace_dp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer, parameter :: n = 10
        real(dp), parameter :: start = 1.0_dp
        real(dp), parameter :: end = 0.0_dp
        real(dp) :: expected_proportion
        integer :: i

        real(dp), allocatable :: x(:)

        x = logspace(start, end, n)

        expected_proportion = 10 ** ( ( end - start ) / ( n - 1 ) )


        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return
        call check(error, x(1), DEFAULT_LOGSPACE_BASE ** start, "Initial value of array is not equal to 10^start")
        if (allocated(error)) return
        call check(error, x(n), DEFAULT_LOGSPACE_BASE ** end, "Final value of array is not equal to 10^end")
        if (allocated(error)) return

        do i = 1, n-1

            call check(error, x(i + 1) / x(i), expected_proportion, &
                & thr=abs(expected_proportion) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_logspace_default(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        real(dp), parameter :: start = 0.0_dp
        real(dp), parameter :: end = 1.0_dp
        integer, parameter :: n = DEFAULT_LOGSPACE_LENGTH
        real(dp) :: expected_proportion
        integer :: i

        real(dp), allocatable :: x(:)

        x = logspace(start, end)

        expected_proportion = 10 ** ( ( end - start ) / ( n - 1 ) )


        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return
        call check(error, x(1), DEFAULT_LOGSPACE_BASE ** start, "Initial value of array is not equal to 10^start")
        if (allocated(error)) return
        call check(error, x(n), DEFAULT_LOGSPACE_BASE ** end, "Final value of array is not equal to 10^end")
        if (allocated(error)) return

        do i = 1, n-1

            call check(error, x(i + 1) / x(i), expected_proportion, &
                & thr=abs(expected_proportion) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_logspace_base_2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer, parameter :: n = 10
        real(dp), parameter :: start = 1.0_dp
        real(dp), parameter :: end = 10.0_dp
        integer, parameter :: base = 2
        integer :: i
        real(dp) :: expected_proportion

        real(dp), allocatable :: x(:)

        x = logspace(start, end, n, base)

        expected_proportion = 2 ** ( ( end - start ) / ( n - 1 ) )

        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return
        call check(error, x(1), base ** start, "Initial value of array is not equal to 2^start")
        if (allocated(error)) return
        call check(error, x(n), base ** end, "Final value of array is not equal to 2^end")
        if (allocated(error)) return

        do i = 1, n-1

            call check(error, x(i + 1) / x(i), expected_proportion, &
                & thr=abs(expected_proportion) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_logspace_base_2_cmplx_start(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer, parameter :: n = 10
        complex(dp), parameter :: start = (1, 0)
        complex(dp), parameter :: end = (0, 1)
        integer, parameter :: base = 2
        complex(dp) :: expected_proportion
        integer :: i

        complex(dp), allocatable :: x(:)

        x = logspace(start, end, n, base)

        expected_proportion = 2 ** ( ( end - start ) / ( n - 1 ) )


        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return
        call check(error, x(1), base ** start, "Initial value of array is not equal to 2^start")
        if (allocated(error)) return
        call check(error, x(n), base ** end, "Final value of array is not equal to 2^end")
        if (allocated(error)) return

        do i = 1, n-1

            call check(error, x(i + 1) / x(i), expected_proportion, &
                & thr=abs(expected_proportion) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_logspace_base_i_int_start(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer, parameter :: n = 5
        integer, parameter :: start = 1
        integer, parameter :: end = 5
        complex(dp), parameter :: base = (0, 1) ! i
        complex(dp) :: expected_proportion
        integer :: i

        complex(dp), allocatable :: x(:)

        x = logspace(start, end, n, base)

        expected_proportion = base ** ( ( end - start ) / ( n - 1 ) )

        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return
        call check(error, x(1), base ** start, "Initial value of array is not equal to 2^start")
        if (allocated(error)) return
        call check(error, x(n), base ** end, "Final value of array is not equal to 2^end")
        if (allocated(error)) return

        do i = 1, n-1

            call check(error, x(i + 1) / x(i), expected_proportion, &
                & thr=abs(expected_proportion) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine


end module

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_logspace, only : collect_logspace
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("logspace", collect_logspace) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program tester

program example_spooky_hash
  use stdlib_hash_64bit, only: new_spooky_hash_seed, &
                               spooky_hash
  use iso_fortran_env, only: int64
  implicit none
  integer, allocatable :: key(:)
  integer(int64) :: hash(2), seed(2)
  key = [0, 1, 2, 3]
  seed = [119_int64, 2_int64**41 - 1]
  call new_spooky_hash_seed(seed)
  hash = spooky_hash(key, seed)
  print *, seed, hash
end program example_spooky_hash

program example_get
  use stdlib_stringlist_type, only: stringlist_type, fidx, bidx
  use stdlib_string_type, only: string_type
  implicit none

  type(stringlist_type) :: stringlist
  type(string_type)     :: output

!> inserting 4 elements to the stringlist
  call stringlist%insert_at(fidx(1), "Element No. one")
  call stringlist%insert_at(fidx(1), "Element No. two")
  call stringlist%insert_at(fidx(1), "Element No. three")
  call stringlist%insert_at(fidx(1), "Element No. four")
! stringlist <-- {"Element No. four", "Element No. three", "Element No. two", "Element No. one"}

  output = stringlist%get(fidx(1))
! output <-- "Element No. four"

  output = stringlist%get(bidx(1))
! output <-- "Element No. one"

!> accessing out of bounds index
  output = stringlist%get(bidx(5))
! output <-- ""
  output = stringlist%get(fidx(0))
! output <-- ""

end program example_get

program example_linspace_int16
  use stdlib_math, only: linspace
  use stdlib_kinds, only: int16, dp
  implicit none

  integer(int16) :: start = 10_int16
  integer(int16) :: end = 23_int16

  real(dp) :: r(15)

  r = linspace(start, end, 15)
end program example_linspace_int16

module test_os
    use testdrive, only : new_unittest, unittest_type, error_type, check, skip_test
    use stdlib_system, only: get_runtime_os, OS_WINDOWS, OS_UNKNOWN, OS_TYPE, is_windows, null_device

    implicit none

contains

    !> Collect all exported unit tests
    subroutine collect_suite(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest('test_get_runtime_os', test_get_runtime_os), &
            new_unittest('test_is_windows', test_is_windows), &
            new_unittest('test_null_device', test_null_device) &
        ]
    end subroutine collect_suite

    subroutine test_get_runtime_os(error)
        type(error_type), allocatable, intent(out) :: error
        integer :: os

        !> Get current OS
        os = get_runtime_os()

        call check(error, os /= OS_UNKNOWN, "running on an unknown/unsupported OS")
        
    end subroutine test_get_runtime_os

    !> If running on Windows (_WIN32 macro is defined), test that the appropriate OS flag is returned
    subroutine test_is_windows(error)
        type(error_type), allocatable, intent(out) :: error
        integer :: os_cached, os_runtime
        
        call check(error, OS_TYPE()==OS_WINDOWS .eqv. is_windows(), &
                   "Cached OS type does not match _WIN32 macro presence")

    end subroutine test_is_windows

    !> Test that the null_device is valid by writing something to it
    subroutine test_null_device(error)
        type(error_type), allocatable, intent(out) :: error
        integer :: unit, ios
        character(len=512) :: iomsg

        ! Try opening the null device for writing
        open(newunit=unit, file=null_device(), status='old', action='write', iostat=ios, iomsg=iomsg)        
        call check(error, ios==0, 'Cannot open null_device unit: '//trim(iomsg))
        if (allocated(error)) return
        
        write(unit, *, iostat=ios, iomsg=iomsg) 'Hello, World!' 
        call check(error, ios==0, 'Cannot write to null_device unit: '//trim(iomsg))
        if (allocated(error)) return        

        close(unit, iostat=ios, iomsg=iomsg)
        call check(error, ios==0, 'Cannot close null_device unit: '//trim(iomsg))
        if (allocated(error)) return     
        
    end subroutine test_null_device

end module test_os

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_os, only : collect_suite

    implicit none

    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("os", collect_suite) &
    ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

! Eigenvalues of a general real / complex matrix 
program example_eigvals
  use stdlib_linalg, only: eigvals
  implicit none

  real, allocatable :: A(:,:),lambda(:)
  complex, allocatable :: cA(:,:),clambda(:)

  ! NB Fortran is column-major -> transpose input
  A = transpose(reshape( [ [2, 8, 4], &
                           [1, 3, 5], &
                           [9, 5,-2] ], [3,3] )) 

  ! Note: real symmetric matrix
  lambda = eigvals(A)
  print *, 'Real    matrix eigenvalues: ',lambda
  
  ! Complex general matrix
  cA = cmplx(A, -2*A)
  clambda = eigvals(cA)
  print *, 'Complex matrix eigenvalues: ',clambda
  
end program example_eigvals

program example_is_skew_symmetric
  use stdlib_linalg, only: is_skew_symmetric
  implicit none
  real :: A(2, 2), B(2, 2)
  logical :: res
  A = reshape([0., -3., 3., 0.], shape(A))
  B = reshape([0., 3., 3., 0.], shape(B))
  res = is_skew_symmetric(A) ! returns .true.
  res = is_skew_symmetric(B) ! returns .false.
end program example_is_skew_symmetric

program example_qr  
  use stdlib_linalg, only: qr
  implicit none
  real :: A(104, 32), Q(104,32), R(32,32)
  
  ! Create a random matrix
  call random_number(A)

  ! Compute its QR factorization (reduced)
  call qr(A,Q,R)

  ! Test factorization: Q*R = A 
  print *, maxval(abs(matmul(Q,R)-A)) 

end program example_qr

! Demonstrate expert subroutine interface with pre-allocated arrays
program example_constrained_lstsq2
   use stdlib_linalg_constants, only: dp
   use stdlib_linalg, only: solve_constrained_lstsq, constrained_lstsq_space
   implicit none
   integer, parameter :: m = 5, n = 4, p = 3
   !> Least-squares cost.
   real(dp) :: A(m, n), b(m)
   !> Equality constraints.
   real(dp) :: C(p, n), d(p)
   !> Solution.
   real(dp) :: x(n), x_true(n)
   !> Workspace array.
   integer :: lwork
   real(dp), allocatable :: work(:)

   !> Least-squares cost.
   A(1, :) = [1.0_dp, 1.0_dp, 1.0_dp, 1.0_dp]
   A(2, :) = [1.0_dp, 3.0_dp, 1.0_dp, 1.0_dp]
   A(3, :) = [1.0_dp, -1.0_dp, 3.0_dp, 1.0_dp]
   A(4, :) = [1.0_dp, 1.0_dp, 1.0_dp, 3.0_dp]
   A(5, :) = [1.0_dp, 1.0_dp, 1.0_dp, -1.0_dp]

   b = [2.0_dp, 1.0_dp, 6.0_dp, 3.0_dp, 1.0_dp]

   !> Equality constraints.
   C(1, :) = [1.0_dp, 1.0_dp, 1.0_dp, -1.0_dp]
   C(2, :) = [1.0_dp, -1.0_dp, 1.0_dp, 1.0_dp]
   C(3, :) = [1.0_dp, 1.0_dp, -1.0_dp, 1.0_dp]

   d = [1.0_dp, 3.0_dp, -1.0_dp]

   !> Optimal workspace size.
   call constrained_lstsq_space(A, C, lwork)
   allocate (work(lwork))

   ! Compute the solution.
   call solve_constrained_lstsq(A, b, C, d, x, &
                                storage=work, &
                                overwrite_matrices=.true.)
   x_true = [0.5_dp, -0.5_dp, 1.5_dp, 0.5_dp]

   print *, "Exact solution :"
   print *, x_true
   print *
   print *, "Computed solution :"
   print *, x
end program example_constrained_lstsq2

module test_npy
    use stdlib_kinds, only : int8, int16, int32, int64, sp, dp
    use stdlib_io_npy, only : save_npy, load_npy
    use testdrive, only : new_unittest, unittest_type, error_type, check
    implicit none
    private

    public :: collect_npy

contains

    !> Collect all exported unit tests
    subroutine collect_npy(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("read-rdp-r2", test_read_rdp_rank2), &
            new_unittest("read-rdp-r3", test_read_rdp_rank3), &
            new_unittest("read-rsp-r1", test_read_rsp_rank1), &
            new_unittest("read-rsp-r2", test_read_rsp_rank2), &
            new_unittest("write-rdp-r2", test_write_rdp_rank2), &
            new_unittest("write-rsp-r2", test_write_rsp_rank2), &
            new_unittest("write-i2-r4", test_write_int16_rank4), &
            new_unittest("invalid-magic-number", test_invalid_magic_number, should_fail=.true.), &
            new_unittest("invalid-magic-string", test_invalid_magic_string, should_fail=.true.), &
            new_unittest("invalid-major-version", test_invalid_major_version, should_fail=.true.), &
            new_unittest("invalid-minor-version", test_invalid_minor_version, should_fail=.true.), &
            new_unittest("invalid-header-len", test_invalid_header_len, should_fail=.true.), &
            new_unittest("invalid-nul-byte", test_invalid_nul_byte, should_fail=.true.), &
            new_unittest("invalid-key", test_invalid_key, should_fail=.true.), &
            new_unittest("invalid-comma", test_invalid_comma, should_fail=.true.), &
            new_unittest("invalid-string", test_invalid_string, should_fail=.true.), &
            new_unittest("duplicate-descr", test_duplicate_descr, should_fail=.true.), &
            new_unittest("missing-descr", test_missing_descr, should_fail=.true.), &
            new_unittest("missing-fortran_order", test_missing_fortran_order, should_fail=.true.), &
            new_unittest("missing-shape", test_missing_shape, should_fail=.true.), &
            new_unittest("iomsg-deallocated", test_iomsg_deallocated) &
            ]
    end subroutine collect_npy

    subroutine test_read_rdp_rank2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=*), parameter :: filename = ".test-rdp-r2.npy"
        real(dp), allocatable :: input(:, :), output(:, :)

        allocate(input(10, 4))
        call random_number(input)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) input
        close(io)

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), size(input))
        if (allocated(error)) return

        call check(error, any(abs(output - input) <= epsilon(1.0_dp)), &
           "Precision loss when rereading array")
    end subroutine test_read_rdp_rank2

    subroutine test_read_rsp_rank2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f4', 'fortran_order': False, 'shape': (12, 5, ), }       " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=*), parameter :: filename = ".test-rsp-r2.npy"
        real(sp), allocatable :: input(:, :), output(:, :)

        allocate(input(5, 12))
        call random_number(input)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) input
        close(io)

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), size(input))
        if (allocated(error)) return

        call check(error, any(abs(output - input) <= epsilon(1.0_dp)), &
           "Precision loss when rereading array")
    end subroutine test_read_rsp_rank2

    subroutine test_read_rdp_rank3(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 2, 2), }       " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=*), parameter :: filename = ".test-rdp-r3.npy"
        real(dp), allocatable :: input(:, :, :), output(:, :, :)

        allocate(input(10, 2, 2))
        call random_number(input)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) input
        close(io)

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), size(input))
        if (allocated(error)) return

        call check(error, any(abs(output - input) <= epsilon(1.0_dp)), &
           "Precision loss when rereading array")
    end subroutine test_read_rdp_rank3

    subroutine test_read_rsp_rank1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr':'<f4', 'shape' : (37 ,  ) , 'fortran_order': False}         " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=*), parameter :: filename = ".test-rsp-r1.npy"
        real(sp), allocatable :: input(:), output(:)

        allocate(input(37))
        call random_number(input)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) input
        close(io)

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), 37)
        if (allocated(error)) return

        call check(error, any(abs(output - input) <= epsilon(1.0_dp)), &
           "Precision loss when rereading array")
    end subroutine test_read_rsp_rank1

    subroutine test_write_rdp_rank2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: stat
        character(len=*), parameter :: filename = ".test-rdp-r2-rt.npy"
        real(dp), allocatable :: input(:, :), output(:, :)

        allocate(input(10, 4))
        call random_number(input)
        call save_npy(filename, input, stat)

        call check(error, stat, "Writing of npy file failed")
        if (allocated(error)) return

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), size(input))
        if (allocated(error)) return

        call check(error, any(abs(output - input) <= epsilon(1.0_dp)), &
           "Precision loss when rereading array")
    end subroutine test_write_rdp_rank2

    subroutine test_write_rsp_rank2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: stat
        character(len=*), parameter :: filename = ".test-rsp-r2-rt.npy"
        real(sp), allocatable :: input(:, :), output(:, :)

        allocate(input(12, 5))
        call random_number(input)
        call save_npy(filename, input, stat)

        call check(error, stat, "Writing of npy file failed")
        if (allocated(error)) return

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), size(input))
        if (allocated(error)) return

        call check(error, any(abs(output - input) <= epsilon(1.0_dp)), &
           "Precision loss when rereading array")
    end subroutine test_write_rsp_rank2

    subroutine test_write_int16_rank4(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: stat, i
        character(len=*), parameter :: filename = ".test-i2-r4-rt.npy"
        integer(int16), allocatable :: input(:, :, :, :), output(:, :, :, :)

        input = reshape([(i*(i+1)/2, i = 1, 40)], [2, 5, 2, 2])
        call save_npy(filename, input, stat)

        call check(error, stat, "Writing of npy file failed")
        if (allocated(error)) return

        call load_npy(filename, output, stat)
        call delete_file(filename)

        call check(error, stat, "Reading of npy file failed")
        if (allocated(error)) return

        call check(error, size(output), size(input))
        if (allocated(error)) return

        call check(error, all(abs(output - input) == 0), &
           "Precision loss when rereading array")
    end subroutine test_write_int16_rank4

    subroutine test_invalid_magic_number(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(50) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-magic-num.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_magic_number

    subroutine test_invalid_magic_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "numpy" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-magic-str.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_magic_string

    subroutine test_invalid_major_version(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(0) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-major-version.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_major_version

    subroutine test_invalid_minor_version(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(9) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-minor-version.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_minor_version

    subroutine test_invalid_header_len(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)-1) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-header-len.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_header_len

    subroutine test_invalid_nul_byte(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'fortran_order': True, 'shape': (10, 4, ), }       " //  &
            char(0) // char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-nul-byte.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_nul_byte

    subroutine test_invalid_key(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'fortran_order': True, 'shape': (10, 4, ), 'descr': '<f8', 'x': 1, }" //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-key.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_key

    subroutine test_invalid_comma(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'fortran_order': True,, 'shape': (10, 4, ), 'descr': '<f8', }       " //  &
            "   " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-comma.npy"
        real(dp), allocatable :: array(:)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_comma

    subroutine test_invalid_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'fortran_order': True, 'shape': (10, 4, ), 'descr': '<f8' '<f4', }  " //  &
            "   " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-string.npy"
        real(dp), allocatable :: array(:)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_invalid_string

    subroutine test_duplicate_descr(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'descr': '<f8', 'fortran_order': True, 'shape': (40, ), }"//&
            "   " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-invalid-descr.npy"
        real(dp), allocatable :: array(:)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_duplicate_descr

    subroutine test_missing_descr(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'fortran_order': True, 'shape': (10, 4, ), }                        " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-missing-descr.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_missing_descr

    subroutine test_missing_fortran_order(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'descr': '<f8', 'shape': (10, 4, ), }                               " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-missing-fortran_order.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_missing_fortran_order

    subroutine test_missing_shape(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: dict = &
            "{'fortran_order': True, 'descr': '<f8'}                              " //  &
            char(10)
        character(len=*), parameter :: header = &
            char(int(z"93")) // "NUMPY" // char(1) // char(0) // &
            char(len(dict)) // char(0) // dict

        integer :: io, stat
        character(len=:), allocatable :: msg
        character(len=*), parameter :: filename = ".test-missing-shape.npy"
        real(dp), allocatable :: array(:, :)

        open(newunit=io, file=filename, form="unformatted", access="stream")
        write(io) header
        write(io) spread(0.0_dp, 1, 40)
        close(io)

        call load_npy(filename, array, stat, msg)
        call delete_file(filename)

        call check(error, stat, msg)
    end subroutine test_missing_shape

    subroutine test_iomsg_deallocated(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: stat
        character(len=:), allocatable :: msg

        character(len=*), parameter :: filename = ".test-iomsg-deallocated.npy"
        real(sp), allocatable :: input(:, :)

        msg = "This message should be deallocated."

        allocate(input(12, 5))
        call random_number(input)
        call save_npy(filename, input, stat, msg)
        call delete_file(filename)

        call check(error,.not. allocated(msg), "Message wrongly allocated.")

    end subroutine

    subroutine delete_file(filename)
        character(len=*), intent(in) :: filename

        integer :: io

        open(newunit=io, file=filename)
        close(io, status="delete")
    end subroutine delete_file

end module test_npy


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_npy, only : collect_npy
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("npy", collect_npy) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_log_gamma
  use stdlib_kinds, only: sp, dp
  use stdlib_specialfunctions_gamma, only: log_gamma
  implicit none

  integer :: i
  real :: x
  real(dp) :: y
  complex(sp) :: z

  i = 10
  x = 8.76
  y = x
  z = (5.345, -3.467)

  print *, log_gamma(i)     !default single precision output
!12.8018274

  print *, log_gamma(x)     !intrinsic function call

!10.0942659

  print *, log_gamma(y)     !intrinsic function call

!10.094265528673880

  print *, log_gamma(z)     !same kind as input

!(2.56165648, -5.73382425)

end program example_log_gamma

! Matrix inversion example: function interface
program example_inverse_function
  use stdlib_linalg_constants, only: dp
  use stdlib_linalg, only: inv,eye
  implicit none

  real(dp) :: A(2,2), Am1(2,2)

  ! Input matrix (NB Fortran is column major! input columns then transpose)
  A = transpose(reshape( [4, 3, &
                          3, 2], [2,2] ))

  ! Invert matrix
  Am1 = inv(A)

  print *, '         |',Am1(1,:),'|' ! | -2  3 |
  print *, ' inv(A)= |',Am1(2,:),'|' ! |  3 -4 |

  ! Final check 
  print *, 'CHECK passed? ',matmul(A,Am1)==eye(2)

end program example_inverse_function

! Singular Values
program example_svdvals
  use stdlib_linalg_constants, only: dp
  use stdlib_linalg, only: svdvals
  implicit none

  real(dp), allocatable :: A(:,:),s(:)
  character(*), parameter :: fmt="(a,*(1x,f12.8))"

  ! We want to find the singular values of matrix: 
  ! 
  !    A = [ 3  2  2]
  !        [ 2  3 -2]  
  !   
  A = transpose(reshape([ 3, 2, 2, &
                          2, 3,-2], [3,2]))

  ! Get singular values
  s = svdvals(A)

  ! Singular values: [5, 3]
  print fmt, '    '
  print fmt, 'S = ',s
  print fmt, '    '
  
end program example_svdvals

program example_to_upper
  use stdlib_string_type
  implicit none
  type(string_type) :: string, uppercase_string

  string = "Uppercase This String"
! string <-- "Uppercase This String"

  uppercase_string = to_upper(string)
! string <-- "Uppercase This String"
! uppercase_string <-- "UPPERCASE THIS STRING"
end program example_to_upper

program example_insert_at
  use stdlib_stringlist_type, only: stringlist_type, stringlist_index_type, fidx, bidx
  use stdlib_string_type, only: string_type
  implicit none

  type(stringlist_type)       :: stringlist
  type(stringlist_index_type) :: index

  index = fidx(1)
  call stringlist%insert_at(index, "Element No. one")
! stringlist <-- {"Element No. one"}

  index = bidx(1)
  call stringlist%insert_at(index, string_type("Element No. two"))
! stringlist <-- {"Element No. one", "Element No. two"}

  call stringlist%insert_at(fidx(2), string_type("Element No. three"))
! stringlist <-- {"Element No. one", "Element No. three", "Element No. two"}

  call stringlist%insert_at(bidx(1), "Element No. four")
! stringlist <-- {"Element No. one", "Element No. three", "Element No. two", "Element No. four"}

end program example_insert_at

program example_falseloc
  use stdlib_array, only: falseloc
  implicit none
  real, allocatable :: array(:)
  allocate (array(-200:200))
  call random_number(array)
  array(falseloc(array < 0.5, lbound(array, 1))) = 0.0
end program example_falseloc

! Matrix pseudo-inversion example: function, subroutine, and operator interfaces
program example_pseudoinverse
  use stdlib_linalg, only: pinv, pseudoinvert, operator(.pinv.), linalg_state_type
  implicit none

  real :: A(15,5), Am1(5,15)
  type(linalg_state_type) :: state
  
  ! Generate random matrix A (15x15)
  call random_number(A)

  ! Pseudo-inverse: Function interfcae
  Am1 = pinv(A, err=state)
  print *, 'Max error (function)  : ', maxval(abs(A-matmul(A, matmul(Am1,A))))
  
  ! User threshold
  Am1 = pinv(A, rtol=0.001, err=state)
  print *, 'Max error (rtol=0.001): ', maxval(abs(A-matmul(A, matmul(Am1,A))))  

  ! Pseudo-inverse: Subroutine interface
  call pseudoinvert(A, Am1, err=state)

  print *, 'Max error (subroutine): ', maxval(abs(A-matmul(A, matmul(Am1,A))))

  ! Operator interface
  Am1 = .pinv.A
  
  print *, 'Max error (operator)  : ', maxval(abs(A-matmul(A, matmul(Am1,A))))

end program example_pseudoinverse

program example_assignment
  use stdlib_bitsets
  use stdlib_kinds, only: int8, int32
  implicit none
  logical(int8)  :: logical1(64) = .true.
  logical(int32), allocatable :: logical2(:)
  type(bitset_64) :: set0, set1
  set0 = logical1
  if (set0%bits() /= 64) then
    error stop &
      ' initialization with logical(int8) failed to set'// &
      ' the right size.'
  else if (.not. set0%all()) then
    error stop ' initialization with'// &
      ' logical(int8) failed to set the right values.'
  else
    write (*, *) 'Initialization with logical(int8) succeeded.'
  end if
  set1 = set0
  if (set1 == set0) &
    write (*, *) 'Initialization by assignment succeeded'
  logical2 = set1
  if (all(logical2)) then
    write (*, *) 'Initialization of logical(int32) succeeded.'
  end if
end program example_assignment

program example_slots_bits
  use stdlib_hashmaps, only: chaining_hashmap_type
  implicit none
  type(chaining_hashmap_type) :: map
  integer :: bits
  call map%init()
  bits = map%slots_bits()
  print *, "Initial slot bits =  ", bits
end program example_slots_bits

! Demonstrate usage of `is_symlink`
program example_is_symlink
  use stdlib_system, only: is_symlink, is_directory
  implicit none

  character(*), parameter :: path = "path/to/check"

  ! Test if path is a symbolic link
  if (is_symlink(path)) then
    print *, "The specified path is a symlink."
    ! Further check if it is linked to a file or a directory
    if (is_directory(path)) then
        print *, "Further, it is a link to a directory."
    else
        print *, "Further, it is a link to a file."
    end if
  else
    print *, "The specified path is not a symlink."
  end if
end program example_is_symlink

! SPDX-Identifier: MIT

!> Terminal color and style escape sequences
module stdlib_ansi
    use stdlib_kinds, only : i1 => int8
    use stdlib_string_type, only : string_type
    implicit none
    private

    public :: ansi_code
    public :: style_reset, style_bold, style_dim, style_italic, style_underline, &
        & style_blink, style_blink_fast, style_reverse, style_hidden, style_strikethrough
    public :: fg_color_black, fg_color_red, fg_color_green, fg_color_yellow, fg_color_blue, &
        & fg_color_magenta, fg_color_cyan, fg_color_white, fg_color_default
    public :: bg_color_black, bg_color_red, bg_color_green, bg_color_yellow, bg_color_blue, &
        & bg_color_magenta, bg_color_cyan, bg_color_white, bg_color_default

    public :: to_string, operator(+), operator(//)



    !> Container for terminal escape code
    type :: ansi_code
        private
        !> Style descriptor
        integer(i1) :: style = -1_i1
        !> Background color descriptor
        integer(i1) :: bg = -1_i1
        !> Foreground color descriptor
        integer(i1) :: fg = -1_i1
    end type ansi_code


    !> Identifier for reset style
    type(ansi_code), parameter :: style_reset = ansi_code(style=0)
    !> Identifier for bold style
    type(ansi_code), parameter :: style_bold = ansi_code(style=1)
    !> Identifier for dim style
    type(ansi_code), parameter :: style_dim = ansi_code(style=2)
    !> Identifier for italic style
    type(ansi_code), parameter :: style_italic = ansi_code(style=3)
    !> Identifier for underline style
    type(ansi_code), parameter :: style_underline = ansi_code(style=4)
    !> Identifier for blink style
    type(ansi_code), parameter :: style_blink = ansi_code(style=5)
    !> Identifier for (fast) blink style
    type(ansi_code), parameter :: style_blink_fast = ansi_code(style=6)
    !> Identifier for reverse style
    type(ansi_code), parameter :: style_reverse = ansi_code(style=7)
    !> Identifier for hidden style
    type(ansi_code), parameter :: style_hidden = ansi_code(style=8)
    !> Identifier for strikethrough style
    type(ansi_code), parameter :: style_strikethrough = ansi_code(style=9)

    !> Identifier for black foreground color
    type(ansi_code), parameter :: fg_color_black = ansi_code(fg=0)
    !> Identifier for red foreground color
    type(ansi_code), parameter :: fg_color_red = ansi_code(fg=1)
    !> Identifier for green foreground color
    type(ansi_code), parameter :: fg_color_green = ansi_code(fg=2)
    !> Identifier for yellow foreground color
    type(ansi_code), parameter :: fg_color_yellow = ansi_code(fg=3)
    !> Identifier for blue foreground color
    type(ansi_code), parameter :: fg_color_blue = ansi_code(fg=4)
    !> Identifier for magenta foreground color
    type(ansi_code), parameter :: fg_color_magenta = ansi_code(fg=5)
    !> Identifier for cyan foreground color
    type(ansi_code), parameter :: fg_color_cyan = ansi_code(fg=6)
    !> Identifier for white foreground color
    type(ansi_code), parameter :: fg_color_white = ansi_code(fg=7)
    !> Identifier for the default foreground color
    type(ansi_code), parameter :: fg_color_default = ansi_code(fg=9)

    !> Identifier for black background color
    type(ansi_code), parameter :: bg_color_black = ansi_code(bg=0)
    !> Identifier for red background color
    type(ansi_code), parameter :: bg_color_red = ansi_code(bg=1)
    !> Identifier for green background color
    type(ansi_code), parameter :: bg_color_green = ansi_code(bg=2)
    !> Identifier for yellow background color
    type(ansi_code), parameter :: bg_color_yellow = ansi_code(bg=3)
    !> Identifier for blue background color
    type(ansi_code), parameter :: bg_color_blue = ansi_code(bg=4)
    !> Identifier for magenta background color
    type(ansi_code), parameter :: bg_color_magenta = ansi_code(bg=5)
    !> Identifier for cyan background color
    type(ansi_code), parameter :: bg_color_cyan = ansi_code(bg=6)
    !> Identifier for white background color
    type(ansi_code), parameter :: bg_color_white = ansi_code(bg=7)
    !> Identifier for the default background color
    type(ansi_code), parameter :: bg_color_default = ansi_code(bg=9)


    interface to_string
        !> Transform a color code into an actual ANSI escape sequence
        pure module function to_string_ansi_code(code) result(str)
            !> Color code to be used
            type(ansi_code), intent(in) :: code
            !> ANSI escape sequence representing the color code
            character(len=:), allocatable :: str
        end function to_string_ansi_code
    end interface to_string


    interface operator(+)
        !> Add two escape sequences, attributes in the right value override the left value ones.
        pure module function add(lval, rval) result(code)
            !> First escape code
            type(ansi_code), intent(in) :: lval
            !> Second escape code
            type(ansi_code), intent(in) :: rval
            !> Combined escape code
            type(ansi_code) :: code
        end function add
    end interface operator(+)

    interface operator(//)
        !> Concatenate an escape code with a string and turn it into an actual escape sequence
        pure module function concat_left(lval, code) result(str)
            !> String to add the escape code to
            character(len=*), intent(in) :: lval
            !> Escape sequence
            type(ansi_code), intent(in) :: code
            !> Concatenated string
            character(len=:), allocatable :: str
        end function concat_left

        !> Concatenate an escape code with a string and turn it into an actual escape sequence
        pure module function concat_right(code, rval) result(str)
            !> String to add the escape code to
            character(len=*), intent(in) :: rval
            !> Escape sequence
            type(ansi_code), intent(in) :: code
            !> Concatenated string
            character(len=:), allocatable :: str
        end function concat_right

        !> Concatenate an escape code with a string and turn it into an actual escape sequence
        pure module function concat_left_str(lval, code) result(str)
            !> String to add the escape code to
            type(string_type), intent(in) :: lval
            !> Escape sequence
            type(ansi_code), intent(in) :: code
            !> Concatenated string
            type(string_type) :: str
        end function concat_left_str

        !> Concatenate an escape code with a string and turn it into an actual escape sequence
        pure module function concat_right_str(code, rval) result(str)
            !> String to add the escape code to
            type(string_type), intent(in) :: rval
            !> Escape sequence
            type(ansi_code), intent(in) :: code
            !> Concatenated string
            type(string_type) :: str
        end function concat_right_str
    end interface operator(//)

end module stdlib_ansi

! Process example 4: Kill a running process
program example_process_kill
    use stdlib_system, only: process_type, runasync, is_running, kill, elapsed, is_windows, sleep
    implicit none
    type(process_type) :: process
    logical :: running, success

    print *, "Starting a long-running process..."
    if (is_windows()) then
        process = runasync("ping -n 10 127.0.0.1")
    else
        process = runasync("ping -c 10 127.0.0.1")
    endif

    ! Verify the process is running
    running = is_running(process)
    print *, "Process running:", running

    ! Wait a bit before killing the process
    call sleep(millisec=250) 

    print *, "Killing the process..."
    call kill(process, success)

    if (success) then
        print *, "Process killed successfully."
    else
        print *, "Failed to kill the process."
    endif

    ! Verify the process is no longer running
    running = is_running(process)
    print *, "Process running after kill:", running

end program example_process_kill

program example_logspace_complex
  use stdlib_math, only: logspace
  use stdlib_kinds, only: dp
  implicit none

  complex(dp) :: start = (10.0_dp, 5.0_dp)
  complex(dp) :: end = (-10.0_dp, 15.0_dp)

  complex(dp) :: z(11) ! Complex values raised to complex powers results in complex values

  z = logspace(start, end, 11)
end program example_logspace_complex

program example_diag2
  use stdlib_linalg, only: diag
  implicit none
  real, allocatable :: v(:)
  real, allocatable :: A(:, :)
  v = [1, 2, 3, 4, 5]
  A = diag(v) ! creates a 5 by 5 matrix with elements of v on the diagonal
end program example_diag2

module test_var
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_kinds, only: sp, dp, int32, int64
    use stdlib_stats, only: var
    use,intrinsic :: ieee_arithmetic, only : ieee_is_nan
    implicit none


    real(sp), parameter :: sptol = 1000 * epsilon(1._sp)
    real(dp), parameter :: dptol = 1000 * epsilon(1._dp)

    integer(int32), parameter :: i321(5) = [1, 2, 3, 4, 5]
    integer(int64), parameter :: i641(5) = [1, 2, 3, 4, 5]

    real(sp), parameter :: s1(5) = [1.0_sp, 2.0_sp, 3.0_sp, 4.0_sp, 5.0_sp]
    real(dp), parameter :: d1(5) = [1.0_dp, 2.0_dp, 3.0_dp, 4.0_dp, 5.0_dp]

    real(dp), parameter :: d(4, 3) = reshape([1._dp, 3._dp, 5._dp, 7._dp,&
                                   2._dp, 4._dp, 6._dp, 8._dp,&
                                   9._dp, 10._dp, 11._dp, 12._dp], [4, 3])
    real(dp), parameter :: d3(4, 3, 3) = reshape([d, d*2, d*4], shape(d3))
    real(sp), parameter :: s(4, 3) = d
    real(sp), parameter :: s3(4, 3, 3) = reshape([s, s*2, s*4], shape(s3))

    integer(int32), parameter :: i32(4, 3) = d
    integer(int32), parameter :: i323(4, 3, 3) = d3
    integer(int64), parameter :: i64(4, 3) = d
    integer(int64), parameter :: i643(4, 3, 3) = d3

    complex(sp), parameter :: cs1(5) = [ cmplx(0.57706_sp, 0.00000_sp, sp),&
                            cmplx(0.00000_sp, 1.44065_sp, sp),&
                            cmplx(1.26401_sp, 0.00000_sp, sp),&
                            cmplx(0.00000_sp, 0.88833_sp, sp),&
                            cmplx(1.14352_sp, 0.00000_sp, sp)]
    complex(dp), parameter :: cd1(5) = [ cmplx(0.57706_dp, 0.00000_dp,kind=dp),&
                            cmplx(0.00000_dp, 1.44065_dp,kind=dp),&
                            cmplx(1.26401_dp, 0.00000_dp,kind=dp),&
                            cmplx(0.00000_dp, 0.88833_dp,kind=dp),&
                            cmplx(1.14352_dp, 0.00000_dp,kind=dp)]
    complex(sp), parameter :: cs(5,3) = reshape([cs1, cs1*3.0_sp, cs1*1.5_sp], shape(cs))
    complex(dp), parameter :: cd(5,3) = reshape([cd1, cd1*3.0_dp, cd1*1.5_dp], shape(cd))

contains


    !> Collect all exported unit tests
    subroutine collect_var(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("sp_1dim", test_sp_1dim), &
            new_unittest("sp_1dim_mask", test_sp_1dim_mask), &
            new_unittest("sp_2dim", test_sp_2dim), &
            new_unittest("sp_2dim_mask", test_sp_2dim_mask), &
            new_unittest("sp_2dim_mask_array", test_sp_2dim_mask_array), &
            new_unittest("sp_3dim", test_sp_3dim), &
            new_unittest("sp_3dim_mask", test_sp_3dim_mask), &
            new_unittest("sp_3dim_mask_array", test_sp_3dim_mask_array), &
            new_unittest("dp_1dim", test_dp_1dim), &
            new_unittest("dp_1dim_mask", test_dp_1dim_mask), &
            new_unittest("dp_1dim_mask_array", test_dp_1dim_mask_array), &
            new_unittest("dp_2dim", test_dp_2dim), &
            new_unittest("dp_2dim_mask", test_dp_2dim_mask), &
            new_unittest("dp_2dim_mask_array", test_dp_2dim_mask_array), &
            new_unittest("dp_3dim", test_dp_3dim), &
            new_unittest("dp_3dim_mask", test_dp_3dim_mask), &
            new_unittest("dp_3dim_mask_array", test_dp_3dim_mask_array), &
            new_unittest("int32_1dim", test_int32_1dim), &
            new_unittest("int32_1dim_mask", test_int32_1dim_mask), &
            new_unittest("int32_1dim_mask_array", test_int32_1dim_mask_array), &
            new_unittest("int32_2dim", test_int32_2dim), &
            new_unittest("int32_2dim_mask", test_int32_2dim_mask), &
            new_unittest("int32_2dim_mask_array", test_int32_2dim_mask_array), &
            new_unittest("int32_3dim", test_int32_3dim), &
            new_unittest("int32_3dim_mask", test_int32_3dim_mask), &
            new_unittest("int32_3dim_mask_array", test_int32_3dim_mask_array), &
            new_unittest("int64_1dim", test_int64_1dim), &
            new_unittest("int64_1dim_mask", test_int64_1dim_mask), &
            new_unittest("int641_1dim_mask_array", test_int641_1dim_mask_array), &
            new_unittest("int64_2dim", test_int64_2dim), &
            new_unittest("int64_2dim_mask", test_int64_2dim_mask), &
            new_unittest("int64_2dim_mask_array", test_int64_2dim_mask_array), &
            new_unittest("int64_3dim", test_int64_3dim), &
            new_unittest("int64_3dim_mask", test_int64_3dim_mask), &
            new_unittest("int64_3dim_mask_array", test_int64_3dim_mask_array), &
            new_unittest("csp_1dim", test_csp_1dim), &
            new_unittest("csp_1dim_mask", test_csp_1dim_mask), &
            new_unittest("csp_1dim_mask_array", test_csp_1dim_mask_array), &
            new_unittest("csp_2dim", test_csp_2dim), &
            new_unittest("csp_2dim_mask", test_csp_2dim_mask), &
            new_unittest("csp_2dim_mask_array", test_csp_2dim_mask_array), &
            new_unittest("cdp_1dim", test_cdp_1dim), &
            new_unittest("cdp_1dim_mask", test_cdp_1dim_mask), &
            new_unittest("cdp_1dim_mask_array", test_cdp_1dim_mask_array), &
            new_unittest("cdp_2dim", test_cdp_2dim), &
            new_unittest("cdp_2dim_mask", test_cdp_2dim_mask), &
            new_unittest("cdp_2dim_mask_array", test_cdp_2dim_mask_array) &
            ]
    end subroutine collect_var

    subroutine test_sp_1dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(s1) - 2.5) < sptol)
        call check(error, abs(var(s1, dim=1) - 2.5) < sptol)

    end subroutine test_sp_1dim

    subroutine test_sp_1dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(s1, .false.)))
        call check(error, ieee_is_nan(var(s1, 1, .false.)))

    end subroutine test_sp_1dim_mask

    subroutine test_sp_1dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(s1, s1 < 5) - 5./3.) < sptol)
        call check(error, ieee_is_nan((var(s1, s1 < 0.))))
        call check(error, ieee_is_nan((var(s1, s1 == 1.))))
        call check(error, abs(var(s1, 1, s1 < 5) - 5./3.) < sptol)

    end subroutine test_sp_1dim_mask_array

    subroutine test_sp_2dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(s) - 13) < sptol)
        call check(error, all( abs( var(s, 1) - [20. / 3., 20. / 3., 5. / 3.]) < sptol))
        call check(error, all( abs( var(s, 2) - [19.0, 43. / 3., 31. / 3. , 7.0]) < sptol))

    end subroutine test_sp_2dim

    subroutine test_sp_2dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(s, .false.)))
        call check(error, any(ieee_is_nan(var(s, 1, .false.))))
        call check(error, any(ieee_is_nan(var(s, 2, .false.))))

    end subroutine test_sp_2dim_mask

    subroutine test_sp_2dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(s, s < 11) - 27.5 / 3.) < sptol)
        call check(error, all( abs( var(s, 1, s < 11) - [20. / 3., 20. / 3., 0.5]) < sptol))
        call check(error, all( abs( var(s, 2, s < 11) - [19.0, 43. / 3., 0.5 , 0.5]) < sptol))

    end subroutine test_sp_2dim_mask_array

    subroutine test_sp_3dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(s3) - 153.4) < sptol)
        call check(error, all( abs( var(s3, 1) -&
                 reshape([20. / 3., 20. / 3., 5. / 3.,&
                          4* 20. / 3., 4* 20. / 3., 4* 5. / 3.,&
                          16* 20. / 3., 16* 20. / 3., 16* 5. / 3.],&
                          [size(s3,2), size(s3,3)]))&
                 < sptol))
        call check(error, all( abs( var(s3, 2) -&
                 reshape([19.0, 43. / 3., 31. / 3. , 7.0,&
                          4* 19.0, 4* 43. / 3., 4* 31. / 3. , 4* 7.0,&
                          16* 19.0, 16* 43. / 3., 16* 31. / 3. , 16* 7.0],&
                          [size(s3,1), size(s3,3)] ))&
                 < sptol))
        call check(error, all(abs( var(s3, 3) -&
                 reshape([ 7./3., 21., 175./3.,&
                           343./3., 28./3., 112./3.,&
                           84., 448./3., 189.,&
                           700./3., 847./3., 336.], [size(s3,1), size(s3,2)] ))&
                 < sptol))

    end subroutine test_sp_3dim

    subroutine test_sp_3dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(s3, .false.)))
        call check(error, any(ieee_is_nan(var(s3, 1, .false.))))
        call check(error, any(ieee_is_nan(var(s3, 2, .false.))))
        call check(error, any(ieee_is_nan(var(s3, 3, .false.))))

    end subroutine test_sp_3dim_mask

    subroutine test_sp_3dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(s3, s3 < 11) - 8.2205877_sp) < sptol)
        call check(error, all( abs( var(s3, 1, s3 < 45) -&
                  reshape([20./3., 20./3., 5./3.,  80./3., 80./3., 20./3.,&
                           320./3., 320./3., 16.],&
                  [size(s3, 2), size(s3, 3)])) < sptol ))
        call check(error, any( ieee_is_nan( var(s3, 2, s3 < 25))))
        call check(error, all( abs( var(s3, 3, s3 < 25) -&
                 reshape([ 7./3., 21., 175./3.,&
                           24.5, 28./3., 112./3.,&
                           84., 32., 40.5,&
                           50., 60.5, 72.], [size(s3,1), size(s3,2)] ))&
                 < sptol ))

    end subroutine test_sp_3dim_mask_array

    subroutine test_dp_1dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(d1) - 2.5) < dptol)
        call check(error, abs(var(d1, 1) - 2.5) < dptol)

    end subroutine test_dp_1dim

    subroutine test_dp_1dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(d1, .false.)))
        call check(error, ieee_is_nan(var(d1, 1, .false.)))

    end subroutine test_dp_1dim_mask

    subroutine test_dp_1dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(d1, d1 < 5) - 5._dp/3._dp) < dptol)
        call check(error, ieee_is_nan((var(d1, d1 < 0.))))
        call check(error, ieee_is_nan((var(d1, d1 == 1.))))
        call check(error, abs(var(d1, 1, d1 < 5) - 5._dp/3._dp) < dptol)

    end subroutine test_dp_1dim_mask_array

    subroutine test_dp_2dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(d) - 13) < dptol)
        call check(error, all( abs( var(d,1) -&
            [20._dp/3._dp, 20._dp/3._dp, 5._dp/3._dp]) < dptol))
        call check(error, all( abs( var(d,2) -&
            [19.0_dp, 43._dp/3._dp, 31._dp/3._dp, 7.0_dp]) < dptol))

    end subroutine test_dp_2dim

    subroutine test_dp_2dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

    call check(error, ieee_is_nan(var(d, .false.)))
    call check(error, any(ieee_is_nan(var(d, 1, .false.))))
    call check(error, any(ieee_is_nan(var(d, 2, .false.))))

    end subroutine test_dp_2dim_mask

    subroutine test_dp_2dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

    call check(error, abs(var(d, d < 11) - 27.5_dp / 3._dp) < dptol)
    call check(error, all( abs( var(d, 1, d < 11) -&
                 [20._dp / 3._dp, 20._dp / 3._dp, 0.5_dp]) < dptol))
    call check(error, all( abs( var(d, 2, d < 11) -&
                 [19.0_dp, 43._dp / 3._dp, 0.5_dp, 0.5_dp]) < dptol))

    end subroutine test_dp_2dim_mask_array

    subroutine test_dp_3dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(d3) - 153.4_dp) < dptol)
        call check(error, all( abs( var(d3, 1) -&
                 reshape([20._dp / 3._dp, 20._dp / 3._dp, 5._dp / 3._dp,&
                          4* 20._dp / 3._dp, 4* 20._dp / 3._dp, 4* 5._dp / 3._dp,&
                          16* 20._dp / 3._dp, 16* 20._dp / 3._dp, 16* 5._dp / 3._dp],&
                          [size(d3,2), size(d3,3)]))&
                 < dptol))
        call check(error, all( abs( var(d3, 2) -&
                 reshape([19.0_dp, 43._dp / 3._dp, 31._dp / 3._dp , 7.0_dp,&
                          4* 19.0_dp, 4* 43._dp / 3._dp, 4* 31._dp / 3._dp , 4* 7.0_dp,&
                          16* 19.0_dp, 16* 43._dp / 3._dp, 16* 31._dp / 3._dp ,&
                          16* 7.0_dp],&
                          [size(d3,1), size(d3,3)] ))&
                 < dptol))
        call check(error, all(abs( var(d3, 3) -&
                 reshape([ 7._dp/3._dp, 21._dp, 175._dp/3._dp,&
                           343._dp/3._dp, 28._dp/3._dp, 112._dp/3._dp,&
                           84._dp, 448._dp/3._dp, 189._dp,&
                           700._dp/3._dp, 847._dp/3._dp, 336._dp],&
                           [size(d3,1), size(d3,2)] ))&
                 < dptol))

    end subroutine test_dp_3dim

    subroutine test_dp_3dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(d3, .false.)))
        call check(error, any(ieee_is_nan(var(d3, 1, .false.))))
        call check(error, any(ieee_is_nan(var(d3, 2, .false.))))
        call check(error, any(ieee_is_nan(var(d3, 3, .false.))))

    end subroutine test_dp_3dim_mask

    subroutine test_dp_3dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(d3, d3 < 25) - 46.041379310344823_dp) < dptol)
        call check(error, all( abs( var(d3, 1, d3 < 45) -&
                  reshape([20._dp/3._dp, 20._dp/3._dp, 5._dp/3._dp,&
                           80._dp/3._dp, 80._dp/3._dp, 20._dp/3._dp,&
                           320._dp/3._dp, 320._dp/3._dp, 16._dp],&
                           [size(d3, 2), size(d3, 3)]))&
                  < dptol ))
        call check(error, any( ieee_is_nan( var(d3, 2, d3 < 25))))
        call check(error, all( abs( var(d3, 3, d3 < 25) -&
                 reshape([ 7._dp/3._dp, 21._dp, 175._dp/3._dp,&
                           24.5_dp, 28._dp/3._dp, 112._dp/3._dp,&
                           84._dp, 32._dp, 40.5_dp,&
                           50._dp, 60.5_dp, 72._dp],&
                           [size(d3,1), size(d3,2)] ))&
                 < dptol ))

    end subroutine test_dp_3dim_mask_array

    subroutine test_int32_1dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i321) - 2.5) < dptol)
        call check(error, abs(var(i321, 1) - 2.5) < dptol)

    end subroutine test_int32_1dim

    subroutine test_int32_1dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(i321, .false.)))
        call check(error, ieee_is_nan(var(i321, 1, .false.)))

    end subroutine test_int32_1dim_mask

    subroutine test_int32_1dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i321, i321 < 5) - 5._dp/3._dp) < dptol)
        call check(error, ieee_is_nan((var(i321, i321 < 0))))
        call check(error, ieee_is_nan((var(i321, i321 == 1))))
        call check(error, abs(var(i321, 1, i321 < 5) - 5._dp/3._dp) < dptol)

    end subroutine test_int32_1dim_mask_array

    subroutine test_int32_2dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i32) - 13) < dptol)
        call check(error, all( abs( var(i32,1) -&
            [20._dp/3._dp, 20._dp/3._dp, 5._dp/3._dp]) < dptol))
        call check(error, all( abs( var(i32,2) -&
            [19.0_dp, 43._dp/3._dp, 31._dp/3._dp, 7.0_dp]) < dptol))

    end subroutine test_int32_2dim

    subroutine test_int32_2dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(i32, .false.)))
        call check(error, any(ieee_is_nan(var(i32, 1, .false.))))
        call check(error, any(ieee_is_nan(var(i32, 2, .false.))))

    end subroutine test_int32_2dim_mask

    subroutine test_int32_2dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i32, i32 < 11) - 27.5_dp / 3._dp) < dptol)
        call check(error, all( abs( var(i32, 1, i32 < 11) -&
            [20._dp / 3._dp, 20._dp / 3._dp, 0.5_dp]) < dptol))
        call check(error, all( abs( var(i32, 2, i32 < 11) -&
            [19.0_dp, 43._dp / 3._dp, 0.5_dp, 0.5_dp]) < dptol))

    end subroutine test_int32_2dim_mask_array

    subroutine test_int32_3dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i323) - 153.4_dp) < dptol)
        call check(error, all( abs( var(i323, 1) -&
                 reshape([20._dp / 3._dp, 20._dp / 3._dp, 5._dp / 3._dp,&
                          4* 20._dp / 3._dp, 4* 20._dp / 3._dp, 4* 5._dp / 3._dp,&
                          16* 20._dp / 3._dp, 16* 20._dp / 3._dp, 16* 5._dp / 3._dp],&
                          [size(i323,2), size(i323,3)]))&
                 < dptol))
        call check(error, all( abs( var(i323, 2) -&
                 reshape([19.0_dp, 43._dp / 3._dp, 31._dp / 3._dp , 7.0_dp,&
                          4* 19.0_dp, 4* 43._dp / 3._dp, 4* 31._dp / 3._dp , 4* 7.0_dp,&
                          16* 19.0_dp, 16* 43._dp / 3._dp, 16* 31._dp / 3._dp ,&
                          16* 7.0_dp],&
                          [size(i323,1), size(i323,3)] ))&
                 < dptol))
        call check(error, all(abs( var(i323, 3) -&
                 reshape([ 7._dp/3._dp, 21._dp, 175._dp/3._dp,&
                           343._dp/3._dp, 28._dp/3._dp, 112._dp/3._dp,&
                           84._dp, 448._dp/3._dp, 189._dp,&
                           700._dp/3._dp, 847._dp/3._dp, 336._dp],&
                           [size(i323,1), size(i323,2)] ))&
                 < dptol))

    end subroutine test_int32_3dim

    subroutine test_int32_3dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(i323, .false.)))
        call check(error, any(ieee_is_nan(var(i323, 1, .false.))))
        call check(error, any(ieee_is_nan(var(i323, 2, .false.))))
        call check(error, any(ieee_is_nan(var(i323, 3, .false.))))

    end subroutine test_int32_3dim_mask

    subroutine test_int32_3dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i323, i323 < 25) - 46.041379310344823_dp) < dptol)
        call check(error, all( abs( var(i323, 1, i323 < 45) -&
                  reshape([20._dp/3._dp, 20._dp/3._dp, 5._dp/3._dp,&
                           80._dp/3._dp, 80._dp/3._dp, 20._dp/3._dp,&
                           320._dp/3._dp, 320._dp/3._dp, 16._dp],&
                           [size(i323, 2), size(i323, 3)]))&
                  < dptol ))
        call check(error, any( ieee_is_nan( var(i323, 2, i323 < 25))))
        call check(error, all( abs( var(i323, 3, i323 < 25) -&
                 reshape([ 7._dp/3._dp, 21._dp, 175._dp/3._dp,&
                           24.5_dp, 28._dp/3._dp, 112._dp/3._dp,&
                           84._dp, 32._dp, 40.5_dp,&
                           50._dp, 60.5_dp, 72._dp],&
                           [size(i323,1), size(i323,2)] ))&
                 < dptol ))

    end subroutine test_int32_3dim_mask_array

    subroutine test_int64_1dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i641) - 2.5) < dptol)
        call check(error, abs(var(i641, 1) - 2.5) < dptol)

    end subroutine test_int64_1dim

    subroutine test_int64_1dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(i641, .false.)))
        call check(error, ieee_is_nan(var(i641, 1, .false.)))

    end subroutine test_int64_1dim_mask

    subroutine test_int641_1dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i641, i641 < 5) - 5._dp/3._dp) < dptol)
        call check(error, ieee_is_nan((var(i641, i641 < 0))))
        call check(error, ieee_is_nan((var(i641, i641 == 1))))
        call check(error, abs(var(i641, 1, i641 < 5) - 5._dp/3._dp) < dptol)

    end subroutine test_int641_1dim_mask_array

    subroutine test_int64_2dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i64) - 13) < dptol)
        call check(error, all( abs( var(i64,1) -&
            [20._dp/3._dp, 20._dp/3._dp, 5._dp/3._dp]) < dptol))
        call check(error, all( abs( var(i64,2) -&
            [19.0_dp, 43._dp/3._dp, 31._dp/3._dp, 7.0_dp]) < dptol))

    end subroutine test_int64_2dim

    subroutine test_int64_2dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(i64, .false.)))
        call check(error, any(ieee_is_nan(var(i64, 1, .false.))))
        call check(error, any(ieee_is_nan(var(i64, 2, .false.))))

    end subroutine test_int64_2dim_mask

    subroutine test_int64_2dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i64, i64 < 11) - 27.5_dp / 3._dp) < dptol)
        call check(error, all( abs( var(i64, 1, i64 < 11) -&
            [20._dp / 3._dp, 20._dp / 3._dp, 0.5_dp]) < dptol))
        call check(error, all( abs( var(i64, 2, i64 < 11) -&
            [19.0_dp, 43._dp / 3._dp, 0.5_dp, 0.5_dp]) < dptol))

    end subroutine test_int64_2dim_mask_array

    subroutine test_int64_3dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i643) - 153.4_dp) < dptol)
        call check(error, all( abs( var(i643, 1) -&
                 reshape([20._dp / 3._dp, 20._dp / 3._dp, 5._dp / 3._dp,&
                          4* 20._dp / 3._dp, 4* 20._dp / 3._dp, 4* 5._dp / 3._dp,&
                          16* 20._dp / 3._dp, 16* 20._dp / 3._dp, 16* 5._dp / 3._dp],&
                          [size(i643,2), size(i643,3)]))&
                 < dptol))
        call check(error, all( abs( var(i643, 2) -&
                 reshape([19.0_dp, 43._dp / 3._dp, 31._dp / 3._dp , 7.0_dp,&
                          4* 19.0_dp, 4* 43._dp / 3._dp, 4* 31._dp / 3._dp , 4* 7.0_dp,&
                          16* 19.0_dp, 16* 43._dp / 3._dp, 16* 31._dp / 3._dp ,&
                          16* 7.0_dp],&
                          [size(i643,1), size(i643,3)] ))&
                 < dptol))
        call check(error, all(abs( var(i643, 3) -&
                 reshape([ 7._dp/3._dp, 21._dp, 175._dp/3._dp,&
                           343._dp/3._dp, 28._dp/3._dp, 112._dp/3._dp,&
                           84._dp, 448._dp/3._dp, 189._dp,&
                           700._dp/3._dp, 847._dp/3._dp, 336._dp],&
                           [size(i643,1), size(i643,2)] ))&
                 < dptol))

    end subroutine test_int64_3dim

    subroutine test_int64_3dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(i643, .false.)))
        call check(error, any(ieee_is_nan(var(i643, 1, .false.))))
        call check(error, any(ieee_is_nan(var(i643, 2, .false.))))
        call check(error, any(ieee_is_nan(var(i643, 3, .false.))))

    end subroutine test_int64_3dim_mask

    subroutine test_int64_3dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(i643, i643 < 25) - 46.041379310344823_dp) < dptol)
        call check(error, all( abs( var(i643, 1, i643 < 45) -&
                  reshape([20._dp/3._dp, 20._dp/3._dp, 5._dp/3._dp,&
                           80._dp/3._dp, 80._dp/3._dp, 20._dp/3._dp,&
                           320._dp/3._dp, 320._dp/3._dp, 16._dp],&
                           [size(i643, 2), size(i643, 3)]))&
                  < dptol ))
        call check(error, any( ieee_is_nan( var(i643, 2, i643 < 25))))
        call check(error, all( abs( var(i643, 3, i643 < 25) -&
                 reshape([ 7._dp/3._dp, 21._dp, 175._dp/3._dp,&
                           24.5_dp, 28._dp/3._dp, 112._dp/3._dp,&
                           84._dp, 32._dp, 40.5_dp,&
                           50._dp, 60.5_dp, 72._dp],&
                           [size(i643,1), size(i643,2)] ))&
                 < dptol ))

    end subroutine test_int64_3dim_mask_array

    subroutine test_csp_1dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cs1) - (var(real(cs1)) + var(aimag(cs1)))) < sptol)
        call check(error, abs(var(cs1, dim=1) - (var(real(cs1),1) + var(aimag(cs1), 1)) ) < sptol)

    end subroutine test_csp_1dim

    subroutine test_csp_1dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(cs1, .false.)))
        call check(error, ieee_is_nan(var(cs1, 1, .false.)))

    end subroutine test_csp_1dim_mask

    subroutine test_csp_1dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cs1, aimag(cs1) == 0) - var(real(cs1), aimag(cs1) == 0)) < sptol)
        call check(error, abs(var(cs1, 1, aimag(cs1) == 0) - var(real(cs1), 1, aimag(cs1) == 0)) < sptol)

    end subroutine test_csp_1dim_mask_array

    subroutine test_csp_2dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cs) - (var(real(cs)) + var(aimag(cs)))) < sptol)
        call check(error, all( abs( var(cs, 1) - (var(real(cs), 1) + var(aimag(cs), 1))) < sptol))
        call check(error, all( abs( var(cs, 2) - (var(real(cs), 2) + var(aimag(cs), 2))) < sptol))

    end subroutine test_csp_2dim

    subroutine test_csp_2dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(cs, .false.)))
        call check(error, any(ieee_is_nan(var(cs, 1, .false.))))
        call check(error, any(ieee_is_nan(var(cs, 2, .false.))))

    end subroutine test_csp_2dim_mask


    subroutine test_csp_2dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cs, aimag(cs) == 0) - var(real(cs), aimag(cs) == 0)) < sptol)
        call check(error, all( abs( var(cs, 1, aimag(cs) == 0) - var(real(cs), 1, aimag(cs) == 0)) < sptol))
        call check(error, any( ieee_is_nan( var(cs, 2, aimag(cs) == 0))))

    end subroutine test_csp_2dim_mask_array

    subroutine test_cdp_1dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cd1) - (var(real(cd1)) + var(aimag(cd1)))) < dptol)
        call check(error, abs(var(cd1, dim=1) - (var(real(cd1),1) + var(aimag(cd1), 1)) ) < dptol)

    end subroutine test_cdp_1dim

    subroutine test_cdp_1dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(cd1, .false.)))
        call check(error, ieee_is_nan(var(cd1, 1, .false.)))

    end subroutine test_cdp_1dim_mask

    subroutine test_cdp_1dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cd1, aimag(cd1) == 0) - var(real(cd1), aimag(cd1) == 0)) < dptol)
        call check(error, abs(var(cd1, 1, aimag(cd1) == 0) - var(real(cd1), 1, aimag(cd1) == 0)) < dptol)

    end subroutine test_cdp_1dim_mask_array

    subroutine test_cdp_2dim(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cd) - (var(real(cd)) + var(aimag(cd)))) < dptol)
        call check(error, all( abs( var(cd, 1) - (var(real(cd), 1) + var(aimag(cd), 1))) < dptol))
        call check(error, all( abs( var(cd, 2) - (var(real(cd), 2) + var(aimag(cd), 2))) < dptol))

    end subroutine test_cdp_2dim

    subroutine test_cdp_2dim_mask(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, ieee_is_nan(var(cd, .false.)))
        call check(error, any(ieee_is_nan(var(cd, 1, .false.))))
        call check(error, any(ieee_is_nan(var(cd, 2, .false.))))

    end subroutine test_cdp_2dim_mask

    subroutine test_cdp_2dim_mask_array(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, abs(var(cd, aimag(cd) == 0) - var(real(cd), aimag(cd) == 0)) < dptol)
        call check(error, all( abs( var(cd, 1, aimag(cd) == 0) - var(real(cd), 1, aimag(cd) == 0)) < dptol))
        call check(error, any( ieee_is_nan( var(cd, 2, aimag(cd) == 0))))

    end subroutine test_cdp_2dim_mask_array

end module


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_var, only : collect_var
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("var", collect_var) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program test_32_bit_hash_performance
!! Program to compare the relative performance of different 32 bit hash
!! functions

    use stdlib_kinds, only: &
        dp,           &
        int8,         &
        int32,        &
        int64

    use stdlib_hash_32bit

    implicit none

    integer, parameter :: &
        block_size(8) = [ 1, 2, 4, 8, 16, 64, 256, 1024 ]
    integer(int32), parameter :: huge32 = huge(0_int32)
    real(dp), parameter :: hugep1 = real(huge32, dp) + 1.0_dp
    integer, parameter :: rand_power = 16
    integer, parameter :: rand_size = 2**rand_power
    integer, parameter :: test_size = rand_size * 4
    integer, parameter :: repeat = 4
    integer :: index, k
    integer :: lun
    real(dp) :: rand(2)
    integer(int32) :: rand_object(rand_size)
    integer(int8) :: test_object(test_size)

    open( newunit=lun, file="32_bit_hash_performance_log.txt", &
          access="sequential", action="write", form="formatted", &
          position="rewind" )

    do index=1, rand_size
        call random_number(rand)
        if (rand(1) < 0.5_dp) then
            rand_object(index) = ceiling(-rand(2)*hugep1, int32) - 1
        else
            rand_object(index) = floor(rand(2)*hugep1, int32)
        end if
    end do

    test_object(:) = transfer( rand_object, 0_int8, test_size )

    write(lun, '("| Algorithm  | Key Size  | Key #      | Time (s) |")')
    write(lun, '("|            | Bytes     |            |          |")')
    write(lun, '("|------------|-----------|------------|----------|")')

    call test_fnv_1()

    call test_fnv_1a()

    call test_nmhash32()

    call test_nmhash32x()

    call test_water()

contains

    subroutine test_fnv_1()
        integer :: index2
        integer(int_hash) :: hash
        real :: t1, t2, tdiff
        integer(int_hash) :: summary(repeat)

        do k=1, size(block_size)
            call cpu_time(t1)
            do index=1, repeat
                do index2=1, test_size, block_size(k)
                    hash = fnv_1_hash( test_object( index2: &
                                                    index2+block_size(k)-1 ) )
                    if (index2 == index) summary(index) = hash
                end do
            end do
            call cpu_time(t2)
            tdiff = t2-t1
            write(lun, '("|", a10, 2x, "|", i8, 3x, "|", 1x, i10, 1x, ' // &
                '"|", f9.5, 1x, "|")') 'FNV-1', &
                block_size(k), repeat*(test_size/block_size(k)), tdiff
        end do

    end subroutine test_fnv_1

    subroutine test_fnv_1a()
        integer :: index2
        integer(int_hash) :: hash
        real :: t1, t2, tdiff
        integer(int_hash) :: summary(repeat)

        do k=1, size(block_size)
            call cpu_time(t1)
            do index=1, repeat
                do index2=1, test_size, block_size(k)
                    hash = fnv_1a_hash( test_object( index2: &
                                                     index2+block_size(k)-1 ) )
                    if (index2 == index) summary(index) = hash
                end do
            end do
            call cpu_time(t2)
            tdiff = t2-t1
            write(lun, '("|", a10, 2x, "|", i8, 3x, "|", 1x, i10, 1x, ' // &
                '"|", f9.5, 1x, "|")') 'FNV-1a', &
                block_size(k), repeat*(test_size/block_size(k)), tdiff
        end do

    end subroutine test_fnv_1a

    subroutine test_nmhash32()
        integer :: index2
        integer(int_hash) :: hash
        integer(int32) :: seed = 0_int32
        real :: t1, t2, tdiff
        integer(int_hash) :: summary(repeat)

        call new_nmhash32_seed( seed )
        do k=1, size(block_size)
            call cpu_time(t1)
            do index=1, repeat
                do index2=1, test_size, block_size(k)
                    hash = nmhash32( test_object( index2: &
                                                  index2+block_size(k)-1 ),&
                                                  seed )
                    if (index2 == index) summary(index) = hash
                end do
            end do
            call cpu_time(t2)
            tdiff = t2-t1
            write(lun, '("|", a10, 2x, "|", i8, 3x, "|", 1x, i10, 1x, ' // &
                '"|", f9.5, 1x, "|")') 'nmhash32', &
                block_size(k), repeat*(test_size/block_size(k)), tdiff
        end do

    end subroutine test_nmhash32

    subroutine test_nmhash32x()
        integer :: index2
        integer(int_hash) :: hash
        integer(int32) :: seed = 0_int32
        real :: t1, t2, tdiff
        integer(int_hash) :: summary(repeat)

        call new_nmhash32x_seed( seed )
        do k=1, size(block_size)
            call cpu_time(t1)
            do index=1, repeat
                do index2=1, test_size, block_size(k)
                    hash = nmhash32x( test_object( index2: &
                                                   index2+block_size(k)-1 ),&
                                                   seed )
                    if (index2 == index) summary(index) = hash
                end do
            end do
            call cpu_time(t2)
            tdiff = t2-t1
            write(lun, '("|", a10, 2x, "|", i8, 3x, "|", 1x, i10, 1x, ' // &
                '"|", f9.5, 1x, "|")') 'nmhash32x', &
                block_size(k), repeat*(test_size/block_size(k)), tdiff
        end do

    end subroutine test_nmhash32x

    subroutine test_water()
        integer :: index2
        integer(int_hash) :: hash
        integer(int64) :: seed = 0_int64
        real :: t1, t2, tdiff
        integer(int_hash) :: summary(repeat)

        call new_water_hash_seed( seed )
        do k=1, size(block_size)
            call cpu_time(t1)
            do index=1, repeat
                do index2=1, test_size, block_size(k)
                    hash = water_hash( test_object( index2:                  &
                                                    index2+block_size(k)-1 ),&
                                                    seed )
                    if (index2 == index) summary(index) = hash
                end do
            end do
            call cpu_time(t2)
            tdiff = t2-t1
            write(lun, '("|", a10, 2x, "|", i8, 3x, "|", 1x, i10, 1x, ' // &
                '"|", f9.5, 1x, "|")') 'water', &
                block_size(k), repeat*(test_size/block_size(k)), tdiff
        end do

    end subroutine test_water

end program test_32_bit_hash_performance

! Demonstrate usage of `is_file`
program example_is_file
  use stdlib_system, only: is_file
  implicit none

  character(*), parameter :: path = "path/to/check"

  ! Test if path is a regular file
  if (is_file(path)) then
    print *, "The specified path is a regular file."
  else
    print *, "The specified path is not a regular file."
  end if
end program example_is_file

program example_linspace_complex
  use stdlib_math, only: linspace
  use stdlib_kinds, only: dp
  implicit none

  complex(dp) :: start = cmplx(10.0_dp, 5.0_dp, kind=dp)
  complex(dp) :: end = cmplx(-10.0_dp, 15.0_dp, kind=dp)

  complex(dp) :: z(11)

  z = linspace(start, end, 11)
end program example_linspace_complex

program example_math_deg2rad
    use stdlib_math, only: deg2rad
    implicit none
    print *, deg2rad(0.0)       ! 0.0
    print *, deg2rad(90.0)      ! 1.57508
    print *, deg2rad(-180.0)    ! -3.1416

end program example_math_deg2rad

program example_ord_sort
  use stdlib_sorting, only: ord_sort
  implicit none
  integer, allocatable :: array1(:), work(:)

  array1 = [5, 4, 3, 1, 10, 4, 9]
  allocate (work, mold=array1)
  call ord_sort(array1, work)
  print *, array1   !print [1, 3, 4, 4, 5, 9, 10]
end program example_ord_sort

program example_le
  use stdlib_bitsets
  implicit none
  type(bitset_64) :: set0, set1, set2
  call set0%init(33)
  call set1%init(33)
  call set2%init(33)
  call set1%set(0)
  call set2%set(32)
  if (set0 <= set1 .and. set1 <= set2 .and. set0 <= set2 .and. &
      set0 <= set0 .and. set1 <= set1 .and. set2 <= set2 .and. &
      .not. set1 <= set0 .and. .not. set2 <= set0 .and. .not. &
      set2 <= set1) then
    write (*, *) 'Passed 64 bit less than or equal tests.'
  else
    error stop 'Failed 64 bit less than or equal tests.'
  end if
end program example_le

program example_index
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: pos

  string = "Search this string for this expression"
  pos = index(string, "this")
! pos == 8

  pos = index(string, "this", back=.true.)
! pos == 24

  pos = index(string, "This")
! pos == 0
end program example_index

program example_input
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_0 = '000000000000000000000000000000000', &
    bits_1 = '000000000000000000000000000000001', &
    bits_33 = '100000000000000000000000000000000'
  integer :: unit
  type(bitset_64) :: set0, set1, set2, set3, set4, set5
  call set0%from_string(bits_0)
  call set1%from_string(bits_1)
  call set2%from_string(bits_33)
  open (newunit=unit, file='test.bin', status='replace', &
        form='unformatted', action='write')
  call set2%output(unit)
  call set1%output(unit)
  call set0%output(unit)
  close (unit)
  open (newunit=unit, file='test.bin', status='old', &
        form='unformatted', action='read')
  call set5%input(unit)
  call set4%input(unit)
  call set3%input(unit)
  close (unit)
  if (set3 /= set0 .or. set4 /= set1 .or. set5 /= set2) then
    error stop 'Transfer to and from units using '// &
      ' output and input failed.'
  else
    write (*, *) 'Transfer to and from units using '// &
      'output and input succeeded.'
  end if
end program example_input

program example_hashmaps_get_all_keys
  use stdlib_kinds, only: int32
  use stdlib_hashmaps, only: chaining_hashmap_type
  use stdlib_hashmap_wrappers, only: get, key_type, set
  implicit none
  type(chaining_hashmap_type) :: map
  type(key_type)   :: key

  type(key_type), allocatable :: keys(:)
  integer(int32) :: i
  
  character(:), allocatable :: str

  ! adding key-value pairs to the map
  call set(key, "initial key")
  call map%map_entry(key, "value 1")

  call set(key, "second key")
  call map%map_entry(key, "value 2")

  call set(key, "last key")
  call map%map_entry(key, "value 3")

  ! getting all the keys in the map
  call map%get_all_keys(keys)

  print '("Number of keys in the hashmap = ", I0)', size(keys)
  !Number of keys in the hashmap = 3

  do i = 1, size(keys)
    call get( keys(i), str )  
    print '("Value of key ", I0, " = ", A)', i, str
  end do
  !Value of key 1 = initial key
  !Value of key 2 = second key
  !Value of key 3 = last key

end program example_hashmaps_get_all_keys

program example_math_is_close

  use stdlib_math, only: is_close
  implicit none
  real :: x(2) = [1, 2], y, NAN

  y = -3
  NAN = sqrt(y)

  print *, is_close(x, [real :: 1, 2.1])       ! [T, F]
  print *, is_close(2.0, 2.1, abs_tol=0.1)    ! T
  print *, NAN, is_close(2.0, NAN), is_close(2.0, NAN, equal_nan=.true.)   ! NAN, F, F
  print *, is_close(NAN, NAN), is_close(NAN, NAN, equal_nan=.true.)        ! F, T

end program example_math_is_close

program example_constructor_integer
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  string = string_type(42)
! len(string) == 2
  string = string_type(-289)
! len(string) == 4
end program example_constructor_integer

program example_error_state1
  use stdlib_error, only: state_type, STDLIB_VALUE_ERROR, STDLIB_SUCCESS, operator(/=) 
  implicit none
  type(state_type) :: err

  ! To create a state variable, we enter its integer state flag, followed by a list of variables 
  ! that will be automatically assembled into a formatted error message. No need to provide string formats
  err = state_type(STDLIB_VALUE_ERROR,'just an example with scalar ',&
                   'integer=',1,'real=',2.0,'complex=',(3.0,1.0),'and array ',[1,2,3],'inputs')

  ! Print flag
  print *, err%print()

  ! Check success
  print *, 'Check error: ',err%error()
  print *, 'Check flag : ',err /= STDLIB_SUCCESS

end program example_error_state1

! SPDX-Identifier: MIT
module test_string_functions
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_string_type, only : string_type, assignment(=), operator(==), &
                                    to_lower, to_upper, to_title, to_sentence, reverse
    use stdlib_strings, only: slice, find, replace_all, padl, padr, count, zfill
    use stdlib_optval, only: optval
    use stdlib_strings, only : to_string
    implicit none

contains


    !> Collect all exported unit tests
    subroutine collect_string_functions(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("to_lower_string", test_to_lower_string), &
            new_unittest("to_upper_string", test_to_upper_string), &
            new_unittest("to_title_string", test_to_title_string), &
            new_unittest("to_sentence_string", test_to_sentence_string), &
            new_unittest("reverse_string", test_reverse_string), &
            new_unittest("slice_string", test_slice_string), &
            new_unittest("slice_gen", test_slice_gen), &
            new_unittest("find", test_find), &
            new_unittest("replace_all", test_replace_all), &
            new_unittest("padl", test_padl), &
            new_unittest("padr", test_padr), &
            new_unittest("count", test_count), &
            new_unittest("zfill", test_zfill) &
            ]
    end subroutine collect_string_functions

    subroutine test_to_lower_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string, compare_string
        test_string = "To_LoWEr !$%-az09AZ"
        compare_string = "to_lower !$%-az09az"

        call check(error, to_lower(test_string) == compare_string)

    end subroutine test_to_lower_string

    subroutine test_to_upper_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string, compare_string
        test_string = "To_UpPeR !$%-az09AZ"
        compare_string = "TO_UPPER !$%-AZ09AZ"

        call check(error, to_upper(test_string) == compare_string)

    end subroutine test_to_upper_string

    subroutine test_to_title_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string, compare_string
        test_string = "tO_%t!TL3 7h1S p#ra$e"
        compare_string = "To_%T!Tl3 7h1s P#Ra$E"

        call check(error, to_title(test_string) == compare_string)

    end subroutine test_to_title_string

    subroutine test_to_sentence_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string, compare_string
        test_string = "_#To seNtEncE !$%-az09AZ"
        compare_string = "_#To sentence !$%-az09az"

        call check(error, to_sentence(test_string) == compare_string)

    end subroutine test_to_sentence_string

    subroutine test_reverse_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string, compare_string
        test_string = "_To ReVerSe !$%-az09AZ   "
        compare_string = "   ZA90za-%$! eSreVeR oT_"

        call check(error, reverse(test_string) == compare_string)

    end subroutine test_reverse_string

    subroutine test_slice_string(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string
        test_string = "abcdefghijklmnopqrstuvwxyz"

        ! Only one argument is given
        ! Valid
        call check(error, slice(test_string, first=10) == "jklmnopqrstuvwxyz", &
            "slice, Valid arguments: first=10") ! last=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=10) == "abcdefghij", &
            "slice, Valid arguments: last=10") ! first=-inf
        if (allocated(error)) return
        call check(error, slice(test_string, stride=3) == "adgjmpsvy", &
            "slice, Valid arguments: stride=3") ! first=-inf, last=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, stride=-3) == "zwtqnkheb", &
            "slice, Valid arguments: stride=-3") ! first=+inf, last=-inf
        if (allocated(error)) return

        ! Invalid
        call check(error, slice(test_string, first=27) == "", &
            "slice, Invalid arguments: first=27") ! last=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, first=-10) == "abcdefghijklmnopqrstuvwxyz", &
            "slice, Invalid arguments: first=-10") ! last=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=-2) == "", &
            "slice, Invalid arguments: last=-2") ! first=-inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=30) == "abcdefghijklmnopqrstuvwxyz", &
            "slice, Invalid arguments: last=30") ! first=-inf
        if (allocated(error)) return
        call check(error, slice(test_string, stride=0) == "abcdefghijklmnopqrstuvwxyz", &
            "slice, Invalid arguments: stride=0") ! stride=1
        if (allocated(error)) return

        ! Only two arguments are given
        ! Valid
        call check(error, slice(test_string, first=10, last=20) == "jklmnopqrst", &
            "slice, Valid arguments: first=10, last=20")
        if (allocated(error)) return
        call check(error, slice(test_string, first=7, last=2) == "gfedcb", &
            "slice, Valid arguments: first=7, last=2") ! stride=-1
        if (allocated(error)) return
        call check(error, slice(test_string, first=10, stride=-2) == "jhfdb", &
            "slice, Valid arguments: first=10, stride=-2") ! last=-inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=21, stride=-2) == "zxv", &
            "slice, Valid arguments: last=21, stride=-2") ! first=+inf
        if (allocated(error)) return

        ! Atleast one argument is invalid
        call check(error, slice(test_string, first=30, last=-3) == "zyxwvutsrqponmlkjihgfedcba", &
            "slice, Invalid arguments: first=30, last=-3")
        if (allocated(error)) return
        call check(error, slice(test_string, first=1, last=-20) == "a", &
            "slice, Invalid arguments: first=1, last=-20")
        if (allocated(error)) return
        call check(error, slice(test_string, first=7, last=-10) == "gfedcba", &
            "slice, Invalid arguments: first=7, last=-10")
        if (allocated(error)) return
        call check(error, slice(test_string, first=500, last=22) == "zyxwv", &
            "slice, Invalid arguments: first=500, last=22")
        if (allocated(error)) return
        call check(error, slice(test_string, first=50, last=27) == "", &
            "slice, Invalid arguments: first=50, last=27")
        if (allocated(error)) return
        call check(error, slice(test_string, first=-20, last=0) == "", &
            "slice, Invalid arguments: first=-20, last=0")
        if (allocated(error)) return
        call check(error, slice(test_string, last=-3, stride=-2) == "zxvtrpnljhfdb", &
            "slice, Invalid arguments: last=-3, stride=-2") ! first=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=10, stride=0) == "abcdefghij", &
            "slice, Invalid arguments: last=10, stride=0") ! stride=1
        if (allocated(error)) return
        call check(error, slice(test_string, first=-2, stride=-2) == "", &
            "slice, Invalid arguments: first=-2, stride=-2") ! last=-inf
        if (allocated(error)) return
        call check(error, slice(test_string, first=27, stride=2) == "", &
            "slice, Invalid arguments: first=27, stride=2") ! last=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=27, stride=-1) == "", &
            "slice, Invalid arguments: last=27, stride=-1") ! first=+inf
        if (allocated(error)) return

        ! All three arguments are given
        ! Valid
        call check(error, slice(test_string, first=2, last=16, stride=3) == "behkn", &
            "slice, Valid arguments: first=2, last=16, stride=3")
        if (allocated(error)) return
        call check(error, slice(test_string, first=16, last=2, stride=-3) == "pmjgd", &
            "slice, Valid arguments: first=16, last=2, stride=-3")
        if (allocated(error)) return
        call check(error, slice(test_string, first=7, last=7, stride=-4) == "g", &
            "slice, Valid arguments: first=7, last=7, stride=-4")
        if (allocated(error)) return
        call check(error, slice(test_string, first=7, last=7, stride=3) == "g", &
            "slice, Valid arguments: first=7, last=7, stride=3")
        if (allocated(error)) return
        call check(error, slice(test_string, first=2, last=6, stride=-1) == "", &
            "slice, Valid arguments: first=2, last=6, stride=-1")
        if (allocated(error)) return
        call check(error, slice(test_string, first=20, last=10, stride=2) == "", &
            "slice, Valid arguments: first=20, last=10, stride=2")
        if (allocated(error)) return

        ! Atleast one argument is invalid
        call check(error, slice(test_string, first=20, last=30, stride=2) == "tvxz", &
            "slice, Invalid arguments: first=20, last=30, stride=2")
        if (allocated(error)) return
        call check(error, slice(test_string, first=-20, last=30, stride=2) == "acegikmoqsuwy", &
            "slice, Invalid arguments: first=-20, last=30, stride=2")
        if (allocated(error)) return
        call check(error, slice(test_string, first=26, last=30, stride=1) == "z", &
            "slice, Invalid arguments: first=26, last=30, stride=1")
        if (allocated(error)) return
        call check(error, slice(test_string, first=1, last=-20, stride=-1) == "a", &
            "slice, Invalid arguments: first=1, last=-20, stride=-1")
        if (allocated(error)) return
        call check(error, slice(test_string, first=26, last=20, stride=1) == "", &
            "slice, Invalid arguments: first=26, last=20, stride=1")
        if (allocated(error)) return
        call check(error, slice(test_string, first=1, last=20, stride=-1) == "", &
            "slice, Invalid arguments: first=1, last=20, stride=-1")
        if (allocated(error)) return

        test_string = ""
        ! Empty string input
        call check(error, slice(test_string, first=-2, last=6) == "", &
            "slice, Empty string: first=-2, last=6")
        if (allocated(error)) return
        call check(error, slice(test_string, first=6, last=-2) == "", &
            "slice, Empty string: first=6, last=-2")
        if (allocated(error)) return
        call check(error, slice(test_string, first=-10) == "", &
            "slice, Empty string: first=-10") ! last=+inf
        if (allocated(error)) return
        call check(error, slice(test_string, last=10) == "", &
            "slice, Empty string: last=10") ! first=-inf
        if (allocated(error)) return
        call check(error, slice(test_string) == "", &
            "slice, Empty string: no arguments provided")

    end subroutine test_slice_string

    subroutine test_find(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string_1, test_string_2, test_pattern_1, test_pattern_2
        test_string_1 = "qwqwqwqwqwqwqw"
        test_string_2 = "abccbabccbabc"
        test_pattern_1 = "qwq"
        test_pattern_2 = "abccbabc"

        call check(error, all(find([test_string_1, test_string_2], test_pattern_1, 4) == [7, 0]), &
            & 'find: [test_string_1, test_string_2], test_pattern_1, 4')
        if (allocated(error)) return
        call check(error, all(find(test_string_1, [test_pattern_1, test_pattern_2], 3, .false.) == [9, 0]), &
            & 'find: test_string_1, [test_pattern_1, test_pattern_2], 3, .false.')
        if (allocated(error)) return
        call check(error, find(test_string_1, test_pattern_1, 7) == 0, &
            & 'find: test_string_1, test_pattern_1, 7')
        if (allocated(error)) return
        call check(error, all(find([test_string_1, test_string_2, test_string_2], [test_pattern_1, &
            & test_pattern_2, test_pattern_2], [7, 2, 2], [.true., .false., .true.]) == [0, 0, 6]), &
            & 'find: [test_string_1, test_string_2, test_string_2], [test_pattern_1, &
            & test_pattern_2, test_pattern_2], [7, 2, 2], [.true., .false., .true.]')
        if (allocated(error)) return
        call check(error, find("qwqwqwqwqwqwqw", test_pattern_1) == 1, &
            & 'find: "qwqwqwqwqwqwqw", test_pattern_1')
        if (allocated(error)) return
        call check(error, all(find(test_string_1, ["qwq", "wqw"], 2) == [3, 4]), &
            & 'find: test_string_1, ["qwq", "wqw"], 2')
        if (allocated(error)) return
        call check(error, find("qwqwqwqwqwqwqw", "qwq", 2, .false.) == 5, &
            & 'find: "qwqwqwqwqwqwqw", "qwq", 2, .false.')
        if (allocated(error)) return
        call check(error, find("", "") == 0, &
            & 'find: "", ""')
        if (allocated(error)) return
        call check(error, find("", test_pattern_1) == 0, &
            & 'find: "", test_pattern_1')
        if (allocated(error)) return
        call check(error, find(test_string_1, "") == 0, &
            & 'find: test_string_1, ""')

    end subroutine test_find

    subroutine test_slice_gen(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), parameter :: test = &
            & "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"
        integer :: i, j, k
        integer, parameter :: offset = 3

        do i = 1 - offset, len(test) + offset
            call check_slicer(error, test, first=i)
            if (allocated(error)) return
        end do

        do i = 1 - offset, len(test) + offset
            call check_slicer(error, test, last=i)
            if (allocated(error)) return
        end do

        do i = -len(test) - offset, len(test) + offset
            call check_slicer(error, test, stride=i)
            if (allocated(error)) return
        end do

        do i = 1 - offset, len(test) + offset
            do j = 1 - offset, len(test) + offset
                call check_slicer(error, test, first=i, last=j)
                if (allocated(error)) return
            end do
        end do

        do i = 1 - offset, len(test) + offset
            do j = -len(test) - offset, len(test) + offset
                call check_slicer(error, test, first=i, stride=j)
                if (allocated(error)) return
            end do
        end do

        do i = 1 - offset, len(test) + offset
            do j = -len(test) - offset, len(test) + offset
                call check_slicer(error, test, last=i, stride=j)
                if (allocated(error)) return
            end do
        end do

        do i = 1 - offset, len(test) + offset
            do j = 1 - offset, len(test) + offset
                do k = -len(test) - offset, len(test) + offset
                    call check_slicer(error, test, first=i, last=j, stride=k)
                    if (allocated(error)) return
                end do
            end do
        end do
    end subroutine test_slice_gen

    subroutine check_slicer(error, string, first, last, stride)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        character(len=*), intent(in) :: string
        integer, intent(in), optional :: first
        integer, intent(in), optional :: last
        integer, intent(in), optional :: stride

        character(len=:), allocatable :: actual, expected, message
        logical :: stat

        actual = slice(string, first, last, stride)
        expected = reference_slice(string, first, last, stride)

        stat = actual == expected

        if (.not.stat) then
            message = "For input '"//string//"'"//new_line('a')

            if (present(first)) then
                message = message // "first: "//to_string(first)//new_line('a')
            end if
            if (present(last)) then
                message = message // "last: "//to_string(last)//new_line('a')
            end if
            if (present(stride)) then
                message = message // "stride: "//to_string(stride)//new_line('a')
            end if
            message = message // "Expected: '"//expected//"' but got '"//actual//"'"
        end if
        call check(error, stat, message)

    end subroutine check_slicer

    pure function reference_slice(string, first, last, stride) result(sliced_string)
        character(len=*), intent(in) :: string
        integer, intent(in), optional :: first
        integer, intent(in), optional :: last
        integer, intent(in), optional :: stride
        character(len=:), allocatable :: sliced_string
        character(len=1), allocatable :: carray(:)

        integer :: first_, last_, stride_

        stride_ = 1
        if (present(stride)) then
            stride_ = merge(stride_, stride, stride == 0)
        else
            if (present(first) .and. present(last)) then
                if (last < first) stride_ = -1
            end if
        end if

        if (stride_ < 0) then
            last_ = min(max(optval(last, 1), 1), len(string)+1)
            first_ = min(max(optval(first, len(string)), 0), len(string))
        else
            first_ = min(max(optval(first, 1), 1), len(string)+1)
            last_ = min(max(optval(last, len(string)), 0), len(string))
        end if

        carray = string_to_carray(string)
        carray = carray(first_:last_:stride_)
        sliced_string = carray_to_string(carray)

    end function reference_slice

    pure function string_to_carray(string) result(carray)
        character(len=*), intent(in) :: string
        character(len=1) :: carray(len(string))

        carray = transfer(string, carray)
    end function string_to_carray

    pure function carray_to_string(carray) result(string)
        character(len=1), intent(in) :: carray(:)
        character(len=size(carray)) :: string

        string = transfer(carray, string)
    end function carray_to_string

    subroutine test_replace_all(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string_1, test_pattern_1, test_replacement_1
        type(string_type) :: test_string_2, test_pattern_2, test_replacement_2
        test_string_1 = "mutate DNA sequence: GTTATCGTATGCCGTAATTAT"
        test_pattern_1 = "TAT"
        test_replacement_1 = "ATA"
        test_string_2 = "mutate DNA sequence: AGAGAGCCTAGAGAGAG"
        test_pattern_2 = "AGA"
        test_replacement_2 = "aga"

        ! all 3 as string_type
        call check(error, replace_all(test_string_1, test_pattern_1, test_replacement_1) == & 
            & "mutate DNA sequence: GTATACGATAGCCGTAATATA", &
            & "replace_all: all 3 string_type, test case 1")
        if (allocated(error)) return
        call check(error, replace_all(test_string_2, test_pattern_2, test_replacement_2) == &
            & "mutate DNA sequence: agaGAGCCTagaGagaG", &
            & "replace_all: all 3 string_type, test case 2")
        if (allocated(error)) return
        call check(error, replace_all(test_string_2, test_pattern_2, test_replacement_1) == &
            & "mutate DNA sequence: ATAGAGCCTATAGATAG", &
            & "replace_all: all 3 string_type, test case 3")
        if (allocated(error)) return

        ! 2 as string_type and 1 as character scalar
        call check(error, replace_all(test_string_1, "tat", test_replacement_1) == &
            & "muATAe DNA sequence: GTTATCGTATGCCGTAATTAT", &
            & "replace_all: 2 string_type & 1 character scalar, test case 1")
        if (allocated(error)) return
        call check(error, replace_all(test_string_2, test_pattern_2, "GC") == &
            & "mutate DNA sequence: GCGAGCCTGCGGCG", &
            & "replace_all: 2 string_type & 1 character scalar, test case 2")
        if (allocated(error)) return
        call check(error, replace_all("mutate DNA sequence: AGAGAGCCTAGAGAGAG", test_pattern_2, &
            & test_replacement_2) == "mutate DNA sequence: agaGAGCCTagaGagaG", &
            & "replace_all: 2 string_type & 1 character scalar, test case 3")
        if (allocated(error)) return


        ! 1 as string_type and 2 as character scalar
        call check(error, replace_all(test_string_1, "TAT", "ATA") == &
            & "mutate DNA sequence: GTATACGATAGCCGTAATATA", &
            & "replace_all: 1 string_type & 2 character scalar, test case 1")
        if (allocated(error)) return
        call check(error, replace_all("mutate DNA sequence: AGAGAGCCTAGAGAGAG", test_pattern_2, "GC") == &
            & "mutate DNA sequence: GCGAGCCTGCGGCG", &
            & "replace_all: 1 string_type & 2 character scalar, test case 2")
        if (allocated(error)) return
        call check(error, replace_all("mutate DNA sequence: GTTATCGTATGCCGTAATTAT", "TA", &
            & test_replacement_2) == "mutate DNA sequence: GTagaTCGagaTGCCGagaATagaT", &
            & "replace_all: 1 string_type & 2 character scalar, test case 3")
        if (allocated(error)) return
        call check(error, replace_all("mutate DNA sequence: GTTATCGTATGCCGTAATTAT", &
            & test_pattern_1, "") == "mutate DNA sequence: GTCGGCCGTAAT", &
            & "replace_all: 1 string_type & 2 character scalar, test case 4")
        if (allocated(error)) return
        call check(error, replace_all(test_string_1, "", "anything here") == test_string_1, &
            & "replace_all: 1 string_type & 2 character scalar, test case 5")
        if (allocated(error)) return
        call check(error, replace_all("", test_pattern_2, "anything here") == "", &
            & "replace_all: 1 string_type & 2 character scalar, test case 6")
        if (allocated(error)) return

        ! all 3 as character scalar
        call check(error, replace_all("mutate DNA sequence: GTTATCGTATGCCGTAATTAT", &
            & "GT", "gct") == "mutate DNA sequence: gctTATCgctATGCCgctAATTAT", &
            & "replace_all: all 3 character scalar, test case 1")
        if (allocated(error)) return
        call check(error, replace_all("", "anything here", "anything here") == "", &
            & "replace_all: all 3 character scalar, test case 2")

    end subroutine test_replace_all

    subroutine test_padl(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string
        character(len=:), allocatable :: test_char

        test_string = "left pad this string"
        test_char = "  left pad this string  "

        ! output_length > len(string)
        call check(error, padl(test_string, 25, "#") == "#####left pad this string", &
            & 'padl: output_length > len(string), test_case 1')
        if (allocated(error)) return
        call check(error, padl(test_string, 22, "$") == "$$left pad this string", &
            & 'padl: output_length > len(string), test_case 2')
        if (allocated(error)) return
        call check(error, padl(test_string, 23) == "   left pad this string", &
            & 'padl: output_length > len(string), test_case 3')
        if (allocated(error)) return
        call check(error, padl(test_char, 26) == "    left pad this string  ", &
            & 'padl: output_length > len(string), test_case 4')
        if (allocated(error)) return
        call check(error, padl(test_char, 26, "&") == "&&  left pad this string  ", &
            & 'padl: output_length > len(string), test_case 5')
        if (allocated(error)) return
        call check(error, padl("", 10, "!") == "!!!!!!!!!!", &
            & 'padl: output_length > len(string), test_case 6')
        if (allocated(error)) return

        ! output_length <= len(string)
        call check(error, padl(test_string, 18, "#") == "left pad this string", &
            & 'padl: output_length <= len(string), test_case 1')
        if (allocated(error)) return
        call check(error, padl(test_string, -4, "@") == "left pad this string", &
            & 'padl: output_length <= len(string), test_case 2')
        if (allocated(error)) return
        call check(error, padl(test_char, 20, "0") == "  left pad this string  ", &
            & 'padl: output_length <= len(string), test_case 3')
        if (allocated(error)) return
        call check(error, padl(test_char, 17) == "  left pad this string  ", &
            & 'padl: output_length <= len(string), test_case 4')
        if (allocated(error)) return
        call check(error, padl("", 0, "!") == "", &
            & 'padl: output_length <= len(string), test_case 5')
        if (allocated(error)) return
        call check(error, padl("", -12, "!") == "", &
            & 'padl: output_length <= len(string), test_case 6')

    end subroutine test_padl

    subroutine test_padr(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string
        character(len=:), allocatable :: test_char

        test_string = "right pad this string"
        test_char = "  right pad this string  "

        ! output_length > len(string)
        call check(error, padr(test_string, 25, "#") == "right pad this string####", &
            & 'padr: output_length > len(string), test_case 1')
        if (allocated(error)) return
        call check(error, padr(test_string, 22, "$") == "right pad this string$", &
            & 'padr: output_length > len(string), test_case 2')
        if (allocated(error)) return
        call check(error, padr(test_string, 24) == "right pad this string   ", &
            & 'padr: output_length > len(string), test_case 3')
        if (allocated(error)) return
        call check(error, padr(test_char, 27) == "  right pad this string    ", &
            & 'padr: output_length > len(string), test_case 4')
        if (allocated(error)) return
        call check(error, padr(test_char, 27, "&") == "  right pad this string  &&", &
            & 'padr: output_length > len(string), test_case 5')
        if (allocated(error)) return
        call check(error, padr("", 10, "!") == "!!!!!!!!!!", &
            & 'padr: output_length > len(string), test_case 6')
        if (allocated(error)) return

        ! output_length <= len(string)
        call check(error, padr(test_string, 18, "#") == "right pad this string", &
            & 'padr: output_length <= len(string), test_case 1')
        if (allocated(error)) return
        call check(error, padr(test_string, -4, "@") == "right pad this string", &
            & 'padr: output_length <= len(string), test_case 2')
        if (allocated(error)) return
        call check(error, padr(test_char, 20, "0") == "  right pad this string  ", &
            & 'padr: output_length <= len(string), test_case 3')
        if (allocated(error)) return
        call check(error, padr(test_char, 17) == "  right pad this string  ", &
            & 'padr: output_length <= len(string), test_case 4')
        if (allocated(error)) return
        call check(error, padr("", 0, "!") == "", &
            & 'padr: output_length <= len(string), test_case 5')
        if (allocated(error)) return
        call check(error, padr("", -12, "!") == "", &
            & 'padr: output_length <= len(string), test_case 6')

    end subroutine test_padr

    subroutine test_count(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string_1, test_string_2, test_pattern_1, test_pattern_2
        test_string_1 = "DNA sequence: AGAGAGAGTCCTGTCGAGA"
        test_string_2 = "DNA sequence: GTCCTGTCCTGTCAGA"
        test_pattern_1 = "AGA"
        test_pattern_2 = "GTCCTGTC"

        ! all 2 as string_type
        call check(error, all(count([test_string_1, test_string_2], test_pattern_1) == [4, 1]), &
            & 'count: all 2 as string_type, test case 1')
        if (allocated(error)) return
        call check(error, all(count(test_string_1, [test_pattern_1, test_pattern_2], .false.) == [3, 1]), &
            & 'count: all 2 as string_type, test case 2')
        if (allocated(error)) return
        call check(error, count(test_string_2, test_pattern_1, .false.) == 1, &
            & 'count: all 2 as string_type, test case 3')
        if (allocated(error)) return
        call check(error, all(count([test_string_2, test_string_2, test_string_1], &
            & [test_pattern_2, test_pattern_2, test_pattern_1], [.true., .false., .false.]) == &
            & [2, 1, 3]), 'count: all 2 as string_type, test case 4')
        if (allocated(error)) return
        call check(error, all(count([[test_string_1, test_string_2], [test_string_1, test_string_2]], &
            & [[test_pattern_1, test_pattern_2], [test_pattern_2, test_pattern_1]], .true.) == &
            & [[4, 2], [1, 1]]), 'count: all 2 as string_type, test case 5')
        if (allocated(error)) return

        ! 1 string_type and 1 character scalar
        call check(error, all(count(test_string_1, ["AGA", "GTC"], [.true., .false.]) == [4, 2]), &
            & 'count: 1 string_type and 1 character scalar, test case 1')
        if (allocated(error)) return
        call check(error, all(count([test_string_1, test_string_2], ["CTC", "GTC"], [.true., .false.]) == &
            & [0, 3]), 'count: 1 string_type and 1 character scalar, test case 2')
        if (allocated(error)) return
        call check(error, all(count(["AGAGAGAGTCCTGTCGAGA", "AGAGAGAGTCCTGTCGAGA"], &
            & test_pattern_1, [.false., .true.]) == [3, 4]), &
            & 'count: 1 string_type and 1 character scalar, test case 3')
        if (allocated(error)) return
        call check(error, count(test_string_1, "GAG") == 4, &
            & 'count: 1 string_type and 1 character scalar, test case 4')
        if (allocated(error)) return
        call check(error, count("DNA sequence: GTCCTGTCCTGTCAGA", test_pattern_2, .false.) == 1, &
            & 'count: 1 string_type and 1 character scalar, test case 5')
        if (allocated(error)) return

        ! all 2 character scalar
        call check(error, all(count("", ["mango", "trees"], .true.) == [0, 0]), &
            & 'count: all 2 character scalar, test case 1')
        if (allocated(error)) return
        call check(error, count("", "", .true.) == 0, 'count: all 2 character scalar, test case 2')
        if (allocated(error)) return
        call check(error, all(count(["mango", "trees"], "", .true.) == [0, 0]), &
            & 'count: all 2 character scalar, test case 3')

    end subroutine test_count

    subroutine test_zfill(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: test_string
        character(len=:), allocatable :: test_char

        test_string = "left pad this string"
        test_char = "  left pad this string  "

        ! output_length > len(string)
        call check(error, zfill(test_string, 25) == "00000left pad this string", &
            & 'zfill: output_length > len(string), test_case 1')
        if (allocated(error)) return
        call check(error, zfill(test_string, 22) == "00left pad this string", &
            & 'zfill: output_length > len(string), test_case 2')
        if (allocated(error)) return
        call check(error, zfill(test_string, 23) == "000left pad this string", &
            & 'zfill: output_length > len(string), test_case 3')
        if (allocated(error)) return
        call check(error, zfill(test_char, 26) == "00  left pad this string  ", &
            & 'zfill: output_length > len(string), test_case 4')
        if (allocated(error)) return
        call check(error, zfill("", 10) == "0000000000", &
            & 'zfill: output_length > len(string), test_case 5')
        if (allocated(error)) return

        ! output_length <= len(string)
        call check(error, zfill(test_string, 18) == "left pad this string", &
            & 'zfill: output_length <= len(string), test_case 1')
        if (allocated(error)) return
        call check(error, zfill(test_string, -4) == "left pad this string", &
            & 'zfill: output_length <= len(string), test_case 2')
        if (allocated(error)) return
        call check(error, zfill(test_char, 20) == "  left pad this string  ", &
            & 'zfill: output_length <= len(string), test_case 3')
        if (allocated(error)) return
        call check(error, zfill(test_char, 17) == "  left pad this string  ", &
            & 'zfill: output_length <= len(string), test_case 4')
        if (allocated(error)) return
        call check(error, zfill("", 0) == "", &
            & 'zfill: output_length <= len(string), test_case 5')
        if (allocated(error)) return
        call check(error, zfill("", -12) == "", &
            & 'zfill: output_length <= len(string), test_case 6')

    end subroutine test_zfill

end module test_string_functions


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_string_functions, only : collect_string_functions
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("string-functions", collect_string_functions) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_ligamma
  use stdlib_specialfunctions_gamma, only: lig => lower_incomplete_gamma
  implicit none
  integer :: p
  real :: p1

  p = 3
  p1 = 2.3
  print *, lig(p, -5.0)

! -2521.02417

  print *, lig(p1, 5.0)

! 1.09715652
end program example_ligamma

program example_any
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_0 = '0000000000000000000'
  type(bitset_64) :: set0
  call set0%from_string(bits_0)
  if (.not. set0%any()) then
    write (*, *) "FROM_STRING interpreted "// &
      "BITS_0's value properly."
  end if
  call set0%set(5)
  if (set0%any()) then
    write (*, *) "ANY interpreted SET0's value properly."
  end if
end program example_any

program example_logspace_rstart_cbase
  use stdlib_math, only: logspace
  use stdlib_kinds, only: dp
  implicit none

  real(dp) :: start = 0.0_dp
  real(dp) :: end = 3.0_dp
  integer, parameter :: n = 4
  complex(dp) :: base = (0.0_dp, 1.0_dp)

  complex(dp) :: z(n) ! complex values raised to real powers result in complex values

  z = logspace(start, end, n, base)

end program example_logspace_rstart_cbase

program example_var
  use stdlib_stats, only: var
  implicit none
  real :: x(1:6) = [1., 2., 3., 4., 5., 6.]
  real :: y(1:2, 1:3) = reshape([1., 2., 3., 4., 5., 6.], [2, 3])
  print *, var(x)                                  !returns 3.5
  print *, var(x, corrected=.false.)             !returns 2.9167
  print *, var(y)                                  !returns 3.5
  print *, var(y, 1)                               !returns [0.5, 0.5, 0.5]
  print *, var(y, 1, y > 3.)                       !returns [NaN, NaN, 0.5]
  print *, var(y, 1, y > 3., corrected=.false.)    !returns [NaN, 0., 0.25]
end program example_var

program example_reverse
  use stdlib_string_type
  implicit none
  type(string_type) :: string, reverse_string

  string = "Reverse This String"
! string <-- "Reverse This String"

  reverse_string = reverse(string)
! string <-- "Reverse This String"
! reverse_string <-- "gnirtS sihT esreveR"
end program example_reverse

module test_savetxt
    use stdlib_kinds, only: int32, sp, dp
    use stdlib_io, only: loadtxt, savetxt
    use testdrive, only: new_unittest, unittest_type, error_type, check
    implicit none

    private
    public :: collect_savetxt
contains

    !> Collect all exported unit tests
    subroutine collect_savetxt(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("iint32", test_iint32), &
            new_unittest("rsp", test_rsp), &
            new_unittest("rdp", test_rdp), &
            new_unittest("csp", test_csp), &
            new_unittest("cdp", test_cdp) &
        ]

    end subroutine collect_savetxt


    function get_outpath() result(outpath)
        integer :: ierr
        character(256) :: argv
        character(:), allocatable :: outpath

        call get_command_argument(1, argv, status=ierr)
        if (ierr == 0) then
            outpath = trim(argv)
        else
            outpath = '.'
        end if
    end function get_outpath


    subroutine test_iint32(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer(int32) :: d(3, 2), e(2, 3)
        integer(int32), allocatable :: d2(:, :)
        character(:), allocatable :: outpath

        outpath = get_outpath() // "/tmp_test_iint32.dat"

        d = reshape([1, 2, 3, 4, 5, 6], [3, 2])
        call savetxt(outpath, d)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [3, 2]))
        if (allocated(error)) return
        call check(error, all(d == d2))
        if (allocated(error)) return

        e = reshape([1, 2, 3, 4, 5, 6], [2, 3])
        call savetxt(outpath, e)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [2, 3]))
        if (allocated(error)) return
        call check(error, all(e == d2))
        if (allocated(error)) return
    end subroutine


    subroutine test_rsp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(sp) :: d(3, 2), e(2, 3)
        real(sp), allocatable :: d2(:, :)
        character(:), allocatable :: outpath

        outpath = get_outpath() // "/tmp_test_rsp.dat"

        d = reshape([1, 2, 3, 4, 5, 6], [3, 2])
        call savetxt(outpath, d)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [3, 2]))
        if (allocated(error)) return
        call check(error, all(d == d2))
        if (allocated(error)) return

        e = reshape([1, 2, 3, 4, 5, 6], [2, 3])
        call savetxt(outpath, e)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [2, 3]))
        if (allocated(error)) return
        call check(error, all(e == d2))
        if (allocated(error)) return
    end subroutine test_rsp


    subroutine test_rdp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(dp) :: d(3, 2), e(2, 3)
        real(dp), allocatable :: d2(:, :)
        character(:), allocatable :: outpath

        outpath = get_outpath() // "/tmp_test_rdp.dat"

        d = reshape([1, 2, 3, 4, 5, 6], [3, 2])
        call savetxt(outpath, d)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [3, 2]))
        if (allocated(error)) return
        call check(error, all(d == d2))
        if (allocated(error)) return

        e = reshape([1, 2, 3, 4, 5, 6], [2, 3])
        call savetxt(outpath, e)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [2, 3]))
        if (allocated(error)) return
        call check(error, all(e == d2))
        if (allocated(error)) return
    end subroutine test_rdp


    subroutine test_csp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        complex(sp) :: d(3, 2), e(2, 3)
        complex(sp), allocatable :: d2(:, :)
        character(:), allocatable :: outpath

        outpath = get_outpath() // "/tmp_test_csp.dat"

        d = cmplx(1, 1,kind=sp)* reshape([1, 2, 3, 4, 5, 6], [3, 2])
        call savetxt(outpath, d)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [3, 2]))
        if (allocated(error)) return
        call check(error, all(d == d2))
        if (allocated(error)) return

        e = cmplx(1, 1,kind=sp)* reshape([1, 2, 3, 4, 5, 6], [2, 3])
        call savetxt(outpath, e)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [2, 3]))
        if (allocated(error)) return
        call check(error, all(e == d2))
        if (allocated(error)) return
    end subroutine test_csp


    subroutine test_cdp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        complex(dp) :: d(3, 2), e(2, 3)
        complex(dp), allocatable :: d2(:, :)
        character(:), allocatable :: outpath

        outpath = get_outpath() // "/tmp_test_cdp.dat"

        d = cmplx(1._dp, 1._dp,kind=dp)* reshape([1, 2, 3, 4, 5, 6], [3, 2])
        call savetxt(outpath, d)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [3, 2]))
        if (allocated(error)) return
        call check(error, all(d == d2))
        if (allocated(error)) return

        e = cmplx(1, 1,kind=dp)* reshape([1, 2, 3, 4, 5, 6], [2, 3])
        call savetxt(outpath, e)
        call loadtxt(outpath, d2)
        call check(error, all(shape(d2) == [2, 3]))
        if (allocated(error)) return
        call check(error, all(e == d2))
        if (allocated(error)) return
    end subroutine test_cdp

end module test_savetxt


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_savetxt, only : collect_savetxt
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("savetxt", collect_savetxt) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program tester

program example_cov
  use stdlib_stats, only: cov
  implicit none
  real :: x(1:6) = [1., 2., 3., 4., 5., 6.]
  real :: y(1:2, 1:3) = reshape([1., 2., 3., 4., 5., 6.], [2, 3])
  print *, cov(x, 1)                          !returns 3.5
  print *, cov(x, 1, corrected=.false.)     !returns 2.9167
  print *, cov(y, 1)                          !returns a square matrix of size 3 with all elements equal to 0.5
end program example_cov

program example_verify
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: pos

  string = "fortran"
  pos = verify(string, "ao")
! pos == 1

  pos = verify(string, "fo")
! pos == 3

  pos = verify(string, "c++")
! pos == 1

  pos = verify(string, "c++", back=.true.)
! pos == 7

  pos = verify(string, string)
! pos == 0
end program example_verify

! Usage of `sleep`
program example_sleep
    use stdlib_system, only: sleep
    implicit none

    print *, "Starting sleep..."

    ! Sleep for 500 milliseconds
    call sleep(500)

    print *, "Finished sleeping!"
    
end program example_sleep    

module stdlib_system
use, intrinsic :: iso_c_binding, only : c_int, c_long, c_ptr, c_null_ptr, c_int64_t, c_size_t, &
    c_f_pointer
use stdlib_kinds, only: int64, dp, c_bool, c_char
use stdlib_strings, only: to_c_char, find, to_string
use stdlib_string_type, only: string_type
use stdlib_optval, only: optval
use stdlib_error, only: state_type, STDLIB_SUCCESS, STDLIB_FS_ERROR
implicit none
private
public :: sleep

!! version: experimental
!!
!! Cached OS type retrieval with negligible runtime overhead.
!! ([Specification](../page/specs/stdlib_system.html#os_type-cached-os-type-retrieval))
!!
!! ### Summary
!! Provides a cached value for the runtime OS type. 
!!
!! ### Description
!! 
!! This function caches the result of `get_runtime_os` after the first invocation. 
!! Subsequent calls return the cached value, ensuring minimal overhead.
!!
public :: OS_TYPE

!! version: experimental
!!
!! Determine the current operating system (OS) type at runtime.
!! ([Specification](../page/specs/stdlib_system.html#get_runtime_os-determine-the-os-type-at-runtime))
!!
!! ### Summary
!! This function inspects the runtime environment to identify the OS type. 
!!
!! ### Description
!! 
!! The function evaluates environment variables (`OSTYPE` or `OS`) and filesystem attributes
!! to identify the OS. It distinguishes between several common operating systems:
!! - Linux
!! - macOS
!! - Windows
!! - Cygwin
!! - Solaris
!! - FreeBSD
!! - OpenBSD
!!
!! Returns a constant representing the OS type or `OS_UNKNOWN` if the OS cannot be determined.
!!                    
public :: get_runtime_os

!> Version: experimental
!>
!> Integer constants representing known operating system (OS) types
!> ([Specification](../page/specs/stdlib_system.html))
integer, parameter, public :: &
    !> Represents an unknown operating system
    OS_UNKNOWN = 0, &
    !> Represents a Linux operating system
    OS_LINUX = 1, &
    !> Represents a macOS operating system
    OS_MACOS = 2, &
    !> Represents a Windows operating system
    OS_WINDOWS = 3, &
    !> Represents a Cygwin environment
    OS_CYGWIN = 4, &
    !> Represents a Solaris operating system
    OS_SOLARIS = 5, &
    !> Represents a FreeBSD operating system
    OS_FREEBSD = 6, &
    !> Represents an OpenBSD operating system
    OS_OPENBSD = 7

!! Helper function returning the name of an OS parameter
public :: OS_NAME 

!> Public sub-processing interface
public :: run
public :: runasync
public :: process_type
public :: is_completed
public :: is_running
public :: update
public :: wait
public :: kill
public :: elapsed
public :: is_windows

!! Public path related functions and interfaces
public :: path_sep
public :: join_path
public :: operator(/)
public :: split_path
public :: base_name
public :: dir_name

!! version: experimental
!!
!! Tests if a given path matches an existing directory.
!! ([Specification](../page/specs/stdlib_system.html#is_directory-test-if-a-path-is-a-directory))
!!
!!### Summary
!! Function to evaluate whether a specified path corresponds to an existing directory.
!!
!!### Description
!! 
!! This function checks if a given file system path is a directory. 
!! It follows symbolic links to return the status of the `target`.
!!
!! It is cross-platform and utilizes native system calls. 
!! It supports common operating systems such as Linux, macOS, Windows, and various UNIX-like environments. 
!! On unsupported operating systems, the function will return `.false.`.
!!
public :: is_directory

!! version: experimental
!!
!! Makes an empty directory.
!! ([Specification](../page/specs/stdlib_system.html#make_directory))
!!
!! ### Summary
!! Creates an empty directory with default permissions.
!!
!! ### Description
!! This function makes an empty directory according to the path provided.
!! Relative paths are supported. On Windows, paths involving either `/` or `\` are accepted.
!! An appropriate error message is returned whenever any error occurs.
!!
public :: make_directory

!! version: experimental
!!
!! Makes an empty directory, also creating all the parent directories required.
!! ([Specification](../page/specs/stdlib_system.html#make_directory))
!!
!! ### Summary
!! Creates an empty directory with all the parent directories required to do so.
!!
!! ### Description
!! This function makes an empty directory according to the path provided.
!! It also creates all the necessary parent directories in the path if they do not exist already.
!! Relative paths are supported.
!! An appropriate error message is returned whenever any error occurs.
!!
public :: make_directory_all

!! version: experimental
!!
!! Removes an empty directory.
!! ([Specification](../page/specs/stdlib_system.html#remove_directory))
!!
!! ### Summary
!! Removes an empty directory.
!!
!! ### Description
!! This function Removes an empty directory according to the path provided.
!! Relative paths are supported. On Windows paths involving either `/` or `\` are accepted.
!! An appropriate error message is returned whenever any error occurs.
!!
public :: remove_directory

!! version: experimental
!!
!! Gets the current working directory of the process
!! ([Specification](../page/specs/stdlib_system.html#get_cwd))
!!
!! ### Summary
!! Gets the current working directory.
!!
!! ### Description
!! This subroutine gets the current working directory the process is executing from.
!!
public :: get_cwd

!! version: experimental
!!
!! Sets the current working directory of the process
!! ([Specification](../page/specs/stdlib_system.html#set_cwd))
!!
!! ### Summary
!! Changes the current working directory to the one specified.
!!
!! ### Description
!! This subroutine sets the current working directory the process is executing from.
!!
public :: set_cwd

!! version: experimental
!!
!! Deletes a specified file from the filesystem.
!! ([Specification](../page/specs/stdlib_system.html#delete_file-delete-a-file))
!!
!!### Summary
!! Subroutine to safely delete a file from the filesystem. It handles errors gracefully using the library's `state_type`.
!!
!!### Description
!! 
!! This subroutine deletes a specified file. If the file is a directory or inaccessible, an error is raised.
!! If the file does not exist, a warning is returned, but no error state. Errors are handled using the 
!! library's `state_type` mechanism. If the optional `err` argument is not provided, exceptions trigger 
!! an `error stop`.
!!
public :: delete_file

!! version: experimental
!!
!! Returns the file path of the null device, which discards all data written to it.
!! ([Specification](../page/specs/stdlib_system.html#null_device-return-the-null-device-file-path))
!!
!! ### Summary
!! Function that provides the file path of the null device appropriate for the current operating system.
!!
!! ### Description
!!
!! The null device is a special file that discards all data written to it and always reads as 
!! an empty file. This function returns the null device path, adapted for the operating system in use.
!! 
!! On Windows, this is `NUL`. On UNIX-like systems, this is `/dev/null`.
!!
public :: null_device

!! version: experimental
!!
!! A helper function for returning the `type(state_type)` with the flag `STDLIB_FS_ERROR` set.
!! ([Specification](../page/specs/stdlib_system.html#FS_ERROR))
!!
public :: FS_ERROR

!! version: experimental
!!
!! A helper function for returning the `type(state_type)` with the flag `STDLIB_FS_ERROR` set.
!! It also formats and prefixes the `code` passed to it as the first argument
!! ([Specification](../page/specs/stdlib_system.html#FS_ERROR_CODE))
!!
public :: FS_ERROR_CODE

!> Version: experimental
!>
!> Integer constants representing the most common path types.
!> ([Specification](../page/specs/stdlib_system.html))
integer, parameter, public :: &
    !> Represents an unknown path type
    fs_type_unknown      = 0, &
    !> Represents a regular file
    fs_type_regular_file = 1, &
    !> Represents a directory
    fs_type_directory    = 2, &
    !> Represents a symbolic link
    fs_type_symlink      = 3

!! version: experimental
!!
!! Checks if a path exists in the filesystem.
!! ([Specification](../page/specs/stdlib_system.html#exists))
!!
!!### Summary
!! Function to check whether the path exists in the fileystem at all.
!! If the path does exist, returns the type of the path.
!!
!!### Description
!!
!! This function makes a system call (syscall) to retrieve metadata for the specified path and determines its type.
!! It can distinguish between the following path types:
!!
!! - Regular File
!! - Directory
!! - Symbolic Link
!!
!! It does not follow symbolic links.
!!
!! It returns a constant representing the detected path type, or `type_unknown` if the type cannot be determined. 
!! Any encountered errors are handled using `state_type`.
!!
public :: exists

!! version: experimental
!!
!! Tests if a given path is a symbolic link.
!! ([Specification](../page/specs/stdlib_system.html#is_symlink))
!!
!!### Summary
!! Function to evaluate whether a specified path corresponds to a symbolic link.
!!
!!### Description
!! 
!! This function checks if a given file system path is a symbolic link either to a 
!! file or a directory. It is cross-platform and utilizes native system calls. 
!! It supports common operating systems such as Linux, macOS, Windows, and various UNIX-like environments.
!!
public :: is_symlink

!! version: experimental
!!
!! Tests if a given path is a regular file.
!! ([Specification](../page/specs/stdlib_system.html#is_file))
!!
!!### Summary
!! Function to evaluate whether a specified path corresponds to a regular file.
!!
!!### Description
!! 
!! This function checks if a given file system path is a regular file. 
!! It follows symbolic links to return the status of the `target`.
!! It is cross-platform and utilizes native system calls. 
!! It supports common operating systems such as Linux, macOS, Windows, and various UNIX-like environments.
!!
public :: is_file
     
! CPU clock ticks storage
integer, parameter, private :: TICKS = int64
integer, parameter, private :: RTICKS = dp

! Interoperable types to the C backend
integer, parameter, public :: process_ID = c_int64_t

! Default flag for the runner process
integer(process_ID), parameter, private :: FORKED_PROCESS = 0_process_ID

!> Process type holding process information and the connected stdout, stderr, stdin units 
type :: process_type
    
    !> Process ID (if external); 0 if run by the program process
    integer(process_ID)  :: id = FORKED_PROCESS
    
    !> Process is completed
    logical :: completed = .false.        
    integer(TICKS) :: start_time = 0
    
    !> Standard input
    character(:), allocatable :: stdin_file
    character(:), allocatable :: stdin
    
    !> Standard output
    character(:), allocatable :: stdout_file
    character(:), allocatable :: stdout
    
    !> Error output
    integer :: exit_code = 0    
    character(:), allocatable :: stderr_file
    character(:), allocatable :: stderr
    
    !> Callback function 
    procedure(process_callback), nopass, pointer :: oncomplete => null()
    
    !> Optional payload for the callback function
    class(*), pointer :: payload => null()
    
    !> Store time at the last update
    integer(TICKS) :: last_update = 0
    
contains

    !! Check if process is still running
    procedure :: is_running   => process_is_running
    
    !! Check if process is completed
    procedure :: is_completed => process_is_completed
    
    !! Return elapsed time since inception
    procedure :: elapsed      => process_lifetime
    
    !! Update process state internals
    procedure :: update       => update_process_state
    
    !! Kill a process
    procedure :: kill         => process_kill
    
    !! Get process ID
    procedure :: pid          => process_get_ID
    
end type process_type

interface runasync
    !! version: experimental
    !!
    !! Executes an external process asynchronously.
    !! ([Specification](../page/specs/stdlib_system.html#runasync-execute-an-external-process-asynchronously))
    !!
    !! ### Summary
    !! Provides methods for executing external processes asynchronously, using either a single command string 
    !! or an argument list, with options for output collection and standard input.
    !!
    !! ### Description
    !! 
    !! This interface allows the user to spawn external processes asynchronously (non-blocking). 
    !! Processes can be executed via a single command string or a list of arguments, with options to collect 
    !! standard output and error streams, or to provide a standard input stream via a `character` string.
    !! Additionally, a callback function can be provided, which will be called upon process completion.
    !! A user-defined payload can be attached and passed to the callback for handling process-specific data.
    !!
    !! @note The implementation depends on system-level process management capabilities.
    !!
    module function run_async_cmd(cmd, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> The command line string to execute.
        character(*), intent(in) :: cmd
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload
        !> The output process handler.
        type(process_type) :: process
        
    end function run_async_cmd

    module function run_async_args(args, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> List of arguments for the process to execute.
        character(*), intent(in) :: args(:)
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload        
        !> The output process handler.
        type(process_type) :: process        
    end function run_async_args
end interface runasync

interface run
    !! version: experimental
    !!
    !! Executes an external process synchronously.
    !! ([Specification](../page/specs/stdlib_system.html#run-execute-an-external-process-synchronously))
    !!
    !! ### Summary
    !! Provides methods for executing external processes synchronously, using either a single command string 
    !! or an argument list, with options for output collection and standard input.
    !!
    !! ### Description
    !! 
    !! This interface allows the user to spawn external processes synchronously (blocking), 
    !! via either a single command string or a list of arguments. It also includes options to collect 
    !! standard output and error streams, or to provide a standard input stream via a `character` string.
    !! Additionally, it supports an optional callback function that is invoked upon process completion, 
    !! allowing users to process results dynamically. A user-defined payload can also be provided, 
    !! which is passed to the callback function to facilitate contextual processing.
    !!
    !! @note The implementation depends on system-level process management capabilities.
    !!
    module function run_sync_cmd(cmd, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> The command line string to execute.
        character(*), intent(in) :: cmd
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload            
        !> The output process handler.
        type(process_type) :: process
    end function run_sync_cmd

    module function run_sync_args(args, stdin, want_stdout, want_stderr, callback, payload) result(process)
        !> List of arguments for the process to execute.
        character(*), intent(in) :: args(:)
        !> Optional input sent to the process via standard input (stdin).
        character(*), optional, intent(in) :: stdin
        !> Whether to collect standard output.
        logical, optional, intent(in) :: want_stdout
        !> Whether to collect standard error output.
        logical, optional, intent(in) :: want_stderr
        !> Optional callback function to be called on process completion
        procedure(process_callback), optional :: callback
        !> Optional payload to pass to the callback on completion
        class(*), optional, intent(inout), target :: payload            
        !> The output process handler.
        type(process_type) :: process        
    end function run_sync_args
    
end interface run

interface is_running
    !! version: experimental
    !!
    !! Checks if an external process is still running.
    !! ([Specification](../page/specs/stdlib_system.html#is_running-check-if-a-process-is-still-running))
    !!
    !! ### Summary
    !! Provides a method to determine if an external process is still actively running.
    !!
    !! ### Description
    !! 
    !! This interface checks the status of an external process to determine whether it is still actively running. 
    !! It is particularly useful for monitoring asynchronous processes created using the `run` interface. 
    !! The internal state of the `process_type` object is updated after the call to reflect the current process status.
    !!
    !! @note The implementation relies on system-level process management capabilities.
    !!
    logical module function process_is_running(process) result(is_running)
        !> The process object to check.
        class(process_type), intent(inout) :: process
        !> Logical result: `.true.` if the process is still running, `.false.` otherwise.
    end function process_is_running
end interface is_running

interface is_completed
    !! version: experimental
    !!
    !! Checks if an external process has completed execution.
    !! ([Specification](../page/specs/stdlib_system.html#is_completed-check-if-a-process-has-completed-execution))
    !!
    !! ### Summary
    !! Provides a method to determine if an external process has finished execution.
    !!
    !! ### Description
    !! 
    !! This interface checks the status of an external process to determine whether it has finished execution. 
    !! It is particularly useful for monitoring asynchronous processes created using the `run` interface. 
    !! The internal state of the `process_type` object is updated after the call to reflect the current process status.
    !!
    !! @note The implementation relies on system-level process management capabilities.
    !!
    logical module function process_is_completed(process) result(is_completed)
        !> The process object to check.
        class(process_type), intent(inout) :: process
        !> Logical result: `.true.` if the process has completed, `.false.` otherwise.
    end function process_is_completed
end interface is_completed

interface elapsed
    !! version: experimental
    !!
    !! Returns the lifetime of a process, in seconds.
    !! ([Specification](../page/specs/stdlib_system.html#elapsed-return-process-lifetime-in-seconds))
    !!
    !! ### Summary
    !! Provides the total elapsed time (in seconds) since the creation of the specified process.
    !!
    !! ### Description
    !! 
    !! This interface returns the total elapsed time (in seconds) for a given process since it was started. 
    !! If the process is still running, the value returned reflects the time from the creation of the process 
    !! until the call to this function. Otherwise, the total process duration until completion is returned.
    !!
    module function process_lifetime(process) result(delta_t)
        !> The process object for which to calculate elapsed time.
        class(process_type), intent(in) :: process
        !> The elapsed time in seconds since the process started.
        real(RTICKS) :: delta_t
    end function process_lifetime
end interface elapsed


interface wait
    !! version: experimental
    !!
    !! Waits for a running process to complete.
    !! ([Specification](../page/specs/stdlib_system.html#wait-wait-until-a-running-process-is-completed))
    !!
    !! ### Summary
    !! Provides a method to block the execution and wait until the specified process finishes.
    !! Supports an optional maximum wait time, after which the function returns regardless of process completion.
    !!
    !! ### Description
    !! 
    !! This interface allows waiting for a process to complete. If the process is running asynchronously, this subroutine
    !! will block further execution until the process finishes. Optionally, a maximum wait time can be specified; if 
    !! the process doesn't complete within this time, the subroutine returns without further waiting.
    !!
    !! @note The process state is accordingly updated on return from this call.
    !!
    module subroutine wait_for_completion(process, max_wait_time)
        !> The process object to monitor.
        class(process_type), intent(inout) :: process
        !> Optional maximum wait time in seconds. If not provided, waits indefinitely.
        real, optional, intent(in) :: max_wait_time
    end subroutine wait_for_completion
end interface wait

interface update
    !! version: experimental
    !!
    !! Updates the internal state of a process variable.
    !! ([Specification](../page/specs/stdlib_system.html#update-update-the-internal-state-of-a-process))
    !!
    !! ### Summary
    !! Provides a method to query the system and update the internal state of the specified process variable.
    !!
    !! ### Description
    !! 
    !! This subroutine queries the system to retrieve and update information about the state of the process.
    !! Once the process is completed, and if standard output or standard error were requested, their respective
    !! data is loaded into the `process%stdout` and `process%stderr` variables. This routine is useful for keeping
    !! track of the latest state and output of a process, particularly for asynchronous processes.
    !!
    !! @note This subroutine should be called periodically for asynchronous processes to check their completion
    !! and retrieve the output.
    !!
    module subroutine update_process_state(process)
        !> The process object whose state needs to be updated.
        class(process_type), intent(inout) :: process
    end subroutine update_process_state
end interface update

interface kill
    !! version: experimental
    !!
    !! Terminates a running process.
    !! ([Specification](../page/specs/stdlib_system.html#kill-terminate-a-running-process))
    !!
    !! ### Summary
    !! Provides a method to kill or terminate a running process.
    !! Returns a boolean flag indicating whether the termination was successful.
    !!
    !! ### Description
    !! 
    !! This interface allows for the termination of an external process that is still running.  
    !! If the process is successfully killed, the `success` output flag is set to `.true.`, otherwise `.false.`.
    !! This function is useful for controlling and managing processes that are no longer needed or for forcefully
    !! stopping an unresponsive process.
    !!
    !! @note This operation may be system-dependent and could fail if the underlying user does not have 
    !! the necessary rights to kill a process.
    !!
    module subroutine process_kill(process, success)
        !> The process object to be terminated.
        class(process_type), intent(inout) :: process
        !> Boolean flag indicating whether the termination was successful.
        logical, intent(out) :: success
    end subroutine process_kill
end interface kill
 
interface sleep
    !! version: experimental
    !!
    !! Pauses execution for a specified time in milliseconds.
    !! ([Specification](../page/specs/stdlib_system.html#sleep-pause-execution-for-a-specified-time=in-milliseconds))
    !!
    !! ### Summary
    !! Pauses code execution for a specified number of milliseconds. This routine is a cross-platform
    !! wrapper around platform-specific sleep functions, providing consistent behavior on different operating systems.
    !!
    !! ### Description
    !! 
    !! This interface allows the user to pause the execution of a program for a specified duration, expressed in
    !! milliseconds. It provides a cross-platform wrapper around native sleep functions, ensuring that the program 
    !! will sleep for the requested amount of time on different systems (e.g., using `Sleep` on Windows or `nanosleep`
    !! on Unix-like systems).
    !!
    !! @note The precision of the sleep may vary depending on the system and platform.
    !!
    module subroutine sleep(millisec)
        !> The number of milliseconds to pause execution for.
        integer, intent(in) :: millisec
    end subroutine sleep
end interface sleep
      
abstract interface

    !! version: experimental
    !!
    !! Process callback interface
    !! 
    !! ### Summary 
    !!
    !! The `process_callback` interface defines a user-provided subroutine that will be called 
    !! upon process completion. It provides access to process metadata, including the process ID, 
    !! exit state, and optional input/output streams. If passed on creation, a generic payload can be 
    !! accessed by the callback function. This variable must be a valid `target` in the calling scope.
    !!  
    subroutine process_callback(pid,exit_state,stdin,stdout,stderr,payload)
        import process_ID
        implicit none
        !> Process ID
        integer(process_ID), intent(in) :: pid
        !> Process return state
        integer, intent(in) :: exit_state
        !> Process input/output: presence of these arguments depends on how process was created
        character(len=*), optional, intent(in) :: stdin,stdout,stderr
        !> Optional payload passed by the user on process creation
        class(*), optional, intent(inout) :: payload        
    end subroutine process_callback
end interface          
    
!! Static storage for the current OS
logical :: have_os    = .false.
integer :: OS_CURRENT = OS_UNKNOWN

interface 
    
    !! version: experimental
    !!
    !! Returns a `logical` flag indicating if the system is Windows.
    !! ([Specification](../page/specs/stdlib_system.html#is_windows-check-if-the-system-is-running-on-windows))
    !!
    !! ### Summary
    !! A fast, compile-time check to determine if the system is running Windows, based on the `_WIN32` macro.
    !!
    !! ### Description
    !! 
    !! This interface provides a function to check if the current system is Windows. The check is performed by
    !! wrapping a C function that tests if the `_WIN32` macro is defined. This check is fast and occurs at
    !! compile-time, making it a more efficient alternative to platform-specific runtime checks.
    !!
    !! The `is_windows` function is particularly useful for conditional compilation or system-specific code paths
    !! that are dependent on whether the code is running on Windows.
    !!
    !! @note This function relies on the `_WIN32` macro, which is defined in C compilers when targeting Windows.
    !!
    logical module function is_windows()
    end function is_windows
    
    module function process_get_ID(process) result(ID)
        class(process_type), intent(in) :: process
        !> Return a process ID
        integer(process_ID) :: ID
    end function process_get_ID
    
end interface 

interface join_path
    !! version: experimental
    !!
    !!### Summary
    !! join the paths provided according to the OS-specific path-separator
    !! ([Specification](../page/specs/stdlib_system.html#join_path))
    !!
    module function join2_char_char(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1, p2
    end function join2_char_char

    module function join2_char_string(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1
        type(string_type), intent(in) :: p2
    end function join2_char_string

    module function join2_string_char(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1
        character(*), intent(in) :: p2
    end function join2_string_char

    module function join2_string_string(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1, p2
    end function join2_string_string

    module function joinarr_char(p) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p(:)
    end function joinarr_char

    module function joinarr_string(p) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p(:)
    end function joinarr_string
end interface join_path

interface operator(/)
    !! version: experimental
    !!
    !!### Summary
    !! A binary operator to join the paths provided according to the OS-specific path-separator
    !! ([Specification](../page/specs/stdlib_system.html#operator(/)))
    !!
    module function join_op_char_char(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1, p2
    end function join_op_char_char

    module function join_op_char_string(p1, p2) result(path)
        character(:), allocatable :: path
        character(*), intent(in) :: p1
        type(string_type), intent(in) :: p2
    end function join_op_char_string

    module function join_op_string_char(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1
        character(*), intent(in) :: p2
    end function join_op_string_char

    module function join_op_string_string(p1, p2) result(path)
        type(string_type) :: path
        type(string_type), intent(in) :: p1, p2
    end function join_op_string_string
end interface operator(/)

interface split_path
    !! version: experimental
    !!
    !!### Summary
    !! splits the path immediately following the final path-separator
    !! separating into typically a directory and a file name.
    !! ([Specification](../page/specs/stdlib_system.html#split_path))
    !!
    !!### Description
    !! If the path is empty `head`='.' and tail=''
    !! If the path only consists of separators, `head` is set to the separator and tail is empty
    !! If the path is a root directory, `head` is set to that directory and tail is empty
    !! `head` ends with a path-separator iff the path appears to be a root directory or a child of the root directory
    module subroutine split_path_char(p, head, tail)
        character(*), intent(in) :: p
        character(:), allocatable, intent(out) :: head, tail
    end subroutine split_path_char

    module subroutine split_path_string(p, head, tail)
        type(string_type), intent(in) :: p
        type(string_type), intent(out) :: head, tail
    end subroutine split_path_string
end interface split_path

interface base_name
    !! version: experimental
    !!
    !!### Summary
    !! returns the base name (last component) of the provided path
    !! ([Specification](../page/specs/stdlib_system.html#base_name))
    !!
    !!### Description
    !! The value returned is the `tail` of the interface `split_path`
    module function base_name_char(p) result(base)
        character(:), allocatable :: base
        character(*), intent(in) :: p
    end function base_name_char

    module function base_name_string(p) result(base)
        type(string_type) :: base
        type(string_type), intent(in) :: p
    end function base_name_string
end interface base_name

interface dir_name
    !! version: experimental
    !!
    !!### Summary
    !! returns everything but the last component of the provided path
    !! ([Specification](../page/specs/stdlib_system.html#dir_name))
    !!
    !!### Description
    !! The value returned is the `head` of the interface `split_path`
    module function dir_name_char(p) result(dir)
        character(:), allocatable :: dir
        character(*), intent(in) :: p
    end function dir_name_char

    module function dir_name_string(p) result(dir)
        type(string_type) :: dir
        type(string_type), intent(in) :: p
    end function dir_name_string
end interface dir_name


contains

integer function get_runtime_os() result(os)
    !! The function identifies the OS by inspecting environment variables and filesystem attributes.
    !!
    !! ### Returns:
    !! - **OS_UNKNOWN**: If the OS cannot be determined.
    !! - **OS_LINUX**, **OS_MACOS**, **OS_WINDOWS**, **OS_CYGWIN**, **OS_SOLARIS**, **OS_FREEBSD**, or **OS_OPENBSD**.
    !!
    !! Note: This function performs a detailed runtime inspection, so it has non-negligible overhead.
    
    ! Local variables
    character(len=255) :: val
    integer            :: length, rc
    logical            :: file_exists

    os = OS_UNKNOWN

    ! Check environment variable `OSTYPE`.
    call get_environment_variable('OSTYPE', val, length, rc)

    if (rc == 0 .and. length > 0) then
        ! Linux
        if (index(val, 'linux') > 0) then
            os = OS_LINUX
            return

        ! macOS
        elseif (index(val, 'darwin') > 0) then
            os = OS_MACOS
            return

        ! Windows, MSYS, MinGW, Git Bash
        elseif (index(val, 'win') > 0 .or. index(val, 'msys') > 0) then
            os = OS_WINDOWS
            return

        ! Cygwin
        elseif (index(val, 'cygwin') > 0) then
            os = OS_CYGWIN
            return

        ! Solaris, OpenIndiana, ...
        elseif (index(val, 'SunOS') > 0 .or. index(val, 'solaris') > 0) then
            os = OS_SOLARIS
            return

        ! FreeBSD
        elseif (index(val, 'FreeBSD') > 0 .or. index(val, 'freebsd') > 0) then
            os = OS_FREEBSD
            return

        ! OpenBSD
        elseif (index(val, 'OpenBSD') > 0 .or. index(val, 'openbsd') > 0) then
            os = OS_OPENBSD
            return
        end if
    end if

    ! Check environment variable `OS`.
    call get_environment_variable('OS', val, length, rc)

    if (rc == 0 .and. length > 0 .and. index(val, 'Windows_NT') > 0) then
        os = OS_WINDOWS
        return
    end if

    ! Linux
    inquire (file='/etc/os-release', exist=file_exists)

    if (file_exists) then
        os = OS_LINUX
        return
    end if

    ! macOS
    inquire (file='/usr/bin/sw_vers', exist=file_exists)

    if (file_exists) then
        os = OS_MACOS
        return
    end if

    ! FreeBSD
    inquire (file='/bin/freebsd-version', exist=file_exists)

    if (file_exists) then
        os = OS_FREEBSD
        return
    end if
    
end function get_runtime_os

!> Retrieves the cached OS type for minimal runtime overhead.
integer function OS_TYPE() result(os)
    !! This function uses a static cache to avoid recalculating the OS type after the first call.
    !! It is recommended for performance-sensitive use cases where the OS type is checked multiple times.
    if (.not.have_os) then 
        OS_CURRENT = get_runtime_os()
        have_os = .true.        
    end if
    os = OS_CURRENT
end function OS_TYPE

!> Return string describing the OS type flag
pure function OS_NAME(os)
    integer, intent(in) :: os
    character(len=:), allocatable :: OS_NAME

    select case (os)
        case (OS_LINUX);   OS_NAME =  "Linux"
        case (OS_MACOS);   OS_NAME =  "macOS"
        case (OS_WINDOWS); OS_NAME =  "Windows"
        case (OS_CYGWIN);  OS_NAME =  "Cygwin"
        case (OS_SOLARIS); OS_NAME =  "Solaris"
        case (OS_FREEBSD); OS_NAME =  "FreeBSD"
        case (OS_OPENBSD); OS_NAME =  "OpenBSD"
        case default     ; OS_NAME =  "Unknown"
    end select
end function OS_NAME

!! Tests if a given path matches an existing directory.
!! Cross-platform implementation without using external C libraries.
logical function is_directory(path)
    !> Input path to evaluate
    character(*), intent(in) :: path

    interface
        
        logical(c_bool) function stdlib_is_directory(path) bind(c, name="stdlib_is_directory")
            import c_bool, c_char
            character(kind=c_char), intent(in) :: path(*)
        end function stdlib_is_directory

    end interface        
    
    is_directory = logical(stdlib_is_directory(to_c_char(trim(path))))
    
end function is_directory

! A Helper function to convert C character arrays to Fortran character strings
function to_f_char(c_str_ptr, len) result(f_str)
    type(c_ptr), intent(in) :: c_str_ptr
    ! length of the string excluding the null character
    integer(kind=c_size_t), intent(in) :: len
    character(:), allocatable :: f_str

    integer :: i
    character(kind=c_char), pointer :: c_str(:)

    call c_f_pointer(c_str_ptr, c_str, [len])

    allocate(character(len=len) :: f_str)

    do concurrent (i=1:len)
        f_str(i:i) = c_str(i)
    end do
end function to_f_char

! A helper function to get the string describing an error from C functions.
! If `winapi` is  false or not present, uses `strerror` provided by `<string.h>`
! Otherwise, uses `strerror` on unix and `FormatMessageA` on windows.
function c_get_strerror(winapi) result(str)
    character(len=:), allocatable :: str
    logical, optional, intent(in) :: winapi

    interface
        type(c_ptr) function strerror(len, winapi) bind(C, name='stdlib_strerror')
            import c_size_t, c_ptr, c_bool
            implicit none
            integer(c_size_t), intent(out) :: len
            logical, intent(in) :: winapi
        end function strerror
    end interface

    type(c_ptr) :: c_str_ptr
    integer(c_size_t) :: len, i
    character(kind=c_char), pointer :: c_str(:)
    logical :: winapi_

    winapi_ = optval(winapi, .false.)

    c_str_ptr = strerror(len, winapi_)

    str = to_f_char(c_str_ptr, len)
end function c_get_strerror

!! makes an empty directory
subroutine make_directory(path, err)
    character(len=*), intent(in) :: path
    type(state_type), optional, intent(out) :: err

    integer :: code
    type(state_type) :: err0

    interface
        integer function stdlib_make_directory(cpath) bind(C, name='stdlib_make_directory')
            import c_char
            character(kind=c_char), intent(in) :: cpath(*)
        end function stdlib_make_directory
    end interface

    code = stdlib_make_directory(to_c_char(trim(path)))

    if (code /= 0) then
        err0 = FS_ERROR_CODE(code, c_get_strerror())
        call err0%handle(err)
    end if

end subroutine make_directory

subroutine make_directory_all(path, err)
    character(len=*), intent(in) :: path
    type(state_type), optional, intent(out) :: err

    integer :: i, indx
    type(state_type) :: err0
    character(len=1) :: sep
    logical :: is_dir, check_is_dir

    sep = path_sep()
    i = 1
    indx = find(path, sep, i)
    check_is_dir = .true.

    do
        ! Base case to exit the loop
        if (indx == 0) then
            is_dir = is_directory(path)

            if (.not. is_dir) then
                call make_directory(path, err0)

                if (err0%error()) then
                    call err0%handle(err)
                end if
            end if

            return
        end if

        if (check_is_dir) then
            is_dir = is_directory(path(1:indx))
        end if

        if (.not. is_dir) then
            ! no need for further `is_dir` checks
            ! all paths going forward need to be created
            check_is_dir = .false.
            call make_directory(path(1:indx), err0)

            if (err0%error()) then
                call err0%handle(err)
                return
            end if
        end if

        i = i + 1 ! the next occurence of `sep`
        indx = find(path, sep, i)
    end do
end subroutine make_directory_all

!! removes an empty directory
subroutine remove_directory(path, err)
    character(len=*), intent(in) :: path
    type(state_type), optional, intent(out) :: err

    integer :: code
    type(state_type) :: err0

    interface
        integer function stdlib_remove_directory(cpath) bind(C, name='stdlib_remove_directory')
            import c_char
            character(kind=c_char), intent(in) :: cpath(*)
        end function stdlib_remove_directory
    end interface

    code = stdlib_remove_directory(to_c_char(trim(path)))

    if (code /= 0) then
        err0 = FS_ERROR_CODE(code, c_get_strerror())
        call err0%handle(err)
    end if

end subroutine remove_directory

subroutine get_cwd(cwd, err)
    character(:), allocatable, intent(out) :: cwd
    type(state_type), optional, intent(out) :: err
    type(state_type) :: err0

    interface
        type(c_ptr) function stdlib_get_cwd(len, stat) bind(C, name='stdlib_get_cwd')
            import c_ptr, c_size_t
            integer(c_size_t), intent(out) :: len
            integer :: stat
        end function stdlib_get_cwd
    end interface

    type(c_ptr) :: c_str_ptr
    integer(c_size_t) :: len
    integer :: stat

    c_str_ptr = stdlib_get_cwd(len, stat)

    if (stat /= 0) then
        err0 = FS_ERROR_CODE(stat, c_get_strerror())
        call err0%handle(err)
    end if

    cwd = to_f_char(c_str_ptr, len)

end subroutine get_cwd

subroutine set_cwd(path, err)
    character(len=*), intent(in) :: path
    type(state_type), optional, intent(out) :: err
    type(state_type) :: err0

    interface
        integer function stdlib_set_cwd(path) bind(C, name='stdlib_set_cwd')
            import c_char
            character(kind=c_char), intent(in) :: path(*)
        end function stdlib_set_cwd
    end interface

    integer :: code

    code = stdlib_set_cwd(to_c_char(trim(path)))

    if (code /= 0) then
        err0 = FS_ERROR_CODE(code, c_get_strerror())
        call err0%handle(err)
    end if
end subroutine set_cwd

!> Returns the file path of the null device for the current operating system.
!>
!> Version: Helper function.
function null_device() result(path)
    !> File path of the null device
    character(:), allocatable :: path
    
    interface
    
        ! No-overhead return path to the null device
        type(c_ptr) function process_null_device(len) bind(C,name='process_null_device')
            import c_ptr, c_size_t    
            implicit none
            integer(c_size_t), intent(out) :: len
        end function process_null_device    
        
    end interface
    
    integer(c_size_t) :: len
    type(c_ptr) :: c_path_ptr

    ! Call the C function to get the null device path and its length
    c_path_ptr = process_null_device(len)

    path = to_f_char(c_path_ptr, len)
end function null_device

!> Delete a file at the given path.
subroutine delete_file(path, err)
    character(*), intent(in) :: path
    type(state_type), optional, intent(out) :: err

    !> Local variables
    integer :: file_unit, ios        
    type(state_type) :: err0
    character(len=512) :: msg
    logical :: file_exists

    ! Verify the file is not a directory.     
    if (is_directory(path)) then 
        ! If unable to open, assume it's a directory or inaccessible
        err0 = state_type(STDLIB_FS_ERROR,'Cannot delete',path,'- is a directory')
        call err0%handle(err)
        return            
    end if

    ! Check if the path exists
    ! Because Intel compilers return .false. if path is a directory, this must be tested
    ! _after_ the directory test
    inquire(file=path, exist=file_exists)
    if (.not. file_exists) then
        ! File does not exist, return non-error status
        err0 = state_type(STDLIB_SUCCESS,path,' not deleted: file does not exist')
        call err0%handle(err)
        return
    endif

    ! Close and delete the file
    open(newunit=file_unit, file=path, status='old', iostat=ios, iomsg=msg)
    if (ios /= 0) then
        err0 = state_type(STDLIB_FS_ERROR,'Cannot delete',path,'-',msg)
        call err0%handle(err)
        return              
    end if        
    close(unit=file_unit, status='delete', iostat=ios, iomsg=msg)
    if (ios /= 0) then
        err0 = state_type(STDLIB_FS_ERROR,'Cannot delete',path,'-',msg)
        call err0%handle(err)
        return              
    end if
end subroutine delete_file

pure function FS_ERROR_CODE(code,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,& 
        a11,a12,a13,a14,a15,a16,a17,a18,a19) result(state)

    type(state_type) :: state
    !> Platform specific error code
    integer, intent(in) :: code
    !> Optional rank-agnostic arguments
    class(*), intent(in), optional, dimension(..) :: a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,&
        a11,a12,a13,a14,a15,a16,a17,a18,a19

    character(32) :: code_msg

    write(code_msg, "('code - ', i0, ',')") code

    state = state_type(STDLIB_FS_ERROR, code_msg,a1,a2,a3,a4,a5,a6,a7,a8,&
        a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19)
end function FS_ERROR_CODE

pure function FS_ERROR(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,&
        a12,a13,a14,a15,a16,a17,a18,a19,a20) result(state)

    type(state_type) :: state
    !> Optional rank-agnostic arguments
    class(*), intent(in), optional, dimension(..) :: a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,&
        a11,a12,a13,a14,a15,a16,a17,a18,a19,a20

    state = state_type(STDLIB_FS_ERROR, a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,&
        a13,a14,a15,a16,a17,a18,a19,a20)
end function FS_ERROR

! checks if a path exists and returns its type
function exists(path, err) result(fs_type)
    character(*), intent(in) :: path
    type(state_type), optional, intent(out) :: err
    integer :: fs_type

    type(state_type) :: err0

    interface
        integer function stdlib_exists(path, stat) bind(C, name='stdlib_exists')
            import c_char, c_int
            character(kind=c_char), intent(in) :: path(*)
            ! to return the error code if any
            integer(kind=c_int), intent(out) :: stat
        end function stdlib_exists
    end interface

    integer(kind=c_int) :: stat

    fs_type = stdlib_exists(to_c_char(trim(path)), stat)

    ! an error occurred
    if (stat /= 0) then
        err0 = FS_ERROR_CODE(stat, c_get_strerror())
        call err0%handle(err)
    end if
end function exists

! public convenience wrapper to check if path is a symbolic link
logical function is_symlink(path)
    character(len=*), intent(in) :: path
    type(state_type) :: err

    is_symlink = exists(path, err) == fs_type_symlink
end function is_symlink

! checks if path is a regular file.
! It follows symbolic links and returns the status of the `target`.
logical function is_file(path)
    character(len=*), intent(in) :: path

    interface
        logical(c_bool) function stdlib_is_file(path) bind(C, name='stdlib_is_file')
            import c_char, c_bool
            character(kind=c_char) :: path(*)
        end function stdlib_is_file
    end interface

    is_file = logical(stdlib_is_file(to_c_char(trim(path))))
end function is_file

character function path_sep()
    if (OS_TYPE() == OS_WINDOWS) then
        path_sep = '\'
    else
        path_sep = '/'
    end if
end function path_sep

end module stdlib_system

program example_len
  use stdlib_stringlist_type, only: stringlist_type, bidx
  implicit none

  type(stringlist_type) :: stringlist
  integer               :: output

  output = stringlist%len()
! output <-- 0

!> inserting 2 elements to the stringlist
  call stringlist%insert_at(bidx(1), "Element No. one")
  call stringlist%insert_at(bidx(1), "Element No. two")
! stringlist <-- {"Element No. one", "Element No. two"}

  print'(a)', stringlist%len()
! 2

end program example_len

program example_to_string
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_all = '111111111111111111111111111111111'
  type(bitset_64) :: set0
  character(:), allocatable :: new_string
  call set0%init(33)
  call set0%not()
  call set0%to_string(new_string)
  if (new_string == bits_all) then
    write (*, *) "TO_STRING transferred BITS0 properly"// &
      " into NEW_STRING."
  end if
end program example_to_string

program example_ansi_to_string
  use stdlib_ansi, only : fg_color_green, style_reset, to_string
  implicit none

  print '(a)', to_string(fg_color_green) // "Colorized text message" // to_string(style_reset)
end program example_ansi_to_string

program example_from_string
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_all = '111111111111111111111111111111111'
  type(bitset_64) :: set0
  call set0%from_string(bits_all)
  if (bits(set0) /= 33) then
    error stop "FROM_STRING failed to interpret "// &
      "BITS_ALL's size properly."
  else if (.not. set0%all()) then
    error stop "FROM_STRING failed to interpret"// &
      "BITS_ALL's value properly."
  else
    write (*, *) "FROM_STRING transferred BITS_ALL properly"// &
      " into set0."
  end if
end program example_from_string

program example_universal_mult_hash
  use stdlib_hash_32bit, only: odd_random_integer, &
                               universal_mult_hash
  use iso_fortran_env, only: int32
  implicit none
  integer, allocatable :: array1(:)
  integer(int32) :: hash, i, seed, source
  seed = 0
  allocate (array1(0:2**6 - 1))
  do i = 0, 2**6 - 1
    array1(i) = i
  end do
  call odd_random_integer(seed)
  source = 42_int32
  hash = universal_mult_hash(source, seed, 6)
  array1(hash) = source
  print *, seed, hash, array1
end program example_universal_mult_hash

! Demonstrate expert subroutine interface with pre-allocated arrays
program example_lstsq2
  use stdlib_linalg_constants, only: dp,ilp
  use stdlib_linalg, only: solve_lstsq, lstsq_space, linalg_state_type
  implicit none

  integer, allocatable :: x(:),y(:)
  real(dp), allocatable :: A(:,:),b(:),coef(:),real_space(:),singvals(:)
  integer(ilp), allocatable :: int_space(:)
  integer(ilp) :: lrwork,liwork,arank

  ! Data set
  x = [1, 2, 2]
  y = [5, 13, 25]

  ! Fit three points using a parabola, least squares method
  ! A = [1 x x**2]
  A = reshape([[1,1,1],x,x**2],[3,3])
  b = y
  
  ! Get storage sizes for the arrays and pre-allocate data
  call lstsq_space(A,b,lrwork,liwork)
  allocate(coef(size(x)),real_space(lrwork),int_space(liwork),singvals(minval(shape(A))))
  
  ! Solve coefficients of y = coef(1) + x*coef(2) + x^2*coef(3)
  ! with no internal allocations
  call solve_lstsq(A,b,x=coef,              &
                   real_storage=real_space, &
                   int_storage=int_space,   &
                   singvals=singvals,       &
                   overwrite_a=.true.,      &
                   rank=arank)
  
  print *, 'parabola: ',coef
  ! parabola:  -0.42857142857141695        1.1428571428571503        4.2857142857142811 
  print *, 'rank: ',arank
  ! rank: 2


end program example_lstsq2

program example_char
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  character(len=:), allocatable :: dlc

  string = "Character sequence"
  dlc = char(string)
! dlc == "Character sequence"
end program example_char

program example_random_seed
  use stdlib_random, only: random_seed
  implicit none
  integer :: seed_put, seed_get

  seed_put = 1234567
  call random_seed(seed_put, seed_get)     ! set and get current value of seed
end program example_random_seed

module test_parse_mode
    use stdlib_ascii, only: reverse
    use stdlib_io, only: parse_mode
    use testdrive, only: new_unittest, unittest_type, error_type, check
    implicit none

    private
    public :: collect_parse_mode

    character(3), parameter :: parse_modes_input(*) = [ &
        "   ", &
        "r  ", "w  ", "a  ", "x  ", &
        "rt ", "wt ", "at ", "xt ", &
        "rb ", "wb ", "ab ", "xb ", &
        "r+ ", "w+ ", "a+ ", "x+ ", &
        "r+t", "w+t", "a+t", "x+t", &
        "r+b", "w+b", "a+b", "x+b"  &
    ]

    character(3), parameter :: parse_modes_expected(*) = [ &
        "r t", &
        "r t", "w t", "a t", "x t", &
        "r t", "w t", "a t", "x t", &
        "r b", "w b", "a b", "x b", &
        "r+t", "w+t", "a+t", "x+t", &
        "r+t", "w+t", "a+t", "x+t", &
        "r+b", "w+b", "a+b", "x+b"  &
    ]

contains

    !> Collect all exported unit tests
    subroutine collect_parse_mode(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("parse_mode_expected_order", test_parse_mode_expected_order), &
            new_unittest("parse_mode_reverse_order", test_parse_mode_reverse_order), &
            new_unittest("parse_mode_random_order", test_parse_mode_random_order) &
            !FIXME Is it possible to run tests with error stop?
            !new_unittest("parse_mode_always_fail", test_parse_mode_always_fail) &
        ]

    end subroutine collect_parse_mode


    subroutine test_parse_mode_expected_order(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer :: n

        do n = 1, size(parse_modes_input)
            call check(error, parse_mode(trim(parse_modes_input(n))) == &
                              parse_modes_expected(n))
            if (allocated(error)) return
        end do

    end subroutine test_parse_mode_expected_order


    subroutine test_parse_mode_reverse_order(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: n

        do n = 1, size(parse_modes_input)
            call check(error, &
                       parse_mode(trim(reverse(parse_modes_input(n)))) == &
                       parse_modes_expected(n))
            if (allocated(error)) return
        end do

    end subroutine test_parse_mode_reverse_order


    subroutine test_parse_mode_random_order(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, parse_mode("t r") == "r t")
        if (allocated(error)) return

        call check(error, parse_mode(" tw ") == "w t")
        if (allocated(error)) return

        call check(error, parse_mode("ta  ") == "a t")
        if (allocated(error)) return

        call check(error, parse_mode("  t   x   ") == "x t")
        if (allocated(error)) return

        call check(error, parse_mode("+ r ") == "r+t")
        if (allocated(error)) return

        call check(error, parse_mode("w   +") == "w+t")
        if (allocated(error)) return

        call check(error, parse_mode(" a+") == "a+t")
        if (allocated(error)) return

        call check(error, parse_mode(" x+   t  ") == "x+t")
        if (allocated(error)) return

        call check(error, parse_mode("tr+ ") == "r+t")
        if (allocated(error)) return

        call check(error, parse_mode("wt + ") == "w+t")
        if (allocated(error)) return

        call check(error, parse_mode("a + t") == "a+t")
        if (allocated(error)) return

        call check(error, parse_mode(" xt + ") == "x+t")
        if (allocated(error)) return

        call check(error, parse_mode(" + t") == "r+t")
        if (allocated(error)) return

        call check(error, parse_mode(" +w  b") == "w+b")
        if (allocated(error)) return

        call check(error, parse_mode("a + b") == "a+b")
        if (allocated(error)) return

        call check(error, parse_mode(" b + x  ") == "x+b")
        if (allocated(error)) return

    end subroutine test_parse_mode_random_order


    subroutine test_parse_mode_always_fail(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, parse_mode("r+w") /= "r t")
        if (allocated(error)) return
        call check(error, parse_mode("tt") /= "r t")
        if (allocated(error)) return
        call check(error, parse_mode("bt") /= "r t")
        if (allocated(error)) return

    end subroutine test_parse_mode_always_fail

end module test_parse_mode


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_parse_mode, only : collect_parse_mode
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("parse_mode", collect_parse_mode) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program tester

module test_subprocess
    use testdrive, only : new_unittest, unittest_type, error_type, check, skip_test
    use stdlib_system, only: process_type, run, runasync, is_running, wait, update, elapsed, is_windows, kill

    implicit none

contains

    !> Collect all exported unit tests
    subroutine collect_suite(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest('test_run_synchronous', test_run_synchronous), &
            new_unittest('test_run_asynchronous', test_run_asynchronous), &
            new_unittest('test_process_kill', test_process_kill), &
            new_unittest('test_process_state', test_process_state), &
            new_unittest('test_input_redirection', test_input_redirection) &
        ]
    end subroutine collect_suite

    !> Test running a synchronous process
    subroutine test_run_synchronous(error)
        type(error_type), allocatable, intent(out) :: error
        type(process_type) :: process
        character(len=*), parameter :: command = "echo Hello"

        process = run(command, want_stdout=.true.)
        call check(error, process%completed)
        if (allocated(error)) return
        
        call check(error, trim(process%stdout) == "Hello", "stdout=<"//trim(process%stdout)//">, expected <Hello>")
    end subroutine test_run_synchronous

    !> Test running an asynchronous process
    subroutine test_run_asynchronous(error)
        type(error_type), allocatable, intent(out) :: error
        type(process_type) :: process
        logical :: running

        ! The closest possible to a cross-platform command that waits
        if (is_windows()) then 
            process = runasync("ping -n 2 127.0.0.1")
        else
            process = runasync("ping -c 2 127.0.0.1")
        endif
        ! Should not be immediately completed
        call check(error, .not. process%completed, "ping process should not complete immediately")
        if (allocated(error)) return

        running = is_running(process)
        call check(error, running, "ping process should still be running immediately after started")
        if (allocated(error)) return

        call wait(process)
        call check(error, process%completed, "process should be complete after `call wait`")
        if (allocated(error)) return

        call check(error, elapsed(process)>1.0e-4, "There should be a non-zero elapsed time")
        
    end subroutine test_run_asynchronous

    !> Test killing an asynchronous process
    subroutine test_process_kill(error)
        type(error_type), allocatable, intent(out) :: error
        type(process_type) :: process
        logical :: running, success

        ! Start a long-running process asynchronously
        if (is_windows()) then
            process = runasync("ping -n 10 127.0.0.1")
        else
            process = runasync("ping -c 10 127.0.0.1")
        endif

        ! Ensure the process starts running
        call check(error, .not. process%completed, "Process should not be completed immediately after starting")
        if (allocated(error)) return

        running = is_running(process)
        call check(error, running, "Process should be running immediately after starting")
        if (allocated(error)) return

        ! Kill the process
        call kill(process, success)
        call check(error, success, "Failed to kill the process")
        if (allocated(error)) return

        ! Verify the process is no longer running
        call check(error, .not. is_running(process), "Process should not be running after being killed")
        if (allocated(error)) return

        ! Ensure process state updates correctly after killing
        call check(error, process%completed, "Process should be marked as completed after being killed")
    end subroutine test_process_kill

    !> Test updating and checking process state
    subroutine test_process_state(error)
        type(error_type), allocatable, intent(out) :: error
        type(process_type) :: process
        character(len=*), parameter :: command = "echo Testing"

        process = run(command, want_stdout=.true., want_stderr=.true.)

        call update(process)
        call check(error, process%completed)
        if (allocated(error)) return

        call check(error, process%exit_code == 0, "Check zero exit code")
        if (allocated(error)) return
        
        call check(error, len_trim(process%stderr) == 0, "Check no stderr output")
        if (allocated(error)) return

        call check(error, trim(process%stdout) == "Testing", "stdout=<"//trim(process%stdout)//">, expected <Testing>")
        if (allocated(error)) return
    end subroutine test_process_state

    !> Test input redirection
    subroutine test_input_redirection(error)
        type(error_type), allocatable, intent(out) :: error
        type(process_type) :: process
        character(len=*), parameter :: input_string = "Hello Stdin"
        
        if (is_windows()) then 
             ! findstr "^" echoes input lines. 
             ! Note: We need complex quoting because of how arguments are parsed.
             ! Actually, sticking to something simpler if possible. 
             ! "more" implies paging which might hang. "sort" is usually safe.
             process = run("sort", stdin=input_string, want_stdout=.true.)
        else
             process = run("cat", stdin=input_string, want_stdout=.true.)
        endif

        call check(error, process%completed, "Process did not complete")
        if (allocated(error)) return

        call check(error, process%exit_code == 0, "Process failed with non-zero exit code")
        if (allocated(error)) return

        ! Check if output matches input (sort of "Hello Stdin" is "Hello Stdin")
        call check(error, index(process%stdout, input_string) > 0, &
                   "Output <"//trim(process%stdout)//"> should contain <"//input_string//">")
        
    end subroutine test_input_redirection

end module test_subprocess

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_subprocess, only : collect_suite

    implicit none

    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("subprocess", collect_suite) &
    ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

module custom_solver
    use stdlib_kinds, only: int8, dp
    use stdlib_sparse, only: CSR_dp_type, spmv, diag
    use stdlib_linalg_iterative_solvers, only: stdlib_linop_dp_type, &
                    stdlib_solver_workspace_dp_type, &
                    stdlib_solve_pcg_kernel, &
                    stdlib_size_wksp_pcg
    use stdlib_optval, only: optval
    implicit none
    private
    public :: stdlib_solve_pcg_custom

contains

    subroutine stdlib_solve_pcg_custom(A,b,x,di,rtol,atol,maxiter,restart,workspace)
        type(CSR_dp_type), intent(in) :: A
        real(dp), intent(in) :: b(:)
        real(dp), intent(inout) :: x(:)
        real(dp), intent(in), optional :: rtol
        real(dp), intent(in), optional :: atol
        logical(int8), intent(in), optional, target  :: di(:)
        integer, intent(in), optional  :: maxiter
        logical, intent(in), optional  :: restart
        type(stdlib_solver_workspace_dp_type), optional, intent(inout), target :: workspace
        !-------------------------
        type(stdlib_linop_dp_type) :: op
        type(stdlib_linop_dp_type) :: M
        type(stdlib_solver_workspace_dp_type), pointer :: workspace_
        integer :: n, maxiter_
        real(dp) :: rtol_, atol_
        logical :: restart_
        logical(int8), pointer :: di_(:)
        real(dp), allocatable :: diagonal(:)
        real(dp) :: norm_sq0
        !-------------------------
        n = size(b)
        maxiter_ = optval(x=maxiter, default=n)
        restart_ = optval(x=restart, default=.true.)
        rtol_    = optval(x=rtol,    default=1.e-4_dp)
        atol_    = optval(x=atol,    default=0._dp)
        norm_sq0 = 0._dp
        !-------------------------
        ! internal memory setup
        op%matvec => my_matvec
        op%inner_product => my_dot
        M%matvec => my_jacobi_preconditioner
        if(present(di))then
            di_ => di
        else 
            allocate(di_(n),source=.false._int8)
        end if
        
        if(present(workspace)) then
            workspace_ => workspace
        else
            allocate( workspace_ )
        end if
        if(.not.allocated(workspace_%tmp)) allocate( workspace_%tmp(n,stdlib_size_wksp_pcg) , source = 0._dp )
        workspace_%callback => my_logger
        !-------------------------
        ! Jacobi preconditioner factorization
        call diag(A,diagonal)
        where(abs(diagonal)>epsilon(0._dp)) diagonal = 1._dp/diagonal
        !-------------------------
        ! main call to the solver
        call stdlib_solve_pcg_kernel(op,M,b,x,rtol_,atol_,maxiter_,workspace_)

        !-------------------------
        ! internal memory cleanup
        if(.not.present(di)) deallocate(di_)
        di_ => null()
        
        if(.not.present(workspace)) then
            deallocate( workspace_%tmp )
            deallocate( workspace_ )
        end if
        workspace_ => null()
        contains

        subroutine my_matvec(x,y,alpha,beta,op)
            real(dp), intent(in)  :: x(:)
            real(dp), intent(inout) :: y(:)
            real(dp), intent(in) :: alpha
            real(dp), intent(in) :: beta
            character(1), intent(in) :: op
            call spmv( A , x, y , alpha, beta , op)
            y = merge( 0._dp, y, di_ )
        end subroutine
        subroutine my_jacobi_preconditioner(x,y,alpha,beta,op)
            real(dp), intent(in)  :: x(:)
            real(dp), intent(inout) :: y(:)
            real(dp), intent(in) :: alpha
            real(dp), intent(in) :: beta
            character(1), intent(in) :: op
            y = merge( 0._dp, diagonal * x , di_ )
        end subroutine
        real(dp) function my_dot(x,y) result(r)
            real(dp), intent(in) :: x(:)
            real(dp), intent(in) :: y(:)
            r = dot_product(x,y)
        end function
        subroutine my_logger(x,norm_sq,iter)
            real(dp), intent(in) :: x(:)
            real(dp), intent(in) :: norm_sq
            integer, intent(in) :: iter
            if(iter == 0) norm_sq0 = norm_sq
            print *, "Iteration: ", iter, " Residual: ", sqrt(norm_sq), " Relative: ", sqrt(norm_sq)/sqrt(norm_sq0)
        end subroutine
    end subroutine
    
end module custom_solver


program example_solve_custom
    use custom_solver
    use stdlib_kinds, only: int8, dp
    use stdlib_sparse, only: CSR_dp_type, COO_dp_type, dense2coo, coo2csr
    implicit none

    type(CSR_dp_type) :: laplacian_csr
    type(COO_dp_type) :: COO
    real(dp) :: laplacian(5,5)
    real(dp) :: x(5), rhs(5)
    logical(int8) :: dirichlet(5)

    laplacian = reshape( [1, -1,  0,  0,  0,&
                         -1,  2, -1,  0,  0,&
                          0, -1,  2, -1,  0,&
                          0,  0, -1,  2, -1,&
                          0,  0,  0, -1,  1] , [5,5])
    call dense2coo(laplacian,COO)
    call coo2csr(COO,laplacian_csr)

    x = 0._dp
    rhs = dble( [0,0,5,0,0] )

    dirichlet = .false._int8
    dirichlet([1,5]) = .true._int8

    call stdlib_solve_pcg_custom(laplacian_csr, rhs, x, rtol=1.d-6, di=dirichlet)
    print *, x !> solution: [0.0, 2.5, 5.0, 2.5, 0.0]
    
end program example_solve_custom

program example_fnv_1_hasher
  use stdlib_hashmap_wrappers, only: fnv_1_hasher, key_type, set
  use iso_fortran_env, only: int8, int32
  implicit none
  integer(int8), allocatable :: array1(:)
  integer(int32) :: hash
  type(key_type) :: key
  array1 = [5_int8, 4_int8, 3_int8, 1_int8, 10_int8, 4_int8]
  call set(key, array1)
  hash = fnv_1_hasher(key)
  print *, hash
end program example_fnv_1_hasher

program example_free_key
  use stdlib_hashmap_wrappers, only: &
    copy_key, free_key, key_type, set
  use iso_fortran_env, only: int8
  implicit none
  integer(int8) :: i, value(15)
  type(key_type) :: old_key, new_key
  value = [(i, i=1, 15)]
  call set(old_key, value)
  call copy_key(old_key, new_key)
  call free_key(old_key)
end program example_free_key

module test_constants
    !! Test constant values only for double precision.
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_kinds, only : dp, int32
    use stdlib_codata, only: YEAR, &
                             ALPHA_PARTICLE_ELECTRON_MASS_RATIO, &
                             ALPHA_PARTICLE_MASS, &
                             ATOMIC_MASS_CONSTANT, &
                             AVOGADRO_CONSTANT, &
                             BOLTZMANN_CONSTANT, &
                             ELECTRON_VOLT, &
                             ELEMENTARY_CHARGE, &
                             FARADAY_CONSTANT, &
                             MOLAR_MASS_CONSTANT,&
                             MOLAR_VOLUME_OF_IDEAL_GAS_273_15_K_101_325_KPA, &
                             PLANCK_CONSTANT,&
                             SPEED_OF_LIGHT_IN_VACUUM,&
                             STANDARD_ACCELERATION_OF_GRAVITY
    implicit none
    private
    public :: collect_constants

contains

!> Collect all exported unit tests
subroutine collect_constants(testsuite)
    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)
    testsuite = [new_unittest("YEAR", test_year), &
                 new_unittest("ALPHA_PARTICLE_ELECTRON_MASS_RATIO", test_ALPHA_PARTICLE_ELECTRON_MASS_RATIO),&
                 new_unittest("ALPHA_PARTICLE_MASS", test_ALPHA_PARTICLE_MASS),&
                 new_unittest("ATOMIC_MASS_CONSTANT", test_ATOMIC_MASS_CONSTANT),&
                 new_unittest("AVOGADRO_CONSTANT", test_AVOGADRO_CONSTANT),&
                 new_unittest("BOLTZMANN_CONSTANT", test_BOLTZMANN_CONSTANT),&
                 new_unittest("ELECTRON_VOLT", test_ELECTRON_VOLT),&
                 new_unittest("ELEMENTARY_CHARGE", test_ELEMENTARY_CHARGE),&
                 new_unittest("FARADAY_CONSTANT", test_FARADAY_CONSTANT),&
                 new_unittest("MOLAR_MASS_CONSTANT", test_MOLAR_MASS_CONSTANT),&
                 new_unittest("MOLAR_VOLUME_OF_IDEAL_GAS__273_15K__101_325_KPA", test_MOLAR_VOLUME_NTP),&
                 new_unittest("PLANCK_CONSTANT", test_PLANCK_CONSTANT),&
                 new_unittest("SPEED_OF_LIGHT_IN_VACUUM", test_SPEED_OF_LIGHT),&
                 new_unittest("STANDARD_ACCELERATION_OF_GRAVITY", test_STANDARD_ACCELERATION_OF_GRAVITY),&
                 new_unittest("U_ALPHA_PARTICLE_ELECTRON_MASS_RATIO", test_U_ALPHA_PARTICLE_ELECTRON_MASS_RATIO),&
                 new_unittest("U_ALPHA_PARTICLE_MASS", test_U_ALPHA_PARTICLE_MASS),&
                 new_unittest("U_ATOMIC_MASS_CONSTANT", test_U_ATOMIC_MASS_CONSTANT),&
                 new_unittest("U_AVOGADRO_CONSTANT", test_U_AVOGADRO_CONSTANT),&
                 new_unittest("U_BOLTZMANN_CONSTANT", test_U_BOLTZMANN_CONSTANT),&
                 new_unittest("U_ELECTRON_VOLT", test_U_ELECTRON_VOLT),&
                 new_unittest("U_ELEMENTARY_CHARGE", test_U_ELEMENTARY_CHARGE),&
                 new_unittest("U_FARADAY_CONSTANT", test_U_FARADAY_CONSTANT),&
                 new_unittest("U_MOLAR_MASS_CONSTANT", test_U_MOLAR_MASS_CONSTANT),&
                 new_unittest("U_MOLAR_VOLUME_OF_IDEAL_GAS__273_15K__101_325_KPA", test_U_MOLAR_VOLUME_NTP),&
                 new_unittest("U_PLANCK_CONSTANT", test_U_PLANCK_CONSTANT),&
                 new_unittest("U_SPEED_OF_LIGHT_IN_VACUUM", test_U_SPEED_OF_LIGHT),&
                 new_unittest("U_STANDARD_ACCELERATION_OF_GRAVITY", test_U_STANDARD_ACCELERATION_OF_GRAVITY)]
end subroutine

subroutine test_year(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, YEAR, 2022)
    if (allocated(error)) return
end subroutine

subroutine test_ALPHA_PARTICLE_ELECTRON_MASS_RATIO(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ALPHA_PARTICLE_ELECTRON_MASS_RATIO%to_real(1.0_dp), 7294.29954171_dp)
    if (allocated(error)) return
end subroutine

subroutine test_ALPHA_PARTICLE_MASS(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ALPHA_PARTICLE_MASS%to_real(1.0_dp), 6.6446573450d-27)
    if (allocated(error)) return
end subroutine

subroutine test_ATOMIC_MASS_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ATOMIC_MASS_CONSTANT%to_real(1.0_dp), 1.66053906892d-27)
    if (allocated(error)) return
end subroutine

subroutine test_AVOGADRO_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, AVOGADRO_CONSTANT%to_real(1.0_dp), 6.02214076d23)
    if (allocated(error)) return
end subroutine

subroutine test_BOLTZMANN_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, BOLTZMANN_CONSTANT%to_real(1.0_dp), 1.380649d-23)
    if (allocated(error)) return
end subroutine

subroutine test_ELECTRON_VOLT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ELECTRON_VOLT%to_real(1.0_dp), 1.602176634d-19)
    if (allocated(error)) return
end subroutine

subroutine test_ELEMENTARY_CHARGE(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ELEMENTARY_CHARGE%to_real(1.0_dp), 1.602176634d-19)
    if (allocated(error)) return
end subroutine

subroutine test_FARADAY_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, FARADAY_CONSTANT%to_real(1.0_dp), 96485.33212d0)
    if (allocated(error)) return
end subroutine

subroutine test_MOLAR_MASS_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, MOLAR_MASS_CONSTANT%to_real(1.0_dp), 1.00000000105d-3)
    if (allocated(error)) return
end subroutine

subroutine test_MOLAR_VOLUME_NTP(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, MOLAR_VOLUME_OF_IDEAL_GAS_273_15_K_101_325_KPA%to_real(1.0_dp), 22.41396954d-3)
    if (allocated(error)) return
end subroutine

subroutine test_PLANCK_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, PLANCK_CONSTANT%to_real(1.0_dp), 6.62607015d-34)
    if (allocated(error)) return
end subroutine

subroutine test_SPEED_OF_LIGHT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, SPEED_OF_LIGHT_IN_VACUUM%to_real(1.0_dp), 299792458.0d0)
    if (allocated(error)) return
end subroutine

subroutine test_STANDARD_ACCELERATION_OF_GRAVITY(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, STANDARD_ACCELERATION_OF_GRAVITY%to_real(1.0_dp), 9.80665d0)
    if (allocated(error)) return
end subroutine

subroutine test_U_ALPHA_PARTICLE_ELECTRON_MASS_RATIO(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ALPHA_PARTICLE_ELECTRON_MASS_RATIO%to_real(1.0_dp, uncertainty=.true.), 0.00000017d0)
    if (allocated(error)) return
end subroutine

subroutine test_U_ALPHA_PARTICLE_MASS(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ALPHA_PARTICLE_MASS%to_real(1.0_dp, uncertainty=.true.), 0.0000000021d-27)
    if (allocated(error)) return
end subroutine

subroutine test_U_ATOMIC_MASS_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ATOMIC_MASS_CONSTANT%to_real(1.0_dp, uncertainty=.true.), 0.00000000052d-27)
    if (allocated(error)) return
end subroutine

subroutine test_U_AVOGADRO_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, AVOGADRO_CONSTANT%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_BOLTZMANN_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, BOLTZMANN_CONSTANT%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_ELECTRON_VOLT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ELECTRON_VOLT%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_ELEMENTARY_CHARGE(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, ELEMENTARY_CHARGE%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_FARADAY_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, FARADAY_CONSTANT%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_MOLAR_MASS_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, MOLAR_MASS_CONSTANT%to_real(1.0_dp, uncertainty=.true.), 0.00000000031d-3)
    if (allocated(error)) return
end subroutine

subroutine test_U_MOLAR_VOLUME_NTP(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, MOLAR_VOLUME_OF_IDEAL_GAS_273_15_K_101_325_KPA%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_PLANCK_CONSTANT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, PLANCK_CONSTANT%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_SPEED_OF_LIGHT(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, SPEED_OF_LIGHT_IN_VACUUM%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

subroutine test_U_STANDARD_ACCELERATION_OF_GRAVITY(error)
    type(error_type), allocatable, intent(out) :: error
    call check(error, STANDARD_ACCELERATION_OF_GRAVITY%to_real(1.0_dp, uncertainty=.true.), 0.0_dp)
    if (allocated(error)) return
end subroutine

end module test_constants

program tester
    use iso_fortran_env
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_constants, only : collect_constants
    implicit none
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'
    integer :: stat, is

    stat = 0

    testsuites = [new_testsuite("constants", collect_constants)]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program

! Singular Value Decomposition 
program example_svd
  use stdlib_linalg_constants, only: dp
  use stdlib_linalg, only: svd
  implicit none

  real(dp), allocatable :: A(:,:),s(:),u(:,:),vt(:,:)
  character(*), parameter :: fmt = "(a,*(1x,f12.8))"

  ! We want to find the singular value decomposition of matrix: 
  ! 
  !    A = [ 3  2  2]
  !        [ 2  3 -2]  
  !   
  A = transpose(reshape([ 3, 2, 2, &
                          2, 3,-2], [3,2]))

  ! Prepare arrays
  allocate(s(2),u(2,2),vt(3,3))

  ! Get singular value decomposition
  call svd(A,s,u,vt)

  ! Singular values: [5, 3]
  print fmt, '    '
  print fmt, 'S = ',s
  print fmt, '    '
  
  ! Left vectors (may be flipped): 
  !     [Ã2/2  Ã2/2]
  ! U = [Ã2/2 -Ã2/2]
  !
  print fmt, '    '
  print fmt, 'U = ',u(1,:)
  print fmt, '    ',u(2,:)
  

  ! Right vectors (may be flipped): 
  !     [Ã2/2    Ã2/2      0]
  ! V = [1/Ã18 -1/Ã18  4/Ã18]
  !     [ 2/3    -2/3   -1/3]
  !
  print fmt, '    '
  print fmt, '    ',vt(1,:)
  print fmt, 'VT= ',vt(2,:)
  print fmt, '    ',vt(3,:)
  print fmt, '    '
  

end program example_svd

module stdlib_logger
!!### Module stdlib_logger
!!
!! This module defines a derived type, procedures, a variable, and
!! constants to be used for logging information and reporting errors
!! in Fortran applications.
!!([Specification](../page/specs/stdlib_logger.html))

!! The derived type, `logger_type`, is to be used to define variables to
!! serve as both local and global loggers. A logger directs its messages
!! to selected I/O units so the user has a record (a log) of major events.
!! For each entity of `logger_type` the reports go to a list of I/O units
!! represented by the private internal array, `log_units`. If `log_units` is
!! empty then output by default goes to `output_unit`. Otherwise reports
!! go to `output_unit` only if it has been explicitly added to `log_units`.
!! Each entity of type `logger_type` also maintains an internal state
!! controlling the formatting of output.
!!
!! The procedures are as follows. The logical function
!! `log_units_assigned` returns the number of I/O units in `log_units`. The
!! subroutines `add_log_file` and `add_log_unit` include the specified file
!! in `log_units`. `remove_log_units` removes the specified logical unit from
!! the `log_units` array and optionally closes the file. `configure`
!! configures the details of the logging process. `configuration`
!! reports the details of that configuration. The subroutines
!! `log_error`, `log_information`, `log_io_error`, `log_message`,
!! `log_text_error`, and `log_warning` send messages to the log units.
!!
!! The variable `global_logger` of type `logger_type` can be used
!! as a default global logger anywhere in the source code.
!!
!! The constants are used to report errors by some of the subroutines
!! in their optional `stat` arguments. The constants are as follows.
!! `success` indicates that no error has occurred. `close_failure`
!! indicates that a `close` statement for an I/O unit failed.
!! `index_invalid_error` indicates that `column` was invalid for
!! the given `line`. `open_failure` indicates that an `open` statement
!! failed. `read_only_error` indicates that an output unit did not have a
!! `"write"` or `"readwrite"` action. `non_sequential_error` indicates
!! that the unit did not have `sequential` access. `unformatted_in_error`
!! indicates that the unit did not have a `form` of `"formatted"`.
!! `unopened_in_error` indicates that the unit was not opened. `write_failure`
!! indicates that at least one of the writes to `log_units` failed.

    use, intrinsic ::           &
        iso_fortran_env, only : &
        error_unit,             &
        input_unit,             &
        output_unit

    use stdlib_ascii, only : to_lower
    use stdlib_optval, only : optval

    implicit none

    private
    public :: global_logger, logger_type

    !! public constants used as error flags
    integer, parameter, public :: &
        success = 0,              &
        close_failure = 1,        &
        index_invalid_error = 2,  &
        non_sequential_error = 3, &
        open_failure = 4,         &
        read_only_error = 5,      &
        unformatted_in_error = 6, &
        unopened_in_error = 7,    &
        write_failure = 8

    integer, parameter, public ::      &
        debug_level = 10,       &
        information_level = 20, &
        warning_level = 30,     &
        error_level = 40,       &
        io_error_level = 40,    &
        text_error_level = 50,  &
        all_level = -10 + min(  &
            debug_level,        &
            information_level,  &
            warning_level,      &
            error_level,        &
            io_error_level,     &
            text_error_level),  &
        none_level = 10 + max(  &
            debug_level,        &
            information_level,  &
            warning_level,      &
            error_level,        &
            io_error_level,     &
            text_error_level)

    character(*), parameter :: module_name = 'stdlib_logger'

    type :: logger_type
        !! version: experimental
        
        !! Public derived type ([Specification](../page/specs/stdlib_logger.html#the-derived-type-logger_type))
        private

        logical                   :: add_blank_line = .false.
        logical                   :: indent_lines = .true.
        integer                   :: level = information_level
        integer, allocatable      :: log_units(:)
        integer                   :: max_width = 0
        logical                   :: time_stamp = .true.
        integer                   :: units = 0

    contains

        private

        procedure, public, pass(self) :: add_log_file
        procedure, public, pass(self) :: add_log_unit
        procedure, public, pass(self) :: configuration
        procedure, public, pass(self) :: configure
        procedure, public, pass(self) :: log_debug
        procedure, public, pass(self) :: log_error
        procedure, public, pass(self) :: log_information
        procedure, public, pass(self) :: log_io_error
        procedure, public, pass(self) :: log_message
        procedure, public, pass(self) :: log_text_error
        procedure, public, pass(self) :: log_units_assigned
        procedure, public, pass(self) :: log_warning
        procedure, public, pass(self) :: remove_log_unit

        final :: final_logger

    end type logger_type

    !! Variable of type `logger_type` to be used as a global logger
    type(logger_type) :: global_logger

    character(*), parameter :: &
        invalid_column = 'column is not a valid index to line.'

contains

    subroutine add_log_file( self, filename, unit, action, position, status, &
                             stat )
!! version: experimental

!! Opens a formatted sequential access output file, `filename` using
!! `newunit` and adds the resulting unit number to `self`'s `log_units`
!! array. `action`, if present, is the `action` specifier of the `open`
!! statement, and has the default value of `"write"`. `position`, if present,
!! is the `position` specifier, and has the default value of `"REWIND"`.
!! `status`, if present, is the `status` specifier of the `open` statement,
!! and has the default value of `"REPLACE"`. `stat`, if present, has the value
!! `success` if `filename` could be opened, `read_only_error` if `action` is
!! `"read"`, and `open_failure` otherwise.
!!([Specification](../page/specs/stdlib_logger.html#add_log_file-open-a-file-and-add-its-unit-to-self-log_units))
        class(logger_type), intent(inout)  :: self
!! The logger variable to which the file is to be added
        character(*), intent(in)           :: filename
!! The name of the file to be  added to the logger
        integer, intent(out), optional     :: unit
!! The resulting I/O unit number
        character(*), intent(in), optional :: action
!! The `action` specifier for the `open`` statement
        character(*), intent(in), optional :: position
!! The `position` specifier for the `open` statement
        character(*), intent(in), optional :: status
!! The `status` specifier for the  `open`  statement
        integer, intent(out), optional     :: stat
!! The error status on exit with the possible values
!! * `success` - no errors found
!! * `read_only_error` - file unopened as `action1 was `"read"` for an output
!!   file
!! * `open_failure` - the `open` statement failed


!!##### Example
!!
!!     program main
!!         use stdlib_logger
!!         ...
!!         integer :: unit, stat
!!         ...
!!         call global_logger % add_log_file( 'error_log.txt', unit,      &
!!                                            position='asis', stat=stat )
!!         if ( stat /= success ) then
!!             error stop 'Unable to open "error_log.txt".'
!!         end if
!!         ...
!!     end program main

        character(16)  :: aaction, aposition, astatus
        integer        :: aunit
        character(128) :: iomsg
        integer        :: iostat
        character(*), parameter :: procedure_name = 'add_log_file'
        integer, allocatable :: dummy(:)
        integer        :: lun
        integer        :: i

        aaction = optval(action, 'write')
        aposition = optval(position, 'rewind')
        astatus = optval(status, 'replace')

        if ( len_trim(aaction) == 4 ) then

            do i=1, 4
                aaction(i:i) = to_lower(aaction(i:i))
            end do

            if ( aaction == 'read' ) then
                if ( present( stat ) ) then
                    stat = read_only_error
                    return
                else
                    error stop 'In ' // module_name // ' % ' //         &
                        procedure_name // ' action is "read" which ' // &
                        'does not allow writes to the file.'
                end if
            end if

        end if

        open( newunit=aunit, file=filename, form='formatted', action=aaction, &
              position=aposition, status=astatus, iostat=iostat, iomsg=iomsg, &
              err=999 )

        if ( allocated( self % log_units ) ) then
            if ( size(self % log_units) == self % units ) then
                allocate( dummy(2*self % units) )
                do lun=1, self % units
                    dummy(lun) = self % log_units(lun)
                end do
                dummy(self % units+1:) = 0
                call move_alloc( dummy, self % log_units )
            end if
        else
            allocate( self % log_units(16) )
        end if

        self % log_units(self % units + 1 ) = aunit
        self % units = self % units + 1
        if ( present(unit) ) unit = aunit
        if ( present(stat) ) stat = success

        return

999     if (present(stat) ) then
            stat = open_failure
            return
        else
            call self % log_io_error( 'Unable to open ' // trim(filename), &
                                      module = module_name,                &
                                      procedure = procedure_name,          &
                                      iostat = iostat,                     &
                                      iomsg = iomsg )
            error stop module_name // ' % ' // procedure_name // &
                ': Unable to open file'
        end if

    end subroutine add_log_file


    subroutine add_log_unit( self, unit, stat )
!! version: experimental

!! Adds `unit` to the log file units in `log_units`. `unit` must be an `open`
!! file, of `form` `"formatted"`, with `"sequential"` `access`, and an `action`
!! of `"write"` or `"readwrite"`, otherwise either `stat`, if present, has a
!! value other than `success` and `unit` is not entered into `log_units`,
!! or, if `stat` is not presecn, processing stops.
!!([Specification](../page/specs/stdlib_logger.html#add_log_unit-add-a-unit-to-the-array-self-log_units))

        class(logger_type), intent(inout) :: self
!! The logger variable to which the I/O unit is to be added
        integer, intent(in)               :: unit
!! The input logical unit number
        integer, intent(out), optional    :: stat
!! An error code with the possible values
!! * `success` - no problems were found
!! * `non_sequential_error` - `unit` did not have sequential access
!! * `read_only_error` - `unit` was not writeable
!! * `unformatted_in_error` - `unit` was an `'unformatted'` file
!! * `unopened_in_error` - `unit` was not opened

!!##### Example
!!
!!     program main
!!         use stdlib_logger
!!         ...
!!         character(256) :: iomsg
!!         integer :: iostat, unit, stat
!!         ...
!!         open( newunit=unit, 'error_log.txt', form='formatted', &
!!               status='replace', position='rewind', err=999,    &
!!               action='read', iostat=iostat, iomsg=iomsg )
!!         ...
!!         call global_logger % add_log_unit( unit, stat )
!!         select case ( stat )
!!         ...
!!         case ( read_only_error )
!!             error stop 'Unable to write to "error_log.txt".'
!!         ...
!!         end select
!!         ...
!!     999 error stop 'Unable to open "error_log.txt".
!!         ...
!!     end program main

        integer, allocatable :: dummy(:)
        character(*), parameter :: procedure_name = 'set_log_unit'
        integer :: lun
        character(12) :: specifier
        logical :: question
        integer :: istat

        call validate_unit()
        if ( present(stat) ) then
            if ( stat /= success ) return
        end if

        do lun = 1, self % units
! Check that unit is not already registered
            if (self % log_units(lun) == unit ) return
        end do

        if ( allocated( self % log_units ) ) then
            if ( size(self % log_units) == self % units ) then
                allocate( dummy(2*self % units) )
                do lun=1, self % units
                    dummy(lun) = self % log_units(lun)
                end do
                call move_alloc( dummy, self % log_units )
            end if
        else
            allocate( self % log_units(16) )
        end if

        self % log_units(self % units + 1 ) = unit
        self % units = self % units + 1

    contains

        subroutine validate_unit()

! Check that unit is not input_unit
            if ( unit == input_unit ) then
                if ( present(stat) ) then
                    stat = read_only_error
                    return
                else
                    error stop 'unit in ' // module_name // ' % ' // &
                        procedure_name // ' must not be input_unit.'
                end if
            end if

! Check that unit is opened
            inquire( unit, opened=question, iostat=istat )
            if(istat /= 0) question = .false.
            if ( .not. question ) then
                if ( present(stat) ) then
                    stat = unopened_in_error
                    return
                else
                    error stop 'unit in ' // module_name // ' % ' // &
                        procedure_name // ' is not open.'
                end if
            end if

! Check that unit is writeable
            inquire( unit, write=specifier )
            if ( specifier(1:1) /= 'Y' .and. specifier(1:1) /= 'y' ) then
                if ( present(stat) ) then
                    stat = read_only_error
                    return
                else
                    error stop 'unit in ' // module_name // ' % ' // &
                        procedure_name // ' is not writeable.'
                end if
            end if

            inquire( unit, sequential=specifier )
            if ( specifier(1:1) /= 'Y' .and. specifier(1:1) /= 'y' ) then
                if ( present(stat) ) then
                    stat = non_sequential_error
                    return
                else
                    error stop 'unit in ' // module_name // ' % ' // &
                        procedure_name // ' is not "sequential".'
                end if
            end if

            inquire( unit, formatted=specifier )
            if ( specifier(1:1) /= 'Y' .and. specifier(1:1) /= 'y' ) then
                if ( present(stat) ) then
                    stat = unformatted_in_error
                    return
                else
                    error stop 'unit in ' // module_name // ' % ' // &
                        procedure_name // ' is not "formatted".'
                end if
            end if

            if ( present(stat) ) stat = success

        end subroutine validate_unit

    end subroutine add_log_unit


    pure subroutine configuration( self, add_blank_line, indent, level, &
        max_width, time_stamp, log_units )
!! version: experimental

!! Reports the logging configuration of `self`. The following attributes are
!! reported:
!! 1. `add_blank_line` is a logical flag with `.true.` implying that output
!!    starts with a blank line, and `.false.` implying no blank line.
!! 2. `indent` is a logical flag with `.true.` implying that subsequent columns
!!    will be indented 4 spaces and `.false.` implying no indentation.
!! 3. `level` is the lowest level for printing a message
!! 4. `max_width` is the maximum number of columns of output text with
!!    `max_width` == 0 => no bounds on output width.
!! 5. `time_stamp` is a logical flag with `.true.` implying that the output
!!    will have a time stamp, and `.false.` implying that there will be no
!!    time stamp.
!! 6. `log_units` is an array of the I/O unit numbers to which log output
!!    will be written.
!!([Specification](../page/specs/stdlib_logger.html#configuration-report-a-loggers-configuration))

        class(logger_type), intent(in)              :: self
!! The logger variable whose configuration is being reported
        logical, intent(out), optional              :: add_blank_line
!! A logical flag to add a preceding blank line
        logical, intent(out), optional              :: indent
!! A logical flag to indent subsequent lines
        integer, intent(out), optional              :: level
!! The minimum level for printing a message
        integer, intent(out), optional              :: max_width
!! The maximum number of columns for most outputs
        logical, intent(out), optional              :: time_stamp
!! A logical flag to add a time stamp
        integer, intent(out), allocatable, optional :: log_units(:)
!! The I/O units used in output

!!##### Example
!!
!!     module example_mod
!!       use stdlib_logger
!!       ...
!!     contains
!!       ...
!!       subroutine example_sub(unit, ...)
!!         integer, intent(in) :: unit
!!         ...
!!         integer, allocatable :: log_units(:)
!!         ...
!!         call global_logger % configuration( log_units=log_units )
!!         if ( size(log_units) == 0 ) then
!!            call add_logger_unit( unit )
!!         end if
!!         ..
!!       end subroutine example_sub
!!       ...
!!     end module example_mod

        if ( present(add_blank_line) ) add_blank_line = self % add_blank_line
        if ( present(indent) ) indent = self % indent_lines
        if ( present(level) ) level = self % level
        if ( present(max_width) ) max_width = self % max_width
        if ( present(time_stamp) ) time_stamp = self % time_stamp
        if ( present(log_units) ) then
            if ( self % units .gt. 0 ) then
                log_units = self % log_units(1:self % units)
            else
                allocate(log_units(0))
            end if
        end if

    end subroutine configuration


    pure subroutine configure( self, add_blank_line, indent, level, max_width, &
        time_stamp )
!! version: experimental

!! Configures the logging process for SELF. The following attributes are
!! configured:
!! 1. `add_blank_line` is a logical flag with `.true.` implying that output
!!    starts with a blank line, and `.false.` implying no blank line.
!!    `add_blank_line` has a startup value of `.false.`.
!! 2. `indent` is a logical flag with `.true.` implying that subsequent lines
!!    will be indented 4 spaces and `.false.` implying no indentation. `indent`
!!    has a startup value of `.true.`.
!! 3. `level` is the lowest level for printing a message
!! 4. `max_width` is the maximum number of columns of output text with
!!    `max_width == 0` => no bounds on output width. `max_width` has a startup
!!    value of 0.
!! 5. `time_stamp` is a logical flag with `.true.` implying that the output
!!    will have a time stamp, and `.false.` implying that there will be no
!!    time stamp. `time_stamp` has a startup value of `.true.`.
!!([Specification](../page/specs/stdlib_logger.html#configure-configure-the-logging-process))
!!##### Example
!!
!!     program main
!!         use stdlib_logger
!!         ...
!!         call global_logger % configure( indent=.false., max_width=72 )
!!         ...

        class(logger_type), intent(inout) :: self
        logical, intent(in), optional     :: add_blank_line
        logical, intent(in), optional     :: indent
        integer, intent(in), optional     :: level
        integer, intent(in), optional     :: max_width
        logical, intent(in), optional     :: time_stamp

        if ( present(add_blank_line) ) self % add_blank_line = add_blank_line
        if ( present(level) ) self % level = level
        if ( present(indent) ) self % indent_lines = indent
        if ( present(max_width) ) then
            if ( max_width <= 4 ) then
                self % max_width = 0
            else
                self % max_width = max_width
            end if
        end if
        if ( present(time_stamp) ) self % time_stamp = time_stamp

    end subroutine configure


    subroutine final_logger( self )
!! version: experimental

!! Finalizes the `logger_type` entity `self` by flushing the units
        type(logger_type), intent(in) :: self

        integer        :: iostat
        character(256) :: message
        integer        :: unit

        do unit=1, self % units
            flush( self % log_units(unit), iomsg=message, iostat=iostat )
            if ( iostat /= 0 ) then
                write(error_unit, '(a, i0)' ) 'In the logger_type ' // &
                    'finalizer an error occurred in flushing unit = ', &
                    self % log_units(unit)
                write(error_unit, '(a, i0)') 'With iostat = ', iostat
                write(error_unit, '(a)') 'With iomsg = ' // trim(message)
            end if
        end do

    end subroutine final_logger


    subroutine format_output_string( self, string, col_indent, len_buffer, buffer )
!! version: experimental

!! Writes the STRING to UNIT ensuring that the number of characters
!! does not exceed MAX_WIDTH and that the lines after the first
!! one are indented four characters.
        class(logger_type), intent(in)             :: self
        character(*), intent(in)                   :: string
        character(*), intent(in)                   :: col_indent
        integer, intent(out)                       :: len_buffer
        character(len=:), allocatable, intent(out) :: buffer

        integer :: count, indent_len, index_, length, remain
        integer, parameter :: new_len = len(new_line('a'))

        length = len_trim(string)
        allocate( character(2*length) :: buffer )
        len_buffer = 0
        indent_len = len(col_indent)
        call format_first_line()

        if ( self % indent_lines ) then
            do while( remain > 0 )
                call indent_format_subsequent_line()
            end do
        else
            do while( remain > 0 )
                call format_subsequent_line()
            end do
        end if

    contains

        subroutine format_first_line()

            if ( self % max_width == 0 .or.                     &
                ( length <= self % max_width .and.              &
                index( string(1:length), new_line('a')) == 0 ) ) then
                buffer(1:length) = string(1:length)
                len_buffer = length
                remain = 0
                return
            else

                index_ = index( string(1:min(length, self % max_width)), &
                                new_line('a') )
                if ( index_ == 0 ) then
                    do index_=self % max_width, 1, -1
                        if ( string(index_:index_) == ' ' ) exit
                    end do
                end if

                if ( index_ == 0 ) then
                    buffer(1:self % max_width) = &
                        string(1:self % max_width)
                    len_buffer = self % max_width
                    count = self % max_width
                    remain = length - count
                    return
                else
                    buffer(1:index_-1) = string(1:index_-1)
                    len_buffer = index_-1
                    count = index_
                    remain = length - count
                    return
                end if

            end if

        end subroutine format_first_line

        subroutine format_subsequent_line()
            integer :: new_len_buffer
            character(:), allocatable :: dummy

            if ( remain <= self % max_width ) then
                new_len_buffer = len_buffer + length - count + new_len
                if ( new_len_buffer > len( buffer ) ) then
                    allocate( character( 2*len( buffer ) ) :: dummy )
                    dummy = buffer
                    call move_alloc( dummy, buffer )
                end if
                buffer( len_buffer+1:new_len_buffer ) = &
                    new_line('a') // string(count+1:length)
                len_buffer = new_len_buffer
                count = length
                remain = 0
                return
            else

                index_ = count + index(string(count+1:count+self % max_width),&
                    new_line('a'))
                if(index_ == count) then
                    do index_=count+self % max_width, count+1, -1
                        if ( string(index_:index_) == ' ' ) exit
                    end do
                end if

                if ( index_ == count ) then
                    new_len_buffer = len_buffer + self % max_width + &
                        new_len
                    if ( new_len_buffer > len( buffer ) ) then
                        allocate( character( 2*len( buffer ) ) :: dummy )
                        dummy = buffer
                        call move_alloc( dummy, buffer )
                    end if
                    buffer( len_buffer+1:new_len_buffer ) = &
                        new_line('a') // string(count+1:count+self % max_width)
                    len_buffer = new_len_buffer
                    count = count + self % max_width
                    remain = length - count
                    return
                else
                    new_len_buffer = len_buffer + index_ - 1 &
                        - count + new_len
                    if ( new_len_buffer > len( buffer ) ) then
                        allocate( character( 2*len( buffer ) ) :: dummy )
                        dummy = buffer
                        call move_alloc( dummy, buffer )
                    end if
                    buffer( len_buffer+1:new_len_buffer ) = &
                        new_line('a') // string(count+1:index_-1)
                    len_buffer = new_len_buffer
                    count = index_
                    remain = length - count
                    return
                end if

            end if

        end subroutine format_subsequent_line

        subroutine indent_format_subsequent_line()
            integer :: new_len_buffer
            character(:), allocatable :: dummy

            if ( index( string(count+1:length), new_line('a')) == 0 .and. &
                remain <= self % max_width - indent_len ) then
                new_len_buffer = len_buffer + length &
                    - count + new_len + indent_len
                if ( new_len_buffer > len( buffer ) ) then
                    allocate( character( 2*len( buffer ) ) :: dummy )
                    dummy = buffer
                    call move_alloc( dummy, buffer )
                end if
                buffer( len_buffer+1:new_len_buffer ) = &
                    new_line('a') // col_indent // string(count+1:length)
                len_buffer = new_len_buffer
                count = length
                remain = 0
                return
            else

                index_ = count + index( string(count+1:                   &
                    min ( length, count+self % max_width - indent_len) ), &
                    new_line('a'))
                if(index_ == count) then
                    do index_=count+self % max_width-indent_len, count+1, -1
                        if ( string(index_:index_) == ' ' ) exit
                    end do
                end if

                if ( index_ == count ) then
                    new_len_buffer = len_buffer + self % max_width &
                        + new_len 
                    if ( new_len_buffer > len( buffer ) ) then
                        allocate( character( 2*len( buffer ) ) :: dummy )
                        dummy = buffer
                        call move_alloc( dummy, buffer )
                    end if
                    buffer( len_buffer+1: new_len_buffer ) = &
                        new_line('a') // col_indent // &
                        string(count+1:count+self % max_width-indent_len)
                    len_buffer = new_len_buffer
                    count = count + self % max_width - indent_len
                    remain = length - count
                    return
                else
                    new_len_buffer = len_buffer + index_ - count - 1 &
                        + new_len + indent_len
                    if ( new_len_buffer > len( buffer ) ) then
                        allocate( character( 2*len( buffer ) ) :: dummy )
                        dummy = buffer
                        call move_alloc( dummy, buffer )
                    end if
                    buffer( len_buffer+1: new_len_buffer ) = &
                        new_line('a') // col_indent // string(count+1:index_-1)
                    len_buffer = new_len_buffer
                    count = index_
                    remain = length - count
                    return
                end if

            end if

        end subroutine indent_format_subsequent_line

    end subroutine format_output_string


    subroutine handle_write_failure( unit, procedure_name, iostat, iomsg )
!! version: experimental

!! Handles a failure to write to `unit` in `procedure_name` with `iostat` and
!! `iomsg` by writing a description of the failure to `output_unit` and
!! stopping.
        integer, intent(in)      :: unit
        character(*), intent(in) :: procedure_name
        integer, intent(in)      :: iostat
        character(*), intent(in) :: iomsg

        character(256) :: name
        logical :: named
        character(10) :: action

         write( output_unit, '(a)' ) 'write failure in ' // module_name // &
             ' % ' // trim(procedure_name) // '.'
         if ( unit == -999 ) then
             write( output_unit, '(a, i0)' ) 'unit = internal file'
         else
             write( output_unit, '(a, i0)' ) 'unit = ', unit
             inquire( unit, named=named )

             if ( named ) then
                 inquire( unit, name=name )
                 write( output_unit, '(a, a)' ) 'name = ', trim(name)
             else
                 write( output_unit, '(a)' ) 'unit is unnamed'
             end if
             inquire( unit, action=action )
             write( output_unit, '(a, a)' ) 'action = ', trim(action)
         end if

         write( output_unit, '(a, i0)' ) 'iostat = ', iostat
         write( output_unit, '(a, a )' ) 'iomsg = ', trim(iomsg)
         error stop 'write failure in ' // module_name // '.'

     end subroutine handle_write_failure


    subroutine log_debug( self, message, module, procedure )
!! version: experimental

!! Writes the string `message` to `self % log_units` with optional additional
!! text.
!!([Specification](../page/specs/stdlib_logger.html#log_debug-writes-the-string-message-to-self-log_units))
!!
!!##### Behavior
!!
!! If time stamps are active, a time stamp is written, followed by
!! `module` and `procedure` if present, and then `message` is
!! written with the prefix 'DEBUG: '.
!!
!!##### Example
!!
!!     module  example_mod
!!       use stdlib_logger
!!       ...
!!       real, allocatable :: a(:)
!!       ...
!!       type(logger_type) :: alogger
!!       ...
!!     contains
!!       ...
!!       subroutine example_sub( selection )
!!         integer, intent(out) :: selection
!!         integer        :: stat
!!         write(*,'(a)') "Enter an integer to select a widget"
!!         read(*,'(i0)') selection
!!         write( message, `(a, i0)' )           &
!!               "The user selected ", selection
!!         call alogger % log_debug( message,                   &
!!                                   module = 'EXAMPLE_MOD',    &
!!                                   procedure = 'EXAMPLE_SUB' )
!!         ...
!!       end subroutine example_sub
!!       ...
!!     end module example_mod
!!

        class(logger_type), intent(in)          :: self
!! The logger used to send the message
        character(len=*), intent(in)            :: message
!! A string to be written to log_unit
        character(len=*), intent(in), optional  :: module
!! The name of the module containing the current invocation of `log_information`
        character(len=*), intent(in), optional  :: procedure
!! The name of the procedure containing the current invocation of
!! `log_information`

        if ( self % level > debug_level ) return

        call self % log_message( message,               &
                                 module = module,       &
                                 procedure = procedure, &
                                 prefix = 'DEBUG' )

    end subroutine log_debug


    subroutine log_error( self, message, module, procedure, stat, errmsg )
!! version: experimental

!! Writes the string `message` to `self % log_units` with optional additional
!! text.
!! ([Specification](../specs/stdlib_logger.html#log_error-writes-the-string-message-to-self-log_units))

!!##### Behavior
!!
!! If time stamps are active, a time stamp is written, followed by
!! `module` and `procedure` if present, then `message` is
!! written with the prefix 'ERROR: ', and then if `stat` or `errmsg`
!! are present they are written.
!!
!!##### Example
!!
!!     module  example_mod
!!       use stdlib_logger
!!       ...
!!       real, allocatable :: a(:)
!!       ...
!!       type(logger_type) :: alogger
!!       ...
!!     contains
!!       ...
!!       subroutine example_sub( size )
!!         integer, intent(in) :: size
!!         character(128) :: errmsg, message
!!         integer        :: stat
!!         allocate( a(size), stat=stat, errmsg=errmsg )
!!         if ( stat /= 0 ) then
!!           write( message, `(a, i0)' )                    &
!!               "Allocation of A failed with SIZE = ", size
!!           alogger % call log_error( message,                   &
!!                                     module = 'EXAMPLE_MOD',    &
!!                                     procedure = 'EXAMPLE_SUB', &
!!                                     stat = stat,               &
!!                                     errmsg = errmsg )
!!         end if
!!       end subroutine example_sub
!!       ...
!!     end module example_mod
!!

        class(logger_type), intent(in)          :: self
!! The logger to be used in logging the message
        character(len=*), intent(in)            :: message
!! A string to be written to log_unit
        character(len=*), intent(in), optional  :: module
!! The name of the module containing the current invocation of `log_error`
        character(len=*), intent(in), optional  :: procedure
!! The name of the procedure containing the current invocation of `log_error`
        integer, intent(in), optional           :: stat
!! The value of the `stat` specifier returned by a Fortran statement
        character(len=*), intent(in), optional  :: errmsg
!! The value of the `errmsg` specifier returned by a Fortran statement

        integer :: iostat
        character(28) :: dummy
        character(256) :: iomsg
        character(*), parameter :: procedure_name = 'log_error'
        character(:), allocatable :: suffix

        if ( self % level > error_level ) return

        if ( present(stat) ) then
            write( dummy, '(a, i0)', err=999, iostat=iostat, iomsg=iomsg ) &
                new_line('a') // "With stat = ", stat
        else
            dummy = ' '
        end if

        if ( present(errmsg) ) then
            if ( len_trim(errmsg) > 0 ) then
                suffix = trim(dummy) // &
                    new_line('a') // 'With errmsg = "' // trim(errmsg) // '"'
            else
                suffix = dummy
            end if
        else
            suffix = dummy
        end if

        call self % log_message( trim(message) // suffix, &
                                 module = module,         &
                                 procedure = procedure,   &
                                 prefix = 'ERROR')

        return

999     call handle_write_failure( -999, procedure_name, iostat, iomsg )

    end subroutine log_error


    subroutine log_information( self, message, module, procedure )
!! version: experimental

!! Writes the string `message` to `self % log_units` with optional additional
!! text.
!!([Specification](../page/specs/stdlib_logger.html#log_information-writes-the-string-message-to-self-log_units))
!!
!!##### Behavior
!!
!! If time stamps are active, a time stamp is written, followed by
!! `module` and `procedure` if present, and then `message` is
!! written with the prefix 'INFO: '.
!!
!!##### Example
!!
!!     module  example_mod
!!       use stdlib_logger
!!       ...
!!       real, allocatable :: a(:)
!!       ...
!!       type(logger_type) :: alogger
!!       ...
!!     contains
!!       ...
!!       subroutine example_sub( selection )
!!         integer, intent(out) :: selection
!!         integer        :: stat
!!         write(*,'(a)') "Enter an integer to select a widget"
!!         read(*,'(i0)') selection
!!         write( message, `(a, i0)' )           &
!!               "The user selected ", selection
!!         call alogger % log_information( message,                   &
!!                                         module = 'EXAMPLE_MOD',    &
!!                                         procedure = 'EXAMPLE_SUB' )
!!         ...
!!       end subroutine example_sub
!!       ...
!!     end module example_mod
!!

        class(logger_type), intent(in)          :: self
!! The logger used to send the message
        character(len=*), intent(in)            :: message
!! A string to be written to log_unit
        character(len=*), intent(in), optional  :: module
!! The name of the module containing the current invocation of `log_information`
        character(len=*), intent(in), optional  :: procedure
!! The name of the procedure containing the current invocation of
!! `log_information`

        if ( self % level > information_level ) return

        call self % log_message( message,               &
                                 module = module,       &
                                 procedure = procedure, &
                                 prefix = 'INFO' )

    end subroutine log_information


    subroutine log_io_error( self, message, module, procedure, iostat, &
                             iomsg )
!! version: experimental

!! Writes the string `message` to the `self % log_units` with optional
!! additional text.
!!([Specification](../page/specs/stdlib_logger.html#log_io_error-write-the-string-message-to-self-log_units))
!!
!!##### Behavior
!!
!! If time stamps are active, a time stamp is written, followed by
!! `module` and `procedure` if present, then `message` is
!! written with a prefix 'I/O ERROR: ', and then if `iostat` or `iomsg`
!! are present they are also written.
!!
!!##### Example
!!
!!    program example
!!      use stdlib_logger
!!      ...
!!      character(*), parameter :: filename = 'dummy.txt'
!!      integer                 :: iostat, lun
!!      character(128)          :: iomsg
!!      character(*), parameter :: message = 'Failure in opening "dummy.txt".'
!!
!!      open( newunit=lun, file = filename, form='formatted', &
!!            status='old', iostat=iostat, iomsg=iomsg )
!!      if ( iostat /= 0 ) then
!!        call global_logger % log_io_error( message, procedure = 'EXAMPLE', &
!!            iostat=iostat, iomsg = iomsg )
!!        error stop 'Error on opening ' // filename
!!      end if
!!      ...
!!    end program example

        class(logger_type), intent(in)          :: self
!! The logger variable to receivee the message
        character(len=*), intent(in)            :: message
!! A string to be written to LOG_UNIT
        character(len=*), intent(in), optional  :: module
!! The name of the module containing the current invocation of REPORT_ERROR
        character(len=*), intent(in), optional  :: procedure
!! The name of the procedure containing the current invocation of REPORT_ERROR
        integer, intent(in), optional           :: iostat
!! The value of the IOSTAT specifier returned by a Fortran I/O statement
        character(len=*), intent(in), optional  :: iomsg
!! The value of the IOMSG specifier returned by a Fortran I/O statement

        character(28) :: dummy
        character(256) :: iomsg2
        integer :: iostat2
        character(*), parameter :: procedure_name = 'log_io_error'
        character(:), allocatable :: suffix

        if ( self % level > io_error_level ) return

        if ( present(iostat) ) then
            write( dummy, '(a, i0)', err=999, iostat=iostat2, iomsg=iomsg2 ) &
                new_line('a') // "With iostat = ", iostat
        else
            dummy = ' '
        end if

        if ( present(iomsg) ) then
            if ( len_trim(iomsg) > 0 ) then
                suffix = trim(dummy) // &
                    new_line('a') // 'With iomsg = "' // trim(iomsg) // '"'
            else
                suffix = trim(dummy)
            end if
        else
            suffix = trim(dummy)
        end if

        call self % log_message( trim(message) // suffix, &
                                 module = module,         &
                                 procedure = procedure,   &
                                 prefix = 'I/O ERROR' )

        return

999     call handle_write_failure( -999, procedure_name, iostat2, iomsg2 )

    end subroutine log_io_error

    subroutine log_message( self, message, module, procedure, prefix )
!! version: experimental

!! Writes the string `message` to the `self % log_units` with optional
!! additional text.
!!([Specification](../page/specs/stdlib_logger.html#log_message-write-the-string-message-to-self-log_units))
!!
!!##### Behavior
!!
!! If time stamps are active, a time stamp is written, followed by `module`
!! and `procedure` if present, followed by `prefix // ': '` if present,
!! and then `message`.
!!
!!##### Example
!!
!!    module  example_mod
!!      use stdlib_logger
!!      ...
!!      real, allocatable :: a(:)
!!      ...
!!    contains
!!      ...
!!      subroutine example_sub( selection )
!!        integer, intent(out) :: selection
!!        integer        :: stat
!!        write(*,'(a)') "Enter an integer to select a widget"
!!        read(*,'(i0)') selection
!!        write( message, `(a, i0)' )          &
!!              "The user selected ", selection
!!        call global_logger % log_message( message,                   &
!!                                          module = 'example_mod',    &
!!                                          procedure = 'example_sub', &
!!                                          prefix = 'info' )
!!      end subroutine example_sub
!!      ...
!!    end module example_mod
!!

        class(logger_type), intent(in)          :: self
!! The logger variable to receive the message
        character(len=*), intent(in)            :: message
!! A string to be written to log_unit
        character(len=*), intent(in), optional  :: module
!! The name of the module containing the current invocation of `log_message`
        character(len=*), intent(in), optional  :: procedure
!! The name of the procedure containing the current invocation of `log_message`
        character(len=*), intent(in), optional  :: prefix
!! To be prepended to message as `prefix // ': ' // message`.

        integer :: unit
        integer :: iostat
        integer :: len_buffer
        character(*), parameter :: procedure_name = 'log_message'
        character(256) :: iomsg
        character(:), allocatable :: d_and_t, m_and_p, pref
        character(:), allocatable :: buffer

        pref = optval(prefix, '')
        if ( len(pref) > 0 ) pref = pref // ': '

        if ( self % time_stamp ) then
            d_and_t = time_stamp() // ': '
        else
            d_and_t = ''
        end if

        if ( present(module) ) then
            if ( present(procedure) ) then
                m_and_p = trim(module) // ' % ' // trim(procedure) // ': '
            else
                m_and_p = trim(module) // ': '
            end if
        else if ( present(procedure) ) then
            m_and_p = trim(procedure) // ': '
        else
            m_and_p = ''
        end if

        call format_output_string( self,                         &
                                   d_and_t // m_and_p // pref // &
                                   trim( message ),              &
                                   '    ',                       &
                                   len_buffer,                   &
                                   buffer)

        if ( self % units == 0 ) then
            if ( self % add_blank_line ) then
                write( output_unit, '(a)', err=999, iostat=iostat, &
                        iomsg=iomsg) &
                    new_line('a') // buffer(1:len_buffer)
            else
                write( output_unit, '(a)', err=999, iostat=iostat, &
                        iomsg=iomsg ) &
                    buffer(1:len_buffer)
            end if
        else
            if ( self % add_blank_line ) then
                do unit=1, self % units
                    write( self % log_units(unit), '(a)', err=999, iostat=iostat, &
                        iomsg=iomsg ) new_line('a') // &
                        buffer(1:len_buffer)
                end do
            else
                do unit=1, self % units
                    write( self % log_units(unit), '(a)', err=999, iostat=iostat, &
                        iomsg=iomsg ) &
                        buffer(1:len_buffer)
                end do
            end if
        end if


        return

999     call handle_write_failure( unit, procedure_name, iostat, iomsg )

    end subroutine log_message

    subroutine log_text_error( self, line, column, summary, filename,  &
                               line_number, caret, stat )
!! version: experimental

!! Sends a message to `self % log_units` describing an error found
!! in a line of text.
!!([Specification](../page/specs/stdlib_logger.html#log_text_error-send-a-message-to-self-log_units-describing-an-error))

!!##### Behavior
!!
!! If time stamps are active first a time stamp is written. Then if
!! `filename` or `line_number` or `column` are present they are written.
!! Then `line` is written. Then the symbol `caret` is written below `line`
!! at the column indicated by `column`. Then `summary` is written.
!
!!##### Example
!!
!!    program example
!!      ...
!!      character(*), parameter :: filename = 'dummy.txt'
!!      integer                 :: col_num, line_num, lun
!!      character(128)          :: line
!!      character(*), parameter :: message = 'Bad text found.'
!!
!!      open( newunit=lun, file = filename, statu='old', form='formatted' )
!!      line_num = 0
!!      do
!!        read( lun, fmt='(a)', end=900 ) line
!!        line_num = line_num + 1
!!        call check_line( line, status, col_num )
!!        if ( status /= 0 )
!!          call global_logger % log_text_error( line, col_num, message, &
!!                                               filename, line_num )
!!          error stop 'Error in reading ' // filename
!!        end if
!!        ...
!!      end do
!!900   continue
!!      ...
!!    end program example
!!
        class(logger_type), intent(in)        :: self
!! The logger variable to receive the message
        character(*), intent(in)              :: line
!! The line of text in which the error was found.
        integer, intent(in)                   :: column
!! The one's based column in LINE at which the error starts.
        character(*), intent(in)              :: summary
!! A brief description of the error.
        character(*), intent(in), optional    :: filename
!! The name of the file, if any, in which the error was found.
        integer, intent(in), optional         :: line_number
!! The one's based line number in the file where `line` was found.
        character(1), intent(in), optional    :: caret
!! The symbol used to mark the column wher the error was first detected
        integer, intent(out), optional        :: stat
!! Integer flag that an error has occurred. Has the value `success` if no
!! error hass occurred, `index_invalid_error` if `column` is less than zero or
!! greater than `len(line)`, and `write_failure` if any of the `write`
!! statements has failed.

        character(1)                  :: acaret
        character(128)                :: iomsg
        integer                       :: iostat
        integer                       :: lun
        character(*), parameter       :: procedure_name = 'LOG_TEXT_ERROR'
        character(len=:), allocatable :: buffer

        if ( self % level > text_error_level ) return

        acaret = optval(caret, '^')

        if ( column < 0 .or. column > len( line ) + 1 ) then
            if ( present(stat) ) then
                stat = index_invalid_error
                return
            else
                call self % log_error( invalid_column,           &
                                       module = module_name,     &
                                       procedure = procedure_name )
                error stop module_name // ' % ' // procedure_name // ': ' // &
                    invalid_column
            end if
        end if

        call write_log_text_error_buffer( )
        if ( self % units == 0 ) then
            write( output_unit, '(a)' ) buffer
        else
            do lun=1, self % units
                write( self % log_units(lun), '(a)' ) buffer
            end do
        end if

    contains

        subroutine write_log_text_error_buffer( )
            integer                   :: i
            character(:), allocatable :: location, marker

            if ( present(filename) ) then
                if ( present(line_number) ) then
                    allocate( character(len_trim(filename)+15) :: location )
                    write( location, fmt='(a, ":", i0, ":", i0)', err=999, &
                           iomsg=iomsg, iostat=iostat )           &
                           trim(filename) , line_number, column
                else
                    allocate( character(len_trim(filename)+45) :: location )
                    write( location, fmt='(a, i0)', err=999, iomsg=iomsg, &
                           iostat=iostat ) &
                           "Error found in file: '" // trim(filename) // &
                           "', at column: ", column
                end if

            else
                if ( present(line_number) ) then
                    allocate( character(54) :: location )
                    write( location, fmt='(a, i0, a, i0)', err=999, &
                           iomsg=iomsg, iostat=iostat ) &
                        'Error found at line number: ', line_number, &
                        ', and column: ', column
                else
                    allocate( character(36) :: location )
                    write( location, &
                           fmt='("Error found in line at column:", i0)' ) &
                        column
                end if
            end if

            allocate( character(column) :: marker )
            do i=1, column-1
                marker(i:i) = ' '
            end do
            marker(column:column) = acaret
            if ( self % add_blank_line ) then
                if ( self % time_stamp ) then
                    buffer = new_line('a') // time_stamp() // &
                        new_line('a') // trim(location) // &
                        new_line('a') // new_line('a') // trim(line) // &
                        new_line('a') // marker // &
                        new_line('a') // 'Error: ' // trim(summary)
                else
                    buffer = new_line('a') // trim(location) // &
                        new_line('a') // new_line('a') // trim(line) // &
                        new_line('a') // marker // &
                        new_line('a') // 'Error: ' // trim(summary)
                end if
            else
                if ( self % time_stamp ) then
                    buffer = time_stamp() // &
                        new_line('a') // trim(location) // &
                        new_line('a') // new_line('a') // trim(line) // &
                        new_line('a') // marker // &
                        new_line('a') // 'Error: ' // trim(summary)
                else
                    buffer = trim(location) // &
                        new_line('a') // new_line('a') // trim(line) // &
                        new_line('a') // marker // &
                        new_line('a') // 'Error: ' // trim(summary)
                end if
            end if

            if ( present(stat) ) stat = success

            return

999         if ( present( stat ) ) then
                stat = write_failure
                return
            else
                call handle_write_failure( -999, procedure_name, iostat, &
                                           iomsg )
            end if

        end subroutine write_log_text_error_buffer

    end subroutine log_text_error


    elemental function log_units_assigned(self)
!! version: experimental

!! Returns the number of units assigned to `self % log_units`
!!([Specification](../page/specs/stdlib_logger.html#log_units_assigned-returns-the-number-of-active-io-units))

        class(logger_type), intent(in) :: self
!! The logger subject to the inquiry
        integer                        :: log_units_assigned
!!##### Example
!!
!!     module  example_mod
!!       use stdlib_logger
!!       ...
!!       type(logger_type) :: alogger
!!       ...
!!     contains
!!       ...
!!       subroutine example_sub(unit, ...)
!!         integer, intent(in) :: unit
!!         ...
!!         integer, allocatable :: log_units(:)
!!         ...
!!         if ( alogger % log_units_assigned() == 0 ) then
!!            call alogger % add_log_unit( unit )
!!         end if
!!         ...
!!       end subroutine example_sub
!!       ...
!!     end module example_mod

        log_units_assigned = self % units

    end function log_units_assigned


    subroutine log_warning( self, message, module, procedure )
!! version: experimental

!! Writes the string `message` to `self % log_units` with optional additional
!! text.
!!([Specification](../page/specs/stdlib_logger.html#log_warning-write-the-string-message-to-log_units))

!!##### Behavior
!!
!! If time stamps are active, a time stamp is written, followed by
!! `module` and `procedure` if present, then `message` is
!! written with the prefix 'WARN: '.
!!
!!##### Example
!!
!!     module  example_mod
!!       use stdlib_logger
!!       ...
!!       real, allocatable :: a(:)
!!       ...
!!       type(logger_type) :: alogger
!!       ...
!!     contains
!!       ...
!!       subroutine example_sub( size, stat )
!!         integer, intent(in)  :: size
!!         integer, intent(out) :: stat
!!         allocate( a(size) )
!!         if ( stat /= 0 ) then
!!           write( message, `(a, i0)' )                    &
!!               "Allocation of A failed with SIZE = ", size
!!           call alogger % log_warning( message,                   &
!!                                       module = 'EXAMPLE_MOD',    &
!!                                       procedure = 'EXAMPLE_SUB' )
!!         end if
!!       end subroutine example_sub
!!       ...
!!     end module example_mod
!!
        class(logger_type), intent(in)          :: self
!! The logger to which the message is written
        character(len=*), intent(in)            :: message
!! A string to be written to LOG_UNIT
        character(len=*), intent(in), optional  :: module
!! The name of the module containing the current invocation of `log_warning`
        character(len=*), intent(in), optional  :: procedure
!! The name of the procedure containing the current invocation of `log_warning`

        if ( self % level > warning_level ) return

        call self % log_message( message,               &
                                 module = module,       &
                                 procedure = procedure, &
                                 prefix = 'WARN' )

    end subroutine log_warning


    subroutine remove_log_unit( self, unit, close_unit, stat )
!! version: experimental

!! Remove the I/O unit from the self % log_units list. If `close_unit` is
!! present and `.true.` then the corresponding file is closed. If `unit` is
!! not in `log_units` then nothing is done. If `stat` is present it, by
!! default, has the value `success`. If closing the `unit` fails, then if
!! `stat` is present it has the value `close_failure`, otherwise processing
!! stops with an informative message.
!!([Specification](../page/specs/stdlib_logger.html#remove_log_unit-remove-unit-from-self-log_units))

        class(logger_type), intent(inout) :: self
!! The logger variable whose unit is to be removed
        integer, intent(in)               :: unit
!! The I/O unit to be removed from self
        logical, intent(in), optional     :: close_unit
!! A logical flag to close the unit while removing it from the SELF list
        integer, intent(out), optional    :: stat
!! An error status with the values
!! * success - no problems found
!! * close_failure - the close statement for unit failed
!!
!!##### Example
!!
!!     module  example_mod
!!       use stdlib_logger
!!       ...
!!       type(logger_type) ::  alogger
!!     contains
!!       ...
!!       subroutine example_sub(unit, ...)
!!         integer, intent(in) :: unit
!!         ...
!!         call alogger % remove_log_unit( unit )
!!         ...
!!       end subroutine example_sub
!!       ...
!!     end module example_mod

        character(128) :: errmsg
        integer :: lun, lun_old
        character(*), parameter :: procedure_name = 'REMOVE_LOG_UNIT'

        if ( present(stat) ) stat = success
        do lun=1, self % units
            if ( unit == self % log_units(lun) ) exit
        end do

        if ( lun == self % units + 1 ) return

        if ( present(close_unit) ) then
            if ( close_unit ) close( unit, err=999, iomsg=errmsg )
        end if

        do lun_old=lun+1, self % units
            self % log_units(lun_old-1) = self % log_units(lun_old)
        end do
        self % units = self % units - 1

        return

999     if ( present(stat) ) then
            stat = close_failure
            return
        else
            write(*, '(a, i0)') 'In ' // module_name // ' % ' // &
                procedure_name // ' close_unit failed for unit = ', unit
            write(*, '(a)' ) 'With iomsg = ' // trim(errmsg)
            error stop 'close_unit failed in ' // module_name // ' % ' // &
                procedure_name // '.'
        end if

    end subroutine remove_log_unit


    function time_stamp()
!! Creates a time stamp in the format 'yyyy-mm-dd hh:mm:ss.sss'
        character(23) :: time_stamp
        character(8)  :: date
        character(10) :: time

        call date_and_time( date, time )

        time_stamp(1:4)   = date(1:4)
        time_stamp(5:5)   = '-'
        time_stamp(6:7)   = date(5:6)
        time_stamp(8:8)   = '-'
        time_stamp(9:10)  = date(7:8)
        time_stamp(11:11) = ' '
        time_stamp(12:13) = time(1:2)
        time_stamp(14:14) = ':'
        time_stamp(15:16) = time(3:4)
        time_stamp(17:17) = ':'
        time_stamp(18:23) = time(5:10)

    end function time_stamp

end module stdlib_logger

submodule (stdlib_quadrature) stdlib_quadrature_gauss
    use stdlib_specialfunctions, only: legendre, dlegendre
    implicit none

    real(dp), parameter :: pi = acos(-1._dp)
    real(dp), parameter :: tolerance = 4._dp * epsilon(1._dp)
    integer, parameter :: newton_iters = 100

contains

    pure module subroutine gauss_legendre_fp64 (x, w, interval)
        real(dp), intent(out) :: x(:), w(:)
        real(dp), intent(in), optional :: interval(2)

        associate (n => size(x)-1 )
        select case (n)
            case (0)
                x = 0
                w = 2
            case (1)
                x(1) = -sqrt(1._dp/3._dp)
                x(2) = -x(1)
                w = 1
            case default
                block
                integer :: i,j
                real(dp) :: leg, dleg, delta

                do i = 0, (n+1)/2 - 1
                    ! use Gauss-Chebyshev points as an initial guess
                    x(i+1) = -cos((2*i+1)/(2._dp*n+2._dp) * pi)
                    do j = 1, newton_iters
                        leg  = legendre(n+1,x(i+1))
                        dleg = dlegendre(n+1,x(i+1))
                        delta = -leg/dleg
                        x(i+1) = x(i+1) + delta
                        if ( abs(delta) <= tolerance * abs(x(i+1)) )  exit
                    end do
                    x(n-i+1) = -x(i+1)

                    dleg = dlegendre(n+1,x(i+1))
                    w(i+1)   = 2._dp/((1-x(i+1)**2)*dleg**2) 
                    w(n-i+1) = w(i+1)
                end do

                if (mod(n,2) == 0) then
                    x(n/2+1) = 0

                    dleg = dlegendre(n+1, 0.0_dp)
                    w(n/2+1) = 2._dp/(dleg**2) 
                end if
                end block
        end select
        end associate

        if (present(interval)) then
            associate ( a => interval(1) , b => interval(2) )
            x = 0.5_dp*(b-a)*x+0.5_dp*(b+a)
            w = 0.5_dp*(b-a)*w
            end associate
        end if
    end subroutine

    pure module subroutine gauss_legendre_lobatto_fp64 (x, w, interval)
        real(dp), intent(out) :: x(:), w(:)
        real(dp), intent(in), optional :: interval(2)

        associate (n => size(x)-1)
        select case (n)
            case (1)
                x(1) = -1
                x(2) =  1
                w = 1
            case default
                block
                integer :: i,j
                real(dp) :: leg, dleg, delta

                x(1)   = -1._dp
                x(n+1) =  1._dp
                w(1)   =  2._dp/(n*(n+1._dp))
                w(n+1) =  2._dp/(n*(n+1._dp))

                do i = 1, (n+1)/2 - 1
                    ! initial guess from an approximate form given by SV Parter (1999)
                    x(i+1) = -cos( (i+0.25_dp)*pi/n  - 3/(8*n*pi*(i+0.25_dp)))
                    do j = 1, newton_iters
                        leg  = legendre(n+1,x(i+1)) - legendre(n-1,x(i+1))
                        dleg = dlegendre(n+1,x(i+1)) - dlegendre(n-1,x(i+1))
                        delta = -leg/dleg
                        x(i+1) = x(i+1) + delta
                        if ( abs(delta) <= tolerance * abs(x(i+1)) )  exit
                    end do
                    x(n-i+1) = -x(i+1)

                    leg = legendre(n, x(i+1))
                    w(i+1)   = 2._dp/(n*(n+1._dp)*leg**2) 
                    w(n-i+1) = w(i+1)
                end do

                if (mod(n,2) == 0) then
                    x(n/2+1) = 0

                    leg = legendre(n, 0.0_dp)
                    w(n/2+1)   = 2._dp/(n*(n+1._dp)*leg**2) 
                end if
                end block
        end select
        end associate
        
        if (present(interval)) then
            associate ( a => interval(1) , b => interval(2) )
            x = 0.5_dp*(b-a)*x+0.5_dp*(b+a)
            x(1)       = interval(1)
            x(size(x)) = interval(2)
            w = 0.5_dp*(b-a)*w
            end associate
        end if
    end subroutine
end submodule    

program example_rehash
  use stdlib_kinds, only: int8
  use stdlib_hashmaps, only: open_hashmap_type
  use stdlib_hashmap_wrappers, only: fnv_1a_hasher, &
                                     key_type, set
  implicit none
  type(open_hashmap_type) :: map
  type(key_type)      :: key
  call map%init(slots_bits=10)
  call set(key, [5_int8, 7_int8, 4_int8, 13_int8])
  call map%map_entry(key, 'A value')
  call map%rehash(fnv_1a_hasher)
end program example_rehash

! Usage of base_name
program example_path_base_name
    use stdlib_system, only: base_name, OS_TYPE, OS_WINDOWS
    character(len=:), allocatable :: p1

    if(OS_TYPE() == OS_WINDOWS) then
        p1 = 'C:\Users'
    else
        p1 = '/home'
    endif 
    
    print *, 'base name of '// p1 // ' -> ' // base_name(p1) 
    ! base name of C:\Users -> Users
    ! OR
    ! base name of /home -> home
end program example_path_base_name

program example_selu
    use stdlib_kinds, only: sp
    use stdlib_math, only: linspace
    use stdlib_specialfunctions, only: selu
    implicit none
    integer, parameter :: n = 10
    real(sp) :: x(n), y(n)
    
    x = linspace(-2._sp, 2._sp, n)
    y = selu( x )
    print *, y
end program example_selu
  

program example_diag1
  use stdlib_linalg, only: diag
  implicit none
  real, allocatable :: A(:, :)
  integer :: i
  A = diag([(1, i=1, 10)]) ! creates a 10 by 10 identity matrix
end program example_diag1

program example_diag5
  use stdlib_linalg, only: diag
  implicit none
  integer, parameter :: n = 3
  real :: A(n, n)
  real, allocatable :: v(:)
  A = reshape([1, 2, 3, 4, 5, 6, 7, 8, 9], [n, n])
  v = diag(A, -1) ! v is [2,6]
  v = diag(A, 1)  ! v is [4,8]
end program example_diag5

! Illustrate the usage of `remove_directory`
program example_remove_directory
    use stdlib_system, only: remove_directory
    use stdlib_error, only: state_type
    implicit none

    type(state_type) :: err

    call remove_directory("directory_to_be_removed", err)

    if (err%error()) then
        print *, err%print()
    else
        print *, "directory removed successfully"
    end if

end program example_remove_directory

program example_tridiagonal_matrix
   use stdlib_linalg_constants, only: dp
   use stdlib_specialmatrices
   implicit none

   integer, parameter :: n = 5
   type(Tridiagonal_dp_type) :: A
   real(dp) :: dl(n - 1), dv(n), du(n - 1)

   ! Generate random tridiagonal elements.
   call random_number(dl)
   call random_number(dv)
   call random_number(du)

   ! Create the corresponding Tridiagonal matrix.
   A = Tridiagonal(dl, dv, du)

end program example_tridiagonal_matrix

! Constrained least-squares solver: functional interface
program example_constrained_lstsq1
   use stdlib_linalg_constants, only: dp
   use stdlib_linalg, only: constrained_lstsq
   implicit none
   integer, parameter :: m = 5, n = 4, p = 3
   !> Least-squares cost.
   real(dp) :: A(m, n), b(m)
   !> Equality constraints.
   real(dp) :: C(p, n), d(p)
   !> Solution.
   real(dp) :: x(n), x_true(n)

   !> Least-squares cost.
   A(1, :) = [1.0_dp, 1.0_dp, 1.0_dp, 1.0_dp]
   A(2, :) = [1.0_dp, 3.0_dp, 1.0_dp, 1.0_dp]
   A(3, :) = [1.0_dp, -1.0_dp, 3.0_dp, 1.0_dp]
   A(4, :) = [1.0_dp, 1.0_dp, 1.0_dp, 3.0_dp]
   A(5, :) = [1.0_dp, 1.0_dp, 1.0_dp, -1.0_dp]

   b = [2.0_dp, 1.0_dp, 6.0_dp, 3.0_dp, 1.0_dp]

   !> Equality constraints.
   C(1, :) = [1.0_dp, 1.0_dp, 1.0_dp, -1.0_dp]
   C(2, :) = [1.0_dp, -1.0_dp, 1.0_dp, 1.0_dp]
   C(3, :) = [1.0_dp, 1.0_dp, -1.0_dp, 1.0_dp]

   d = [1.0_dp, 3.0_dp, -1.0_dp]

   ! Compute the solution.
   x = constrained_lstsq(A, b, C, d)
   x_true = [0.5_dp, -0.5_dp, 1.5_dp, 0.5_dp]

   print *, "Exact solution :"
   print *, x_true
   print *
   print *, "Computed solution :"
   print *, x

end program example_constrained_lstsq1

program example_silu
    use stdlib_kinds, only: sp
    use stdlib_math, only: linspace
    use stdlib_specialfunctions, only: silu
    implicit none
    integer, parameter :: n = 10
    real(sp) :: x(n), y(n)
    
    x = linspace(-2._sp, 2._sp, n)
    y = silu( x )
    print *, y
end program example_silu
  

! SPDX-Identifer: MIT
module test_string_derivedtype_io
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_string_type, only : string_type, assignment(=), len, &
        write(formatted), read(formatted), write(unformatted), read(unformatted), &
        operator(==)
    implicit none

contains

    !> Collect all exported unit tests
    subroutine collect_string_derivedtype_io(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("listdirected_io", test_listdirected_io), &
            new_unittest("formatted_io", test_formatted_io), &
            new_unittest("unformatted_io", test_unformatted_io) &
            ]
    end subroutine collect_string_derivedtype_io

    subroutine test_listdirected_io(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: io, stat
        string = "Important saved value"

        open(newunit=io, form="formatted", status="scratch")
        write(io, *) string
        write(io, *) ! Pad with a newline or we might run into EOF while reading

        string = ""
        rewind(io)

        read(io, *, iostat=stat) string
        close(io)

        call check(error, stat == 0)
        if (allocated(error)) return
        call check(error, len(string) == 21)
        if (allocated(error)) return
        call check(error, string == "Important saved value")
    end subroutine test_listdirected_io

    subroutine test_formatted_io(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: io, stat
        string = "Important saved value"

        open(newunit=io, form="formatted", status="scratch")
        write(io, '(dt)') string
        write(io, '(a)') ! Pad with a newline or we might run into EOF while reading

        string = ""
        rewind(io)

        read(io, *, iostat=stat) string
        close(io)

        call check(error, stat == 0)
        if (allocated(error)) return
        call check(error, len(string) == 21)
        if (allocated(error)) return
        call check(error, string == "Important saved value")
    end subroutine test_formatted_io

    subroutine test_unformatted_io(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        integer :: io
        string = "Important saved value"

        open(newunit=io, form="unformatted", status="scratch")
        write(io) string

        string = ""
        rewind(io)

        read(io) string
        close(io)

        call check(error, len(string) == 21)
        if (allocated(error)) return
        call check(error, string == "Important saved value")
    end subroutine test_unformatted_io

end module test_string_derivedtype_io


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_string_derivedtype_io, only : collect_string_derivedtype_io
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("string-derivedtype-io", collect_string_derivedtype_io) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

! Eigenvalues of a general real/complex matrix for the generalized eigenproblem
program example_eigvals_generalized
  use stdlib_linalg, only: eigvals, eye
  implicit none

  real, allocatable :: A(:,:), B(:,:), lambda(:)
  complex, allocatable :: cA(:,:), cB(:,:), clambda(:)

  ! NB Fortran is column-major -> transpose input
  A = transpose(reshape([ [2, 8, 4], &
                          [1, 3, 5], &
                          [9, 5,-2] ], [3,3]))

  B = eye(3)

  ! Real generalized eigenproblem
  lambda = eigvals(A, B)
  print *, 'Real generalized matrix eigenvalues: ', lambda

  ! Complex generalized eigenproblem
  cA = cmplx(A, -2*A)
  cB = cmplx(B, 0.5*B)
  clambda = eigvals(cA, cB)
  print *, 'Complex generalized matrix eigenvalues: ', clambda

end program example_eigvals_generalized

! SPDX-Identifer: MIT
module test_string_operator
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_string_type, only : string_type, assignment(=), len, &
        operator(>), operator(<), operator(>=), operator(<=), &
        operator(/=), operator(==), operator(//)
    implicit none

contains


    !> Collect all exported unit tests
    subroutine collect_string_operator(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("gt", test_gt), &
            new_unittest("lt", test_lt), &
            new_unittest("ge", test_ge), &
            new_unittest("le", test_le), &
            new_unittest("eq", test_eq), &
            new_unittest("ne", test_ne), &
            new_unittest("concat", test_concat) &
            ]
    end subroutine collect_string_operator

    subroutine test_gt(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = string > "abc"
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = string > "bcd"
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = string > "cde"
        call check(error, res .eqv. .false.)
    end subroutine test_gt

    subroutine test_lt(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = string < "abc"
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = string < "bcd"
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = string < "cde"
        call check(error, res .eqv. .true.)
    end subroutine test_lt

    subroutine test_ge(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = string >= "abc"
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = string >= "bcd"
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = string >= "cde"
        call check(error, res .eqv. .false.)
    end subroutine test_ge

    subroutine test_le(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = string <= "abc"
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = string <= "bcd"
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = string <= "cde"
        call check(error, res .eqv. .true.)
    end subroutine test_le

    subroutine test_eq(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = string == "abc"
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = string == "bcd"
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = string == "cde"
        call check(error, res .eqv. .false.)
    end subroutine test_eq

    subroutine test_ne(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string
        logical :: res

        string = "bcd"
        res = string /= "abc"
        call check(error, res .eqv. .true.)
        if (allocated(error)) return

        res = string /= "bcd"
        call check(error, res .eqv. .false.)
        if (allocated(error)) return

        res = string /= "cde"
        call check(error, res .eqv. .true.)
    end subroutine test_ne

    subroutine test_concat(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        type(string_type) :: string

        string = "Hello, "
        string = string // "World!"
        call check(error, len(string) == 13)
    end subroutine test_concat

end module test_string_operator


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_string_operator, only : collect_string_operator
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("string-operator", collect_string_operator) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_solve2
  use stdlib_linalg_constants, only: sp
  use stdlib_linalg, only: solve, linalg_state_type 
  implicit none

  complex(sp), allocatable :: A(:,:),b(:),x(:)

  ! Solve a system of 3 complex linear equations: 
  !  2x +      iy + 2z = (5-i)
  ! -ix + (4-3i)y + 6z = i
  !  4x +      3y +  z = 1

  ! Note: Fortran is column-major! -> transpose 
  A = transpose(reshape([(2.0, 0.0),(0.0, 1.0),(2.0,0.0), &
                         (0.0,-1.0),(4.0,-3.0),(6.0,0.0), &
                         (4.0, 0.0),(3.0, 0.0),(1.0,0.0)] , [3,3])) 
  b = [(5.0,-1.0),(0.0,1.0),(1.0,0.0)]

  ! Get coefficients of y = coef(1) + x*coef(2) + x^2*coef(3)
  x = solve(A,b) 

  print *, 'solution: ',x
  !   (1.0947,0.3674) (-1.519,-0.4539) (1.1784,-0.1078)

end program example_solve2

program example_fnv_1_hash
  use stdlib_hash_32bit, only: fnv_1_hash
  use iso_fortran_env, only: int32
  implicit none
  integer(int32) :: hash
  hash = fnv_1_hash([5, 4, 3, 1, 10, 4, 9])
  print *, hash
end program example_fnv_1_hash

! Demonstrate usage of `delete_file`
program example_delete_file
  use stdlib_system, only: delete_file
  use stdlib_error, only: state_type
  implicit none

  type(state_type) :: err
  character(*), parameter :: filename = "example.txt"

  ! Delete a file with error handling
  call delete_file(filename, err)

  if (err%error()) then
    print *, err%print() 
  else
    print *, "File "//filename//" deleted successfully."
  end if
end program example_delete_file

program example_move
  use stdlib_string_type, only: string_type, assignment(=), move
  implicit none
  type(string_type) :: from_string
  character(len=:), allocatable :: from_char, to_char

  from_string = "move this string"
  from_char = "move this char"
! from_string <-- "move this string"
! from_char   <-- "move this char"
! to_char   <-- (unallocated)

  call move(from_string, to_char)
! from_string <-- ""
! to_char   <-- "move this string"

  call move(from_char, to_char)
! from_char <-- (unallocated)
! to_string <-- "move this char"

end program example_move

program example_shuffle
  use stdlib_random, only: random_seed
  use stdlib_stats_distribution_uniform, only: shuffle
  implicit none
  integer :: seed_put, seed_get, i
  real :: x(10)
  integer :: n(10)
  complex :: z(10)

  do i = 1, 10
    n(i) = i
    x(i) = real(i)
    z(i) = cmplx(real(i), real(i))
  end do
  seed_put = 32165498
  call random_seed(seed_put, seed_get)    ! set and get current value of seed
  print *, shuffle(n)                          ! get randomized n

!10   6   9   2   8   1   3   5   7   4

  print *, shuffle(x)                          ! get randomized x

!5.0   10.0   9.0   4.0   3.0   8.0   2.0   1.0   7.0   6.0

  print *, shuffle(z)                          ! get randomized z

!(8.0, 8.0)    (7.0, 7.0)    (4.0, 4.0)    (1.0, 1.0)    (5.0, 5.0)
!(9.0, 9.0)    (6.0, 6.0)    (3.0, 3.0)    (2.0, 2.0)    (10.0, 10.0)

end program example_shuffle

program example_fmt_constants
  use stdlib_kinds, only: int32, int64, sp, dp
  use stdlib_io, only: FMT_INT, FMT_REAL_SP, FMT_REAL_DP, FMT_COMPLEX_SP, FMT_COMPLEX_DP
  implicit none

  integer(kind=int32) :: i32
  integer(kind=int64) :: i64
  real(kind=sp)       :: r32
  real(kind=dp)       :: r64
  complex(kind=sp)    :: c32
  complex(kind=dp)    :: c64

  i32 = 100_int32
  i64 = 100_int64
  r32 = 100.0_sp
  r64 = 100.0_dp
  c32 = cmplx(100.0_sp, kind=sp)
  c64 = cmplx(100.0_dp, kind=dp)

  print "(2("//FMT_INT//",1x))", i32, i64 ! outputs: 100 100
  print FMT_REAL_SP, r32                  ! outputs: 1.00000000E+02
  print FMT_REAL_DP, r64                  ! outputs: 1.0000000000000000E+002
  print FMT_COMPLEX_SP, c32               ! outputs: 1.00000000E+02  0.00000000E+00
  print FMT_COMPLEX_DP, c64               ! outputs: 1.0000000000000000E+002  0.0000000000000000E+000

end program example_fmt_constants

program example_kronecker_product
  use stdlib_linalg, only: kronecker_product
  implicit none
  integer, parameter :: m1 = 1, n1 = 2, m2 = 2, n2 = 3
  integer :: i, j
  real :: A(m1, n1), B(m2,n2)
  real, allocatable :: C(:,:)

  do j = 1, n1
     do i = 1, m1
        A(i,j) = i*j ! A = [1, 2]
     end do
  end do
  
  do j = 1, n2
     do i = 1, m2      ! B = [ 1, 2, 3 ]
        B(i,j) = i*j !     [ 2, 4, 6 ]
     end do
  end do
  
  C = kronecker_product(A, B)
  ! C =     [ a(1,1) * B(:,:) | a(1,2) * B(:,:) ]
  ! or in other words, 
  ! C =     [  1.00      2.00      3.00      2.00      4.00      6.00  ]
  !         [  2.00      4.00      6.00      4.00      8.00     12.00  ]
end program example_kronecker_product

program example_solve_pcg
    use stdlib_kinds, only: int8, dp
    use stdlib_sparse
    use stdlib_linalg_iterative_solvers, only: stdlib_solve_pcg

    type(CSR_dp_type) :: laplacian_csr
    type(COO_dp_type) :: COO
    real(dp) :: laplacian(5,5)
    real(dp) :: x(5), rhs(5)
    logical(int8) :: dirichlet(5)

    laplacian = reshape( [1, -1,  0,  0,  0,&
                         -1,  2, -1,  0,  0,&
                          0, -1,  2, -1,  0,&
                          0,  0, -1,  2, -1,&
                          0,  0,  0, -1,  1] , [5,5])
    call dense2coo(laplacian,COO)
    call coo2csr(COO,laplacian_csr)

    x = 0._dp
    rhs = real( [0,0,5,0,0], kind=dp )

    dirichlet = .false._int8
    dirichlet([1,5]) = .true._int8

    call stdlib_solve_pcg(laplacian, rhs, x, rtol=1.d-6, di=dirichlet)
    print *, x !> solution: [0.0, 2.5, 5.0, 2.5, 0.0]
    x = 0._dp

    call stdlib_solve_pcg(laplacian_csr, rhs, x, rtol=1.d-6, di=dirichlet)
    print *, x !> solution: [0.0, 2.5, 5.0, 2.5, 0.0]
end program

program example_optval
  use stdlib_optval, only: optval
  implicit none
  print *, root(64.0)
! 8.0
  print *, root(64.0, 3)
! 4.0
contains
  real function root(x, n)
    real, intent(in) :: x
    integer, intent(in), optional :: n
    root = x**(1.0/optval(n, 2))
  end function root
end program example_optval

program example_normal_cdf
  use stdlib_random, only: random_seed
  use stdlib_stats_distribution_normal, only: norm_cdf => cdf_normal, &
                                              norm => rvs_normal

  implicit none
  real, dimension(2, 3, 4) :: x, mu, sigma
  real :: xsum
  complex :: loc, scale
  integer :: seed_put, seed_get, i

  seed_put = 1234567
  call random_seed(seed_put, seed_get)

  ! standard normal cumulative probability at x=0.0
  print *, norm_cdf(0.0, 0.0, 1.0)
  ! 0.500000000

  ! cumulative probability at x=2.0 with mu=-1.0 sigma=2.0
  print *, norm_cdf(2.0, -1.0, 2.0)
  ! 0.933192849

  ! cumulative probability at x=1.0 with mu=1.0 and sigma=-1.0 (out of range) 
  print *, norm_cdf(1.0, 1.0, -1.0)
  ! NaN

  ! standard normal random variates array
  x = reshape(norm(0.0, 1.0, 24), [2, 3, 4])

  ! standard normal cumulative array
  mu(:, :, :) = 0.0
  sigma(:, :, :) = 1.0
  print *, norm_cdf(x, mu, sigma)        
  !  0.713505626     0.207069695  0.486513376  0.424511284  0.587328553
  !  0.335559726     0.401470929  0.806552052  0.866687536  0.371323735
  !  0.866228044     0.898046613  0.198435277  0.141147852  0.681565762
  !  0.206268221     0.627057910  0.580759525  0.190364420  7.27325380E-02
  !  7.08068311E-02  0.728241026  0.522919059  0.390097380

   ! cumulative probability array where sigma<=0.0 for certain elements 
  print *, norm_cdf([1.0, 1.0, 1.0], [1.0, 1.0, 1.0], [1.0, 0.0, -1.0])
  ! 0.500000000  NaN NaN

  ! `cdf_normal` is pure and, thus, can be called concurrently 
  xsum = 0.0
  do concurrent (i=1:size(x,3))
    xsum = xsum + sum(norm_cdf(x(:,:,i), mu(:,:,i), sigma(:,:,i)))
  end do
  print *, xsum
  ! 11.3751936

  ! complex normal cumulative distribution at x=(0.5,-0.5) with real part of
  ! mu=1.0, sigma=0.5 and imaginary part of mu=0.0, sigma=1.0
  loc = (1.0, 0.0)
  scale = (0.5, 1.0)
  print *, norm_cdf((0.5, -0.5), loc, scale)
  ! 4.89511043E-02

end program example_normal_cdf

program example_remove
  use stdlib_kinds, only: int8, int64
  use stdlib_hashmaps, only: open_hashmap_type
  use stdlib_hashmap_wrappers, only: key_type, set
  implicit none
  type(open_hashmap_type) :: map
  type(key_type)      :: key
  logical             :: existed
  integer             :: int_scalar
  
  ! Initialize hashmap with 2^10 slots.
  ! Hashmap will dynamically increase size if needed.
  call map%init(slots_bits=10)
  ! Explicitly set key type using set function
  call set(key, [1, 2, 3])
  call map%map_entry(key, 4.0)
  call map%remove(key, existed)
  print *, "Removed key existed = ", existed
  
  ! Using map_entry and remove int32 generic interface.
  call map%map_entry([1, 2, 3], 4.0)
  call map%remove([1, 2, 3], existed)
  print *, "Removed key existed = ", existed
  
  ! Integer scalars need to be passed as an array.
  int_scalar = 1
  call map%map_entry( [int_scalar], 4.0)
  call map%remove( [int_scalar], existed)
  print *, "Removed key existed = ", existed
  
  ! Using map_entry and remove character generic interface.
  call map%map_entry('key_string', 4.0)
  call map%remove('key_string', existed)
  print *, "Removed key existed = ", existed
  
  ! Use transfer to int8 arrays for unsupported key types.
  call map%map_entry( transfer( [1_int64, 2_int64], [0_int8] ), 4.0)
  call map%remove( transfer( [1_int64,2_int64], [0_int8] ), existed)
  print *, "Removed key existed = ", existed
end program example_remove

program example_log_factorial
  use stdlib_kinds, only: int64
  use stdlib_specialfunctions_gamma, only: lf => log_factorial
  implicit none
  integer :: n

  n = 10
  print *, lf(n)

! 15.1044130

  print *, lf(35_int64)

! 92.1361771
end program example_log_factorial

module test_linspace
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_kinds, only: sp, dp, int8, int16
    use stdlib_math, only: linspace, DEFAULT_LINSPACE_LENGTH

    implicit none
    private

    public :: collect_linspace

    real(sp), parameter :: TOLERANCE_SP = 1000 * epsilon(1.0_sp)
    real(dp), parameter :: TOLERANCE_DP = 1000 * epsilon(1.0_dp) ! Percentage of the range for which the actual gap must not exceed

    ! Testing linspace.
    !
    ! For single and double precision, check if the beginning and end values are properly recorded
    ! and make sure that the size of the result array is as expected.
    !
    ! This testing suite makes use of the a repeated section of code that will check to make
    ! sure that every element is linearly spaced (i.e., call check(|array(i+1) - array(i)| < |expected_value| * TOLERANCE)).
    ! I would convert this repeated code into a subroutine but that would require the implementation of a
    ! generic procedure given that each linear space will have a different expected_value type and kind.

contains

    !> Collect all exported unit tests
    subroutine collect_linspace(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("linspace_sp", test_linspace_sp), &
            new_unittest("linspace_dp", test_linspace_dp), &
            new_unittest("linspace_neg_index", test_linspace_neg_index), &
            new_unittest("linspace_cmplx", test_linspace_cmplx), &
            new_unittest("linspace_cmplx_2", test_linspace_cmplx_2), &
            new_unittest("linspace_cmplx_3", test_linspace_cmplx_3), &
            new_unittest("linspace_cmplx_sp", test_linspace_cmplx_sp), &
            new_unittest("linspace_cmplx_sp_2", test_linspace_cmplx_sp_2), &
            new_unittest("linspace_int16", test_linspace_int16), &
            new_unittest("linspace_int8", test_linspace_int8) &
            ]

    end subroutine collect_linspace


    subroutine test_linspace_sp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer, parameter :: n = 20
        real(sp), parameter :: start = 1.0_sp
        real(sp), parameter :: end = 10.0_sp
        real(sp) :: expected_interval
        real(sp) :: true_difference

        integer :: i
        real(sp), allocatable :: x(:)

        x = linspace(start, end, n)

        expected_interval =( end - start ) / real(( n - 1 ), sp)

        call check(error, x(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, x(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return
        call check(error, size(x), n, "Array not allocated to appropriate size")
        if (allocated(error)) return

        print *, "Made it through first round of tests"

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            true_difference = x(i + 1) - x(i)
            call check(error, abs(true_difference - expected_interval) < abs(expected_interval) * TOLERANCE_SP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_dp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        real(dp), parameter :: start = 1.0_dp
        real(dp), parameter :: end = 10.0_dp
        integer, parameter :: n = DEFAULT_LINSPACE_LENGTH
        real(dp) :: expected_interval
        real(dp) :: true_difference

        real(dp), allocatable :: x(:)
        integer :: i

        x = linspace(start, end)

        expected_interval =( end - start ) / ( n - 1 )

        call check(error, size(x), n, "Array not allocated to default size")
        if (allocated(error)) return
        call check(error, x(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, x(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            true_difference = x(i + 1) - x(i)
            call check(error, true_difference, expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_neg_index(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        real(dp), parameter :: start = 1.0_dp
        real(dp), parameter :: end = 10.0_dp

        real(dp), allocatable :: x(:)

        x = linspace(start, end, -15)

        call check(error, size(x), 0, "Allocated array is not empty")

    end subroutine

    subroutine test_linspace_cmplx(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        complex(dp), parameter :: start = (0.0_dp, 10.0_dp)
        complex(dp), parameter :: end = (1.0_dp, 0.0_dp)
        complex(dp) :: expected_interval
        integer, parameter :: n = 10

        complex(dp), allocatable :: z(:)

        integer :: i

        z = linspace(start, end, n)

        expected_interval =( end - start ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to correct size")
        if (allocated(error)) return
        call check(error, z(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            call check(error, z(i + 1) - z(i), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_cmplx_2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        complex(dp), parameter :: start = (10.0_dp, 10.0_dp)
        complex(dp), parameter :: end = (1.0_dp, 1.0_dp)
        complex(dp) :: expected_interval

        integer, parameter :: n = 5

        complex(dp), allocatable :: z(:)

        integer :: i

        z = linspace(start, end, n)

        expected_interval =( end - start ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to correct size")
        if (allocated(error)) return
        call check(error, z(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            call check(error, z(i + 1) - z(i), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_cmplx_3(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        complex(dp), parameter :: start = (-5.0_dp, 100.0_dp)
        complex(dp), parameter :: end = (20.0_dp, 13.0_dp)
        complex(dp) :: expected_interval

        integer, parameter :: n = 20

        complex(dp), allocatable :: z(:)

        integer :: i

        z = linspace(start, end, n)

        expected_interval = ( end - start ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to correct size")
        if (allocated(error)) return
        call check(error, z(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            call check(error, z(i + 1) - z(i), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_cmplx_sp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        complex(sp), parameter :: start = (0.5_sp, 5.0_sp)
        complex(sp), parameter :: end = (1.0_sp, -30.0_sp)
        complex(sp) :: expected_interval

        integer, parameter :: n = 10

        complex(sp), allocatable :: z(:)

        integer :: i

        z = linspace(start, end, n)

        expected_interval =( end - start ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to correct size")
        if (allocated(error)) return
        call check(error, z(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            call check(error, z(i + 1) - z(i), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_SP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_cmplx_sp_2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        complex(sp), parameter :: start = (50.0_sp, 500.0_sp)
        complex(sp), parameter :: end = (-100.0_sp, 2000.0_sp)
        complex(sp) :: expected_interval
        complex(sp) :: true_interval
        real(sp) :: offset

        integer, parameter :: n = DEFAULT_LINSPACE_LENGTH

        complex(sp), allocatable :: z(:)

        integer :: i

        z = linspace(start, end)

        expected_interval =( end - start ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to default size")
        if (allocated(error)) return
        call check(error, z(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            true_interval = (z(i + 1) - z(i))
            offset = abs(true_interval - expected_interval)
            call check(error, z(i + 1) - z(i), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_SP)
            if (allocated(error)) return
            ! print *, i

        end do

    end subroutine

    subroutine test_linspace_int16(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer(int16), parameter :: start = 5
        integer(int16), parameter :: end = 10
        real(dp) :: expected_interval

        integer, parameter :: n = 6

        integer(int16), allocatable :: z(:)

        integer :: i

        z = linspace(start, end, n)

        expected_interval =( end - start ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to correct size")
        if (allocated(error)) return
        call check(error, z(1), start, "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), end, "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            call check(error, real(z(i + 1) - z(i), dp), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine

    subroutine test_linspace_int8(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer(int8), parameter :: start = 20
        integer(int8), parameter :: end = 50

        real(dp) :: expected_interval

        integer, parameter :: n = 10

        real(dp), allocatable :: z(:)
        integer(int8) :: z_int(n)

        integer :: i

        z = linspace(start, end, n)
        z_int = linspace(start, end, n)

        expected_interval =real( end - start, dp ) / ( n - 1 )

        call check(error, size(z), n, "Array not allocated to correct size")
        if (allocated(error)) return
        call check(error, z(1), real(start, dp), "Initial value of array is not equal to the passed start parameter")
        if (allocated(error)) return
        call check(error, z(n), real(end, dp), "Final array value is not equal to end parameter")
        if (allocated(error)) return

        ! Due to roundoff error, it is possible that the jump from x(n-1) to x(n) is slightly different than the expected interval
        do i = 1, n-1

            call check(error, z(i + 1) - z(i), expected_interval, &
                & thr=abs(expected_interval) * TOLERANCE_DP)
            if (allocated(error)) return

        end do

    end subroutine



end module

program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_linspace, only : collect_linspace
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("linspace", collect_linspace) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program tester

program example_to_lower
  use stdlib_string_type
  implicit none
  type(string_type) :: string, lowercase_string

  string = "Lowercase This String"
! string <-- "Lowercase This String"

  lowercase_string = to_lower(string)
! string <-- "Lowercase This String"
! lowercase_string <-- "lowercase this string"
end program example_to_lower

program example_to_string
  use stdlib_strings, only: to_string
  implicit none

!> Example for `complex` type
  print *, to_string((1, 1))              !! "(1.00000000,1.00000000)"
  print *, to_string((1, 1), '(F6.2)')    !! "(  1.00,  1.00)"
  print *, to_string((1000, 1), '(ES0.2)'), to_string((1000, 1), '(SP,F6.3)')
!! "(1.00E+3,1.00)""(******,+1.000)"
!! Too narrow formatter for real number
!! Normal demonstration(`******` from Fortran Standard)

!> Example for `integer` type
  print *, to_string(-3)                  !! "-3"
  print *, to_string(42, '(I4)')          !! "  42"
  print *, to_string(1, '(I0.4)'), to_string(2, '(B4)')           !! "0001""  10"

!> Example for `real` type
  print *, to_string(1.)                  !! "1.00000000"
  print *, to_string(1., '(F6.2)')        !! "  1.00"
  print *, to_string(1., 'F6.2')          !! "  1.00"
  print *, to_string(1., '(SP,ES9.2)'), to_string(1, '(F7.3)')    !! "+1.00E+00""[*]"
!! 1 wrong demonstration (`[*]` from `to_string`)

!> Example for `logical` type
  print *, to_string(.true.)              !! "T"
  print *, to_string(.true., '(L2)')      !! " T"
  print *, to_string(.true., 'L2')        !! " T"
  print *, to_string(.false., '(I5)')     !! "[*]"
!! 1 wrong demonstrations(`[*]` from `to_string`)

end program example_to_string

! SPDX-Identifier: MIT
module test_append_prepend
    use stdlib_error, only: check
    use stdlib_string_type, only: string_type, operator(//), operator(==)
    use stdlib_stringlist_type, only: stringlist_type, fidx, bidx, list_head, &
                            & list_tail, operator(//), operator(==), operator(/=)
    use stdlib_strings, only: to_string
    implicit none    

contains

    subroutine test_append_prepend_string
        type(stringlist_type)           :: work_list
        type(stringlist_type)           :: reference_list
        integer                         :: i
        integer, parameter              :: first = -100
        integer, parameter              :: last = 100
        character(len=:), allocatable   :: string
        type(string_type)               :: all_strings(first:last)
        
        do concurrent (i=first:last)
            all_strings(i) = string_type( to_string(i) )
        end do        

        do i = first, last
            string = to_string(i)
            work_list = work_list // string
            call check( work_list%get( fidx( i - first + 1 ) ) == string_type( string ), &
                        & "test_append_prepend_string: get fidx( i - first + 1 ) " // string )

        end do

        call compare_list( work_list, first, last + 1, 1 )
        call check( work_list == all_strings, &
                        & "test_append_prepend_string: work_list ==&
                        & [ ( string_type( to_string(i) ), i = first, last ) ]" )
        call check( all_strings == work_list, &
                        & "test_append_prepend_string: [ ( string_type( to_string(i) ),&
                        & i = first, last ) ] == work_list" )

        do i = last, first, -1
            call check( work_list /= reference_list, "test_append_prepend_string:&
                                    & work_list /= reference_list" )
            call check( reference_list /= work_list, "test_append_prepend_string:&
                                    & reference_list /= work_list" )

            string = to_string(i)
            reference_list = string_type( string ) // reference_list
            call check( reference_list%get( bidx( last - i + 1 ) ) == string, &
                                    & "test_append_prepend_string: get bidx( last - i + 1 ) " // string )

        end do

        call compare_list( reference_list, first, last + 1, 2 )
        call check( reference_list == all_strings, "test_append_prepend_string:&
                    & reference_list == [ ( string_type( to_string(i) ), i = first, last ) ]" )
        call check( all_strings == reference_list, &
                    & "test_append_prepend_string: [ ( string_type( to_string(i) ), i = first, last ) ] == reference_list" )

        call check( work_list == reference_list, "test_append_prepend_string:&
                                    & work_list == reference_list" )
        call check( reference_list == work_list, "test_append_prepend_string:&
                                    & reference_list == work_list" )

    end subroutine test_append_prepend_string

    subroutine test_append_prepend_array
        type(stringlist_type)           :: work_list
        type(stringlist_type)           :: reference_list
        integer                         :: i, j
        integer, parameter              :: first = -100
        integer, parameter              :: last = 100
        integer, parameter              :: stride = 10
        type(string_type)               :: all_strings(first:last)
        
        do concurrent (j=first:last)
            all_strings(j) = string_type( to_string(j) )
        end do   

        do i = first, last - 1, stride
            work_list = work_list // all_strings(i:i+stride-1)
            call check( work_list == all_strings(first:i+stride-1), &
                    & "test_append_prepend_array: work_list ==&
                    & [ ( string_type( to_string(j) ), j = first, i + stride - 1) ]" )

        end do

        work_list = work_list // to_string(last)

        call compare_list( work_list, first, last + 1, 3 )
        call check( work_list == all_strings, &
                    & "test_append_prepend_array: work_list ==&
                    & [ ( string_type( to_string(i) ), i = first, last) ]" )
        call check( all_strings == work_list, &
                    & "test_append_prepend_array: [ ( string_type( to_string(i) ), i = first, last) ]&
                    & == work_list" )

        do i = last, first + 1, -1 * stride
            call check( work_list /= reference_list, "test_append_prepend_array:&
                                    & work_list /= reference_list" )
            call check( reference_list /= work_list, "test_append_prepend_array:&
                                    & reference_list /= work_list" )

            reference_list = all_strings(i-stride+1:i) // reference_list
            call check( reference_list == all_strings(i-stride+1:last), &
                            & "test_append_prepend_array: reference_list ==&
                            & [ ( string_type( to_string(j) ), j = i - stride + 1, last ) ]" )

        end do

        reference_list = to_string(first) // reference_list

        call compare_list( reference_list, first, last + 1, 4 )
        call check( all_strings == reference_list, &
                    & "test_append_prepend_array:&
                    & [ ( string_type( to_string(i) ), i = first, last) ] == reference_list" )
        call check( all_strings == reference_list, &
                    & "test_append_prepend_array: [ ( string_type( to_string(i) ), i = first, last) ]&
                    & == reference_list" )

        call check( work_list == reference_list, "test_append_prepend_array:&
                                    & work_list == reference_list" )
        call check( reference_list == work_list, "test_append_prepend_array:&
                                    & reference_list == work_list" )

    end subroutine test_append_prepend_array

    subroutine test_append_prepend_list
        type(stringlist_type)           :: work_list, reference_list
        type(stringlist_type)           :: temp_list
        integer                         :: i, j
        integer, parameter              :: first = -100
        integer, parameter              :: last = 100
        integer, parameter              :: stride = 10
        type(string_type)               :: all_strings(first:last)
        
        do concurrent (j=first:last)
            all_strings(j) = string_type( to_string(j) )
        end do   

        do i = first, last - 1, stride
            call temp_list%clear()
            do j = i, i + stride - 1
                call temp_list%insert_at( list_tail, string_type( to_string(j) ) )
            end do
            work_list = work_list // temp_list
            
            call check( work_list == all_strings(first:i+stride-1), &
                    & "test_append_prepend_list: work_list ==&
                    & [ ( to_string(j), j = first, i + stride - 1) ]" )

        end do

        work_list = work_list // to_string(last)

        call compare_list( work_list, first, last + 1, 5 )
        call check( work_list == all_strings, "test_append_prepend_list:&
                    & work_list == [ ( string_type( to_string(i) ), i = first, last) ]" )
        call check( all_strings == work_list, &
                    & "test_append_prepend_list: [ ( string_type( to_string(i) ), i = first, last) ]&
                    & == work_list" )

        do i = last, first + 1, -1 * stride
            call check( work_list /= reference_list, "test_append_prepend_list:&
                                    & work_list /= reference_list" )
            call check( reference_list /= work_list, "test_append_prepend_list:&
                                    & reference_list /= work_list" )

            call temp_list%clear()
            do j = i - stride + 1, i
                call temp_list%insert_at( list_tail, to_string(j) )
            end do
            reference_list = temp_list // reference_list

            call check( reference_list == &
                            & all_strings(i-stride+1:last), &
                            & "test_append_prepend_list: reference_list ==&
                            & [ ( string_type( to_string(j) ), j = i - stride + 1, last ) ]" )

        end do

        reference_list = to_string(first) // reference_list

        call compare_list( reference_list, first, last + 1, 6 )
        call check( all_strings == reference_list, &
                    & "test_append_prepend_list:&
                    & [ ( string_type( to_string(i) ), i = first, last) ] == reference_list" )
        call check( all_strings == reference_list, &
                    & "test_append_prepend_list: [ ( string_type( to_string(i) ), i = first, last) ]&
                    & == reference_list" )

        call check( work_list == reference_list, "test_append_prepend_list:&
                                    & work_list == reference_list" )
        call check( reference_list == work_list, "test_append_prepend_list:&
                                    & reference_list == work_list" )

    end subroutine test_append_prepend_list

    ! compares input stringlist 'list' with an array of consecutive integers
    ! array is 'first' inclusive and 'last' exclusive
    subroutine compare_list(list, first, last, call_number)
        type(stringlist_type), intent(in)   :: list
        integer, intent(in)                 :: first, last, call_number
        integer                             :: i, j

        call check( abs( last - first ) == list%len(), "compare_list: length mis-match&
                                        & call_number " // to_string( call_number ) )

        j = merge(-1, 1, last < first)
        do i = 1, list%len()
            call check( list%get( fidx(i) ) == to_string( first + ( ( i - 1 ) * j ) ), &
                                    & "compare_list: call_number " // to_string( call_number ) &
                                    & // " fidx( " // to_string( i ) // " )")
            call check( list%get( bidx(i) ) == to_string( last - ( i * j ) ), &
                                    & "compare_list: call_number " // to_string( call_number ) &
                                    & // " bidx( " // to_string( i ) // " )")
        end do

    end subroutine compare_list

end module test_append_prepend


program tester
    use test_append_prepend
    implicit none
    
    call test_append_prepend_string
    call test_append_prepend_array
    call test_append_prepend_list

end program tester

program example_get_other_data
  use stdlib_kinds, only: int8, int64
  use stdlib_hashmaps, only: chaining_hashmap_type, int_index
  use stdlib_hashmap_wrappers, only: key_type, set
  implicit none
  logical                     :: conflict
  type(key_type)              :: key
  type(chaining_hashmap_type) :: map
  type dummy_type
    integer                   :: value(4)
  end type dummy_type
  type(dummy_type) :: dummy
  class(*), allocatable       :: data
  integer(int8), allocatable  :: key_array(:)
  integer                     :: int_scalar
  
  ! Hashmap functions are setup to store scalar value types (other).  Use a dervied
  ! type wrapper to store arrays.
  dummy%value = [4, 3, 2, 1]
  
  ! Explicitly set key type using set function
  call set(key, [0, 1])
  call map%map_entry(key, dummy, conflict)
  if (.not. conflict) then
    call map%get_other_data(key, data)
  else
    error stop 'Key is already present in the map.'
  end if
  
  ! Get_other_data returns data as an unlimited polymorphic scalar.  
  ! To use this type in other operations, there must be a select type operation.
  select type (data)
  type is (dummy_type)
    print *, 'Other data % value = ', data%value
  class default
    print *, 'Invalid data type in other'
  end select
  
! Also can use map_entry and get_other_data generic key interfaces.   
! This is an exmple with integer arrays.  
  call map%map_entry( [2,3], dummy, conflict)
  if (.not. conflict) then
    call map%get_other_data( [2,3], data)
  else
    error stop 'Key is already present in the map.'
  end if
  
  select type (data)
  type is (dummy_type)
    print *, 'Other data % value = ', data%value
  class default
    print *, 'Invalid data type in other'
  end select
  
  ! Integer scalar keys need to be passed as an array.   
  int_scalar = 2
  call map%map_entry( [int_scalar], dummy, conflict)
  if (.not. conflict) then
    call map%get_other_data( [int_scalar], data)
  else
    error stop 'Key is already present in the map.'
  end if
  
  select type (data)
  type is (dummy_type)
    print *, 'Other data % value = ', data%value
  class default
    print *, 'Invalid data type in other'
  end select
  
  ! Example using character type key interface
  call map%map_entry( 'key_string', dummy, conflict)
  if (.not. conflict) then
    call map%get_other_data( 'key_string', data)
  else
    error stop 'Key is already present in the map.'
  end if
  
  select type (data)
  type is (dummy_type)
    print *, 'Other data % value = ', data%value
  class default
    print *, 'Invalid data type in other'
  end select
  
! Transfer to int8 arrays to generate key for unsupported types.  
  key_array = transfer( [0_int64, 1_int64], [0_int8] )
  call map%map_entry( key_array, dummy, conflict)
  if (.not. conflict) then
    call map%get_other_data( key_array, data)
  else
    error stop 'Key is already present in the map.'
  end if
  
  select type (data)
  type is (dummy_type)
    print *, 'Other data % value = ', data%value
  class default
    print *, 'Invalid data type in other'
  end select
  
end program example_get_other_data

program example_probes
  use stdlib_hashmaps, only: chaining_hashmap_type
  implicit none
  type(chaining_hashmap_type) :: map
  integer :: nprobes
  call map%init()
  nprobes = map%map_probes()
  print *, "Initial probes =  ", nprobes
end program example_probes

module test_varn
  use, intrinsic :: ieee_arithmetic, only: ieee_is_nan
  use stdlib_kinds, only: sp, dp, int32
  use stdlib_stats, only: var
  use testdrive, only: new_unittest, unittest_type, error_type, check
  implicit none

  private
  public :: collect_varn, initialize_test_data

  real(sp), parameter :: sptol = 1000 * epsilon(1._sp)
  real(dp), parameter :: dptol = 1000 * epsilon(1._dp)

  integer(int32) :: i321(5) = [1, 2, 3, 4, 5]

  integer(int32), allocatable :: i32(:,:), i323(:,:,:)

  real(sp) :: s1(5) = [1._sp, 2._sp, 3._sp, 4._sp, 5._sp]
  real(dp) :: d1(5) = [1._dp, 2._dp, 3._dp, 4._dp, 5._dp]

  real(sp), allocatable :: s(:,:), s3(:,:,:)
  real(dp), allocatable :: d3(:,:,:)
  real(dp) :: d(4,3) = reshape([1._dp, 3._dp, 5._dp, 7._dp, &
                                2._dp, 4._dp, 6._dp, 8._dp, &
                                9._dp, 10._dp, 11._dp, 12._dp], [4, 3])

  complex(dp) :: cd1(5) = [(0.57706_dp, 0.00000_dp), &
                           (0.00000_dp, 1.44065_dp), &
                           (1.26401_dp, 0.00000_dp), &
                           (0.00000_dp, 0.88833_dp), &
                           (1.14352_dp, 0.00000_dp)]
  complex(dp) :: cd(5,3)

contains

  subroutine initialize_test_data()

    s = d
    i32 = d

    allocate(s3(size(s, 1),size(s, 2),3))
    s3(:,:,1) = s
    s3(:,:,2) = s * 2
    s3(:,:,3) = s * 4

    allocate(d3(size(d, 1),size(d, 2),3))
    d3(:,:,1) = d
    d3(:,:,2) = d * 2
    d3(:,:,3) = d * 4

    allocate(i323(size(i32, 1),size(i32, 2),3))
    i323(:,:,1) = i32
    i323(:,:,2) = i32 * 2
    i323(:,:,3) = i32 * 4

    cd(:,1) = cd1
    cd(:,2) = cd1 * 3_sp
    cd(:,3) = cd1 * 1.5_sp

  end subroutine initialize_test_data

  !> Collect all exported unit tests
  subroutine collect_varn(testsuite)
    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)

    testsuite = [ &
      new_unittest('varn_sp_1dim', test_sp_1dim), &
      new_unittest('varn_sp_1dim_mask', test_sp_1dim_mask), &
      new_unittest('varn_sp_1dim_mask_array', test_sp_1dim_mask_array), &
      new_unittest('varn_sp_2dim', test_sp_2dim), &
      new_unittest('varn_sp_2dim_mask', test_sp_2dim_mask), &
      new_unittest('varn_sp_2dim_mask_array', test_sp_2dim_mask_array), &
      new_unittest('varn_sp_3dim', test_sp_3dim), &
      new_unittest('varn_sp_3dim_mask', test_sp_3dim_mask), &
      new_unittest('varn_sp_3dim_mask_array', test_sp_3dim_mask_array), &
      new_unittest('varn_dp_1dim', test_dp_1dim), &
      new_unittest('varn_dp_1dim_mask', test_dp_1dim_mask), &
      new_unittest('varn_dp_1dim_mask_array', test_dp_1dim_mask_array), &
      new_unittest('varn_dp_2dim', test_dp_2dim), &
      new_unittest('varn_dp_2dim_mask', test_dp_2dim_mask), &
      new_unittest('varn_dp_2dim_mask_array', test_dp_2dim_mask_array), &
      new_unittest('varn_dp_3dim', test_dp_3dim), &
      new_unittest('varn_dp_3dim_mask', test_dp_3dim_mask), &
      new_unittest('varn_dp_3dim_mask_array', test_dp_3dim_mask_array), &
      new_unittest('varn_int32_1dim', test_int32_1dim), &
      new_unittest('varn_int32_1dim_mask', test_int32_1dim_mask), &
      new_unittest('varn_int32_1dim_mask_array', test_int32_1dim_mask_array), &
      new_unittest('varn_int32_2dim', test_int32_2dim), &
      new_unittest('varn_int32_2dim_mask', test_int32_2dim_mask), &
      new_unittest('varn_int32_2dim_mask_array', test_int32_2dim_mask_array), &
      new_unittest('varn_int32_3dim', test_int32_3dim), &
      new_unittest('varn_int32_3dim_mask', test_int32_3dim_mask), &
      new_unittest('varn_int32_3dim_mask_array', test_int32_3dim_mask_array), &
      new_unittest('varn_cdp_1dim', test_cdp_1dim), &
      new_unittest('varn_cdp_1dim_mask', test_cdp_1dim_mask), &
      new_unittest('varn_cdp_1dim_mask_array', test_cdp_1dim_mask_array), &
      new_unittest('varn_cdp_2dim', test_cdp_2dim), &
      new_unittest('varn_cdp_2dim_mask', test_cdp_2dim_mask), &
      new_unittest('varn_cdp_2dim_mask_array', test_cdp_2dim_mask_array) &
    ]

  end

  subroutine test_sp_1dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(s1, corrected=.false.) - 2.5*(4./5.)) < sptol)
    call check(error, abs(var(s1, dim=1, corrected=.false.) - 2.5*(4./5.)) < sptol)
  end

  subroutine test_sp_1dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(s1, .false., corrected=.false.)))
    call check(error, ieee_is_nan(var(s1, 1, .false., corrected=.false.)))
  end

  subroutine test_sp_1dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(s1, s1 < 5, corrected=.false.) - 5./4.) < sptol)
    call check(error, ieee_is_nan((var(s1, s1 < 0., corrected=.false.))))
    call check(error, abs(var(s1, s1 == 1., corrected=.false.)) < sptol)
    call check(error, abs(var(s1, 1, s1 < 5, corrected=.false.) - 5./4.) < sptol)
  end

  subroutine test_sp_2dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(s, corrected=.false.) - 13.*11./12.) < sptol)
    call check(error, all(abs(var(s, 1, corrected=.false.) &
                              - [20., 20., 5.]/4.) < sptol))
    call check(error, all(abs(var(s, 2, corrected=.false.) &
                              - [19., 43./3., 31./ 3., 7.0]*2./3.) < sptol))
  end

  subroutine test_sp_2dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(s, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(s, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(s, 2, .false., corrected=.false.))))
  end

  subroutine test_sp_2dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(s, s < 11, corrected=.false.) - 2.75*3.) < sptol)
    call check(error, all(abs(var(s, 1, s < 11, corrected=.false.) &
                              - [5., 5., 0.25]) < sptol))
    call check(error, all(abs(var(s, 2, s < 11, corrected=.false.) &
                              - [19.0*2./3., 43./9.*2., 0.25 , 0.25]) < sptol))
  end

  subroutine test_sp_3dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(s3, corrected=.false.) - 153.4*35./36.) < sptol)
    call check(error, all(abs(var(s3, 1, corrected=.false.) -&
                 reshape([20. / 3., 20. / 3., 5. / 3.,&
                          4* 20. / 3., 4* 20. / 3., 4* 5. / 3.,&
                          16* 20. / 3., 16* 20. / 3., 16* 5. / 3.],&
                          [size(s3, 2), size(s3, 3)])*3./4.)&
                 < sptol))
    call check(error, all(abs(var(s3, 2, corrected=.false.) -&
                 reshape([19.0, 43. / 3., 31. / 3. , 7.0,&
                          4* 19.0, 4* 43. / 3., 4* 31. / 3. , 4* 7.0,&
                          16* 19.0, 16* 43. / 3., 16* 31. / 3. , 16* 7.0],&
                          [size(s3, 1), size(s3, 3)])*2./3.)&
                 < sptol))
    call check(error, all(abs(var(s3, 3, corrected=.false.) -&
                 reshape([ 7./3., 21., 175./3.,&
                           343./3., 28./3., 112./3.,&
                           84., 448./3., 189.,&
                           700./3., 847./3., 336.], [size(s3,1), size(s3,2)] )*2./3.)&
                 < sptol))
  end

  subroutine test_sp_3dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(s3, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(s3, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(s3, 2, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(s3, 3, .false., corrected=.false.))))
  end

  subroutine test_sp_3dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(s3, s3 < 11, corrected=.false.) - 7.73702383_sp) < sptol)
    call check(error, all( abs( var(s3, 1, s3 < 45, corrected=.false.) -&
                  reshape([5., 5., 1.25,  20., 20., 5., 80., 80., 32./3.],&
                  [size(s3, 2), size(s3, 3)])) < sptol ))
    call check(error, all( abs( var(s3, 2, s3 < 45, corrected=.false.) -&
                  reshape([ 38./3., 86./9., 6.88888931, 14./3., 152./3.,&
                            38.2222214, 27.5555573, 18.6666660, 202.666672,&
                            152.888885, 110.222229, 4.&
                           ],&
                  [size(s3, 1), size(s3, 3)])) < sptol ))
    call check(error, all( abs( var(s3, 3, s3 < 45, corrected=.false.) -&
                 reshape([1.555555, 14., 38.888888, 76.222222, 6.2222222,&
                          24.888888, 56., 99.5555, 126., 155.555555, 188.22222, 36.&
                           ], [size(s3,1), size(s3,2)] ))&
                 < sptol ))
  end

  subroutine test_dp_1dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(d1, corrected=.false.) - 2.5_dp*(4._dp/5.)) < dptol)
    call check(error, abs(var(d1, dim=1, corrected=.false.) - 2.5_dp*(4._dp/5.)) < dptol)
  end

  subroutine test_dp_1dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(d1, .false., corrected=.false.)))
    call check(error, ieee_is_nan(var(d1, 1, .false., corrected=.false.)))
  end

  subroutine test_dp_1dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(d1, d1 < 5, corrected=.false.) - 5._dp/4.) < dptol)
    call check(error, ieee_is_nan((var(d1, d1 < 0, corrected=.false.))))
    call check(error, abs(var(d1, d1 == 1, corrected=.false.)) < dptol)
    call check(error, abs(var(d1, 1, d1 < 5, corrected=.false.) - 5._dp/4.) < dptol)
  end

  subroutine test_dp_2dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(d, corrected=.false.) - 13._dp*11./12.) < dptol)
    call check(error, all( abs( var(d, 1, corrected=.false.) - [20., 20., 5.]/4._dp) < dptol))
    call check(error, all( abs( var(d, 2, corrected=.false.) -&
                      [38._dp, 86._dp / 3._dp, 62._dp / 3._dp , 14._dp]/3._dp) < dptol))
  end

  subroutine test_dp_2dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(d, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(d, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(d, 2, .false., corrected=.false.))))
  end

  subroutine test_dp_2dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(d, d < 11, corrected=.false.) - 2.75_dp*3._dp) < dptol)
    call check(error, all( abs( var(d, 1, d < 11, corrected=.false.) -&
                      [5._dp, 5._dp, 0.25_dp]) < dptol))
    call check(error, all( abs( var(d, 2, d < 11, corrected=.false.) -&
                      [38._dp/3., 86._dp/9., 0.25_dp , 0.25_dp]) < dptol))
  end

  subroutine test_dp_3dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(d3, corrected=.false.) - 153.4_dp*35._dp/36._dp) < dptol)
    call check(error, all( abs( var(d3, 1, corrected=.false.) -&
                 reshape([20._dp , 20._dp , 5._dp ,&
                          4* 20._dp , 4* 20._dp , 4* 5._dp ,&
                          16* 20._dp , 16* 20._dp , 16* 5._dp ],&
                          [size(d3,2), size(d3,3)])/4._dp)&
                 < dptol))
    call check(error, all( abs( var(d3, 2, corrected=.false.) -&
                 reshape([38._dp, 86. / 3._dp, 62. / 3._dp , 14._dp,&
                          8* 19._dp, 8* 43. / 3._dp, 8* 31. / 3._dp, 8* 7._dp,&
                          32* 19._dp, 32* 43. / 3._dp, 32* 31. / 3._dp, 32* 7._dp],&
                          [size(d3,1), size(d3,3)] )/3._dp)&
                 < dptol))
    call check(error, all(abs( var(d3, 3, corrected=.false.) -&
                 reshape([7._dp/3., 21._dp, 175._dp/3.,&
                          343._dp/3., 28._dp/3., 112._dp/3.,&
                          84._dp, 448._dp/3., 189._dp,&
                          700._dp/3., 847._dp/3., 336._dp],&
                          [size(d3, 1), size(d3, 2)] )*2._dp/3._dp)&
                 < dptol))
  end

  subroutine test_dp_3dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(d3, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(d3, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(d3, 2, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(d3, 3, .false., corrected=.false.))))
  end

  subroutine test_dp_3dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(d3, d3 < 11, corrected=.false.) -&
                     7.7370242214532876_dp) < dptol)
    call check(error, all(abs(var(d3, 1, d3 < 45, corrected=.false.) -&
                  reshape([5._dp, 5._dp, 1.25_dp,  20._dp, 20._dp, 5._dp,&
                           80._dp, 80._dp, 32._dp/3.],&
                           [size(d3, 2), size(d3, 3)])) < dptol))
    call check(error, all(abs( var(d3, 2, d3 < 45, corrected=.false.) -&
                  reshape([38._dp/3., 86._dp/9., 62._dp/9., 14._dp/3., 152._dp/3.,&
                           344._dp/9., 248._dp/9., 168._dp/9., 1824._dp/9.,&
                           1376._dp/9., 992._dp/9., 4._dp&
                           ],&
                  [size(d3, 1), size(d3, 3)])) < dptol))
    call check(error, all(abs(var(d3, 3, d3 < 45, corrected=.false.) -&
                 reshape([14._dp/9., 14._dp, 350._dp/9., 686._dp/9., 56._dp/9.,&
                          224._dp/9., 56._dp, 896._dp/9., 126._dp, 1400._dp/9.,&
                          1694._dp/9., 36._dp&
                           ], [size(d3, 1), size(d3, 2)]))&
                 < dptol ))
  end

  subroutine test_int32_1dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(i321, corrected=.false.) - 2.5_dp*(4._dp/5.)) < dptol)
    call check(error, abs(var(i321, dim=1, corrected=.false.) - 2.5_dp*(4._dp/5.)) < dptol)
  end

  subroutine test_int32_1dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(i321, .false., corrected=.false.)))
    call check(error, ieee_is_nan(var(i321, 1, .false., corrected=.false.)))
  end

  subroutine test_int32_1dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(i321, i321 < 5, corrected=.false.) - 5._dp/4.) < dptol)
    call check(error, ieee_is_nan((var(i321, i321 < 0, corrected=.false.))))
    call check(error, abs(var(i321, i321 == 1, corrected=.false.)) < dptol)
    call check(error, abs(var(i321, 1, i321 < 5, corrected=.false.) - 5._dp/4.) < dptol)
  end

  subroutine test_int32_2dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(i32, corrected=.false.) - 13._dp*11./12.) < dptol)
    call check(error, all(abs(var(i32, 1, corrected=.false.) -&
                      [20., 20., 5.]/4._dp) < dptol))
    call check(error, all(abs(var(i32, 2, corrected=.false.) -&
                      [38._dp, 86._dp / 3._dp, 62._dp / 3._dp , 14._dp]/3._dp) < dptol))
  end

  subroutine test_int32_2dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(i32, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(i32, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(i32, 2, .false., corrected=.false.))))
  end

  subroutine test_int32_2dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(i32, i32 < 11, corrected=.false.) - 2.75_dp*3._dp) < dptol)
    call check(error, all(abs(var(i32, 1, i32 < 11, corrected=.false.) -&
                      [5._dp, 5._dp, 0.25_dp]) < dptol))
    call check(error, all(abs(var(i32, 2, i32 < 11, corrected=.false.) -&
                      [38._dp/3., 86._dp/9., 0.25_dp , 0.25_dp]) < dptol))
  end

  subroutine test_int32_3dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(i323, corrected=.false.) - 153.4_dp*35._dp/36._dp) < dptol)
    call check(error, all(abs(var(i323, 1, corrected=.false.) -&
                 reshape([20._dp , 20._dp , 5._dp ,&
                          4* 20._dp , 4* 20._dp , 4* 5._dp ,&
                          16* 20._dp , 16* 20._dp , 16* 5._dp ],&
                          [size(i323,2), size(i323,3)])/4._dp)&
                 < dptol))
    call check(error, all(abs(var(i323, 2, corrected=.false.) -&
                 reshape([38._dp, 86. / 3._dp, 62. / 3._dp , 14._dp,&
                          8* 19._dp, 8* 43. / 3._dp, 8* 31. / 3._dp, 8* 7._dp,&
                          32* 19._dp, 32* 43. / 3._dp, 32* 31. / 3._dp, 32* 7._dp],&
                          [size(i323,1), size(i323,3)] )/3._dp)&
                 < dptol))
    call check(error, all(abs(var(i323, 3, corrected=.false.) -&
                 reshape([ 7._dp/3., 21._dp, 175._dp/3.,&
                           343._dp/3., 28._dp/3., 112._dp/3.,&
                           84._dp, 448._dp/3., 189._dp,&
                           700._dp/3., 847._dp/3., 336._dp],&
                           [size(i323,1), size(i323,2)] )*2._dp/3._dp)&
                 < dptol))
  end

  subroutine test_int32_3dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(i323, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(i323, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(i323, 2, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(i323, 3, .false., corrected=.false.))))
  end

  subroutine test_int32_3dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(i323, i323 < 11, corrected=.false.) -&
                     7.7370242214532876_dp) < dptol)
    call check(error, all(abs(var(i323, 1, i323 < 45, corrected=.false.) -&
                  reshape([5._dp, 5._dp, 1.25_dp,  20._dp, 20._dp, 5._dp,&
                           80._dp, 80._dp, 32._dp/3.],&
                           [size(i323, 2), size(i323, 3)])) < dptol ))
    call check(error, all(abs(var(i323, 2, i323 < 45, corrected=.false.) -&
                  reshape([ 38._dp/3., 86._dp/9., 62._dp/9., 14._dp/3., 152._dp/3.,&
                            344._dp/9., 248._dp/9., 168._dp/9., 1824._dp/9.,&
                            1376._dp/9., 992._dp/9., 4._dp&
                           ],&
                  [size(i323, 1), size(i323, 3)])) < dptol ))
    call check(error, all(abs(var(i323, 3, i323 < 45, corrected=.false.) -&
                 reshape([14._dp/9., 14._dp, 350._dp/9., 686._dp/9., 56._dp/9.,&
                          224._dp/9., 56._dp, 896._dp/9., 126._dp, 1400._dp/9.,&
                          1694._dp/9., 36._dp&
                           ], [size(i323,1), size(i323,2)] ))&
                 < dptol ))
  end

  subroutine test_cdp_1dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(cd1, corrected=.false.) -&
                 (var(real(cd1), corrected=.false.) +&
                  var(aimag(cd1), corrected=.false.))) < dptol)
    call check(error, abs(var(cd1, dim=1, corrected=.false.) -&
                 (var(real(cd1), dim=1, corrected=.false.) +&
                  var(aimag(cd1), dim=1, corrected=.false.))) < dptol)
  end

  subroutine test_cdp_1dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(cd1, .false., corrected=.false.)))
    call check(error, ieee_is_nan(var(cd1, 1, .false., corrected=.false.)))
  end

  subroutine test_cdp_1dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(cd1, cd1%im == 0, corrected=.false.) &
                          - var(cd1%re, cd1%im == 0, corrected=.false.)) < dptol)
    call check(error, abs(var(cd1, 1, cd1%im == 0, corrected=.false.) &
                          - var(cd1%re, 1, cd1%im == 0, corrected=.false.)) < dptol)
    call check(error, ieee_is_nan((var(cd1, all([cd1%re, cd1%im] == 0), &
                                       corrected=.false.))))
    call check(error, abs(var(cd1, (cd1%re > 1.2 .and. cd1%im == 0), &
                              corrected=.false.)) < dptol)
  end

  subroutine test_cdp_2dim(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(cd, corrected=.false.) &
                          - (var(cd%re, corrected=.false.) &
                          + var(cd%im, corrected=.false.))) < dptol)
    call check(error, all(abs(var(cd, 1, corrected=.false.) &
                          - (var(cd%re, 1, corrected=.false.) &
                          + var(cd%im, 1, corrected=.false.))) < dptol))
    call check(error, all(abs(var(cd, 2, corrected=.false.) &
                          - (var(cd%re, 2, corrected=.false.) &
                          + var(cd%im, 2, corrected=.false.))) < dptol))
  end

  subroutine test_cdp_2dim_mask(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, ieee_is_nan(var(cd, .false., corrected=.false.)))
    call check(error, any(ieee_is_nan(var(cd, 1, .false., corrected=.false.))))
    call check(error, any(ieee_is_nan(var(cd, 2, .false., corrected=.false.))))
  end

  subroutine test_cdp_2dim_mask_array(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error
    call check(error, abs(var(cd, cd%im == 0, corrected=.false.) &
                          - var(cd%re, cd%im == 0, corrected=.false.)) < dptol)
    call check(error, all(abs(var(cd, 1, cd%im == 0, corrected=.false.) &
                          - var(cd%re, 1, cd%im == 0, corrected=.false.)) < dptol))
    call check(error, any(ieee_is_nan(var(cd, 2, cd%im == 0, corrected=.false.))))
  end

end module test_varn


program tester
  use, intrinsic :: iso_fortran_env, only: error_unit
  use testdrive, only: run_testsuite, new_testsuite, testsuite_type
  use test_varn, only: collect_varn, initialize_test_data
  implicit none
  integer :: stat, is
  type(testsuite_type), allocatable :: testsuites(:)
  character(len=*), parameter :: fmt = '("#", *(1x, a))'

  stat = 0

  testsuites = [ &
    new_testsuite('varn', collect_varn) &
  ]

  call initialize_test_data()

  do is = 1, size(testsuites)
    write(error_unit, fmt) "Testing:", testsuites(is)%name
    call run_testsuite(testsuites(is)%collect, error_unit, stat)
  end do

  if (stat > 0) then
    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
    error stop
  end if

end program tester

program example_getrf
  use stdlib_linalg, only: eye
  use stdlib_linalg_lapack, only: dp,ilp,getrf
  implicit none
  real(dp) :: A(3, 3)
  integer(ilp) :: ipiv(3),info
  
  A = eye(3)
  
  ! LAPACK matrix factorization interface (overwrite result)
  call getrf(size(A,1),size(A,2),A,size(A,1),ipiv,info)
  print *, info ! info==0: Success!

end program example_getrf

! Demonstrate usage of (non-cached) runtime OS query
program example_get_runtime_os
    use stdlib_system, only: OS_NAME, get_runtime_os
    implicit none

    ! Runtime OS detection (full inspection)
    print *, "Runtime OS Type: ", OS_NAME(get_runtime_os())

end program example_get_runtime_os

program example_arg_select
  use stdlib_selection, only: arg_select
  implicit none

  real, allocatable :: array(:)
  integer, allocatable :: indx(:)
  integer :: kth_smallest
  integer :: k

  array = [3., 2., 7., 4., 5., 1., 4., -1.]
  indx = [(k, k=1, size(array))]

  k = 2
  call arg_select(array, indx, k, kth_smallest)
  print *, array(kth_smallest) ! print 1.0

  k = 7
! Due to the previous call to arg_select, we know for sure this is in an
! index >= 2
  call arg_select(array, indx, k, kth_smallest, left=2)
  print *, array(kth_smallest) ! print 5.0

  k = 6
! Due to the previous two calls to arg_select, we know for sure this is in
! an index >= 2 and <= 7
  call arg_select(array, indx, k, kth_smallest, left=2, right=7)
  print *, array(kth_smallest) ! print 4.0

end program example_arg_select

! SPDX-Identifier: MIT

module test_colors
    use stdlib_ansi, only : fg_color_red, bg_color_yellow, style_bold, to_string
    use testdrive, only : new_unittest, unittest_type, error_type, check
    implicit none

contains

    !> Collect all exported unit tests
    subroutine collect_colors(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("fg_color", test_fg_color), &
            new_unittest("bg_color", test_bg_color), &
            new_unittest("style", test_style) &
            ]
    end subroutine collect_colors

    subroutine test_fg_color(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=:), allocatable :: str

        str = to_string(fg_color_red)
        call check(error, iachar(str(1:1)), 27)
        if (allocated(error)) return
        call check(error, str(2:), "[0;31m")
    end subroutine test_fg_color

    subroutine test_bg_color(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=:), allocatable :: str

        str = to_string(bg_color_yellow)
        call check(error, iachar(str(1:1)), 27)
        if (allocated(error)) return
        call check(error, str(2:), "[0;43m")
    end subroutine test_bg_color

    subroutine test_style(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        character(len=:), allocatable :: str

        str = to_string(style_bold)
        call check(error, iachar(str(1:1)), 27)
        if (allocated(error)) return
        call check(error, str(2:), "[0;1m")
    end subroutine test_style

end module test_colors


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_colors, only : collect_colors
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("colors", collect_colors) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

program example_sum
    use stdlib_kinds, only: sp
    use stdlib_intrinsics, only: stdlib_sum, stdlib_sum_kahan
    implicit none

    real(sp), allocatable :: x(:)
    real(sp) :: total_sum(3)

    allocate( x(1000) )
    call random_number(x)

    total_sum(1) = sum(x)       !> compiler intrinsic
    total_sum(2) = stdlib_sum(x)      !> chunked summation
    total_sum(3) = stdlib_sum_kahan(x)!> chunked kahan summation
    print *, total_sum(1:3)
    
end program example_sum

! SPDX-Identifier: MIT
module test_string_to_string

    use stdlib_strings, only: to_string, to_c_char, starts_with
    use testdrive, only : new_unittest, unittest_type, error_type, check
    use stdlib_optval, only: optval
    implicit none

contains


    !> Collect all exported unit tests
    subroutine collect_string_to_string(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("to_string-complex", test_to_string_complex), &
            new_unittest("to_string-integer", test_to_string_integer), &
            new_unittest("to_string-logical", test_to_string_logical), &
            new_unittest("to_string-real", test_to_string_real), &
            new_unittest("to_string-limit-i1", test_string_i1), &
            new_unittest("to_string-limit-i2", test_string_i2), &
            new_unittest("to_string-limit-i4", test_string_i4), &
            new_unittest("to_string-limit-i8", test_string_i8), &
            new_unittest("to_c_char", test_to_c_char) &
            ]
    end subroutine collect_string_to_string

    subroutine check_formatter(error, actual, expected, description, partial)
        type(error_type), allocatable, intent(out) :: error
        character(len=*), intent(in) :: actual, expected, description
        logical, intent(in), optional :: partial
        logical :: stat
        character(len=:), allocatable :: msg

        if (optval(partial, .false.)) then
            stat = starts_with(actual, expected)
        else
            stat = actual == expected
        end if

        if (.not. stat) then
            msg = description // new_line("a") // &
                & "Expected: '" // expected // "' but got '" // actual // "'"
        else
            print '(" - ", a, /, "   Result: ''", a, "''")', description, actual
        end if

        call check(error, stat, msg)

    end subroutine check_formatter

    subroutine test_to_string_complex(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check_formatter(error, to_string((1, 1)), "(1.0", &
            & "Default formatter for complex number", partial=.true.)
        if (allocated(error)) return
        call check_formatter(error, to_string((1, 1), '(F6.2)'), "(  1.00,  1.00)", &
            & "Formatter for complex number")
        if (allocated(error)) return
        call check_formatter(error, to_string((-1, -1), 'F6.2'), "( -1.00, -1.00)", &
            & "Formatter for negative complex number")
        if (allocated(error)) return
        call check_formatter(error, to_string((1, 1), 'SP,F6.2'), "( +1.00, +1.00)", &
            & "Formatter with sign control descriptor for complex number")
        if (allocated(error)) return
        call check_formatter(error, to_string((1, 1), 'F6.2') // to_string((2, 2), '(F7.3)'), &
            & "(  1.00,  1.00)(  2.000,  2.000)", &
            & "Multiple formatters for complex numbers")

    end subroutine test_to_string_complex

    subroutine test_to_string_integer(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check_formatter(error, to_string(100), "100", &
            & "Default formatter for integer number")
        if (allocated(error)) return
        call check_formatter(error, to_string(100, 'I6'), "   100", &
            & "Formatter for integer number")
        if (allocated(error)) return
        call check_formatter(error, to_string(100, 'I0.6'), "000100", &
            & "Formatter with zero padding for integer number")
        if (allocated(error)) return
        call check_formatter(error, to_string(100, 'I6') // to_string(1000, '(I7)'), &
            & "   100   1000", "Multiple formatters for integers")
        if (allocated(error)) return
        call check_formatter(error, to_string(34, 'B8'), "  100010", &
            & "Binary formatter for integer number")
        if (allocated(error)) return
        call check_formatter(error, to_string(34, 'O0.3'), "042", &
            & "Octal formatter with zero padding for integer number")
        if (allocated(error)) return
        call check_formatter(error, to_string(34, 'Z3'), " 22", &
            & "Hexadecimal formatter for integer number")

    end subroutine test_to_string_integer

    subroutine test_to_string_real(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check_formatter(error, to_string(100.), "100.0", &
            & "Default formatter for real number", partial=.true.)
        if (allocated(error)) return
        call check_formatter(error, to_string(100., 'F6.2'), "100.00", &
            & "Formatter for real number")
        if (allocated(error)) return
        call check_formatter(error, to_string(289., 'E7.2'), ".29E+03", &
            & "Exponential formatter with rounding for real number")
        if (allocated(error)) return
        call check_formatter(error, to_string(128., 'ES8.2'), "1.28E+02", &
            & "Exponential formatter for real number")
        if (allocated(error)) return

        ! Wrong demonstration
        call check_formatter(error, to_string(-100., 'F6.2'), "*", &
            & "Too narrow formatter for signed real number", partial=.true.)
        if (allocated(error)) return
        call check_formatter(error, to_string(1000., 'F6.3'), "*", &
            & "Too narrow formatter for real number", partial=.true.)
        if (allocated(error)) return
        call check_formatter(error, to_string(1000., '7.3'), "[*]", &
            & "Invalid formatter for real number", partial=.true.)
        if (allocated(error)) return

    end subroutine test_to_string_real

    subroutine test_to_string_logical(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check_formatter(error, to_string(.true.), "T", &
            & "Default formatter for logcal value")
        if (allocated(error)) return
        call check_formatter(error, to_string(.true., 'L2'), " T", &
            & "Formatter for logical value")
        if (allocated(error)) return
        call check_formatter(error, to_string(.false., 'L2') // to_string(.true., '(L5)'), &
            & " F    T", "Multiple formatters for logical values")
        if (allocated(error)) return

        ! Wrong demonstration
        call check_formatter(error, to_string(.false., '1x'), "[*]", &
            & "Invalid formatter for logical value", partial=.true.)

    end subroutine test_to_string_logical

    subroutine test_to_c_char(error)
        use stdlib_kinds, only : c_char
        use stdlib_string_type, only: string_type, len, char
        use iso_c_binding, only: c_size_t
        
        !> Error handling
        type(error_type), allocatable, intent(out) :: error        
        
        !> Interface to C standard library 
        interface 
            integer(c_size_t) function c_strlen(cstr) bind(C, name="strlen") result(len)
               import :: c_char, c_size_t
               character(kind=c_char), intent(in) :: cstr(*)
            end function c_strlen
        end interface
        
        type(string_type) :: shello
        character(kind=c_char), allocatable :: cstr(:)
        character(*), parameter :: hello = "Hello, World!"
        integer :: i
          
        ! Convert character array
        cstr = to_c_char(hello)
        call check(error, len(hello)==c_strlen(cstr), 'to_c_char_from_char: invalid C length')
        if (allocated(error)) return
        
        do i=1,len(hello)
            call check(error, hello(i:i)==cstr(i), 'to_c_char_from_char: character mismatch')
            if (allocated(error)) return
        end do
        
        ! Convert string type
        shello = string_type(hello)
        cstr = to_c_char(shello)
        call check(error, len(shello)==c_strlen(cstr), 'to_c_char_from_string: invalid C length')
        if (allocated(error)) return
        
        do i=1,len(shello)
            call check(error, char(shello,pos=i)==cstr(i), 'to_c_char_from_string: character mismatch')
            if (allocated(error)) return
        end do
        
    end subroutine test_to_c_char

    subroutine test_string_i1(error)
        use stdlib_kinds, only : i1 => int8

        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, to_string(-huge(1_i1) - 1_i1), "-128")
    end subroutine test_string_i1


    subroutine test_string_i2(error)
        use stdlib_kinds, only : i2 => int16

        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, to_string(-huge(1_i2) - 1_i2), "-32768")
    end subroutine test_string_i2


    subroutine test_string_i4(error)
        use stdlib_kinds, only : i4 => int32

        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, to_string(-huge(1_i4) - 1_i4), "-2147483648")
    end subroutine test_string_i4


    subroutine test_string_i8(error)
        use stdlib_kinds, only : i8 => int64

        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        call check(error, to_string(-huge(1_i8) - 1_i8), "-9223372036854775808")
    end subroutine test_string_i8


end module test_string_to_string


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_string_to_string, only : collect_string_to_string
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("string-to_string", collect_string_to_string) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if
end program

module test_sleep
  use, intrinsic :: iso_fortran_env, only : int64, real64
  use stdlib_system, only : sleep
  use testdrive, only: new_unittest, unittest_type, error_type, check
  implicit none

  private
  public :: collect_sleep

  integer, parameter :: millisec = 100

contains

  !> Collect all exported unit tests
  subroutine collect_sleep(testsuite)
    !> Collection of tests
    type(unittest_type), allocatable, intent(out) :: testsuite(:)

    testsuite = [ &
      new_unittest('sleep', test_sleep_) &
    ]

  end subroutine collect_sleep


  subroutine test_sleep_(error)
    !> Error handling
    type(error_type), allocatable, intent(out) :: error

    integer(int64) :: tic, toc, trate
    real(real64) :: t_ms

    call system_clock(count_rate=trate)

    call system_clock(count=tic)
    call sleep(millisec)
    call system_clock(count=toc)

    t_ms = (toc - tic) * 1000._real64 / trate

    call check(error, t_ms, real(millisec, real64), thr=1.5_real64, rel=.true.)

  end subroutine test_sleep_

end module test_sleep


program tester
  use, intrinsic :: iso_fortran_env, only: error_unit
  use testdrive, only: run_testsuite, new_testsuite, testsuite_type
  use test_sleep, only: collect_sleep
  implicit none
  integer :: stat, is
  type(testsuite_type), allocatable :: testsuites(:)
  character(len=*), parameter :: fmt = '("#", *(1x, a))'

  stat = 0

  testsuites = [ &
    new_testsuite('sleep', collect_sleep) &
  ]

  do is = 1, size(testsuites)
    write(error_unit, fmt) "Testing:", testsuites(is)%name
    call run_testsuite(testsuites(is)%collect, error_unit, stat)
  end do

  if (stat > 0) then
    write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
    error stop
  end if

end program tester

program example_bits
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_0 = '0000000000000000000'
  type(bitset_64) :: set0
  call set0%from_string(bits_0)
  if (set0%bits() == 19) then
    write (*, *) "FROM_STRING interpreted "// &
      "BITS_0's size properly."
  end if
end program example_bits

program example_chomp
  use stdlib_ascii, only: TAB, VT, LF, CR, FF
  use stdlib_strings, only: chomp
  implicit none
  print'(a)', chomp("   hello   ")             ! "   hello"
  print'(a)', chomp(TAB//"goodbye"//CR//LF)    ! "\tgoodbye"
  print'(a)', chomp(" "//TAB//LF//VT//FF//CR)  ! ""
  print'(a)', chomp("  !  ")//"!"              ! "  !!"
  print'(a)', chomp("Hello")                   ! "Hello"
  print'(a)', chomp("hello", ["l", "o"])       ! "he"
  print'(a)', chomp("hello", set=["l", "o"])   ! "he"
  print'(a)', chomp("hello", "lo")             ! "hel"
  print'(a)', chomp("hello", substring="lo")   ! "hel"
end program example_chomp

! SPDX-Identifier: MIT

!> Implementation of the conversion to enumerator and identifier types to strings
submodule (stdlib_ansi) stdlib_ansi_to_string
    implicit none

    character, parameter :: esc = achar(27), chars(0:9) = &
        ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

contains

    !> Transform a color code into an actual ANSI escape sequence
    pure module function to_string_ansi_code(code) result(str)
        !> Color code to be used
        type(ansi_code), intent(in) :: code
        !> ANSI escape sequence representing the color code
        character(len=:), allocatable :: str

        if (anycolor(code)) then
            str = esc // "[0"  ! Always reset the style
            if (code%style > 0 .and. code%style < 10) str = str // ";" // chars(code%style)
            if (code%fg >= 0 .and. code%fg < 10) str = str // ";3" // chars(code%fg)
            if (code%bg >= 0 .and. code%bg < 10) str = str // ";4" // chars(code%bg)
            str = str // "m"
        else
            str = ""
        end if
    end function to_string_ansi_code

    !> Check whether the code describes any color / style or is just a stub
    pure function anycolor(code)
        !> Escape sequence
        type(ansi_code), intent(in) :: code
        !> Any color / style is active
        logical :: anycolor

        anycolor = code%fg >= 0 .or. code%bg >= 0 .or. code%style >= 0
    end function anycolor

end submodule stdlib_ansi_to_string

module test_stats_random
    use stdlib_kinds, only: int8, int16, int32, int64
    use stdlib_random, only : random_seed, dist_rand
    use testdrive, only: new_unittest, unittest_type, error_type, check

    implicit none

    private
    public :: collect_stats_random

contains

    !> Collect all exported unit tests
    subroutine collect_stats_random(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("random_seed", test_random_seed), &
            new_unittest("random_rand_iint8", test_random_rand_iint8), &
            new_unittest("random_rand_iint16", test_random_rand_iint8), &
            new_unittest("random_rand_iint32", test_random_rand_iint8), &
            new_unittest("random_rand_iint64", test_random_rand_iint8) &
        ]

    end subroutine collect_stats_random

    subroutine test_random_seed(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error

        integer :: put, get, res(5)
        integer :: ans(5) = [-1859553078, -1933696596, -642834430, &
                             1711399314,  1548311463]
        integer :: i

        put = 135792468
        do i = 1, 5
            call random_seed(put, get)
            res(i) = get
            put = get
        end do
        call check(error, all(res == ans))
    end subroutine test_random_seed

    subroutine test_random_rand_iint8(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer :: put, get, i
        integer(int8) :: res(5), ans(5) = [118, -15, -72, 101, 70]

        put = 12345678
        call random_seed(put, get)
        do i = 1, 5
            res(i) = dist_rand(1_int8)
        end do
        call check(error, all(res == ans))
    end subroutine test_random_rand_iint8

    subroutine test_random_rand_iint16(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer :: put, get, i
        integer(int16) :: res(5), ans(5) = [30286, -3799, -18204, 25947, 18148]

        put = 12345678
        call random_seed(put, get)
        do i = 1, 5
            res(i) = dist_rand(1_int16)
        end do
        call check(error, all(res == ans))
    end subroutine test_random_rand_iint16

    subroutine test_random_rand_iint32(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer :: put, get, i
        integer(int32) :: res(5), ans(5)=[1984865646, -248954393, -1192993267, &
                                  1700514835, 1189401802]

        put = 12345678
        call random_seed(put, get)
        do i = 1, 5
            res(i) = dist_rand(1_int32)
        end do
        call check(error, all(res == ans))
    end subroutine test_random_rand_iint32

    subroutine test_random_rand_iint64(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer :: put, get, i
        integer(int64) :: res(5), ans(5)=[8524933037632333570_int64, &
                                  -1069250973542918798_int64,        &
                                  -5123867065024149335_int64,        &
                                  7303655603304982073_int64,         &
                                  5108441843522503546_int64]

        put = 12345678
        call random_seed(put, get)
        do i = 1, 5
            res(i) = dist_rand(1_int64)
        end do
        call check(error, all(res == ans))
    end subroutine test_random_rand_iint64

end module test_stats_random


program tester
    use iso_fortran_env, only: error_unit
    use testdrive, only: new_testsuite, run_testsuite, testsuite_type
    use test_stats_random, only: collect_stats_random
    implicit none

    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("stats_random", collect_stats_random) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program tester

! Demonstrate usage of `get_file`
program example_get_file
  use stdlib_io, only: get_file
  use stdlib_string_type, only: string_type
  use stdlib_error, only: state_type
  implicit none

  character(*), parameter :: filename = "example.txt"
  type(string_type) :: filecontent
  type(state_type) :: err

  ! Read a file into a string
  call get_file(filename, filecontent, err=err)

  if (err%error()) then
    print *, err%print()
  else
    print *, "Success! File "//filename//" imported."
  end if
end program example_get_file

program example_bit_count
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_0 = '0000000000000000000'
  type(bitset_64) :: set0
  type(bitset_large) :: set1
  logical, allocatable :: logi(:)
  
  call set0%from_string(bits_0)
  if (set0%bit_count() == 0) then
    write (*, *) "FROM_STRING interpreted "// &
      "BITS_0's value properly."
  end if
  call set0%set(5)
  if (set0%bit_count() == 1) then
    write (*, *) "BIT_COUNT interpreted SET0's value properly."
  end if
  
  allocate( logi(1000), source=.false.)
  logi(1::7) = .true.
  set1 = logi
  if (set1%bit_count() == count(logi)) then
    write (*, *) "BIT_COUNT interpreted SET1's value properly."
  end if
end program example_bit_count

module test_moment
    use,intrinsic :: ieee_arithmetic, only : ieee_is_nan
    use stdlib_kinds, only: sp, dp, int32, int64
    use stdlib_stats, only: moment
    use testdrive, only: new_unittest, unittest_type, error_type, check

    implicit none

    private
    public :: collect_moment, initialize_test_data

    real(sp), parameter :: sptol = 1000 * epsilon(1._sp)
    real(dp), parameter :: dptol = 1000 * epsilon(1._dp)

    real(dp), parameter :: d1(5) = [1._dp, 2._dp, 3._dp, 4._dp, 5._dp]
    real(dp), parameter :: d(4,3) = reshape( &
        [1._dp, 3._dp, 5._dp, 7._dp, &
         2._dp, 4._dp, 6._dp, 8._dp, &
         9._dp, 10._dp, 11._dp, 12._dp], [4, 3])

    complex(dp) :: c1(5) = [(0.57706_dp, 0.00000_dp), &
                            (0.00000_dp, 1.44065_dp), &
                            (1.26401_dp, 0.00000_dp), &
                            (0.00000_dp, 0.88833_dp), &
                            (1.14352_dp, 0.00000_dp)]
    complex(dp) :: c2(5,3)

    real(sp) :: x1(5) = real(d1, sp)
    real(sp) :: x2(4,3) = real(d, sp)
    real(sp), allocatable :: x3(:,:,:)

    real(dp) :: dx1(5) = d1
    real(dp) :: dx2(4,3) = d
    real(dp), allocatable :: dx3(:,:,:)

    integer(int32) :: i1(5) = d1
    integer(int32) :: i2(4,3) = d
    integer(int32), allocatable :: i3(:,:,:)

    integer(int64) :: di1(5) = d1
    integer(int64) :: di2(4,3) = d
    integer(int64), allocatable :: di3(:,:,:)

contains

    subroutine initialize_test_data()

        allocate(x3(size(x2, 1),size(x2, 2),3))
        x3(:,:,1) = x2
        x3(:,:,2) = x2 * 2
        x3(:,:,3) = x2 * 4

        allocate(dx3(size(dx2, 1),size(dx2, 2),3))
        dx3(:,:,1) = dx2
        dx3(:,:,2) = dx2 * 2
        dx3(:,:,3) = dx2 * 4

        i3 = x3
        di3 = dx3

        c2(:,1) = c1
        c2(:,2) = c1 * 3
        c2(:,3) = c1 * 1.5

    end subroutine initialize_test_data

    !> Collect all exported unit tests
    subroutine collect_moment(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest('moment_sp_dim1_order1', test_sp_dim1_order1), &
            new_unittest('moment_sp_dim1_mask_order1', test_sp_dim1_mask_order1), &
            new_unittest('moment_sp_dim1_mask_array_order1', test_sp_dim1_mask_array_order1), &
            new_unittest('moment_sp_dim2_order1', test_sp_dim2_order1), &
            new_unittest('moment_sp_dim2_mask_order1', test_sp_dim2_mask_order1), &
            new_unittest('moment_sp_dim2_mask_array_order1', test_sp_dim2_mask_array_order1), &
            new_unittest('moment_sp_dim3_order1', test_sp_dim3_order1), &
            new_unittest('moment_sp_dim3_mask_order1', test_sp_dim3_mask_order1), &
            new_unittest('moment_sp_dim3_mask_array_order1', test_sp_dim3_mask_array_order1), &
            new_unittest('moment_sp_dim1_order2', test_sp_dim1_order2), &
            new_unittest('moment_sp_dim1_mask_order2', test_sp_dim1_mask_order2), &
            new_unittest('moment_sp_dim1_mask_array_order2', test_sp_dim1_mask_array_order2), &
            new_unittest('moment_sp_dim2_order2', test_sp_dim2_order2), &
            new_unittest('moment_sp_dim2_mask_order2', test_sp_dim2_mask_order2), &
            new_unittest('moment_sp_dim2_mask_array_order2', test_sp_dim2_mask_array_order2), &
            new_unittest('moment_sp_dim3_order2', test_sp_dim3_order2), &
            new_unittest('moment_sp_dim3_mask_order2', test_sp_dim3_mask_order2), &
            new_unittest('moment_sp_dim3_mask_array_order2', test_sp_dim3_mask_array_order2), &
            new_unittest('moment_dp_dim1_order1', test_dp_dim1_order1), &
            new_unittest('moment_dp_dim1_mask_order1', test_dp_dim1_mask_order1), &
            new_unittest('moment_dp_dim1_mask_array_order1', test_dp_dim1_mask_array_order1), &
            new_unittest('moment_dp_dim2_order1', test_dp_dim2_order1), &
            new_unittest('moment_dp_dim2_mask_order1', test_dp_dim2_mask_order1), &
            new_unittest('moment_dp_dim2_mask_array_order1', test_dp_dim2_mask_array_order1), &
            new_unittest('moment_dp_dim3_order1', test_dp_dim3_order1), &
            new_unittest('moment_dp_dim3_mask_order1', test_dp_dim3_mask_order1), &
            new_unittest('moment_dp_dim3_mask_array_order1', test_dp_dim3_mask_array_order1), &
            new_unittest('moment_dp_dim1_order2', test_dp_dim1_order2), &
            new_unittest('moment_dp_dim1_mask_order2', test_dp_dim1_mask_order2), &
            new_unittest('moment_dp_dim1_mask_array_order2', test_dp_dim1_mask_array_order2), &
            new_unittest('moment_dp_dim2_order2', test_dp_dim2_order2), &
            new_unittest('moment_dp_dim2_mask_order2', test_dp_dim2_mask_order2), &
            new_unittest('moment_dp_dim2_mask_array_order2', test_dp_dim2_mask_array_order2), &
            new_unittest('moment_dp_dim3_order2', test_dp_dim3_order2), &
            new_unittest('moment_dp_dim3_mask_order2', test_dp_dim3_mask_order2), &
            new_unittest('moment_dp_dim3_mask_array_order2', test_dp_dim3_mask_array_order2), &
            new_unittest('moment_int32_dim1_order1', test_int32_dim1_order1), &
            new_unittest('moment_int32_dim1_mask_order1', test_int32_dim1_mask_order1), &
            new_unittest('moment_int32_dim1_mask_array_order1', test_int32_dim1_mask_array_order1), &
            new_unittest('moment_int32_dim2_order1', test_int32_dim2_order1), &
            new_unittest('moment_int32_dim2_mask_order1', test_int32_dim2_mask_order1), &
            new_unittest('moment_int32_dim2_mask_array_order1', test_int32_dim2_mask_array_order1), &
            new_unittest('moment_int32_dim3_order1', test_int32_dim3_order1), &
            new_unittest('moment_int32_dim3_mask_order1', test_int32_dim3_mask_order1), &
            new_unittest('moment_int32_dim3_mask_array_order1', test_int32_dim3_mask_array_order1), &
            new_unittest('moment_int32_dim1_order2', test_int32_dim1_order2), &
            new_unittest('moment_int32_dim1_mask_order2', test_int32_dim1_mask_order2), &
            new_unittest('moment_int32_dim1_mask_array_order2', test_int32_dim1_mask_array_order2), &
            new_unittest('moment_int32_dim2_order2', test_int32_dim2_order2), &
            new_unittest('moment_int32_dim2_mask_order2', test_int32_dim2_mask_order2), &
            new_unittest('moment_int32_dim2_mask_array_order2', test_int32_dim2_mask_array_order2), &
            new_unittest('moment_int32_dim3_order2', test_int32_dim3_order2), &
            new_unittest('moment_int32_dim3_mask_order2', test_int32_dim3_mask_order2), &
            new_unittest('moment_int32_dim3_mask_array_order2', test_int32_dim3_mask_array_order2), &
            new_unittest('moment_int64_dim1_order1', test_int64_dim1_order1), &
            new_unittest('moment_int64_dim1_mask_order1', test_int64_dim1_mask_order1), &
            new_unittest('moment_int64_dim1_mask_array_order1', test_int64_dim1_mask_array_order1), &
            new_unittest('moment_int64_dim2_order1', test_int64_dim2_order1), &
            new_unittest('moment_int64_dim2_mask_order1', test_int64_dim2_mask_order1), &
            new_unittest('moment_int64_dim2_mask_array_order1', test_int64_dim2_mask_array_order1), &
            new_unittest('moment_int64_dim3_order1', test_int64_dim3_order1), &
            new_unittest('moment_int64_dim3_mask_order1', test_int64_dim3_mask_order1), &
            new_unittest('moment_int64_dim3_mask_array_order1', test_int64_dim3_mask_array_order1), &
            new_unittest('moment_int64_dim1_order2', test_int64_dim1_order2), &
            new_unittest('moment_int64_dim1_mask_order2', test_int64_dim1_mask_order2), &
            new_unittest('moment_int64_dim1_mask_array_order2', test_int64_dim1_mask_array_order2), &
            new_unittest('moment_int64_dim2_order2', test_int64_dim2_order2), &
            new_unittest('moment_int64_dim2_mask_order2', test_int64_dim2_mask_order2), &
            new_unittest('moment_int64_dim2_mask_array_order2', test_int64_dim2_mask_array_order2), &
            new_unittest('moment_int64_dim3_order2', test_int64_dim3_order2), &
            new_unittest('moment_int64_dim3_mask_order2', test_int64_dim3_mask_order2), &
            new_unittest('moment_int64_dim3_mask_array_order2', test_int64_dim3_mask_array_order2), &
            new_unittest('moment_csp_dim1_order1', test_csp_dim1_order1), &
            new_unittest('moment_csp_dim1_mask_order1', test_csp_dim1_mask_order1), &
            new_unittest('moment_csp_dim1_mask_array_order1', test_csp_dim1_mask_array_order1), &
            new_unittest('moment_csp_dim2_order1', test_csp_dim2_order1), &
            new_unittest('moment_csp_dim2_mask_order1', test_csp_dim2_mask_order1), &
            new_unittest('moment_csp_dim2_mask_array_order1', test_csp_dim2_mask_array_order1), &
            new_unittest('moment_csp_dim1_order2', test_csp_dim1_order2), &
            new_unittest('moment_csp_dim1_mask_order2', test_csp_dim1_mask_order2), &
            new_unittest('moment_csp_dim1_mask_array_order2', test_csp_dim1_mask_array_order2), &
            new_unittest('moment_csp_dim2_order2', test_csp_dim2_order2), &
            new_unittest('moment_csp_dim2_mask_order2', test_csp_dim2_mask_order2), &
            new_unittest('moment_csp_dim2_mask_array_order2', test_csp_dim2_mask_array_order2) &
        ]

    end subroutine collect_moment

    subroutine test_sp_dim1_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(x1, order)) < sptol)
        call check(error, abs(moment(x1, order, dim=1)) < sptol)
    end subroutine

    subroutine test_sp_dim1_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(x1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(x1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_sp_dim1_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(x1, order, mask=(x1 < 5))) < sptol)
        call check(error, abs(moment(x1, order, 1, mask=(x1 < 5))) < sptol)
    end subroutine

    subroutine test_sp_dim2_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(x2, order)) < sptol)
        call check(error, all(abs(moment(x2, order, 1)) < sptol))
        call check(error, all(abs(moment(x2, order, 2)) < sptol))
    end subroutine

    subroutine test_sp_dim2_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(x2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(x2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_sp_dim2_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(x2, order, mask=(x2 < 11))) < sptol)
        call check(error, all(abs(moment(x2, order, 1, mask=(x2 < 11))) < sptol))
        call check(error, all(abs(moment(x2, order, 2, mask=(x2 < 11))) < sptol))
    end subroutine

    subroutine test_sp_dim3_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(x3, order)) < sptol)
        call check(error, all(abs(moment(x3, order, 1)) < sptol))
        call check(error, all(abs(moment(x3, order, 2)) < sptol))
        call check(error, all(abs(moment(x3, order, 3)) < sptol))
    end subroutine
    
    subroutine test_sp_dim3_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(x3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(x3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_sp_dim3_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(x3, order, mask=(x3 < 11)) ) < sptol)
        call check(error, all(abs(moment(x3, order, 1, mask=(x3 < 45))) < sptol ))
        call check(error, all(abs(moment(x3, order, 2, mask=(x3 < 45))) < sptol ))
        call check(error, all(abs(moment(x3, order, 3, mask=(x3 < 45))) < sptol ))
    end subroutine

    subroutine test_sp_dim1_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(x1, order) - 2._sp) < sptol)
        call check(error, abs(moment(x1, order, dim=1) - 2._sp) < sptol)
    end subroutine

    subroutine test_sp_dim1_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(x1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(x1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_sp_dim1_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(x1, order, mask=(x1 < 5)) - 1.25_sp) < sptol)
        call check(error, abs(moment(x1, order, 1, mask=(x1 < 5)) - 1.25_sp) < sptol)
    end subroutine

    subroutine test_sp_dim2_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(x2, order) - 107.25_sp/9.) < sptol)
        call check(error, all(abs(moment(x2, order, 1) - [5._sp, 5._sp, 1.25_sp]) < sptol))
        call check(error, all(abs(moment(x2, order, 2) -&
                           [19.0, 43. / 3., 31. / 3. , 7.0]*2./3.) < sptol))
    end subroutine

    subroutine test_sp_dim2_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(x2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(x2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(x2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_sp_dim2_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(x2, order, mask=(x2 < 11))- 2.75_sp*3.) < sptol)
        call check(error, all(abs(moment(x2, order, 1, mask=(x2 < 11)) -&
                      [5._sp, 5._sp, 0.25_sp]) < sptol))
        call check(error, all(abs(moment(x2, order, 2, mask=(x2 < 11)) -&
                      [19._sp*2./3., 43._sp/9.*2., 0.25_sp , 0.25_sp]) < sptol))
    end subroutine

    subroutine test_sp_dim3_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(x3, order) - 153.4_sp*35./36.) < sptol)
        call check(error, all(abs(moment(x3, order, 1) -&
                 reshape([20._sp / 3., 20._sp / 3., 5._sp / 3.,&
                          4* 20._sp / 3., 4* 20._sp / 3., 4* 5._sp / 3.,&
                          16* 20._sp / 3., 16* 20._sp / 3., 16* 5._sp / 3.],&
                          [size(x3,2), size(x3,3)])*3._sp/4.)&
                 < sptol))
        call check(error, all(abs(moment(x3, order, 2) -&
                 reshape([19._sp, 43._sp / 3., 31._sp / 3. , 7.0_sp,&
                          4* 19.0_sp, 4* 43._sp / 3., 4* 31._sp / 3. , 4* 7.0_sp,&
                          16* 19.0_sp, 16* 43._sp / 3., 16* 31._sp / 3. , 16* 7.0_sp],&
                          [size(x3,1), size(x3,3)] )*2._sp/3.)&
                 < sptol))
        call check(error, all(abs(moment(x3, order, 3) -&
                 reshape([ 7._sp/3., 21._sp, 175._sp/3.,&
                           343._sp/3., 28._sp/3., 112._sp/3.,&
                           84._sp, 448._sp/3., 189._sp,&
                           700._sp/3., 847._sp/3., 336._sp],&
                           [size(x3,1), size(x3,2)] )*2./3.)&
                 < sptol))
    end subroutine
    
    subroutine test_sp_dim3_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(x3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(x3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(x3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_sp_dim3_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(x3, order, mask=(x3 < 11)) -&
                      7.7370242214532876_dp ) < sptol)
        call check(error, all(abs(moment(x3, order, 1, mask=(x3 < 45)) -&
                      reshape([5._sp, 5._sp, 1.25_sp,  20._sp, 20._sp, 5._sp,&
                               80._sp, 80._sp, 32._sp/3.],&
                               [size(x3, 2), size(x3, 3)])) < sptol ))
        call check(error, all(abs(moment(x3, order, 2, mask=(x3 < 45)) -&
                      reshape([ 38._sp/3., 86._sp/9., 62._sp/9., 14._sp/3., 152._sp/3.,&
                                344._sp/9., 248._sp/9., 168._sp/9., 1824._sp/9.,&
                                1376._sp/9., 992._sp/9., 4._sp&
                               ],&
                      [size(x3, 1), size(x3, 3)])) < sptol ))
        call check(error, all(abs(moment(x3, order, 3, mask=(x3 < 45)) -&
                     reshape([14._sp/9., 14._sp, 350._sp/9., 686._sp/9., 56._sp/9.,&
                              224._sp/9., 56._sp, 896._sp/9., 126._sp, 1400._sp/9.,&
                              1694._sp/9., 36._sp&
                               ], [size(x3,1), size(x3,2)] ))&
                     < sptol ))
    end subroutine

    subroutine test_dp_dim1_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(dx1, order)) < dptol)
        call check(error, abs(moment(dx1, order, dim=1)) < dptol)
    end subroutine

    subroutine test_dp_dim1_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(dx1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(dx1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_dp_dim1_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(dx1, order, mask=(dx1 < 5))) < dptol)
        call check(error, abs(moment(dx1, order, 1, mask=(dx1 < 5))) < dptol)
    end subroutine

    subroutine test_dp_dim2_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(dx2, order)) < dptol)
        call check(error, all(abs(moment(dx2, order, 1)) < dptol))
        call check(error, all(abs(moment(dx2, order, 2)) < dptol))
    end subroutine

    subroutine test_dp_dim2_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(dx2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(dx2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(dx2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_dp_dim2_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(dx2, order, mask=(dx2 < 11))) < dptol)
        call check(error, all(abs(moment(dx2, order, 1, mask=(dx2 < 11))) < dptol))
        call check(error, all(abs(moment(dx2, order, 2, mask=(dx2 < 11))) < dptol))
    end subroutine

    subroutine test_dp_dim3_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(dx3, order)) < dptol)
        call check(error, all(abs(moment(dx3, order, 1)) < dptol))
        call check(error, all(abs(moment(dx3, order, 2)) < dptol))
        call check(error, all(abs(moment(dx3, order, 3)) < dptol))
    end subroutine
    
    subroutine test_dp_dim3_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(dx3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(dx3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(dx3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(dx3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_dp_dim3_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(dx3, order, mask=(dx3 < 11)) ) < dptol)
        call check(error, all(abs(moment(dx3, order, 1, mask=(dx3 < 45))) < dptol ))
        call check(error, all(abs(moment(dx3, order, 2, mask=(dx3 < 45))) < dptol ))
        call check(error, all(abs(moment(dx3, order, 3, mask=(dx3 < 45))) < dptol ))
    end subroutine

    subroutine test_dp_dim1_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(dx1, order) - 2._dp) < dptol)
        call check(error, abs(moment(dx1, order, dim=1) - 2._dp) < dptol)
    end subroutine

    subroutine test_dp_dim1_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(dx1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(dx1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_dp_dim1_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(dx1, order, mask=(dx1 < 5)) - 1.25_dp) < dptol)
        call check(error, abs(moment(dx1, order, 1, mask=(dx1 < 5)) - 1.25_dp) < dptol)
    end subroutine

    subroutine test_dp_dim2_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(dx2, order) - 107.25_dp/9.) < dptol)
        call check(error, all(abs(moment(dx2, order, 1) - [5._dp, 5._dp, 1.25_dp]) < dptol))
        call check(error, all(abs(moment(dx2, order, 2) -&
                      [19._dp, 43._dp / 3., 31._dp / 3. , 7._dp]*2._dp/3.) < dptol))
    end subroutine

    subroutine test_dp_dim2_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(dx2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(dx2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(dx2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_dp_dim2_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(dx2, order, mask=(dx2 < 11))- 2.75_dp*3.) < dptol)
        call check(error, all(abs(moment(dx2, order, 1, mask=(dx2 < 11)) -&
                      [5._dp, 5._dp, 0.25_dp]) < dptol))
        call check(error, all(abs(moment(dx2, order, 2, mask=(dx2 < 11)) -&
                      [19._dp*2./3., 43._dp/9.*2., 0.25_dp , 0.25_dp]) < dptol))
    end subroutine

    subroutine test_dp_dim3_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(dx3, order) - 153.4_dp*35./36.) < dptol)
        call check(error, all(abs(moment(dx3, order, 1) -&
                 reshape([20._dp / 3., 20._dp / 3., 5._dp / 3.,&
                          4* 20._dp / 3., 4* 20._dp / 3., 4* 5._dp / 3.,&
                          16* 20._dp / 3., 16* 20._dp / 3., 16* 5._dp / 3.],&
                          [size(dx3,2), size(dx3,3)])*3._dp/4.)&
                 < dptol))
        call check(error, all(abs(moment(dx3, order, 2) -&
                 reshape([19._dp, 43._dp / 3., 31._dp / 3. , 7.0_dp,&
                          4* 19.0_dp, 4* 43._dp / 3., 4* 31._dp / 3. , 4* 7.0_dp,&
                          16* 19.0_dp, 16* 43._dp / 3., 16* 31._dp / 3. , 16* 7.0_dp],&
                          [size(dx3,1), size(dx3,3)] )*2._dp/3.)&
                 < dptol))
        call check(error, all(abs(moment(dx3, order, 3) -&
                 reshape([ 7._dp/3., 21._dp, 175._dp/3.,&
                           343._dp/3., 28._dp/3., 112._dp/3.,&
                           84._dp, 448._dp/3., 189._dp,&
                           700._dp/3., 847._dp/3., 336._dp],&
                           [size(dx3,1), size(dx3,2)] )*2./3.)&
                 < dptol))
    end subroutine
    
    subroutine test_dp_dim3_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(dx3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(dx3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(dx3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(dx3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_dp_dim3_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(dx3, order, mask=(dx3 < 11)) -&
                          7.7370242214532876_dp ) < dptol)
        call check(error, all(abs(moment(dx3, order, 1, mask=(dx3 < 45)) -&
                      reshape([5._dp, 5._dp, 1.25_dp,  20._dp, 20._dp, 5._dp,&
                               80._dp, 80._dp, 32._dp/3.],&
                               [size(dx3, 2), size(dx3, 3)])) < dptol ))
        call check(error, all(abs(moment(dx3, order, 2, mask=(dx3 < 45)) -&
                      reshape([ 38._dp/3., 86._dp/9., 62._dp/9., 14._dp/3., 152._dp/3.,&
                                344._dp/9., 248._dp/9., 168._dp/9., 1824._dp/9.,&
                                1376._dp/9., 992._dp/9., 4._dp&
                               ],&
                      [size(dx3, 1), size(dx3, 3)])) < dptol ))
        call check(error, all(abs(moment(dx3, order, 3, mask=(dx3 < 45)) -&
                     reshape([14._dp/9., 14._dp, 350._dp/9., 686._dp/9., 56._dp/9.,&
                              224._dp/9., 56._dp, 896._dp/9., 126._dp, 1400._dp/9.,&
                              1694._dp/9., 36._dp&
                               ], [size(dx3,1), size(dx3,2)] ))&
                     < dptol ))
    end subroutine

    subroutine test_int32_dim1_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(i1, order)) < dptol)
        call check(error, abs(moment(i1, order, dim=1)) < dptol)
    end subroutine

    subroutine test_int32_dim1_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(i1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(i1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_int32_dim1_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(i1, order, mask=(i1 < 5))) < dptol)
        call check(error, abs(moment(i1, order, 1, mask=(i1 < 5))) < dptol)
    end subroutine

    subroutine test_int32_dim2_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(i2, order)) < dptol)
        call check(error, all(abs(moment(i2, order, 1)) < dptol))
        call check(error, all(abs(moment(i2, order, 2)) < dptol))
    end subroutine

    subroutine test_int32_dim2_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(i2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(i2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(i2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_int32_dim2_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(i2, order, mask=(i2 < 11))) < dptol)
        call check(error, all(abs(moment(i2, order, 1, mask=(i2 < 11))) < dptol))
        call check(error, all(abs(moment(i2, order, 2, mask=(i2 < 11))) < dptol))
    end subroutine

    subroutine test_int32_dim3_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(i3, order)) < dptol)
        call check(error, all(abs(moment(i3, order, 1)) < dptol))
        call check(error, all(abs(moment(i3, order, 2)) < dptol))
        call check(error, all(abs(moment(i3, order, 3)) < dptol))
    end subroutine
    
    subroutine test_int32_dim3_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(i3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(i3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(i3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(i3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_int32_dim3_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(i3, order, mask=(i3 < 11)) ) < dptol)
        call check(error, all(abs(moment(i3, order, 1, mask=(i3 < 45))) < dptol ))
        call check(error, all(abs(moment(i3, order, 2, mask=(i3 < 45))) < dptol ))
        call check(error, all(abs(moment(i3, order, 3, mask=(i3 < 45))) < dptol ))
    end subroutine
 
    subroutine test_int32_dim1_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(i1, order) - 2._dp) < dptol)
        call check(error, abs(moment(i1, order, dim=1) - 2._dp) < dptol)
    end subroutine

    subroutine test_int32_dim1_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(i1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(i1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_int32_dim1_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(i1, order, mask=(i1 < 5)) - 1.25_dp) < dptol)
        call check(error, abs(moment(i1, order, 1, mask=(i1 < 5)) - 1.25_dp) < dptol)
    end subroutine

    subroutine test_int32_dim2_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(i2, order) - 107.25_dp/9.) < dptol)
        call check(error, all(abs(moment(i2, order, 1) - [5._dp, 5._dp, 1.25_dp]) < dptol))
        call check(error, all(abs(moment(i2, order, 2) -&
                      [19._dp, 43._dp / 3., 31._dp / 3. , 7._dp]*2._dp/3.) < dptol))
    end subroutine

    subroutine test_int32_dim2_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(i2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(i2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(i2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_int32_dim2_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(i2, order, mask=(i2 < 11))- 2.75_dp*3.) < dptol)
        call check(error, all(abs(moment(i2, order, 1, mask=(i2 < 11)) -&
                      [5._dp, 5._dp, 0.25_dp]) < dptol))
        call check(error, all(abs(moment(i2, order, 2, mask=(i2 < 11)) -&
                      [19._dp*2./3., 43._dp/9.*2., 0.25_dp , 0.25_dp]) < dptol))
    end subroutine

    subroutine test_int32_dim3_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(i3, order) - 153.4_dp*35./36.) < dptol)
        call check(error, all(abs(moment(i3, order, 1) -&
                 reshape([20._dp / 3., 20._dp / 3., 5._dp / 3.,&
                          4* 20._dp / 3., 4* 20._dp / 3., 4* 5._dp / 3.,&
                          16* 20._dp / 3., 16* 20._dp / 3., 16* 5._dp / 3.],&
                          [size(i3,2), size(i3,3)])*3._dp/4.)&
                 < dptol))
        call check(error, all(abs(moment(i3, order, 2) -&
                 reshape([19._dp, 43._dp / 3., 31._dp / 3. , 7.0_dp,&
                          4* 19.0_dp, 4* 43._dp / 3., 4* 31._dp / 3. , 4* 7.0_dp,&
                          16* 19.0_dp, 16* 43._dp / 3., 16* 31._dp / 3. , 16* 7.0_dp],&
                          [size(i3,1), size(i3,3)] )*2._dp/3.)&
                 < dptol))
        call check(error, all(abs(moment(i3, order, 3) -&
                 reshape([ 7._dp/3., 21._dp, 175._dp/3.,&
                           343._dp/3., 28._dp/3., 112._dp/3.,&
                           84._dp, 448._dp/3., 189._dp,&
                           700._dp/3., 847._dp/3., 336._dp],&
                           [size(i3,1), size(i3,2)] )*2./3.)&
                 < dptol))
    end subroutine
    
    subroutine test_int32_dim3_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(i3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(i3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(i3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(i3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_int32_dim3_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(i3, order, mask=(i3 < 11)) -&
                          7.7370242214532876_dp ) < dptol)
        call check(error, all(abs(moment(i3, order, 1, mask=(i3 < 45)) -&
                      reshape([5._dp, 5._dp, 1.25_dp,  20._dp, 20._dp, 5._dp,&
                               80._dp, 80._dp, 32._dp/3.],&
                               [size(i3, 2), size(i3, 3)])) < dptol ))
        call check(error, all(abs(moment(i3, order, 2, mask=(i3 < 45)) -&
                      reshape([ 38._dp/3., 86._dp/9., 62._dp/9., 14._dp/3., 152._dp/3.,&
                                344._dp/9., 248._dp/9., 168._dp/9., 1824._dp/9.,&
                                1376._dp/9., 992._dp/9., 4._dp&
                               ],&
                      [size(i3, 1), size(i3, 3)])) < dptol ))
        call check(error, all(abs(moment(i3, order, 3, mask=(i3 < 45)) -&
                     reshape([14._dp/9., 14._dp, 350._dp/9., 686._dp/9., 56._dp/9.,&
                              224._dp/9., 56._dp, 896._dp/9., 126._dp, 1400._dp/9.,&
                              1694._dp/9., 36._dp&
                               ], [size(i3,1), size(i3,2)] ))&
                     < dptol ))
    end subroutine

    subroutine test_int64_dim1_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(di1, order)) < dptol)
        call check(error, abs(moment(di1, order, dim=1)) < dptol)
    end subroutine

    subroutine test_int64_dim1_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(di1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(di1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_int64_dim1_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(di1, order, mask=(di1 < 5))) < dptol)
        call check(error, abs(moment(di1, order, 1, mask=(di1 < 5))) < dptol)
    end subroutine

    subroutine test_int64_dim2_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(di2, order)) < dptol)
        call check(error, all(abs(moment(di2, order, 1)) < dptol))
        call check(error, all(abs(moment(di2, order, 2)) < dptol))
    end subroutine

    subroutine test_int64_dim2_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(di2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(di2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(di2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_int64_dim2_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(di2, order, mask=(di2 < 11))) < dptol)
        call check(error, all(abs(moment(di2, order, 1, mask=(di2 < 11))) < dptol))
        call check(error, all(abs(moment(di2, order, 2, mask=(di2 < 11))) < dptol))
    end subroutine

    subroutine test_int64_dim3_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(di3, order)) < dptol)
        call check(error, all(abs(moment(di3, order, 1)) < dptol))
        call check(error, all(abs(moment(di3, order, 2)) < dptol))
        call check(error, all(abs(moment(di3, order, 3)) < dptol))
    end subroutine
    
    subroutine test_int64_dim3_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(moment(di3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(di3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(di3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(di3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_int64_dim3_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(di3, order, mask=(di3 < 11)) ) < dptol)
        call check(error, all(abs(moment(di3, order, 1, mask=(di3 < 45))) < dptol ))
        call check(error, all(abs(moment(di3, order, 2, mask=(di3 < 45))) < dptol ))
        call check(error, all(abs(moment(di3, order, 3, mask=(di3 < 45))) < dptol ))
    end subroutine
 
    subroutine test_int64_dim1_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(di1, order) - 2._dp) < dptol)
        call check(error, abs(moment(di1, order, dim=1) - 2._dp) < dptol)
    end subroutine

    subroutine test_int64_dim1_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(di1, order, mask=.false.)))
        call check(error, ieee_is_nan(moment(di1, order, 1, mask=.false.)))
    end subroutine

    subroutine test_int64_dim1_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(di1, order, mask=(di1 < 5)) - 1.25_dp) < dptol)
        call check(error, abs(moment(di1, order, 1, mask=(di1 < 5)) - 1.25_dp) < dptol)
    end subroutine

    subroutine test_int64_dim2_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(di2, order) - 107.25_dp/9.) < dptol)
        call check(error, all(abs(moment(di2, order, 1) - [5._dp, 5._dp, 1.25_dp]) < dptol))
        call check(error, all(abs(moment(di2, order, 2) -&
                      [19._dp, 43._dp / 3., 31._dp / 3. , 7._dp]*2._dp/3.) < dptol))
    end subroutine

    subroutine test_int64_dim2_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(i2, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(di2, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(di2, order, 2, mask=.false.))))
    end subroutine

    subroutine test_int64_dim2_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(di2, order, mask=(di2 < 11))- 2.75_dp*3.) < dptol)
        call check(error, all(abs(moment(di2, order, 1, mask=(di2 < 11)) -&
                      [5._dp, 5._dp, 0.25_dp]) < dptol))
        call check(error, all(abs(moment(di2, order, 2, mask=(di2 < 11)) -&
                      [19._dp*2./3., 43._dp/9.*2., 0.25_dp , 0.25_dp]) < dptol))
    end subroutine

    subroutine test_int64_dim3_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(di3, order) - 153.4_dp*35./36.) < dptol)
        call check(error, all(abs(moment(di3, order, 1) -&
                 reshape([20._dp / 3., 20._dp / 3., 5._dp / 3.,&
                          4* 20._dp / 3., 4* 20._dp / 3., 4* 5._dp / 3.,&
                          16* 20._dp / 3., 16* 20._dp / 3., 16* 5._dp / 3.],&
                          [size(di3,2), size(di3,3)])*3._dp/4.)&
                 < dptol))
        call check(error, all(abs(moment(di3, order, 2) -&
                 reshape([19._dp, 43._dp / 3., 31._dp / 3. , 7.0_dp,&
                          4* 19.0_dp, 4* 43._dp / 3., 4* 31._dp / 3. , 4* 7.0_dp,&
                          16* 19.0_dp, 16* 43._dp / 3., 16* 31._dp / 3. , 16* 7.0_dp],&
                          [size(di3,1), size(di3,3)] )*2._dp/3.)&
                 < dptol))
        call check(error, all(abs(moment(di3, order, 3) -&
                 reshape([ 7._dp/3., 21._dp, 175._dp/3.,&
                           343._dp/3., 28._dp/3., 112._dp/3.,&
                           84._dp, 448._dp/3., 189._dp,&
                           700._dp/3., 847._dp/3., 336._dp],&
                           [size(di3,1), size(di3,2)] )*2./3.)&
                 < dptol))
    end subroutine
    
    subroutine test_int64_dim3_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(moment(di3, order, mask=.false.)))
        call check(error, any(ieee_is_nan(moment(di3, order, 1, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(di3, order, 2, mask=.false.))))
        call check(error, any(ieee_is_nan(moment(di3, order, 3, mask=.false.))))
    end subroutine
    
    subroutine test_int64_dim3_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(di3, order, mask=(di3 < 11)) -&
                          7.7370242214532876_dp ) < dptol)
        call check(error, all(abs(moment(di3, order, 1, mask=(di3 < 45)) -&
                      reshape([5._dp, 5._dp, 1.25_dp,  20._dp, 20._dp, 5._dp,&
                               80._dp, 80._dp, 32._dp/3.],&
                               [size(di3, 2), size(di3, 3)])) < dptol ))
        call check(error, all(abs(moment(di3, order, 2, mask=(di3 < 45)) -&
                      reshape([ 38._dp/3., 86._dp/9., 62._dp/9., 14._dp/3., 152._dp/3.,&
                                344._dp/9., 248._dp/9., 168._dp/9., 1824._dp/9.,&
                                1376._dp/9., 992._dp/9., 4._dp&
                               ],&
                      [size(i3, 1), size(i3, 3)])) < dptol ))
        call check(error, all(abs(moment(di3, order, 3, mask=(di3 < 45)) -&
                     reshape([14._dp/9., 14._dp, 350._dp/9., 686._dp/9., 56._dp/9.,&
                              224._dp/9., 56._dp, 896._dp/9., 126._dp, 1400._dp/9.,&
                              1694._dp/9., 36._dp&
                               ], [size(di3,1), size(di3,2)] ))&
                     < dptol ))
    end subroutine

    subroutine test_csp_dim1_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(c1, order)) < sptol)
        call check(error, abs(moment(c1, order, dim=1)) < sptol)
    end subroutine

    subroutine test_csp_dim1_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(abs(moment(c1, order, mask=.false.))))
        call check(error, ieee_is_nan(abs(moment(c1, order, 1, mask=.false.))))
    end subroutine

    subroutine test_csp_dim1_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(c1, order, mask=(aimag(c1) == 0))) < sptol)
        call check(error, abs(moment(c1, order, 1, mask=(aimag(c1) == 0))) < sptol)
    end subroutine

    subroutine test_csp_dim2_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(c2, order)) < sptol)
        call check(error, all(abs(moment(c2, order, 1)) < sptol))
        call check(error, all(abs(moment(c2, order, 2)) < sptol))
    end subroutine

    subroutine test_csp_dim2_mask_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, ieee_is_nan(abs(moment(c2, order, mask=.false.))))
        call check(error, any(ieee_is_nan(abs(moment(c2, order, 1, mask=.false.)))))
        call check(error, any(ieee_is_nan(abs(moment(c2, order, 2, mask=.false.)))))
    end subroutine

    subroutine test_csp_dim2_mask_array_order1(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 1
        call check(error, abs(moment(c2, order, mask=(aimag(c2) == 0))) < sptol)
        call check(error, all(abs(moment(c2, order, 1, mask=(aimag(c2) == 0))) < sptol))
        call check(error, any(ieee_is_nan( abs(moment(c2, order, 2,&
                          mask=(aimag(c2) == 0))))))
    end subroutine

    subroutine test_csp_dim1_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(c1, order) - (-6.459422410E-02,-0.556084037)) < sptol)
        call check(error, abs(moment(c1, order, dim=1) -&
                        (-6.459422410E-02,-0.556084037)) < sptol)
    end subroutine

    subroutine test_csp_dim1_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(abs(moment(c1, order, mask=.false.))))
        call check(error, ieee_is_nan(abs(moment(c1, order, 1, mask=.false.))))
    end subroutine

    subroutine test_csp_dim1_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(c1, order, mask=(aimag(c1) == 0)) -&
                          (8.969944715E-02,0.00000000)) < sptol)
        call check(error, abs(moment(c1, order, 1, mask=(aimag(c1) == 0)) -&
                          (8.969944715E-02,0.00000000)) < sptol)
    end subroutine

    subroutine test_csp_dim2_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(c2, order) - (-0.163121477,-1.86906016)) < sptol)
        call check(error, all(abs(moment(c2, order, 1) -&
                     [(-6.459422410E-02,-0.556084037),&
                      (-0.581347823,-5.00475645),&
                      (-0.145336956,-1.25118911)]&
                     ) < sptol))
        call check(error, all(abs(moment(c2, order, 2) -&
                     [(0.240498722,0.00000000),&
                     (-1.49895227,0.00000000),&
                     (1.15390968,0.00000000),&
                     (-0.569927275,0.00000000),&
                     (0.944405317,0.00000000)]&
                     ) < sptol))
    end subroutine

    subroutine test_csp_dim2_mask_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, ieee_is_nan(abs(moment(c2, order, mask=.false.))))
        call check(error, any(ieee_is_nan(abs(moment(c2, order, 1, mask=.false.)))))
        call check(error, any(ieee_is_nan(abs(moment(c2, order, 2, mask=.false.)))))
    end subroutine

    subroutine test_csp_dim2_mask_array_order2(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer, parameter :: order = 2
        call check(error, abs(moment(c2, order, mask=(aimag(c2) == 0))-&
                     (1.08109438,0.00000000)) < sptol)
        call check(error, all(abs(moment(c2, order, 1, mask=(aimag(c2)==0)) -&
                      [(8.969944715E-02,0.00000000),&
                       (0.807295084,0.00000000),&
                       (0.201823771,0.00000000)]&
                       ) < sptol))
    end subroutine

end module test_moment


program tester

    use, intrinsic :: iso_fortran_env, only: error_unit
    use testdrive, only: run_testsuite, new_testsuite, testsuite_type
    use test_moment, only: collect_moment, initialize_test_data
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0

    testsuites = [ &
        new_testsuite("moment", collect_moment) &
        ]

    call initialize_test_data()

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program tester

program example_dot_product
    use stdlib_kinds, only: sp
    use stdlib_intrinsics, only: stdlib_dot_product, stdlib_dot_product_kahan
    implicit none

    real(sp), allocatable :: x(:), y(:)
    real(sp) :: total_prod(3)

    allocate( x(1000), y(1000) )
    call random_number(x)
    call random_number(y)

    total_prod(1) = dot_product(x,y) !> compiler intrinsic
    total_prod(2) = stdlib_dot_product(x,y)       !> chunked summation over inner product
    total_prod(3) = stdlib_dot_product_kahan(x,y) !> chunked kahan summation over inner product
    print *, total_prod(1:3)
    
end program example_dot_product

program example_solve1
  use stdlib_linalg_constants, only: sp
  use stdlib_linalg, only: solve, linalg_state_type 
  implicit none

  real(sp), allocatable :: A(:,:),b(:),x(:)

  ! Solve a system of 3 linear equations: 
  !  4x + 3y + 2z =  25
  ! -2x + 2y + 3z = -10
  !  3x - 5y + 2z =  -4

  ! Note: Fortran is column-major! -> transpose 
  A = transpose(reshape([ 4, 3, 2, &
                         -2, 2, 3, &
                          3,-5, 2], [3,3])) 
  b = [25,-10,-4]

  ! Get coefficients of y = coef(1) + x*coef(2) + x^2*coef(3)
  x = solve(A,b) 

  print *, 'solution: ',x
  ! 5.0, 3.0, -2.0

end program example_solve1

! SPDX-Identifier: MIT

!> Implementation of the conversion to enumerator and identifier types to strings
submodule (stdlib_ansi) stdlib_ansi_operator
    use stdlib_string_type, only : operator(//)
    implicit none

contains

    !> Add two escape sequences, attributes in the right value override the left value ones.
    pure module function add(lval, rval) result(code)
        !> First escape code
        type(ansi_code), intent(in) :: lval
        !> Second escape code
        type(ansi_code), intent(in) :: rval
        !> Combined escape code
        type(ansi_code) :: code

        code%style = merge(rval%style, lval%style, rval%style >= 0)
        code%fg = merge(rval%fg, lval%fg, rval%fg >= 0)
        code%bg = merge(rval%bg, lval%bg, rval%bg >= 0)
    end function add

    !> Concatenate an escape code with a string and turn it into an actual escape sequence
    pure module function concat_left(lval, code) result(str)
        !> String to add the escape code to
        character(len=*), intent(in) :: lval
        !> Escape sequence
        type(ansi_code), intent(in) :: code
        !> Concatenated string
        character(len=:), allocatable :: str

        str = lval // to_string(code)
    end function concat_left

    !> Concatenate an escape code with a string and turn it into an actual escape sequence
    pure module function concat_right(code, rval) result(str)
        !> String to add the escape code to
        character(len=*), intent(in) :: rval
        !> Escape sequence
        type(ansi_code), intent(in) :: code
        !> Concatenated string
        character(len=:), allocatable :: str

        str = to_string(code) // rval
    end function concat_right

    !> Concatenate an escape code with a string and turn it into an actual escape sequence
    pure module function concat_left_str(lval, code) result(str)
        !> String to add the escape code to
        type(string_type), intent(in) :: lval
        !> Escape sequence
        type(ansi_code), intent(in) :: code
        !> Concatenated string
        type(string_type) :: str

        str = lval // to_string(code)
    end function concat_left_str

    !> Concatenate an escape code with a string and turn it into an actual escape sequence
    pure module function concat_right_str(code, rval) result(str)
        !> String to add the escape code to
        type(string_type), intent(in) :: rval
        !> Escape sequence
        type(ansi_code), intent(in) :: code
        !> Concatenated string
        type(string_type) :: str

        str = to_string(code) // rval
    end function concat_right_str

end submodule stdlib_ansi_operator

program example_check4
  use stdlib_error, only: check
  implicit none
  integer :: a = 1
! If a /= 5, stops the program with exit code 77 and prints 'a == 5 failed.'
  call check(a == 5, msg='a == 5 failed.', code=77)
end program example_check4

program example_moment
  use stdlib_stats, only: moment
  implicit none
  real :: x(1:6) = [1., 2., 3., 4., 5., 6.]
  real :: y(1:2, 1:3) = reshape([1., 2., 3., 4., 5., 6.], [2, 3])
  print *, moment(x, 2)                            !returns 2.9167
  print *, moment(y, 2)                            !returns 2.9167
  print *, moment(y, 2, 1)                         !returns [0.25, 0.25, 0.25]
  print *, moment(y, 2, 1, mask=(y > 3.))        !returns [NaN, 0., 0.25]
  print *, moment(x, 2, center=0.)               !returns 15.1667
  print *, moment(y, 1, 1, center=0.)            !returns [1.5, 3.5, 5.5]
end program example_moment

program example_corr
  use stdlib_stats, only: corr
  implicit none
  real :: x(1:6) = [1., 2., 3., 4., 5., 6.]
  real :: y(1:2, 1:3) = reshape([-1., 40., -3., 4., 10., 6.], [2, 3])
  print *, corr(x, 1)           !returns 1.
  print *, corr(y, 2)           !returns reshape([ 1., -.32480, -.32480, 1. ], [ 2, 3])
end program example_corr

program example_ansi_combine
  use stdlib_ansi, only : fg_color_red, style_bold, ansi_code, operator(+), to_string
  implicit none
  type(ansi_code) :: bold_red

  bold_red = fg_color_red + style_bold
  print '(a)', to_string(bold_red)
  
end program example_ansi_combine

program example_value
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0
  call set0%init(166)
  call set0%not()
  if (set0%all()) write (*, *) 'SET0 is properly initialized.'
  call set0%clear(165)
  if (set0%value(165) == 0) write (*, *) 'Bit 165 is cleared.'
  call set0%set(165)
  if (set0%value(165) == 1) write (*, *) 'Bit 165 is set.'
end program example_value

program example_ansi_concat
  use stdlib_ansi, only : fg_color_red, style_reset, operator(//)
  implicit none

  print '(a)', fg_color_red // "Colorized text message" // style_reset
end program example_ansi_concat

module test_loadtxt
    use stdlib_kinds, only: int32, sp, dp
    use stdlib_io, only: loadtxt, savetxt
    use testdrive, only: new_unittest, unittest_type, error_type, check
    implicit none

    private
    public :: collect_loadtxt
contains

    !> Collect all exported unit tests
    subroutine collect_loadtxt(testsuite)
        !> Collection of tests
        type(unittest_type), allocatable, intent(out) :: testsuite(:)

        testsuite = [ &
            new_unittest("loadtxt_int32", test_loadtxt_int32), &
            new_unittest("loadtxt_sp", test_loadtxt_sp), &
            new_unittest("loadtxt_sp_huge", test_loadtxt_sp_huge), &
            new_unittest("loadtxt_sp_tiny", test_loadtxt_sp_tiny), &
            new_unittest("loadtxt_dp", test_loadtxt_dp), &
            new_unittest("loadtxt_dp_max_skip", test_loadtxt_dp_max_skip), &
            new_unittest("loadtxt_dp_huge", test_loadtxt_dp_huge), &
            new_unittest("loadtxt_dp_tiny", test_loadtxt_dp_tiny), &
            new_unittest("loadtxt_complex", test_loadtxt_complex) &
        ]

    end subroutine collect_loadtxt


    subroutine test_loadtxt_int32(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        integer(int32), allocatable :: input(:,:), expected(:,:)
        real(sp), allocatable :: harvest(:,:)
        integer :: n
        allocate(harvest(10,10))
        allocate(input(10,10))
        allocate(expected(10,10))
        do n = 1, 10
            call random_number(harvest)
            input = int(harvest * 100)
            call savetxt('test_int32.txt', input)
            call loadtxt('test_int32.txt', expected)
            call check(error, all(input == expected),'Default list directed read failed')
            if (allocated(error)) return
            call loadtxt('test_int32.txt', expected, fmt='*')
            call check(error, all(input == expected),'User specified list directed read faile')
            if (allocated(error)) return
            call savetxt('test_int32.txt', input, delimiter=',')
            call loadtxt('test_int32.txt', expected, delimiter=',')
            call check(error, all(input == expected),'User specified delimiter `,` read failed')
            if (allocated(error)) return
            call savetxt('test_int32.txt', input, delimiter='-')
            call loadtxt('test_int32.txt', expected, delimiter='-')
            call check(error, all(input == expected),'User specified delimiter `-` read failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_int32


    subroutine test_loadtxt_sp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(sp), allocatable :: input(:,:), expected(:,:)
        character(len=*), parameter :: FMT_REAL_SP = '(es15.8e2)'
        integer :: n

        allocate(input(10,10))
        allocate(expected(10,10))
        do n = 1, 10
            call random_number(input)
            input = input - 0.5
            call savetxt('test_sp.txt', input)
            call loadtxt('test_sp.txt', expected)
            call check(error, all(input == expected),'Default format read failed')
            if (allocated(error)) return
            call loadtxt('test_sp.txt', expected, fmt='*')
            call check(error, all(input == expected),'List directed read failed')
            if (allocated(error)) return
            call loadtxt('test_sp.txt', expected, fmt="(*"//FMT_REAL_sp(1:len(FMT_REAL_sp)-1)//",1x))")
            call check(error, all(input == expected),'User specified format failed')
            if (allocated(error)) return
            call savetxt('test_sp.txt', input, delimiter=',')
            call loadtxt('test_sp.txt', expected, delimiter=',')
            call check(error, all(input == expected),'User specified delimiter `,` read failed')
            if (allocated(error)) return
            call savetxt('test_sp.txt', input, delimiter=';')
            call loadtxt('test_sp.txt', expected, delimiter=';')
            call check(error, all(input == expected),'User specified delimiter `;` read failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_sp


    subroutine test_loadtxt_sp_huge(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(sp), allocatable :: input(:,:), expected(:,:)
        integer :: n
        character(len=*), parameter :: FMT_REAL_SP = '(es15.8e2)'
        
        allocate(input(10,10))
        allocate(expected(10,10))

        do n = 1, 10
            call random_number(input)
            input = (input - 0.5) * huge(input)
            call savetxt('test_sp_huge.txt', input)
            call loadtxt('test_sp_huge.txt', expected)
            call check(error, all(input == expected),'Default format read failed')
            if (allocated(error)) return
            call loadtxt('test_sp_huge.txt', expected, fmt='*')
            call check(error, all(input == expected),'List directed read failed')
            if (allocated(error)) return
            call loadtxt('test_sp_huge.txt', expected, fmt="(*"//FMT_REAL_sp(1:len(FMT_REAL_sp)-1)//",1x))")
            call check(error, all(input == expected),'User specified format failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_sp_huge


    subroutine test_loadtxt_sp_tiny(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(sp), allocatable :: input(:,:), expected(:,:)
        integer :: n
        character(len=*), parameter :: FMT_REAL_SP = '(es15.8e2)'

        allocate(input(10,10))
        allocate(expected(10,10))

        do n = 1, 10
            call random_number(input)
            input = (input - 0.5) * tiny(input)
            call savetxt('test_sp_tiny.txt', input)
            call loadtxt('test_sp_tiny.txt', expected)
            call check(error, all(input == expected),'Default format read failed')
            if (allocated(error)) return
            call loadtxt('test_sp_tiny.txt', expected, fmt='*')
            call check(error, all(input == expected),'List directed read failed')
            if (allocated(error)) return
            call loadtxt('test_sp_tiny.txt', expected, fmt="(*"//FMT_REAL_sp(1:len(FMT_REAL_sp)-1)//",1x))")
            call check(error, all(input == expected),'User specified format failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_sp_tiny


    subroutine test_loadtxt_dp(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(dp), allocatable :: input(:,:), expected(:,:)
        integer :: n
        character(len=*), parameter :: FMT_REAL_DP = '(es24.16e3)'

        allocate(input(10,10))
        allocate(expected(10,10))

        do n = 1, 10
            call random_number(input)
            input = input - 0.5
            call savetxt('test_dp.txt', input)
            call loadtxt('test_dp.txt', expected)
            call check(error, all(input == expected),'Default format read failed')
            if (allocated(error)) return
            call loadtxt('test_dp.txt', expected, fmt='*')
            call check(error, all(input == expected),'List directed read failed')
            if (allocated(error)) return
            call loadtxt('test_dp.txt', expected, fmt="(*"//FMT_REAL_dp(1:len(FMT_REAL_dp)-1)//",1x))")
            call check(error, all(input == expected),'User specified format failed')
            if (allocated(error)) return
            call savetxt('test_dp.txt', input, delimiter=',')
            call loadtxt('test_dp.txt', expected, delimiter=',')
            call check(error, all(input == expected),'User specified delimiter read failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_dp


    subroutine test_loadtxt_dp_max_skip(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(dp), allocatable :: input(:,:), expected(:,:)
        integer :: n, m
        character(len=*), parameter :: FMT_REAL_DP = '(es24.16e3)'

        allocate(input(10,10))

        do m = 0, 5
            do n = 1, 11
                call random_number(input)
                input = input - 0.5
                call savetxt('test_dp_max_skip.txt', input)
                call loadtxt('test_dp_max_skip.txt', expected, skiprows=m, max_rows=n)
                call check(error, all(input(m+1:min(n+m,10),:) == expected),'Default format read failed')
                if (allocated(error)) return
                call loadtxt('test_dp_max_skip.txt', expected, skiprows=m, max_rows=n, fmt='*')
                call check(error, all(input(m+1:min(n+m,10),:) == expected),'List directed read failed')
                if (allocated(error)) return
                call loadtxt('test_dp_max_skip.txt', expected, fmt="(*"//FMT_REAL_dp(1:len(FMT_REAL_dp)-1)//",1x))")
                call check(error, all(input == expected),'User specified format failed')
                deallocate(expected)
                if (allocated(error)) return
            end do
        end do

    end subroutine test_loadtxt_dp_max_skip


    subroutine test_loadtxt_dp_huge(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(dp), allocatable :: input(:,:), expected(:,:)
        integer :: n
        character(len=*), parameter :: FMT_REAL_DP = '(es24.16e3)'

        allocate(input(10,10))
        allocate(expected(10,10))

        do n = 1, 10
            call random_number(input)
            input = (input - 0.5) * huge(input)
            call savetxt('test_dp_huge.txt', input)
            call loadtxt('test_dp_huge.txt', expected)
            call check(error, all(input == expected),'Default format read failed')
            if (allocated(error)) return
            call loadtxt('test_dp_huge.txt', expected, fmt='*')
            call check(error, all(input == expected),'List directed read failed')
            if (allocated(error)) return
            call loadtxt('test_dp_huge.txt', expected, fmt="(*"//FMT_REAL_dp(1:len(FMT_REAL_dp)-1)//",1x))")
            call check(error, all(input == expected),'User specified format failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_dp_huge


    subroutine test_loadtxt_dp_tiny(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        real(dp), allocatable :: input(:,:), expected(:,:)
        integer :: n
        character(len=*), parameter :: FMT_REAL_DP = '(es24.16e3)'
        
        allocate(input(10,10))
        allocate(expected(10,10))

        do n = 1, 10
            call random_number(input)
            input = (input - 0.5) * tiny(input)
            call savetxt('test_dp_tiny.txt', input)
            call loadtxt('test_dp_tiny.txt', expected)
            call check(error, all(input == expected),'Default format read failed')
            if (allocated(error)) return
            call loadtxt('test_dp_tiny.txt', expected, fmt='*')
            call check(error, all(input == expected),'List directed read failed')
            if (allocated(error)) return
            call loadtxt('test_dp_tiny.txt', expected, fmt="(*"//FMT_REAL_dp(1:len(FMT_REAL_dp)-1)//",1x))")
            call check(error, all(input == expected),'User specified format failed')
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_dp_tiny


    subroutine test_loadtxt_complex(error)
        !> Error handling
        type(error_type), allocatable, intent(out) :: error
        complex(dp), allocatable :: input(:,:), expected(:,:)
        real(dp), allocatable :: re(:,:), im(:,:)
        integer :: n
        character(len=*), parameter :: FMT_COMPLEX_DP = '(es24.16e3,1x,es24.16e3)'

        allocate(re(10,10))
        allocate(im(10,10))
        allocate(input(10,10))
        allocate(expected(10,10))

        do n = 1, 10
            call random_number(re)
            call random_number(im)
            input = cmplx(re, im)
            call savetxt('test_complex.txt', input)
            call loadtxt('test_complex.txt', expected)
            call check(error, all(input == expected))
            call loadtxt('test_complex.txt', expected, fmt="(*"//FMT_COMPLEX_dp(1:len(FMT_COMPLEX_dp)-1)//",1x))")
            call check(error, all(input == expected))
            if (allocated(error)) return
            call savetxt('test_complex.txt', input, delimiter=',')
            call loadtxt('test_complex.txt', expected, delimiter=',')
            call check(error, all(input == expected))
            if (allocated(error)) return
            call savetxt('test_complex.txt', input, delimiter=';')
            call loadtxt('test_complex.txt', expected, delimiter=';')
            call check(error, all(input == expected))
            if (allocated(error)) return
        end do

    end subroutine test_loadtxt_complex

end module test_loadtxt


program tester
    use, intrinsic :: iso_fortran_env, only : error_unit
    use testdrive, only : run_testsuite, new_testsuite, testsuite_type
    use test_loadtxt, only : collect_loadtxt
    implicit none
    integer :: stat, is
    type(testsuite_type), allocatable :: testsuites(:)
    character(len=*), parameter :: fmt = '("#", *(1x, a))'

    stat = 0
    testsuites = [ &
        new_testsuite("loadtxt", collect_loadtxt) &
        ]

    do is = 1, size(testsuites)
        write(error_unit, fmt) "Testing:", testsuites(is)%name
        call run_testsuite(testsuites(is)%collect, error_unit, stat)
    end do

    if (stat > 0) then
        write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
        error stop
    end if

end program tester

! Illustrate the usage of `exists`
program example_exists
    use stdlib_system, only: exists, fs_type_unknown, fs_type_regular_file, &
        fs_type_directory, fs_type_symlink
    use stdlib_error, only: state_type
    implicit none

    type(state_type) :: err

    ! Path to check
    character(*), parameter :: path = "path/to/check"
    ! To get the type of the path
    integer :: t

    t = exists(path, err)

    if (err%error()) then
        ! An error occured, print it
        print *, err%print()
    end if

    ! switching on the type returned by `exists`
    select case (t)
    case (fs_type_unknown); print *, "Unknown type!"
    case (fs_type_regular_file); print *, "Regular File!"
    case (fs_type_directory); print *, "Directory!"
    case (fs_type_symlink); print *, "Symbolic Link!"
    end select
end program example_exists

!! The module STDLIB_HASHMAP_CHAINING implements a simple separate
!! chaining hash map. The implementation is loosely based on a C
!! implementation by David Chase, http://chasewoerner.org/src/hasht/, for
!! which he has given permission to use in the Fortran Standard Library.

! Note an error in the code caused attempts to deallocate already deallocated
! entries. This did not cause stat to be non-zero, but did cause system errors,
! on my Mac. I therefore decided to remove all deallocation error reporting.

submodule(stdlib_hashmaps) stdlib_hashmap_chaining
!! Version: Experimental
!!
!! Implements a simple separate chaining hash map.

    implicit none

! Error messages
    character(len=*), parameter ::                                            &
        alloc_inv_fault    = "CHAINING_HASHMAP_TYPE % INVERSE allocation " // &
                             "fault.",                                        &
        alloc_slots_fault  = "CHAINING_HASHMAP_TYPE % SLOTS allocation " //   &
                             "fault.",                                        &
        conflicting_key    = "KEY already exists in MAP.",                    &
        expand_slots_fail  = "CHAINING_HASHMAP_TYPE % SLOTS allocation > " // &
                             "max bits.",                                     &
        init_slots_pow_fail = "SLOT_BITS is not between DEFAULT_BITS " //     &
                              "and MAX_BITS.",                                &
        invalid_inmap      = "INMAP was not a valid INVERSE index.",          &
        map_consist_fault  = "The hash map found a inconsistency."

    character(len=*), parameter :: submodule_name = "STDLIB_HASHMAP_CHAINING"

    interface expand_slots
!! Version: Experimental
!!
!! Interface to internal procedure that expands the number of map slots.
        module procedure expand_chaining_slots
    end interface expand_slots

    interface extend_map_entry_pool
!! Version: Experimental
!!
!! Interface to internal procedure that expands a chaining map entry pool.
        module procedure extend_chaining_map_entry_pool
    end interface extend_map_entry_pool

    interface free_map
!! Version: Experimental
!!
!! Interface to procedure that finalizes a chaining hash map.
        module procedure free_chaining_map
    end interface free_map

    interface free_map_entry_pool
!! Version: Experimental
!!
!! Interface to internal procedure that finalizes a chaining hash map
!! entry pool.
        module procedure free_map_entry_pool
    end interface free_map_entry_pool

    interface get_other_data
!! Version: Experimental
!!
!! Interface to procedure that gets an entry's other data.
        module procedure get_other_chaining_data
    end interface get_other_data

    interface init
!! Version: Experimental
!!
!! Interface to initialization procedure for a chaining hash map.
        module procedure init_chaining_map
    end interface init

    interface rehash
!! Version: Experimental
!!
!! Interface to a procedure that changes the hash function that
!! is used to map the keys into a chaining hash map.
        module procedure rehash_chaining_map
    end interface rehash

    interface remove
!! Version: Experimental
!!
!! Interface to a procedure that removes the entry associated with a key
        module procedure remove_chaining_entry ! Chase's delent
    end interface remove

    interface set_other_data
!! Version: Experimental
!!
!! Interface to a procedure that changes the other data associated with a key
        module procedure set_other_chaining_data
    end interface set_other_data

contains

!  Internal routine to make a duplicate map with more hash slots.
!  Note David Chase had pointer returning functions, but the logic did not
!  depend on the result value
    subroutine expand_chaining_slots( map )
!! Version: Experimental
!!
!! Internal routine to make a duplicate map with more hash slots.
!! Doubles the size of the map % slots array
!! Arguments:
!!     map - the hash map whose hash slots are to be expanded
!
        type(chaining_hashmap_type), intent(inout) :: map

        type(chaining_map_entry_type), pointer    :: current_entry
        type(chaining_map_entry_ptr), allocatable :: dummy_slots(:)
        integer(int_index)                        :: min_size, new_size
        integer(int_index)                        :: old_size, &
                                                     slot_index
        integer(int32)                            :: bits, &
                                                     stat
        character(256) :: errmsg
        character(*), parameter :: procedure = 'EXPAND_SLOTS'

        if ( map % nbits == max_bits ) then
            error stop submodule_name // ' % ' // procedure // ': ' // &
                expand_slots_fail
        end if

        old_size = size(map % slots, kind=int_index)

       determine_new_size: if ( map % num_entries <= old_size ) then
! Expand by factor of two to improve efficiency
            new_size = 2*old_size
            bits = map % nbits + 1
        else
! Expand so the number of slots is no more than 2**max_bits but otherwise
! at least the number of entries
            min_size = map % num_entries
            new_size = old_size
            bits = map % nbits
            do
                bits = bits + 1
                new_size = new_size * 2
                if ( bits >= max_bits .OR. new_size >= min_size ) exit
            end do
        end if determine_new_size

        allocate( dummy_slots(0:new_size-1), stat=stat, errmsg=errmsg )
        if (stat /= 0) then
            write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
            error stop submodule_name // ' % ' // procedure // ': ' // &
                alloc_slots_fault
        end if

        map % nbits = bits
        do slot_index=0, new_size-1
            dummy_slots(slot_index) % target => null() ! May be redundant
        end do

        map % total_probes = map % total_probes + map % probe_count
        map % probe_count = 0

! This maps old slots entries to new slots, but we could also map inverse
! entries to new_slots
        do slot_index=0, old_size-1
            do while( associated(map % slots(slot_index) % target) )
                current_entry => map % slots(slot_index) % target
                map % slots(slot_index) % target => current_entry % next
                call remap( dummy_slots, current_entry, map % nbits )
            end do
        end do

        call move_alloc( dummy_slots, map % slots )

    contains

        subroutine remap(slots, gentry, bits)
            type(chaining_map_entry_ptr), intent(inout)          :: slots(0:)
            type(chaining_map_entry_type), intent(inout), target :: gentry
            integer(int_hash), intent(in)                        :: bits

            integer(int_index)                     :: hash_index
            type(chaining_map_entry_type), pointer :: where_loc

            hash_index = fibonacci_hash( gentry % hash_val, bits )
            where_loc => slots(hash_index) % target
            gentry % next => null() ! May be redundant

            if ( associated( where_loc ) ) then
                do while ( associated(where_loc % next) )
                    where_loc => where_loc % next
                end do
                where_loc % next => gentry
            else
                slots(hash_index) % target => gentry
            end if

        end subroutine remap

    end subroutine expand_chaining_slots


    subroutine extend_chaining_map_entry_pool(map) ! gent_pool_new
!! Version: Experimental
!!
!! Add more map_entrys to the pool head
!! Arguments:
!!     pool - a chaining map entry pool
        type(chaining_hashmap_type), intent(inout) :: map

        type(chaining_map_entry_pool), pointer :: pool

        allocate(pool)
        allocate(pool % more_map_entries(0:pool_size-1))
        pool % next = 0 ! may be redundant
        pool % lastpool => map % cache
        map % cache => pool

    end subroutine extend_chaining_map_entry_pool


!  Internal final routine to free a map and its memory
    module subroutine free_chaining_map( map )
!! Version: Experimental
!!
!! Frees internal memory of an chaining map
!! Arguments:
!!     map - the chaining hash map whose memory is to be freed
!
        type(chaining_hashmap_type), intent(inout) :: map

        integer(int_index) :: i
        type(chaining_map_entry_type), pointer :: next

        if ( allocated( map % slots ) ) then
            remove_slot_links: do i=0, size( map % slots ) - 1
                if ( associated( map % slots(i) % target ) ) then
                    map % slots(i) % target => null()
                end if
            end do remove_slot_links
            deallocate( map % slots )
        end if

        if ( allocated( map % inverse) ) then
            remove_links: do i=1, size( map % inverse, kind=int_index )
                if ( associated( map % inverse(i) % target ) ) then
                    map % inverse(i) % target % next => null()
                end if
                map % inverse(i) % target => null()
            end do remove_links
            deallocate( map % inverse )
        end if

        free_free_list: do
            if ( associated( map % free_list) ) then
                next => map % free_list % next
                map % free_list => next
                cycle free_free_list
            else
                map % num_free = 0
                exit free_free_list
            end if
        end do free_free_list

        if ( associated( map % cache ) ) call free_map_entry_pool(map % cache)

        map % num_entries = 0

    end subroutine free_chaining_map


    recursive subroutine free_map_entry_pool(pool) ! gent_pool_free
!! Version: Experimental
!!
!! Recursively descends map entry pool list freeing each element
!! Arguments:
!!     pool  The map entry pool whose elements are to be freed
!
        type(chaining_map_entry_pool), intent(inout), pointer :: pool

        if ( .not.  associated(pool) ) return
        call free_map_entry_pool(pool % lastpool)
        deallocate( pool )

    end subroutine free_map_entry_pool


    module subroutine get_all_chaining_keys(map, all_keys)
!! Version: Experimental
!!
!! Returns all the keys contained in a hash map
!! Arguments:
!!     map - a chaining hash map
!!     all_keys - all the keys contained in a hash map
!
        class(chaining_hashmap_type), intent(in) :: map
        type(key_type), allocatable, intent(out) :: all_keys(:)
        
        integer(int32) :: num_keys
        integer(int_index) :: i, key_idx

        num_keys = map % entries()
        allocate( all_keys(num_keys) )
        if ( num_keys == 0 ) return

        if( allocated( map % inverse ) ) then
            key_idx = 1_int_index
            do i=1_int_index, size( map % inverse, kind=int_index )
                if ( associated( map % inverse(i) % target ) ) then
                    all_keys(key_idx) = map % inverse(i) % target % key
                    key_idx = key_idx + 1_int_index
                end if
            end do 
        end if

    end subroutine get_all_chaining_keys


    module subroutine get_other_chaining_data( map, key, other, exists )
!! Version: Experimental
!!
!! Returns the other data associated with the inverse table index
!! Arguments:
!!     map    - a chaining hash map
!!     key    - the key associated with a map entry
!!     other  - the other data associated with the key
!!     exists - a logical flag indicating whether an entry with that key exists
!
        class(chaining_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)                  :: key
        class(*), allocatable, intent(out)          :: other
        logical, intent(out), optional              :: exists

        integer(int_index) :: inmap
        character(*), parameter :: procedure = 'GET_OTHER_DATA'

        call in_chain_map(map, inmap, key)
        if ( inmap <= 0 .or. &
             inmap > size(map % inverse, kind=int_index ) ) then
            if ( present(exists) ) then
                exists = .false.
                return
            else
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    invalid_inmap
            end if
        else if ( associated( map % inverse(inmap) % target ) ) then
            if (present(exists) ) exists = .true.
            other = map % inverse(inmap) % target % other
        else
            if ( present(exists) ) then
                exists = .false.
                return
            else
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    map_consist_fault
            end if
        end if

    end subroutine get_other_chaining_data


    subroutine in_chain_map(map, inmap, key)
!! Version: Experimental
!!
!! Returns the index into the INVERSE array associated with the KEY
!! Arguments:
!!     map   - the hash map of interest
!!     inmap - the returned index into the INVERSE array of entry pointers.
!!             A value of zero indicates that an entry with that key was not
!!             found.
!!     key   - the key identifying the entry of interest
!
        class(chaining_hashmap_type), intent(inout) :: map
        integer(int_index), intent(out)             :: inmap
        type(key_type), intent(in)                  :: key

        integer(int_hash)                      :: hash_val, hash_index
        type(chaining_map_entry_type), pointer :: gentry, pentry, sentry

        if ( map % probe_count > inmap_probe_factor * map % call_count ) then
            if ( map % nbits < max_bits .AND. &
                 map % num_entries > size( map % slots, kind=int_index ) ) then
                call expand_slots(map)
            end if
        end if
        map % call_count = map % call_count + 1
        hash_val = map % hasher( key )
        hash_index = fibonacci_hash( hash_val, map % nbits )
        pentry => map % slots(hash_index) % target
        sentry => pentry

        climb_chain: do
            gentry => pentry
            map % probe_count = map % probe_count + 1
            if (.not. associated( gentry ) ) then
                inmap = 0
                return
            else if ( hash_val == gentry % hash_val ) then
                if ( key == gentry % key ) then
! The swap to front seems to confuse gfortran's pointers
!                    if ( .not. associated( pentry, sentry ) ) then
!                    ! swap to front
!                        pentry => gentry % next
!                        gentry % next => sentry
!                        sentry => gentry
!                    end if
                    inmap = gentry % inmap
                    return
                end if
            end if
            pentry => gentry % next
        end do climb_chain

    end subroutine in_chain_map


    module subroutine init_chaining_map( map,        &
                                         hasher,     &
                                         slots_bits, &
                                         status )
!! Version: Experimental
!!
!! Routine to allocate an empty map with HASHER as the hash function,
!! 2**SLOTS_BITS initial SIZE(map % slots), and SIZE(map % slots) limited
!! to a maximum of 2**MAX_BITS. All fields are initialized.
!! Arguments:
!!     map         - the chaining hash map to be initialized
!!     hasher      - the hash function to be used to map keys to slots
!!     slots_bits - the bits of two used to initialize the number of slots
!!     status      - an integer error status flag with the allowed values:
!!         success - no problems were found
!!         alloc_fault - map % slots or map % inverse could not be allocated
!!         array_size_error - slots_bits is less than default_bits or
!!             greater than max_bits
!
        class(chaining_hashmap_type), intent(out)  :: map
        procedure(hasher_fun), optional            :: hasher
        integer, intent(in), optional              :: slots_bits
        integer(int32), intent(out), optional      :: status

        character(256)          :: errmsg
        integer(int_index)      :: index
        character(*), parameter :: procedure = 'INIT'
        integer(int_index)      :: slots
        integer(int32)          :: stat

        map % call_count = 0
        map % probe_count = 0
        map % total_probes = 0

        ! Check if user has specified a hasher other than the default hasher.
        if (present(hasher)) map % hasher => hasher      
            
        call free_chaining_map( map )

        if ( present(slots_bits) ) then
            if ( slots_bits < 6 .OR. slots_bits > max_bits ) then
                if ( present(status) ) then
                    status = array_size_error
                    return
                else
                    error stop submodule_name // ' % ' // procedure // ': ' // &
                        init_slots_pow_fail
                end if
            end if
            map % nbits = slots_bits
        else
            map % nbits = min( default_bits, max_bits )
        end if

        slots = 2_int_index**map % nbits

        allocate( map % slots(0:slots-1), stat=stat, errmsg=errmsg )
        if ( stat /= 0 ) then
            if ( present(status) ) then
                status = alloc_fault
                return
            else
                write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    alloc_slots_fault
            end if
        end if
        do index = 0, size( map % slots, kind=int_index )-1
            map % slots(index) % target => null() ! May be redundant
        end do

! 5*s from Chase's g_new_map
        allocate( map % inverse(1:slots), stat=stat, errmsg=errmsg )
        if ( stat /= 0 ) then
            if ( present( status ) ) then
                status = alloc_fault
                return
            else
                write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    alloc_inv_fault
            end if
        end if
        do index=1, size(map % inverse, kind=int_index)
            map % inverse(index) % target => null()
        end do

        call extend_map_entry_pool(map)

        map % initialized = .true.
        
        if (present(status) ) status = success

    end subroutine init_chaining_map


    pure module function chaining_loading( map )
!! Version: Experimental
!!
!! Returns the number of entries relative to slots in a hash map
!! Arguments:
!!      map - a chaining hash map
        class(chaining_hashmap_type), intent(in) :: map
        real :: chaining_loading

        chaining_loading = real( map % num_entries ) / &
                           real( size( map % slots, kind=int_index ) )

    end function chaining_loading


    module subroutine map_chain_entry(map, key, other, conflict)
!! Version: Experimental
!!
!! Inserts an entry into the hash table
!! Arguments:
!!     map      - the hash table of interest
!!     key      - the key identifying the entry
!!     other    - other data associated with the key
!!     conflict - logical flag indicating whether the entry key conflicts
!!                 with an existing key
!
        class(chaining_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)                  :: key
        class(*), intent(in), optional              :: other
        logical, intent(out), optional              :: conflict

        integer(int_hash)                      :: hash_index
        integer(int_hash)                      :: hash_val
        integer(int_index)                     :: inmap
        type(chaining_map_entry_type), pointer :: new_ent
        type(chaining_map_entry_type), pointer :: gentry, pentry, sentry
        character(*), parameter :: procedure = 'MAP_ENTRY'

        ! Check that map is initialized.  
        if (.not. map % initialized) call init_chaining_map( map )
        
        hash_val = map % hasher( key )

        if ( map % probe_count > map_probe_factor * map % call_count ) then
            call expand_slots(map)
        end if
        map % call_count = map % call_count + 1
        hash_index = fibonacci_hash( hash_val, map % nbits )
        pentry => map % slots(hash_index) % target
        sentry => pentry

        do
            gentry => pentry
            map % probe_count = map % probe_count + 1
            if ( .not. associated( gentry ) ) then
                call allocate_chaining_map_entry( map, new_ent )
                new_ent % hash_val = hash_val
! Adding to tail of chain doesn't work on gfortran
!                new_ent % next => sentry
!                sentry => new_ent
! Adding to head of chain works on gfortran
                new_ent % next => map % slots(hash_index) % target
                map % slots(hash_index) % target => new_ent
                call copy_key( key, new_ent % key )
                if ( present(other) ) new_ent % other = other
                if ( new_ent % inmap == 0 ) then
                    map % num_entries = map % num_entries + 1
                    inmap = map % num_entries
                else
                    inmap = new_ent % inmap
                end if

                if ( inmap == size( map % inverse, kind=int_index ) ) then
                    call expand_inverse( map )
                end if
                new_ent % inmap = inmap
                map % inverse(inmap) % target => new_ent
                if ( present(conflict) ) conflict = .false.

                return

            else if ( hash_val == gentry % hash_val ) then
                if ( key == gentry % key ) then
                    inmap = gentry % inmap
                    if ( .not. associated( pentry, sentry ) ) then
                        ! Swap to front
                        pentry => gentry % next
                        gentry % next => sentry
                        sentry => gentry
                    end if
                    if ( present(conflict) ) then
                        conflict = .true.
                    else
                        error stop submodule_name // ' % ' // procedure &
                                  // ': ' // conflicting_key
                    end if
                    return
                end if
            end if
            pentry => gentry % next

        end do

    contains

        subroutine allocate_chaining_map_entry(map, bucket) ! Chases gent_malloc
!         allocates a hash bucket
            type(chaining_hashmap_type), intent(inout)         :: map
            type(chaining_map_entry_type), pointer, intent(out) :: bucket

            type(chaining_map_entry_pool), pointer :: pool

            pool => map % cache
            map % num_entries = map % num_entries + 1
            if ( associated(map % free_list) ) then
!             Get hash bucket from free_list
                bucket         => map % free_list
                map % free_list => bucket % next
                map % num_free = map % num_free - 1
            else
!             Get hash bucket from pool
                if ( pool % next == pool_size ) then
!                 Expand pool
                    call extend_map_entry_pool(map)
                    pool => map % cache
                end if
                bucket      => pool % more_map_entries(pool % next)
                pool % next =  pool % next + 1 ! 0s based
                if ( map % num_entries > &
                     size( map % inverse, kind=int_index ) ) &
                    then
                    call expand_inverse( map )
                end if
                bucket % inmap = map % num_entries
            end if

        end subroutine allocate_chaining_map_entry


        subroutine expand_inverse(map)
!         Increase size of map % inverse
            type(chaining_hashmap_type), intent(inout) :: map
            type(chaining_map_entry_ptr), allocatable  :: dummy_inverse(:)
            integer(int32) :: stat
            character(256) :: errmsg
            character(*), parameter :: procedure = 'MAP_ENTRY'

            allocate( dummy_inverse( 1:2*size(map % inverse,     &
                                              kind=int_index) ), &
                      stat=stat,                                 &
                      errmsg=errmsg )
            if ( stat /= 0 ) then
                write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    alloc_inv_fault
            end if

            dummy_inverse(1:size(map % inverse, kind=int_index)) = &
                map % inverse(:)

            call move_alloc( dummy_inverse, map % inverse )

        end subroutine expand_inverse

    end subroutine map_chain_entry


    module subroutine rehash_chaining_map( map, hasher )
!! Version: Experimental
!!
!! Changes the hashing method of the table entries to that of HASHER.
!! Arguments:
!!     map    the table to be rehashed
!!     hasher the hasher function to be used for the table
!
        class(chaining_hashmap_type), intent(inout) :: map
        procedure(hasher_fun)                       :: hasher

        integer(int_hash)  :: hash_val
        integer(int_index) :: i
        integer(int_index) :: index

        map % hasher => hasher

        do i=0, size( map % slots, kind=int_index ) - 1
            map % slots(i) % target => null()
        end do

        do i=1, map % num_entries + map % num_free
            if ( .not. associated( map % inverse(i) % target ) ) cycle
            hash_val = map % hasher ( map % inverse(i) % target % key )
            map % inverse(i) % target % hash_val = hash_val
            index = fibonacci_hash( hash_val, map % nbits )
            map % inverse(i) % target % inmap = i
            if ( associated( map % slots(index) % target ) ) then
                map % inverse(i) % target % next => map % slots(index) % target
                map % slots(index) % target => map % inverse(i) % target
            else
                map % slots(index) % target => map % inverse(i) % target
                map % slots(index) % target % next => null()
            end if
        end do

    end subroutine rehash_chaining_map


    module subroutine remove_chaining_entry(map, key, existed)
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
        class(chaining_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)                  :: key
        logical, intent(out), optional              :: existed

        type(chaining_map_entry_type), pointer :: bucket, aentry, bentry, centry
        integer(int_hash)                      :: hash_val
        integer(int_index)                     :: inmap, k, level

        call in_chain_map( map, inmap, key )
        if ( inmap < 1 .or. inmap > size( map % inverse ) ) then
            if ( present( existed ) ) existed = .false.
            return
        end if

        bucket => map % inverse(inmap) % target
        if ( .not. associated(bucket) ) then
            if ( present( existed ) ) existed = .false.
            return
        end if
        if ( present(existed) ) existed = .true.
        hash_val = bucket % hash_val
        k = fibonacci_hash( hash_val, map % nbits )
        allocate(aentry)
        aentry => map % slots(k) % target
        if ( associated(aentry) ) then
            if ( aentry % inmap == inmap ) then
                bentry => aentry % next
                map % slots(k) % target => bentry
                aentry % next => map % free_list
                map % free_list => aentry
                map % inverse(inmap) % target => null()
                map % num_free = map % num_free + 1
                map % num_entries = map % num_entries - 1
                return
            end if
        else
            return
        end if
        level = 1
        centry => map % slots(k) % target
        aentry => aentry % next

        FIND_SLOTS_ENTRY:do
            if ( .not. associated(aentry) ) return
            if ( aentry % inmap == inmap ) exit
            centry => aentry
            aentry => aentry % next
            level = level + 1
        end do FIND_SLOTS_ENTRY

        bentry => aentry % next
        aentry % next => map % free_list
        map % free_list => aentry
        centry % next => bentry
        map % inverse(inmap) % target => null()
        map % num_free = map % num_free + 1
        map % num_entries = map % num_entries - 1

    end subroutine remove_chaining_entry


    module subroutine set_other_chaining_data( map, key, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     key    - the key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!
        class(chaining_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)                  :: key
        class(*), intent(in)                        :: other
        logical, intent(out), optional              :: exists

        integer(int_index) :: inmap
        character(*), parameter :: procedure = 'SET_OTHER_DATA'

        call in_chain_map( map, inmap, key )
        if ( inmap <= 0 .or. inmap > size( map % inverse, kind=int_index ) ) &
            then
            if ( present(exists) ) then
                exists = .false.
                return
            else
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    invalid_inmap
            end if
        else if ( associated( map % inverse(inmap) % target ) ) then
            map % inverse(inmap) % target % other = other
            if ( present(exists) ) exists = .true.
            return
        else
            error stop submodule_name // ' % ' // procedure // ': ' // &
                invalid_inmap
        end if

    end subroutine set_other_chaining_data


    module function total_chaining_depth( map ) result(total_depth)
!! Version: Experimental
!!
!! Returns the total number of ones based offsets of slot entries from
!! their slot index for a hash map
!! Arguments:
!!     map - an chaining hash map
        class(chaining_hashmap_type), intent(in) :: map
        integer(int_depth)                       :: total_depth

        type(chaining_map_entry_type), pointer :: current_key
        integer(int_index) :: slot, slots
        integer(int_depth) :: index

        total_depth = 0_int_depth
        slots = size( map % slots, kind=int_index )
        do slot=0, slots-1
            current_key => map % slots(slot) % target
            index = 0_int_depth
            do while( associated(current_key) )
                index = index + 1_int_depth
                total_depth = total_depth + index
                current_key => current_key % next
            end do
        end do

    end function total_chaining_depth


    module subroutine chaining_key_test(map, key, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY is present in the hash map
!! Arguments:
!!     map     - the hash map of interest
!!     key     - the key of interest
!!     present - a logical flag indicating whether key is present in map
!
        class(chaining_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)                  :: key
        logical, intent(out)                        :: present

        integer(int_index) :: inmap

        call in_chain_map( map, inmap, key )
        if ( inmap <= 0 .or. inmap > size( map % inverse, kind=int_index ) ) &
            then
            present = .false.
        else
            present = associated( map % inverse(inmap) % target )
        end if

    end subroutine chaining_key_test


end submodule stdlib_hashmap_chaining

program example_getline
  use, intrinsic :: iso_fortran_env, only: input_unit, output_unit
  use stdlib_io, only: get_line
  implicit none
  character(len=:), allocatable :: line
  integer :: stat

  call get_line(input_unit, line, stat)
  do while (stat == 0)
    write (output_unit, '(a)') line
    call get_line(input_unit, line, stat)
  end do
end program example_getline

program example_matmul
    use stdlib_intrinsics, only: stdlib_matmul
    complex :: x(2, 2), y(2, 2), z(2, 2)

    x = reshape([(0, 0), (1, 0), (1, 0), (0, 0)], [2, 2])  ! pauli x-matrix
    y = reshape([(0, 0), (0, 1), (0, -1), (0, 0)], [2, 2]) ! pauli y-matrix
    z = reshape([(1, 0), (0, 0), (0, 0), (-1, 0)], [2, 2]) ! pauli z-matrix

    print *, stdlib_matmul(x, y) ! should be iota*z
    print *, stdlib_matmul(y, z, x) ! should be iota*identity
    print *, stdlib_matmul(x, x, z, y) ! should be -iota*x
    print *, stdlib_matmul(x, x, z, y, y) ! should be z
end program example_matmul

program example_trapz
  use stdlib_quadrature, only: trapz
  implicit none
  real, parameter :: x(5) = [0., 1., 2., 3., 4.]
  real :: y(5) = x**2
  print *, trapz(y, x)
! 22.0
  print *, trapz(y, 0.5)
! 11.0
end program example_trapz

!! The module STDLIB_HASHMAP_WRAPPERS provides wrappers for various
!! entities used by the hash map procedures. These include wrappers for the
!! `key` and `other` data, and hashing procedures to operate on entities of
!! the `key_type`.

module stdlib_hashmap_wrappers

    use, intrinsic :: iso_fortran_env, only : &
        character_storage_size

    use stdlib_hash_32bit

    use stdlib_kinds, only : &
        int8,                &
        int16,               &
        int32,               &
        int64,               &
        dp

    implicit none

    private

!! Public procedures
    public ::                    &
        copy_key,                &
        fibonacci_hash,          &
        fnv_1_hasher,            &
        fnv_1a_hasher,           &
        free_key,                &
        get,                     &
        hasher_fun,              &
        operator(==),            &
        seeded_nmhash32_hasher,  &
        seeded_nmhash32x_hasher, &
        seeded_water_hasher,     &
        set

!! Public types
    public ::      &
        key_type

!! Public integers
    public ::   &
        int_hash

    integer, parameter ::               &
! Should be 8
        bits_int8  = bit_size(0_int8)

    integer, parameter ::                   &
        bits_char = character_storage_size, &
        bytes_char = bits_char/bits_int8

    character(*), parameter :: module_name = "STDLIB_HASHMAP_WRAPPERS"

    type :: key_type
!! Version: Experimental
!!
!! A wrapper type for the key's true type
!        private
        integer(int8), allocatable :: value(:)
    end type key_type

    abstract interface
!! Version: Experimental
!!
!! Abstract interface to a 64 bit hash function operating on a KEY_TYPE
        pure function hasher_fun( key )  result(hash_value)
            import key_type, int_hash
            type(key_type), intent(in)    :: key
            integer(int_hash)             :: hash_value
        end function hasher_fun
    end interface

    
    interface get

        module procedure get_char_key,   &
                         get_int8_key,   &
                         get_int32_key

    end interface get


    interface operator(==)
        module procedure equal_keys
    end interface operator(==)

    interface set

        module procedure set_char_key,   &
                         set_int8_key,   &
                         set_int32_key

    end interface set

contains


    pure subroutine copy_key( old_key, new_key )
!! Version: Experimental
!!
!! Copies the contents of the key, old_key, to the key, new_key
!! ([Specifications](../page/specs/stdlib_hashmaps.html#copy_key-returns-a-copy-of-the-key))
!!
!! Arguments:
!!     old_key - the input key
!!     new_key - the output copy of old_key
        type(key_type), intent(in)  :: old_key
        type(key_type), intent(out) :: new_key

        new_key % value = old_key % value

    end subroutine copy_key


    function equal_keys( key1, key2 ) result(test) ! Chase's tester
!! Version: Experimental
!!
!! Compares two keys for equality
!! ([Specifications](../page/specs/stdlib_hashmaps.html#operator(==)-compares-two-keys-for-equality))
!!
!! Arguments:
!!     key1 - the first key
!!     key2 - the second key
        logical                    :: test
        type(key_type), intent(in) :: key1
        type(key_type), intent(in) :: key2

        if ( size(key1 % value, kind=int64) /= &
             size(key2 % value, kind=int64) ) then
            test = .false.
            return
        end if

        if ( all( key1 % value == key2 % value ) ) then
            test = .true.
        else
            test = .false.
        end if

    end function equal_keys


    subroutine free_key( key )
!! Version: Experimental
!!
!! Frees the memory in a key
!! ([Specifications](../page/specs/stdlib_hashmaps.html#free_key-frees-the-memory-associated-with-a-key))
!!
!! Arguments:
!!     key  - the key
        type(key_type), intent(inout) :: key

        if ( allocated( key % value ) ) deallocate( key % value )

    end subroutine free_key


    subroutine get_char_key( key, value )
!! Version: Experimental
!!
!! Gets the contents of the key as a CHARACTER string
!! Arguments:
!!     key   - the input key
!!     value - the contents of key mapped to a CHARACTER string
        type(key_type), intent(in)             :: key
        character(:), allocatable, intent(out) :: value
        character(*), parameter :: procedure = "GET"

        integer(int64) :: key_as_char
        integer(int64) :: key_size

        key_size = size( key % value, kind=int64 )
        select case( bytes_char )
        case(1)
            key_as_char = key_size
        case(2)
            if ( iand( key_size, 1_int64 ) > 0 ) then
                error stop module_name // " % " // procedure // &
                          ": Internal Error at stdlib_hashmaps: " // &
                           "System uses 2 bytes per character, so " // &
                           "key_size can't be an odd number."
            end if
            key_as_char = ishft( key_size, -1 )
        case(4)
            if ( iand( key_size, 3_int64) > 0 ) then
                error stop module_name // " % " // procedure // &
                          ": Internal Error at stdlib_hashmaps: " // &
                           "System uses 4 bytes per character, and " // &
                           "key_size is not a multiple of four."
            end if
            key_as_char = ishft( key_size, -2 )
        case default
            error stop module_name // " % " // procedure // &
                       ": Internal Error: " // &
                       "System doesn't use a power of two for its " // &
                       "character size as expected by stdlib_hashmaps."
        end select

        allocate( character( len=key_as_char ) :: value )

        value(1:key_as_char) = transfer( key % value, value )

    end subroutine get_char_key


    subroutine get_int8_key( key, value )
!! Version: Experimental
!!
!! Gets the contents of the key as an INTEGER(INT8) vector
!! Arguments:
!!     key   - the input key
!!     value - the contents of key mapped to an INTEGER(INT8) vector
        type(key_type), intent(in)              :: key
        integer(int8), allocatable, intent(out) :: value(:)

        value = key % value

    end subroutine get_int8_key


    pure subroutine get_int32_key( key, value )
!! Version: Experimental
!!
!! Gets the contents of the key as an INTEGER(INT32) vector
!! Arguments:
!!     key   - the input key
!!     value - the contents of key mapped to an INTEGER(INT32) vector
        type(key_type), intent(in)              :: key
        integer(int32), allocatable, intent(out) :: value(:)
        
        value = transfer( key % value, value )
        
    end subroutine get_int32_key


    subroutine set_char_key( key, value )
!! Version: Experimental
!!
!! Sets the contents of the key from a CHARACTER string
!! Arguments:
!!     key   - the output key
!!     value - the input CHARACTER string
        type(key_type), intent(out) :: key
        character(*), intent(in)    :: value

        key % value = transfer( value, key % value, &
                                bytes_char * len( value ) )

    end subroutine set_char_key


    subroutine set_int8_key( key, value )
!! Version: Experimental
!!
!! Sets the contents of the key from an INTEGER(INT8) vector
!! Arguments:
!!     key   - the output key
!!     value - the input INTEGER(INT8) vector
        type(key_type), intent(out) :: key
        integer(int8), intent(in)   :: value(:)

        key % value = value

    end subroutine set_int8_key


    pure subroutine set_int32_key( key, value )
!! Version: Experimental
!!
!! Sets the contents of the key from an INTEGER(INT32) vector
!! Arguments:
!!     key   - the output key
!!     value - the input INTEGER(INT32) vector
        type(key_type), intent(out) :: key
        integer(int32), intent(in)   :: value(:)
                
        key % value = transfer(value, key % value)
                
    end subroutine set_int32_key


    pure function fnv_1_hasher( key )
!! Version: Experimental
!!
!! Hashes a key with the FNV_1 algorithm
!! Arguments:
!!     key  - the key to be hashed
        type(key_type), intent(in)    :: key
        integer(int_hash)             :: fnv_1_hasher

        fnv_1_hasher = fnv_1_hash( key % value )

    end function fnv_1_hasher


    pure function fnv_1a_hasher( key )
!! Version: Experimental
!!
!! Hashes a key with the FNV_1a algorithm
!! ([Specifications](../page/specs/stdlib_hashmaps.html#fnv_1a_hasher-calculates-a-hash-code-from-a-key))
!!
!! Arguments:
!!     key  - the key to be hashed
        type(key_type), intent(in)    :: key
        integer(int_hash)             :: fnv_1a_hasher

        fnv_1a_hasher = fnv_1a_hash( key % value )

    end function fnv_1a_hasher


    pure function seeded_nmhash32_hasher( key )
!! Version: Experimental
!!
!! Hashes a key with the NMHASH32 hash algorithm
!! ([Specifications](../page/specs/stdlib_hashmaps.html#seeded_nmhash32_hasher-calculates-a-hash-code-from-a-key))
!!
!! Arguments:
!!     key  - the key to be hashed
!!     seed - the seed (unused) for the hashing algorithm
        type(key_type), intent(in)    :: key
        integer(int_hash)             :: seeded_nmhash32_hasher

        seeded_nmhash32_hasher = nmhash32( key % value, &
            int( z'DEADBEEF', int32 ) )

    end function seeded_nmhash32_hasher


    pure function seeded_nmhash32x_hasher( key )
!! Version: Experimental
!!
!! Hashes a key with the NMHASH32X hash algorithm
!! ([Specifications](../page/specs/stdlib_hashmaps.html#seeded_nmhash32x_hasher-calculates-a-hash-code-from-a-key))
!! Arguments:
!!     key  - the key to be hashed
!!     seed - the seed (unused) for the hashing algorithm
        type(key_type), intent(in)    :: key
        integer(int_hash)             :: seeded_nmhash32x_hasher

        seeded_nmhash32x_hasher = nmhash32x( key % value, &
            int( z'DEADBEEF', int32 ) )

    end function seeded_nmhash32x_hasher


    pure function seeded_water_hasher( key )
!! Version: Experimental
!!
!! Hashes a key with the waterhash algorithm
!! ([Specifications](../page/specs/stdlib_hashmaps.html#seeded_water_hasher-calculates-a-hash-code-from-a-key))
!!
!! Arguments:
!!     key  - the key to be hashed
        type(key_type), intent(in)  :: key
        integer(int_hash)           :: seeded_water_hasher

        seeded_water_hasher = water_hash( key % value, &
            int( z'DEADBEEF1EADBEEF', int64 ) )

    end function seeded_water_hasher


end module stdlib_hashmap_wrappers

program example_clear
  use stdlib_stringlist_type, only: stringlist_type, fidx
  implicit none

  type(stringlist_type) :: stringlist

!> inserting 2 elements to the stringlist
  call stringlist%insert_at(fidx(1), "Element No. one")
  call stringlist%insert_at(fidx(1), "Element No. two")
! stringlist <-- {"Element No. two", "Element No. one"}

  call stringlist%clear()
! stringlist <-- { } (empty stringlist)

!> inserting 1 element to the stringlist
  call stringlist%insert_at(fidx(1), "Element No. one")
! stringlist <-- {"Element No. one"}

end program example_clear

program example_log_text_error
  use stdlib_logger
  implicit none

  character(*), parameter :: filename = 'dummy.txt'
  integer                 :: col_no, line_no, lun, status
  character(128)          :: line
  character(*), parameter :: message = 'Bad text found.'

  open (newunit=lun, file=filename, status='old', &
        form='formatted')
  line_no = 0
  do
    read (lun, fmt='(a)', end=900) line
    line_no = line_no + 1
    call check_line(line, status, col_no)
    if (status /= 0) then
      call global_logger%log_text_error(line, &
                                        col_no, message, filename, line_no)
      error stop 'Error in reading '//filename
    end if
  end do
900 continue

contains

  subroutine check_line(line, status, col_no)
    character(*), intent(in)    :: line
    integer, intent(inout) :: status
    integer, intent(inout) :: col_no
    ! scan the line for forbidden characters
    col_no = scan(line, ".$/")
    ! col_no > 0 means there is a forbidden character
    status = col_no
  end subroutine

end program example_log_text_error

program example_add_log_unit
  use stdlib_logger, only: global_logger, read_only_error
  implicit none

  character(256) :: iomsg
  integer :: iostat, unit, stat

  open (newunit=unit, file='error_log.txt', &
        form='formatted', status='replace', &
        position='rewind', &
        action='write', iostat=iostat, iomsg=iomsg)

  call global_logger%add_log_unit(unit, stat)

  select case (stat)
  case (read_only_error)
    error stop 'Unable to write to "error_log.txt".'
  end select

end program example_add_log_unit

program example_not
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0
  call set0%init(155)
  if (set0%none()) then
    write (*, *) "FROM_STRING interpreted "// &
      "BITS_0's value properly."
  end if
  call set0%not()
  if (set0%all()) then
    write (*, *) "ALL interpreted SET0's value properly."
  end if
end program example_not

program example_gt
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  logical :: res

  string = "bcd"
  res = string > "abc"
! res .eqv. .true.

  res = string > "bcd"
! res .eqv. .false.

  res = string > "cde"
! res .eqv. .false.
end program example_gt

! Matrix inversion example: subroutine interface
program example_inverse_subroutine
  use stdlib_linalg_constants, only: dp
  use stdlib_linalg, only: invert,eye
  implicit none

  real(dp) :: A(2,2), Am1(2,2)

  ! Input matrix (NB Fortran is column major! input columns then transpose)
  A = transpose(reshape( [4, 3, &
                          3, 2], [2,2] ))

  ! Invert matrix
  call invert(A,Am1)

  print *, '         |',Am1(1,:),'|' ! | -2  3 |
  print *, ' inv(A)= |',Am1(2,:),'|' ! |  3 -4 |

  ! Final check 
  print *, 'CHECK passed? ',matmul(A,Am1)==eye(2)

end program example_inverse_subroutine

program example_solve3
  use stdlib_linalg_constants, only: sp,ilp
  use stdlib_linalg, only: solve_lu, linalg_state_type 
  implicit none

  integer(ilp) :: test
  integer(ilp), allocatable :: pivot(:)
  complex(sp), allocatable :: A(:,:),b(:),x(:)

  ! Solve a system of 3 complex linear equations: 
  !  2x +      iy + 2z = (5-i)
  ! -ix + (4-3i)y + 6z = i
  !  4x +      3y +  z = 1

  ! Note: Fortran is column-major! -> transpose 
  A = transpose(reshape([(2.0, 0.0),(0.0, 1.0),(2.0,0.0), &
                         (0.0,-1.0),(4.0,-3.0),(6.0,0.0), &
                         (4.0, 0.0),(3.0, 0.0),(1.0,0.0)] , [3,3])) 
  
  ! Pre-allocate x
  allocate(b(size(A,2)),pivot(size(A,2)))
  allocate(x,mold=b)

  ! Call system many times avoiding reallocation 
  do test=1,100
     b = test*[(5.0,-1.0),(0.0,1.0),(1.0,0.0)]
     call solve_lu(A,b,x,pivot)
     print "(i3,'-th solution: ',*(1x,f12.6))", test,x
  end do

end program example_solve3

! Usage of join_path, operator(/)
program example_path_join
    use stdlib_system, only: join_path, operator(/), OS_TYPE, OS_WINDOWS
    character(len=:), allocatable :: p1, p2, p3
    character(len=20) :: parr(4)

    if(OS_TYPE() == OS_WINDOWS) then
        p1 = 'C:'/'Users'/'User1'/'Desktop'
        p2 = join_path('C:\Users\User1', 'Desktop')
        parr = [character(len=20) :: 'C:', 'Users', 'User1', 'Desktop']
        p3 = join_path(parr)
    else
        p1 = ''/'home'/'User1'/'Desktop'
        p2 = join_path('/home/User1', 'Desktop')
        parr = [character(len=20) :: '', 'home', 'User1', 'Desktop']
        p3 = join_path(parr)
    end if

    ! (p1 == p2 == p3) = '/home/User1/Desktop' OR 'C:\Users\User1\Desktop'
    print *, p1 ! /home/User1/Desktop OR 'C:\Users\User1\Desktop'
    print *, "p1 == p2: ", p1 == p2 ! T
    print *, "p2 == p3: ", p2 == p3 ! T
end program example_path_join

program example_uread
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  integer :: io
  string = "Important saved value"

  open (newunit=io, form="unformatted", status="scratch")
  write (io) string

  rewind (io)

  read (io) string
  close (io)
end program example_uread

program example_radix_sort
    use iso_fortran_env, only: int8, int16, dp => real64
    use stdlib_sorting, only: radix_sort
    implicit none
    integer(int8), allocatable :: arri8(:)
    integer(int16), allocatable :: arri16(:)
    real(dp) ::  x
    real(dp), allocatable ::  arrf64(:)

    arri8 = [-128, 127, 0, -1, 1]
    call radix_sort(arri8)
    print *, arri8

    arri16 = [-32767, 32767, 0, 0, -3, 2, -3]
    call radix_sort(arri16, reverse=.true.)
    print *, arri16

    allocate (arrf64(10))
    x = 0.0_dp ! divide zero will arise compile error
    arrf64 = [1.0_dp/x, 0.0_dp, 0.0_dp/x, -1.0_dp/x, -0.0_dp, 1.0_dp, -1.0_dp, 3.45_dp, -3.14_dp, 3.44_dp]
    call radix_sort(arrf64)
    print *, arrf64
    ! Expected output:
    ! nan, -inf, -3.14, -1.0, -0.0, 0.0, 1.0, 3.44, 3.45, inf
    ! Note: the position of nan is undefined
end program example_radix_sort

program example_extract
  use stdlib_bitsets
  implicit none
  type(bitset_large) :: set0, set1
  call set0%init(166)
  call set0%set(100, 150)
  call extract(set1, set0, 100, 150)
  if (set1%bits() == 51) &
    write (*, *) 'SET1 has the proper size.'
  if (set1%all()) write (*, *) 'SET1 has the proper values.'
end program example_extract

! Process example 3: Run with many arguments, and check runtime
program run_with_args
    use stdlib_system, only: process_type, run, elapsed, wait
    implicit none

    type(process_type) :: p
    character(len=15), allocatable :: args(:)

    ! Define arguments for the `echo` command
    allocate(args(2))
    args(1) = "echo"
    args(2) = "Hello, Fortran!"

    ! Run the command with arguments (synchronous)
    p = run(args)

    ! Print the runtime of the process
    print *, "Process runtime:", elapsed(p), "seconds."

    ! Clean up
    deallocate(args)
end program run_with_args

program example_constants
    use stdlib_constants, only: c, pi=>PI_dp
    use stdlib_codata, only: alpha=>ALPHA_PARTICLE_ELECTRON_MASS_RATIO
    use stdlib_codata_type, only : to_real
    use stdlib_kinds, only: dp, sp

    ! Use most common physical constants defined as double precision reals
    print *, "speed of light in vacuum= ", c

    ! Use of mathematical constants such as PI
    print *, "PI as double precision real= ", pi

    ! Use codata_constant type for evaluating the value to the desired precision
    print *, "Value of alpha... evaluated to double precision=", alpha%to_real(1.0_dp)
    print *, "Uncertainty of alpha... evaluated to double precision=", alpha%to_real(1.0_sp, .true.)
    print *, "Value of alpha... evaluated to single precision=", alpha%to_real(1.0_sp)

    ! Convert a codata constant to a real
    print *, "Value of the alpha... evaluated to double precision=", to_real(alpha, 1.0_dp)


    ! Print out codata constant attributes: name, value, uncertainty and unit
    call alpha%print()

end program example_constants

! This example computes the Schur decomposition of a real-valued square matrix.
program example_schur_real
  use stdlib_linalg, only: schur
  use stdlib_linalg_constants, only: dp
  implicit none
  integer, parameter :: n = 3
  real(dp), dimension(n,n) :: A, T, Z

  ! Initialize a real-valued square matrix
  A = reshape([ 0, 2, 2, &
                0, 1, 2, &
                1, 0, 1], shape=[n,n])

  ! Compute the Schur decomposition: A = Z T Z^T
  call schur(A, T, Z)

  ! Output results
  print *, "Original Matrix A:"
  print *, A
  print *, "Schur Form Matrix T:"
  print *, T
  print *, "Orthogonal Matrix Z:"
  print *, Z

  ! Test factorization: Z*T*Z^T = A
  print *, "Max error in reconstruction:", maxval(abs(matmul(Z, matmul(T, transpose(Z))) - A))

end program example_schur_real

program example_lt
  use stdlib_bitsets
  implicit none
  type(bitset_64) :: set0, set1, set2
  call set0%init(33)
  call set1%init(33)
  call set2%init(33)
  call set1%set(0)
  call set2%set(32)
  if (set0 < set1 .and. set1 < set2 .and. set0 < set2 .and. &
      .not. set0 < set0 .and. .not. set2 < set0 .and. .not. &
      set2 < set1) then
    write (*, *) 'Passed 64 bit less than tests.'
  else
    error stop 'Failed 64 bit less than tests.'
  end if
end program example_lt

! Illustrate the usage of `get_cwd`, `set_cwd`
program example_cwd
    use stdlib_system, only: get_cwd, set_cwd
    use stdlib_error, only: state_type
    implicit none 

    character(len=:), allocatable :: path
    type(state_type) :: err

    call get_cwd(path, err)

    if (err%error()) then
        print *, "Error getting current working directory: "//err%print()
    end if
    
    print *, "CWD: "//path

    call set_cwd("./src", err)

    if (err%error()) then
        print *, "Error setting current working directory: "//err%print()
    end if

    call get_cwd(path, err)

    if (err%error()) then
        print *, "Error getting current working directory after using set_cwd: "//err%print()
    end if
    
    print *, "CWD: "//path
end program example_cwd

!! The module, STDLIB_HASHMAP_OPEN implements a simple open addressing hash
!! map using linear addressing. The implementation is loosely based on a
!! C implementation by David Chase, http://chasewoerner.org/src/hasht/, for
!! which he has given permission to use in the Fortran Standard Library.

! Note an error in the code caused attempts to deallocate already deallocated
! entries. This did not cause stat to be non-zero, but did cause system errors,
! on my Mac. I therefore decided to remove all deallocation error reporting.

submodule(stdlib_hashmaps) stdlib_hashmap_open

    use, intrinsic :: iso_fortran_env, only: &
        character_storage_size,              &
        error_unit

    use stdlib_hashmap_wrappers

    implicit none

! Error messages
    character(len=*), parameter ::                                             &
        alloc_inv_fault     = "OPEN_HASHMAP_TYPE % INVERSE allocation fault.", &
        alloc_key_fault     = "KEY allocation fault.",                         &
        alloc_slots_fault   = "OPEN_HASHMAP_TYPE % SLOTS allocation fault.",   &
        conflicting_key     = "KEY already exists in MAP.",                    &
        expand_slots_fail   = "OPEN_HASHMAP_TYPE % SLOTS allocation > " //     &
                              "MAX_BITS.",                                     &
        init_slots_pow_fail = "SLOTS_BITS is not between DEFAULT_BITS " //     &
                              "and MAX_BITS.",                                 &
        invalid_inmap       = "INMAP was not a valid INVERSE index.",          &
        map_consist_fault   = "The hash map found an inconsistency."

    character(*), parameter :: submodule_name = 'STDLIB_HASHMAP_OPEN'


    interface expand_slots
!! Version: Experimental
!!
!! Interface to internal procedure that expands an open map's slots.
        module procedure expand_open_slots
    end interface expand_slots

    interface extend_map_entry_pool
!! Version: Experimental
!!
!! Interface to internal procedure that expands an open map entry pool.
        module procedure extend_open_map_entry_pool
    end interface extend_map_entry_pool

    interface free_map
!! Version: Experimental
!!
!! Interface to procedure that finalizes an open hash map.
        module procedure free_open_map
    end interface free_map

    interface free_map_entry_pool
!! Version: Experimental
!!
!! Interface to internal procedure that finalizes an open hash map
!! entry pool.
        module procedure free_map_entry_pool
    end interface free_map_entry_pool

    interface get_other_data
!! Version: Experimental
!!
!! Interface to procedure that gets an entry's other data.
        module procedure get_other_open_data
    end interface get_other_data

    interface  init
!! Version: Experimental
!!
!! Interface to initialization procedure for an open hash map.
        module procedure init_open_map
    end interface init

    interface rehash
!! Version: Experimental
!!
!! Interface to a procedure that changes the hash function that
!! is used to map the keys into an open hash map.
        module procedure rehash_open_map
    end interface rehash

    interface remove
!! Version: Experimental
!!
!! Interface to a procedure that removees an entry from an open hash map.
        module procedure remove_open_entry
    end interface remove

    interface set_other_data
!! Version: Experimental
!!
!! Interface to a procedure that changes the other data associated with a key
        module procedure set_other_open_data
    end interface set_other_data

contains


    subroutine expand_open_slots( map )
!! Version: Experimental
!!
!! Internal routine to make a duplicate map with more hash slots.
!! Doubles the size of the map % slots array
!! Arguments:
!!     map - the hash table whose hash slots are to be expanded
!
        type(open_hashmap_type), intent(inout) :: map

        integer(int_hash)               :: base_slot
        integer(int_index), allocatable :: dummy_slots(:)
        integer(int_index)              :: inv_index,  &
                                           new_size,   &
                                           offset,     &
                                           old_size,   &
                                           test_slot
        integer(int32)                  :: bits,      &
                                           stat

        character(256) :: errmsg
        character(*), parameter :: procedure = 'EXPAND_SLOTS'

        if ( map % nbits == max_bits ) then
            error stop submodule_name // ' % ' // procedure // ': ' // &
                expand_slots_fail
        end if

        old_size = size(map % slots, kind=int_index)

        new_size = 2*old_size
        bits = map % nbits + 1

        allocate( dummy_slots(0:new_size-1), stat=stat, errmsg=errmsg )
        if (stat /= 0) then
            error stop submodule_name // ' % ' // procedure // ': ' // &
                alloc_slots_fault
        end if

        map % nbits = bits

        dummy_slots(:) = 0
        map % index_mask = new_size-1

        map % total_probes = map % total_probes + map % probe_count
        map % probe_count = 0

        REMAP_SLOTS: do inv_index=1_int_index, &
            map % num_entries + map % num_free
            associate( inverse => map % inverse(inv_index) )
              if ( associated(inverse % target) ) then
                  base_slot = fibonacci_hash( inverse % target % hash_val, &
                                              map % nbits )
                  offset = 0
                  FIND_EMPTY_SLOT: do
                      test_slot = iand( int( base_slot + offset, int_hash), &
                                        map % index_mask )
                      if ( dummy_slots(test_slot) == 0 ) then
                          dummy_slots(test_slot) = inv_index
                          exit FIND_EMPTY_SLOT
                      end if
                      offset = offset + 1
                  end do FIND_EMPTY_SLOT
              end if
            end associate
        end do REMAP_SLOTS

        call move_alloc( dummy_slots, map % slots )

    end subroutine expand_open_slots


    subroutine extend_open_map_entry_pool(pool) ! gent_pool_new
!! Version: Experimental
!!
!! Add more map_entrys to the pool head
!! Arguments:
!!     pool - an open map entry pool
        type(open_map_entry_pool), intent(inout), pointer :: pool

        type(open_map_entry_pool), pointer :: map_entry_pool_head

        allocate(map_entry_pool_head)
        allocate(map_entry_pool_head % more_map_entries(0:pool_size-1))
        map_entry_pool_head % lastpool => pool
        pool => map_entry_pool_head
        pool % next = 0

    end subroutine extend_open_map_entry_pool


    recursive subroutine free_map_entry_pool(pool) ! gent_pool_free
!! Version: Experimental
!! Note the freeing of allocated memory may be unnecessary
!!
!! Recursively descends map entry pool list freeing each element
!! Arguments:
!!     pool  The map entry pool whose elements are to be freed
!
        type(open_map_entry_pool), intent(inout), pointer :: pool

        type(open_map_entry_pool), pointer :: lastpool

        if ( associated(pool) ) then
            lastpool => pool % lastpool
            pool % lastpool => null()
            deallocate( pool )
!         Trace component pointers/lists
            call free_map_entry_pool( lastpool )
        end if

    end subroutine free_map_entry_pool


    module subroutine free_open_map( map )
!! Version: Experimental
!!
!! Frees internal memory of an open map
!! Arguments:
!!     map - the open hash map whose memory is to be freed
!
        type(open_hashmap_type), intent(inout) :: map

        type(open_map_entry_list), pointer :: free_list
        integer(int_index) :: i

        if ( allocated( map % slots ) ) then
            deallocate( map % slots )
        end if

        if ( allocated( map % inverse ) ) then
             remove_links: do i=1, size( map % inverse, kind=int_index )
                map % inverse(i) % target => null()
            end do remove_links
            deallocate( map % inverse )
        end if

        free_free_list: do while( map % num_free > 0 )
            free_list => map % free_list
            map % free_list => map % free_list % next
            free_list % next => null()
            free_list % target => null()
            map % num_free = map % num_free - 1
        end do free_free_list
        map % num_free = 0

        if ( associated( map % cache ) ) call free_map_entry_pool(map % cache)

        map % num_entries = 0

    end subroutine free_open_map


    module subroutine get_all_open_keys(map, all_keys)
!! Version: Experimental
!!
!! Returns all the keys contained in a hash map
!! Arguments:
!!     map - an open hash map
!!     all_keys - all the keys contained in a hash map
!
        class(open_hashmap_type), intent(in) :: map
        type(key_type), allocatable, intent(out) :: all_keys(:)
        
        integer(int32) :: num_keys
        integer(int_index) :: i, key_idx

        num_keys = map % entries()
        allocate( all_keys(num_keys) )
        if ( num_keys == 0 ) return

        if ( allocated( map % inverse) ) then
            key_idx = 1_int_index
            do i=1_int_index, size( map % inverse, kind=int_index )
                if ( associated( map % inverse(i) % target ) ) then
                    all_keys(key_idx) = map % inverse(i) % target % key
                    key_idx = key_idx + 1_int_index
                end if
            end do 
        end if

    end subroutine get_all_open_keys


    module subroutine get_other_open_data( map, key, other, exists )
!! Version: Experimental
!!
!! Returns the other data associated with the inverse table index
!! Arguments:
!!     map   - an open hash table
!!     key   - the key associated with a map entry
!!     other - the other data associated with the key
!!     exists - a logical flag indicating whether an entry with that key exists
!
        class(open_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)              :: key
        class(*), allocatable, intent(out)      :: other
        logical, intent(out), optional          :: exists

        integer(int_index) :: inmap
        character(*), parameter :: procedure = 'GET_OTHER_DATA'

        call in_open_map(map, inmap, key)
        if ( inmap <= 0 .or. &
            inmap > map % num_entries + map % num_free ) then
            if ( present(exists) ) then
                exists = .false.
                return
            else
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    invalid_inmap
            end if
        else if ( associated( map % inverse(inmap) % target ) ) then
            if ( present(exists) ) exists = .true.
            other = map % inverse(inmap) % target % other
        else
            if ( present(exists) ) then
                exists = .false.
                return
            else
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    map_consist_fault
            end if
        end if

    end subroutine get_other_open_data


    subroutine in_open_map(map, inmap, key) ! Chase's inmap
!! Version: Experimental
!!
!! Returns the index into the INVERSE array associated with the KEY
!! Arguments:
!!     map   - the hash map of interest
!!     inmap - the returned index into the INVERSE array of entry pointers
!!     key   - the key identifying the entry of interest
!
        class(open_hashmap_type), intent(inout) :: map
        integer(int_index), intent(out)         :: inmap
        type(key_type), intent(in)              :: key

        character(*), parameter :: procedure = 'IN_MAP'
        integer(int_hash) :: &
            base_slot,       &
            hash_val,        &
            test_slot
        integer(int_index) :: &
            offset

        hash_val = map % hasher( key )

        if ( map % probe_count > inmap_probe_factor * map % call_count .or. &
             map % num_entries >= load_factor *                             &
             size( map % slots, kind=int_index ) ) then
            if ( map % nbits < max_bits ) &
                 call expand_slots(map)
        end if

        map % call_count = map % call_count + 1
        base_slot = fibonacci_hash( hash_val, map % nbits )
        offset = 0_int_index
        PROBE_SLOTS: do
            test_slot = iand( base_slot + offset, map % index_mask )
            map % probe_count = map % probe_count + 1
            inmap = map % slots( test_slot )
            if ( inmap == 0 ) then
                return
            else if ( inmap < 0 .or. &
                 inmap > map % num_entries + map % num_free ) then
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    map_consist_fault
            else if ( .not. associated( map % inverse(inmap) % target ) ) then
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    map_consist_fault
            else
                associate( inverse => map % inverse(inmap) )
                  if ( hash_val == inverse % target % hash_val ) then
                      if ( key == inverse % target % key ) then
                          return
                      end if
                  end if
                end associate
            end if
            offset = offset + 1_int_index
        end do PROBE_SLOTS

    end subroutine in_open_map


    module subroutine init_open_map( map,         &
                                     hasher,      &
                                     slots_bits,  &
                                     status )
!! Version: Experimental
!!
!! Routine to allocate an empty map with HASHER as the hash function,
!! 2**SLOTS_BITS initial SIZE(map % slots), and SIZE(map % slots) limited to a
!! maximum of 2**MAX_BITS. All fields are initialized.
!! Arguments:
!!     map         - the open hash maap to be initialized
!!     hasher      - the hash function to be used to map keys to slots
!!     slots_bits  - the number of bits used to map to the slots
!!     status      - an integer error status flag with the allowed values:
!!         success - no problems were found
!!         alloc_fault - map % slots or map % inverse could not be allocated
!!         array_size_error - slots_bits is less than default_bitd or
!!             greater than max_bits

        class(open_hashmap_type), intent(out)      :: map
        procedure(hasher_fun), optional            :: hasher
        integer, intent(in), optional              :: slots_bits
        integer(int32), intent(out), optional      :: status

        character(256)          :: errmsg
        integer(int_index)      :: i
        character(*), parameter :: procedure = 'INIT'
        integer(int_index)      :: slots
        integer(int32)          :: stat
        type(open_map_entry_pool), pointer :: map_entry_pool_head

        map % call_count = 0
        map % probe_count = 0
        map % total_probes = 0
        
        ! Check if user has specified a hasher other than the default hasher.
        if (present(hasher)) map % hasher => hasher        

        if ( present(slots_bits) ) then
            if ( slots_bits < default_bits .OR. &
                 slots_bits > max_bits ) then
                if ( present(status) ) then
                    status = array_size_error
                    return
                else
                    error stop submodule_name // ' % ' // procedure // ': ' // &
                        init_slots_pow_fail
                end if
            end if
            map % nbits = slots_bits
        else
            map % nbits = min( default_bits, max_bits )
        end if

        slots = 2_int32**map % nbits
        map % index_mask = slots - 1

        allocate( map % slots(0:slots-1), stat=stat, errmsg=errmsg )
        if ( stat /= 0 ) then
            if ( present(status) ) then
                status = alloc_fault
                return
            else
                write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    alloc_slots_fault
            end if
        end if

        do i=0, size( map % slots, kind=int_index ) -  1
            map % slots(i) = 0 ! May be redundant
        end do

!! 5*s from Chase's g_new_map
        allocate( map % inverse(1:ceiling(load_factor*slots, &
                  kind=int_index)),                          &
                  stat=stat,                                 &
                  errmsg=errmsg )
        if ( stat /= 0 ) then
            if ( present( status ) ) then
                status = alloc_fault
                return
            else
                write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    alloc_inv_fault
            end if
        end if

        do i=1, size(map % inverse, kind=int_index)
            map % inverse(i) % target => null()
        end do

        do while(associated(map % cache))
            map_entry_pool_head => map % cache
            map % cache => map_entry_pool_head % lastpool
            map_entry_pool_head % lastpool => null()
            deallocate( map_entry_pool_head % more_map_entries )
            deallocate( map_entry_pool_head )
        end do

        call extend_map_entry_pool(map % cache)
        
        map % initialized = .true.

        if (present(status) ) status = success

    end subroutine init_open_map


    pure module function open_loading( map )
!! Version: Experimental
!!
!! Returns the number of entries relative to slots in a hash map
!! Arguments:
!!       map - an open hash map
        class(open_hashmap_type), intent(in) :: map
        real :: open_loading

        open_loading = real( map % num_entries ) / &
                       size( map % slots, kind=int_index )

    end function open_loading


    module subroutine map_open_entry(map, key, other, conflict)
!! Version: Experimental
!!
!! Inserts an entry into the hash table
!!  Arguments:
!!      map     the hash table of interest
!!      key      - the key identifying the entry
!!      other    - other data associated with the key
!!      conflict - logical flag indicating whether the entry key conflicts
!!                 with an existing key
!
        class(open_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)              :: key
        class(*), intent(in), optional          :: other
        logical, intent(out), optional          :: conflict

        type(open_map_entry_type), pointer :: new_ent
        integer(int_hash)  :: base_slot
        integer(int_hash)  :: hash_val
        integer(int_index) :: inmap, offset, test_slot
        character(*), parameter :: procedure = 'MAP_ENTRY'
        
        ! Check that map is initialized.  
        if (.not. map % initialized) call init_open_map( map )
        
        hash_val = map % hasher( key )

        if ( map % probe_count > map_probe_factor * map % call_count .or.   &
             map % num_entries >= load_factor * size( map % slots,          &
                                                      kind=int_index) ) then
            call expand_slots(map)
        end if
        map % call_count = map % call_count  + 1
        base_slot = fibonacci_hash( hash_val, map % nbits )

        offset = 0
        PROBE_SUCCESSIVE_SLOTS: do
            map % probe_count = map % probe_count + 1
            test_slot = iand( base_slot + offset, map % index_mask )
            inmap = map % slots(test_slot)
            if ( inmap == 0 ) then
                call allocate_open_map_entry(map, new_ent)
                new_ent % hash_val = hash_val
                call copy_key( key, new_ent % key )
                if ( present( other ) ) new_ent % other = other
                inmap = new_ent % inmap
                map % inverse( inmap ) % target => new_ent
                map % slots( test_slot ) = inmap
                if ( present(conflict) ) conflict = .false.
                return
            else if ( inmap < 0 .or. &
                inmap > map % num_entries + map % num_free ) then
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    invalid_inmap
            else if (.not. associated( map % inverse(inmap) % target ) ) then
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    invalid_inmap
            else
                associate( target => map % inverse(inmap) % target )
                  if ( hash_val == target % hash_val ) then
                      if ( key == target % key ) then
                          ! entry already exists
                          if ( present(conflict) ) then
                              conflict = .true.
                          else
                              error stop submodule_name // ' % ' // procedure &
                                  // ': ' // conflicting_key
                          end if
                          return
                      end if
                  end if
                end associate
            end if
            offset = offset + 1
        end do PROBE_SUCCESSIVE_SLOTS

    contains

        subroutine allocate_open_map_entry(map, bucket)
!         allocates a hash bucket
            type(open_hashmap_type), intent(inout) :: map
            type(open_map_entry_type), pointer, intent(out) :: bucket
            type(open_map_entry_list), pointer :: free_list
            type(open_map_entry_pool), pointer :: pool
            character(*), parameter :: procedure_name = "ALLOCATE_MAP_ENTRY"

            pool => map % cache
            map % num_entries = map % num_entries + 1
            if ( associated(map % free_list) ) then
!             Get hash bucket from free_list
                free_list => map % free_list
                bucket => free_list % target
                map % free_list => free_list % next
                free_list % target => null()
                free_list % next => null()
                if (bucket % inmap <= 0) &
                    error stop submodule_name // " % " // procedure_name // &
                    ": Failed consistency check: BUCKET % INMAP <= 0"
                map % num_free = map % num_free - 1
            else
!             Get hash bucket from pool
                if ( pool % next == pool_size ) then
!         Expand pool
                    call extend_map_entry_pool(map % cache)
                    pool => map % cache
                end if
                bucket      => pool % more_map_entries(pool % next)
                pool % next =  pool % next + 1 ! 0s based -> post-increment
                if ( map % num_entries >                     &
                     size( map % inverse, kind=int_index ) ) then
                    call expand_inverse( map )
                end if
                if ( map % num_entries <= 0 ) &
                    error stop submodule_name // " % " // procedure_name // &
                    ": Failed consistency check: MAP % NUM_ENTRIES <= 0."
                bucket % inmap = map % num_entries
            end if

        end subroutine allocate_open_map_entry

        subroutine expand_inverse(map)
!!     Increase size of map % inverse
            type(open_hashmap_type), intent(inout) :: map
            type(open_map_entry_ptr), allocatable   :: dummy_inverse(:)

            integer(int32) :: stat
            character(256) :: errmsg

            allocate( dummy_inverse(1:2*size(map % inverse, kind=int_index)), &
                      stat=stat, errmsg=errmsg )
            if ( stat /= 0 ) then
                write(error_unit, '(a)') 'Allocation ERRMSG: ' // trim(errmsg)
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    alloc_inv_fault
            end if
            dummy_inverse(1:size(map % inverse, kind=int_index)) = &
                map % inverse(:)

            call move_alloc( dummy_inverse, map % inverse )

        end subroutine expand_inverse

    end subroutine map_open_entry


    module subroutine rehash_open_map( map, hasher )
!! Version: Experimental
!!
!! Changes the hashing method of the table entries to that of HASHER.
!! Arguments:
!!     map      the table to be rehashed
!!     hasher the hasher function to be used for the table
!
        class(open_hashmap_type), intent(inout) :: map
        procedure(hasher_fun)                   :: hasher

        integer(int_hash)       :: base_slot
        integer(int_hash)       :: hash_val
        integer(int_index)      :: i, test_slot, offset

        map % hasher => hasher

        map % slots = 0

        do i=1, map % num_entries + map % num_free
            if ( .not. associated( map % inverse(i) % target ) ) cycle
            hash_val = map % hasher( map % inverse(i) % target % key )
            map % inverse(i) % target % hash_val = hash_val
            base_slot = fibonaccI_hash( hash_val, map % nbits )
            offset = 0
            FIND_EMPTY_SLOT: do
                test_slot = iand( int( base_slot + offset, int_hash ), &
                                  map % index_mask )
                if ( map % slots(test_slot) == 0 ) then
                    map % slots(test_slot) = i
                    exit FIND_EMPTY_SLOT
                end if
                offset = offset + 1
            end do FIND_EMPTY_SLOT
        end do

    end subroutine rehash_open_map


    module subroutine remove_open_entry(map, key, existed)
!! Remove the entry, if any, that has the key
!! Arguments:
!!    map     - the table from which the entry is to be removed
!!    key     - the key to an entry
!!    existed - a logical flag indicating whether an entry with the key
!!              was present in the original map
!
        class(open_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)              :: key
        logical, intent(out), optional          :: existed

        type(open_map_entry_list), pointer :: aentry
        type(open_map_entry_type), pointer :: bucket
        integer(int_index)                 :: base_slot
        integer(int_index)                 :: current_index
        integer(int_index)                 :: current_slot
        integer(int_index)                 :: empty_slot
        integer(int_index)                 :: inmap
        logical                            :: overlap
        integer(int_index)                 :: slot_index

        overlap = .false.
        call in_open_map( map, inmap, key )
        if ( inmap < 1 .or. inmap > size( map % inverse ) ) then
            if ( present( existed ) ) existed = .false.
            return
        end if

        bucket => map % inverse(inmap) % target
        if ( associated(bucket) ) then
            base_slot = fibonacci_hash( bucket % hash_val, map % nbits )
            if ( present(existed) ) existed = .true.
        else
            if ( present( existed ) ) existed = .false.
            return
        end if

! Find slot associated with inmap and nullify the pointer
        current_slot = base_slot
        search_for_inmap: do
            slot_index = map % slots(current_slot)
            if ( slot_index == inmap ) then
                allocate(aentry)
                aentry % target => map % inverse(inmap) % target
                aentry % next => map % free_list
                map % free_list => aentry
                map % num_free = map % num_free + 1
                map % slots( current_slot ) = 0
                map % inverse(inmap) % target => null()
                map % num_entries = map % num_entries - 1
                empty_slot = current_slot
                current_slot = iand( map % index_mask, current_slot + 1 )
                if ( map % slots(current_slot) == 0 ) return
                if ( current_slot == 0 ) overlap = .true.
                exit search_for_inmap
            else
                if ( map % slots(current_slot) == 0 ) return
                current_slot = iand( map % index_mask, current_slot + 1 )
                if ( current_slot == 0 ) overlap = .true.
                cycle search_for_inmap
            end if
        end do search_for_inmap

! Have found slot and stored it in free_list, now may need to iteratively
! swap to fill holes. First search backwards to find start of run.
        find_run_start: do
            base_slot = iand( map % index_mask, base_slot - 1 )
            if ( base_slot == map % index_mask ) then
                if ( map % slots(base_slot) == 0 ) then
                    base_slot = 0
                    exit find_run_start
                else
                    overlap = .true.
                    cycle find_run_start
                end if
            else if ( map % slots(base_slot) == 0 ) then
                base_slot = iand( map % index_mask, base_slot + 1 )
                exit find_run_start
            else
                cycle find_run_start
            end if
        end do find_run_start

! Search forward for entry to fill empty slot
        fill_empty_slots: do
            bucket => map % inverse(map % slots(current_slot) ) % target
            current_index = fibonacci_hash( bucket % hash_val, &
                                            map % nbits )
            if ( overlap .and. empty_slot < base_slot ) then
                if ( ( current_index >= base_slot .and. &
                       current_index <= map % index_mask ) .or. &
                     ( current_index >= 0 .and. &
                       current_index <= empty_slot ) ) then
                    map % slots( empty_slot ) = map % slots( current_slot )
                    map % slots( current_slot ) = 0
                    empty_slot = current_slot
                end if
                current_slot = iand( map % index_mask, current_slot + 1 )
            else
                if ( current_index >= base_slot .and. &
                     current_index <= empty_slot ) then
                    map % slots( empty_slot ) = map % slots( current_slot )
                    map % slots( current_slot ) = 0
                    empty_slot = current_slot
                end if
                current_slot = iand( map % index_mask, current_slot + 1 )
                if ( current_slot == 0 ) overlap = .true.
            end if
            if ( map % slots( current_slot ) == 0 ) exit fill_empty_slots
        end do fill_empty_slots

    end subroutine remove_open_entry


    module subroutine set_other_open_data( map, key, other, exists )
!! Version: Experimental
!!
!! Change the other data associated with the key
!! Arguments:
!!     map    - the map with the entry of interest
!!     key    - the key to the entry inthe map
!!     other  - the new data to be associated with the key
!!     exists - a logical flag indicating whether the key is already entered
!!              in the map
!
        class(open_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)              :: key
        class(*), intent(in)                    :: other
        logical, intent(out),optional           :: exists

        integer(int_index) :: inmap

        character(*), parameter :: procedure = 'SET_OTHER_DATA'

        call in_open_map( map, inmap, key )
        if ( inmap <= 0 .or. inmap > size( map % inverse, kind=int_index ) ) &
            then
            if ( present(exists) ) then
                exists = .false.
                return
            else
                error stop submodule_name // ' % ' // procedure // ': ' // &
                    invalid_inmap
            end if
        else if ( associated( map % inverse(inmap) % target ) ) then
            map % inverse(inmap) % target % other = other
            if ( present(exists) ) exists = .true.
            return
        else
            error stop submodule_name // ' % ' // procedure // ': ' // &
                invalid_inmap
        end if

    end subroutine set_other_open_data


    module function total_open_depth( map ) result(total_depth)
!! Version: Experimental
!!
!! Returns the total number of ones based offsets of slot entries from
!! their slot index for a hash map
!! Arguments:
!!     map - an open hash map
        class(open_hashmap_type), intent(in) :: map
        integer(int64) :: total_depth

        integer(int_index) :: inv_index, slot, slots
        integer(int_hash)  :: index

        total_depth = 0_int64
        slots = size( map % slots, kind=int_index )
        do slot=0, slots-1
            if ( map % slots( slot ) == 0 ) cycle
            inv_index = map % slots( slot )
            if ( inv_index <= 0 ) cycle
            associate( inverse => map % inverse( inv_index ))
              index = fibonacci_hash( inverse % target % hash_val, &
                                      map % nbits )
            end associate
            total_depth = total_depth + &
                iand( slot - index, map % index_mask ) + 1_int64
        end do

    end function total_open_depth


    module subroutine open_key_test(map, key, present)
!! Version: Experimental
!!
!! Returns a logical flag indicating whether KEY exists in the hash map
!! Arguments:
!!     map - the hash map of interest
!!     key - the key of interest
!
        class(open_hashmap_type), intent(inout) :: map
        type(key_type), intent(in)              :: key
        logical, intent(out)                    :: present

        integer(int_index) :: inmap

        call in_open_map( map, inmap, key )
        if ( inmap <= 0 .or. inmap > size( map % inverse, kind=int_index ) ) &
            then
            present = .false.
        else
            present = associated( map % inverse(inmap) % target )
        end if

    end subroutine open_key_test

end submodule stdlib_hashmap_open

program example_uigamma
  use stdlib_specialfunctions_gamma, only: uig => upper_incomplete_gamma
  implicit none

  print *, uig(3, -5.0)

!2523.02295

  print *, uig(2.3, 5.0)

!6.95552528E-02
end program example_uigamma

program selection_vs_sort
  use stdlib_kinds, only: int64
  use stdlib_selection, only: select, arg_select
  use stdlib_sorting, only: sort
  implicit none

  call compare_select_sort_for_median(1)
  call compare_select_sort_for_median(11)
  call compare_select_sort_for_median(101)
  call compare_select_sort_for_median(1001)
  call compare_select_sort_for_median(10001)
  call compare_select_sort_for_median(100001)

contains
  subroutine compare_select_sort_for_median(N)
    integer, intent(in) :: N

    integer :: i, k, result_arg_select, indx(N), indx_local(N)
    real :: random_vals(N), local_random_vals(N)
    integer, parameter :: test_reps = 100
    integer(int64) :: t0, t1
    real :: result_sort, result_select
    integer(int64) :: time_sort, time_select, time_arg_select
    logical :: select_test_passed, arg_select_test_passed

! Ensure N is odd
    if (mod(N, 2) /= 1) stop

    time_sort = 0
    time_select = 0
    time_arg_select = 0

    select_test_passed = .true.
    arg_select_test_passed = .true.

    indx = (/(i, i=1, N)/)

    k = (N + 1)/2 ! Deliberate integer division

    do i = 1, test_reps
      call random_number(random_vals)

! Compute the median with sorting
      local_random_vals = random_vals
      call system_clock(t0)
      call sort(local_random_vals)
      result_sort = local_random_vals(k)
      call system_clock(t1)
      time_sort = time_sort + (t1 - t0)

! Compute the median with selection, assuming N is odd
      local_random_vals = random_vals
      call system_clock(t0)
      call select(local_random_vals, k, result_select)
      call system_clock(t1)
      time_select = time_select + (t1 - t0)

! Compute the median with arg_select, assuming N is odd
      local_random_vals = random_vals
      indx_local = indx
      call system_clock(t0)
      call arg_select(local_random_vals, indx_local, k, result_arg_select)
      call system_clock(t1)
      time_arg_select = time_arg_select + (t1 - t0)

      if (result_select /= result_sort) select_test_passed = .FALSE.
      if (local_random_vals(result_arg_select) /= result_sort) arg_select_test_passed = .FALSE.
    end do

    print *, "select    ; N=", N, '; ', merge('PASS', 'FAIL', select_test_passed), &
      '; Relative-speedup-vs-sort:', (1.0*time_sort)/(1.0*time_select)
    print *, "arg_select; N=", N, '; ', merge('PASS', 'FAIL', arg_select_test_passed), &
      '; Relative-speedup-vs-sort:', (1.0*time_sort)/(1.0*time_arg_select)

  end subroutine

end program

program example_string_to_number
    use stdlib_kinds, only: dp
    use stdlib_str2num, only: to_num
    implicit none
    character(:), allocatable :: txt
    real(dp) :: x
  
    txt = ' 8.8541878128e−12 '
    x = to_num( txt , x )
  end program example_string_to_number

program example_zfill
  use stdlib_string_type, only: string_type, assignment(=), write (formatted)
  use stdlib_strings, only: zfill
  implicit none
  type(string_type) :: string

  string = "left pad this string with zeros"
! string <-- "left pad this string with zeros"

  print '(dt)', zfill(string, 36) ! "00000left pad this string with zeros"

  string = zfill(string, 36)
! string <-- "00000left pad this string with zeros"

end program example_zfill

program example_gamma
  use stdlib_kinds, only: sp, dp, int64
  use stdlib_specialfunctions_gamma, only: gamma
  implicit none

  integer :: i
  integer(int64) :: n
  real :: x
  real(dp) :: y
  complex(sp) :: z

  i = 10
  n = 15_int64
  x = 2.5
  y = 4.3_dp
  z = (2.3, 0.6)

  print *, gamma(i)              !integer gives exact result
! 362880

  print *, gamma(n)
! 87178291200

  print *, gamma(x)              ! intrinsic function call
! 1.32934034

  print *, gamma(y)              ! intrinsic function call
! 8.8553433604540341

  print *, gamma(z)
! (0.988054395, 0.383354813)

end program example_gamma

program example_determinant
  use stdlib_kinds, only: dp
  use stdlib_linalg, only: det, linalg_state_type
  implicit none

  real(dp) :: d

  ! Compute determinate of a real matrix
  d = det(reshape([real(dp)::1,2,3,4],[2,2]))

  print *, d ! a*d-b*c = -2.0

end program example_determinant

submodule (stdlib_specialfunctions) stdlib_specialfunctions_legendre
    implicit none

contains

    ! derivatives of legegendre polynomials
    ! unspecified behaviour if n is negative
    pure elemental module function dlegendre_fp64(n,x) result(dleg)
        integer, intent(in) :: n
        real(dp), intent(in) :: x
        real(dp) :: dleg

        select case(n)
            case(0)
                dleg = 0
            case(1)
                dleg = 1
            case default
                block
                    real(dp) :: leg_down1, leg_down2, leg
                    real(dp) :: dleg_down1, dleg_down2
                    integer :: i 

                    leg_down1  = x
                    dleg_down1 = 1

                    leg_down2  = 1
                    dleg_down2 = 0

                    do i = 2, n
                        leg = (2*i-1)*x*leg_down1/i - (i-1)*leg_down2/i
                        dleg = dleg_down2 + (2*i-1)*leg_down1
                        leg_down2 = leg_down1
                        leg_down1 = leg
                        dleg_down2 = dleg_down1
                        dleg_down1 = dleg
                    end do
                end block
        end select
    end function

    ! legegendre polynomials
    ! unspecified behaviour if n is negative
    pure elemental module function legendre_fp64(n,x) result(leg)
        integer, intent(in) :: n
        real(dp), intent(in) :: x
        real(dp) :: leg
        select case(n)
            case(0)
                leg  = 1
            case(1)
                leg  = x
            case default
                block
                    real(dp) :: leg_down1, leg_down2
                    integer :: i 

                    leg_down1  = x
                    leg_down2  = 1

                    do i = 2, n
                        leg = (2*i-1)*x*leg_down1/i - (i-1)*leg_down2/i
                        leg_down2 = leg_down1
                        leg_down1 = leg
                    end do
                end block
        end select
    end function

end submodule

program example_is_square
  use stdlib_linalg, only: is_square
  implicit none
  real :: A(2, 2), B(3, 2)
  logical :: res
  A = reshape([1., 2., 3., 4.], shape(A))
  B = reshape([1., 2., 3., 4., 5., 6.], shape(B))
  res = is_square(A) ! returns .true.
  res = is_square(B) ! returns .false.
end program example_is_square

program example_equal_keys
  use stdlib_hashmap_wrappers, only: &
    copy_key, operator(==), key_type, set
  use iso_fortran_env, only: int8
  implicit none
  integer(int8) :: i, value(15)
  type(key_type) :: old_key, new_key
  do i = 1, 15
    value(i) = i
  end do
  call set(old_key, value)
  call copy_key(old_key, new_key)
  print *, "old_key == new_key = ", old_key == new_key
end program example_equal_keys

! Example program demonstrating the usage of hermitian
program example_hermitian
  use stdlib_linalg, only: hermitian
  implicit none

  complex, dimension(2, 2) :: A, AT

  ! Define input matrices
  A = reshape([(1,2),(3,4),(5,6),(7,8)],[2,2])

  ! Compute Hermitian matrices
  AT = hermitian(A)

  print *, "Original Complex Matrix:"
  print *, A
  print *, "Hermitian Complex Matrix:"
  print *, AT
  
end program example_hermitian

program example_padr
  use stdlib_string_type, only: string_type, assignment(=), write (formatted)
  use stdlib_strings, only: padr
  implicit none
  type(string_type) :: string

  string = "right pad this string"
! string <-- "right pad this string"

  print '(dt)', padr(string, 25, "$") ! "right pad this string$$$$"

  string = padr(string, 25)
! string <-- "right pad this string    "

end program example_padr

program example_write_bitset
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_0 = 'S33B000000000000000000000000000000000', &
    bits_1 = 'S33B000000000000000000000000000000001', &
    bits_2 = 'S33B100000000000000000000000000000000'
  character(:), allocatable :: test_0, test_1, test_2
  integer :: unit, status
  type(bitset_64) :: set0, set1, set2, set3, set4, set5
  call set0%read_bitset(bits_0, status)
  call set1%read_bitset(bits_1, status)
  call set2%read_bitset(bits_2, status)
  call set0%write_bitset(test_0, status)
  call set1%write_bitset(test_1, status)
  call set2%write_bitset(test_2, status)
  if (bits_0 == test_0 .and. bits_1 == test_1 .and. &
      bits_2 == test_2) then
    write (*, *) 'READ_BITSET to WRITE_BITSET strings worked.'
  end if
  open (newunit=unit, file='test.txt', status='replace', &
        form='formatted', action='write')
  call set2%write_bitset(unit, advance='no')
  call set1%write_bitset(unit, advance='no')
  call set0%write_bitset(unit)
  close (unit)
  open (newunit=unit, file='test.txt', status='old', &
        form='formatted', action='read')
  call set3%read_bitset(unit, advance='no')
  call set4%read_bitset(unit, advance='no')
  call set5%read_bitset(unit)
  if (set3 == set0 .and. set4 == set1 .and. set5 == set2) then
    write (*, *) 'WRITE_BITSET to READ_BITSET through unit worked.'
  end if
end program example_write_bitset

program example_constructor_scalar
  use stdlib_string_type
  implicit none
  type(string_type) :: string
  string = string_type("Sequence")
! len(string) == 8
  string = string_type(" S p a c e d ")
! len(string) == 13
end program example_constructor_scalar

program example_exponential_cdf
  use stdlib_random, only: random_seed
  use stdlib_stats_distribution_exponential, only: exp_cdf => cdf_exp, &
                                                   rexp => rvs_exp

  implicit none
  real, dimension(2, 3, 4) :: x, loc, scale
  real :: xsum
  complex :: cloc, cscale
  integer :: seed_put, seed_get, i

  seed_put = 1234567
  call random_seed(seed_put, seed_get)

  ! standard exponential cumulative distribution at x=1.0 with loc=0.0, scale=1.0
  print *, exp_cdf(1.0, 0.0, 1.0)
  ! 0.632120550

  ! standard exponential cumulative distribution at x=1.0 with lambda=1.0
  print *, exp_cdf(1.0, 1.0)
  ! 0.632120550

  ! cumulative distribution at x=2.0 with lambda=2
  print *, exp_cdf(2.0, 2.0)
  ! 0.981684387

  ! cumulative distribution at x=2.0 with loc=0.0 and scale=0.5 (equivalent of lambda=2)
  print *, exp_cdf(2.0, 0.0, 0.5)
  ! 0.981684387

  ! cumulative distribution at x=2.5 with loc=0.5 and scale=0.5 (equivalent of lambda=2)
  print *, exp_cdf(2.5, 0.5, 0.5)
  ! 0.981684387

  ! cumulative distribution at x=2.0 with loc=0.0 and scale=-1.0 (out of range)
  print *, exp_cdf(2.0, 0.0, -1.0)
  ! NaN

  ! cumulative distribution at x=0.5 with loc=1.0 and scale=1.0, putting x below the minimum
  print *, exp_cdf(0.5, 1.0, 1.0)
  ! 0.00000000

   ! standard exponential random variates array
  x = reshape(rexp(0.0, 2.0, 24), [2, 3, 4])

  ! a rank-3 exponential cumulative distribution
  loc(:, :, :)   = 0.0
  scale(:, :, :) = 2.0
  print *, exp_cdf(x, loc, scale)
  ! 0.301409245  0.335173965  5.94930053E-02  0.113003314
  ! 0.365694344  0.583515942  0.113774836     0.838585377
  ! 0.509324908  0.127967060  0.857194781     0.893231630
  ! 0.355383813  0.470882893  0.574203610     0.799321830
  ! 0.546216846  0.111995399  0.801794767     0.922525287
  ! 0.937719882  0.301136374  3.44503522E-02  0.134661376


  ! cumulative distribution array where scale<=0.0 for certain elements
  print *, exp_cdf([1.0, 1.0, 1.0], [0.0, 0.0, 0.0], [1.0, 0.0, -1.0])
  ! 0.632120550  NaN NaN

  ! `cdf_exp` is pure and, thus, can be called concurrently
  xsum = 0.0
  do concurrent (i=1:size(x,3))
    xsum = xsum + sum(exp_cdf(x(:,:,i), loc(:,:,i), scale(:,:,i)))
  end do
  print *, xsum
  ! 11.0886612

  ! complex exponential cumulative distribution at (0.5, 0.0, 2) with real part of
  ! scale=2 and imaginary part of scale=1.0
  cloc   = (0.0, 0.0)
  cscale = (2, 1.0)
  print *, exp_cdf((0.5, 0.5), cloc, cscale)
  ! 8.70351046E-02

  ! As above, but with scale%im < 0
  cloc   = (0.0, 0.0)
  cscale = (1.0, -2.0)
  print *, exp_cdf((1.5, 1.0), cloc, cscale)
  ! NaN

end program example_exponential_cdf

program example_select
  use stdlib_selection, only: select
  implicit none

  real, allocatable :: array(:)
  real :: kth_smallest
  integer :: k

  array = [3., 2., 7., 4., 5., 1., 4., -1.]

  k = 2
  call select(array, k, kth_smallest)
  print *, kth_smallest ! print 1.0

  k = 7
! Due to the previous call to select, we know for sure this is in an
! index >= 2
  call select(array, k, kth_smallest, left=2)
  print *, kth_smallest ! print 5.0

  k = 6
! Due to the previous two calls to select, we know for sure this is in
! an index >= 2 and <= 7
  call select(array, k, kth_smallest, left=2, right=7)
  print *, kth_smallest ! print 4.0

end program example_select

! Showcase usage of the null device
program example_null_device
    use stdlib_system, only: null_device
    use iso_fortran_env, only: output_unit
    implicit none
    integer :: unit 
    logical :: screen_output = .false.

    if (screen_output) then 
       unit = output_unit
    else
       ! Write to the null device if no screen output is wanted
       open(newunit=unit,file=null_device())
    endif     

    write(unit,*) "Hello, world!" 

    if (.not.screen_output) close(unit) 

end program example_null_device

program example_read_bitset
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_0 = 'S33B000000000000000000000000000000000', &
    bits_1 = 'S33B000000000000000000000000000000001', &
    bits_2 = 'S33B100000000000000000000000000000000'
  character(:), allocatable :: test_0, test_1, test_2
  integer :: unit, status
  type(bitset_64) :: set0, set1, set2, set3, set4, set5
  call set0%read_bitset(bits_0, status)
  call set1%read_bitset(bits_1, status)
  call set2%read_bitset(bits_2, status)
  call set0%write_bitset(test_0, status)
  call set1%write_bitset(test_1, status)
  call set2%write_bitset(test_2, status)
  if (bits_0 == test_0 .and. bits_1 == test_1 .and. &
      bits_2 == test_2) then
    write (*, *) 'READ_BITSET to WRITE_BITSET strings worked.'
  end if
  open (newunit=unit, file='test.txt', status='replace', &
        form='formatted', action='write')
  call set2%write_bitset(unit, advance='no')
  call set1%write_bitset(unit, advance='no')
  call set0%write_bitset(unit)
  close (unit)
  open (newunit=unit, file='test.txt', status='old', &
        form='formatted', action='read')
  call set3%read_bitset(unit, advance='no')
  call set4%read_bitset(unit, advance='no')
  call set5%read_bitset(unit)
  if (set3 == set0 .and. set4 == set1 .and. set5 == set2) then
    write (*, *) 'WRITE_BITSET to READ_BITSET through unit worked.'
  end if
end program example_read_bitset

! Illustrate the usage of `make_directory`, `make_directory_all`
program example_make_directory
    use stdlib_system, only: make_directory, make_directory_all
    use stdlib_error, only: state_type
    implicit none

    type(state_type) :: err

    call make_directory("temp_dir", err)

    if (err%error()) then
        print *, err%print()
    else
        print *, "directory created sucessfully"
    end if

    call make_directory_all("d1/d2/d3/d4", err)

    if (err%error()) then
        print *, err%print()
    else
        print *, "nested directories created sucessfully"
    end if

end program example_make_directory

! Process example 1: Run a Command Synchronously and Capture Output
program run_sync
    use stdlib_system, only: run, is_completed, is_windows, process_type
    implicit none

    type(process_type) :: p
    logical :: completed

    ! Run a synchronous process to list directory contents
    if (is_windows()) then
        p = run("dir", want_stdout=.true.)
    else
        p = run("ls -l", want_stdout=.true.)
    end if

    ! Check if the process is completed (should be true since wait=.true.)
    if (is_completed(p)) then
        print *, "Process completed successfully. The current directory: "
        print *, p%stdout
    else
        print *, "Process is still running (unexpected)."
    end if
    
end program run_sync

! Process example 7: Usage of `kill`
program example_process_7
    use stdlib_system, only: process_type, runasync, kill
    implicit none

    type(process_type) :: p
    logical :: success

    ! Start a process asynchronously
    p = runasync("sleep 10")

    ! Attempt to kill the process
    call kill(p, success)

    if (success) then
        print *, "Process successfully killed."
    else
        print *, "Failed to kill the process."
    end if
    
end program example_process_7    

program example_all
  use stdlib_bitsets
  implicit none
  character(*), parameter :: &
    bits_all = '111111111111111111111111111111111'
  type(bitset_64) :: set0
  call set0%from_string(bits_all)
  if (.not. set0%all()) then
    error stop "FROM_STRING failed to interpret"// &
      "BITS_ALL's value properly."
  else
    write (*, *) "FROM_STRING transferred BITS_ALL properly"// &
      " into set0."
  end if
end program example_all

program example_to_sentence
  use stdlib_ascii, only: to_sentence
  implicit none
  print *, to_sentence("hello!") ! returns "Hello!"
  print *, to_sentence("'enquoted'") ! returns "'Enquoted'"
  print *, to_sentence("1st")  ! returns "1st"
end program example_to_sentence

program example_water_hash
  use stdlib_hash_32bit, only: water_hash, &
                               new_water_hash_seed
  use iso_fortran_env, only: int32, int64
  implicit none
  integer(int32) :: hash
  integer(int64) :: seed = 42_int64
  call new_water_hash_seed(seed)
  hash = water_hash([5, 4, 3, 1, 10, 4, 9], seed)
  print *, hash, seed
end program example_water_hash

program example_error_state2
  !! This example shows how to set a `type(state_type)` variable to process output conditions 
  !! out of a simple division routine. The example is meant to highlight: 
  !! 1) the different mechanisms that can be used to initialize the `state_type` variable providing 
  !!    strings, scalars, or arrays, on input to it; 
  !! 2) `pure` setup of the error control
  use stdlib_error, only: state_type, STDLIB_VALUE_ERROR, STDLIB_SUCCESS
  implicit none
  type(state_type) :: err
  real :: a_div_b
  
  ! OK
  call very_simple_division(0.0,2.0,a_div_b,err)
  print *, err%print()
  
  ! Division by zero
  call very_simple_division(1.0,0.0,a_div_b,err)
  print *, err%print()  

  ! Out of bounds
  call very_simple_division(huge(0.0),0.001,a_div_b,err)
  print *, err%print()  
  
  contains
  
     !> Simple division returning an integer flag (LAPACK style)
     elemental subroutine very_simple_division(a,b,a_div_b,err)
        real, intent(in) :: a,b
        real, intent(out) :: a_div_b
        type(state_type), optional, intent(out) :: err
        
        type(state_type) :: err0
        real, parameter :: MAXABS = huge(0.0)
        character(*), parameter :: this = 'simple division'
        
        !> Check a
        if (b==0.0) then 
            ! Division by zero
            err0 = state_type(this,STDLIB_VALUE_ERROR,'Division by zero trying ',a,'/',b)
        elseif (.not.abs(b)<MAXABS) then 
            ! B is out of bounds
            err0 = state_type(this,STDLIB_VALUE_ERROR,'B is infinity in a/b: ',[a,b]) ! use an array
        elseif (.not.abs(a)<MAXABS) then 
            ! A is out of bounds
            err0 = state_type(this,STDLIB_VALUE_ERROR,'A is infinity in a/b: a=',a,' b=',b)
        else
            a_div_b = a/b
            if (.not.abs(a_div_b)<MAXABS) then 
                ! Result is out of bounds
                err0 = state_type(this,STDLIB_VALUE_ERROR,'A/B is infinity in a/b: a=',a,' b=',b)
            else
                err0%state = STDLIB_SUCCESS
            end if
        end if
        
        ! Return error flag, or hard stop on failure
        call err0%handle(err)
                
     end subroutine very_simple_division


end program example_error_state2

program example_simps
  use stdlib_quadrature, only: simps
  implicit none
  real, parameter :: x(5) = [0., 1., 2., 3., 4.]
  real :: y(5) = 3.*x**2
  print *, simps(y, x)
! 64.0
  print *, simps(y, 0.5)
! 32.0
end program example_simps

! This example includes eigenvalue computation in addition to 
! the Schur decomposition for a randomly generated matrix.
program example_schur_eigenvalues
  use stdlib_linalg, only: schur
  use stdlib_linalg_constants, only: dp
  implicit none
  
  integer, parameter :: n = 5  
  real(dp), dimension(n,n) :: A, T, Z
  complex(dp), dimension(n) :: eigenvalues
  
  ! Create a random real-valued square matrix
  call random_number(A)

  ! Compute the Schur decomposition and eigenvalues
  call schur(A, T, Z, eigenvalues)

  ! Output results
  print *, "Random Matrix A:"
  print *, A
  print *, "Schur Form Matrix T:"
  print *, T
  print *, "Orthogonal Matrix Z:"
  print *, Z
  print *, "Eigenvalues:"
  print *, eigenvalues

  ! Test factorization: Z*T*Z^T = A
  print *, "Max error in reconstruction:", maxval(abs(matmul(Z, matmul(T, transpose(Z))) - A))

end program example_schur_eigenvalues

program example_repeat
  use stdlib_string_type
  implicit none
  type(string_type) :: string

  string = "What? "
  string = repeat(string, 3)
! string == "What? What? What? "
end program example_repeat

program example_check3
  use stdlib_error, only: check
  implicit none
  integer :: a = 1
! If a /= 5,  prints 'a == 5 failed.', but doesn't stop the program.
  call check(a == 5, msg='a == 5 failed.', warn=.true.)
end program example_check3

program example_loadtxt
  use stdlib_io, only: loadtxt
  implicit none
  real, allocatable :: x(:, :)
  call loadtxt('example.dat', x)
  
  ! Can also use list directed format if the default read fails.
  call loadtxt('example.dat', x, fmt='*')

  call loadtxt('example.csv', x, delimiter=',')

end program example_loadtxt

program example_dist_rand
  use stdlib_kinds, only: int8, int16, int32, int64
  use stdlib_random, only: dist_rand, random_seed
  implicit none
  integer :: put, get

  put = 135792468
  call random_seed(put, get)     ! set and get current value of seed
  print *, dist_rand(1_int8)     ! random integer in [-2^7, 2^7 - 1]
! -90
  print *, dist_rand(1_int16)    ! random integer in [-2^15, 2^15 - 1]
! -32725
  print *, dist_rand(1_int32)    ! random integer in [-2^31, 2^31 - 1]
! -1601563881
  print *, dist_rand(1_int64)    ! random integer in [-2^63, 2^63 - 1]
! 180977695517992208
end program example_dist_rand

! Process example 5: Object-oriented interface
program example_process_5
    use stdlib_system, only: process_type, runasync, is_windows, sleep, update
    implicit none
    type(process_type) :: process

    if (is_windows()) then
        process = runasync("ping -n 10 127.0.0.1")
    else
        process = runasync("ping -c 10 127.0.0.1")
    endif

    ! Verify the process is running
    do while (process%is_running())
        
        ! Update process state
        call update(process)
        
        ! Wait a bit before killing the process
        call sleep(millisec=1500)
        
        print *, "Process has been running for ",process%elapsed()," seconds..."

    end do
    
    print *, "Process ",process%pid()," completed in ",process%elapsed()," seconds."
    
end program example_process_5

---
title: Workflow for Contributors
---

@note
This is a living document.
You are welcome to propose changes to this workflow by opening an
[issue](https://github.com/fortran-lang/stdlib/issues).

{!WORKFLOW.md!}

---
project: Fortran-lang/stdlib
summary: A community driven standard library for (modern) Fortran
src_dir: src
include: src
         include
exclude_dir: src/tests
output_dir: API-doc
page_dir: doc
media_dir: doc/media
exclude: src/stdlib_linalg_lapack.fypp
         src/stdlib_linalg_lapack_aux.fypp
         src/stdlib_linalg_lapack_c.fypp
         src/stdlib_linalg_lapack_d.fypp
         src/stdlib_linalg_lapack_q.fypp
         src/stdlib_linalg_lapack_s.fypp
         src/stdlib_linalg_lapack_w.fypp
         src/stdlib_linalg_lapack_z.fypp
fpp_extensions: fypp
preprocess: true
macro: MAXRANK=3
       PROJECT_VERSION_MAJOR=0
       PROJECT_VERSION_MINOR=0
       PROJECT_VERSION_PATCH=0
preprocessor: fypp
display: public
         protected
source: true
proc_internals: true
md_extensions: markdown.extensions.toc
graph: true
graph_maxnodes: 250
graph_maxdepth: 5
coloured_edges: true
sort: permission-alpha
extra_mods: iso_fortran_env:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fFORTRAN_005fENV.html
            iso_c_binding:https://gcc.gnu.org/onlinedocs/gfortran/ISO_005fC_005fBINDING.html#ISO_005fC_005fBINDING
print_creation_date: true
creation_date: %Y-%m-%d %H:%M %z
project_github: https://github.com/fortran-lang/stdlib
project_download: https://github.com/fortran-lang/stdlib/archive/HEAD.zip
project_website: https://stdlib.fortran-lang.org
favicon: doc/media/favicon.ico
license: by-sa
author: fortran-lang/stdlib contributors
author_pic: https://fortran-lang.org/en/_static/fortran-logo-256x256.png 
email: fortran-lang@groups.io
github: https://github.com/fortran-lang
twitter: https://twitter.com/fortranlang
website: https://fortran-lang.org
dbg: true
---

[TOC]

@warning This API documentation for the Fortran-lang/stdlib is a work in progress

@note
Use the navigation bar at the top of the screen to browse modules, procedures, source files, etc.
The listings near the bottom of the page are incomplete.

Fortran stdlib API Documentation
================================

This is the main API documentation landing page generated by [FORD].
The documentation for comment markup in source code, running [FORD] and the [FORD project file] are all maintained on the [FORD wiki].

[FORD]: https://github.com/Fortran-FOSS-Programmers/ford#readme
[FORD wiki]: https://github.com/Fortran-FOSS-Programmers/ford/wiki
[FORD project file]: https://github.com/fortran-lang/stdlib/blob/HEAD/API-doc-FORD-file.md

Goals and Motivation
====================

The Fortran Standard, as published by the ISO (https://wg5-fortran.org/), does
not have a Standard Library. The goal of this project is to provide a community
driven and agreed upon *de facto* "standard" library for Fortran, called a
Fortran Standard Library (`stdlib`). We have a rigorous process how `stdlib` is
developed as documented in our [Workflow](page/contributing/Workflow.html). `stdlib` is both a
specification and a reference implementation. We are cooperating with the
Fortran Standards Committee (e.g., the effort
[started](https://github.com/j3-fortran/fortran_proposals/issues/104) at the J3
committee repository) and the plan is to continue working with the Committee in
the future (such as in the step 5. in the [Workflow](page/contributing/Workflow.html) document), so
that if the Committee wants to standardize some feature already available in `stdlib`, it would
base it on `stdlib`'s implementation.

Scope
=====

The goal of the Fortran Standard Library is to achieve the following general scope:

* Utilities (containers, strings, files, OS/environment integration, unit
  testing & assertions, logging,  ...)
* Algorithms (searching and sorting, merging, ...)
* Mathematics (linear algebra, sparse matrices, special functions, fast Fourier
  transform, random numbers, statistics, ordinary differential equations,
  numerical integration, optimization, ...)

Code of Conduct
===============

In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to make participation in our project and our community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, gender identity and expression, level of experience, nationality, personal appearance, race, religion, or sexual identity and orientation. Please read first [this Code of Conduct](./page/contributing/CodeOfConduct.html)

License
=======

The `stdlib` source code and related files and documentation are distributed under the [MIT license](page/License.html).

# Contributing to the Fortran standard library

Thank you for considering contributing to the Fortran standard library (*stdlib*).
Please review and follow these guidelines to make the contribution process
simple and effective for all involved. It will help communicate that you
respect the time of the community developers. In return, the community will
help to address your problem, evaluate changes, and guide you through your pull
requests.

By contributing to *stdlib*, you certify that you own or are allowed to share the
content of your contribution under the
[stdlib license](https://github.com/fortran-lang/stdlib/blob/HEAD/LICENSE).

* [Style](#style)
* [Reporting a bug](#reporting-a-bug)
* [Suggesting a feature](#suggesting-a-feature)
* [Workflow](#workflow)
* [General guidelines](#general-guidelines)
* [For new contributors](#for-new-contributors)


## Style

Please follow the
[Fortran stdlib style guide](https://github.com/fortran-lang/stdlib/blob/HEAD/STYLE_GUIDE.md)
for any Fortran code that you contribute.
This allows the community to focus on substance rather than style.

The style guide is a living document.
You are welcome to propose changes to the style guide by
[opening an issue](https://github.com/fortran-lang/stdlib/issues/new/choose) or
[starting a discussion](https://github.com/fortran-lang/stdlib/discussions/new).


## Reporting a bug

A bug is a *demonstrable problem* caused by the code in this repository.
Good bug reports are extremely valuable to the community—thank you!

Before opening a bug report:

1. Check if the issue has already been reported
   ([issues](https://github.com/fortran-lang/stdlib/issues)).
2. Check if it is still an issue or it has been fixed?
   Try to reproduce it with the latest version from the default branch.
3. Isolate the problem and create a minimal test case.

A good bug report should include all information needed to reproduce the bug.
Please be as detailed as possible:

1. Which version of *stdlib* are you using?
   Which compiler version are you using?
   Which platform and architecture are you on?
   Please be specific.
2. What are the steps to reproduce the issue?
3. What is the expected outcome?
4. What happens instead?

This information will help the community to diagnose the issue quickly and with
minimal back-and-forth.


## Suggesting a feature

Before suggesting a new feature, take a moment to find out if it fits the scope
of the project, or if it has already been discussed. It is up to you to provide
a strong argument to convince the community of the benefits of this feature.
Please provide as many details and context as possible. If applicable, include a
mocked-up snippet of what the output or behavior would look like with this
feature implemented. “Crazy,” out-of-the-box ideas are especially welcome.
It is quite possible we have not considered such solutions yet.


## Workflow

The general workflow is documented in
[this document](https://github.com/fortran-lang/stdlib/blob/HEAD/WORKFLOW.md)

The workflow guide is a living document.
You are welcome to propose changes to the workflow by
[opening an issue](https://github.com/fortran-lang/stdlib/issues/new/choose) or
[starting a discussion](https://github.com/fortran-lang/stdlib/discussions/new).


## General guidelines

* A PR should implement *only one* feature or bug fix.
* Do not commit changes to files that are irrelevant to your feature or bug fix.
* Smaller PRs are better than large PRs, and will lead to a shorter review and
  merge cycle.
* Add tests for your feature or bug fix to be sure that it stays functional and useful.
* Include new features and changes in the
  [CHANGELOG](https://github.com/fortran-lang/stdlib/blob/master/CHANGELOG.md)
* Be open to constructive criticism and requests for improving your code.
* Again, please follow the
  [Fortran stdlib style guide](https://github.com/fortran-lang/stdlib/blob/HEAD/STYLE_GUIDE.md).


## For new contributors

If you have never created a pull request before, welcome :tada:.
You can learn how from
[this great tutorial](https://app.egghead.io/courses/how-to-contribute-to-an-open-source-project-on-github).

Don’t know where to start?
You can start by looking through the list of
[open issues](https://github.com/fortran-lang/stdlib/issues).

---
title: Contributing and specs
---

@warning
This page is currently under construction!

@todo
Improve the title of this FORD "pages" section, and
improve the organization of pages
to separate end-user, high-level documentation and examples from developer documentation and specs.

# Fortran stdlib Style Guide

Adopting a consistent style can improve code legibility through the choice of good naming conventions.
In addition, style checks will be run during CI to flag any severe non-conformance.
This allows code review discussions to focus on semantics and substance rather than pedantry.
Consistent whitespace usage, and not polluting line endings with trailing white space makes `git diff`s considerably more legible.
This style guide is a living document and proposed changes may be adopted after discussing them and coming to a consensus.

## Use (modern) standard Fortran

* Do not use obsolescent or deleted language features
  E.g., `common`, `pause`, `entry`, arithmetic `if` and computed `goto`
* Do not use vendor extensions in the form of non-standard syntax and vendor supplied intrinsic procedures
  E.g., `real*8` or `etime()`

## File naming conventions

* Source files should contain at most one `program`, `module`, or `submodule`
* The filename should match the program or module name and have the file extension `.f90` or `.F90` if preprocessing is required
* All included files must use the `.inc` extension. These files should be located in the `include/` directory.
* If the interface and implementation is split using submodules the implementation submodule file should have the same name as the
  interface (parent) module but end in `_implementation`
  E.g., `string_class.f90` and `string_class_implementation.f90`
* Tests should be added in the `test` subdirectory and have the same name as the module they are testing with the `test_` prefix
  added
  E.g., `string_class.f90` and `test/test_string_class.f90`

## Indentation & whitespace

By setting and following a convention for indentation and whitespace, code reviews and git-diffs can
focus on the semantics of the proposed changes rather than style and formatting.

* The body of every Fortran construct should be indented by __four (4) spaces__
* Line length *should be limited to 80 characters* and __must not exceed 132__
* Please do not use <kbd>Tab</kbd> characters for indentation
* Please remove trailing white space before committing code

## Variable and procedure naming

* Variable and procedure names, as well as Fortran keywords, should be written in lowercase
* Variable and procedure names should be made up of one or more full words separated by an underscore,
  for example `has_failed` is preferred over `hasfailed`
* Where conventional and appropriate shortening of a word is used then the underscore may be omitted,
  for example `linspace` is preferred over `lin_space`

## Attributes

<!-- ATTENTION! This section includes intentional trailing whitespace to get decent formatting with GFM and Python Markdown. -->

* Always specify `intent` for dummy arguments.
* Don't use `dimension` attribute to declare arrays because it is more verbose.
  Use this:  
  ```
  real, allocatable :: a(:), b(:,:)
  ```  
  instead of:  
  ```
  real, dimension(:), allocatable :: a
  ```  
  ```
  real, dimension(:,:), allocatable :: b
  ```  
  When defining many arrays of the same dimension, `dimension` can be used as an exception if it makes the code less verbose.
* If the `optional` attribute is used to declare a dummy argument, it should follow the `intent` attribute.
* For module procedures, it is recommended to declare attributes before the module keyword for better retro compatibility (Projects using CMake versions lower than CMake 3.25.0 are concerned see [Spurious modules](https://gitlab.kitware.com/cmake/cmake/-/issues/18427#note_983426)).
  Prefer the following pattern:
  ```
  <attribute> <attribute> module <function/subroutine> <name>
  ```
  instead of:
  ```
  module <attribute> <attribute> <function/subroutine> <name>
  ```
## End <scope> block closing statements

Fortran allows certain block constructs or scopes to include the name of the program unit in the end statement.
The convention adopted herein is to include procedure names, `module` names and `program` names in the `end` statement,
unless the closing statement can reasonably be expected to be on the same screen or page, within about 25 lines.

## Document public API code with FORD

Documentation strings should be provided for all public and protected entities and their arguments or parameters.
This is currently accomplished using the [FORD tool](https://github.com/Fortran-FOSS-Programmers/ford).
For help writing FORD style documentation please see the [FORD wiki](https://github.com/Fortran-FOSS-Programmers/ford/wiki).
The following two sections are most relevant for contributing new code:

* [Writing Documentation](https://github.com/Fortran-FOSS-Programmers/ford/wiki/Writing-Documentation)
* [Documentation Meta Data](https://github.com/Fortran-FOSS-Programmers/ford/wiki/Documentation-Meta-Data)
* [Limitations](https://github.com/Fortran-FOSS-Programmers/ford/wiki/Limitations)

To write the "spec" (specification) for a new proposal, please place it in the
[FORD "pages"](https://github.com/Fortran-FOSS-Programmers/ford/wiki/Writing-Pages) directory at
[`doc/specs/`](https://github.com/fortran-lang/stdlib/tree/HEAD/doc/specs).
To get help please see the ["Writing Pages"](https://github.com/Fortran-FOSS-Programmers/ford/wiki/Writing-Pages)
and ["Writing Documentation"](https://github.com/Fortran-FOSS-Programmers/ford/wiki/Writing-Documentation) pages
on the [FORD wiki](https://github.com/Fortran-FOSS-Programmers/ford/wiki).

# Workflow for the Fortran stdlib contributors

This document describes our current workflow.

We welcome everyone and anyone to participate and propose additions to stdlib.
It is okay if you do not have experience for specification or implementation,
but have an idea for stdlib. If the idea is popular among the community, more
experienced contributors will help it through all 5 steps.


1. **Idea**: You have an idea or a proposal. Open an
   [issue](https://github.com/fortran-lang/stdlib/issues) to discuss it. This
   is on the level of "is there interest in having image reader/writer
   functions in stdlib?" The goal of this step is to find out if the community
   is interested in having this functionality as part of stdlib.

2. **API**: When there seems to be significant interest in the proposal (vast
   majority of participants think it is a good idea), move on to discuss the
   specific API. It's OK to propose the API off the bat if you already have an
   idea for it. This step is exploratory and its goal is to find out what the
   API should *look* and *feel* like.

3. **Specification**: Discuss the API and iterate. When there is vast majority
   approval for the API, move on to implement it and submit a PR. Small PRs are
   always better than large.  It is OK to implement only a few functions of a
   new module, and continue work on the others in a later PR. All new
   functionality goes into an "experimental" namespace
   (`version: experimental`). As part of the PR, when submitting a new
   public facing API, please provide the initial draft of the specification
   document as well as the initial reference implementation of this
   specification.  The
   [specification is a document](https://stdlib.fortran-lang.org/page/specs/index.html)
   that describes the API and
   the functionality, so that anyone can use it to create an implementation
   from scratch without looking at `stdlib`. The `stdlib` library then provides
   the reference implementation.

4. **Implementation** in experimental: When opening a PR, request reviews from
   one or more people that are most relevant to it. These are likely to be
   people involved in prior steps of the workflow. Other contributors (not
   explicitly invited) are encouraged to provide reviews and suggestions as
   well. Iterate until all (or most) participants are on the same page.
   A merge is permitted if there are unit tests for a majority of the possible
   calling scenarios (with or without optional arguments, with arguments that
   trigger an error) and if there is vast majority approval of the PR.

5. **Release**: Moving from experimental to release. The experimental
   "namespace" contains new functionality together with its specification. In
   order to move from experimental to release, the specification document must
   be approved by the wide community and the standards committee (informally).
   If that happens, it has now been blessed for broad use and we can move the
   code into the main section of `stdlib`, and the particular specification
   document becomes part of the Fortran Standard Library.


Note: the general term "vast majority" above means at least 80%, but ultimately
it is left to our best judgement to ensure that the community agrees that each
PR and proposal was approved by "vast majority".

You are welcome to propose changes to this workflow by opening an
[issue](https://github.com/fortran-lang/stdlib/issues).


## Build systems

This project supports two build systems,
[fpm](https://github.com/fortran-lang/fpm) and CMake.

### CMake build files

The build files for CMake allow both in-tree, *i.e.* build artifacts share
the same tree as the source files, and out-of-tree builds, *i.e.* build artifacts
exist in a separate directory tree.
Both build types are explicitly supported and tested, the latter strategy
is recommended for local development.

Sources for the main library target are added in ``src/CMakeLists.txt``
relative to the library target, *i.e.* no absolute paths are required.

To add tests, the macro ``ADDTEST`` should be used instead of the CMake function
``add_test``, the macro hides creation of the executable target, linking against the 
main library target and registering the test.
The tests themselves are defined as standalone executables in the subdirectories
in ``test``, a new subdirectory with tests has to be registered in
``test/CMakeLists.txt``.

The source tree should be considered read-only. References to ``PROJECT_SOURCE_DIR``
and ``CMAKE_CURRENT_SOURCE_DIR`` should only be used for accessing source files,
never to write build outputs, use ``PROJECT_BINARY_DIR`` and ``CMAKE_CURRENT_BINARY_DIR``
to write build artifacts instead.
To fully support in-tree builds, build artifacts must never have the same name as
source files to avoid accidentally overwriting them, *e.g.* when preprocessing or
configuring a file.

The ``CMAKE_INSTALL_PREFIX`` should only be written to on install, never in the build
process. To install generated files, create a build output in the build tree and
install it with the ``install`` function.
This project follows the GNU install conventions, this means that the variables
``CMAKE_INSTALL_BINDIR``, ``CMAKE_INSTALL_LIBDIR``, and ``CMAKE_INSTALL_INCLUDEDIR``
must be used instead of ``bin``, ``lib``, and ``include``, respectively.
Library targets should be exported on install to allow correct inclusion of the
project in other CMake projects.
Prefer dashes as in ``project-config`` or ``project-targets`` over camel-case as in
``projectConfig`` or ``projectTarget`` for file names as the former allows easier
construction from the ``PROJECT_NAME`` variable by concatenation.

The project is usable as CMake subproject. Explicit references to
``CMAKE_SOURCE_DIR`` and ``CMAKE_BINARY_DIR`` must be avoided to not
break subproject builds.
An example project is available [here](https://github.com/fortran-lang/stdlib-cmake-example)
to test the CMake subproject integration.

## GitHub collaboration

Contributing can be daunting, we know! Even more for a big project with many contributors, and if you are not expert on the whole github workflow then even more, we have been there at some point.

In order to help lowering the barrier for collaborating on ongoing efforts (e.g. an open PR), we have crafted a simple script that might come in handy. To explain the process we'll use Alice (the person you want to help) and Bob (you):

```text
       ┌────────────────────────────┐
       │    fortran-lang/stdlib     │
       └────────────▲───────────────┘
                    │
                    │  [Pull Request]
                    │
            ┌───────┴────────┐
            │  alice/stdlib  │ ←─────┐
            └──────▲─────────┘       │
                   │                 │
   [PR Branch] ←───┘          ┌──────┴──────┐
   feature-branch             │  bob/stdlib │
   (hosted here)              │    (fork)   │
                              └─────────────┘
                                     ▲
                                     │
                       [Push access to Alice's repo]
```

After having forked from `fortran-lang/stdlib` and cloned your `stdlib` fork on your local machine; on an unix compatible terminal with access to the `git` CLI, being at the root folder: 
```sh
./.github/collab.sh
```
You will be asked to enter the username and branch of the other person:
```bash
Enter the GitHub username of the fork owner (e.g., alice): alice
Enter the PR branch name (e.g., feature-branch): feature-branch
```
This will fetch Alice's repository and switch your view to Alice's feature-branch. Now you can review, build, run, play around, propose your nice improvements.

Once you finish helping out, you can always `git checkout <your_own_branch>` and/or delet Alice's branch from your local view `git branch -d feature-branch`.

Remember, announce your willingness to help 😉

---
title: Style Guide
---

@note
This is a living document.
You are welcome to propose changes to this workflow by opening an
[issue](https://github.com/fortran-lang/stdlib/issues).

[TOC]

{!STYLE_GUIDE.md!}

---
title: logger
---
# Loggers

[TOC]

## Introduction

This module defines a derived type, its methods, a variable, and
constants to be used for the reporting of errors, displaying messages,
and other information. The derived type, `logger_type`, is to be used
to define both global and local logger variables. The `logger_type`
methods serve to configure the loggers and use the logger variables to
report messages to a variable specific list of I/O units termed
`log_units`. The variable, `global_logger`, of type `logger_type`,
is intended to serve as the default global logger. The constants serve
as error flags returned by the optional integer `stat` argument.

The logger variables have the option to:

* change which units receive the log messages;
* report which units receive the log messages;
* select which types of messages are logged;
* precede messages by a blank line;
* precede messages by a time stamp of the form
  `yyyy-mm-dd hh:mm:ss.sss`;
* precede messages with the names of a module and procedure;
* follow a message with the `stat` and `errmsg` of the error report
  that prompted the log message;
* follow a message with the `iostat` and `iomsg` of the I/O error
  report that prompted the log message;
* label a message with one of `'DEBUG: '`, `'INFO: '`, `'WARN: '`,
  `'ERROR: '`, or `'I/O ERROR: '`;
* indent subsequent lines of the messages; and
* format the text to fit within a maximum column width.

While every effort has been made to make the code process and
asynchronous I/O safe, it is always best to have each process write to
its own dedicated logger file.
For thread parallelism (e.g., with OpenMP), it is advised to put the
logger call in a guarding region (e.g., in an OpenMP critical region).

Note: Loggers of type `logger_type` normally report their messages to I/O
units in the internal list termed `log_units`. However if `log_units`
is empty then the messages go to the `output_unit` of the intrinsic
module `iso_fortran_env`.


## The `stdlib_logger` constants

The module defines nine distinct public integer constants for
reporting errors in the `stat` arguments of some of the module's
procedures. The constants, termed error codes, are as follows:

Error Code             | Description
-----------------------|------------
`success`              | no error was detected
`close_failure`        | a `close` statement for an I/O unit failed
`index_invalid_error`  | the `column` was invalid for the given `line`
`non_sequential_error` | the I/O unit did not have `SEQUENTIAL` access
`open_failure`         | an `open` statement failed
`read_only_error`      | an output unit did not have an `access` specifier of `'WRITE'` or `'READWRITE'`
`unformatted_in_error` | the unit did not have a `form` of `'FORMATTED'`
`unopened_in_error`    | the unit was not opened
`write_fault`          | one of the writes to `log_units` failed

The module also defines eight distinct public integer constants for
selecting the messages that are logged. These constants, termed
severity levels, are (sorted following their increasing order of
severity): `all_level`, `debug_level`, `information_level`,
`warning_level`, `error_level`, `io_error_level`, `text_error_level`,
and `none_level`.
All log messages with a level (e.g., `debug_level`) lower than a
specified severity level (e.g., `information_level`) will be ignored.
The levels `error_level` and `io_error_level` have the same severity.
The default severity level is `information_level`.


## The derived type: logger_type

### Status

Experimental

### Description

Serves to define 'logger' variables to be used in reporting
significant events encountered during the execution of a program.

### Syntax

`type(` [[stdlib_logger(module):logger_type(type)]] `) :: variable`

### Private attributes

| Attribute        | Type          | Description                                     | Initial value       |
|------------------|---------------|-------------------------------------------------|---------------------|
| `add_blank_line` | Logical       | Flag to precede output with a blank line        | `.false.`           |
| `indent_lines`   | Logical       | Flag to indent subsequent lines by four columns | `.true.`            |
| `level`          | Integer       | Severity level                                  | `information_level` |
| `log_units`      | Integer array | List of I/O units used for output               | Unallocated         |
| `max_width`      | Integer       | Maximum column width of output                  | 0                   |
| `time_stamp`     | Logical       | Flag to precede output by a time stamp          | `.true.`            |
| `units`          | Integer       | Count of the number of active output units      | 0                   |

## The `stdlib_logger` variable

The module defines one public variable, `global_logger`, of type
`logger_type`. As might be guessed from its name, `global_logger` is
intended to serve as the default logger for use throughout an
application.


### Public `logger_type` methods

The module defines twelve public procedures: one function and eleven
subroutines.  The
methods are:

Method               | Class      | Description
---------------------|------------|------------
[`add_log_file`](./stdlib_logger.html#add_log_file-open-a-file-and-add-its-unit-to-self-log_units)       | Subroutine | Opens a file using `newunit`, and adds the resulting unit to the `log_units` list
[`add_log_unit`](./stdlib_logger.html#add_log_unit-add-a-unit-to-the-array-self-log_units)       | Subroutine | Adds an existing unit to the `log_units` list
[`configuration`](./stdlib_logger.html#configuration-report-a-loggers-configuration)      | Subroutine | Reports the details of the logging configuration
[`configure`](./stdlib_logger.html#configure-configure-the-logging-process)          | Subroutine | Configures the details of the logging process
[`log_debug`](./stdlib_logger.html#log_debug-writes-the-string-message-to-self-log_units)    | Subroutine | Sends a message prepended by `'DEBUG: '`
[`log_error`](./stdlib_logger.html#log_error-writes-the-string-message-to-self-log_units)          | Subroutine | Sends a message prepended by `'ERROR: '` optionally followed by a `stat` or `errmsg`
[`log_information`](./stdlib_logger.html#log_information-writes-the-string-message-to-self-log_units)    | Subroutine | Sends a message prepended by `'INFO: '`
[`log_io_error`](./stdlib_logger.html#log_io_error-write-the-string-message-to-self-log_units)       | Subroutine | Sends a message prepended by `'I/O ERROR: '` optionally followed by an `iostat` or `iomsg`
[`log_message`](./stdlib_logger.html#log_message-write-the-string-message-to-self-log_units)        | Subroutine | Sends a message
[`log_text_error`](./stdlib_logger.html#log_text_error-send-a-message-to-self-log_units-describing-an-error)     | Subroutine | Sends a message describing an error found in a line of text
[`log_units_assigned`](./stdlib_logger.html#log_units_assigned-returns-the-number-of-active-io-units) | Function   | Returns the number of active I/O units in `log_units`
[`log_warning`](./stdlib_logger.html#log_warning-write-the-string-message-to-log_units)        | Subroutine | Sends a message prepended by `'WARN: '`
[`remove_log_unit`](./stdlib_logger.html#remove_log_unit-remove-unit-from-self-log_units)    | Subroutine | Removes the `unit` number from the `log_units` array

## Specification of the `logger_type` methods

### `add_log_file` - open a file and add its unit to `self % log_units`

#### Status

Experimental

#### Description

Opens a formatted, sequential access, output file, `filename` using
`newunit` and adds the resulting unit number to the logger's
`log_units` array.

#### Syntax

`call self % ` [[logger_type(type):add_log_file(bound)]] `( filename [, unit, action, position, status, stat ] )`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(inout)` argument. It shall be the logger to add the file to its `log_units`.

`filename`: shall be a scalar default character expression. It is
an `intent(in)` argument. It shall be the name of the file to be opened.

`unit` (optional): shall be a scalar default integer variable. It is an
`intent(out)` argument. It will be the unit number returned by the
`newunit` specifier of the `open` statement for `filename`.

`action` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It shall be the `action`
  specifier of the `open` statement and must have one of the values
  `'WRITE'` or `'READWRITE'`. It has the default value of `'WRITE'`.

`position` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It shall be the
  `position` specifier of the `open` statement and must have one of
  the values `'ASIS'`, `'REWIND'`, or `'APPEND'`. It has the default
  value of `'REWIND'`.

`status` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It shall be the
  `status` specifier of the `open` statement and must have one of
  the values `'OLD'`, `'NEW'`, `'REPLACE'`, or `'UNKNOWN'`. It has the
  default value of `'REPLACE'`.

`stat` (optional): shall be a scalar default integer variable. It
  is an `intent(out)` argument. If present, on return it will have the
  value `success` if `filename` could be opened, the value
  `read_only_error` if the `action` specifier is `"READ"`, or the value
  `open_failure` if `filename` could not be opened. If absent and `filename`
  could not be opened then processing will stop with an informative message as the stop code.

#### Example

```fortran
{!example/logger/example_global_logger.f90!}
```

### `add_log_unit` - add a unit to the array `self % log_units`

#### Status

Experimental

#### Description

Adds `unit` to the array of `self % log_units`. The `unit` shall
be the unit number for an opened, sequential, formatted file with an
`action` specifier of `'WRITE'` or `'READWRITE'`. Failure of `unit` to meet
those requirements will cause `stat`, if present, to not be
`success` and `unit` will not be added to `log_units`. In this case, if `stat` is
not present, cause processing to stop with an informative string as
the stop code.

#### Syntax

`call self % ` [[logger_type(type):add_log_unit(bound)]] `( unit [, stat ] )`

#### Class. 

Subroutine.

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(inout)` argument. It shall be the logger to direct its output
to `unit`.

`unit`: shall be a scalar default integer expression. It is an
  `intent(in)` argument. It shall be the unit number for an opened,
  sequential, formatted file with an action specifier of `'WRITE'` or
  `'READWRITE'`.

`stat` (optional): shall be a scalar default integer variable. It is
  an `intent(out)` argument. If absent  and `unit` could not be added
  to self's `log_units` processing will stop with an informative
  message as the stop code. If present it shall have the value of one
  of the module's error codes indicating any errors found with
  `unit`. The codes are
  * `success` - no problem found
  * `non_sequential_error` - `unit` did not have an `access` specifier of
    `'SEQUENTIAL'`
  * `read_only_error` - `unit` had an `action` specifier of `'READ'`
    when it needs a specifier of `'WRITE'` or `'READWRITE'`
  * `unformatted_in_error` - `unit` did not have a `form` specifier of
    `'FORMATTED'`
  * `unopened_in_error` - `unit` was not opened

#### Example

```fortran
{!example/logger/example_add_log_unit.f90!}
```

### `configuration` - report a logger's configuration

#### Status

Experimental

#### Description

Reports the configuration of a logger.

#### Syntax

`call self % ` [[logger_type(type):configuration(bound)]] `( [ add_blankline, indent, level, max_width, time_stamp, log_units ] )`

#### Class

Pure subroutine

#### Arguments

`self`: shall be a scalar expression of type `logger_type`. It is an
`intent(in)` argument. It shall be the logger whose configuration is reported.

`add_blank_line` (optional): shall be a scalar default logical
  variable. It is an `intent(out)` argument. A value of `.true.`
  starts output with a blank line, and `.false.` otherwise.

`indent` (optional): shall be a scalar default logical variable. It
  is an `intent(out)` argument. A value of `.true.` indents subsequent
  lines by four spaces, and `.false.` otherwise.

`level` (optional): shall be a scalar default integer variable. It is an
  `intent(out)` argument. The value corresponds to the severity level for
  ignoring a message.

`max_width` (optional): shall be a scalar default integer
  variable. It is an `intent(out)` argument. A positive value bigger
  than four defines the maximum width of the output, otherwise there
  is no maximum width.

`time_stamp` (optional): shall be a scalar default logical
  variable. It is an `intent(out)` argument. A value of `.true.`
  precedes output with a time stamp of the form 'yyyy-mm-dd
  hh:mm:ss.sss', and `.false.` otherwise.

`log_units` (optional): shall be a rank one allocatable array
  variable of type default integer. It is an `intent(out)`
  argument. On return it shall be the elements of the `self`'s `log_units`
  array. If there were no elements in `self`'s `log_units`, a
  zero-sized array is returned.

#### Example

```fortran
module example_mod
    use stdlib_logger
   
    type(logger_type) :: logger
    contains
  
    subroutine example_sub(unit, ...)
        integer, intent(in) :: unit
  
        integer, allocatable :: log_units(:)
  
        call logger % configuration( log_units=log_units )
        if ( size(log_units) == 0 ) then
           call add_logger_unit( unit )
        end if
  
    end subroutine example_sub
  
end module example_mod
```

### `configure` - configure the logging process

#### Status

Experimental

#### Description

Configures the logging process for self.

#### Syntax

`call self % ` [[logger_type(type):configure(bound)]] `( [ add_blank_line, indent, level, max_width, time_stamp ] )`

#### Class

Pure subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(inout)` argument. It shall be the logger to be configured.

`add_blank_line` (optional): shall be a scalar default logical
  expression. It is an `intent(in)` argument. Set to `.true.` to start
  output with a blank line, and to `.false.` otherwise.
  
`indent` (optional): shall be a scalar default logical
  expression. It is an `intent(in)` argument. Set to `.true.` to
  indent subsequent lines by four spaces, and to `.false.` to
  not indent.

`level` (optional): shall be a scalar default integer expression. It is
  an `intent(in)` argument. Set the severity level for ignoring a log
  message.

`max_width` (optional): shall be a scalar default integer
  expression. It is an `intent(in)` argument. Set to a positive value
  bigger than four to define the maximum width of the output,
  otherwise there is no maximum width.
  
`time_stamp` (optional): shall be a scalar default logical
  expression. It is an `intent(in)` argument. Set to `.true.` to
  precede output with a time stamp of the form 'yyyy-mm-dd
  hh:mm:ss.sss', and to `.false.` otherwise.
  
#### Example

```fortran
{!example/logger/example_configure.f90!}
```

### `log_debug` - Writes the string `message` to `self % log_units`

#### Status

Experimental

#### Description

Writes the string `message` to `self % log_units` with optional additional text.

#### Syntax

`call self % ` [[logger_type(type):log_debug(bound)]] `( message [, module, procedure ] )`

#### Behavior

If time stamps are active, a time stamp is written, followed
by `module` and `procedure` if present, and then
`message` is written with the prefix `'DEBUG: '`.

It is ignored if the `level` of `self` is higher than `debug_level`.

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`message`: shall be a scalar default character expression. It is an
  `intent(in)` argument.

* Note `message` may have embedded new_line calls. 

`module` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the module containing the `log_information` call.

`procedure` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the procedure containing the `log_information` call.

#### Example

```fortran
module  example_mod
    use stdlib_logger
    
    real, allocatable :: a(:)
    
    type(logger_type) :: logger
    contains
    
    subroutine example_sub( selection )
        integer, intent(out) :: selection
        character(128) :: errmsg, message
        integer        :: stat
        write(*,'(a)') "Enter an integer to select a widget"
        read(*,'(i0)') selection
        write( message, '(a, i0)' )                     &
              "The user selected ", selection
        call logger % log_DEBUG( message,               &
            module = 'EXAMPLE_MOD', procedure = 'EXAMPLE_SUB' )
        
    end subroutine example_sub
    
end module example_mod
```

### `log_error` - Writes the string `message` to `self % log_units`

#### Status

Experimental

#### Description

Writes the string `message` to `self % log_units` with optional additional text.

#### Syntax

`call self % ` [[logger_type(type):log_error(bound)]] `( message [, module, procedure, stat, errmsg ] )`

#### Behavior

If time stamps are active for `self`, a time stamp is written,
followed by `module` and `procedure` if present, then
`message` is written with the prefix `'ERROR: '`, and then
if `stat` or `errmsg` are present they are written.

It is ignored if the `level` of `self` is higher than `error_level`.

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`message`: shall be a scalar default character expression. It is an
`intent(in)` argument.

* Note `message` may have embedded new_line calls. 

`module` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the module containing the `log_error` call.

`procedure` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the procedure containing the `log_error` call.

`stat` (optional): shall be a scalar default integer expression. It
  is an `intent(in)` argument. It should be the `stat` specifier of
  the subroutine call or intrinsic statement that prompted the
  `log_error` call.

`errmsg` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the
  `errmsg` specifier of the subroutine call or intrinsic statement
  that prompted the `log_error` call.

#### Example

```fortran
module  example_mod
    use stdlib_logger
    
    real, allocatable :: a(:)
    
    type(logger_type) :: logger
    
    contains
    
    subroutine example_sub( size)
        integer, intent(in) :: size
        character(128) :: errmsg, message
        integer        :: stat
        allocate( a(size), stat=stat, errmsg=errmsg )
        if ( stat /= 0 ) then
            write( message, '(a, i0)' )                    &
                "Allocation of A failed with SIZE = ", size
            call logger % log_error( message,                   &
                                   module = 'EXAMPLE_MOD',    &
                                   procedure = 'EXAMPLE_SUB', &
                                   stat = stat,               &
                                   errmsg = errmsg )
          end if
    end subroutine example_sub

end module example_mod
```

### `log_information` - Writes the string `message` to `self % log_units`

#### Status

Experimental

#### Description

Writes the string `message` to `self % log_units` with optional additional text.

#### Syntax

`call self % ` [[logger_type(type):log_information(bound)]] `( message [, module, procedure ] )`

#### Behavior

If time stamps are active, a time stamp is written, followed
by `module` and `procedure` if present, and then
`message` is written with the prefix `'INFO: '`.

It is ignored if the `level` of `self` is higher than `information_level`.

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`message`: shall be a scalar default character expression. It is an
  `intent(in)` argument.

* Note `message` may have embedded new_line calls. 

`module` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the module containing the `log_information` call.

`procedure` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the procedure containing the `log_information` call.

#### Example

```fortran
module  example_mod
    use stdlib_logger
    
    real, allocatable :: a(:)
    
    type(logger_type) :: logger
    contains
    
    subroutine example_sub( selection )
        integer, intent(out) :: selection
        character(128) :: errmsg, message
        integer        :: stat
        write(*,'(a)') "Enter an integer to select a widget"
        read(*,'(i0)') selection
        write( message, '(a, i0)' )                    &
              "The user selected ", selection
        call logger % log_information( message,               &
            module = 'EXAMPLE_MOD', procedure = 'EXAMPLE_SUB' )
        
    end subroutine example_sub
    
end module example_mod
```

### `log_io_error` - Write the string `message` to `self % log_units`

#### Status

Experimental

#### Description

Writes the string `message` to `self % log_units` with
optional additional text.

#### Behavior

If time stamps are active, a time stamp is written
first. Then if `module` or `procedure` are present, they are
written. Then `message` is written with the prefix
`'I/O ERROR: '`. Then if `iostat` or `iomsg` are present they are
written.

It is ignored if the `level` of `self` is higher than `io_error_level`.

#### Syntax

`call self % ` [[logger_type(type):log_io_error(bound)]] `( message [, module, procedure, iostat, iomsg ] )`

#### Class

Subroutine

#### Arguments
`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`message`: shall be a scalar default character expression. It is an
  `intent(in)` argument.

* Note `message` may have embedded new_line calls. 

`module` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the module containing the `log_io_error` call.

`procedure` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the procedure containing the `log_io_error` call.

`iostat` (optional): shall be a scalar default integer
  expression. It is an `intent(in)` argument. It should be the
  `iostat` specifier of the subroutine call or intrinsic statement
  that prompted the `log_io_error` call.

`iomsg` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the
  `iomsg` specifier of the subroutine call or intrinsic statement
  that prompted the `log_io_error` call.

#### Example

```fortran
{!example/logger/example_log_io_error.f90!}
```

### `log_message` - write the string `message` to `self % log_units` 

#### Status

Experimental

#### Description

Writes the string `message` to `self % log_units` with
  optional additional text.

#### Behavior

If time stamps are active, a time stamp is written,
then `module` and `procedure` are written if present,
followed by `prefix \\ ': '`, if present, and finally `message`.

No severity level is applied to `log_message`.

#### Syntax

`call self % ` [[logger_type(type):log_message(bound)]] `( message [, module, procedure, prefix ] )`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`message`: shall be a scalar default character expression. It is an
  `intent(in)` argument.

* Note `message` may have embedded new_line calls. 

`module` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the module containing the `log_message` call.

`procedure` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the procedure containing the `log_message` call.
  
`prefix` (optional): shall be a scalar default character expression.
It is an `intent(in)` argument. It will precede `message` with an
`': '` appended.

#### Example

```fortran
module  example_mod
    use stdlib_logger
    
    real, allocatable :: a(:)
    
    type(logger_type) :: logger
    contains
    
    subroutine example_sub( selection )
        integer, intent(out) :: selection
        integer        :: stat
        write(*,'(a)') "Enter an integer to select a widget"
        read(*,'(i0)') selection
        write( message, '(a, i0)' )          &
              "The user selected ", selection
        call logger % log_message( message,                   &
                                   module = 'EXAMPLE_MOD',    &
                                   procedure = 'EXAMPLE_SUB', &
                                   prefix = `INFO' )
    end subroutine example_sub
    
end module example_mod
```

### `log_text_error` - send a message to `self % log_units` describing an error

#### Status

Experimental

#### Description

`log_text_error` sends a message to `self % log_units`
describing an error found in a line of text.

#### Behavior

If time stamps are active first a time stamp is
written. Then if `filename` or `line_number` are present they are
written with `column`. Then `line` is written. Then a caret, '^', is
written below `line` at the column indicated by `column`. Then
`summary` is written below the caret.

It is ignored if the `level` of `self` is higher than `text_error_level`.

#### Syntax

`call self % ` [[logger_type(type):log_text_error(bound)]] `( line, column, summary [, filename, line_number, caret, stat ] )`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`line`: shall be a scalar default character expression. It is an
  `intent(in)` argument. It should be the line of text in which the
  error was found.

`column`: shall be a scalar default integer expression. It is an
  `intent(in)` argument. It should be the one's based column at which
  the error begins.

`summary`: shall be a scalar default character expression. It is an
  `intent(in)` argument. It should be a description of the error in
  `line`.

`filename` (optional): shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the file, if any, in which `line` was found.

`line_number` (optional): shall be a scalar default integer
  expression. It is an `intent(in)` argument. It should be the line
  number in `filename` associated with `line`.

`caret` (optional): shall be a scalar default single character
  expression. It is an `intent(in)` argument. If present it will be
  placed below `line` on output to indicate the starting location of
  the error. It has a default value of '^'.

`stat` (optional): shall be a scalar default integer variable. It
  is an `intent(out)` argument. If present it will have the value of
  `success` if no errors were encountered, the value
  `index_invalid_error` if `column` is less than one or greater than
  `len(line)+1`, or the value `write_fault` if the writes to any of
  `log_units` failed. If `stat` is absent and would not have the value
  `success` then processing will stop with an informative stop code.

#### Example

```fortran
{!example/logger/example_log_text_error.f90!}
```

### `log_units_assigned` - returns the number of active I/O units

#### Status

Experimental

#### Description

Returns the number of active I/O units in `self % log_units`

#### Syntax

`result = self % ` [[logger_type(type):log_units_assigned(bound)]] `()`

#### Class

Elemental function

#### Argument

`self`: shall be a scalar expression of type `logger_type`. It is an
`intent(in)` argument. It is the logger whose state is queried.

#### Result character

The result shall be a scalar of type default integer.

#### Result value
The result is the number of I/O units in
  `self % log_units`.

#### Example

```fortran
module  example_mod
    use stdlib_logger
    
    type(logger_type) :: logger
    contains
    
    subroutine example_sub(unit, ...)
        integer, intent(in) :: unit
        
        integer, allocatable :: log_units(:)
        
        if ( logger % log_units_assigned() == 0 ) then
            call logger % add_log_unit( unit )
        end if
        
    end subroutine example_sub
    
end module example_mod
```

### `log_warning` - write the string `message` to `log_units`

#### Status

Experimental

#### Description

Writes the string `message` to `log_units` with
  optional additional text.

#### Behavior

If time stamps are active, a time stamp is written,
then `module` and `procedure` if present, then
`message` is written with the prefix `WARN: '`.

#### Syntax

`call self % ` [[logger_type(type):log_warning(bound)]] `( message [, module, procedure ] )`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(in)` argument. It is the logger used to send the message.

`message`: shall be a scalar default character expression. It is an
  `intent(in)` argument.

* Note `message` may have embedded new_line calls. 

`module`: (optional) shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the module containing the `log_warning` call.

`procedure`: (optional) shall be a scalar default character
  expression. It is an `intent(in)` argument. It should be the name of
  the procedure containing the `log_warning` call.

#### Example

```fortran
module  example_mod
    use stdlib_logger
    
    real, allocatable :: a(:)
    type(logger_type) :: logger
    
    contains
    
    subroutine example_sub( size, stat )
        integer, intent(in)  :: size
        integer, intent(out) :: stat
        allocate( a(size) )
        if ( stat /= 0 ) then
            write( message, '(a, i0)' )                    &
              "Allocation of A failed with SIZE = ", size
            call logger % log_warning( message,                 &
                                     module = 'EXAMPLE_MOD',  &
                                     procedure = 'EXAMPLE_SUB' )
          end if
     end subroutine example_sub
     
end module example_mod
```

### `remove_log_unit` - remove `unit` from `self % log_units`

#### Status

Experimental

#### Description

Remove `unit` from the `self % log_units` list. If
`close_unit` is present and `.true.` then the corresponding file is
closed. If `unit` is not in `self % log_units` then nothing is done.

#### Syntax

`call self % ` [[logger_type(type):remove_log_unit(bound)]] `( unit [, close_unit, stat ] )`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of type `logger_type`. It is an
`intent(inout)` argument. It is the logger whose `log_units` is to be
modified.

`unit`: shall be a scalar default integer expression. It is an
  `intent(in)` argument. It should be one of the I/O `unit` numbers
  in `self % log_units`. If it is not, then nothing is done.

`close_unit` (optional): shall be a scalar default logical
  expression. It is an `intent(in)` argument. If `.true` and `unit` is
  in `self % log_units` then `unit` will be closed, otherwise the I/O unit
  will be unaffected.

`stat` (optional): shall be a scalar default integer variable. It is
  an `intent(out)` argument. If present it has the default value of
  `success`, but has the value `close_failure` if `close_unit` is
  present with the value `.true.`, and `unit` is initially in
  `log_units`, and closing `unit` fails. If `stat` is absent and
  closing the `unit` fails then processing stops with an informative
  stop code.

#### Example

```fortran
module  example_mod
    use stdlib_logger, global => global_logger
    
    contains
    
    subroutine example_sub(unit, ...)
        integer, intent(in) :: unit
    
        call global % remove_log_unit( unit )
    
    end subroutine example_sub
    
end module example_mod
```

---
title: io
---

# IO

[TOC]

## `loadtxt` - load a 2D array from a text file

### Status

Experimental

### Description
Loads a rank-2 `array` from a text file.

### Syntax

`call ` [[stdlib_io(module):loadtxt(interface)]] `(filename, array [, skiprows] [, max_rows] [, fmt] [, delimiter])`

### Arguments

`filename`: Shall be  a character expression containing the file name from which to load the rank-2 `array`.

`array`: Shall be an allocatable rank-2 array of type `real`, `complex` or `integer`.

`skiprows` (optional): Skip the first `skiprows` lines. If skipping more rows than present, a 0-sized array will be returned. The default is 0.

`max_rows` (optional): Read `max_rows` lines of content after `skiprows` lines. A negative value results in reading all lines. A value of zero results in no lines to be read. The default value is -1.

`fmt` (optional): Fortran format specifier for the text read.  Defaults to the write format for the data type.  Setting fmt='*' will specify list directed read.   

`delimiter` (optional): Shall be a character expression of length 1 that contains the delimiter used to separate the columns. The default is `' '`.

### Return value

Returns an allocated rank-2 `array` with the content of `filename`.

### Example

```fortran
{!example/io/example_loadtxt.f90!}
```


## `open` - open a file

### Status

Experimental

### Description

Returns the unit number of a file opened to read, to write, or to read and write. The file might be a text file or a binary file.
Text files are opened using a sequential access, while binary files are opened using a streamed access.

### Syntax

`u = ` [[stdlib_io(module):open(function)]] `(filename [, mode] [, iostat])`

### Arguments

`filename`: Shall be a character expression containing the name of the file to open.

`mode` (optional): Shall be a character expression containing characters describing the way in which the file will be used. The available modes are:


| Character | Meaning |
| --------- | ------- |
| `'r'` | open for reading (default) |
| `'w'` | open for writing, truncating the file first |
| `'x'` | open for exclusive creation, failing if the file already exists |
| `'a'` | open for writing, appending to the end of the file if it exists |
| `'+'` | open for updating (reading and writing) |
| `'b'` | binary mode |
| `'t'` | text mode (default) |


The default `mode` is `'rt'` (i.e. open for reading a text file). The `mode` may include one of the four different methods for opening a file (i.e., `'r'`, `'w'`, `'x'`, and `'a'`). These four methods can be associated with the character `'+'` to open the file for updating. In addition, it can be specified if the file should be handled as a binary file (`'b'`) or a text file (`'t'`).

`iostat` (optional): Shall be a scalar of type `integer` that receives the error status of `open`, if provided. If no error exists, `iostat` is zero.

`u`: Shall be a scalar of type `integer` that specifies the unit number associated with the file `filename`.


### Return value

The result is a scalar of type `integer`.

### Example

```fortran
{!example/io/example_open.f90!}
```


## `savetxt` - save a 2D array into a text file

### Status

Experimental

### Description
Saves a rank-2 `array` into a text file.

### Syntax

`call ` [[stdlib_io(module):savetxt(interface)]] `(filename, array [, delimiter])`

### Arguments

`filename`: Shall be  a character expression containing the name of the file that will contain the 2D `array`.

`array`: Shall be a rank-2 array of type `real`, `complex` or `integer`.

`delimiter` (optional): Shall be a character expression of length 1 that contains the delimiter used to separate the columns. The default is `' '`.

### Output

Provides a text file called `filename` that contains the rank-2 `array`.

### Example

```fortran
{!example/io/example_savetxt.f90!}
```


## `load_npy`

### Status

Experimental

### Description

Loads an `array` from a npy formatted binary file.

### Syntax

`call ` [[stdlib_io_npy(module):load_npy(interface)]] `(filename, array[, iostat][, iomsg])`

### Arguments

`filename`: Shall be  a character expression containing the file name from which to load the `array`.
            This argument is `intent(in)`.

`array`: Shall be an allocatable array of any rank of type `real`, `complex` or `integer`.
         This argument is `intent(out)`.

`iostat`: Default integer, contains status of loading to file, zero in case of success.
          It is an optional argument, in case not present the program will halt for non-zero status.
          This argument is `intent(out)`.

`iomsg`: Deferred length character value, contains error message in case `iostat` is non-zero.
         It is an optional argument, error message will be dropped if not present.
         This argument is `intent(out)`.

### Return value

Returns an allocated `array` with the content of `filename` in case of success.

### Example

```fortran
{!example/io/example_loadnpy.f90!}
```


## `save_npy`

### Status

Experimental

### Description

Saves an `array` into a npy formatted binary file.

### Syntax

`call ` [[stdlib_io_npy(module):save_npy(interface)]] `(filename, array[, iostat][, iomsg])`

### Arguments

`filename`: Shall be  a character expression containing the name of the file that will contain the `array`.
            This argument is `intent(in)`.

`array`: Shall be an array of any rank of type `real`, `complex` or `integer`.
         This argument is `intent(in)`.

`iostat`: Default integer, contains status of saving to file, zero in case of success.
          It is an optional argument, in case not present the program will halt for non-zero status.
          This argument is `intent(out)`.

`iomsg`: Deferred length character value, contains error message in case `iostat` is non-zero.
         It is an optional argument, error message will be dropped if not present.
         This argument is `intent(out)`.

### Output

Provides a npy file called `filename` that contains the rank-2 `array`.

### Example

```fortran
{!example/io/example_savenpy.f90!}
```

## `get_line`

### Status

Experimental

### Description

Read a whole line from a formatted unit into a string variable

### Syntax

`call ` [[stdlib_io(module):get_line(interface)]] ` (unit, line[, iostat][, iomsg])`

`call ` [[stdlib_io(module):get_line(interface)]] ` (line[, iostat][, iomsg])`

### Arguments

`unit`: Formatted input unit.
        This argument is `intent(in)`.
        If `unit` is not specified standard input is used.

`line`: Deferred length character or `string_type` variable.
        This argument is `intent(out)`.

`iostat`: Default integer, contains status of reading from unit, zero in case of success.
          It is an optional argument, in case not present the program will halt for non-zero status.
          This argument is `intent(out)`.

`iomsg`: Deferred length character value, contains error message in case `iostat` is non-zero.
         It is an optional argument, error message will be dropped if not present.
         This argument is `intent(out)`.

### Example

```fortran
{!example/io/example_get_line.f90!}
```

## Formatting constants

### Status

Experimental

### Description

Formatting constants for printing out integer, floating point, and complex numbers at their full precision.
Provides formats for all kinds as defined in the `stdlib_kinds` module.

### Example

```fortran
{!example/io/example_fmt_constants.f90!}
```

## `get_file` - Read a whole ASCII file into a `character` or a `string` variable

### Status

Experimental

### Description

This subroutine interface reads the entirety of a specified ASCII file and returns its content as a string or an allocatable `character` variable. 
The function provides an optional error-handling mechanism via the `state_type` class. If the `err` argument is not provided, exceptions will trigger an `error stop`. The function also supports an optional flag to delete the file after reading.

### Syntax

`call [[stdlib_io(module):get_file(subroutine)]] (filename, file [, err] [, delete=.false.])`

### Class
Function

### Arguments

`filename`: Shall be a character input containing the path to the ASCII file to read. It is an `intent(in)` argument.

`file`: Shall be a `type(string_type)` or an allocatable `character` variable containing the full content of the specified file. It is an `intent(out)` argument.
 
`err` (optional): Shall be a `type(state_type)` variable. It is an `intent(out)` argument used for error handling.

`delete` (optional): Shall be a `logical` flag. If `.true.`, the file is deleted after reading. Default is `.false.`. It is an `intent(in)` argument.

### Return values

Output variable `file` will contain the full content of the specified file.

Raises `STDLIB_IO_ERROR` if the file is not found, cannot be opened, read, or deleted. 
Exceptions trigger an `error stop` unless the optional `err` argument is provided.

### Example

```fortran
{!example/io/example_get_file.f90!}
```

---
title: str2num
---

# The `stdlib_str2num` module

This module proposes a function-style interface for string-to-number conversion. It also profits from Fortran's interfaces to implement precision-dependant algorithms to maximize runtime efficiency.

[TOC]

## `to_num` - conversion of strings to numbers

### Status

Experimental

### Description

Convert a string or an array of strings to numerical types.

### Syntax

`number = ` [[stdlib_str2num(module):to_num(interface)]] `(string, mold)`

### Arguments

`string`: argument has `intent(in)` and is of type `character(*)`.

`mold`: argument has `intent(in)` and is of numerical type (that is of `integer` or of `real`). **Note**: The type of the `mold` argument defines the type of the result.

### Return value

Return a scalar of numerical type (i.e., `integer`, or `real`).

### Example

```fortran
{!example/strings/example_string_to_number.f90!}
```

## `to_num_from_stream` - conversion of a stream of values in a string to numbers

### Status

Experimental

### Description

Convert a stream of values in a string to an array of values.

### Syntax

`number = ` [[stdlib_str2num(module):to_num_from_stream(interface)]] `(string, mold)`

### Arguments

`string`: argument has `intent(in)` and is of type `character(:), pointer`.

`mold`: argument has `intent(in)` and is of numerical type (currently of `integer` or `real`). **Note**: The type of the `mold` argument defines the type of the result.

### Return value

Return a scalar of numerical type (i.e., `integer` or `real`).

### Example

```fortran
{!example/strings/example_stream_of_strings_to_numbers.f90!}
```

## Note
The accuracy of the conversion is implementation dependent; it is recommended that implementers guarantee precision down to the last 3 bits.

**The current implementation has been tested to provide for** :

`sp`  : exact match

`dp`  : precision up-to epsilon(0.0_dp)

`qp` : precision around 200*epsilon(0.0_qp)

Where precision refers to the relative difference between `to_num` and `read`. On the other hand, `to_num` provides speed-ups ranging from 4x to >10x compared to the intrinsic `read`.

---
title: specialfunctions_activations
---

# Special functions - Neural Networks activations and their gradients

[TOC]

## `Gaussian` - Gaussian function

### Status

Experimental

### Description

Computes the gaussian function:
$$f(x)=\exp(-x^2)$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):gaussian(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_gaussian.f90!}
```

## `Gaussian_grad` - Gradient of the Gaussian function

### Status

Experimental

### Description

Computes the gradient of the gaussian function:
$$f(x)=-2 * x * \exp( - x ^ 2)$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):gaussian_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

## `Elu` - Exponential Linear Unit function

### Status

Experimental

### Description

Computes the gaussian function:
$$
\text{f}(x) =
\begin{cases} 
x, & \text{if } x \geq 0 \\
a * (\exp(x) - 1), & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):elu(interface)]] ` (x,a)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 
`a`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_elu.f90!}
```

## `Elu_grad` - Gradient of the Exponential Linear Unit function

### Status

Experimental

### Description

Computes the gradient of the gaussian function:
$$
\text{f}(x) =
\begin{cases} 
1, & \text{if } x \geq 0 \\
a * \exp(x), & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):elu_grad(interface)]] ` (x,a)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.
`a`: Shall be a scalar or array of any `real` kind.  

### Return value

The function returns a value with the same type and kind as input argument.

## `Relu` - Rectified Linear Unit function

### Status

Experimental

### Description

Computes the Rectified Linear Unit function:
$$f(x) = \text{max}(0,x)$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):relu(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_relu.f90!}
```

## `Relu_grad` - Gradient of the Rectified Linear Unit function

### Status

Experimental

### Description

Computes the gradient of the gaussian function:
$$
f(x) =
\begin{cases} 
1, & \text{if } x \geq 0 \\
0, & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):relu_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `leaky_relu` - leaky Rectified Linear Unit function

### Status

Experimental

### Description

Computes the gaussian function:
$$
\text{f}(x) =
\begin{cases} 
x, & \text{if } x \geq 0 \\
a * x, & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):leaky_relu(interface)]] ` (x,a)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 
`a`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_leaky_relu.f90!}
```

## `leaky_relu_grad` - Gradient of the leaky Rectified Linear Unit function

### Status

Experimental

### Description

Computes the gradient of the leaky_relu function:
$$
\text{f}(x) =
\begin{cases} 
1, & \text{if } x \geq 0 \\
a , & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):leaky_relu_grad(interface)]] ` (x,a)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.
`a`: Shall be a scalar or array of any `real` kind.  

### Return value

The function returns a value with the same type and kind as the input argument.

## `Gelu` - Gaussian Error Linear Unit function

### Status

Experimental

### Description

Computes the Gaussian Error Linear Unit function:
$$f(x) = \frac{1}{2} x ( 1 + \text{erf}(\frac{x}{\sqrt{2}}) ) $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):gelu(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_gelu.f90!}
```

## `Gelu_grad` - Gradient of the Gaussian Error Linear Unit function

### Status

Experimental

### Description

Computes the gradient of the gaussian error linear unit function:
$$
f(x) = \frac{1}{2} ( 1 + \text{erf}(x \sqrt{2}) ) + x \sqrt{2} \exp( -\frac{1}{2} x^2)
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):gelu_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `Gelu_approx` - Approximation of the Gaussian Error Linear Unit function

### Status

Experimental

### Description

Computes a fast approximation of the Gaussian Error Linear Unit function using a fast $\text{erf}$ approximation:
$$f(x) = \frac{1}{2} x ( 1 + \text{ferf}(\frac{x}{\sqrt{2}}) ) $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):gelu_approx(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

## `Gelu_approx_grad` - Gradient of the Approximated Gaussian Error Linear Unit function

### Status

Experimental

### Description

Computes the gradient of the gaussian error linear unit function using a fast $\text{erf}$ approximation:
$$
f(x) = \frac{1}{2} ( 1 + \text{ferf}(x \sqrt{2}) ) + x \sqrt{2} \exp( -\frac{1}{2} x^2)
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):gelu_approx_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `Selu` - Scaled Exponential Linear Unit function

### Status

Experimental

### Description

Applies the Scaled Exponential Linear Unit activation function:
$$
f(x) =
\begin{cases} 
scale * x, & \text{if } x \ge 0 \\
scale * (\alpha * exp(x) - \alpha ), & \text{otherwise}
\end{cases}
$$
Where,
$$scale = 1.0507009873554804934193349852946$$ and $$\alpha = 1.6732632423543772848170429916717$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):selu(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_selu.f90!}
```

## `selu_grad` - Gradient of the Scaled Exponential Linear Unit function

### Status

Experimental

### Description

Applies the gradient of the Scaled Exponential Linear Unit activation function:
$$
f(x) =
\begin{cases} 
scale, & \text{if } x \ge 0 \\
scale * \alpha * exp(x) , & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):selu_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `Sigmoid` - Sigmoid function

### Status

Experimental

### Description

Computes the sigmoid function:
$$f(x) = \frac{1}{1+\exp(-x)} $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):sigmoid(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

## `Sigmoid_grad` - Gradient of the Sigmoid function

### Status

Experimental

### Description

Computes the gradient of the Sigmoid function:
$$f(x) = \frac{\exp(x)}{(1+\exp(x))^2} $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):sigmoid_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `SiLU` - Sigmoid Linear Unit function

### Status

Experimental

### Description

Computes the Sigmoid Linear Unit function:
$$f(x) = \frac{x}{1+\exp(-x)} $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):silu(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_silu.f90!}
```

## `Silu_grad` - Gradient of the Sigmoid Linear Unit function

### Status

Experimental

### Description

Computes the gradient of the Sigmoid function:
$$f(x) = \frac{\exp(x)*(x+(1+\exp(x))^2)}{(1+\exp(x))^2} $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):silu_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `Step` - Step function

### Status

Experimental

### Description

Computes the step function:
$$
f(x) =
\begin{cases} 
1, & \text{if } x > 0 \\
0, & \text{otherwise}
\end{cases}
$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):step(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_step.f90!}
```

## `step_grad` - Gradient of the Step function

### Status

Experimental

### Description

Computes the gradient of the Sigmoid function:
$$f(x) = 0 $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):step_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `softmax` - softmax function

### Status

Experimental

### Description

Computes the softmax function:
$$f(x) = \frac{\exp(x)-\text{max}(x_j)}{\sum_j{\exp(x)-\text{max}(x_j)}}$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):softmax(interface)]] ` (x,dim)`

### Class

Pure function for ranks 1 to 4.

### Arguments

`x`: Shall be an array of rank 1 to 4 of any `real` kind. 
`dim`: integer scalar indicating upon which dimension to apply the normalization.

### Return value

The function returns an array with the same rank and kind as the input argument `x`.

### Example
```fortran
{!example/specialfunctions_activations/example_softmax.f90!}
```

## `softmax_grad` - Gradient of the softmax function

### Status

Experimental

### Description

Computes the gradient of the softmax function:
$$f(x,dim) = \text{softmax}(x,dim)*(1-\text{softmax}(x,dim)) $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):softmax_grad(interface)]] ` (x,dim)`

### Class

Pure function for ranks 1 to 4.

### Arguments

`x`: Shall be an array of rank 1 to 4 of any `real` kind. 
`dim`: integer scalar indicating upon which dimension to apply the normalization.

### Return value

The function returns a value with the same type and kind as input argument.

## `softplus` - softplus function

### Status

Experimental

### Description

Computes the softplus function:
$$f(x) = \log(\exp(x)+1)$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):softplus(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_activations/example_softplus.f90!}
```

## `softplus_grad` - Gradient of the softplus function

### Status

Experimental

### Description

Computes the gradient of the softplus function:
$$f(x) = \frac{\exp(x)}{\exp(x)+1} $$

### Syntax

`result = ` [[stdlib_specialfunctions(module):softplus_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind.

### Return value

The function returns a value with the same type and kind as input argument.

## `Fast tanh` - Approximation of the hyperbolic tangent function

### Status

Experimental

### Description

Computes an approximated but faster solution to:
$$f(x)=\tanh(x)$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):fast_tanh(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

## `fast_tanh_grad` - Gradient of the approximation of the hyperbolic tangent function

### Status

Experimental

### Description

Computes the gradient of the `fast_tanh` function:
$$f(x)=1 - \fast_tanh(x)^2$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):fast_tanh_grad(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

## `Fast erf` - Approximation of the error function

### Status

Experimental

### Description

Computes an approximated but faster solution to:
$$f(x)=\erf(x)$$

### Syntax

`result = ` [[stdlib_specialfunctions(module):fast_erf(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a scalar or array of any `real` kind. 

### Return value

The function returns a value with the same type and kind as input argument.

---
title: sorting
---

# The `stdlib_sorting` module

[TOC]

## Overview of sorting

The sorting of collections of data is useful in the analysis of those
collections.
With its absence of generics and limited polymorphism, it is
impractical, in current Fortran, to provide sorting routines for
arbitrary collections of arbitrary types of data.
However Fortran's arrays are by far its most widely used collection,
and arrays of arbitrary types of data can often be sorted in terms of
a single component of intrinsic type.
The Fortran Standard Library therefore provides a module,
`stdlib_sorting`, with procedures to sort arrays of simple intrinsic
numeric types, i.e. the different kinds of integers and reals, the
default assumed length character, and the `stdlib_string_type`
module's `string_type` type.

## Overview of the module

The module `stdlib_sorting` defines several public entities, two
default integer parameters, `int_index` and `int_index_low`, and four overloaded
subroutines: `ORD_SORT`, `SORT`, `RADIX_SORT` and `SORT_INDEX`. The
overloaded subroutines also each have several specific names for
versions corresponding to different types of array arguments.

### The parameters `int_index` and `int_index_low`

The parameters `int_index` and `int_index_low` are used to specify the kind of integer used
in indexing the various arrays. Currently the module sets `int_index` and
`int_index_low`
to the value of `int64` and `int32` from the `stdlib_kinds` module, respectively.

### The module subroutines

The `stdlib_sorting` module provides three different overloaded
subroutines intended to sort three different kinds of arrays of
data:

* `ORD_SORT` is intended to sort simple arrays of intrinsic data
  that have significant sections that were partially ordered before
  the sort;
* `SORT_ADJOINT` is based on `ORD_SORT`, but in addition to sorting the
  input array, it re-orders a second array of the same size
  according to the same permutations;
* `SORT_INDEX` is based on `ORD_SORT`, but in addition to sorting the
  input array, it returns indices that map the original array to its
  sorted version. This enables related arrays to be re-ordered in the
  same way;
* `SORT` is intended to sort simple arrays of intrinsic data
  that are effectively unordered before the sort;
* `RADIX_SORT` is intended to sort fixed width intrinsic data 
  types (integers and reals).

#### Licensing

The Fortran Standard Library is distributed under the MIT
License. However components of the library may be based on code with
additional licensing restrictions. In particular `ORD_SORT`,
`SORT_ADJOINT`, `SORT_INDEX`, and `SORT` are translations of codes with their
own distribution restrictions.

The `ORD_SORT`, `SORT_ADJOINT` and `SORT_INDEX` subroutines are essentially
translations to Fortran 2008 of the `"Rust" sort` of the Rust Language
distributed as part of
[`slice.rs`](https://github.com/rust-lang/rust/blob/90eb44a5897c39e3dff9c7e48e3973671dcd9496/src/liballoc/slice.rs).
The header of the `slice.rs` file has as its licensing requirements:

    Copyright 2012-2015 The Rust Project Developers. See the COPYRIGHT
    file at the top-level directory of this distribution and at
    http://rust-lang.org/COPYRIGHT.

    Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
    http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
    <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
    option. This file may not be copied, modified, or distributed
    except according to those terms.

So the license for the `slice.rs` code is compatible with the use of
modified versions of the code in the Fortran Standard Library under
the MIT license.

The `SORT` subroutine is essentially a translation to Fortran
2008 of the
[`introsort`]((http://www.cs.rpi.edu/~musser/gp/introsort.ps) of David
Musser.  David Musser has given permission to include a variant of
`introsort` in the Fortran Standard Library under the MIT license
provided we cite:

    Musser, D.R., “Introspective Sorting and Selection Algorithms,”
    Software—Practice and Experience, Vol. 27(8), 983–993 (August 1997).

as the official source of the algorithm.


#### The `ORD_SORT` subroutine

`ORD_SORT` is a translation of the `"Rust" sort` sorting algorithm
contained in [`slice.rs`]
(https://github.com/rust-lang/rust/blob/90eb44a5897c39e3dff9c7e48e3973671dcd9496/src/liballoc/slice.rs).
`"Rust" sort`, in turn, is inspired by the [`timsort` algorithm]
(http://svn.python.org/projects/python/trunk/Objects/listsort.txt)
that Tim Peters created for the Python Language.
`ORD_SORT` is a hybrid stable comparison algorithm combining `merge sort`,
and `insertion sort`. It has always at worst O(N Ln(N)) runtime
performance in sorting random data, having a performance about 15-25%
slower than `SORT` on such data. However it has much better
performance than `SORT` on partially sorted data, having O(N)
performance on uniformly increasing or decreasing data.


When sorting in an increasing order, `ORD_SORT` begins by traversing the array
starting in its tail attempting to identify `runs` in the array, where a run is
either a uniformly decreasing sequence, `ARRAY(i-1) > ARRAY(i)`, or a
non-decreasing, `ARRAY(i-1) <= ARRAY(i)`, sequence. First delimited decreasing
sequences are reversed in their order. Then, if the sequence has less than
`MIN_RUN` elements, previous elements in the array are added to the run using
`insertion sort` until the run contains `MIN_RUN` elements or the array is
completely processed. As each run is identified the start and length of the run
are then pushed onto a stack and the stack is then processed using `merge` until
it obeys the stack invariants:

1. len(i-2) > len(i-1) + len(i)
2. len(i-1) > len(i)

ensuring that processing the stack is, at worst, of order `O(N
Ln(N))`. However, because of the identification of decreasing and
non-decreasing runs, processing of structured data can be much faster,
with processing of uniformly decreasing or non-decreasing arrays being
of order O(N). The result in our tests is that `ORD_SORT` is about
25% slower than `SORT` on purely random data, depending on
the compiler, but can be `Ln(N)` faster than `SORT` on highly
structured data. As a modified `merge sort`, `ORD_SORT` requires the
use of a "scratch" array, that may be provided as an optional `work`
argument or allocated internally on the stack.

Arrays can be also sorted in a decreasing order by providing the argument `reverse
= .true.`.

#### The `SORT_ADJOINT` subroutine

The `SORT` and `ORD_SORT` subroutines can sort rank 1 isolated
arrays of intrinsic types, but do nothing for the coordinated sorting
of related data, e.g., a related rank 1 array. Therefore the module
provides a subroutine, `SORT_ADJOINT`, that re-order such a rank 1 array
according to the same permutations as for the input array based on the `ORD_SORT` algorithm,
in addition to sorting the input array.

The logic of `SORT_ADJOINT` parallels that of `ORD_SORT`, with
additional housekeeping to keep the associated array consistent with
the sorted positions of the input array. Because of this additional
housekeeping it has slower runtime performance than `ORD_SORT`.
`SORT_ADJOINT` requires the use of two "scratch" arrays, that may be
provided as optional `work` and `iwork` arguments or allocated
internally on the stack.

#### The `SORT_INDEX` subroutine

The `SORT` and `ORD_SORT` subroutines can sort rank 1 isolated
arrays of intrinsic types, but do nothing for the coordinated sorting
of related data, e.g., multiple related rank 1 arrays, higher rank
arrays, or arrays of derived types. For such related data, what is
useful is an array of indices that maps a rank 1 array to its sorted
form. For such a sort, a stable sort is useful, therefore the module
provides a subroutine, `SORT_INDEX`, that generates such an array of
indices based on the `ORD_SORT` algorithm, in addition to sorting
the input array.

The logic of `SORT_INDEX` parallels that of `ORD_SORT`, with
additional housekeeping to keep the array of indices consistent with
the sorted positions of the input array. Because of this additional
housekeeping it has slower runtime performance than `ORD_SORT`.
`SORT_INDEX` requires the use of two "scratch" arrays, that may be
provided as optional `work` and `iwork` arguments or allocated
internally on the stack.

#### The `SORT` subroutine

`SORT` uses the `introsort` sorting algorithm of David Musser.
`introsort` is a hybrid unstable comparison algorithm combining
`quicksort`, `insertion sort`, and `heap sort`. While this algorithm's
runtime performance is always O(N Ln(N)), it is relatively fast on
randomly ordered data, but does not show the improvement in
performance on partly sorted data found for `ORD_SORT`.

First it examines the array and estimates the depth of recursion a
quick sort would require for ideal (random) data, `D =
Ceiling(Ln(N)/Ln(2))`. It then defines a limit to the number of
`quicksort` recursions to be allowed in processing,
`D_limit = factor * D`, where factor is currently 2, and
calls `introsort` proper. `introsort` proper then:

1. Examines the number of elements remaining to be sorted, and, if
   they are less than 16, sorts them using insertion sort and returns;
2. If they are not less than 16, checks whether the current depth of
   recursion exceeds `D_limit` and, if it does, processes the remaining
   elements with heap sort and returns;
3. If the current depth of recursion does not exceed `D_limit`, then
   in effect does a `quicksort` step:

    * Partitions the remaining array using a median of three,
    * Calls `introsort` proper on the leftmost partition,
    * Calls `introsort` proper on the rightmost partition, and then
      returns.

The resulting algorithm is of order O(N Ln(N)) run time performance
for all inputs. Because it relies on `quicksort`, the coefficient of
the O(N Ln(N)) behavior is typically small compared to other sorting
algorithms on random data. On partially sorted data it can show either
slower `heap sort` performance, or enhanced performance by up to a
factor of six. Still, even when it shows enhanced performance, its
performance on partially sorted data is typically an order of
magnitude slower than `ORD_SORT`. Its memory requirements are also
low, being of order O(Ln(N)), while the memory requirements of
`ORD_SORT`, `SORT_ADJOINT` and `SORT_INDEX` are of order O(N).

#### The `RADIX_SORT` subroutine

`RADIX_SORT` is a implementation of LSD [radix sort](https://www.growingwiththeweb.com/sorting/radix-sort-lsd/),
using `256` as the radix. It only works for fixed width data,
thus integers and reals. `RADIX_SORT` is always of O(N) runtime performance
for any input data. For large and random data, it is about five (or more)
times faster than other sort subroutines.

The `RADIX_SORT` needs a buffer that have same size of the input data.
Your can provide it using `work` argument, if not the subroutine will
allocate the buffer and deallocate before return.

### Specifications of the `stdlib_sorting` procedures

#### `ord_sort` - sorts an input array

##### Status

Experimental

##### Description

Returns an input `array` with the elements sorted in order of
increasing, or decreasing, value.

##### Syntax

`call ` [[stdlib_sorting(module):ord_sort(interface)]] `( array[, work, reverse ] )`

##### Class

Generic subroutine.

##### Arguments

`array` : shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`, `real(qp)`, `character(*)`, `type(string_type)`,
`type(bitset_64)`, or `type(bitset_large)`.
It is an `intent(inout)` argument. On input it is
the array to be sorted. If both the type of `array` is real and at
least one of the elements is a `NaN`, then the ordering of the result
is undefined. Otherwise on return its elements will be sorted in order
of non-decreasing value.

`work` (optional): shall be a rank one array of the same type as
array, and shall have at least `size(array)/2` elements. It is an
`intent(out)` argument. It is intended to be used as "scratch"
memory for internal record keeping. If associated with an array in
static storage, its use can significantly reduce the stack memory
requirements for the code. Its contents on return are undefined.

`reverse` (optional): shall be a scalar of type default logical. It
is an `intent(in)` argument. If present with a value of `.true.` then
`array` will be sorted in order of non-increasing values in stable
order. Otherwise index will sort `array` in order of non-decreasing
values in stable order.

##### Notes

`ORD_SORT` implements a hybrid sorting algorithm combining
`merge sort`, and `insertion sort`. For most purposes it behaves like
a `merge sort`, providing worst case `O(N Ln(N))` run time performance
for most random arrays, that is typically slower than `SORT`.
However, if the array has significant runs of decreasing or
non-decreasing values, performance can be much better than
`SORT`, with `O(N)` behavior on uniformly decreasing, or
non-decreasing arrays. The optional `work` array replaces "scratch"
memory that would otherwise be allocated on the stack. If `array` is of
any type `REAL` the order of its elements on return undefined if any
element of `array` is a `NaN`.  Sorting of `CHARACTER(*)` and
`STRING_TYPE` arrays are based on the operators `>` and `<`, and not on the
function `LGT`.


##### Example

```fortran
{!example/sorting/example_ord_sort.f90!}
```

#### `sort` - sorts an input array

##### Status

Experimental

##### Description

Returns an input array with the elements sorted in order of increasing, or
decreasing, value.

##### Syntax

`call ` [[stdlib_sorting(module):sort(interface)]] `( array[, reverse] )`

##### Class

Pure generic subroutine.

##### Arguments

`array` : shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`, `real(qp)`. `character(*)`, `type(string_type)`,
`type(bitset_64)`, or `type(bitset_large)`.
It is an `intent(inout)` argument. On return its
input elements will be sorted in order of non-decreasing value.


`reverse` (optional): shall be a scalar of type default logical. It
is an `intent(in)` argument. If present with a value of `.true.` then
`array` will be sorted in order of non-increasing values in unstable
order. Otherwise index will sort `array` in order of non-decreasing
values in unstable order.

##### Notes

`SORT` implements a hybrid sorting algorithm combining
`quicksort`, `merge sort`, and `insertion sort`. For most purposes it
behaves like a `quicksort` with a median of three partition, providing
good, `O(N Ln(N))`, run time performance for most random arrays, but
defaulting to `merge sort` if the structure of the array results in
the `quicksort` not converging as rapidly as expected. If `array` is of
any type `REAL`, the behavior of the sorting is undefined if any
element of `array` is a `NaN`.  Sorting of `CHARACTER(*)` and
`STRING_TYPE` arrays are based on the operators `<`, `<=`, `>`, and
`>=`, and not on the functions `LLT`, `LLE`, `LGT`, or `LGE`.

##### Example


```fortran
{!example/sorting/example_sort.f90!}
```

#### `radix_sort` - sorts an input array

##### Status

Experimental

##### Description

Returns an input array with the elements sorted in order of increasing, or
decreasing, value.

##### Syntax

`call ` [[stdlib_sorting(module):radix_sort(interface)]] `( array[, work, reverse] )`

##### Class

Generic subroutine.

##### Arguments

`array` : shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`. It is an `intent(inout)` argument. On return its
input elements will be sorted in order of non-decreasing value.

`work` (optional): shall be a rank one array of the same type as
array, and shall have at least `size(array)` elements. It is an
`intent(inout)` argument, and its contents on return are undefined.

`reverse` (optional): shall be a scalar of type default `logical`. It
is an `intent(in)` argument. If present with a value of `.true.` then
`array` will be sorted in order of non-increasing values in unstable
order. Otherwise index will sort `array` in order of non-decreasing
values in unstable order.

##### Notes

`radix_sort` implements a LSD radix sort algorithm with a `256` radix. For any
input data it provides `O(N)` run time performance. If `array` is of
any type `real` the order of its elements on return undefined if any
element of `array` is a `NaN`.

##### Example

```fortran
{!example/sorting/example_radix_sort.f90!}
```

#### `sort_adjoint` - sorts an associated array 
according to the same permutations as for the input array.

##### Status

Experimental

##### Description

Returns the input `array` sorted in the direction requested while
retaining order stability, and an associated array whose elements are
sorted according to the same permutations as for the input `array`.

##### Syntax

`call ` [[stdlib_sorting(module):sort_adjoint(interface)]] `( array, adjoint_array[, work, iwork, reverse ] )`

##### Class

Generic subroutine.

##### Arguments

`array`: shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`, `real(qp)`, `character(*)`, `type(string_type)`,
`type(bitset_64)`, or `type(bitset_large)`.
It is an `intent(inout)` argument. On input it
will be an array whose sorting indices are to be determined. On return
it will be the sorted array.

`adjoint_array`: shall be a rank one `integer` or `real` array of
the size of `array`. It is an `intent(inout)` argument. On return it
shall have values that are the indices needed to sort the original
array in the desired direction.

`work` (optional): shall be a rank one array of any of the same type as
`array`, and shall have at least `size(array)/2` elements. It is an
`intent(out)` argument. It is intended to be used as "scratch"
memory for internal record keeping. If associated with an array in
static storage, its use can significantly reduce the stack memory
requirements for the code. Its contents on return are undefined.

`iwork` (optional): shall be a rank one integer array of the same kind
of the array `adjoint_array`, and shall have at least `size(array)/2` elements. It
is an `intent(out)` argument.  It is intended to be used as "scratch"
memory for internal record keeping. If associated with an array in
static storage, its use can significantly reduce the stack memory
requirements for the code. Its contents on return are undefined.

`reverse` (optional): shall be a scalar of type default logical. It
is an `intent(in)` argument. If present with a value of `.true.` then
`array` will be sorted in order of non-increasing values in stable
order. Otherwise `array` will be sorted in order of non-decreasing
values in stable order.

##### Notes

`SORT_ADJOINT` implements the hybrid sorting algorithm of `ORD_SORT`,
keeping the values of `adjoint_array` consistent with the elements of `array`
as it is sorted. As a `merge sort` based algorithm, it is a stable
sorting comparison algorithm. The optional `work` and `iwork` arrays
replace "scratch" memory that would otherwise be allocated on the
stack. If `array` is of any kind of `REAL` the order of the elements in
`adjoint_array` and `array` on return are undefined if any element of `array`
is a `NaN`. Sorting of `CHARACTER(*)` and `STRING_TYPE` arrays are
based on the operator `>`, and not on the function `LGT`.

It should be emphasized that the order of `array` will typically be
different on return

##### Examples

Sorting a rank one array with `sort_adjoint`:

```Fortran
{!example/sorting/example_sort_adjoint.f90!}
```

#### `sort_index` - creates an array of sorting indices for an input array, while also sorting the array.

##### Status

Experimental

##### Description

Returns the input `array` sorted in the direction requested while
retaining order stability, and an integer array whose elements would
sort the input `array` to produce the output `array`.

##### Syntax

`call ` [[stdlib_sorting(module):sort_index(interface)]] `( array, index[, work, iwork, reverse ] )`

##### Class

Generic subroutine.

##### Arguments

`array`: shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`, `real(qp)`, `character(*)`, `type(string_type)`,
`type(bitset_64)`, or `type(bitset_large)`.
It is an `intent(inout)` argument. On input it
will be an array whose sorting indices are to be determined. On return
it will be the sorted array.

`index`: shall be a rank one integer array of kind `int_index` or `int_index_low` and of
the size of `array`. It is an `intent(out)` argument. On return it
shall have values that are the indices needed to sort the original
array in the desired direction.

`work` (optional): shall be a rank one array of any of the same type as
`array`, and shall have at least `size(array)/2` elements. It is an
`intent(out)` argument. It is intended to be used as "scratch"
memory for internal record keeping. If associated with an array in
static storage, its use can significantly reduce the stack memory
requirements for the code. Its contents on return are undefined.

`iwork` (optional): shall be a rank one integer array of the same kind
of the array `index`, and shall have at least `size(array)/2` elements. It
is an `intent(out)` argument.  It is intended to be used as "scratch"
memory for internal record keeping. If associated with an array in
static storage, its use can significantly reduce the stack memory
requirements for the code. Its contents on return are undefined.

`reverse` (optional): shall be a scalar of type default logical. It
is an `intent(in)` argument. If present with a value of `.true.` then
`index` will sort `array` in order of non-increasing values in stable
order. Otherwise index will sort `array` in order of non-decreasing
values in stable order.

##### Notes

`SORT_INDEX` implements the hybrid sorting algorithm of `ORD_SORT`,
keeping the values of `index` consistent with the elements of `array`
as it is sorted. As a `merge sort` based algorithm, it is a stable
sorting comparison algorithm. The optional `work` and `iwork` arrays
replace "scratch" memory that would otherwise be allocated on the
stack. If `array` is of any kind of `REAL` the order of the elements in
`index` and `array` on return are undefined if any element of `array`
is a `NaN`. Sorting of `CHARACTER(*)` and `STRING_TYPE` arrays are
based on the operator `>`, and not on the function `LGT`.

It should be emphasized that the order of `array` will typically be
different on return


##### Examples

Sorting a rank one array with `sort_index`:

```Fortran
{!example/sorting/example_sort_index.f90!}
```

Sorting a related rank one array:

```Fortran
    subroutine sort_related_data( a, b, work, index, iwork )
        ! Sort `a`, and  also  sort `b` to be reorderd the same way as `a`
        integer, intent(inout)         :: a(:)
        integer(int32), intent(inout)  :: b(:) ! The same size as a
        integer(int32), intent(out)    :: work(:)
        integer(int_index), intent(out) :: index(:)
        integer(int_index), intent(out) :: iwork(:)
        ! Find the indices to sort a
        call sort_index(a, index(1:size(a)),&
            work(1:size(a)/2), iwork(1:size(a)/2))
        ! Sort b based on the sorting of a
        b(:) = b( index(1:size(a)) )
    end subroutine sort_related_data
```

Sorting a rank 2 array based on the data in a column

```Fortran
    subroutine sort_related_data( array, column, work, index, iwork )
        ! Reorder rows of `array` such that `array(:, column)` is  sorted
        integer, intent(inout)         :: array(:,:)
        integer(int32), intent(in)     :: column
        integer(int32), intent(out)    :: work(:)
        integer(int_index), intent(out) :: index(:)
        integer(int_index), intent(out) :: iwork(:)
        integer, allocatable           :: dummy(:)
        integer :: i
        allocate(dummy(size(array, dim=1)))
        ! Extract a column of `array`
        dummy(:) = array(:, column)
        ! Find the indices to sort the column
        call sort_index(dummy, index(1:size(dummy)),&
            work(1:size(dummy)/2), iwork(1:size(dummy)/2))
        ! Sort a based on the sorting of its column
        do i=1, size(array, dim=2)
            array(:, i) = array(index(1:size(array, dim=1)), i)
        end do
    end subroutine sort_related_data
```

Sorting an array of a derived type based on the data in one component

```fortran
    subroutine sort_a_data( a_data, a, work, index, iwork )
        ! Sort `a_data` in terms of its component `a`
        type(a_type), intent(inout)      :: a_data(:)
        integer(int32), intent(inout)    :: a(:)
        integer(int32), intent(out)    :: work(:)
        integer(int_index), intent(out) :: index(:)
        integer(int_index), intent(out) :: iwork(:)
        ! Extract a component of `a_data`
        a(1:size(a_data)) = a_data(:) % a
        ! Find the indices to sort the component
        call sort_index(a(1:size(a_data)), index(1:size(a_data)),&
            work(1:size(a_data)/2), iwork(1:size(a_data)/2))
        ! Sort a_data based on the sorting of that component
        a_data(:) = a_data( index(1:size(a_data)) )
    end subroutine sort_a_data
```


### Performance benchmarks

We have performed benchmarks of the procedures on nine different
integer arrays each of size `2**16`:

* Blocks - the array is divided into six blocks, each of distinct
  uniformly increasing integers.
* Decreasing - values decrease uniformly from `2**16-1` to `0`.
* Identical - all integers have the same value of 10.
* Increasing - values increase uniformly from `0` to `2**16-1`.
* Random dense - the integers are generated randomly from a set of
  values from `0` to `2**14-1` so duplicates are dense.
* Random order - a set of integers from `0` to `2**16 - 1` in random
  order.
* Random sparse - the integers are generated randomly from a set of
  values from `0` to `2**18-1` so duplicates are sparse.
* Random-3 - the increasing array has 3 random exchanges of individual
  elements.
* Random-10 - the final ten elements of the increasing array are
  replaced by random values.

On three different default character arrays, each of length 4 and of
size `20**4, with characters drawn from the set "a"-"p":

* Char. Decreasing - values decrease uniformly from `"pppp"` to
  `"aaaa"`.
* Char. Increasing - values decrease uniformly from `"aaaa"` to
  `"pppp"`.
* Char. Random - the set of strings from `"aaaa"` to `"pppp"` in
  random order.

On three different `string_type` arrays, each of length 4 elements and
of size `16**3`, with characters drawn from the set "a"-"p":

* String Decreasing - values decrease uniformly from `"ppp"` to
  `"aaa"`.
* String Increasing - values decrease uniformly from `"aaa"` to
  `"ppp"`.
* String Random - the set of strings from `"aaa"` to `"ppp"` in
  random order.

These benchmarks have been performed on two different compilers, both
on WSL with Ubuntu-20.04, Intel(R) Core(TM) i7-10700 CPU @ 2.9GHz, with
32 GB DDR4 memory. The first compiler is GNU Fortran (GCC) 9.4.0, with
the following results.

|    Type     | Elements |    Array Name   |    Method   |  Time (s) |
|-------------|----------|-----------------|-------------|-----------|
|     Integer |   65536  |          Blocks |    Ord_Sort |  0.001048 |
|     Integer |   65536  |      Decreasing |    Ord_Sort |  0.000204 |
|     Integer |   65536  |       Identical |    Ord_Sort |  0.000097 |
|     Integer |   65536  |      Increasing |    Ord_Sort |  0.000096 |
|     Integer |   65536  |    Random dense |    Ord_Sort |  0.006580 |
|     Integer |   65536  |    Random order |    Ord_Sort |  0.006886 |
|     Integer |   65536  |   Random sparse |    Ord_Sort |  0.006821 |
|     Integer |   65536  |        Random 3 |    Ord_Sort |  0.000461 |
|     Integer |   65536  |       Random 10 |    Ord_Sort |  0.000226 |
|   Character |   65536  |  Char. Decrease |    Ord_Sort |  0.000824 |
|   Character |   65536  |  Char. Increase |    Ord_Sort |  0.000370 |
|   Character |   65536  |    Char. Random |    Ord_Sort |  0.016020 |
| String_type |    4096  | String Decrease |    Ord_Sort |  0.000465 |
| String_type |    4096  | String Increase |    Ord_Sort |  0.000169 |
| String_type |    4096  |   String Random |    Ord_Sort |  0.004194 |
|     Integer |   65536  |          Blocks |  Radix_Sort |  0.001610 |
|     Integer |   65536  |      Decreasing |  Radix_Sort |  0.001076 |
|     Integer |   65536  |       Identical |  Radix_Sort |  0.001074 |
|     Integer |   65536  |      Increasing |  Radix_Sort |  0.001060 |
|     Integer |   65536  |    Random dense |  Radix_Sort |  0.001161 |
|     Integer |   65536  |    Random order |  Radix_Sort |  0.001069 |
|     Integer |   65536  |   Random sparse |  Radix_Sort |  0.001005 |
|     Integer |   65536  |        Random 3 |  Radix_Sort |  0.001057 |
|     Integer |   65536  |       Random 10 |  Radix_Sort |  0.001046 |
|     Integer |   65536  |     rand-real32 |  Radix_Sort |  0.001429 |
|     Integer |   65536  |          Blocks |        Sort |  0.004269 |
|     Integer |   65536  |      Decreasing |        Sort |  0.005108 |
|     Integer |   65536  |       Identical |        Sort |  0.006257 |
|     Integer |   65536  |      Increasing |        Sort |  0.002093 |
|     Integer |   65536  |    Random dense |        Sort |  0.006032 |
|     Integer |   65536  |    Random order |        Sort |  0.006030 |
|     Integer |   65536  |   Random sparse |        Sort |  0.006126 |
|     Integer |   65536  |        Random 3 |        Sort |  0.007930 |
|     Integer |   65536  |       Random 10 |        Sort |  0.014729 |
|   Character |   65536  |  Char. Decrease |        Sort |  0.020623 |
|   Character |   65536  |  Char. Increase |        Sort |  0.008028 |
|   Character |   65536  |    Char. Random |        Sort |  0.014258 |
| String_type |    4096  | String Decrease |        Sort |  0.005542 |
| String_type |    4096  | String Increase |        Sort |  0.001987 |
| String_type |    4096  |   String Random |        Sort |  0.003267 |
|     Integer |   65536  |          Blocks |  Sort_Index |  0.000686 |
|     Integer |   65536  |      Decreasing |  Sort_Index |  0.000529 |
|     Integer |   65536  |       Identical |  Sort_Index |  0.000218 |
|     Integer |   65536  |      Increasing |  Sort_Index |  0.000214 |
|     Integer |   65536  |    Random dense |  Sort_Index |  0.008044 |
|     Integer |   65536  |    Random order |  Sort_Index |  0.008042 |
|     Integer |   65536  |   Random sparse |  Sort_Index |  0.008148 |
|     Integer |   65536  |        Random 3 |  Sort_Index |  0.000677 |
|     Integer |   65536  |       Random 10 |  Sort_Index |  0.000387 |
|   Character |   65536  |  Char. Decrease |  Sort_Index |  0.000932 |
|   Character |   65536  |  Char. Increase |  Sort_Index |  0.000487 |
|   Character |   65536  |    Char. Random |  Sort_Index |  0.017231 |
| String_type |    4096  | String Decrease |  Sort_Index |  0.000489 |
| String_type |    4096  | String Increase |  Sort_Index |  0.000183 |
| String_type |    4096  |   String Random |  Sort_Index |  0.004102 |

The second compiler is Intel(R) Fortran Intel(R) 64 Compiler Classic
for applications running on Intel(R) 64, Version 2021.7.0 Build
20220726_000000, with the following results:

|    Type     | Elements |    Array Name   |    Method   |  Time (s) |
|-------------|----------|-----------------|-------------|-----------|
|     Integer |   65536  |          Blocks |    Ord_Sort |  0.000135 |
|     Integer |   65536  |      Decreasing |    Ord_Sort |  0.000053 |
|     Integer |   65536  |       Identical |    Ord_Sort |  0.000033 |
|     Integer |   65536  |      Increasing |    Ord_Sort |  0.000034 |
|     Integer |   65536  |    Random dense |    Ord_Sort |  0.003291 |
|     Integer |   65536  |    Random order |    Ord_Sort |  0.003546 |
|     Integer |   65536  |   Random sparse |    Ord_Sort |  0.003313 |
|     Integer |   65536  |        Random 3 |    Ord_Sort |  0.000145 |
|     Integer |   65536  |       Random 10 |    Ord_Sort |  0.000070 |
|   Character |   65536  |  Char. Decrease |    Ord_Sort |  0.000696 |
|   Character |   65536  |  Char. Increase |    Ord_Sort |  0.000338 |
|   Character |   65536  |    Char. Random |    Ord_Sort |  0.015255 |
| String_type |    4096  | String Decrease |    Ord_Sort |  0.001276 |
| String_type |    4096  | String Increase |    Ord_Sort |  0.000153 |
| String_type |    4096  |   String Random |    Ord_Sort |  0.024705 |
|     Integer |   65536  |          Blocks |  Radix_Sort |  0.001038 |
|     Integer |   65536  |      Decreasing |  Radix_Sort |  0.000910 |
|     Integer |   65536  |       Identical |  Radix_Sort |  0.000441 |
|     Integer |   65536  |      Increasing |  Radix_Sort |  0.000803 |
|     Integer |   65536  |    Random dense |  Radix_Sort |  0.000363 |
|     Integer |   65536  |    Random order |  Radix_Sort |  0.000741 |
|     Integer |   65536  |   Random sparse |  Radix_Sort |  0.000384 |
|     Integer |   65536  |        Random 3 |  Radix_Sort |  0.000877 |
|     Integer |   65536  |       Random 10 |  Radix_Sort |  0.000801 |
|     Integer |   65536  |     rand-real32 |  Radix_Sort |  0.000604 |
|     Integer |   65536  |          Blocks |        Sort |  0.001342 |
|     Integer |   65536  |      Decreasing |        Sort |  0.001391 |
|     Integer |   65536  |       Identical |        Sort |  0.001485 |
|     Integer |   65536  |      Increasing |        Sort |  0.000447 |
|     Integer |   65536  |    Random dense |        Sort |  0.002778 |
|     Integer |   65536  |    Random order |        Sort |  0.002896 |
|     Integer |   65536  |   Random sparse |        Sort |  0.003136 |
|     Integer |   65536  |        Random 3 |        Sort |  0.002996 |
|     Integer |   65536  |       Random 10 |        Sort |  0.005752 |
|   Character |   65536  |  Char. Decrease |        Sort |  0.021973 |
|   Character |   65536  |  Char. Increase |        Sort |  0.008391 |
|   Character |   65536  |    Char. Random |        Sort |  0.015155 |
| String_type |    4096  | String Decrease |        Sort |  0.034014 |
| String_type |    4096  | String Increase |        Sort |  0.010464 |
| String_type |    4096  |   String Random |        Sort |  0.015748 |
|     Integer |   65536  |          Blocks |  Sort_Index |  0.000381 |
|     Integer |   65536  |      Decreasing |  Sort_Index |  0.000085 |
|     Integer |   65536  |       Identical |  Sort_Index |  0.000046 |
|     Integer |   65536  |      Increasing |  Sort_Index |  0.000046 |
|     Integer |   65536  |    Random dense |  Sort_Index |  0.004020 |
|     Integer |   65536  |    Random order |  Sort_Index |  0.004059 |
|     Integer |   65536  |   Random sparse |  Sort_Index |  0.004073 |
|     Integer |   65536  |        Random 3 |  Sort_Index |  0.000215 |
|     Integer |   65536  |       Random 10 |  Sort_Index |  0.000101 |
|   Character |   65536  |  Char. Decrease |  Sort_Index |  0.000680 |
|   Character |   65536  |  Char. Increase |  Sort_Index |  0.000356 |
|   Character |   65536  |    Char. Random |  Sort_Index |  0.016231 |
| String_type |    4096  | String Decrease |  Sort_Index |  0.001219 |
| String_type |    4096  | String Increase |  Sort_Index |  0.000125 |
| String_type |    4096  |   String Random |  Sort_Index |  0.018631 |

---
title: optval
---

# Default values for optional arguments

[TOC]

## `optval` - fallback value for optional arguments

### Status

Experimental

### Description

Returns `x` if it is present, otherwise `default`. 

This function is intended to be called in a procedure with one or more `optional` arguments, in order to conveniently fall back to a default value if an `optional` argument is not present.

### Syntax

`result = ` [[stdlib_optval(module):optval(interface)]] `(x, default)`

### Arguments

`x`: Shall be of type `integer`, `real`, `complex`, or `logical`, or a scalar of type `character`.

`default`: Shall have the same type, kind, and rank as `x`.

### Return value

If `x` is present, the result is `x`, otherwise the result is `default`.

### Example

```fortran
{!example/optval/example_optval.f90!}
```

---
title: intrinsics
---

# The `stdlib_intrinsics` module

[TOC]

## Introduction

The `stdlib_intrinsics` module provides replacements for some of the well known intrinsic functions found in Fortran compilers for which either a faster and/or more accurate implementation is found which has also proven of interest to the Fortran community.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_sum` function

#### Description

The `stdlib_sum` function can replace the intrinsic `sum` for `real`, `complex` or `integer` arrays. It follows a chunked implementation which maximizes vectorization potential as well as reducing the round-off error. This procedure is recommended when summing large (e..g, >2**10 elements) arrays, for repetitive summation of smaller arrays consider the classical `sum`.

#### Syntax

`res = ` [[stdlib_intrinsics(module):stdlib_sum(interface)]] ` (x [,mask] )`

`res = ` [[stdlib_intrinsics(module):stdlib_sum(interface)]] ` (x, dim [,mask] )`

#### Status

Experimental

#### Class

Pure function.

#### Argument(s)

`x`: N-D array of either `real`, `complex` or `integer` type. This argument is `intent(in)`.

`dim` (optional): scalar of type `integer` with a value in the range from 1 to n, where n equals the rank of `x`.

`mask` (optional): N-D array of `logical` values, with the same shape as `x`. This argument is `intent(in)`.

#### Output value or Result value

If `dim` is absent, the output is a scalar of the same `type` and `kind` as to that of `x`. Otherwise, an array of rank n-1, where n equals the rank of `x`, and a shape similar to that of `x` with dimension `dim` dropped is returned.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_sum_kahan` function

#### Description

The `stdlib_sum_kahan` function can replace the intrinsic `sum` for `real` or `complex` arrays. It follows a chunked implementation which maximizes vectorization potential complemented by an `elemental` kernel based on the [kahan summation](https://doi.org/10.1145%2F363707.363723) strategy to reduce the round-off error:

```fortran
elemental subroutine kahan_kernel_<kind>(a,s,c)
    type(<kind>), intent(in) :: a
    type(<kind>), intent(inout) :: s
    type(<kind>), intent(inout) :: c
    type(<kind>) :: t, y
    y = a - c
    t = s + y
    c = (t - s) - y
    s = t
end subroutine
```

#### Syntax

`res = ` [[stdlib_intrinsics(module):stdlib_sum_kahan(interface)]] ` (x [,mask] )`

`res = ` [[stdlib_intrinsics(module):stdlib_sum_kahan(interface)]] ` (x, dim [,mask] )`

#### Status

Experimental

#### Class

Pure function.

#### Argument(s)

`x`: 1D array of either `real` or `complex` type. This argument is `intent(in)`.

`dim` (optional): scalar of type `integer` with a value in the range from 1 to n, where n equals the rank of `x`.

`mask` (optional): N-D array of `logical` values, with the same shape as `x`. This argument is `intent(in)`.

#### Output value or Result value

If `dim` is absent, the output is a scalar of the same type and kind as to that of `x`. Otherwise, an array of rank n-1, where n equals the rank of `x`, and a shape similar to that of `x` with dimension `dim` dropped is returned.

#### Example

```fortran
{!example/intrinsics/example_sum.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_dot_product` function

#### Description

The `stdlib_dot_product` function can replace the intrinsic `dot_product` for 1D `real`, `complex` or `integer` arrays. It follows a chunked implementation which maximizes vectorization potential as well as reducing the round-off error. This procedure is recommended when crunching large arrays, for repetitive products of smaller arrays consider the classical `dot_product`.

#### Syntax

`res = ` [[stdlib_intrinsics(module):stdlib_dot_product(interface)]] ` (x, y)`

#### Status

Experimental

#### Class

Pure function.

#### Argument(s)

`x`: 1D array of either `real`, `complex` or `integer` type. This argument is `intent(in)`.

`y`: 1D array of the same type and kind as `x`. This argument is `intent(in)`.

#### Output value or Result value

The output is a scalar of `type` and `kind` same as to that of `x` and `y`.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_dot_product_kahan` function

#### Description

The `stdlib_dot_product_kahan` function can replace the intrinsic `dot_product` for 1D `real` or `complex` arrays. It follows a chunked implementation which maximizes vectorization potential, complemented by the same `elemental` kernel based on the [kahan summation](https://doi.org/10.1145%2F363707.363723) used for `stdlib_sum` to reduce the round-off error.

#### Syntax

`res = ` [[stdlib_intrinsics(module):stdlib_dot_product_kahan(interface)]] ` (x, y)`

#### Status

Experimental

#### Class

Pure function.

#### Argument(s)

`x`: 1D array of either `real` or `complex` type. This argument is `intent(in)`.

`y`: 1D array of the same type and kind as `x`. This argument is `intent(in)`.

#### Output value or Result value

The output is a scalar of the same type and kind as to that of `x` and `y`.

```fortran
{!example/intrinsics/example_dot_product.f90!}
```

### `stdlib_matmul` function

#### Description

The extension of the intrinsic function `matmul` to handle more than 2 and less than or equal to 5 matrices, with error handling using `linalg_state_type`.
The optimal parenthesization to minimize the number of scalar multiplications is done using the Algorithm as outlined in Cormen, "Introduction to Algorithms", 4ed, ch-14, section-2.
The actual matrix multiplication is performed using the `gemm` interfaces.
It supports only `real` and `complex` matrices.

#### Syntax

`res = ` [[stdlib_intrinsics(module):stdlib_matmul(interface)]] ` (m1, m2, m3, m4, m5, err)`

#### Status

Experimental

#### Class

Function.

#### Argument(s)

`m1`, `m2`: 2D arrays of the same kind and type. `intent(in)` arguments.
`m3`,`m4`,`m5`: 2D arrays of the same kind and type as the other matrices. `intent(in), optional` arguments.
`err`: `type(linalg_state_type), intent(out), optional` argument. Can be used for elegant error handling. It is assigned `LINALG_VALUE_ERROR` 
        in case the matrices are not of compatible sizes.

#### Result

The output is a matrix of the appropriate size.

#### Example

```fortran
{!example/intrinsics/example_matmul.f90!}
```

---
title: version
---

# The `stdlib_version` module

[TOC]

## Introduction

The `stdlib_version` module contains the version of the standard library.
The version information can be used as a compile time constant or retrieved from a getter function at runtime.
In case the standard library is dynamically linked, the version number retrieved from the getter might mismatch the compile time constants provided from the version built against.
Therefore, it is recommended to retrieve the version information always at runtime.


## Constants provided by `stdlib_version`

### `stdlib_version_string`

String constant representing the version number.

### `stdlib_version_compact`

Compact representation of the version string following the scheme:
major * 10000 + minor * 100 + patch.


### `get_stdlib_version`

#### Status

Experimental

#### Description

Getter subroutine to retrieve version information

#### Syntax

`call ` [[stdlib_version(module):get_stdlib_version(subroutine)]] ` ([major], [minor], [patch], [string])`

#### Class

Pure subroutine.

#### Argument

`major`: shall be an intrinsic integer type. It is an optional, `intent(out)` argument.
`minor`: shall be an intrinsic integer type. It is an optional, `intent(out)` argument.
`patch`: shall be an intrinsic integer type. It is an optional, `intent(out)` argument.
`string`: shall be a deferred length character type. It is an optional, `intent(out)` argument.

#### Example

```fortran
{!example/version/example_version.f90!}
``` 

---
title: quadrature
---

# Numerical integration

[TOC]

## `trapz` - integrate sampled values using trapezoidal rule

### Status

Experimental

### Description

Returns the trapezoidal rule integral of an array `y` representing discrete samples of a function. The integral is computed assuming either equidistant abscissas with spacing `dx` or arbitrary abscissas `x`.

### Syntax

`result = ` [[stdlib_quadrature(module):trapz(interface)]] `(y, x)`

`result = ` [[stdlib_quadrature(module):trapz(interface)]] `(y, dx)`

### Arguments

`y`: Shall be a rank-one array of type `real`.

`x`: Shall be a rank-one array of type `real` having the same kind and size as `y`. 

`dx`: Shall be a scalar of type `real` having the same kind as `y`.

### Return value

The result is a scalar of type `real` having the same kind as `y`.

If the size of `y` is zero or one, the result is zero.

### Example

```fortran
{!example/quadrature/example_trapz.f90!}
```

## `trapz_weights` - trapezoidal rule weights for given abscissas

### Status

Experimental

### Description

Given an array of abscissas `x`, computes the array of weights `w` such that if `y` represented function values tabulated at `x`, then `sum(w*y)` produces a trapezoidal rule approximation to the integral.

### Syntax

`result = ` [[stdlib_quadrature(module):trapz_weights(interface)]] `(x)`

### Arguments

`x`: Shall be a rank-one array of type `real`.

### Return value

The result is a `real` array with the same size and kind as `x`.

If the size of `x` is one, then the sole element of the result is zero.

### Example

```fortran
{!example/quadrature/example_trapz_weights.f90!}
```

## `simps` - integrate sampled values using Simpson's rule

### Status

Experimental

### Description

Returns the Simpson's rule integral of an array `y` representing discrete samples of a function. The integral is computed assuming either equidistant abscissas with spacing `dx` or arbitrary abscissas `x`. 

Simpson's ordinary ("1/3") rule is used for odd-length arrays. For even-length arrays, Simpson's 3/8 rule is also utilized in a way that depends on the value of `even`. If `even` is negative (positive), the 3/8 rule is used at the beginning (end) of the array. If `even` is zero or not present, the result is as if the 3/8 rule were first used at the beginning of the array, then at the end of the array, and these two results were averaged.

### Syntax

`result = ` [[stdlib_quadrature(module):simps(interface)]] `(y, x [, even])`

`result = ` [[stdlib_quadrature(module):simps(interface)]] `(y, dx [, even])`

### Arguments

`y`: Shall be a rank-one array of type `real`.

`x`: Shall be a rank-one array of type `real` having the same kind and size as `y`. 

`dx`: Shall be a scalar of type `real` having the same kind as `y`.

`even`: (Optional) Shall be a default-kind `integer`.

### Return value

The result is a scalar of type `real` having the same kind as `y`.

If the size of `y` is zero or one, the result is zero.

If the size of `y` is two, the result is the same as if `trapz` had been called instead.

### Example

```fortran
{!example/quadrature/example_simps.f90!}
```

## `simps_weights` - Simpson's rule weights for given abscissas

### Status

Experimental

### Description

Given an array of abscissas `x`, computes the array of weights `w` such that if `y` represented function values tabulated at `x`, then `sum(w*y)` produces a Simpson's rule approximation to the integral.

Simpson's ordinary ("1/3") rule is used for odd-length arrays. For even-length arrays, Simpson's 3/8 rule is also utilized in a way that depends on the value of `even`. If `even` is negative (positive), the 3/8 rule is used at the beginning (end) of the array and the 1/3 rule used elsewhere. If `even` is zero or not present, the result is as if the 3/8 rule were first used at the beginning of the array, then at the end of the array, and then these two results were averaged.

### Syntax

`result = ` [[stdlib_quadrature(module):simps_weights(interface)]] `(x [, even])`

### Arguments

`x`: Shall be a rank-one array of type `real`.

`even`: (Optional) Shall be a default-kind `integer`.

### Return value

The result is a `real` array with the same size and kind as `x`.

If the size of `x` is one, then the sole element of the result is zero.

If the size of `x` is two, then the result is the same as if `trapz_weights` had been called instead.

### Example

```fortran
{!example/quadrature/example_simps_weights.f90!}
```

## `gauss_legendre` - Gauss-Legendre quadrature (a.k.a. Gaussian quadrature) nodes and weights

### Status

Experimental

### Description

Computes Gauss-Legendre quadrature (also known as simply Gaussian quadrature) nodes and weights,
 for any `N` (number of nodes).
Using the nodes `x` and weights `w`, you can compute the integral of some function `f` as follows:
`integral = sum(f(x) * w)`.

Only double precision is supported - if lower precision is required, you must do the appropriate conversion yourself.
Accuracy has been validated up to N=64 by comparing computed results to tablulated values known to be accurate to machine precision
(maximum difference from those values is 2 epsilon).

### Syntax

`subroutine ` [[stdlib_quadrature(module):gauss_legendre(interface)]] ` (x, w[, interval])`

### Arguments

`x`: Shall be a rank-one array of type `real(real64)`. It is an *output* argument, representing the quadrature nodes.

`w`: Shall be a rank-one array of type `real(real64)`, with the same dimension as `x`. 
It is an *output* argument, representing the quadrature weights.

`interval`: (Optional) Shall be a two-element array of type `real(real64)`. 
If present, the nodes and weigts are calculated for integration from `interval(1)` to `interval(2)`.
If not specified, the default integral is -1 to 1.

### Example

```fortran
{!example/quadrature/example_gauss_legendre.f90!}
```

## `gauss_legendre_lobatto` - Gauss-Legendre-Lobatto quadrature nodes and weights

### Status

Experimental

### Description

Computes Gauss-Legendre-Lobatto quadrature nodes and weights,
 for any `N` (number of nodes).
Using the nodes `x` and weights `w`, you can compute the integral of some function `f` as follows:
`integral = sum(f(x) * w)`.

Only double precision is supported - if lower precision is required, you must do the appropriate conversion yourself.
Accuracy has been validated up to N=64 by comparing computed results to tablulated values known to be accurate to machine precision
(maximum difference from those values is 2 epsilon).

### Syntax

`subroutine ` [[stdlib_quadrature(module):gauss_legendre_lobatto(interface)]] ` (x, w[, interval])`

### Arguments

`x`: Shall be a rank-one array of type `real(real64)`. It is an *output* argument, representing the quadrature nodes.

`w`: Shall be a rank-one array of type `real(real64)`, with the same dimension as `x`. 
It is an *output* argument, representing the quadrature weights.

`interval`: (Optional) Shall be a two-element array of type `real(real64)`. 
If present, the nodes and weigts are calculated for integration from `interval(1)` to `interval(2)`.
If not specified, the default integral is -1 to 1.

### Example

```fortran
{!example/quadrature/example_gauss_legendre_lobatto.f90!}
```

---
title: strings
---

# The `stdlib_strings` module

[TOC]

## Introduction

The `stdlib_strings` module provides basic string handling and manipulation routines.


## Procedures and methods provided


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `strip`

#### Description

Remove leading and trailing whitespace characters.

#### Syntax

`string = ` [[stdlib_strings(module):strip(interface)]] ` (string)`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_strip.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `chomp`

#### Description

Remove trailing characters in *set* or *substring* from *string*.
If no character *set* or *substring* is provided trailing whitespace is removed.

#### Syntax

`string = ` [[stdlib_strings(module):chomp(interface)]] ` (string[, set|substring])`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `set`: Array of length one character. This argument is intent(in).
- `substring`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_chomp.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `starts_with`

#### Description

Check if a *string* starts with a given *substring*.

#### Syntax

`string = ` [[stdlib_strings(module):starts_with(interface)]] ` (string, substring)`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `substring`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).

#### Result value

The result is of scalar logical type.

#### Example

```fortran
{!example/strings/example_starts_with.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `ends_with`

#### Description

Check if a *string* ends with a given *substring*.

#### Syntax

`string = ` [[stdlib_strings(module):ends_with(interface)]] ` (string, substring)`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `substring`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).

#### Result value

The result is of scalar logical type.

#### Example

```fortran
{!example/strings/example_ends_with.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `slice`

#### Description

Extracts the characters from the defined region of the input string by taking strides.  
Argument `first` and `last` defines this region for extraction by function `slice`.  
Argument `stride` defines the magnitude and direction (+/-) of stride to be taken while extraction. 
`stride` when given invalid value 0, is converted to +1.

Deduction Process:  
Function first automatically deduces the optional arguments that are not provided by the user.  
Deduced `first` and `last` argument take +infinity or -infinity value and deduced `stride` argument 
takes value +1 or -1 depending upon the actual argument(s) provided by the user.  

Extraction Process:  
Extraction starts only if `last` is crossable from `first` with stride of `stride`.  
Extraction starts from the first valid index in the defined region to take stride of `stride` 
and ends when the last valid index in the defined region is crossed.  
If no valid index exists in the defined region, empty string is returned.

#### Syntax

`string = ` [[stdlib_strings(module):slice(interface)]] ` (string [, first, last, stride])`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `first`: integer.
  This argument is intent(in) and optional.
- `last`: integer.
  This argument is intent(in) and optional.
- `stride`: integer.
  This argument is intent(in) and optional.

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_slice.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `find`

#### Description

Returns the starting index of the `occurrence`th occurrence of the substring `pattern` 
in the input string `string`.  
Default value of `occurrence` is set to `1`. 
If `consider_overlapping` is not provided or is set to `.true.` the function counts two overlapping occurrences of substring `pattern` as two different occurrences.  
If `occurrence`th occurrence is not found, function returns `0`.

#### Syntax

`string = ` [[stdlib_strings(module):find(interface)]] ` (string, pattern [, occurrence, consider_overlapping])`

#### Status

Experimental

#### Class

Elemental function

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `pattern`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `occurrence`: integer.
  This argument is intent(in) and optional.
- `consider_overlapping`: logical.
  This argument is intent(in) and optional.

#### Result value

The result is a scalar of integer type or an integer array of rank equal to the highest rank among all dummy arguments.

#### Example

```fortran
{!example/strings/example_find.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `replace_all`

#### Description

Replaces all occurrences of substring `pattern` in the input `string` with the replacement `replacement`.  
Occurrences overlapping on a base occurrence will not be replaced.

#### Syntax

`string = ` [[stdlib_strings(module):replace_all(interface)]] ` (string, pattern, replacement)`

#### Status

Experimental

#### Class

Pure function

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `pattern`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `replacement`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_replace_all.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `padl`

#### Description

Returns a string of length `output_length` left padded with `pad_with` character if it is provided, otherwise with `" "` (1 whitespace).  
If `output_length` is less than or equal to the length of `string`, padding is not performed.

#### Syntax

`string = ` [[stdlib_strings(module):padl(interface)]] ` (string, output_length [, pad_with])`

#### Status

Experimental

#### Class

Pure function

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `output_length`: integer.
  This argument is intent(in).
- `pad_with`: Character scalar of length 1.
  This argument is intent(in) and optional.

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_padl.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `padr`

#### Description

Returns a string of length `output_length` right padded with `pad_with` character if it is provided, otherwise with `" "` (1 whitespace).  
If `output_length` is less than or equal to the length of `string`, padding is not performed.

#### Syntax

`string = ` [[stdlib_strings(module):padr(interface)]] ` (string, output_length [, pad_with])`

#### Status

Experimental

#### Class

Pure function

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `output_length`: integer.
  This argument is intent(in).
- `pad_with`: Character scalar of length 1.
  This argument is intent(in) and optional.

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_padr.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `count`

#### Description

Returns the number of times the substring `pattern` has occurred in the input string `string`.  
If `consider_overlapping` is not provided or is set to `.true.` the function counts two overlapping occurrences of substring `pattern` as two different occurrences.

#### Syntax

`string = ` [[stdlib_strings(module):count(interface)]] ` (string, pattern [, consider_overlapping])`

#### Status

Experimental

#### Class

Elemental function

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `pattern`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `consider_overlapping`: logical.
  This argument is intent(in) and optional.

#### Result value

The result is a scalar of integer type or an integer array of rank equal to the highest rank among all dummy arguments.

#### Example

```fortran
{!example/strings/example_count.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `zfill`

#### Description

Returns a string of length `output_length` left-padded with zeros.
If `output_length` is less than or equal to the length of `string`, padding is not performed.

#### Syntax

`string = ` [[stdlib_strings(module):zfill(interface)]] ` (string, output_length)`

#### Status

Experimental

#### Class

Pure function

#### Argument

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is intent(in).
- `output_length`: integer.
  This argument is intent(in).

#### Result value

The result is of the same type as `string`.

#### Example

```fortran
{!example/strings/example_zfill.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `join`

#### Description

Joins an array of strings into a single string. This function concatenates the strings from the input array, 
inserting a separator between each string (default: space). A user-defined separator may be provided, The resulting string is returned.


#### Syntax

`joined = ` [[stdlib_strings(module):join(interface)]] ` (strings, separator)`

#### Status

Experimental

#### Class

Pure function

#### Argument

- `strings`: Array of strings (either `type(string_type)` or `character(len=*)`).
  This argument is `intent(in)`. It is an array of strings that will be concatenated together.
- `separator`: `character(len=*)` scalar (optional).
  This argument is `intent(in)`. It specifies the separator to be used between the strings. If not provided, the default separator (a space) is used.

#### Result value

The result is of the same type as the elements of `strings` (`type(string_type)` or `character(len=:), allocatable`).

#### Example

```fortran
{!example/strings/example_join.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->

### `to_string`

#### Description

Format or transfer a `integer/real/complex/logical` scalar as a string.  
Input a wrong `format` that cause the internal-IO to fail, the result value is a string of `[*]`.

#### Syntax

`string = ` [[stdlib_strings(module):to_string(interface)]] ` (value [, format])`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `value`: Shall be an `integer/real/complex/logical` scalar.
  This is an `intent(in)` argument.
- `format`: Shall be a `character(len=*)` scalar like `'(F6.2)'` or just `'F6.2'`.
  This is an `intent(in)` and `optional` argument.  
  Contains the edit descriptor to format `value` into a string, for example `'(F6.2)'` or `'(f6.2)'`. 
  `to_string` will automatically enclose `format` in a set of parentheses, so passing `F6.2` or `f6.2` as `format` is possible as well.
  
#### Result value

The result is an `allocatable` length `character` scalar with up to `128` cached `character` length.

#### Example

```fortran
{!example/strings/example_to_string.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `to_c_char`

#### Description

Convert a Fortran `character` string or a `type(string_type)` variable to a C character array.  
This function converts a Fortran string into a C-style array of characters, ensuring proper null-termination for use in C functions or libraries.  

#### Syntax

`cstr = ` [[stdlib_strings(module):to_c_char(function)]] ` (value)`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `value`: Shall be a `character(len=*)` string or a `type(string_type)` variable. It is an `intent(in)` argument.  
  This Fortran variable will be converted to a C character array.

#### Result value

The result is a `character(kind=c_char)` array with a dimension of `len(value) + 1` to accommodate the null terminator.

#### Example

```fortran
{!example/strings/example_to_c_char.f90!}
```

---
title: Hash maps
---

# The `stdlib_hashmap_wrappers`, and `stdlib_hashmaps` modules

[TOC]

## Overview of hash maps

A hash map (hash table) is a data structure that maps *keys* to
*values*. It uses a hash function to compute a hash code from the *key*
that serves as an index into a linear array of *slots* (buckets) from
which the desired *value* can be extracted.
Each key ideally maps to a unique slot, but most hash functions are
imperfect and can map multiple keys to the same *slot* resulting in
collisions. Hash maps differ in how they deal with such collisions.
This document discusses the hash maps in the Fortran Standard Library.

## Licensing

The Fortran Standard Library is distributed under the MIT License.
However components of the library should be evaluated as to whether
they are compatible with the MIT License.
The current hash maps were inspired by an
[implementation](http://chasewoerner.org/src/hasht/) of David
Chase. While the code has been greatly modified from his
implementation, he has give permission for the unrestricted use of
his code.

## The hash map modules

The Fortran Standard Library provides two modules for the
implementation of simple hash maps. These maps only accept hash
functions with a single argument, the key, and yield a 32 bit
hash code. The modules will need to be modified if it is desired to
use hash functions with a different API. The two modules are:
`stdlib_hashmap_wrappers`, and `stdlib_hashmaps` corresponding to the
files: `stdlib_hashmap_wrappers.f90`, and `stdlib_hashmaps.f90`

The module `stdlib_hashmap_wrappers` provides types and procedures for
use by `stdlib_hashmaps`. It provides an
interface to the 32 bit hash functions of the Standard Library module,
`stdlib_hash_32bit`, and provides wrappers to some of the
hash functions so that they no longer need to be supplied seeds. It
also defines the `key_type` derived type. The `key_type` is used to
define keys that, in turn, are used to identify the data entered into
a hash map.

The module `stdlib_hashmaps` defines the API for a parent datatype,
`hashmap_type` and two extensions of that hash map type:
`chaining_hashmap_type` and `open_hashmap_type`.

The `hashmap_type` defines the Application Programmers
Interface (API) for the procedures used by its two extensions. It
explicitly defines five non-overridable procedures. It also defines
the interfaces for eleven deferred procedures. It does not define the
finalization routines for the two extension types, or one routine
provided by the `open_hashmap_type`.

The `chaining_hashmap_type` uses separate chaining with linked
lists to deal with hash index collisions. In separate chaining the
colliding indices are handled by using linked lists with their roots
at the hash index. The `chaining_hashmap_type` procedures are
implemented in the module `stdlib_hashmap_chaining` corresponding
to the file, `stdlib_hashmap_chaining.f90`.

The `open_hashmap_type`
uses linear open addressing to deal with hash index collisions. In
linear open addressing the colliding indices are
handled by searching from the initial hash index in increasing
steps of one (modulo the hash map size) for an open map slot.
The `open_hashmap_type` procedures are implemented in the submodule
`stdlib_hashmap_open` corresponding to the file
`stdlib_hashmap_open.f90`.

The maps use powers of two for their slot sizes, so that the function,
`fibonacci_hash`, can 
be used to map the hash codes to indices in the map. This is
expected to be more efficient than prime number mapping using a
modulo operation, and reduces the requirement that the hash
function need to do a good job randomizing its lower order bits.
They do require a good randomizing hash method for good performance.
Both adjust the map size to reduce collisions, based on 
the ratio of the number of hash map probes to the number of subroutine 
calls.
Wile the maps make extensive use of pointers internally, a private
finalization subroutine avoids memory leaks.
The maps can take entry keys of type `key_type`, and other data (also
commonly known as values, as in key value pairs) in any scalar type. 
The maps allow the addition, removal, and lookup of entries, and the
inclusion of data in addition to the entry key.

## The `stdlib_hashmap_wrappers` module

The `stdlib_hashmap_wrappers` module provides data types to
represent keys and associated data stored in a module, but is also, a
wrapper for the `stdlib_hash_32bit` module. It allows
direct access to the `stdlib_hash_32bit` procedures:
`fibonacci_hash`, `fnv_1_hasher`, `fnv_1a_hasher`; and provides
wrapper functions, `seeded_nmhash32_hasher`,
`seeded_nmhash32x_hasher`, and `seeded_water_hasher` to the hash
functions: `nmhash32`, `nmhash32x`, and `water_hash`, respectively. It
defines an interface, `hasher_fun`, compatible with the hash functions
that take a `non-scalar key`. It defines one integer constant used
as a kind value,`int_hash`. It also defines two types, `key_type` and
`other_type`, and associated procedures, for storing and manipulating
keys and their associated data.

### The `stdlib_hashmap_wrappers`'s constant, `int_hash`

The constant `int_hash` is used to define the integer kind value for
the returned hash codes and variables used to access them. It
currently is imported from `stdlib_hash_32bit` where it has the
value, `int32`. 

### The `stdlib_hashmap_wrappers`' module's derived types

The `stdlib_hashmap_wrappers` defines `key_type` which is intended to
be used for the search keys of hash tables. The tye is opaque.
The current representation is as follows

```fortran
    type :: key_type
        private
        integer(int8), allocatable :: value(:)
    end type key_type
```
The module also defines six procedures for those types: `copy_key`,
`equal_keys`, `free_key`, `get`, `set`, and one operator, `==`,
for use by the hash maps to manipulate or inquire of components of
those types.

### Table of `stdlib_hashmap_wrappers` procedures

The  `stdlib_hashmap_wrappers` module provides procedures in
several categories: procedures to manipulate data of the `key_type`;
and 32 bit hash functions for keys. The procedures in each category 
are listed below. It also provides an operator to compare two key 
type values for equality. 

Procedures to manipulate `key_type` data:

* `copy_key( key_in, key_out )` - Copies the contents of the key,
  `key_in`, to contents of the key, `key_out`.

* `get( key, value )` - extracts the contents of `key` into `value`,
  an `int8` array, `int32` array, or character string.

* `free_key( key )` - frees the memory in `key`.

* `set( key, value )` - sets the content of `key` to `value`.  
  Supported key types are `int8` array, `int32` array, and character
  string.

Procedures to hash keys to 32 bit integers:

* `fnv_1_hasher( key )` - hashes a `key` using the FNV-1 algorithm.

* `fnv_1a_hasher( key )` - hashes a `key` using the FNV-1a algorithm.

* `seeded_nmhash32_hasher( key )` - hashes a `key` using the nmhash32
  algorithm.

* `seeded_nmhash32x_hasher( key )` - hashes a `key` using the nmhash32x
  algorithm.

* `seeded_water_hasher( key )` - hashes a `key` using the waterhash
  algorithm.

Operator to compare two `key_type` values for equality

* `key1 == key2` - compares `key1` with `key2` for equality

### Specifications of the `stdlib_hashmap_wrappers` procedures

#### `copy_key` - Returns a copy of the key

##### Status

Experimental

##### Description

Returns a copy of an input of type `key_type`.

##### Syntax

`call ` [[stdlib_hashmap_wrappers:copy_key]] `( old_key, new_key )`

##### Class

Subroutine.

##### Arguments

`old_key`: shall be a scalar expression of type `key_type`. It
is an `intent(in)` argument.

`new_key`: shall be a scalar variable of type `key_type`. It
is an `intent(out)` argument.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_copy_key.f90!}
```


#### `fibonacci_hash` - maps an integer to a smaller number of bits

##### Status

Experimental

##### Description

`fibonacci_hash` is just a re-export of the function of the same name
implemented in
[`stdlib_hash_32bit`](https://stdlib.fortran-lang.org/page/spec/stdlib_hash_functions.html#fibonacci_hash-maps-an-integer-to-a-smaller-number-of-bits).
It reduces the value of a 32 bit integer to a smaller number of bits.


#### `fnv_1_hasher`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32 bit hash code from an input of type `key_type`.

##### Syntax

`code = ` [[stdlib_hashmap_wrappers:fnv_1_hasher]] `( key )`

##### Class

Pure function

##### Argument

`key`: Shall be a scalar expression of type `key_type`.
It is an `intent(in)` argument.

##### Result character

The result is a scalar integer of kind `int32`.

##### Result value

The result is a hash code created using the FNV-1 algorithm.

##### Note

`fnv_1_hasher` is an implementation of the original FNV-1 hash code of
Glenn Fowler, Landon Curt Noll, and Phong Vo.
This code is relatively fast on short keys, and is small enough that
it will often be retained in the instruction cache if hashing is
intermittent.
As a result it should give good performance for typical hash map
applications.
This code does not pass any of the SMHasher tests, but the resulting
degradation in performance due to its larger number of collisions is
expected to be minor compared to its faster hashing rate.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_fnv_1_hasher.f90!}
```


#### `fnv_1a_hasher`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32 bit hash code from an input of type `key_type`.

##### Syntax

`code = ` [[stdlib_hashmap_wrappers:fnv_1a_hasher]] `( key )`

##### Class

Pure function

##### Argument

`key`: Shall be a scalar expression of type `key_type`.
It is an `intent(in)` argument.

##### Result character

The result is a scalar integer of kind `int32`.

##### Result value

The result is a hash code created using the FNV-1a algorithm.

##### Note

`fnv_1a_hasher` is an implementation of the original FNV-1A hash code
of Glenn Fowler, Landon Curt Noll, and Phong Vo.
This code is relatively fast on short keys, and is small enough that
it will often be retained in the instruction cache if hashing is
intermittent.
As a result it should give good performance for typical hash map
applications.
This code does not pass any of the SMHasher tests, but the resulting
degradation in performance due to its larger number of collisions is
expected to be minor compared to its faster hashing rate.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_fnv_1a_hasher.f90!}
```

#### `free_key` - frees the memory associated with a key

##### Status

Experimental

##### Description

Deallocates the memory associated with a variable of type
`key_type`.

##### Syntax

`call ` [[stdlib_hashmap_wrappers:free_key]] `( key )`

##### Class

Subroutine.

##### Argument

`key`: shall be a scalar variable of type `key_type`. It
is an `intent(out)` argument.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_free_key.f90!}
```


#### `get` - extracts the data from a derived type

##### Status

Experimental

##### Description

Extracts the data from a `key_type` and stores it in the
variable `value`.

##### Syntax

`call ` [[stdlib_hashmap_wrappers:get]] `( key, value )`

##### Class

Subroutine.

##### Argument

`key`: shall be a scalar expression of type `key_type`. It
is an `intent(in)` argument.

`value`: shall be an allocatable default `character` string variable,
or an allocatable vector variable of type `integer` and kind `int8` or 
`int32`.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_get.f90!}
```


#### `hasher_fun`- serves as a function prototype.

##### Status

Experimental

##### Description

Serves as a prototype for hashing functions with a single, `key`,
argument of type `key_type` returning an `int32` hash value.

##### Syntax

`type(` [[stdlib_hashmap_wrappers:hasher_fun]] `), pointer :: fun_pointer`

##### Class

Pure function prototype

##### Argument

`key`: Shall be a rank one array expression of type `integer(int8)`.
It is an `intent(in)` argument.

##### Result character

The result is a scalar integer of kind `int32`.

##### Result value

The result is a hash code.

##### Note

`hasher_fun` is a prototype for defining dummy arguments and function
pointers intended for use as a hash function for the hash maps.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_hasher_fun.f90!}
```


#### `operator(==)` - Compares two keys for equality 

##### Status 

Experimental 

##### Description 

Returns `.true.` if two keys are equal, and `.false.` otherwise. 

##### Syntax 

`test = key1 == key2`

##### Class 

Pure operator. 

##### Arguments 

`key1`: shall be a scalar expression of type `key_type`. It 
is an `intent(in)` argument. 

`key2`: shall be a scalar expression of type `key_type`. It 
is an `intent(in)` argument. 

##### Result character 

The result is a value of type default `logical`. 

##### Result value 

The result is `.true.` if the keys are equal, otherwise `.falss.`. 

##### Example 

```fortran 
{!example/hashmaps/example_hashmaps_equal_keys.f90!}
```


#### `seeded_nmhash32_hasher`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32 bit hash code from an input of type `key_type`.

##### Syntax

`code = ` [[stdlib_hashmap_wrappers:seeded_nmhash32_hasher]] `( key )`

##### Class

Pure function

##### Argument

`key`: Shall be a scalar expression of type `key_type`.
It is an `intent(in)` argument.

##### Result character

The result is a scalar integer of kind `int32`.

##### Result value

The result is a hash code created using the `nmhash32` algorithm.

##### Note

`seeded_nmhash32_hasher` is a wrapper to the `NMHASH32_HASH` of the
module `stdlib_hash_32bit`, which supplies a fixed seed
to the wrapped function. `NMHASH32` is an implementation of the
`nmhash32` hash code of James Z. M. Gao.
This code has good, but not great, performance on long keys, poorer
performance on short keys.
As a result it should give fair performance for typical hash map
applications.
This code passes the SMHasher tests.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_seeded_nmhash32_hasher.f90!}
```


#### `seeded_nmhash32x_hasher`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32 bit hash code from an input of type `key_type`.

##### Syntax

`code = ` [[stdlib_hashmap_wrappers:seeded_nmhash32x_hasher]] `( key )`

##### Class

Pure function

##### Argument

`key`: Shall be a scalar expression of type `key_type`.
It is an `intent(in)` argument.

##### Result character

The result is a scalar integer of kind `int32`.

##### Result value

The result is a hash code created using the `nmhash32x` algorithm.

##### Note

`seeded_nmhash32x_hasher` is a wrapper to the `nmhash32x_hash` of the
module `stdlib_hash_32bit`, which supplies a fixed seed
to the wrapped function. `nmhash32x` is an implementation of the
`nmhash32x` hash code of James Z. M. Gao.
This code has good, but not great, performance on long keys, poorer
performance on short keys.
As a result it should give fair performance for typical hash map
applications.
This code passes the SMHasher tests.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_seeded_nmhash32x_hasher.f90!}
```


#### `seeded_water_hasher`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32 bit hash code from an input of type `key_type`.

##### Syntax

`code = ` [[stdlib_hashmap_wrappers:seeded_water_hasher]] `( key )`

##### Class

Pure function

##### Argument

`key`: Shall be a scalar expression of type `key_type`.
It is an `intent(in)` argument.

##### Result character

The result is a scalar integer of kind `int32`.

##### Result value

The result is a hash code created using the `waterhash` algorithm.

##### Note

`seeded_water_hasher` is a wrapper to the `water_hash` of the
module `stdlib_hash_32bit`, which supplies a fixed seed
to the wrapped function. `water_hash` is an implementation of the
`waterhash` hash code of Tommy Ettinger.
This code has excellent performance on long keys, and good performance
on short keys.
As a result it should give reasonable performance for typical hash
table applications.
This code passes the SMHasher tests.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_seeded_water_hasher.f90!}
```


#### `set` - places the data in a derived type

##### Status

Experimental

##### Description

Places the data from `value` in a `key_type`.

##### Syntax

`call ` [[stdlib_hashmap_wrappers:set]] `( key, value )`

##### Class

Subroutine.

##### Argument

`key`: shall be a scalar variable of type `key_type`. It
is an `intent(out)` argument.

`value`: shall be a default `character` string scalar expression,
or a vector expression of type `integer`and kind `int8` or `int32`.
It is an `intent(in)` argument.

##### Note

Values of types other than a scalar default character or and
`int8` or `int32` vector can be used as the basis of a `key` by transferring the
value to an `int8` vector.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_set.f90!}
```


## The `stdlib_hashmaps` module

The `stdlib_hashmaps` module defines three public data types,
associated procedures and constants that implement two simple hash map
types using separate chaining hashing and open addressing hashing. The
derived type `hashmap_type` is the parent type to its two
extensions: `chaining_hashmap_type` and `open_hashmap_type`.
The extension types provide 
procedures to manipulate the structure of a hash map object:
`init`, `map_entry`, `rehash`, `remove`, and
`set_other_data`. They also provide procedures to inquire about
entries in the hash map: `get_other_data`, and
`key_test`. Finally they provide procedures to inquire about the
overall structure and performance of the hash map object:`calls`,
`entries`, `get_other_data`, `loading`, `slots`, and
`total_depth`. The module also defines a number of public constants:
`probe_factor`, `load_factor`, `map_probe_factor`, `default_bits`,
`max_bits`, `int_calls`, `int_depth`, `int_index`,
`int_probes`, `success`, `alloc_fault`, and `array_size_error`.

Generic key interfaces for `key_test`, `map_entry`, `get_other_data`,
`remove`, and `set_other_data` are povided so that the supported types
of `int8` arrays, `int32` arrays and `character` scalars can be used in the
key field as well as the base `key` type.  So for `key_test`,
`key_key_test` specifies key type for the key field, `int8_key_test` is `int8`
for the key field and so on.  Procedures other than `key_key_test` will call
the `set` function to generate a key type and pass to `key_key_test`.         

### The `stdlib_hashmaps` module's public constants

The module defines several categories of public constants. Some are
used to parameterize the empirical slot expansion code. Others
parameterize the slots table size. Some are used to define
integer kind values for different applications. Finally, some are used
to report errors or success.

The constants `probe_factor`, and `map_probe_factor` are used to
parameterize the slot expansion code used to determine when in a
in a procedure call the number 
of slots need to be increased to decrease the search path for an
entry. The constant `probe_factor` is used to determine when
the ratio of the number of map probes to map calls is too large and 
the slots need expansion. The constant `map_probe_factor` is used to
determine when inserting a new entry the ratio of the number of map
probes to map calls is too large and the slots need expansion.

The constants `default_bits`, and
`max_bits` are used to parameterize the table's slots size. The
`default_bits` constant defines the default initial number of slots
with a current value of 6 resulting in an initial `2**6 == 64`
slots. This may optionally be overridden on hash map creation. The
`max_bits` parameter sets the maximum table size as `2**max_bits` with
a default value for `max_bits` of 30. The table will not work for a
slots size greater than `2**30`.

The constants `int_calls`, `int_depth`, `int_index`, and `int_probes`
are used to define integer kind values for various contexts. The
number of calls are reported and stored in entities of kind
`int_calls`. Currently `int_calls` has the value of `int64`. The
total depth, the number of inquiries needed to access all elements
of the table, is reported and stored in entities of kind
`int_depth`. Currently `int_depth` has the value of `int64`. The
number of entries in the table, is reported and stored in entities of
kind `int_index`. Currently `int_index` has the value of `int32`.
The number of probes, hash map enquiries, are reported and stored in
entities of kind `int_probes`. Currently `int_probes` has the value of
`int64`.

The constant `load_factor` is only used by the `open_hashmap_type`. It
specifies the maximum fraction of the available slots that may be
filled before expansion occurs. The current `load_factor = 0.5625` so
the current implementation of `open_hashmap_type` can only hold a
little more than `2**29` entries.

Finally the error codes `success`, `alloc_fault`, and
`array_size_error` are used to report the error status of certain
procedure calls. The `succes` code indicates that no problems were
found. The `alloc_fault` code indicates that a memory allocation
failed. Finally the `array_size_error` indicates that on table
creation `slots_bits` is less than `default_bits` or
greater than `max_bits`.

### The `stdlib_hashmaps` module's derived types

The `stdlib_hashmaps` module defines three public derived types and
seven private types used in the implementation of the public
types. The public types are the abstract `hashmap_type` and its
extensions: `chaining_hashmap_type` and `open_hashmap_type`. The three
private derived types, `chaining_map_entry_type`,
`chaining_map_entry_ptr`, and `chaining_map_entry_pool` are used in
the implementation of the `chaining_hashmap_type` public type. The
four private derived types, `open_map_entry_type`,
`open_map_entry_list`, `open_map_entry_ptr`, and `open_map_entry_pool`
are used in the implementation of the `open_hashmap_type` public
type. Each of these types are described below. 

#### The `hashmap_type` abstract type

The `hashmap_type` abstract type serves as the parent type for the two
types `chaining_hashmap_type` and `open_hashmap_type`. It defines
eight private components:

* `call_count` - the number of procedure calls on the map;

* `nbits` - the number of bits used to address the slots; 

* `num_entries` - the number of entries in the map;

* `num_free` - the number of entries in the free list of removed 
  entries;

* `probe_count` - the number of map probes since the last resizing or
  initialization;

* `total_probes` - the number of probes of the map up to the last
  resizing or initialization; and

* `hasher` - a pointer to the hash function used by the map.

* `initialized` - track if map has been initialized

It also defines five non-overridable procedures:

* `calls` - returns the number of procedure calls on the map;

* `entries` - returns the number of entries in the map;

* `map_probes` - returns the number of map probes since
  initialization;

* `num_slots` - returns the number of slots in the map; and

* `slots_bits` - returns the number of bits used to address the slots;

and ten deferred procedures:

* `get_all_keys` - gets all the keys contained in a map;

* `get_other_data` - gets the value associated with a key;

* `init` - initializes the hash map;

* `key_test` - returns a logical flag indicating whether the key is 
  defined in the map. 

* `loading` - returns the ratio of the number of entries to the number
  of slots;

* `map_entry` - inserts a key and optionally a corresponding value into
 the map;

* `rehash` - rehashes the map with the provided hash function;

* `remove` - removes the entry associated wit the key;

* `set_other_data` - replaces the value associated with a key;

* `total_depth` - returns the number of probes needed to address all
  the entries in the map;

The type's definition is below:

```fortran
    type, abstract :: hashmap_type

        private
        integer(int_calls) :: call_count = 0
        integer(int_calls) :: probe_count = 0
        integer(int_calls) :: total_probes = 0
        integer(int_index) :: num_entries = 0
        integer(int_index) :: num_free = 0
        integer(int32)     :: nbits = default_bits
        procedure(hasher_fun), pointer, nopass :: hasher => fnv_1_hasher

    contains
    
        procedure, non_overridable, pass(map) :: calls
        procedure, non_overridable, pass(map) :: entries
        procedure, non_overridable, pass(map) :: map_probes
        procedure, non_overridable, pass(map) :: num_slots
        procedure, non_overridable, pass(map) :: slots_bits
        procedure(get_all_keys), deferred, pass(map)        :: get_all_keys
        procedure(init_map), deferred, pass(map)            :: init
        procedure(loading), deferred, pass(map)             :: loading
        procedure(rehash_map), deferred, pass(map)          :: rehash
        procedure(total_depth), deferred, pass(map)         :: total_depth
    
        !! Generic interfaces for key types.
        procedure(key_key_test), deferred, pass(map) :: key_key_test
        procedure, non_overridable, pass(map) :: int8_key_test
        procedure, non_overridable, pass(map) :: int32_key_test
        procedure, non_overridable, pass(map) :: char_key_test
        
        procedure(key_map_entry), deferred, pass(map) :: key_map_entry
        procedure, non_overridable, pass(map) :: int8_map_entry
        procedure, non_overridable, pass(map) :: int32_map_entry
        procedure, non_overridable, pass(map) :: char_map_entry
        
        procedure(key_get_other_data), deferred, pass(map)  :: key_get_other_data
        procedure, non_overridable, pass(map) :: int8_get_other_data
        procedure, non_overridable, pass(map) :: int32_get_other_data
        procedure, non_overridable, pass(map) :: char_get_other_data
        
        procedure(key_remove_entry), deferred, pass(map) :: key_remove_entry
        procedure, non_overridable, pass(map) :: int8_remove_entry
        procedure, non_overridable, pass(map) :: int32_remove_entry
        procedure, non_overridable, pass(map) :: char_remove_entry
        
        procedure(key_set_other_data), deferred, pass(map)  :: key_set_other_data
        procedure, non_overridable, pass(map) :: int8_set_other_data
        procedure, non_overridable, pass(map) :: int32_set_other_data
        procedure, non_overridable, pass(map) :: char_set_other_data
        
        generic, public :: key_test => key_key_test, int8_key_test, int32_key_test, char_key_test
        generic, public :: map_entry => key_map_entry, int8_map_entry, int32_map_entry, char_map_entry
        generic, public :: get_other_data => key_get_other_data, int8_get_other_data, int32_get_other_data, char_get_other_data
        generic, public :: remove => key_remove_entry, int8_remove_entry, int32_remove_entry, char_remove_entry
        generic, public :: set_other_data => key_set_other_data, int8_set_other_data, int32_set_other_data, char_set_other_data
        
    end type hashmap_type
```


#### The `chaining_map_entry_type` derived type

Entities of the type `chaining_map_entry_type` are used to define
a linked list structure that stores the
key, its other data, the hash of the key, and the resulting index into
the inverse table. The type's definition is below:

```fortran
    type :: chaining_map_entry_type  ! Chaining hash map entry type
        private
        integer(int_hash)   :: hash_val ! Full hash value
        type(key_type)      :: key ! The entry's key
        class(*), allocatable  :: other ! Other entry data
        integer(int_index)  :: index ! Index into inverse table
        type(chaining_map_entry_type), pointer :: &
            next => null() ! Next bucket
    end type chaining_map_entry_type
```
Currently the `int_hash` and `int_index` have the value of `int32`.


#### The `chaining_map_entry_ptr` derived type

The type `chaining_map_entry_ptr` is used to define the elements of
the hash map that are either empty or link to the linked lists
containing the elements of the table. The type's definition is below:

```fortran
    type chaining_map_entry_ptr ! Wrapper for a pointer to a chaining
                                ! map entry type object
        type(chaining_map_entry_type), pointer :: target => null()
    end type chaining_map_entry_ptr
```


#### The `chaining_map_entry_pool` derived type

The type `chaining_map_entry_pool` is used to implement a pool of
allocated `chaining_map_entry_type` elements to save on allocation
costs. The type's definition is below: 

```fortran
    type :: chaining_map_entry_pool
    ! Type implementing a pool of allocated
    ! `chaining_map_entry_type` objects
        private
    ! Index of next bucket
        integer(int_index)                          :: next = 0
        type(chaining_map_entry_type), allocatable :: more_map_entries(:)
        type(chaining_map_entry_pool), pointer      :: lastpool => null()
    end type chaining_map_entry_pool
```


#### The `chaining_hashmap_type` derived type

The `chaining_hashmap_type` derived type extends the `hashmap_type` to
implements a separate chaining hash map. In addition to the components
of the `hashmap_type` it provides the four components:

* `cache` - a pool of `chaining_map_entry_pool` objects used to reduce
allocation costs;

* `free_list` - a free list of map entries;

* `inverse` - an array of `chaining_map_entry_ptr` bucket lists
(inverses) storing entries at fixed locations once
entered; and

* `slots` - an array of bucket lists serving as the hash map.

It also implements all of the deferred procedures of the
`hashmap_type` and a finalizer for its maps. The type's definition is
as follows:

```fortran
    type, extends(hashmap_type) :: chaining_hashmap_type
        private
        type(chaining_map_entry_pool), pointer    :: cache => null()
        type(chaining_map_entry_type), pointer    :: free_list => null()
        type(chaining_map_entry_ptr), allocatable :: inverse(:)
        type(chaining_map_entry_ptr), allocatable :: slots(:)
    contains
        procedure :: get_all_keys => get_all_chaining_keys
        procedure :: key_get_other_data => get_other_chaining_data
        procedure :: init => init_chaining_map
        procedure :: loading => chaining_loading
        procedure :: key_map_entry => map_chain_entry
        procedure :: rehash => rehash_chaining_map
        procedure :: key_remove_entry => remove_chaining_entry
        procedure :: key_set_other_data => set_other_chaining_data
        procedure :: total_depth => total_chaining_depth
        procedure :: key_key_test => chaining_key_test
        final     :: free_chaining_map
    end type chaining_hashmap_type
```


#### The `open_map_entry_type` derived type

Entities of the type `open_map_entry_type` are used to define
a linked list structure that stores the
key, its other data, the hash of the key, and the resulting index into
the inverse table. The type's definition is below:

```fortran
    type :: open_map_entry_type  ! Open hash map entry type
        private
        integer(int_hash)  :: hash_val ! Full hash value
        type(key_type)     :: key ! The entry's key
        class(*), allocatable  :: other ! Other entry data
        integer(int_index) :: index ! Index into inverse table
    end type open_map_entry_type
```

Currently `int_hash` and `int_index` have the value of `int32`.


#### The `open_map_entry_ptr` derived type

The type `open_map_entry_ptr` is used to define the elements of
the hash map that are either empty or link to the linked lists
containing the elements of the table. The type's definition is below:

```fortran
    type open_map_entry_ptr ! Wrapper for a pointer to a open
                            ! map entry type object
        type(open_map_entry_type), pointer :: target => null()
    end type open_map_entry_ptr
```


#### The `open_hashmap_type` derived type

The `open_hashmap_type` derived type extends the `hashmap_type` to
implement an open addressing hash map. In addition to the components
of the `hashmap_type` it provides the four components:

* `cache` - a pool of `open_map_entry_pool` objects used to reduce
allocation costs;

* `free_list` - a free list of map entries;

* `index_mask` - an `and` mask used in linear addressing;

* `inverse` - an array of `open_map_entry_ptr` bucket lists
(inverses) storing entries at fixed locations once
entered; and

* `slots` - an array of bucket lists serving as the hash map.

It also implements all of the deferred procedures of the
`hashmap_type` and a finalizer for its maps. The type's definition is
as follows:

```fortran
    type, extends(hashmap_type) :: open_hashmap_type
        private
        integer(int_index) :: index_mask = 2_int_index**default_bits-1
        type(open_map_entry_pool), pointer    :: cache => null()
        type(open_map_entry_list), pointer    :: free_list => null()
        type(open_map_entry_ptr), allocatable  :: inverse(:)
        integer(int_index), allocatable        :: slots(:)
    contains
        procedure :: get_all_keys => get_all_open_keys
        procedure :: key_get_other_data => get_other_open_data
        procedure :: init => init_open_map
        procedure :: loading => open_loading
        procedure :: key_map_entry => map_open_entry
        procedure :: rehash => rehash_open_map
        procedure :: key_remove_entry => remove_open_entry
        procedure :: key_set_other_data => set_other_open_data
        procedure :: total_depth => total_open_depth
        procedure :: key_key_test => open_key_test
        final     :: free_open_map
    end type open_hashmap_type
```


### Table of `stdlib_hashmap` procedures

The `stdlib_hashmap` module provides procedures in
several categories: a procedure to initialize the map; a procedure to
modify the structure of a map; procedures to modify the content of a
map; procedures to report on the content of a map; and procedures
to report on the structure of the map. The procedures in each category
are listed below.

Procedure to initialize a chaining hash map:

* `map % init( [hasher, slots_bits, status] )` - Routine
  to initialize a chaining hash map.

Procedure to modify the structure of a map:

* `map % rehash( hasher )` - Routine to change the hash function
  for a map.

Procedures to modify the content of a map:

* `map % map_entry( key[, other, conflict] )` - Inserts an entry into the
  hash map.

* `map % remove( key[, existed] )` - Remove the entry, if any,
  associated with the `key`.

* `map % set_other_data( key, other[, exists] )` - Change the value 
associated with the `key`.

Procedures to report the content of a map:

* `map % get_all_keys( all_keys )` - Returns all the keys
  contained in the map;

* `map % get_other_data( key, other[, exists] )` - Returns the value 
  associated with the `key`;

* `map % key_test( key, present)` - Returns a flag indicating whether
  the `key` is present in the map.

Procedures to report on the structure of the map:

* `map % calls()` - the number of subroutine calls on the hash map.

* `map % entries()`- the number of entries in a hash map.

* `map % loading()` - the number of entries relative to the number of
  slots in a hash map.

* `map % map_probes()` - the total number of table probes on a hash
  map.

* `map % slots()` - Returns the number of allocated slots in a hash
  map.

* `map % total_depth()` - Returns the total number of one's based
offsets of slot entries from their slot index


### Specifications of the `stdlib_hashmaps` procedures

#### `calls` - Returns the number of calls on the hash map

##### Status

Experimental

##### Description

Returns the number of procedure calls on a hash map.

##### Syntax

`value = map % ` [[hashmap_type(type):calls(bound)]] `()`

##### Class

Pure function

##### Argument

`map` (pass) - shall be an expression of class `hashmap_type`.
It is an `intent(in)` argument.

##### Result character

The result will be an integer of kind `int_calls`.

##### Result value

The result will be the number of procedure calls on the hash map.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_calls.f90!}
```


#### `entries` - Returns the number of entries in the hash map

##### Status

Experimental

##### Description

Returns the number of entries in a hash map.

##### Syntax

`value = map % ` [[hashmap_type(type):entries(bound)]] `()`

##### Class

Pure function

##### Argument

`map` (pass)  - shall be an expression of class `hashmap_type`.
It is an `intent(in)` argument.

##### Result character

The result will be an integer of kind `int_index`.

##### Result value

The result will be the number of entries in the hash map.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_entries.f90!}
```


#### `get_all_keys` - Returns all the keys contained in a map

##### Status

Experimental

##### Description

Returns all the keys contained in a map.

##### Syntax

`call map % ` [[hashmap_type(type):get_all_keys(bound)]] `( all_keys )`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
  `chaining_hashmap_type` or `open_hashmap_type`. It is an
  `intent(in)` argument. It will be 
  the hash map used to store and access the other data.

`all_keys`: shall be a rank-1 allocatable array of type `key_type`. 
  It is an `intent(out)` argument.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_get_all_keys.f90!}
```


#### `get_other_data` - Returns other data associated with the `key`

##### Status

Experimental

##### Description

Returns the value associated with the `key`,

##### Syntax

`value = map % ` [[hashmap_type(type):get_other_data(bound)]] `( key, other [, exists] )`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
  `chaining_hashmap_type` or `open_hashmap_type`. It is an
  `intent(inout)` argument. It will be 
  the hash map used to store and access the other data.

`key`: shall be a of type `key_type` scalar, `character` scalar, `int8` array
or `int32` array. It is an `intent(in)` argument.

`other`: shall be a allocatable unlimited polymorphic scalar.  
(class(*), allocatable)  It is an `intent(out)` argument.
It is the value associated with the `key`.

`exists` (optional): shall be a variable of type logical. It is an
`intent(out)` argument. If `.true.` an entry with the given `key`
exists in the map and `other` is defined. If `.false.` `other` is
undefined.

##### Example

 The following is an example of the retrieval of other data
  associated with a `key`:

```fortran
{!example/hashmaps/example_hashmaps_get_other_data.f90!}
```


#### `init` - initializes a hash map

##### Status

Experimental

##### Description

Initializes a `hashmap_type` object.

##### Syntax

`call map % ` [[hashmap_type(type):init(bound)]] `( [hasher, slots_bits, status ] )`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
  `chaining_hashmap_type` or `open_hashmap_type`. It is an
  `intent(out)` argument. It will 
  be a hash map used to store and access the entries.

`hasher`: (optional): shall be a procedure with interface `hash_fun`.
  It is an `intent(in)` argument. It is the procedure to be used to
  generate the hashes for the table from the keys of the entries. 
  Defaults to fnv_1_hasher if not provided.

`slots_bits` (optional): shall be a scalar default integer 
  expression. It is an `intent(in)` argument. The initial number of
  slots in the table will be `2**slots_bits`.

* `slots_bits` shall be a positive default integer less than
  `max_bits`, otherwise processing stops with an informative
  error code.

* If `slots_bits` is absent then the effective value for `slots_bits`
  is `default_bits`.

`status` (optional): shall be a scalar integer variable of kind
`int32`. It is an `intent(out)` argument. On return if present it
shall have an error code value.

* If map was successfully initialized then `status` has the value
`success`.

* If allocation of memory for the `map` arrays fails then `status`
has the value `alloc_fault`.

* If `slot_bits < 6` or `slots_bits > max_bits` then `status`
  has the value of `array_size_error`.

* If `status` is absent, but `status` would have a value other than
`success`, then processing stops with an informative stop code.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_init.f90!}
```


#### `key_test` - indicates whether `key` is present

##### Status

Experimental

##### Description

Returns a logical flag indicating whether `key` is present for an
entry in the map.

##### Syntax

`call map % ` [[hashmap_type(type):key_test(bound)]] `( key, present )`

##### Class

Subroutine.

##### Arguments

`map` (pass): shall be a scalar variable of class
`chaining_hashmap_type` or `open_hashmap_type`. 
It is an `intent(inout)` argument. It is the hash map whose entries
are examined.

`key`: shall be a of type `key_type` scalar, `character` scalar, `int8` array
or `int32` array. It is an `intent(in)` argument. It is a `key` whose 
presence in the `map` is being examined.

`present`: shall be a scalar variable of type `logical`.
It is an `intent(out)` argument. It is a logical flag where
`.true.` indicates that an entry with that `key` is present in the
`map` and `.false.` indicates that no such entry is present.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_key_test.f90!}
```


#### `loading` - Returns the ratio of entries to slots

##### Status

Experimental

##### Description

Returns the ratio of the number of entries relative to the number of
slots in the hash map.

##### Syntax

`value = map % ` [[hashmap_type(type):loading(bound)]] `( )`

##### Class

Pure function

##### Argument

`map` (pass) - shall be an expression of class `chaining_hashmap_type`
or `open_hashmap_type`. It is an `intent(in)` argument.

##### Result character

The result will be a default real.

##### Result value

The result will be the ratio of the number of entries relative to the
number of slots in the hash map.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_loading.f90!}
```


#### `map_entry` - inserts an entry into the hash map

##### Status

Experimental

##### Description

Inserts an entry into the hash map if it is not already present.

##### Syntax

`call map % ` [[hashmap_type(type):map_entry(bound)]] `( key[, other, conflict ] )`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
`chaining_hashmap_type` or `open_hashmap_type`. It
is an `intent(inout)` argument. It is the hash map to receive the
entry.

`key`: shall be a of type `key_type` scalar, `character` scalar, `int8` array
or `int32` array. It is an `intent(in)` argument. It is the key for the entry
to be placed in the table.

`other` (optional): shall be a scalar of any type, including derived types.
It is an `intent(in)` argument. If present it is the value to be
associated with the `key`.

`conflict` (optional): shall be a scalar variable of type
`logical`. It is an `intent(out)` argument. If present, a `.true.`
value indicates that an entry with the value of `key` already exists
and the entry was not entered into the map, a `.false.` value indicates
that `key` was not present in the map and the entry was added to the
map. 

* If `key` is already present in `map` and the `conflict` argument has been
provided then the presence of `other` is ignored. If `conflict` has not 
been provided then it routine will error stop.  

##### Example

```fortran
{!example/hashmaps/example_hashmaps_map_entry.f90!}
```


#### `map_probes` - returns the number of hash map probes

##### Status

Experimental

##### Description

Returns the total number of table probes on the hash map.

##### Syntax

`result = map % ` [[hashmap_type(type):map_probes(bound)]] `( )`

##### Class

Pure function

##### Argument

`map` (pass): shall be a scalar expression of class
`hashmap_type`. It is an `intent(in)`
argument. It is the hash map of interest.

##### Result character

The result is a scalar integer of kind `int_probes`.

##### Result value

The result is the number of probes of `map` since initialization or
rehashing. 

##### Example

```fortran
{!example/hashmaps/example_hashmaps_probes.f90!}
```


#### `num_slots` - returns the number of hash map slots.

##### Status

Experimental

##### Description

Returns the total number of slots on a hash map

##### Syntax

`result = map % ` [[hashmap_type(type):num_slots(bound)]] `( )`

##### Class

Pure function

##### Argument

`map`: shall be a scalar expression of class
`hashmap_type`. It is an `intent(in)` argument. It is the
hash map of interest.

##### Result character

The result is a scalar integer of kind `int_index`.

##### Result value

The result is the number of slots in `map`.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_num_slots.f90!}
```


#### `rehash` - changes the hashing function

##### Status

Experimental

##### Description

Changes the hashing function for the map entries to that of `hasher`.

##### Syntax

`call map % ` [[hashmap_type(type):rehash(bound)]] `( hasher )`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
`chaining_hashmap_type` or `open_hashmap_type`.
It is an `intent(inout)` argument. It is the hash map whose hashing 
method is to be changed.

`hasher`: shall be a function of interface `hasher_fun`.
It is the hash method to be used by `map`.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_rehash.f90!}
```


#### `remove` - removes an entry from the hash map

##### Status

Experimental

##### Description

Removes an entry from the hash map, `map`.

##### Syntax

`call map % ` [[hashmap_type(type):remove(bound)]] `( key[, existed ])`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
`chaining_hashmap_type` or `open_hashmap_type`. 
It is an `intent(inout)` argument. It is the hash map with the element 
to be removed.

`key`: shall be a of type `key_type` scalar, `character` scalar, `int8` array
or `int32` array. It is an `intent(in)` argument. It is the `key` identifying 
the entry to be removed.

`existed` (optional): shall be a scalar variable of type default
logical. It is an `intent(out)` argument. If present with the value
`.true.` the entry existed in the map before removal, if `.false.` the
entry was not present to be removed and the map is unchanged. If
absent, the procedure returns with no entry with the given key.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_remove.f90!}
```


#### `set_other_data` - replaces the other data for an entry

##### Status

Experimental

##### Description

Replaces the other data in the map for the entry with the key value,
`key`.

##### Syntax

`call map % ` [[hashmap_type(type):set_other_data(bound)]] `( key, other[, exists] )`

##### Class

Subroutine

##### Arguments

`map` (pass): shall be a scalar variable of class
`chaining_hashmap_type` or `open_hashmap_type`. It
is an `intent(inout)` argument. It will be a hash map used to store
and access the entry's data.

`key`: shall be a of type `key_type` scalar, `character` scalar, `int8` array
or `int32` array. It is an `intent(in)` argument. It is the `key` to the 
entry whose `other` data is to be replaced.

`other` (optional): shall be a scalar of any type, including derived types.
It is an `intent(in)` argument. If present it is the value to be
associated with the `key`.

`exists` (optional): shall be a scalar variable of type `logical`.
It is an `intent(out)` argument. If present with the value
`.true.` an entry with that `key` existed in the map and its `other`
data was replaced.  If `exists` is `.false.` the `key` did
not exist and nothing was done.

* If `key` is not already present in `map` and `exists` has not 
been provided then the routine will error stop.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_set_other_data.f90!}
```


#### `slots_bits` - returns the number of bits used to address the hash map slots 

##### Status

Experimental

##### Description

Returns the total number of bits used to address the hash map slots.

##### Syntax

`result = map % ` [[hashmap_type(type):slots_bits(bound)]] `( )`

##### Class

Pure function

##### Argument

`map` (pass): shall be a scalar expression of class
`hashmap_type`. It is an `intent(in)` argument. It is the
hash map of interest.

##### Result character

The result is a scalar integer of kind `int_index`.

##### Result value

The result is the number of bits used in addressing the slots in `map`.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_slots_bits.f90!}
```


#### `total_depth` - returns the total depth of the hash map entries

##### Status

Experimental

##### Description

Returns the total number of one's based offsets of slot entries from
their slot index for a hash map

##### Syntax

`result = map % ` [[hashmap_type:total_depth]] `( )`

##### Class

Pure function

##### Argument

`map` (pass): shall be a scalar expression of class
`hashmap_type`. It is an `intent(in)` argument. It is the
hash map of interest.

##### Result character

The result is a scalar integer of kind `int_depth`.

##### Result value

The result is the total number of one's based offsets of slot entries
from their slot index the map.

##### Example

```fortran
{!example/hashmaps/example_hashmaps_total_depth.f90!}
```

---
title: ascii
---

# The `stdlib_ascii` module

[TOC]

## Introduction

The `stdlib_ascii` module provides procedures for handling and manipulating
intrinsic character variables and constants.


## Constants provided by `stdlib_ascii`

### `NUL`

Null character

### `SOH`

Start Of Heading Character

### `STX`

Start Of Text character

### `ETX`

End Of Text character

### `EOT`

End Of Transmission character

### `ENQ`

Enquiry character

### `ACK`

Acknowledge character

### `BEL`

Bell character

### `BS`

Backspace character

### `TAB`

Horizontal Tab character

### `LF`

Line Feed character

### `VT`

Vertical Tab character

### `FF`

Form Feed character

### `CR`

Carriage Return character

### `SO`

Shift Out character

### `SI`

Shift In character

### `DLE`

Data Link Escape character

### `DC1`

Device Control 1 character

### `DC2`

Device Control 2 character

### `DC3`

Device Control 3 character

### `DC4`

Device Control 4 character

### `NAK`

Negative Acknowledge character

### `SYN`

Synchronous Idle character

### `ETB`

End of Transmission Block character

### `CAN`

Cancel character

### `EM`

End of Medium character

### `SUB`

Substitute character

### `ESC`

Escape character

### `FS`

File separator character

### `GS`

Group Separator character

### `RS`

Record Separator character

### `US`

Unit separator character

### `DEL`

Delete character

### `fullhex_digits`

All the hexadecimal digits (0-9, A-F, a-f)

### `hex_digits`

All the numerical and uppercase hexadecimal digits (0-9, A-F)

### `lowerhex_digits`

All the numerical and lowercase hexadecimal digits (0-9, a-f)

### `digits`

base 10 digits (0-9)

### `octal_digits`

base 8 digits (0-7)

### `letters`

Uppercase and lowercase letters of the english alphabet (A-Z, a-z)

### `uppercase`

Uppercase english albhabets (A-Z)

### `lowercase`

Lowercase english albhabets (a-z)

### `whitespace`

All the ascii whitespace characters (space, horizontal tab, vertical tab, carriage return, line feed, form feed)

## Specification of the `stdlib_ascii` procedures

### `is_alpha`

#### Status

Experimental

#### Description

Checks whether input character is an ASCII letter (A-Z, a-z).

#### Syntax

`res =` [[stdlib_ascii(module):is_alpha(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_alphanum`

#### Status

Experimental

#### Description

Checks whether input character is an ASCII letter or a number (A-Z, a-z, 0-9).

#### Syntax

`res =` [[stdlib_ascii(module):is_alphanum(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_ascii`

#### Status

Experimental

#### Description

Checks whether input character is in the ASCII character set i.e in the range 0-128.

#### Syntax

`res =` [[stdlib_ascii(module):is_ascii(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_control`

#### Status

Experimental

#### Description

Checks whether input character is a control character.

#### Syntax

`res =` [[stdlib_ascii(module):is_control(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_digit`

#### Status

Experimental

#### Description

Checks whether input character is a digit (0-9).

#### Syntax

`res =` [[stdlib_ascii(module):is_digit(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_octal_digit`

#### Status

Experimental

#### Description

Checks whether input character is an octal digit (0-7)

#### Syntax

`res =` [[stdlib_ascii(module):is_octal_digit(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_hex_digit`

#### Status

Experimental

#### Description

Checks whether input character is a hexadecimal digit (0-9, A-F, a-f).

#### Syntax

`res =` [[stdlib_ascii(module):is_hex_digit(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_punctuation`

#### Status

Experimental

#### Description

Checks whether input character is a punctuation character.

#### Syntax

`res =` [[stdlib_ascii(module):is_punctuation(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_graphical`

#### Status

Experimental

#### Description

Checks whether input character is a graphical character (printable other than the space character).

#### Syntax

`res =` [[stdlib_ascii(module):is_graphical(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_printable`

#### Status

Experimental

#### Description

Checks whether input character is a printable character (including the space character).

#### Syntax

`res =` [[stdlib_ascii(module):is_printable(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_lower`

#### Status

Experimental

#### Description

Checks whether input character is a lowercase ASCII letter (a-z).

#### Syntax

`res =` [[stdlib_ascii(module):is_lower(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_upper`

#### Status

Experimental

#### Description

Checks whether input character is an uppercase ASCII letter (A-Z).

#### Syntax

`res =` [[stdlib_ascii(module):is_upper(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_white`

#### Status

Experimental

#### Description

Checks whether input character is a whitespace character (which includes space, horizontal tab, vertical tab,
carriage return, linefeed and form feed characters)

#### Syntax

`res =` [[stdlib_ascii(module):is_white(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `is_blank`

#### Status

Experimental

#### Description

Checks whether input character is a blank character (which includes space and tabs).

#### Syntax

`res =` [[stdlib_ascii(module):is_blank(function)]] `(c)`

#### Class

Elemental function.

#### Argument

`c`: shall be an intrinsic `character(len=1)` type. It is an `intent(in)` argument.

#### Result value

The result is a `logical`.

### `to_lower`

#### Status

Experimental

#### Description

Converts input character variable to all lowercase.

#### Syntax

`res =` [[stdlib_ascii(module):to_lower(function)]] `(string)`

#### Class

Elemental function.

#### Argument

`string`: shall be an intrinsic character type. It is an `intent(in)` argument.

#### Result value

The result is an intrinsic character type of the same length as `string`.

#### Example

```fortran
{!example/ascii/example_ascii_to_lower.f90!}
```

### `to_upper`

#### Status

Experimental

#### Description

Converts input character variable to all uppercase.

#### Syntax

`res =` [[stdlib_ascii(module):to_upper(function)]] `(string)`

#### Class

Elemental function.

#### Argument

`string`: shall be an intrinsic character type. It is an `intent(in)` argument.

#### Result value

The result is an intrinsic character type of the same length as `string`.

#### Example

```fortran
{!example/ascii/example_ascii_to_upper.f90!}
```

### `to_title`

#### Status

Experimental

#### Description

Returns the titlecase version of the input character variable.  
Title case: First character of every word in the sentence is converted to 
uppercase and the rest of the characters are converted to lowercase.  
A word is a contiguous sequence of character(s) which consists of alphabetical 
character(s) and numeral(s) only and doesn't exclude any alphabetical character 
or numeral present next to either of its 2 ends.

#### Syntax

`res =` [[stdlib_ascii(module):to_title(function)]] `(string)`

#### Class

Elemental function.

#### Argument

`string`: shall be an intrinsic character type. It is an `intent(in)` argument.

#### Result value

The result is an intrinsic character type of the same length as `string`.

#### Example

```fortran
{!example/ascii/example_ascii_to_title.f90!}
```

### `to_sentence`

#### Status

Experimental

#### Description

Returns the sentencecase version of the input character variable.  
The first alphabetical character of the sequence is transformed to uppercase 
unless it follows a numeral. The rest of the characters in the sequence are 
transformed to lowercase.

#### Syntax

`res =` [[stdlib_ascii(module):to_sentence(function)]] `(string)`

#### Class

Elemental function.

#### Argument

`string`: shall be an intrinsic character type. It is an `intent(in)` argument.

#### Result value

The result is an intrinsic character type of the same length as `string`.

#### Example

```fortran
{!example/ascii/example_ascii_to_sentence.f90!}
```

### `reverse`

#### Status

Experimental

#### Description

Reverses the order of all characters in the input character type.

#### Syntax

`res =` [[stdlib_ascii(module):reverse(function)]] `(string)`

#### Class

Elemental function.

#### Argument

`string`: shall be an intrinsic character type. It is an `intent(in)` argument.

#### Result value

The result is an intrinsic character type of the same length as `string`.

#### Example

```fortran
{!example/ascii/example_ascii_reverse.f90!}
```

---
title: specialfunctions
---

# Special functions

[TOC]

## `legendre` - Calculate Legendre polynomials

### Status

Experimental

### Description

Computes the value of the n-th Legendre polynomial at a specified point.
Currently only 64 bit floating point is supported.

This is an `elemental` function.

### Syntax

`result = ` [[stdlib_specialfunctions(module):legendre(interface)]] ` (n, x)`

### Arguments

`n`: Shall be a scalar of type `real(real64)`. 

`x`: Shall be a scalar or array (this function is elemental) of type `real(real64)`. 

### Return value

The function result will be the value of the `n`-th Legendre polynomial, evaluated at `x`.



## `dlegendre` - Calculate first derivatives of Legendre polynomials

### Status

Experimental

### Description

Computes the value of the first derivative of the n-th Legendre polynomial at a specified point.
Currently only 64 bit floating point is supported.

This is an `elemental` function.

### Syntax

`result = ` [[stdlib_specialfunctions(module):dlegendre(interface)]] ` (n, x)`

### Arguments

`n`: Shall be a scalar of type `real(real64)`. 

`x`: Shall be a scalar or array (this function is elemental) of type `real(real64)`. 

### Return value

The function result will be the value of the first derivative of the `n`-th Legendre polynomial, evaluated at `x`.

---
title: Specifications (specs)
---

# Fortran stdlib Specifications (specs)

This is an index/directory of the specifications (specs) for each new module/feature as described in the
[workflow document](../Workflow.html).

[TOC]

## Experimental Features & Modules

 - [ansi](./stdlib_ansi.html) - Terminal color and style escape sequences
 - [array](./stdlib_array.html) - Procedures for index manipulation and array handling
 - [ascii](./stdlib_ascii.html) - Procedures for handling ASCII characters
 - [constants](./stdlib_constants.html) - Constants
 - [bitsets](./stdlib_bitsets.html) - Bitset data types and procedures
 - [error](./stdlib_error.html) - Catching and handling errors
 - [state_type](./stdlib_error_state_type.html) - General state and error handling 
 - [hash](./stdlib_hash_procedures.html) - Hashing integer
 vectors or character strings
 - [hashmaps](./stdlib_hashmaps.html) - Hash maps/tables
 - [io](./stdlib_io.html) - Input/output helper & convenience
 - [kinds](./stdlib_kinds.html) - Kind parameters
 - [linalg](./stdlib_linalg.html) - Linear Algebra
 - [linalg_state_type](./stdlib_linalg_state_type.html) - Linear Algebra state and error handling 
 - [logger](./stdlib_logger.html) - Runtime logging system
 - [math](./stdlib_math.html) - General purpose mathematical functions
 - [optval](./stdlib_optval.html) - Fallback value for optional arguments
 - [quadrature](./stdlib_quadrature.html) - Numerical integration
 - [random](./stdlib_random.html) - Probability Distributions random number generator
 - [sorting](./stdlib_sorting.html) - Sorting of rank one arrays
 - [stats](./stdlib_stats.html) - Descriptive Statistics
 - [stats_distributions_uniform](./stdlib_stats_distribution_uniform.html) - Uniform Probability Distribution
 - [stats_distributions_normal](./stdlib_stats_distribution_normal.html) - Normal Probability Distribution
 - [stats_distributions_exponential](./stdlib_stats_distribution_exponential.html) - Exponential Probability Distribution
 - [string\_type](./stdlib_string_type.html) - Basic string support
 - [stringlist_type](./stdlib_stringlist_type.html) - 1-Dimensional list of strings
 - [strings](./stdlib_strings.html) - String handling and manipulation routines
 - [system](./stdlib_system.html) - OS and sub-processing routines
 - [version](./stdlib_version.html) - Version information

## Released/Stable Features & Modules

 - (None yet)

---
title: stats_distribution_exponential
---

# Statistical Distributions -- Exponential Distribution Module

[TOC]

## `rvs_exp` - exponential distribution random variates

### Status

Experimental

### Description

An exponential distribution is the distribution of time between events in a Poisson point process.
The inverse `scale` parameter `lambda` specifies the average time between events (\(\lambda\)), also called the rate of events. The location `loc` specifies the value by which the distribution is shifted.

Without argument, the function returns a random sample from the unshifted standard exponential distribution \(E(\lambda=1)\) or \(E(loc=0, scale=1)\).

With a single argument of type `real`, the function returns a random sample from the exponential distribution \(E(\lambda=\text{lambda})\). 
For complex arguments, the real and imaginary parts are sampled independently of each other.

With one argument of type `real` and one argument of type `integer`, the function returns a rank-1 array of exponentially distributed random variates for (E(\lambda=\text{lambda})\).

With two arguments of type `real`, the function returns a random sample from the exponential distribution \(E(loc=loc, scale=scale)\).
For complex arguments, the real and imaginary parts are sampled independently of each other.

With two arguments of type `real` and one argument of type `integer`, the function returns a rank-1 array of exponentially distributed random variates for \(E(loc=loc, scale=scale)\).

@note
The algorithm used for generating exponential random variates is fundamentally limited to double precision.[^1]

### Syntax

`result = ` [[stdlib_stats_distribution_exponential(module):rvs_exp(interface)]] `([loc, scale] [[, array_size]])`

or

`result = ` [[stdlib_stats_distribution_exponential(module):rvs_exp(interface)]] `([lambda] [[, array_size]])`

### Class

Elemental function

### Arguments

`lambda`: optional argument has `intent(in)` and is a scalar of type `real` or `complex`.
If `lambda` is `real`, its value must be positive. If `lambda` is `complex`, both the real and imaginary components must be positive.

`loc`: optional argument has `intent(in)` and is a scalar of type `real` or `complex`. 

`scale`: optional argument has `intent(in)` and is a positive scalar of type `real` or `complex`.
If `scale` is `real`, its value must be positive. If `scale` is `complex`, both the real and imaginary components must be positive.

`array_size`: optional argument has `intent(in)` and is a scalar of type `integer` with default kind.

### Return value

If `lambda` is passed, the result is a scalar or rank-1 array with a size of `array_size`, and the same type as `lambda`.
If `lambda` is non-positive, the result is `NaN`.

If `loc` and `scale` are passed, the result is a scalar or rank-1 array with a size of `array_size`, and the same type as `scale`.
If `scale` is non-positive, the result is `NaN`.

### Example

```fortran
{!example/stats_distribution_exponential/example_exponential_rvs.f90!}
```

## `pdf_exp` - exponential distribution probability density function

### Status

Experimental

### Description

The probability density function (pdf) of the single real variable exponential distribution is:

$$f(x)=\begin{cases} \lambda e^{-\lambda x} &x\geqslant 0 \\\\ 0 &x< 0\end{cases}$$

For a complex variable \(z=(x + y i)\) with independent real \(x\) and imaginary \(y\) parts, the joint probability density function is the product of the corresponding real and imaginary marginal pdfs:[^2]

$$f(x+\mathit{i}y)=f(x)f(y)=\begin{cases} \lambda_{x} \lambda_{y} e^{-(\lambda_{x} x + \lambda_{y} y)} &x\geqslant 0, y\geqslant 0 \\\\ 0 &\text{otherwise}\end{cases}$$

Instead of of the inverse scale parameter `lambda`, it is possible to pass `loc` and `scale`, where \(scale = \frac{1}{\lambda}\) and `loc` specifies the value by which the distribution is shifted.

### Syntax

`result = ` [[stdlib_stats_distribution_exponential(module):pdf_exp(interface)]] `(x, loc, scale)`

or

`result = ` [[stdlib_stats_distribution_exponential(module):pdf_exp(interface)]] `(x, lambda)`

### Class

Elemental function

### Arguments

`x`: has `intent(in)` and is a scalar of type `real` or `complex`.

`lambda`: has `intent(in)` and is a scalar of type `real` or `complex`.
If `lambda` is `real`, its value must be positive. If `lambda` is `complex`, both the real and imaginary components must be positive.

`loc`: has `intent(in)` and is a scalar of type `real` or `complex`.

`scale`: has `intent(in)` and is a positive scalar of type `real` or `complex`.
If `scale` is `real`, its value must be positive. If `scale` is `complex`, both the real and imaginary components must be positive.

All arguments must have the same type.

### Return value

The result is a scalar or an array, with a shape conformable to the arguments, and the same type as the input arguments. If non-positive `lambda` or `scale`, the result is `NaN`.


### Example

```fortran
{!example/stats_distribution_exponential/example_exponential_pdf.f90!}
```

## `cdf_exp` - exponential cumulative distribution function

### Status

Experimental

### Description

Cumulative distribution function (cdf) of the single real variable exponential distribution:

$$F(x)=\begin{cases}1 - e^{-\lambda x} &x\geqslant 0 \\\\ 0 &x< 0\end{cases}$$

For a complex variable  \(z=(x + y i)\) with independent real \(x\) and imaginary \(y\) parts, the joint cumulative distribution function is the product of corresponding real and imaginary marginal cdfs:[^2]

$$F(x+\mathit{i}y)=F(x)F(y)=\begin{cases} (1 - e^{-\lambda_{x} x})(1 - e^{-\lambda_{y} y}) &x\geqslant 0, \;\; y\geqslant 0 \\\\ 0 & \text{otherwise} \end{cases}$$

Alternative to the inverse scale parameter `lambda`, it is possible to pass `loc` and `scale`, where \(scale = \frac{1}{\lambda}\) and `loc` specifies the value by which the distribution is shifted.

### Syntax

`result = ` [[stdlib_stats_distribution_exponential(module):cdf_exp(interface)]] `(x, loc, scale)`

or

`result = ` [[stdlib_stats_distribution_exponential(module):cdf_exp(interface)]] `(x, lambda)`

### Class

Elemental function

### Arguments

`x`: has `intent(in)` and is a scalar of type `real` or `complex`.

`lambda`: has `intent(in)` and is a scalar of type `real` or `complex`.
If `lambda` is `real`, its value must be positive. If `lambda` is `complex`, both the real and imaginary components must be positive.

`loc`: has `intent(in)` and is a scalar of type `real` or `complex`.

`scale`: has `intent(in)` and is a positive scalar of type `real` or `complex`.
If `scale` is `real`, its value must be positive. If `scale` is `complex`, both the real and imaginary components must be positive.

All arguments must have the same type.

### Return value

The result is a scalar or an array, with a shape conformable to the arguments, and the same type as the input arguments. With non-positive `lambda` or `scale`, the result is `NaN`.

### Example

```fortran
{!example/stats_distribution_exponential/example_exponential_cdf.f90!}
```

[^1]: Marsaglia, George, and Wai Wan Tsang. "The ziggurat method for generating random variables." _Journal of statistical software_ 5 (2000): 1-7.

[^2]: Miller, Scott, and Donald Childers. _Probability and random processes: With applications to signal processing and communications_. Academic Press, 2012 (p. 197).

---
title: string_type
---

# The `stdlib_string_type` module

[TOC]

## Introduction

The `stdlib_string_type` provides a derived type holding an arbitrary sequence
of characters compatible with most Fortran intrinsic character procedures as
well as operators for working with character variables and constants.


## Derived types provided


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### The `string_type` derived type

The `string_type` is defined as a non-extendible derived type representing a
sequence of characters. The internal representation of the character sequence
is implementation dependent and not visible for the user of the module.

#### Status

Experimental


## Procedures and methods provided

Procedures returning `string_type` instances can usually be used in elemental
context, while procedures returning scalar character values can only be
used in a pure way.


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Constructor for empty string

#### Status

Experimental

#### Description

The module defines a constructor to create an empty string type.

Creates a string instance representing an empty string.

#### Syntax

`res = ` [[stdlib_string_type(module):string_type(interface)]] ` ()`

#### Class

Elemental function.

#### Argument

None.

#### Result value

The result is an instance of `string_type` with zero length.

#### Example

```fortran
{!example/string_type/example_constructor_empty.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Constructor from character scalar

#### Status

Experimental

#### Description

The module defines a constructor to create a string type from a character scalar.

Creates a string instance representing the input character scalar value.
The constructor shall create an empty string if an unallocated deferred-length
character variable is passed.

#### Syntax

`res = ` [[stdlib_string_type(module):string_type(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: shall be a scalar character value. It is an `intent(in)` argument.

#### Result value

The result is an instance of `string_type`.

#### Example

```fortran
{!example/string_type/example_constructor_scalar.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Constructor from integer scalar

#### Status

Experimental

#### Description

The module defines a constructor to create a string type from an integer scalar.

#### Syntax

`res = ` [[stdlib_string_type(module):string_type(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`val`: shall be a scalar integer value. It is an `intent(in)` argument.

#### Result value

The result is an instance of `string_type`.

#### Example

```fortran
{!example/string_type/example_constructor_integer.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Constructor from logical scalar

#### Status

Experimental

#### Description

The module defines a constructor to create a string type from a logical scalar.

#### Syntax

`res = ` [[stdlib_string_type(module):string_type(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`val`: shall be a scalar logical value. It is an `intent(in)` argument.

#### Result value

The result is an instance of `string_type`.

#### Example

```fortran
{!example/string_type/example_constructor_logical.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Assignment of character scalar

#### Status

Experimental

#### Description

The module defines an assignment operations, `=`, to create a string type
from a character scalar.

Creates a string instance representing the right-hand-side character scalar value.

#### Syntax

`lhs = rhs`

#### Class

Elemental subroutine, `assignment(=)`.

#### Example

```fortran
{!example/string_type/example_constructor_character.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Len function

#### Status

Experimental

#### Description

Returns the length of the string.

#### Syntax

`res = ` [[stdlib_string_type(module):len(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_len.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Len\_trim function

#### Status

Experimental

#### Description

Returns the length of the character sequence without trailing spaces
represented by the string.

#### Syntax

`res = ` [[stdlib_string_type(module):len_trim(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_len_trim.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Trim function

#### Status

Experimental

#### Description

Returns the character sequence hold by the string without trailing spaces
represented by a `string_type`.

#### Syntax

`res = ` [[stdlib_string_type(module):trim(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_trim.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Adjustl function

#### Status

Experimental

#### Description

Left-adjust the character sequence represented by the string.
The length of the character sequence remains unchanged.

#### Syntax

`res = ` [[stdlib_string_type(module):adjustl(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_adjustl.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Adjustr function

#### Status

Experimental

#### Description

Right-adjust the character sequence represented by the string.
The length of the character sequence remains unchanged.

#### Syntax

`res = ` [[stdlib_string_type(module):adjustr(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_adjustr.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Repeat function

#### Status

Experimental

#### Description

Repeats the character sequence hold by the string by the number of
specified copies.

#### Syntax

`res = ` [[stdlib_string_type(module):repeat(interface)]] ` (string, ncopies)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.
- `ncopies`: Integer of default type. This argument is `intent(in)`.

#### Result value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_repeat.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Char function

#### Status

Experimental

#### Description

Return the character sequence represented by the string.

#### Syntax

`res = ` [[stdlib_string_type(module):char(interface)]] ` (string)`

#### Class

Pure function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a scalar character value.

#### Example

```fortran
{!example/string_type/example_char.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Char function (position variant)

#### Status

Experimental

#### Description

Return the character at a certain position in the string.

#### Syntax

`res = ` [[stdlib_string_type(module):char(interface)]] ` (string, pos)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.
- `pos`: Integer of default type. This argument is `intent(in)`.

#### Result value

The result is a scalar character value.

#### Example

```fortran
{!example/string_type/example_char_position.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Char function (range variant)

#### Status

Experimental

#### Description

Return a substring from the character sequence of the string.

#### Syntax

`res = ` [[stdlib_string_type(module):char(interface)]] ` (string, start, last)`

#### Class

Pure function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.
- `start`: Integer of default type. This argument is `intent(in)`.
- `last`: Integer of default type. This argument is `intent(in)`.

#### Result value

The result is a scalar character value.

#### Example

```fortran
{!example/string_type/example_char_range.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Ichar function

#### Status

Experimental

#### Description

Character-to-integer conversion function.

Returns the code for the character in the first character position of the
character sequence in the system's native character set.

#### Syntax

`res = ` [[stdlib_string_type(module):ichar(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_ichar.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Iachar function

#### Status

Experimental

#### Description

Code in ASCII collating sequence.

Returns the code for the ASCII character in the first character position of
the character sequences represent by the string.

#### Syntax

`res = ` [[stdlib_string_type(module):iachar(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

- `string`: Instance of a `string_type`. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_iachar.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Index function

#### Status

Experimental

#### Description

Position of a *substring* within a *string*.

Returns the position of the start of the leftmost or rightmost occurrence
of string *substring* in *string*, counting from one. If *substring* is not
present in *string*, zero is returned.

#### Syntax

`res = ` [[stdlib_string_type(module):index(interface)]] ` (string, substring[, back])`

#### Class

Elemental function.

#### Argument

- `string`: Either scalar character value or string type. This argument is `intent(in)`.
- `substring`: Either scalar character value or string type. This argument is `intent(in)`.
- `back`: Either absent or a scalar logical value. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_index.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Scan function

#### Status

Experimental

#### Description

Scans a *string* for the  presence any of the characters in a *set* of characters.
If *back* is either absent or *false*, this function returns the position
of the leftmost character of *string* that is in *set*. If *back* is *true*,
the rightmost position is returned. If no character of *set* is found in
*string*, the result is zero.

#### Syntax

`res = ` [[stdlib_string_type(module):scan(interface)]] ` (string, set[, back])`

#### Class

Elemental function.

#### Argument

- `string`: Either scalar character value or string type. This argument is `intent(in)`.
- `set`: Either scalar character value or string type. This argument is `intent(in)`.
- `back`: Either absent or a scalar logical value. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_scan.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Verify function

#### Status

Experimental

#### Description

Verifies that all the characters in *string* belong to the set of characters in *set*.
If *back* is either absent or *false*, this function returns the position
of the leftmost character of *string* that is not in *set*. If *back* is *true*,
the rightmost position is returned. If all characters of *string* are found
in *set*, the result is zero.

#### Syntax

`res = ` [[stdlib_string_type(module):verify(interface)]] ` (string, set[, back])`

#### Class

Elemental function.

#### Argument

- `string`: Either scalar character value or string type. This argument is `intent(in)`.
- `set`: Either scalar character value or string type. This argument is `intent(in)`.
- `back`: Either absent or a scalar logical value. This argument is `intent(in)`.

#### Result value

The result is a default integer scalar value.

#### Example

```fortran
{!example/string_type/example_verify.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Lgt function (lexical greater than)

#### Status

Experimental

#### Description

Lexically compare the order of two character sequences being greater than.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `lgt` procedure.

#### Syntax

`res = ` [[stdlib_string_type(module):lgt(interface)]] ` (lhs, rhs)`

#### Class

Elemental function.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_lgt.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Llt function (lexical less than)

#### Status

Experimental

#### Description

Lexically compare the order of two character sequences being less than.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `llt` procedure.

#### Syntax

`res = ` [[stdlib_string_type(module):llt(interface)]] ` (lhs, rhs)`

#### Class

Elemental function.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_llt.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Lge function (lexical greater than or equal)

#### Status

Experimental

#### Description

Lexically compare the order of two character sequences being greater than
or equal.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `lge` procedure.

#### Syntax

`res = ` [[stdlib_string_type(module):lge(interface)]] ` (lhs, rhs)`

#### Class

Elemental function.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_lge.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Lle function (lexical less than or equal)

#### Status

Experimental

#### Description

Lexically compare the order of two character sequences being less than
or equal.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `lle` procedure.

#### Syntax

`res = ` [[stdlib_string_type(module):lle(interface)]] ` (lhs, rhs)`

#### Class

Elemental function.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_lle.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### To\_lower function

#### Status

Experimental

#### Description

Returns a new string_type instance which holds the lowercase version of the
character sequence hold by the input string.

#### Syntax

`lowercase_string = ` [[stdlib_string_type(module):to_lower(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of `string_type`. This argument is `intent(in)`.

#### Result Value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_to_lower.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### To\_upper function

#### Status

Experimental

#### Description

Returns a new string_type instance which holds the uppercase version of the
character sequence hold by the input string.

#### Syntax

`uppercase_string = ` [[stdlib_string_type(module):to_upper(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of `string_type`. This argument is `intent(in)`.

#### Result Value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_to_upper.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### To\_title function

#### Status

Experimental

#### Description

Returns a new string_type instance which holds the titlecase version
of the character sequence hold by the input string.
Title case: First character of every word in the sentence is converted to
uppercase and the rest of the characters are converted to lowercase.
A word is a contiguous sequence of character(s) which consists of alphabetical
character(s) and numeral(s) only and doesn't exclude any alphabetical character
or numeral present next to either of its 2 ends.

#### Syntax

`titlecase_string = ` [[stdlib_string_type(module):to_title(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of `string_type`. This argument is `intent(in)`.

#### Result Value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_to_title.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### To\_sentence function

#### Status

Experimental

#### Description

Returns a new string_type instance which holds the sentencecase
version of the character sequence hold by the input string.
Sentencecase version: The first alphabetical character of the input character sequence
is transformed to uppercase unless it follows a numeral and the rest of the
characters in the sequence are transformed to lowercase.

#### Syntax

`sentencecase_string = ` [[stdlib_string_type(module):to_sentence(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of `string_type`. This argument is `intent(in)`.

#### Result Value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_to_sentence.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Reverse function

#### Status

Experimental

#### Description

Returns a new string_type instance which holds the reversed version of the
character sequence hold by the input string.

#### Syntax

`reverse_string = ` [[stdlib_string_type(module):reverse(interface)]] ` (string)`

#### Class

Elemental function.

#### Argument

`string`: Instance of `string_type`. This argument is `intent(in)`.

#### Result Value

The result is a scalar `string_type` value.

#### Example

```fortran
{!example/string_type/example_reverse.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator greater

#### Status

Experimental

#### Description

Compare the order of two character sequences being greater.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(>)`
and `operator(.gt.)`.

#### Syntax

`res = lhs > rhs`

`res = lhs .gt. rhs`

#### Class

Elemental function, `operator(>)` and `operator(.gt.)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_gt.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator less

#### Status

Experimental

#### Description

Compare the order of two character sequences being less.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(<)`
and `operator(.lt.)`.

#### Syntax

`res = lhs < rhs`

`res = lhs .lt. rhs`

#### Class

Elemental function, `operator(<)` and `operator(.lt.)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_lt.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator greater or equal

#### Status

Experimental

#### Description

Compare the order of two character sequences being greater or equal.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(>=)`
and `operator(.ge.)`.

#### Syntax

`res = lhs >= rhs`

`res = lhs .ge. rhs`

#### Class

Elemental function, `operator(>=)` and `operator(.ge.)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_ge.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator less or equal

#### Status

Experimental

#### Description

Compare the order of two character sequences being less or equal.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(<=)`
and `operator(.le.)`.

#### Syntax

`res = lhs <= rhs`

`res = lhs .le. rhs`

#### Class

Elemental function, `operator(<=)` and `operator(.le.)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_le.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator equal

#### Status

Experimental

#### Description

Compare two character sequences for equality.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(==)`
and `operator(.eq.)`.

#### Syntax

`res = lhs == rhs`

`res = lhs .eq. rhs`

#### Class

Elemental function, `operator(==)` and `operator(.eq.)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_eq.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator not equal

#### Status

Experimental

#### Description

Compare two character sequences for inequality.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(/=)`
and `operator(.ne.)`.

#### Syntax

`res = lhs /= rhs`

`res = lhs .ne. rhs`

#### Class

Elemental function, `operator(/=)` and `operator(.ne.)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is a default logical scalar value.

#### Example

```fortran
{!example/string_type/example_ne.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Concatenation operator

#### Status

Experimental

#### Description

Concatenate two character sequences.

The left-hand side, the right-hand side or both character sequences can
be represented by a string type.
This defines three procedures overloading the intrinsic `operator(//)`.

#### Syntax

`res = lhs // rhs`

#### Class

Elemental function, `operator(//)`.

#### Argument

- `lhs`: Either scalar character value or string type. This argument is `intent(in)`.
- `rhs`: Either scalar character value or string type. This argument is `intent(in)`.

#### Result value

The result is an instance of `string_type`.

#### Example

```fortran
{!example/string_type/example_cont.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Unformatted write

#### Status

Experimental

#### Description

Write the character sequence hold by the string to a connected unformatted unit.
The character sequences is represented by an 64 bit signed integer record,
holding the length of the following character record.

#### Syntax

`write(unit, iostat=iostat, iomsg=iomsg) string`

#### Class

Unformatted user defined derived type output.

#### Argument

- `string`: Instance of the string type to read. This argument is `intent(inout)`.
- `unit`: Formatted unit for output. This argument is `intent(in)`.
- `iostat`: Status identifier to indicate success of output operation.
  This argument is `intent(out)`.
- `iomsg`: Buffer to return error message in case of failing output operation.
  This argument is `intent(inout)`.

#### Example

```fortran
{!example/string_type/example_uwrite.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Formatted write

#### Status

Experimental

#### Description

Write the character sequence hold by the string to a connected formatted unit.

The current implementation is limited to list directed output and `dt` formatted
output. Requesting namelist output will raise an error.

#### Syntax

`write(unit, fmt, iostat=iostat, iomsg=iomsg) string`

#### Class

Formatted user defined derived type output.

#### Argument

- `string`: Instance of the string type to read. This argument is `intent(inout)`.
- `unit`: Formatted unit for output. This argument is `intent(in)`.
- `iotype`: Type of formatted data transfer, has the value `"LISTDIRECTED"` for `fmt=*`,
  `"NAMELIST"` for namelist output or starts with `"DT"` for derived type output.
  This argument is `intent(in)`.
- `v_list`: Rank one array of default integer type containing the edit descriptors for
  derived type output.
  This argument is `intent(in)`.
- `iostat`: Status identifier to indicate success of output operation.
  This argument is `intent(out)`.
- `iomsg`: Buffer to return error message in case of failing output operation.
  This argument is `intent(inout)`.

#### Example

```fortran
{!example/string_type/example_fwrite.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Unformatted read

#### Status

Experimental

#### Description

Read a character sequence from a connected unformatted unit into the string.
The character sequences is represented by an 64 bit signed integer record,
holding the length of the following character record.

On failure the state the read variable is undefined and implementation dependent.

#### Syntax

`read(unit, iostat=iostat, iomsg=iomsg) string`

#### Class

Unformatted derived type input.

#### Argument

- `string`: Instance of the string type to read. This argument is `intent(inout)`.
- `unit`: Formatted unit for input. This argument is `intent(in)`.
- `iostat`: Status identifier to indicate success of input operation.
  This argument is `intent(out)`.
- `iomsg`: Buffer to return error message in case of failing input operation.
  This argument is `intent(inout)`.

#### Example

```fortran
{!example/string_type/example_uread.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Formatted read

#### Status

Experimental

#### Description

Read a character sequence from a connected formatted unit into the string.
List-directed input will retrieve the complete record into the string.

On failure the state the read variable is undefined and implementation dependent.

The current implementation is limited to list directed input.
Requesting `dt` formatted input or namelist output will raise an error.

#### Syntax

`read(unit, fmt, iostat=iostat, iomsg=iomsg) string`

#### Class

Formatted derived type input.

#### Argument

- `string`: Instance of the string type to read. This argument is `intent(inout)`.
- `unit`: Formatted unit for input. This argument is `intent(in)`.
- `iotype`: Type of formatted data transfer, has the value `"LISTDIRECTED"` for `fmt=*`,
  `"NAMELIST"` for namelist input or starts with `"DT"` for derived type input.
  This argument is `intent(in)`.
- `v_list`: Rank one array of default integer type containing the edit descriptors for
  derived type input.
  This argument is `intent(in)`.
- `iostat`: Status identifier to indicate success of input operation.
  This argument is `intent(out)`.
- `iomsg`: Buffer to return error message in case of failing input operation.
  This argument is `intent(inout)`.

#### Example

```fortran
{!example/string_type/example_fread.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### move

#### Status

Experimental

#### Description

Moves the allocation from `from` to `to`, consequently deallocating `from` in this process.
If `from` is not allocated before execution, `to` gets deallocated by the process.
An unallocated `string_type` instance is equivalent to an empty string.
If `from` and `to` are the same variable, then `from` remains unchanged.

#### Syntax

`call ` [[stdlib_string_type(module):move(interface)]] ` (from, to)`

#### Class

Pure subroutine (Elemental subroutine, only when both `from` and `to` are `type(string_type)`)

#### Argument

- `from`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is `intent(inout)`.
- `to`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is `intent(inout)` when both `from` and `to` are `type(string_type)`,
  otherwise `intent(out)`.

#### Example

```fortran
{!example/string_type/example_move.f90!}
```

---
title: specialmatrices
---

# The `stdlib_specialmatrices` module

[TOC]

## Introduction

The `stdlib_specialmatrices` module provides derived types and specialized drivers for highly structured matrices often encountered in scientific computing as well as control and signal processing applications.
These include:

- Tridiagonal matrices
- Symmetric Tridiagonal matrices (not yet supported)
- Circulant matrices (not yet supported)
- Toeplitz matrices (not yet supported)
- Hankel matrices (not yet supported)

In addition, it also provides a `Poisson2D` matrix type (not yet supported) corresponding to the sparse block tridiagonal matrix obtained from discretizing the Laplace operator on a 2D grid with the standard second-order accurate central finite-difference scheme.

## List of derived types for special matrices

Below is a list of the currently supported derived types corresponding to different special matrices.
Note that this module is under active development and this list will eventually grow.

### Tridiagonal matrices {#Tridiagonal}

#### Status

Experimental

#### Description

Tridiagonal matrices are ubiquituous in scientific computing and often appear when discretizing 1D differential operators.
A generic tridiagonal matrix has the following structure:
$$
    A
    =
    \begin{bmatrix}
        a_1 &  b_1  \\
        c_1 &  a_2      &  b_2  \\
            &  \ddots   &  \ddots   &  \ddots   \\
            &           &  c_{n-2} &  a_{n-1}  &  b_{n-1} \\
            &           &           &  c_{n-1} &  a_n
    \end{bmatrix}.
$$
Hence, only one vector of size `n` and two of size `n-1` need to be stored to fully represent the matrix.
This particular structure also lends itself to specialized implementations for many linear algebra tasks.
Interfaces to the most common ones will soon be provided by `stdlib_specialmatrices`.
Tridiagonal matrices are available with all supported data types as `tridiagonal_<kind>_type`, for example:

- `tridiagonal_sp_type`   : Tridiagonal matrix of size `n` with `real`/`single precision` data.
- `tridiagonal_dp_type`   : Tridiagonal matrix of size `n` with `real`/`double precision` data.
- `tridiagonal_xdp_type`  : Tridiagonal matrix of size `n` with `real`/`extended precision` data.
- `tridiagonal_qp_type`   : Tridiagonal matrix of size `n` with `real`/`quadruple precision` data.
- `tridiagonal_csp_type`  : Tridiagonal matrix of size `n` with `complex`/`single precision` data.
- `tridiagonal_cdp_type`  : Tridiagonal matrix of size `n` with `complex`/`double precision` data.
- `tridiagonal_cxdp_type` : Tridiagonal matrix of size `n` with `complex`/`extended precision` data.
- `tridiagonal_cqp_type`  : Tridiagonal matrix of size `n` with `complex`/`quadruple precision` data.


#### Syntax

- To construct a tridiagonal matrix from already allocated arrays `dl` (lower diagonal, size `n-1`), `dv` (main diagonal, size `n`) and `du` (upper diagonal, size `n-1`):

`A = ` [[stdlib_specialmatrices(module):tridiagonal(interface)]] `(dl, dv, du)`

- To construct a tridiagonal matrix of size `n x n` with constant diagonal elements `dl`, `dv`, and `du`:

`A = ` [[stdlib_specialmatrices(module):tridiagonal(interface)]] `(dl, dv, du, n)`

#### Example

```fortran
{!example/specialmatrices/example_tridiagonal_dp_type.f90!}
```

## Specialized drivers for linear algebra tasks

Below is a list of all the specialized drivers for linear algebra tasks currently provided by the `stdlib_specialmatrices` module.

### Matrix-vector products with `spmv` {#spmv}

#### Status

Experimental

#### Description

With the exception of `extended precision` and `quadruple precision`, all the types provided by `stdlib_specialmatrices` benefit from specialized kernels for matrix-vector products accessible via the common `spmv` interface.

- For `tridiagonal` matrices, the backend is either LAPACK `lagtm` or the generalized routine `glagtm`, depending on the values and types of `alpha` and `beta`.

#### Syntax

`call ` [[stdlib_specialmatrices(module):spmv(interface)]] `(A, x, y [, alpha, beta, op])`

#### Arguments

- `A` : Shall be a matrix of one of the types provided by `stdlib_specialmatrices`. It is an `intent(in)` argument.

- `x` : Shall be a rank-1 or rank-2 array with the same kind as `A`. It is an `intent(in)` argument.

- `y` : Shall be a rank-1 or rank-2 array with the same kind as `A`. It is an `intent(inout)` argument.

- `alpha` (optional) : Scalar value of the same type as `x`. It is an `intent(in)` argument. By default, `alpha = 1`.

- `beta` (optional) : Scalar value of the same type as `y`. It is an `intent(in)` argument. By default `beta = 0`.

- `op` (optional) : In-place operator identifier. Shall be a character(1) argument. It can have any of the following values: `N`: no transpose, `T`: transpose, `H`: hermitian or complex transpose.

#### Examples

```fortran
{!example/specialmatrices/example_specialmatrices_dp_spmv.f90!}
```

## Utility functions

### `dense` : converting a special matrix to a standard Fortran array {#dense}

#### Status

Experimental

#### Description

Utility function to convert all the matrix types provided by `stdlib_specialmatrices` to a standard rank-2 array of the appropriate kind.

#### Syntax

`B = ` [[stdlib_specialmatrices(module):dense(interface)]] `(A)`

#### Arguments

- `A` : Shall be a matrix of one of the types provided by `stdlib_specialmatrices`. It is an `intent(in)` argument.

- `B` : Shall be a rank-2 allocatable array of the appropriate `real` or `complex` kind.

### `transpose` : Transposition of a special matrix {#transpose}

#### Status

Experimental

#### Description

Utility function returning the transpose of a special matrix. The returned matrix is of the same type and kind as the input one.

#### Syntax

`B = ` [[stdlib_specialmatrices(module):transpose(interface)]] `(A)`

#### Arguments

- `A` : Shall be a matrix of one of the types provided by `stdlib_specialmatrices`. It is an `intent(in)` argument.

- `B` : Shall be a matrix of one of the same type and kind as `A`.

### `hermitian` : Complex-conjugate transpose of a special matrix {#hermitian}

#### Status

Experimental

#### Description

Utility function returning the complex-conjugate transpose of a special matrix. The returned matrix is of the same type and kind as the input one. For real-valued matrices, `hermitian` is equivalent to `transpose`.

#### Syntax

`B = ` [[stdlib_specialmatrices(module):hermitian(interface)]] `(A)`

#### Arguments

- `A` : Shall be a matrix of one of the types provided by `stdlib_specialmatrices`. It is an `intent(in)` argument.

- `B` : Shall be a matrix of one of the same type and kind as `A`.

### Operator overloading (`+`, `-`, `*`) {#operators}

#### Status

Experimental

#### Description

The definition of all standard artihmetic operators have been overloaded to be applicable for the matrix types defined by `stdlib_specialmatrices`:

- Overloading the `+` operator for adding two matrices of the same type and kind.
- Overloading the `-` operator for subtracting two matrices of the same type and kind.
- Overloading the `*` for scalar-matrix multiplication.

#### Syntax

- Adding two matrices of the same type:

`C = A` [[stdlib_specialmatrices(module):operator(+)(interface)]] `B`

- Subtracting two matrices of the same type:

`C = A` [[stdlib_specialmatrices(module):operator(-)(interface)]] `B`

- Scalar multiplication

`B = alpha` [[stdlib_specialmatrices(module):operator(*)(interface)]] `A`

@note
For addition (`+`) and subtraction (`-`), matrices `A`, `B` and `C` all need to be of the same type and kind. For scalar multiplication (`*`), `A` and `B` need to be of the same type and kind, while `alpha` is either `real` or `complex` (with the same kind again) depending on the type being used.
@endnote

---
title: linalg_iterative_solvers
---

# The `stdlib_linalg_iterative_solvers` module

[TOC]

## Introduction

The `stdlib_linalg_iterative_solvers` module provides base implementations for known iterative solver methods. Each method is exposed with two procedure flavors: 

* A `stdlib_solve_<method>_kernel` which holds the method's base implementation. The linear system argument is defined through a `stdlib_linop` derived type which enables extending the method for implicit or unknown (by `stdlib`) matrices or to complex scenarios involving distributed parallelism for which the user shall extend the `inner_product` and/or matrix-vector product to account for parallel syncrhonization.

* A `stdlib_solve_<method>` which proposes an off-the-shelf ready to use interface for `dense` and `CSR_<kind>_type` matrices for all `real` kinds.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### The `stdlib_linop` derived type

The `stdlib_linop_<kind>_type` derive type is an auxiliary class enabling to abstract the definition of the linear system and the actual implementation of the solvers.

#### Type-bound procedures

The following type-bound procedure pointers enable customization of the solver:

##### `matvec`

Proxy procedure for the matrix-vector product \( y = alpha * op(M) * x + beta * y \).

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_linop_dp_type(type)]] `%matvec(x,y,alpha,beta,op)`

###### Class

Subroutine

###### Argument(s)

`x`: 1-D array of `real(<kind>)`. This argument is `intent(in)`.

`y`: 1-D array of `real(<kind>)`. This argument is `intent(inout)`.

`alpha`: scalar of `real(<kind>)`. This argument is `intent(in)`.

`beta`: scalar of `real(<kind>)`. This argument is `intent(in)`.

`op`: `character(1)` scalar which can be have any of the following values: `N` (no transpose), `T` (transpose) or `H` (conjugate transpose). This argument is `intent(in)`.

##### `inner_product`

Proxy procedure for the `dot_product`.

#### Syntax

`res = ` [[stdlib_linalg_iterative_solvers(module):stdlib_linop_dp_type(type)]] `%inner_product(x,y)`

###### Class

Function

###### Argument(s)

`x`: 1-D array of `real(<kind>)`. This argument is `intent(in)`.

`y`: 1-D array of `real(<kind>)`. This argument is `intent(in)`.

###### Output value or Result value

The output is a scalar of `type` and `kind` same as to that of `x` and `y`.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### The `solver_workspace` derived type

The `stdlib_solver_workspace_<kind>_type` derive type is an auxiliary class enabling to hold the data associated to the working arrays needed by the solvers to operate.

#### Type-bound procedures

- `callback`: null pointer procedure enabling to pass a callback at each iteration to check on the solvers status.

##### Class

Subroutine

##### Argument(s)

`x`: 1-D array of `real(<kind>)` type with the current state of the solution vector. This argument is `intent(in)` as it should not be modified by the callback.

`norm_sq`: scalar of `real(<kind>)` type representing the squared norm of the residual at the current iteration. This argument is `intent(in)`.

`iter`: scalar of `integer` type giving the current iteration counter. This argument is `intent(in)`.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_solve_cg_kernel` subroutine

#### Description

Implements the Conjugate Gradient (CG) method for solving the linear system \( Ax = b \), where \( A \) is a symmetric positive-definite linear operator defined via the `stdlib_linop` type. This is the core implementation, allowing flexibility for custom matrix types or parallel environments.

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_solve_cg_kernel(interface)]] ` (A, b, x, tol, maxiter, workspace)`

#### Status

Experimental

#### Class

Subroutine

#### Argument(s)

`A`: `class(stdlib_linop_<kind>_type)` defining the linear operator. This argument is `intent(in)`.

`b`: 1-D array of `real(<kind>)` defining the loading conditions of the linear system. This argument is `intent(in)`.

`x`: 1-D array of `real(<kind>)` which serves as the input initial guess and the output solution. This argument is `intent(inout)`.

`rtol` and `atol`: scalars of type `real(<kind>)` specifying the convergence test. For convergence, the following criterion is used \( || b - Ax ||^2 <= max(rtol^2 * || b ||^2 , atol^2 ) \). These arguments are `intent(in)`.

`maxiter`: scalar of type `integer` defining the maximum allowed number of iterations. This argument is `intent(in)`.

`workspace`: scalar derived type of `type(stdlib_solver_workspace_<kind>_type)` holding the work array for the solver. This argument is `intent(inout)`.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `solve_cg` subroutine

#### Description

Provides a user-friendly interface to the CG method for solving \( Ax = b \), supporting `dense` and `CSR_<kind>_type` matrices. It handles workspace allocation and optional parameters for customization.

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_solve_cg(interface)]] ` (A, b, x [, di, rtol, atol, maxiter, restart, workspace])`

#### Status

Experimental

#### Class

Subroutine

#### Argument(s)

`A`: `dense` or `CSR_<kind>_type` matrix defining the linear system. This argument is `intent(in)`.

`b`: 1-D array of `real(<kind>)` defining the right-hand-side (or loading) of the linear system. This argument is `intent(in)`.

`x`: 1-D array of `real(<kind>)` which serves as the input initial guess and as the output solution. This argument is `intent(inout)`.

`di` (optional): 1-D mask array of type `logical(int8)` defining the degrees of freedom subject to dirichlet boundary conditions. The actual boundary conditions values should be stored in the `b` load array. This argument is `intent(in)`.

`rtol` and `atol` (optional): scalars of type `real(<kind>)` specifying the convergence test. For convergence, the following criterion is used \( || b - Ax ||^2 <= max(rtol^2 * || b ||^2 , atol^2 ) \). Defaults values are `rtol=1.e-5` and `atol=epsilon(1._<kind>)`. These arguments are `intent(in)`.

`maxiter` (optional): scalar of type `integer` defining the maximum allowed number of iterations. If no value is given, a default of `N` is set, where `N = size(b)`. This argument is `intent(in)`.

`workspace` (optional): scalar derived type of `type(stdlib_solver_workspace_<kind>_type)` holding the work array for the solver. If the user passes its own `workspace`, then a pointer is set internally to it. Otherwise, memory will be internally allocated and deallocated before exiting the procedure. This argument is `intent(inout)`.

#### Example

```fortran
{!example/linalg/example_solve_cg.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_solve_pcg_kernel` subroutine

#### Description

Implements the Preconditioned Conjugate Gradient (PCG) method for solving the linear system \( Ax = b \), where \( A \) is a symmetric positive-definite linear operator defined via the `stdlib_linop` type. This is the core implementation, allowing flexibility for custom matrix types or parallel environments.

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_solve_cg_kernel(interface)]] ` (A, M, b, x, tol, maxiter, workspace)`

#### Status

Experimental

#### Class

Subroutine

#### Argument(s)

`A`: `class(stdlib_linop_<kind>_type)` defining the linear operator. This argument is `intent(in)`.

`M`: `class(stdlib_linop_<kind>_type)` defining the preconditioner linear operator. This argument is `intent(in)`.

`b`: 1-D array of `real(<kind>)` defining the loading conditions of the linear system. This argument is `intent(in)`.

`x`: 1-D array of `real(<kind>)` which serves as the input initial guess and the output solution. This argument is `intent(inout)`.

`rtol` and `atol` (optional): scalars of type `real(<kind>)` specifying the convergence test. For convergence, the following criterion is used \( || b - Ax ||^2 <= max(rtol^2 * || b ||^2 , atol^2 ) \). These arguments are `intent(in)`.

`maxiter`: scalar of type `integer` defining the maximum allowed number of iterations. This argument is `intent(in)`.

`workspace`: scalar derived type  of `type(stdlib_solver_workspace_<kind>_type)` holding the work array for the solver. This argument is `intent(inout)`.

#### Example

```fortran
{!example/linalg/example_solve_custom.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_solve_pcg` subroutine

#### Description

Provides a user-friendly interface to the PCG method for solving \( Ax = b \), supporting `dense` and `CSR_<kind>_type` matrices. It supports optional preconditioners and handles workspace allocation.

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_solve_pcg(interface)]] ` (A, b, x [, di, tol, maxiter, restart, precond, M, workspace])`

#### Status

Experimental

#### Class

Subroutine

#### Argument(s)

`A`: `dense` or `CSR_<kind>_type` matrix defining the linear system. This argument is `intent(in)`.

`b`: 1-D array of `real(<kind>)` defining the loading conditions of the linear system. This argument is `intent(in)`.

`x`: 1-D array of `real(<kind>)` which serves as the input initial guess and the output solution. This argument is `intent(inout)`.

`di` (optional): 1-D mask array of type `logical(int8)` defining the degrees of freedom subject to dirichlet boundary conditions. The actual boundary conditions values should be stored in the `b` load array. This argument is `intent(in)`.

`rtol` and `atol` (optional): scalars of type `real(<kind>)` specifying the convergence test. For convergence, the following criterion is used \( || b - Ax ||^2 <= max(rtol^2 * || b ||^2 , atol^2 ) \). Defaults values are `rtol=1.e-5` and `atol=epsilon(1._<kind>)`. These arguments are `intent(in)`.

`maxiter` (optional): scalar of type `integer` defining the maximum allowed number of iterations. If no value is given, a default of `N` is set, where `N = size(b)`. This argument is `intent(in)`.

`precond` (optional): scalar of type `integer` enabling to switch among the default preconditioners available with the following enum (`pc_none`, `pc_jacobi`). If no value is given, no preconditionning will be applied. This argument is `intent(in)`.

`M` (optional): scalar derived type of `class(stdlib_linop_<kind>_type)` defining a custom preconditioner linear operator. If given, `precond` will have no effect, a pointer is set to this custom preconditioner.

`workspace` (optional): scalar derived type of `type(stdlib_solver_workspace_<kind>_type)` holding the work temporal array for the solver. If the user passes its own `workspace`, then internally a pointer is set to it, otherwise, memory will be internally allocated and deallocated before exiting the procedure. This argument is `intent(inout)`.

#### Example

```fortran
{!example/linalg/example_solve_pcg.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_solve_bicgstab_kernel` subroutine

#### Description

Implements the Biconjugate Gradient Stabilized (BiCGSTAB) method for solving the linear system \( Ax = b \), where \( A \) is a general (non-symmetric) linear operator defined via the `stdlib_linop` type. BiCGSTAB is particularly suitable for solving non-symmetric linear systems and provides better stability than the basic BiCG method. This is the core implementation, allowing flexibility for custom matrix types or parallel environments.

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_solve_bicgstab_kernel(interface)]] ` (A, M, b, x, rtol, atol, maxiter, workspace)`

#### Status

Experimental

#### Class

Subroutine

#### Argument(s)

`A`: `class(stdlib_linop_<kind>_type)` defining the linear operator. This argument is `intent(in)`.

`M`: `class(stdlib_linop_<kind>_type)` defining the preconditioner linear operator. This argument is `intent(in)`.

`b`: 1-D array of `real(<kind>)` defining the loading conditions of the linear system. This argument is `intent(in)`.

`x`: 1-D array of `real(<kind>)` which serves as the input initial guess and the output solution. This argument is `intent(inout)`.

`rtol` and `atol`: scalars of type `real(<kind>)` specifying the convergence test. For convergence, the following criterion is used \( || b - Ax ||^2 <= max(rtol^2 * || b ||^2 , atol^2 ) \). These arguments are `intent(in)`.

`maxiter`: scalar of type `integer` defining the maximum allowed number of iterations. This argument is `intent(in)`.

`workspace`: scalar derived type of `type(stdlib_solver_workspace_<kind>_type)` holding the work array for the solver. This argument is `intent(inout)`.

#### Note

The BiCGSTAB method requires 8 auxiliary vectors in its workspace, making it more memory-intensive than CG or PCG methods. However, it can handle general non-symmetric matrices and often converges faster than BiCG for many problems.

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stdlib_solve_bicgstab` subroutine

#### Description

Provides a user-friendly interface to the BiCGSTAB method for solving \( Ax = b \), supporting `dense` and `CSR_<kind>_type` matrices. BiCGSTAB is suitable for general (non-symmetric) linear systems and supports optional preconditioners for improved convergence. It handles workspace allocation and optional parameters for customization.

#### Syntax

`call ` [[stdlib_linalg_iterative_solvers(module):stdlib_solve_bicgstab(interface)]] ` (A, b, x [, di, rtol, atol, maxiter, restart, precond, M, workspace])`

#### Status

Experimental

#### Class

Subroutine

#### Argument(s)

`A`: `dense` or `CSR_<kind>_type` matrix defining the linear system. This argument is `intent(in)`.

`b`: 1-D array of `real(<kind>)` defining the loading conditions of the linear system. This argument is `intent(in)`.

`x`: 1-D array of `real(<kind>)` which serves as the input initial guess and the output solution. This argument is `intent(inout)`.

`di` (optional): 1-D mask array of type `logical(int8)` defining the degrees of freedom subject to dirichlet boundary conditions. The actual boundary condition values should be stored in the `b` load array. This argument is `intent(in)`.

`rtol` and `atol` (optional): scalars of type `real(<kind>)` specifying the convergence test. For convergence, the following criterion is used \( || b - Ax ||^2 <= max(rtol^2 * || b ||^2 , atol^2 ) \). Default values are `rtol=1.e-5` and `atol=epsilon(1._<kind>)`. These arguments are `intent(in)`.

`maxiter` (optional): scalar of type `integer` defining the maximum allowed number of iterations. If no value is given, a default of `N` is set, where `N = size(b)`. This argument is `intent(in)`.

`restart` (optional): scalar of type `logical` indicating whether to restart the iteration with zero initial guess. Default is `.true.`. This argument is `intent(in)`.

`precond` (optional): scalar of type `integer` enabling to switch among the default preconditioners available with the following enum (`pc_none`, `pc_jacobi`). If no value is given, no preconditioning will be applied. This argument is `intent(in)`.

`M` (optional): scalar derived type of `class(stdlib_linop_<kind>_type)` defining a custom preconditioner linear operator. If given, `precond` will have no effect, and a pointer is set to this custom preconditioner. This argument is `intent(in)`.

`workspace` (optional): scalar derived type of `type(stdlib_solver_workspace_<kind>_type)` holding the work temporal array for the solver. If the user passes its own `workspace`, then internally a pointer is set to it, otherwise, memory will be internally allocated and deallocated before exiting the procedure. This argument is `intent(inout)`.

#### Note

BiCGSTAB is particularly effective for:
- Non-symmetric linear systems
- Systems where CG cannot be applied
- Cases where BiCG suffers from irregular convergence

The method uses 8 auxiliary vectors internally, requiring more memory than simpler methods but often providing better stability and convergence properties.

#### Example 1

```fortran
{!example/linalg/example_solve_bicgstab.f90!}
```

#### Example 2
```fortran
{!example/linalg/example_solve_bicgstab_wilkinson.f90!}
```

---
title: stats_distribution_uniform
---

# Statistical Distributions -- Uniform Distribution Module

[TOC]

## `shuffle` - Using Fisher-Yates algorithm to generate a random permutation of a list

### Status

Experimental

### Description

Applying Fisher-Yates algorithm to generate an unbiased permutation for any list of intrinsic numerical data types.

### Syntax

`result = ` [[stdlib_stats_distribution_uniform(module):shuffle(interface)]] `( list )`

### Class

Function.

### Arguments

`list`: argument has `intent(in)` and is a rank one array of `integer`, `real`, or `complex` type.

### Return value

Return a randomized rank one array of the input type.

### Example

```fortran
{!example/stats_distribution_uniform/example_shuffle.f90!}
```

## `rvs_uniform` - uniform distribution random variates

### Status

Experimental

### Description

Without argument the function returns a scalar standard uniformly distributed variate U(0,1) of `real` type with single precision on [0,1].

With single argument `scale` of `integer` type the function returns a scalar uniformly distributed variate of `integer` type on [0,scale]. This is the standard Rectangular distribution.

With single argument `scale` of `real` or `complex` type the function returns a scalar uniformly distributed variate of `real` type on [0, scale] or `complex` type on [(0, 0i), (scale, i(scale))].

With double arguments `loc` and `scale` the function returns a scalar uniformly distributed random variates of `integer` or `real` type on [loc, loc + scale], or `complex` type on [(loc, i(loc)), ((loc + scale), i(loc + scale))], dependent of input type.

With triple arguments `loc`, `scale` and `array_size` the function returns a rank one array of uniformly distributed variates of `integer`, `real` or `complex` type with an array size of `array_size`.

For `complex` type, the real part and imaginary part are independent of each other.

Note: the algorithm used for generating uniform random variates is fundamentally limited to double precision.

### Syntax

`result = ` [[stdlib_stats_distribution_uniform(module):rvs_uniform(interface)]] `([[loc,] scale] [[[,array_size]]])`

### Class

Elemental function (without the third argument).

### Arguments

`loc`: optional argument has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

`scale`: optional argument has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

`array_size`: optional argument has `intent(in)` and is a scalar of type `integer` with default kind.

`loc` and `scale` must have the same type and kind when both are present.

### Return value

The result is a scalar or a rank one array with size of `array_size`, of type `integer`, `real` or `complex` depending on the input type.

### Example

```fortran
{!example/stats_distribution_uniform/example_uniform_rvs.f90!}
```

## `pdf_uniform` - Uniform distribution probability density function

### Status

Experimental

### Description

The probability density function of the uniform distribution:

f(x) = 0       x < loc or x > loc + scale  for all types uniform distributions

For random variable x in [loc, loc + scale]:

f(x) = 1 / (scale + 1);            for discrete uniform distribution.

f(x) = 1 / scale;                  for continuous uniform distribution.

f(x) = 1 / (scale%re * scale%im);  for complex uniform distribution.

### Syntax

`result = ` [[stdlib_stats_distribution_uniform(module):pdf_uniform(interface)]] `(x, loc, scale)`

### Class

Elemental function.

### Arguments

`x`: has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

`loc`: has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

`scale`: has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

All three arguments must have the same type and kind.

### Return value

The result is a scalar or an array, with a shape conformable to arguments, of type `real`.

### Example

```fortran
{!example/stats_distribution_uniform/example_uniform_pdf.f90!}
```

## `cdf_uniform` - Uniform distribution cumulative distribution function

### Status

Experimental

### Description

Cumulative distribution function of the uniform distribution:

F(x) = 0             x < loc             for all types uniform distributions

F(x) = 1             x > loc + scale     for all types uniform distributions

For random variable x in [loc, loc + scale]:

F(x) = (x - loc + 1) / (scale + 1);      for discrete uniform distribution.

F(x) = (x - loc) / scale;                for continuous uniform distribution.

F(x) = (x%re - loc%re)(x%im - loc%im) / (scale%re * scale%im); for complex uniform distribution.

### Syntax

`result = ` [[stdlib_stats_distribution_uniform(module):cdf_uniform(interface)]] `(x, loc, scale)`

### Class

Elemental function.

### Arguments

`x`: has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

`loc`: has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

`scale`: has `intent(in)` and is a scalar of type `integer`, `real` or `complex`.

All three arguments must have the same type and kind.

### Return value

The result is a scalar or an array, with a shape conformable to arguments, of type `real`.

### Example

```fortran
{!example/stats_distribution_uniform/example_uniform_cdf.f90!}
```

---
title: kinds
---

# The `stdlib_kinds` module

[TOC]

## Introduction

The `stdlib_kinds` module provides kind parameters for the Fortran intrinsic data types,
*integer*, *logical*, *real*, and *complex*.


## Constants provided by `stdlib_kinds`

### `sp`

Single precision real kind parameter.
Provides real kind parameter for floating point numbers with a minimal precision of 6 significant digits.


### `dp`

Double precision real kind parameter.
Provides real kind parameter for floating point numbers with a minimal precision of 15 significant digits.


### `xdp`

Extended double precision real kind parameter.
Provides real kind parameter for floating point numbers with a minimal precision of 18 significant digits.
If not available it has value `-1`.


### `qp`

Quadruple precision real kind parameter.
Provides real kind parameter for floating point numbers with a minimal precision of 33 significant digits.
If not available it has value `-1`.


### `int8`

Reexported intrinsic named constant `int8` from `iso_fortran_env`.


### `int16`

Reexported intrinsic named constant `int16` from `iso_fortran_env`.


### `int32`

Reexported intrinsic named constant `int32` from `iso_fortran_env`.


### `int64`

Reexported intrinsic named constant `int64` from `iso_fortran_env`.


### `lk`

Kind parameter of the default logical data type.


### `c_bool`

Reexported intrinsic named constant `c_bool` from `iso_c_binding`.

---
title: state_type
---

# State and Error Handling Derived Type

[TOC]

## Introduction

The `stdlib_error` module provides a derived type holding information on the state of operations within the standard library and procedures for expert control of workflows.
An optional `state_type` variable to hold such information is provided as a form of expert API.
If the user does not require state information but fatal errors are encountered during execution, the program will undergo a hard stop.
Instead, if the state argument is present, the program will never stop but will return detailed error information into the state handler.

## Derived types provided

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### The `state_type` derived type

The `state_type` is defined as a derived type containing an integer error flag and fixed-size character strings to store an error message and the location of the error state change.
Fixed-size string storage was chosen to facilitate the compiler's memory allocation and ultimately ensure maximum computational performance.  

A similarly named generic interface, `state_type`, is provided to allow the developer to create diagnostic messages and raise error flags easily. 
The call starts with an error flag or the location of the event and is followed by an arbitrary list of `integer`, `real`, `complex`, or `character` variables. 
Numeric variables may be provided as either scalars or rank-1 (array) inputs.

#### Type-bound procedures

The following convenience type-bound procedures are provided:
- `print()` returns an allocatable character string containing state location, message, and error flag;
- `print_message()` returns an allocatable character string containing the state message;
- `ok()` returns a `logical` flag that is `.true.` in case of successful state (`flag==STDLIB_SUCCESS`);
- `error()` returns a `logical` flag that is `.true.` in case of an error state (`flag/=STDLIB_SUCCESS`).

#### Status

Experimental

#### Example

```fortran
{!example/error/example_error_state1.f90!}
```

## Error flags provided

The module provides the following state flags:
- `STDLIB_SUCCESS`: Successful execution
- `STDLIB_VALUE_ERROR`: Numerical errors (such as infinity, not-a-number, range bounds) are encountered.
- `STDLIB_LINALG_ERROR`: Linear Algebra errors are encountered, such as non-converging iterations, impossible operations, etc.
- `STDLIB_INTERNAL_ERROR`: Provided as a developer safeguard for internal errors that should never occur.
- `STDLIB_IO_ERROR`: Input/Output-related errors, such as file reading/writing failures.
- `STDLIB_FS_ERROR`: File system-related errors, such as directory access issues.

## Comparison operators provided

The module provides overloaded comparison operators for all comparisons of a `state_type` variable with an integer error flag: `<`, `<=`, `==`, `>=`, `>`, `/=`.

---
title: linalg_state_type
---

# Linear Algebra -- State and Error Handling Module

[TOC]

## Introduction

The `stdlib_linalg_state` module provides a derived type holding information on the state of linear algebra operations, and procedures for expert control of linear algebra workflows. 
All linear algebra procedures are engineered to support returning an optional `linalg_state_type` variable to hold such information, as a form of expert API. If the user does not require state information but fatal errors are encountered during the execution of linear algebra routines, the program will undergo a hard stop.
Instead, if the state argument is present, the program will never stop but will return detailed error information into the state handler. 

## Derived types provided

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### The `linalg_state_type` derived type

The `linalg_state_type` is an extension of the `state_type` derived type, containing an integer error flag and fixed-size character strings to store an error message and the location of the error state change. 
Fixed-size string storage was chosen to facilitate the compiler's memory allocation and ultimately ensure maximum computational performance.  

A similarly named generic interface, `linalg_state_type`, is provided to allow the developer to create diagnostic messages and raise error flags easily. The call starts with an error flag or the location of the event and is followed by an arbitrary list of `integer`, `real`, `complex`, or `character` variables. Numeric variables may be provided as either scalars or rank-1 (array) inputs. 

#### Type-bound procedures

The following convenience type-bound procedures are inherited from `state_type` and available:
- `print()` returns an allocatable character string containing state location, message, and error flag; 
- `print_message()` returns an allocatable character string containing the state message; 
- `ok()` returns a `logical` flag that is `.true.` in case of successful state (`flag==LINALG_SUCCESS`);
- `error()` returns a `logical` flag that is `.true.` in case of an error state (`flag/=LINALG_SUCCESS`).

#### Status

Experimental

#### Example

```fortran
{!example/linalg/example_state1.f90!}
```

## Error flags provided

The module provides the following state flags, mapped to the general `state_type` error flags: 
- `LINALG_SUCCESS`: Successful execution (equivalent to `STDLIB_SUCCESS`)
- `LINALG_VALUE_ERROR`: Numerical errors (such as infinity, not-a-number, range bounds) are encountered (equivalent to `STDLIB_VALUE_ERROR`).
- `LINALG_ERROR`: Linear Algebra errors are encountered, such as non-converging iterations, and impossible operations (equivalent to `STDLIB_LINALG_ERROR`).
- `LINALG_INTERNAL_ERROR`: Provided as a developer safeguard for internal errors that should never occur (equivalent to `STDLIB_INTERNAL_ERROR`).

## Comparison operators provided

The module provides overloaded comparison operators for all comparisons of a `linalg_state_type` variable with an integer error flag: `<`, `<=`, `==`, `>=`, `>`, `/=`.

---
title: sparse
---

# The `stdlib_sparse` module

[TOC]

## Introduction

The `stdlib_sparse` module provides derived types for standard sparse matrix data structures. It also provides math kernels such as sparse matrix-vector product and conversion between matrix types.

## Sparse matrix derived types

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### The `sparse_type` abstract derived type
#### Status

Experimental

#### Description
The parent `sparse_type` is as an abstract derived type holding the basic common meta data needed to define a sparse matrix, as well as shared APIs. All sparse matrix flavors are extended from the `sparse_type`.

```Fortran
type, public, abstract :: sparse_type
    integer :: nrows   !! number of rows
    integer :: ncols   !! number of columns
    integer :: nnz     !! number of non-zero values
    integer :: storage !! assumed storage symmetry
end type
```

The storage integer label should be assigned from the module's internal enumerator containing the following three enums:

```Fortran
enum, bind(C)
    enumerator :: sparse_full  !! Full Sparse matrix (no symmetry considerations)
    enumerator :: sparse_lower !! Symmetric Sparse matrix with triangular inferior storage
    enumerator :: sparse_upper !! Symmetric Sparse matrix with triangular supperior storage
end enum
```
In the following, all sparse kinds will be presented in two main flavors: a data-less type `<matrix>_type` useful for topological graph operations. And real/complex valued types `<matrix>_<kind>_type` containing the `data` buffer for the matrix values. The following rectangular matrix will be used to showcase how each sparse matrix holds the data internally:

$$ M = \begin{bmatrix} 
    9 & 0 & 0  & 0 & -3 \\
    4 & 7 & 0  & 0 & 0 \\
    0 & 8 & -1 & 8 & 0 \\
    4 & 0 & 5  & 6 & 0 \\
  \end{bmatrix} $$
<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `COO`: The COOrdinates compressed sparse format
#### Status

Experimental

#### Description
The `COO`, triplet or `ijv` format defines all non-zero elements of the matrix by explicitly allocating the `i,j` index and the value of the matrix. While some implementations use separate `row` and `col` arrays for the index, here we use a 2D array in order to promote fast memory acces to `ij`.

```Fortran
type(COO_sp_type) :: COO
call COO%malloc(4,5,10)
COO%data(:)   = real([9,-3,4,7,8,-1,8,4,5,6])
COO%index(1:2,1)  = [1,1]
COO%index(1:2,2)  = [1,5]
COO%index(1:2,3)  = [2,1]
COO%index(1:2,4)  = [2,2]
COO%index(1:2,5)  = [3,2]
COO%index(1:2,6)  = [3,3]
COO%index(1:2,7)  = [3,4]
COO%index(1:2,8)  = [4,1]
COO%index(1:2,9)  = [4,3]
COO%index(1:2,10) = [4,4]
```
<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `CSR`: The Compressed Sparse Row or Yale format
#### Status

Experimental

#### Description
The Compressed Sparse Row or Yale format `CSR` stores the matrix structure by compressing the row indices with a counter pointer `rowptr` enabling to know the first and last non-zero column index `col` of the given row. 

```Fortran
type(CSR_sp_type) :: CSR
call CSR%malloc(4,5,10)
CSR%data(:)   = real([9,-3,4,7,8,-1,8,4,5,6])
CSR%col(:)    = [1,5,1,2,2,3,4,1,3,4]
CSR%rowptr(:) = [1,3,5,8,11]
```
<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `CSC`: The Compressed Sparse Column format
#### Status

Experimental

#### Description
The Compressed Sparse Colum `CSC` is similar to the `CSR` format but values are accesed first by column, thus an index counter is given by `colptr` which enables to know the first and last non-zero row index of a given colum. 

```Fortran
type(CSC_sp_type) :: CSC
call CSC%malloc(4,5,10)
CSC%data(:)   = real([9,4,4,7,8,-1,5,8,6,-3])
CSC%row(:)    = [1,2,4,2,3,3,4,3,4,1]
CSC%colptr(:) = [1,4,6,8,10,11]
```
<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `ELLPACK`: ELL-pack storage format
#### Status

Experimental

#### Description
The `ELL` format stores data in a dense matrix of $nrows \times K$ in column major order. By imposing a constant number of elements per row $K$, this format will incur in additional zeros being stored, but it enables efficient vectorization as memory acces is carried out by constant sized strides. 

```Fortran
type(ELL_sp_type) :: ELL
call ELL%malloc(num_rows=4,num_cols=5,num_nz_row=3)
ELL%data(1,1:3)   = real([9,-3,0])
ELL%data(2,1:3)   = real([4,7,0])
ELL%data(3,1:3)   = real([8,-1,8])
ELL%data(4,1:3)   = real([4,5,6])

ELL%index(1,1:3) = [1,5,0]
ELL%index(2,1:3) = [1,2,0]
ELL%index(3,1:3) = [2,3,4]
ELL%index(4,1:3) = [1,3,4]
```
<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `SELL-C`: The Sliced ELLPACK with Constant blocks format
#### Status

Experimental

#### Description
The Sliced ELLPACK format `SELLC` is a variation of the `ELLPACK` format. This modification reduces the storage size compared to the `ELLPACK` format but maintaining its efficient data access scheme. It can be seen as an intermediate format between `CSR` and `ELLPACK`. For more details read [the reference](https://arxiv.org/pdf/1307.6209v1)

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
## `add`- sparse matrix data accessors

### Status

Experimental

### Description
Type-bound procedures to enable adding data in a sparse matrix.

### Syntax

`call matrix%add(i,j,v)` or
`call matrix%add(i(:),j(:),v(:,:))`

### Arguments

`i`: Shall be an integer value or rank-1 array. It is an `intent(in)` argument.

`j`: Shall be an integer value or rank-1 array. It is an `intent(in)` argument.

`v`: Shall be a `real` or `complex` value or rank-2 array. The type shall be in accordance to the declared sparse matrix object. It is an `intent(in)` argument.

## `at`- sparse matrix data accessors

### Status

Experimental

### Description
Type-bound procedures to enable requesting data from a sparse matrix.

### Syntax

`v = matrix%at(i,j)`

### Arguments

`i` : Shall be an integer value. It is an `intent(in)` argument.

`j` : Shall be an integer value. It is an `intent(in)` argument.

`v` : Shall be a `real` or `complex` value in accordance to the declared sparse matrix object. If the `ij` tuple is within the sparse pattern, `v` contains the value in the data buffer. If the `ij` tuple is outside the sparse pattern, `v` is equal `0`. If the `ij` tuple is outside the matrix pattern `(nrows,ncols)`, `v` is `NaN`.

### Example
```fortran
{!example/linalg/example_sparse_data_accessors.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
## `spmv` - Sparse Matrix-Vector product

### Status

Experimental

### Description

Provide sparse matrix-vector product kernels for the current supported sparse matrix types.

$$y=\alpha*op(M)*x+\beta*y$$

### Syntax

`call ` [[stdlib_sparse_spmv(module):spmv(interface)]] `(matrix,vec_x,vec_y [,alpha,beta,op])`

### Arguments

`matrix`: Shall be a `real` or `complex` sparse type matrix. It is an `intent(in)` argument.

`vec_x`: Shall be a rank-1 or rank-2 array of `real` or `complex` type array. It is an `intent(in)` argument.

`vec_y`: Shall be a rank-1 or rank-2 array of `real` or `complex` type array. . It is an `intent(inout)` argument.

`alpha`, `optional` : Shall be a scalar value of the same type as `vec_x`. Default value `alpha=1`. It is an `intent(in)` argument.

`beta`, `optional` : Shall be a scalar value of the same type as `vec_x`. Default value `beta=0`. It is an `intent(in)` argument.

`op`, `optional`: In-place operator identifier. Shall be a `character(1)` argument. It can have any of the following values: `N`: no transpose, `T`: transpose, `H`: hermitian or complex transpose. These values are provided as constants by the `stdlib_sparse` module: `sparse_op_none`, `sparse_op_transpose`, `sparse_op_hermitian`

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
## Sparse matrix to matrix conversions

### Status

Experimental

### Description

This module provides facility functions for converting between storage formats.

### Syntax

`call ` [[stdlib_sparse_conversion(module):coo2ordered(interface)]] `(coo[,sort_data])`

### Arguments

`COO` : Shall be any `COO` type. The same object will be returned with the arrays reallocated to the correct size after removing duplicates. It is an `intent(inout)` argument.

`sort_data`, `optional` : Shall be a `logical` argument to determine whether data in the COO graph should be sorted while sorting the index array, default `.false.`. It is an `intent(in)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):from_ijv(interface)]] `(sparse,row,col[,data,nrows,ncols,num_nz_rows,chunk])`

### Arguments

`sparse` : Shall be a `COO`, `CSR`, `ELL` or `SELLC` type. The graph object will be returned with a canonical shape after sorting and removing duplicates from the `(row,col,data)` triplet. If the graph is `COO_type` no data buffer is allowed. It is an `intent(inout)` argument.

`row` : rows index array. It is an `intent(in)` argument.

`col` : columns index array. It is an `intent(in)` argument.

`data`, `optional`: `real` or `complex` data array. It is an `intent(in)` argument.

`nrows`, `optional`: number of rows, if not given it will be computed from the `row` array. It is an `intent(in)` argument.

`ncols`, `optional`: number of columns, if not given it will be computed from the `col` array. It is an `intent(in)` argument.

`num_nz_rows`, `optional`: number of non zeros per row, only valid in the case of an `ELL` matrix, by default it will computed from the largest row. It is an `intent(in)` argument.

`chunk`, `optional`: chunk size, only valid in the case of a `SELLC` matrix, by default it will be taken from the `SELLC` default attribute chunk size. It is an `intent(in)` argument.

### Example
```fortran
{!example/linalg/example_sparse_from_ijv.f90!}
```
### Syntax

`call ` [[stdlib_sparse_conversion(module):diag(interface)]] `(matrix,diagonal)`

### Arguments

`matrix` : Shall be a `dense`, `COO`, `CSR` or `ELL` type. It is an `intent(in)` argument.

`diagonal` : A rank-1 array of the same type as the `matrix`. It is an `intent(inout)` and `allocatable` argument.

#### Note
If the `diagonal` array has not been previously allocated, the `diag` subroutine will allocate it using the `nrows` of the `matrix`.

### Syntax

`call ` [[stdlib_sparse_conversion(module):dense2coo(interface)]] `(dense,coo)`

### Arguments

`dense` : Shall be a rank-2 array of `real` or `complex` type. It is an `intent(in)` argument.

`coo` : Shall be a `COO` type of `real` or `complex` type. It is an `intent(out)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):coo2dense(interface)]] `(coo,dense)`

### Arguments

`coo` : Shall be a `COO` type of `real` or `complex` type. It is an `intent(in)` argument.

`dense` : Shall be a rank-2 array of `real` or `complex` type. It is an `intent(out)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):coo2csr(interface)]] `(coo,csr)`

### Arguments

`coo` : Shall be a `COO` type of `real` or `complex` type. It is an `intent(in)` argument.

`csr` : Shall be a `CSR` type of `real` or `complex` type. It is an `intent(out)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):coo2csc(interface)]] `(coo,csc)`

### Arguments

`coo` : Shall be a `COO` type of `real` or `complex` type. It is an `intent(in)` argument.

`csc` : Shall be a `CSC` type of `real` or `complex` type. It is an `intent(out)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):csr2coo(interface)]] `(csr,coo)`

### Arguments

`csr` : Shall be a `CSR` type of `real` or `complex` type. It is an `intent(in)` argument.

`coo` : Shall be a `COO` type of `real` or `complex` type. It is an `intent(out)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):csr2sellc(interface)]] `(csr,sellc[,chunk])`

### Arguments

`csr` : Shall be a `CSR` type of `real` or `complex` type. It is an `intent(in)` argument.

`sellc` : Shall be a `SELLC` type of `real` or `complex` type. It is an `intent(out)` argument.

`chunk`, `optional`: chunk size for the Sliced ELLPACK format. It is an `intent(in)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):csr2sellc(interface)]] `(csr,ell[,num_nz_rows])`

### Arguments

`csr` : Shall be a `CSR` type of `real` or `complex` type. It is an `intent(in)` argument.

`ell` : Shall be a `ELL` type of `real` or `complex` type. It is an `intent(out)` argument.

`num_nz_rows`, `optional`: number of non zeros per row. If not give, it will correspond to the size of the longest row in the `CSR` matrix. It is an `intent(in)` argument.

### Syntax

`call ` [[stdlib_sparse_conversion(module):csc2coo(interface)]] `(csc,coo)`

### Arguments

`csc` : Shall be a `CSC` type of `real` or `complex` type. It is an `intent(in)` argument.

`coo` : Shall be a `COO` type of `real` or `complex` type. It is an `intent(out)` argument.

### Example
```fortran
{!example/linalg/example_sparse_spmv.f90!}
```

---
title: system
---

# System and sub-processing module

The `stdlib_system` module provides interface for interacting with external processes, enabling the execution 
and monitoring of system commands or applications directly from Fortran. 

[TOC]

## `run` - Execute an external process synchronously

### Status

Experimental

### Description

The `run` interface allows execution of external processes using a single command string or a list of arguments.  
Processes run synchronously, meaning execution is blocked until the process finishes.  
Optional arguments enable the collection of standard output and error streams, as well as sending input via standard input. 
Additionally, a callback function can be specified to execute upon process completion, optionally receiving a user-defined payload.

### Syntax

`process = ` [[stdlib_system(module):run(interface)]] `(args [, stdin] [, want_stdout] [, want_stderr] [, callback] [, payload])`

### Arguments

`args`: Shall be a `character(*)` string (for command-line execution) or a `character(*), dimension(:)` array (for argument-based execution). It specifies the command and arguments to execute. This is an `intent(in)` argument.

`stdin` (optional): Shall be a `character(*)` value containing input to send to the process via standard input (pipe). This is an `intent(in)` argument.

`want_stdout` (optional): Shall be a `logical` flag. If `.true.`, the standard output of the process will be captured; if `.false.` (default), it will be lost. This is an `intent(in)` argument.

`want_stderr` (optional): Shall be a `logical` flag. If `.true.`, the standard error output of the process will be captured. If `.false.` (default), it will be lost. This is an `intent(in)` argument.

`callback` (optional): Shall be a procedure conforming to the `process_callback` interface. If present, this function will be called upon process completion with the process ID, exit state, and optionally collected standard input, output, and error streams. This is an `intent(in)` argument.

`payload` (optional): Shall be a generic (`class(*)`) scalar that will be passed to the callback function upon process completion. It allows users to associate custom data with the process execution. This is an `intent(inout), target` argument.

### Return Value

Returns an object of type `process_type` that contains information about the state of the created process.

### Example

```fortran
! Example usage with command line or list of arguments
type(process_type) :: p

! Run a simple command line synchronously
p = run("echo 'Hello, world!'", want_stdout=.true.)
```

## `runasync` - Execute an external process asynchronously

### Status

Experimental

### Description

The `runasync` interface allows execution of external processes using a single command string or a list of arguments.  
Processes are run asynchronously (non-blocking), meaning execution does not wait for the process to finish.  
Optional arguments enable the collection of standard output and error streams, as well as sending input via standard input.
Additionally, a callback function can be specified to execute upon process completion, optionally receiving a user-defined payload.

### Syntax

`process = ` [[stdlib_system(module):runasync(interface)]] `(args [, stdin] [, want_stdout] [, want_stderr] [, callback] [, payload])`

### Arguments

`args`: Shall be a `character(*)` string (for command-line execution) or a `character(*), dimension(:)` array (for argument-based execution). It specifies the command and arguments to execute. This is an `intent(in)` argument.

`stdin` (optional): Shall be a `character(*)` value containing input to send to the process via standard input (pipe). This is an `intent(in)` argument.

`want_stdout` (optional): Shall be a `logical` flag. If `.true.`, the standard output of the process will be captured; if `.false.` (default), it will be lost. This is an `intent(in)` argument.

`want_stderr` (optional): Shall be a `logical` flag. If `.true.`, the standard error output of the process will be captured. Default: `.false.`. This is an `intent(in)` argument.

`callback` (optional): Shall be a procedure conforming to the `process_callback` interface. If present, this function will be called upon process completion with the process ID, exit state, and optionally collected standard input, output, and error streams. This is an `intent(in)` argument.

`payload` (optional): Shall be a generic (`class(*)`) scalar that will be passed to the callback function upon process completion. It allows users to associate custom data with the process execution. This is an `intent(inout), target` argument.

### Return Value

Returns an object of type `process_type` that contains information about the state of the created process.

### Example

```fortran
{!example/system/example_process_1.f90!}
```

## `is_running` - Check if a process is still running

### Status

Experimental

### Description

The `is_running` interface provides a method to check if an external process is still running.  
This is useful for monitoring the status of asynchronous processes created with the `run` interface.

### Syntax

`status = ` [[stdlib_system(module):is_running(interface)]] `(process)`

### Arguments

`process`:  Shall be a `type(process_type)` object representing the external process to check. This is an `intent(inout)` argument.


### Return Value

Returns a `logical` value: `.true.` if the process is still running, or `.false.` if the process has terminated.
After a call to `is_running`, the `type(process_type)` structure is also updated to the latest process state.

### Example

```fortran
{!example/system/example_process_2.f90!}
```

## `is_completed` - Check if a process has completed execution

### Status

Experimental

### Description

The `is_completed` interface provides a method to check if an external process has finished execution.  
This is useful for determining whether asynchronous processes created with the `run` interface have terminated.

### Syntax

`status = ` [[stdlib_system(module):is_completed(interface)]] `(process)`

### Arguments

`process`: Shall be a `type(process_type)` object representing the external process to check. This is an `intent(inout)` argument.

### Return Value

Returns a `logical` value:  
- `.true.` if the process has completed.  
- `.false.` if the process is still running.  

After a call to `is_completed`, the `type(process_type)` structure is updated to reflect the latest process state.

### Example

```fortran
{!example/system/example_process_1.f90!}
```

## `elapsed` - Return process lifetime in seconds

### Status

Experimental

### Description

The `elapsed` interface provides a method to calculate the total time that has elapsed since a process was started.  
This is useful for tracking the duration of an external process or for performance monitoring purposes.  

The result is a real value representing the elapsed time in seconds, measured from the time the process was created.

### Syntax

`delta_t = ` [[stdlib_system(module):elapsed(interface)]] `(process)`

### Arguments

`process`: Shall be a `type(process_type)` object representing the external process. It is an `intent(in)` argument.

### Return Value

Returns a `real(real64)` value that represents the elapsed time (in seconds) since the process was started.  
If the process is still running, the value returned is the time elapsed until the call to this function. 
Otherwise, the total process duration from creation until completion is returned.

### Example

```fortran
{!example/system/example_process_3.f90!}
```

## `wait` - Wait until a running process is completed

### Status

Experimental

### Description

The `wait` interface provides a method to block the calling program until the specified process completes.  
If the process is running asynchronously, this subroutine will pause the workflow until the given process finishes.  
Additionally, an optional maximum wait time can be provided. If the process does not finish within the specified time, 
the subroutine will return without waiting further.

On return from this routine, the process state is accordingly updated.
This is useful when you want to wait for a background task to complete, but want to avoid indefinite blocking 
in case of process hang or delay.


### Syntax

`call ` [[stdlib_system(module):wait(interface)]] `(process [, max_wait_time])`

### Arguments

`process`: Shall be a `type(process_type)` object representing the external process to monitor.  
This is an `intent(inout)` argument, and its state is updated upon completion.

`max_wait_time` (optional): Shall be a `real` value specifying the maximum wait time in seconds.  
If not provided, the subroutine will wait indefinitely until the process completes.

### Example

```fortran
{!example/system/example_process_2.f90!}
```

## `update` - Update the internal state of a process

### Status

Experimental

### Description

The `update` interface allows the internal state of a process object to be updated by querying the system.  
After the process completes, the standard output and standard error are retrieved, if they were requested, and loaded into the `process%stdout` and `process%stderr` string variables, respectively.

This is especially useful for monitoring asynchronous processes and retrieving their output after they have finished.

### Syntax

`call ` [[stdlib_system(module):update(interface)]] `(process)`

### Arguments

`process`: Shall be a `type(process_type)` object representing the external process whose state needs to be updated.  
This is an `intent(inout)` argument, and its internal state is updated on completion.

### Example

```fortran
{!example/system/example_process_5.f90!}
```

## `kill` - Terminate a running process

### Status

Experimental

### Description

The `kill` interface is used to terminate a running external process. It attempts to stop the process and returns a boolean flag indicating whether the operation was successful.
This interface is useful when a process needs to be forcefully stopped, for example, if it becomes unresponsive or if its execution is no longer required.

### Syntax

`call ` [[stdlib_system(module):kill(interface)]] `(process, success)`

### Arguments

`process`: Shall be a `type(process_type)` object representing the external process to be terminated.  
This is an `intent(inout)` argument, and on return is updated with the terminated process state.

`success`: Shall be a `logical` variable. It is set to `.true.` if the process was successfully killed, or `.false.` otherwise.

### Example

```fortran
{!example/system/example_process_4.f90!}
```

## `sleep` - Pause execution for a specified time in milliseconds

### Status

Experimental

### Description

The `sleep` interface pauses the execution of a program for a specified duration, given in milliseconds. 
This routine acts as a cross-platform wrapper, abstracting the underlying platform-specific sleep implementations. 
It ensures that the requested sleep duration is honored on both Windows and Unix-like systems.

### Syntax

`call ` [[stdlib_system(module):sleep(interface)]] `(millisec)`

### Arguments

`millisec`: Shall be an `integer` representing the number of milliseconds to sleep. This is an `intent(in)` argument.

### Example

```fortran
{!example/system/example_sleep.f90!}
```

## `is_windows` - Check if the system is running on Windows

### Status

Experimental

### Description

The `is_windows` interface provides a quick, compile-time check to determine if the current system is Windows. 
It leverages a C function that checks for the presence of the `_WIN32` macro, which is defined in C compilers when targeting Windows. 
This function is highly efficient and works during the compilation phase, avoiding the need for runtime checks.

### Syntax

`result = ` [[stdlib_system(module):is_windows(interface)]] `()`

### Return Value

Returns a `logical` flag: `.true.` if the system is Windows, or `.false.` otherwise.

### Example

```fortran
{!example/system/example_process_1.f90!}
```

## `get_runtime_os` - Determine the OS type at runtime

### Status

Experimental

### Description

`get_runtime_os` inspects the runtime environment to identify the current OS type. It evaluates environment variables (`OSTYPE`, `OS`) and checks for specific files associated with known operating systems.
The supported OS types are `integer, parameter` variables stored in the `stdlib_system` module:

- **Linux** (`OS_LINUX`)
- **macOS** (`OS_MACOS`)
- **Windows** (`OS_WINDOWS`)
- **Cygwin** (`OS_CYGWIN`)
- **Solaris** (`OS_SOLARIS`)
- **FreeBSD** (`OS_FREEBSD`)
- **OpenBSD** (`OS_OPENBSD`)

If the OS cannot be identified, the function returns `OS_UNKNOWN`.

### Syntax

`os = ` [[stdlib_system(module):get_runtime_os(function)]] `()`

### Class

Function

### Arguments

None.

### Return Value

Returns one of the `integer` `OS_*` parameters representing the OS type, from the `stdlib_system` module, or `OS_UNKNOWN` if undetermined.

### Example

```fortran
{!example/system/example_get_runtime_os.f90!}
```

---

## `OS_TYPE` - Cached OS type retrieval

### Status

Experimental

### Description

`OS_TYPE` provides a cached result of the `get_runtime_os` function. The OS type is determined during the first invocation and stored in a static variable. 
Subsequent calls reuse the cached value, making this function highly efficient.

This caching mechanism ensures negligible overhead for repeated calls, unlike `get_runtime_os`, which performs a full runtime inspection.

### Syntax

`os = ` [[stdlib_system(module):OS_TYPE(function)]]`()`

### Class

Function

### Arguments

None.

### Return Value

Returns one of the `integer` `OS_*` parameters representing the OS type, from the `stdlib_system` module, or `OS_UNKNOWN` if undetermined.

### Example

```fortran
{!example/system/example_os_type.f90!}
```

---

## `FS_ERROR` - Helper function for error handling

### Status

Experimental

### Description

A helper function for returning the `type(state_type)` with the flag `STDLIB_FS_ERROR` set.

### Syntax

`err = FS_ERROR([a1,a2,a3,a4...... a20])`

### Class
Pure Function

### Arguments

`a1,a2,a3.....a20`(optional): They are of type `class(*), dimension(..), optional, intent(in)`. 
An arbitrary list of `integer`, `real`, `complex`, `character` or `string_type` variables. Numeric variables may be provided as either scalars or rank-1 (array) inputs.

### Behavior

Formats all the arguments into a nice error message, utilizing the constructor of [[stdlib_system(module):state_type(type)]]

### Return values

`type(state_type)`

### Example

```fortran
{!example/system/example_fs_error.f90!}
```

---

## `FS_ERROR_CODE` - Helper function for error handling (with error code)

### Status

Experimental

### Description

A helper function for returning the `type(state_type)` with the flag `STDLIB_FS_ERROR` set.
It also formats and prefixes the `code` passed to it as the first argument.

### Syntax

`err = FS_ERROR_CODE(code [, a1,a2,a3,a4...... a19])`

### Class
Pure Function

### Arguments

`code`: An `integer` code.

`a1,a2,a3.....a19`(optional): They are of type `class(*), dimension(..), optional, intent(in)`.
An arbitrary list of `integer`, `real`, `complex`, `character` or `string_type` variables. Numeric variables may be provided as either scalars or rank-1 (array) inputs.

### Behavior

Formats all the arguments into a nice error message, utilizing the constructor of [[stdlib_system(module):state_type(type)]]

### Return values

`type(state_type)`

### Example

```fortran
{!example/system/example_fs_error.f90!}
```

---

## `is_file` - Test if a path is a regular file

### Status

Experimental

### Description

This function checks if a specified file system path is a regular file. 
It follows symbolic links and returns the status of the `target`.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`result = ` [[stdlib_system(module):is_file(function)]]`(path)`

### Class

Function

### Arguments

`path`: Shall be a character string containing the file system path to evaluate. It is an `intent(in)` argument.

### Return values

The function returns a `logical` value:

- `.true.` if the path matches an existing regular file.
- `.false.` otherwise, or if path does not exist.

### Example

```fortran
{!example/system/example_is_file.f90!}
```

---

## `is_directory` - Test if a path is a directory

### Status

Experimental

### Description

This function checks if a specified file system path is a directory. 
It follows symbolic links and returns the status of the `target`.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`result = ` [[stdlib_system(module):is_directory(function)]]`(path)`

### Class

Function

### Arguments

`path`: Shall be a character string containing the file system path to evaluate. It is an `intent(in)` argument.

### Return values

The function returns a `logical` value:

- `.true.` if the path matches an existing directory.
- `.false.` otherwise, or if the operating system is unsupported.

### Example

```fortran
{!example/system/example_is_directory.f90!}
```

---

## `is_symlink` - Test if a path is a symbolic link.

### Status

Experimental

### Description

This function checks if a specified file system path is a symbolic link to either a file or a directory.
Use [[stdlib_system(module):is_file(function)]] and [[stdlib_system(module):is_directory(function)]] functions
to check further if the link is to a file or a directory respectively.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`result = ` [[stdlib_system(module):is_symlink(function)]]`(path)`

### Class

Function

### Arguments

`path`: Shall be a character string containing the file system path to evaluate. It is an `intent(in)` argument.

### Return values

The function returns a `logical` value:

- `.true.` if the path matches an existing regular file.
- `.false.` otherwise, or if the path does not exist.

### Example

```fortran
{!example/system/example_is_symlink.f90!}
```

---

## `make_directory` - Creates an empty directory

### Status

Experimental

### Description

It creates an empty directory with default permissions.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`call [[stdlib_system(module):make_directory(subroutine)]] (path [,err])`

### Class

Subroutine

### Arguments

`path`: Shall be a character string containing the path of the directory to create. It is an `intent(in)` argument.

`err`(optional): Shall be of type `state_type`, and is used for error handling. It is an `optional, intent(out)` argument.

### Return values

`err` is an optional state return flag. If not requested and an error occurs, an `FS_ERROR` will trigger an error stop.

### Example

```fortran
{!example/system/example_make_directory.f90!}
```

---

## `make_directory_all` - Creates an empty directory with all its parent directories

### Status

Experimental

### Description

It creates an empty directory with default permissions.
It also creates all the necessary parent directories in the path if they do not exist already.

### Syntax

`call [[stdlib_system(module):make_directory_all(subroutine)]] (path [,err])`

### Class

Subroutine

### Arguments

`path`: Shall be a character string containing the path of the directory to create. It is an `intent(in)` argument.

`err`(optional): Shall be of type `state_type`, and is used for error handling. It is an `optional, intent(out)` argument.

### Return values

`err` is an optional state return flag. If not requested and an error occurs, an `FS_ERROR` will trigger an error stop.

### Example

```fortran
{!example/system/example_make_directory.f90!}
```

---

## `remove_directory` - Removes an empty directory

### Status

Experimental

### Description

It deletes an empty directory.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`call [[stdlib_system(module):remove_directory(subroutine)]] (path, err)`

### Class

Subroutine

### Arguments

`path`: Shall be a character string containing the path of the directory to create. It is an `intent(in)` argument.

`err`(optional): Shall be of type `state_type`, and is used for error handling. It is an `optional, intent(out)` argument.

### Return values

`err` is an optional state return flag. On error if not requested, an `FS_ERROR` will trigger an error stop.

### Example

```fortran
{!example/system/example_remove_directory.f90!}
```

---

## `get_cwd` - Gets the current working directory

### Status

Experimental

### Description

This subroutine retrieves the current working directory the running process is executing from.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`call [[stdlib_system(module):get_cwd(subroutine)]] (cwd [, err])`

### Class

Subroutine

### Arguments

`cwd`: Shall be a character string for receiving the path of the current working directory (cwd). It is an `intent(out)` argument.

`err`(optional): Shall be of type `state_type`, and is used for error handling. It is an `intent(out)` argument.

### Return values

`err` is an optional state return flag. On error if not requested, an `FS_ERROR` will trigger an error stop.

### Example

```fortran
{!example/system/example_cwd.f90!}
```

---

## `set_cwd` - Sets the current working directory

### Status

Experimental

### Description

This subrotine sets the current working directory the process is executing from.
It is designed to work across multiple platforms. On Windows, paths with both forward `/` and backward `\` slashes are accepted.

### Syntax

`call [[stdlib_system(module):set_cwd(subroutine)]] (path [, err])`

### Class

Subroutine

### Arguments

`path`: Shall be a character string containing the path of the directory. It is an `intent(in)` argument.

`err`(optional): Shall be of type `state_type`, and is used for error handling. It is an `intent(out)` argument.

### Return values

`err` is an optional state return flag. On error if not requested, an `FS_ERROR` will trigger an error stop.

### Example

```fortran
{!example/system/example_cwd.f90!}
```

---

## `exists` - Checks if a path exists in the filesystem

### Status

Experimental

### Description

This function makes a system call (syscall) to retrieve metadata for the specified path and determines its type.
It can distinguish between the following path types:

- Regular File
- Directory
- Symbolic Link

It returns a constant representing the detected path type, or `type_unknown` if the type cannot be determined. 
Any encountered errors are handled using `state_type`.

### Syntax

`fs_type = [[stdlib_system(module):exists(function)]] (path [, err])`

### Class

Function

### Arguments

`path`: Shall be a character string containing the path. It is an `intent(in)` argument.

`err`(optional): Shall be of type `state_type`, and is used for error handling. It is an `optional, intent(out)` argument.

### Return values

`fs_type`: An `intent(out), integer` parameter indicating the type. The possible values are:
- `fs_type_unknown`: 0      => an unknown type
- `fs_type_regular_file`: 1 => a regular file
- `fs_type_directory`: 2    => a directory 
- `fs_type_symlink`: 3      => a symbolic link

`err`(optional): It is an optional state return flag. If not requested and an error occurs, an `FS_ERROR` will trigger an error stop.

```fortran
{!example/system/example_exists.f90!}
```

---

## `null_device` - Return the null device file path

### Status

Experimental

### Description

This function returns the file path of the null device, which is a special file used to discard any data written to it. 
It reads as an empty file. The null device's path varies by operating system:
- On Windows, the null device is represented as `NUL`.
- On UNIX-like systems (Linux, macOS), the null device is represented as `/dev/null`.

### Syntax

`path = ` [[stdlib_system(module):null_device(function)]]`()`

### Class

Function

### Arguments

None.

### Return Value

- **Type:** `character(:), allocatable`
- Returns the null device file path as a character string, appropriate for the operating system.

### Example

```fortran
{!example/system/example_null_device.f90!}
```

---

## `delete_file` - Delete a file

### Status

Experimental

### Description

This subroutine deletes a specified file from the filesystem. It ensures that the file exists and is not a directory before attempting deletion.
If the file cannot be deleted due to permissions, being a directory, or other issues, an error is raised. 
The function provides an optional error-handling mechanism via the `state_type` class. If the `err` argument is not provided, exceptions will trigger an `error stop`.

### Syntax

`call ` [[stdlib_system(module):delete_file(subroutine)]]` (path [, err])`

### Class
Subroutine

### Arguments

`path`: Shall be a character string containing the path to the file to be deleted. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(state_type)` variable for error handling. If provided, errors are returned as a state object. If not provided, the program stops execution on error.

### Behavior

- Checks if the file exists. If not, an error is raised.
- Ensures the path is not a directory before deletion.
- Attempts to delete the file, raising an error if unsuccessful.

### Return values

The file is removed from the filesystem if the operation is successful. If the operation fails, an error is raised.

### Example

```fortran
{!example/system/example_delete_file.f90!}
```

---

## `join_path` - Joins the provided paths according to the OS

### Status

Experimental

### Description

This interface joins the paths provided to it according to the platform specific path-separator.
i.e `\` for windows and `/` for others

### Syntax

`res = ` [[stdlib_system(module):join_path(interface)]] ` (p1, p2)`

`res = ` [[stdlib_system(module):join_path(interface)]] ` (p)`

### Class
Pure function

### Arguments

`p1, p2`: Shall be a character string or `type(string_type)`. It is an `intent(in)` argument.
    or
`p`: Shall be a list of character strings or list of `type(string_type)`. It is an `intent(in)` argument.

### Return values

The resultant path, either a character string or `type(string_type)`.

## `operator(/)`

Alternative syntax to`join_path` using an overloaded operator. Join two paths according to the platform specific path-separator.

### Status

Experimental

### Syntax

`p = lval / rval`

### Class

Pure function.

### Arguments

`lval`: A character string or `type(string_type)`. It is an `intent(in)` argument.

`rval`: A character string or `type(string_type)`. It is an `intent(in)` argument.

### Result value

The result is an `allocatable` character string or `type(string_type)`

#### Example

```fortran
{!example/system/example_path_join.f90!}
```

---

## `split_path` - splits a path immediately following the last separator

### Status

Experimental

### Description

This subroutine splits a path immediately following the last separator after removing the trailing separators
splitting it into most of the times a directory and a file name.

### Syntax

`call `[[stdlib_system(module):split_path(interface)]]`(p, head, tail)`

### Class
Subroutine

### Arguments

`p`: A character string or `type(string_type)` containing the path to be split. It is an `intent(in)` argument.
`head`: The first part of the path. Either a character string or `type(string_type)`. It is an `intent(out)` argument.
`tail`: The rest part of the path. Either a character string or `type(string_type)`. It is an `intent(out)` argument.

### Behavior

- If `p` is empty, `head` is set to `.` and `tail` is left empty.
- If `p` consists entirely of path-separators, `head` is set to the path-separator and `tail` is left empty.
- `head` ends with a path-separator if and only if `p` appears to be a root directory or child of one.

### Return values

The splitted path. `head` and `tail`.

### Example

```fortran
{!example/system/example_path_split_path.f90!}
```

---

## `base_name` - The last part of a path

### Status

Experimental

### Description

This function returns the last part of a path after removing trailing path separators.

### Syntax

`res = ` [[stdlib_system(module):base_name(interface)]]`(p)`

### Class
Function

### Arguments

`p`: the path, a character string or `type(string_type)`. It is an `intent(in)` argument.

### Behavior

- The `tail` of `[[stdlib_system(module):split_path(interface)]]` is exactly what is returned. Same Behavior.

### Return values

A character string or `type(string_type)`.

### Example

```fortran
{!example/system/example_path_base_name.f90!}
```

---

## `dir_name` - Everything except the last part of the path

### Status

Experimental

### Description

This function returns everything except the last part of a path.

### Syntax

`res = ` [[stdlib_system(module):dir_name(interface)]]`(p)`

### Class
Function

### Arguments

`p`: the path, a character string or `type(string_type)`. It is an `intent(in)` argument.

### Behavior

- The `head` of `[[stdlib_system(module):split_path(interface)]]` is exactly what is returned. Same Behavior.

### Return values

A character string or `type(string_type)`.

### Example

```fortran
{!example/system/example_path_dir_name.f90!}
```

---
title: terminal colors
...


# The `stdlib_ansi` module

[TOC]

## Introduction

Support terminal escape sequences to produce styled and colored terminal output.


## Derived types provided


### ``ansi_code`` type

The ``ansi_code`` type represent an ANSI escape sequence with a style, foreground
color and background color attribute. By default the instances of this type are
empty and represent no escape sequence.

#### Status

Experimental

#### Example

```fortran
{!example/ansi/example_ansi_color.f90!}
```


## Constants provided

### ``style_reset``

Style enumerator representing a reset escape code.


### ``style_bold``

Style enumerator representing a bold escape code.


### ``style_dim``

Style enumerator representing a dim escape code.


### ``style_italic``

Style enumerator representing an italic escape code.


### ``style_underline``

Style enumerator representing an underline escape code.


### ``style_blink``

Style enumerator representing a blink escape code.


### ``style_blink_fast``

Style enumerator representing a (fast) blink escape code.


### ``style_reverse``

Style enumerator representing a reverse escape code.


### ``style_hidden``

Style enumerator representing a hidden escape code.


### ``style_strikethrough``

Style enumerator representing a strike-through escape code.


### ``fg_color_black``

Foreground color enumerator representing a foreground black color escape code.


### ``fg_color_red``

Foreground color enumerator representing a foreground red color escape code.


### ``fg_color_green``

Foreground color enumerator representing a foreground green color escape code.


### ``fg_color_yellow``

Foreground color enumerator representing a foreground yellow color escape code.


### ``fg_color_blue``

Foreground color enumerator representing a foreground blue color escape code.


### ``fg_color_magenta``

Foreground color enumerator representing a foreground magenta color escape code.


### ``fg_color_cyan``

Foreground color enumerator representing a foreground cyan color escape code.


### ``fg_color_white``

Foreground color enumerator representing a foreground white color escape code.


### ``fg_color_default``

Foreground color enumerator representing a foreground default color escape code.


### ``bg_color_black``

Background color enumerator representing a background black color escape code.


### ``bg_color_red``

Background color enumerator representing a background red color escape code.


### ``bg_color_green``

Background color enumerator representing a background green color escape code.


### ``bg_color_yellow``

Background color enumerator representing a background yellow color escape code.


### ``bg_color_blue``

Background color enumerator representing a background blue color escape code.


### ``bg_color_magenta``

Background color enumerator representing a background magenta color escape code.


### ``bg_color_cyan``

Background color enumerator representing a background cyan color escape code.


### ``bg_color_white``

Background color enumerator representing a background white color escape code.


### ``bg_color_default``

Background color enumerator representing a background default color escape code.


## Procedures and methods provided

### ``to_string``

Generic interface to turn a style, foreground or background enumerator into an actual escape code string for printout.

#### Syntax

`string =` [[stdlib_ansi(module):to_string(interface)]] `(code)`

#### Class

Pure function.

#### Argument

``code``: Style, foreground or background code of ``ansi_code`` type,
          this argument is ``intent(in)``.

#### Result value

The result is a default character string.

#### Status

Experimental

#### Example

```fortran
{!example/ansi/example_ansi_to_string.f90!}
```


### ``operator(+)``

Add two escape sequences, attributes in the right value override the left value ones.

#### Syntax

`code = lval + rval`

#### Class

Pure function.

#### Argument

``lval``: Style, foreground or background code of ``ansi_code`` type,
          this argument is ``intent(in)``.
``rval``: Style, foreground or background code of ``ansi_code`` type,
          this argument is ``intent(in)``.

#### Result value

The result is a style, foreground or background code of ``ansi_code`` type.

#### Status

Experimental

#### Example

```fortran
{!example/ansi/example_ansi_combine.f90!}
```


### ``operator(//)``

Concatenate an escape code with a string and turn it into an actual escape sequence

#### Syntax

`str = lval // rval`

#### Class

Pure function.

#### Argument

``lval``: Style, foreground or background code of ``ansi_code`` type or a character string,
          this argument is ``intent(in)``.
``rval``: Style, foreground or background code of ``ansi_code`` type or a character string,
          this argument is ``intent(in)``.

#### Result value

The result is a character string with the escape sequence prepended or appended.

#### Status

Experimental

#### Example

```fortran
{!example/ansi/example_ansi_concat.f90!}
```

---
title: specialfunctions_gamma
---

# Special functions gamma

[TOC]

## `gamma` - Calculate the gamma function

### Status

Experimental

### Description

The gamma function is defined as the analytic continuation of a convergent improper integral function on the whole complex plane except zero and negative integers:

$$\Gamma(z)=\int_{0}^{\infty}x^{z-1}e^{-x}dx, \;\;  z\in \mathbb{C} \setminus 0, -1, -2, \cdots$$

Fortran 2018 standard implements the intrinsic gamma function of real type argument in single and double precisions. Here the gamma function is extended to both integer and complex arguments. The values of the gamma function with integer arguments are exact. The values of the gamma function with complex arguments are approximated in single and double precisions by using Lanczos approximation.

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):gamma(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: should be a positive integer or a complex type number

### Return value

The function returns a value with the same type and kind as input argument.

### Example
```fortran
{!example/specialfunctions_gamma/example_gamma.f90!}
```

## `log_gamma` - Calculate the natural logarithm of the gamma function

### Status

Experimental

### Description

Mathematically, logarithm of gamma function is a special function with complex arguments by itself. Due to the different branch cut structures and a different principal branch, natural logarithm of gamma function log_gamma(z) with complex argument is different from the ln(Gamma(z)). The two have the same real part but different imaginary part. 

Fortran 2018 standard implements intrinsic log_gamma function of absolute value of real type argument in single and double precision. Here the log_gamma function is extended to both integer and complex arguments. The values of log_gamma function with complex arguments are approximated in single and double precisions by using Stirling's approximation.

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):log_gamma(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a positive integer or a complex type number. 

### Return value

The function returns real single precision values for integer input arguments, while it returns complex values with the same kind as complex input arguments.

### Example

```fortran
{!example/specialfunctions_gamma/example_log_gamma.f90!}
```

## `log_factorial` - calculate the logarithm of a factorial

### Status

Experimental

### Description

Compute the natural logarithm of factorial, log(n!)

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):log_factorial(interface)]] ` (x)`

### Class

Elemental function

### Arguments

`x`: Shall be a positive integer type number. 

### Return value

The function returns real type values with single precision.

### Example
```fortran
{!example/specialfunctions_gamma/example_log_factorial.f90!}
```

## `lower_incomplete_gamma` - calculate lower incomplete gamma integral

### Status

Experimental

### Description

The lower incomplete gamma function is defined as:

$$\gamma(p,x)=\int_{0}^{x}t^{p-1}e^{-t}dt, \;\;  p > 0, x\in \mathbb{R}$$

When x < 0, p must be positive integer.

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):lower_incomplete_gamma(interface)]] ` (p, x)`

### Class

Elemental function

### Arguments

`p`: is a positive integer or real type argument.

`x`: is a real type argument. 

### Return value

The function returns a real type value with the same kind as argument x.

### Example
```fortran
{!example/specialfunctions_gamma/example_ligamma.f90!}
```

## `upper_incomplete_gamma` - calculate the upper incomplete gamma integral

### Status

Experimental

### Description

The upper incomplete gamma function is defined as:

$$\Gamma (p, x) = \int_{x}^{\infty }t^{p-1}e^{-t}dt, \; \; p >0,\; x \in \mathbb{R}$$

When x < 0, p must be a positive integer.

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):upper_incomplete_gamma(interface)]] ` (p, x)`

### Class

Elemental function

### Arguments

`p`: is a positive integer or real type argument.

`x`: is a real type argument. 

### Return value

The function returns a real type value with the same kind as argument x.

### Example
```fortran
{!example/specialfunctions_gamma/example_uigamma.f90!}
```

## `log_lower_incomplete_gamma` - calculate the natural logarithm of the lower incomplete gamma integral

### Status

Experimental

### Description

Compute the natural logarithm of the absolute value of the lower incomplete gamma function.

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):log_lower_incomplete_gamma(interface)]] ` (p, x)`

### Class

Elemental function

### Arguments

`p`: is a positive integer or real type argument.

`x`: is a real type argument. 

### Return value

The function returns a real type value with the same kind as argument x.


## `log_upper_incomplete_gamma` - calculate logarithm of the upper incomplete gamma integral

### Status

Experimental

### Description

Compute the natural logarithm of the absolute value of the upper incomplete gamma function.

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):log_upper_incomplete_gamma(interface)]] ` (p, x)`

### Class

Elemental function

### Arguments

`p`: is a positive integer or real type argument.

`x`: is a real type argument. 

### Return value

The function returns a real type value with the same kind as argument x.


## `regularized_gamma_p` - calculate the gamma quotient P

### Status

Experimental

### Description

The regularized gamma quotient P, also known as normalized incomplete gamma function, is defined as:

$$P(p,x)=\gamma(p,x)/\Gamma(p)$$

The values of regularized gamma P is in the range of [0, 1]

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):regularized_gamma_p(interface)]] ` (p, x)`

### Class

Elemental function

### Arguments

`p`: is a positive integer or real type argument.

`x`: is a real type argument. 

### Return value

The function returns a real type value with the same kind as argument x.

### Example
```fortran
{!example/specialfunctions_gamma/example_gamma_p.f90!}
```

## `regularized_gamma_q` - calculate the gamma quotient Q

### Status

Experimental

### Description

The regularized gamma quotient Q is defined as:

$$Q(p,x)=\Gamma(p,x)/\Gamma(p)=1-P(p,x)$$

The values of regularized gamma Q is in the range of [0, 1]

### Syntax

`result = ` [[stdlib_specialfunctions_gamma(module):regularized_gamma_q(interface)]] ` (p, x)`

### Class

Elemental function

### Arguments

`p`: is a positive integer or real type argument.

`x`: is a real type argument. 

### Return value

The function returns a real type value with the same kind as argument x.

### Example
```fortran
{!example/specialfunctions_gamma/example_gamma_q.f90!}
```

---
title: math
---

# The `stdlib_math` module

[TOC]

## Introduction

`stdlib_math` module provides general purpose mathematical functions.


## Procedures and Methods provided


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `clip` function

#### Description

Returns a value which lies in the given interval [`xmin`, `xmax`] (interval is `xmin` and `xmax` inclusive) and is closest to the input value `x`.

#### Syntax

`res = ` [[stdlib_math(module):clip(interface)]] ` (x, xmin, xmax)`

#### Status

Experimental

#### Class

Elemental function.

#### Argument(s)

`x`: scalar of either `integer` or `real` type. This argument is `intent(in)`.
`xmin`: scalar of either `integer` or `real` type. This argument is `intent(in)`.
`xmax`: scalar of either `integer` or `real` type, which must be greater than or equal to `xmin`. This argument is `intent(in)`.

Note: All arguments must have same `type` and same `kind`.

#### Output value or Result value

The output is a scalar of `type` and `kind` same as to that of the arguments.

#### Examples

##### Example 1:

Here inputs are of type `integer` and kind `int32`
```fortran
{!example/math/example_clip_integer.f90!}
```

##### Example 2:

Here inputs are of type `real` and kind `sp`
```fortran
{!example/math/example_clip_real.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `swap` subroutine

#### Description

Swaps the values in `lhs` and `rhs`.

#### Syntax

`call` [[stdlib_math(module):swap(interface)]] ` (lhs, rhs)`

#### Status

Experimental

#### Class

Elemental subroutine.

#### Argument(s)

`lhs`: scalar or array of any of the intrinsic types `integer`, `real`, `complex`, `logical`, `character`, `string_type`, `bitset` type. This argument is `intent(inout)`.
`rhs`: scalar or array of any of the intrinsic types `integer`, `real`, `complex`, `logical`, `character`, `string_type`, `bitset` type. This argument is `intent(inout)`.

##### Note
All arguments must have same `type` and same `kind`.

**WARNING**: For fix size characters with different length, the `swap` subroutine will truncate the longest amongst `lhs` and `rhs`. To avoid truncation it is possible to pass a subsection of the string.

#### Examples

```fortran
{!example/math/example_math_swap.F90!}
```

### `gcd` function

#### Description

Returns the greatest common divisor of two integers.

#### Syntax

`res = ` [[stdlib_math(module):gcd(interface)]] ` (a, b)`

#### Status

Experimental

#### Class

Elemental function.

#### Argument(s)

`a`: One integer with `intent(in)` to get the divisor for.
`b`: Another integer with `intent(in)` to get the divisor for.

Note: All arguments must be integers of the same `kind`.

#### Output value or Result value

Returns an integer of the same `kind` as that of the arguments.

#### Examples

##### Example 1:

```fortran
{!example/math/example_gcd.f90!}
```

### `linspace` - Create a linearly spaced rank one array

#### Description

Returns a linearly spaced rank 1 array from [`start`, `end`]. Optionally, you can specify the length of the returned array by passing `n`.

#### Syntax

`res = ` [[stdlib_math(module):linspace(interface)]] ` (start, end [, n])`

#### Status

Experimental

#### Class

Pure function.

#### Argument(s)

`start`: Shall be scalar of any numeric type or kind. This argument is `intent(in)`.
`end`: Shall be the same `type` and `kind` as `start`. This argument is `intent(in)`.
`n`: Shall be an integer specifying the length of the output. This argument is `optional` and `intent(in)`.

#### Output value or Result value

The output is a rank 1 array whose length is either 100 (default value) or `n`.

If `n` == 1, return a rank 1 array whose only element is `end`.
If `n` <= 0, return a rank 1 array with length 0.

If `start`/`end` are `real` or `complex` types, the `result` will be of the same type and kind as `start`/`end`.
If `start`/`end` are `integer` types, the `result` will default to a `real(dp)` array.

#### Examples

##### Example 1:

Here inputs are of type `complex` and kind `dp`
```fortran
{!example/math/example_linspace_complex.f90!}
```

##### Example 2:

Here inputs are of type `integer` and kind `int16`, with the result defaulting to `real(dp)`.
```fortran
{!example/math/example_linspace_int16.f90!}
```

### `logspace` - Create a logarithmically spaced rank one array

#### Description

Returns a logarithmically spaced rank 1 array from [`base`^`start`, `base`^`end`]. The default size of the array is 50. Optionally, you can specify the length of the returned array by passing `n`. You can also specify the `base` used to compute the range (default 10).

#### Syntax

`res = ` [[stdlib_math(module):logspace(interface)]] ` (start, end [, n [, base]])`

#### Status

Experimental

#### Class

Pure function.

#### Argument(s)

`start`: Shall be a scalar of any numeric type. All kinds are supported for real and complex arguments. For integers, only the default kind is currently implemented. This argument is `intent(in)`.
`end`: Shall be the same `type` and `kind` as `start`. This argument is `intent(in)`.
`n`: Shall be an integer specifying the length of the output. This argument is `optional` and `intent(in)`.
`base` : Shall be a scalar of any numeric type. All kinds are supported for real and complex arguments. For integers, only the default kind is currently implemented. This argument is `optional` and `intent(in)`.

#### Output value or Result value

The output is a rank 1 array whose length is either 50 (default value) or `n`.

If `n` == 1, return a rank 1 array whose only element is `base`^`end`.
If `n` <= 0, return a rank 1 array with length 0

The `type` and `kind` of the output is dependent on the `type` and `kind` of the passed parameters.

For function calls where the `base` is not specified: `logspace(start, end)`/`logspace(start, end, n)`, the `type` and `kind` of
the output follows the same scheme as above for `linspace`.
>If `start`/`end` are `real` or `complex` types, the `result` will be the same type and kind as `start`/`end`.
>If `start`/`end` are integer types, the `result` will default to a `real(dp)` array.

For function calls where the `base` is specified, the `type` and `kind` of the result is in accordance with the following table:

| `start`/`end` | `n` | `base` | `output` |
| ------------- | --- | ------ | -------- |
| `real(KIND)` | `Integer` | `real(KIND)` | `real(KIND)` |
| "          " | "       " | `complex(KIND)` | `complex(KIND)` |
| "          " | "       " | `Integer` | `real(KIND)` |
| `complex(KIND)` | "       " | `real(KIND)` | `complex(KIND)` |
| "             " | "       " | `complex(KIND)` | `complex(KIND)` |
| "             " | "       " | `Integer` | `complex(KIND)` |
| `Integer` | "        " | `real(KIND)` | `real(KIND)` |
| "              " | "        " | `complex(KIND)` | `complex(KIND)` |
| "              " | "        " | `Integer` | `Integer` |

#### Examples

##### Example 1:

Here inputs are of type `complex` and kind `dp`. `n` and `base` is not specified and thus default to 50 and 10, respectively.
```fortran
{!example/math/example_logspace_complex.f90!}
```

##### Example 2:

Here inputs are of type `integer` and default kind. `base` is not specified and thus defaults to 10.
```fortran
{!example/math/example_logspace_int.f90!}
```

##### Example 3:

Here `start`/`end` are of type `real` and double precision. `base` is type `complex` and also double precision.
```fortran
{!example/math/example_logspace_rstart_cbase.f90!}
```
### `arange` function

#### Status

Experimental

#### Class

Pure function.

#### Description

Creates a rank-1 `array` of the `integer/real` type with fixed-spaced values of given spacing, within a given interval.

#### Syntax

`result = ` [[stdlib_math(module):arange(interface)]] `(start [, end, step])`

#### Arguments

All arguments should be the same type and kind.

`start`: Shall be an `integer/real` scalar.
This is an `intent(in)` argument.  
The default `start` value is `1`.

`end`: Shall be an `integer/real` scalar.
This is an `intent(in)` and `optional` argument.  
The default `end` value is the inputted `start` value.

`step`: Shall be an `integer/real` scalar and large than `0`. 
This is an `intent(in)` and `optional` argument.   
The default `step` value is `1`.

##### Warning
If `step = 0`, the `step` argument will be corrected to `1/1.0` by the internal process of the `arange` function.   
If `step < 0`, the `step` argument will be corrected to `abs(step)` by the internal process of the `arange` function. 

#### Return value

Returns a rank-1 `array` of fixed-spaced values.

For `integer` type arguments, the length of the result vector is `(end - start)/step + 1`.  
For `real` type arguments, the length of the result vector is `floor((end - start)/step) + 1`.

#### Example

```fortran
{!example/math/example_math_arange.f90!}
```

### `arg` function

#### Status

Experimental

#### Class

Elemental function.

#### Description

`arg` computes the phase angle (radian version) of `complex` scalar in the interval (-π,π]. 
The angles in `θ` are such that `z = abs(z)*exp((0.0, θ))`.

#### Syntax

`result = ` [[stdlib_math(module):arg(interface)]] `(z)`

#### Arguments

`z`: Shall be a `complex` scalar/array.
This is an `intent(in)` argument.

#### Return value

Returns the `real` type phase angle (radian version) of the `complex` argument `z`.

Notes: Although the angle of the complex number `0` is undefined, `arg((0,0))` returns the value `0`.

#### Example

```fortran
{!example/math/example_math_arg.f90!}
```

### `argd` function

#### Status

Experimental

#### Class

Elemental function.

#### Description

`argd` computes the phase angle (degree version) of `complex` scalar in the interval (-180.0,180.0]. 
The angles in `θ` are such that `z = abs(z)*exp((0.0, θ*π/180.0))`.

#### Syntax

`result = ` [[stdlib_math(module):argd(interface)]] `(z)`

#### Arguments

`z`: Shall be a `complex` scalar/array.
This is an `intent(in)` argument.

#### Return value

Returns the `real` type phase angle (degree version) of the `complex` argument `z`.

Notes: Although the angle of the complex number `0` is undefined, `argd((0,0))` returns the value `0`.

#### Example

```fortran
{!example/math/example_math_argd.f90!}
```

### `argpi` function

#### Status

Experimental

#### Class

Elemental function.

#### Description

`argpi` computes the phase angle (IEEE circular version) of `complex` scalar in the interval (-1.0,1.0]. 
The angles in `θ` are such that `z = abs(z)*exp((0.0, θ*π))`.

#### Syntax

`result = ` [[stdlib_math(module):argpi(interface)]] `(z)`

#### Arguments

`z`: Shall be a `complex` scalar/array.
This is an `intent(in)` argument.

#### Return value

Returns the `real` type phase angle (circular version) of the `complex` argument `z`.

Notes: Although the angle of the complex number `0` is undefined, `argpi((0,0))` returns the value `0`.

#### Example

```fortran
{!example/math/example_math_argpi.f90!}
```

### `deg2rad`

#### Status

Experimental

#### Class

Elemenal function.

#### Description

`deg2rad` converts phase angles from degrees to radians.

#### Syntax

`result = ` [[stdlib_math(module):deg2rad(interface)]] `(theta)`

#### Arguments

`theta`: Shall be a `real` scalar/array.

#### Return value

Returns the `real` phase angle in radians.

#### Example

```fortran
{!example/math/example_math_deg2rad.f90!}
```

### `rad2deg`

#### Status

Experimental

#### Class

Elemenal function.

#### Description

`rad2deg` converts phase angles from radians to degrees.

#### Syntax

`result = ` [[stdlib_math(module):rad2deg(interface)]] `(theta)`

#### Arguments

`theta`: Shall be a `real` scalar/array.

#### Return value

Returns the `real` phase angle in degrees.

#### Example

```fortran
{!example/math/example_math_rad2deg.f90!}
```

### `is_close` function

#### Description

Returns a boolean scalar/array where two scalars/arrays are element-wise equal within a tolerance.

```fortran
!> For `real` type
is_close(a, b, rel_tol, abs_tol) = abs(a - b) <= max(rel_tol*(abs(a), abs(b)), abs_tol)

!> and for `complex` type
is_close(a, b, rel_tol, abs_tol) = is_close(a%re, b%re, rel_tol, abs_tol) .and. &
                                   is_close(a%im, b%im, rel_tol, abs_tol)
```

#### Syntax

`bool = ` [[stdlib_math(module):is_close(interface)]] ` (a, b [, rel_tol, abs_tol, equal_nan])`

#### Status

Experimental.

#### Class

Elemental function.

#### Arguments

Note: All `real/complex` arguments must have same `kind`.  
If the value of `rel_tol/abs_tol` is negative (not recommended), 
it will be corrected to `abs(rel_tol/abs_tol)` by the internal process of `is_close`.

`a`: Shall be a `real/complex` scalar/array.
This argument is `intent(in)`.

`b`: Shall be a `real/complex` scalar/array.
This argument is `intent(in)`.

`rel_tol`: Shall be a `real` scalar/array.
This argument is `intent(in)` and `optional`, which is `sqrt(epsilon(..))` by default.

`abs_tol`: Shall be a `real` scalar/array.
This argument is `intent(in)` and `optional`, which is `0.0` by default.

`equal_nan`: Shall be a `logical` scalar/array.
This argument is `intent(in)` and `optional`, which is `.false.` by default.
Whether to compare `NaN` values as equal. If `.true.`, 
`NaN` values in `a` will be considered equal to `NaN` values in `b`.

#### Result value

Returns a `logical` scalar/array.

#### Example

```fortran
{!example/math/example_math_is_close.f90!}
```

### `all_close` function

#### Description

Returns a boolean scalar where two arrays are element-wise equal within a tolerance.

#### Syntax

`bool = ` [[stdlib_math(module):all_close(interface)]] ` (a, b [, rel_tol, abs_tol, equal_nan])`

#### Status

Experimental.

#### Class

Pure function.

#### Arguments

Note: All `real/complex` arguments must have same `kind`.  
If the value of `rel_tol/abs_tol` is negative (not recommended), 
it will be corrected to `abs(rel_tol/abs_tol)` by the internal process of `all_close`.

`a`: Shall be a `real/complex` array.
This argument is `intent(in)`.

`b`: Shall be a `real/complex` array.
This argument is `intent(in)`.

`rel_tol`: Shall be a `real` scalar.
This argument is `intent(in)` and `optional`, which is `sqrt(epsilon(..))` by default.

`abs_tol`: Shall be a `real` scalar.
This argument is `intent(in)` and `optional`, which is `0.0` by default.

`equal_nan`: Shall be a `logical` scalar.
This argument is `intent(in)` and `optional`, which is `.false.` by default.
Whether to compare `NaN` values as equal. If `.true.`, 
`NaN` values in `a` will be considered equal to `NaN` values in `b`.

#### Result value

Returns a `logical` scalar.

#### Example

```fortran
{!example/math/example_math_all_close.f90!}
```

### `diff` function

#### Description

Computes differences between adjacent elements of an array.

#### Syntax

For a rank-1 array:  
`y = ` [[stdlib_math(module):diff(interface)]] `(x [, n, prepend, append])`

and for a rank-2 array:  
`y = ` [[stdlib_math(module):diff(interface)]] `(x [, n, dim, prepend, append])`

#### Status

Experimental.

#### Class

Pure function.

#### Arguments

`x`: The array to take a difference of.
Shall be a `real/integer` and `rank-1/rank-2` array.
This argument is `intent(in)`.

`n`: How many times to iteratively calculate the difference.
Shall be an `integer` scalar.
This argument is `intent(in)` and `optional`, and has value of `1` by default.

`dim`: The dimension of the input array along which to calculate the difference.
Its value must be between `1` and `rank(x)`.
Shall be an `integer` scalar.
This argument is `intent(in)` and `optional` and has a value of `1` by default.

`prepend`, `append`: Arrays to prepend or append to a along axis prior to performing the difference.
The dimension and shape must match a except along axis.
Shall be a `real/integer` and `rank-1/rank-2` array.
This argument is `intent(in)` and `optional`, which is no value by default.

Note: 

- The `x`, `prepend` and `append` arguments must have the same `type`, `kind` and `rank`.  
- If the value of `n` is less than or equal to `0` (which is not recommended), the return value of `diff` is `x`.  
- If the value of `dim` is not equal to `1` or `2` (which is not recommended),
`1` will be used by the internal process of `diff`.


#### Result value

Returns the finite difference of the input array.
Shall be a `real/integer` and `rank-1/rank-2` array.
When both `prepend` and `append` are not present, the result `y` has one fewer element than `x` alongside the dimension `dim`.

#### Example

```fortran
{!example/math/example_diff.f90!}
```

### `meshgrid` subroutine

#### Description

Computes a list of coordinate matrices from coordinate vectors.

For $n \geq 1$ coordinate vectors $(x_1, x_2, ..., x_n)$ of sizes $(s_1, s_2, ..., s_n)$, `meshgrid` computes $n$ coordinate matrices $(X_1, X_2, ..., X_n)$ with identical shape corresponding to the selected indexing:
- Cartesian indexing (default behavior): the shape of the coordinate matrices is $(s_2, s_1, s_3, s_4, ... s_n)$.
- matrix indexing: the shape of the coordinate matrices is $(s_1, s_2, s_3, s_4, ... s_n)$.

#### Syntax

For a 2D problem in Cartesian indexing:
`call ` [[stdlib_math(module):meshgrid(interface)]] `(x, y, xm, ym)`

For a 3D problem in Cartesian indexing:
`call ` [[stdlib_math(module):meshgrid(interface)]] `(x, y, z, xm, ym, zm)`

For a 3D problem in matrix indexing:
`call ` [[stdlib_math(module):meshgrid(interface)]] `(x, y, z, xm, ym, zm, indexing="ij")`

The subroutine can be called in `n`-dimensional situations, as long as `n` is inferior to the maximum allowed array rank.

#### Status

Experimental.

#### Class

Subroutine.

#### Arguments

For a `n`-dimensional problem, with `n >= 1`:

`x1, x2, ..., xn`: The coordinate vectors.
Shall be `real/integer` and `rank-1` arrays.
These arguments are `intent(in)`.

`xm1, xm2, ..., xmn`: The coordinate matrices.
Shall be arrays of type `real` or `integer` of adequate shape:
- for Cartesian indexing, the shape of the coordinate matrices must be `[size(x2), size(x1), size(x3), ..., size(xn)]`.
- for matrix indexing, the shape of the coordinate matrices must be `[size(x1), size(x2), size(x3), ..., size(xn)]`.

These argument are `intent(out)`.

`indexing`: the selected indexing.
Shall be an `integer` equal to `stdlib_meshgrid_xy` for Cartesian indexing (default), or `stdlib_meshgrid_ij` for matrix indexing. `stdlib_meshgrid_xy` and `stdlib_meshgrid_ij` are public constants defined in the module.
This argument is `intent(in)` and `optional`, and is equal to `stdlib_meshgrid_xy` by default.

#### Example

```fortran
{!example/math/example_meshgrid.f90!}
```

---
title: linalg
---

# Linear Algebra

[TOC]

The `stdlib` linear algebra library provides high-level APIs for dealing with common linear algebra operations.

## BLAS and LAPACK

### Status

Experimental

### Description

`BLAS` and `LAPACK` backends provide efficient low level implementations of many linear algebra algorithms, and are employed for non-trivial operators. 
A Modern Fortran version of the [Reference-LAPACK 3.10.1](http://github.com/reference-LAPACK) implementation is provided as a backend. 
Modern Fortran modules with full explicit typing features are provided after an 
[automated conversion](https://github.com/perazz/fortran-lapack/blob/main/scripts/modularize_blas.py) 
of the legacy codes: 
- [stdlib_linalg_blas(module)], [stdlib_linalg_lapack(module)] provide kind-agnostic interfaces to all functions.
- Both libraries are available for 32- (`sp`), 64- (`dp`) and 128-bit (`qp`) `real` and `complex` numbers (the latter if available in the current build)
- Free format, lower-case style
- `implicit none(type, external)` applied to all procedures and modules
- `intent` added and all `pure` procedures where possible
- `stdlib` provides all procedures in two different flavors: (a) original BLAS/LAPACK names with a prefix `stdlib_?<name>` (ex: `stdlib_dgemv`, `stdlib_sgemv`); (b) A generic, kind agnostic `<name>`, i.e. `gemv`. 
- F77-style `parameter`s removed, and all numeric constants have been generalized with KIND-dependent Fortran intrinsics. 
- preprocessor-based OpenMP directives retained.
The single-source module structure hopefully allows for cross-procedural inlining which is otherwise impossible without link-time optimization.

When available, highly optimized libraries that take advantage of specialized processor instructions should be preferred over the `stdlib` implementation. 
Examples of such libraries are: OpenBLAS, MKL (TM), Accelerate, and ATLAS. In order to enable their usage, simply ensure that the following pre-processor macros are defined: 

- `STDLIB_EXTERNAL_BLAS`   wraps all BLAS procedures (except for the 128-bit ones) to an external library
- `STDLIB_EXTERNAL_LAPACK` wraps all LAPACK procedures (except for the 128-bit ones) to an external library

These can be enabled during the build process. For example, with CMake, one can enable these preprocessor directives using `add_compile_definitions(STDLIB_EXTERNAL_BLAS STDLIB_EXTERNAL_LAPACK)`.
The same is possible from the `fpm` branch, where the `cpp` preprocessor is enabled by default. For example, the macros can be added to the project's manifest:

```toml
# Link against appropriate external BLAS and LAPACK libraries, if necessary
[build]
link = ["blas", "lapack"]  

[dependencies]
stdlib="*"

# Macros are only needed if using an external library
[preprocess]
[preprocess.cpp]
macros = ["STDLIB_EXTERNAL_BLAS", "STDLIB_EXTERNAL_LAPACK"]
```

or directly via compiler flags: 

`fpm build --flag "-DSTDLIB_EXTERNAL_BLAS -DSTDLIB_EXTERNAL_LAPACK -lblas -llapack"`.

### Syntax 

All procedures in the `BLAS` and `LAPACK` backends follow the standard interfaces from the 
[Reference LAPACK](https://www.netlib.org/lapack/). So, the online [Users Guide](https://www.netlib.org/lapack/explore-html/)
should be consulted for the full API and descriptions of procedure arguments and their usage. 

The `stdlib` implementation makes both kind-agnostic and specific procedure interfaces available via modules
[stdlib_linalg_blas(module)] and [stdlib_linalg_lapack(module)]. Because all procedures start with a letter 
[that indicates the base datatype](https://www.netlib.org/lapack/lug/node24.html), the `stdlib` generic
interface drops the heading letter and contains all kind-dependent implementations. For example, the generic 
interface to the `axpy` function looks like: 

```fortran  
!> AXPY: constant times a vector plus a vector.
interface axpy
    module procedure stdlib_saxpy
    module procedure stdlib_daxpy
    module procedure stdlib_qaxpy
    module procedure stdlib_caxpy
    module procedure stdlib_zaxpy
    module procedure stdlib_waxpy
end interface axpy
```

The generic interface is the endpoint for using an external library. Whenever the latter is used, references
to the internal `module procedure`s are replaced with interfaces to the external library, 
for example: 

```fortran  
!> AXPY: constant times a vector plus a vector.
interface axpy
    pure subroutine caxpy(n,ca,cx,incx,cy,incy)
        import sp,dp,qp,ilp,lk 
        implicit none 
        complex(sp), intent(in) :: ca,cx(*)
        integer(ilp), intent(in) :: incx,incy,n
        complex(sp), intent(inout) :: cy(*)
    end subroutine caxpy
    ! [....]
    module procedure stdlib_qaxpy
end interface axpy
```

Note that the 128-bit functions are only provided by `stdlib` and always point to the internal implementation. 
Because 128-bit precision is identified as [stdlib_kinds(module):qp], initials for 128-bit procedures were 
labelled as `q` (quadruple-precision reals) and `w` ("wide" or quadruple-precision complex numbers). 
Extended precision ([stdlib_kinds(module):xdp]) calculations are labelled as `x` (extended-precision reals).
and `y` (extended-precision complex numbers).

### Example

```fortran
{!example/linalg/example_blas_gemv.f90!}
```

```fortran
{!example/linalg/example_lapack_getrf.f90!}
```

### Licensing

The Fortran Standard Library is distributed under the MIT License. `LAPACK` and its contained `BLAS` are a 
freely-available software package. They are available from [netlib](https://www.netlib.org/lapack/) via anonymous 
ftp and the World Wide Web. Thus, they can be included in commercial software packages (and have been). 
The license used for the `BLAS` and `LAPACK` backends is the [modified BSD license](https://www.netlib.org/lapack/LICENSE.txt).

The header of the `LICENSE.txt` file has as its licensing requirements:

    Copyright (c) 1992-2013 The University of Tennessee and The University
                            of Tennessee Research Foundation.  All rights
                            reserved.
    Copyright (c) 2000-2013 The University of California Berkeley. All
                            rights reserved.
    Copyright (c) 2006-2013 The University of Colorado Denver.  All rights
                            reserved.

    $COPYRIGHT$

    Additional copyrights may follow

    $HEADER$

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are
    met:

    - Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    - Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer listed
      in this license in the documentation and/or other materials
      provided with the distribution.

    - Neither the name of the copyright holders nor the names of its
      contributors may be used to endorse or promote products derived from
      this software without specific prior written permission.

    The copyright holders provide no reassurances that the source code
    provided does not infringe any patent, copyright, or any other
    intellectual property rights of third parties.  The copyright holders
    disclaim any liability to any recipient for claims brought against
    recipient by any third party for infringement of that parties
    intellectual property rights.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

So the license for the `LICENSE.txt` code is compatible with the use of
modified versions of the code in the Fortran Standard Library under the MIT license.    
Credit for the `BLAS`, `LAPACK` libraries should be given to the [LAPACK authors](https://www.netlib.org/lapack/contributor-list.html).
According to the original license, we also changed the name of the routines and commented the changes made 
to the original.
    
## `diag` - Create a diagonal array or extract the diagonal elements of an array

### Status

Stable

### Class

Pure function.

### Description

Create a diagonal array or extract the diagonal elements of an array

### Syntax

`d = ` [[stdlib_linalg(module):diag(interface)]] `(a [, k])`

### Arguments

`a`: Shall be a rank-1 or or rank-2 array. If `a` is a rank-1 array (i.e. a vector) then `diag` returns a rank-2 array with the elements of `a` on the diagonal. If `a` is a rank-2 array (i.e. a matrix) then `diag` returns a rank-1 array of the diagonal elements.

`k` (optional): Shall be a scalar of type `integer` and specifies the diagonal. The default `k = 0` represents the main diagonal, `k > 0` are diagonals above the main diagonal, `k < 0` are diagonals below the main diagonal.

### Return value

Returns a diagonal array or a vector with the extracted diagonal elements.

### Example

```fortran
{!example/linalg/example_diag1.f90!}
```

```fortran
{!example/linalg/example_diag2.f90!}
```

```fortran
{!example/linalg/example_diag3.f90!}
```

```fortran
{!example/linalg/example_diag4.f90!}
```

```fortran
{!example/linalg/example_diag5.f90!}
```

## `eye` - Construct the identity matrix

### Status

Stable

### Class

Pure function.

### Description

Constructs the identity matrix.

### Syntax

`I = ` [[stdlib_linalg(module):eye(function)]] `(dim1 [, dim2] [, mold])`

### Arguments

- `dim1`: A scalar of type `integer`. This is an `intent(in)` argument and specifies the number of rows.
- `dim2`: A scalar of type `integer`. This is an optional `intent(in)` argument specifying the number of columns. If not provided, the matrix is square (`dim1 = dim2`).
- `mold`: A scalar of any supported `integer`, `real`, or `complex` type. This is an optional `intent(in)` argument. If provided, the returned identity matrix will have the same type and kind as `mold`. If not provided, the matrix will be of type `real(real64)` by default.

### Return value

Returns the identity matrix, with ones on the main diagonal and zeros elsewhere. 

- By default, the return value is of type `real(real64)`, which is recommended for arithmetic safety.
- If the `mold` argument is provided, the return value will match the type and kind of `mold`, allowing for arbitrary `integer`, `real`, or `complex` return types.

### Example

```fortran
!> Return default type (real64)
A = eye(2,2)/2             !! A == diag([0.5_dp, 0.5_dp])
!> Return 32-bit complex
A = eye(2,2, mold=(0.0,0.0))/2   !! A == diag([(0.5,0.5), (0.5,0.5)])
```

```fortran
{!example/linalg/example_eye1.f90!}
```

```fortran
{!example/linalg/example_eye2.f90!}
```

## `trace` - Trace of a matrix

### Status

Stable

### Description

Trace of a matrix (rank-2 array)

### Syntax

`result = ` [[stdlib_linalg(module):trace(interface)]] `(A)`

### Arguments

`A`: Shall be a rank-2 array. If `A` is not square, then `trace(A)` will return the sum of diagonal values from the square sub-section of `A`.

### Return value

Returns the trace of the matrix, i.e. the sum of diagonal elements.

### Example
```fortran
{!example/linalg/example_trace.f90!}
```

## `outer_product` - Computes the outer product of two vectors

### Status

Experimental

### Description

Computes the outer product of two vectors

### Syntax

`d = ` [[stdlib_linalg(module):outer_product(interface)]] `(u, v)`

### Arguments

`u`: Shall be a rank-1 array

`v`: Shall be a rank-1 array

### Return value

Returns a rank-2 array equal to `u v^T` (where `u, v` are considered column vectors). The shape of the returned array is `[size(u), size(v)]`.

### Example

```fortran
{!example/linalg/example_outer_product.f90!}
```

## `kronecker_product` - Computes the Kronecker product of two rank-2 arrays

### Status

Experimental

### Description

Computes the Kronecker product of two rank-2 arrays

### Syntax

`C = ` [[stdlib_linalg(module):kronecker_product(interface)]] `(A, B)`

### Arguments

`A`: Shall be a rank-2 array with dimensions M1, N1

`B`: Shall be a rank-2 array with dimensions M2, N2

### Return value

Returns a rank-2 array equal to `A \otimes B`. The shape of the returned array is `[M1*M2, N1*N2]`.

### Example

```fortran
{!example/linalg/example_kronecker_product.f90!}
```


## `cross_product` - Computes the cross product of two vectors

### Status

Experimental

### Description

Computes the cross product of two vectors

### Syntax

`c = ` [[stdlib_linalg(module):cross_product(interface)]] `(a, b)`

### Arguments

`a`: Shall be a rank-1 and size-3 array

`b`: Shall be a rank-1 and size-3 array

### Return value

Returns a rank-1 and size-3 array which is perpendicular to both `a` and `b`.

### Example

```fortran
{!example/linalg/example_cross_product.f90!}
```

## `is_square` - Checks if a matrix is square

### Status

Experimental

### Description

Checks if a matrix is square

### Syntax

`d = ` [[stdlib_linalg(module):is_square(interface)]] `(A)`

### Arguments

`A`: Shall be a rank-2 array

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is square, and `.false.` otherwise.

### Example

```fortran
{!example/linalg/example_is_square.f90!}
```

## `is_diagonal` - Checks if a matrix is diagonal

### Status

Experimental

### Description

Checks if a matrix is diagonal

### Syntax

`d = ` [[stdlib_linalg(module):is_diagonal(interface)]] `(A)`

### Arguments

`A`: Shall be a rank-2 array

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is diagonal, and `.false.` otherwise.
Note that nonsquare matrices may be diagonal, so long as `a_ij = 0` when `i /= j`.

### Example

```fortran
{!example/linalg/example_is_diagonal.f90!}
```

## `is_symmetric` - Checks if a matrix is symmetric

### Status

Experimental

### Description

Checks if a matrix is symmetric

### Syntax

`d = ` [[stdlib_linalg(module):is_symmetric(interface)]] `(A)`

### Arguments

`A`: Shall be a rank-2 array

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is symmetric, and `.false.` otherwise.

### Example

```fortran
{!example/linalg/example_is_symmetric.f90!}
```

## `is_skew_symmetric` - Checks if a matrix is skew-symmetric

### Status

Experimental

### Description

Checks if a matrix is skew-symmetric

### Syntax

`d = ` [[stdlib_linalg(module):is_skew_symmetric(interface)]] `(A)`

### Arguments

`A`: Shall be a rank-2 array

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is skew-symmetric, and `.false.` otherwise.

### Example

```fortran
{!example/linalg/example_is_skew_symmetric.f90!}
```

## `hermitian` - Compute the Hermitian version of a rank-2 matrix

### Status

Experimental

### Description

Compute the Hermitian version of a rank-2 matrix. 
For `complex` matrices, the function returns the conjugate transpose (`conjg(transpose(a))`). 
For `real` or `integer` matrices, the function returns the transpose (`transpose(a)`).

### Syntax

`h = ` [[stdlib_linalg(module):hermitian(interface)]] `(a)`

### Arguments

`a`: Shall be a rank-2 array of type `integer`, `real`, or `complex`. The input matrix `a` is not modified.

### Return value

Returns a rank-2 array of the same shape and type as `a`. If `a` is of type `complex`, the Hermitian matrix is computed as `conjg(transpose(a))`. 
For `real` or `integer` types, it is equivalent to the intrinsic `transpose(a)`.

### Example

```fortran
{!example/linalg/example_hermitian.f90!}
```

## `is_hermitian` - Checks if a matrix is Hermitian

### Status

Experimental

### Description

Checks if a matrix is Hermitian

### Syntax

`d = ` [[stdlib_linalg(module):is_hermitian(interface)]] `(A)`

### Arguments

`A`: Shall be a rank-2 array

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is Hermitian, and `.false.` otherwise.

### Example

```fortran
{!example/linalg/example_is_hermitian.f90!}
```

## `is_triangular` - Checks if a matrix is triangular

### Status

Experimental

### Description

Checks if a matrix is triangular

### Syntax

`d = ` [[stdlib_linalg(module):is_triangular(interface)]] `(A,uplo)`

### Arguments

`A`: Shall be a rank-2 array

`uplo`: Shall be a single character from `{'u','U','l','L'}`

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is the type of triangular specified by `uplo` (upper or lower), and `.false.` otherwise.
Note that the definition of triangular used in this implementation allows nonsquare matrices to be triangular.
Specifically, upper triangular matrices satisfy `a_ij = 0` when `j < i`, and lower triangular matrices satisfy `a_ij = 0` when `j > i`.

### Example

```fortran
{!example/linalg/example_is_triangular.f90!}
```

## `is_hessenberg` - Checks if a matrix is hessenberg

### Status

Experimental

### Description

Checks if a matrix is Hessenberg

### Syntax

`d = ` [[stdlib_linalg(module):is_hessenberg(interface)]] `(A,uplo)`

### Arguments

`A`: Shall be a rank-2 array

`uplo`: Shall be a single character from `{'u','U','l','L'}`

### Return value

Returns a `logical` scalar that is `.true.` if the input matrix is the type of Hessenberg specified by `uplo` (upper or lower), and `.false.` otherwise.
Note that the definition of Hessenberg used in this implementation allows nonsquare matrices to be Hessenberg.
Specifically, upper Hessenberg matrices satisfy `a_ij = 0` when `j < i-1`, and lower Hessenberg matrices satisfy `a_ij = 0` when `j > i+1`.

### Example

```fortran
{!example/linalg/example_is_hessenberg.f90!}
```

## `solve` - Solves a linear matrix equation or a linear system of equations. 

### Status

Stable

### Description

This function computes the solution to a linear matrix equation \( A \cdot x = b \), where \( A \) is a square, full-rank, `real` or `complex` matrix.

Result vector or array `x` returns the exact solution to within numerical precision, provided that the matrix is not ill-conditioned. 
An error is returned if the matrix is rank-deficient or singular to working precision. 
The solver is based on LAPACK's `*GESV` backends.

### Syntax

`Pure` interface:

`x = ` [[stdlib_linalg(module):solve(interface)]] `(a, b)`

Expert interface:

`x = ` [[stdlib_linalg(module):solve(interface)]] `(a, b [, overwrite_a], err)`

### Arguments
 
`a`: Shall be a rank-2 `real` or `complex` square array containing the coefficient matrix. It is normally an `intent(in)` argument. If `overwrite_a=.true.`, it is an `intent(inout)` argument and is destroyed by the call. 

`b`: Shall be a rank-1 or rank-2 array of the same kind as `a`, containing the right-hand-side vector(s). It is an `intent(in)` argument.

`overwrite_a` (optional): Shall be an input logical flag. if `.true.`, input matrix `a` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument. The function is not `pure` if this argument is provided.

### Return value

For a full-rank matrix, returns an array value that represents the solution to the linear system of equations.

Raises `LINALG_ERROR` if the matrix is singular to working precision.
Raises `LINALG_VALUE_ERROR` if the matrix and rhs vectors have invalid/incompatible sizes.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_solve1.f90!}

{!example/linalg/example_solve2.f90!}
```

## `solve_lu` - Solves a linear matrix equation or a linear system of equations (subroutine interface). 

### Status

Stable

### Description

This subroutine computes the solution to a linear matrix equation \( A \cdot x = b \), where \( A \) is a square, full-rank, `real` or `complex` matrix.

Result vector or array `x` returns the exact solution to within numerical precision, provided that the matrix is not ill-conditioned. 
An error is returned if the matrix is rank-deficient or singular to working precision. 
If all optional arrays are provided by the user, no internal allocations take place.
The solver is based on LAPACK's `*GESV` backends.

### Syntax

Simple (`Pure`) interface:

`call ` [[stdlib_linalg(module):solve_lu(interface)]] `(a, b, x)`

Expert (`Pure`) interface:

`call ` [[stdlib_linalg(module):solve_lu(interface)]] `(a, b, x [, pivot, overwrite_a, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` square array containing the coefficient matrix. It is normally an `intent(in)` argument. If `overwrite_a=.true.`, it is an `intent(inout)` argument and is destroyed by the call. 

`b`: Shall be a rank-1 or rank-2 array of the same kind as `a`, containing the right-hand-side vector(s). It is an `intent(in)` argument.

`x`: Shall be a rank-1 or rank-2 array of the same kind and size as `b`, that returns the solution(s) to the system. It is an `intent(inout)` argument, and must have the `contiguous` property. 

`pivot` (optional): Shall be a rank-1 array of the same kind and matrix dimension as `a`, providing storage for the diagonal pivot indices. It is an `intent(inout)` arguments, and returns the diagonal pivot indices. 

`overwrite_a` (optional): Shall be an input logical flag. if `.true.`, input matrix `a` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

For a full-rank matrix, returns an array value that represents the solution to the linear system of equations.

Raises `LINALG_ERROR` if the matrix is singular to working precision.
Raises `LINALG_VALUE_ERROR` if the matrix and rhs vectors have invalid/incompatible sizes.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_solve3.f90!}
```

## `lstsq` - Computes the least squares solution to a linear matrix equation. 

### Status

Stable

### Description

This function computes the least-squares solution to a linear matrix equation \( A \cdot x = b \).

Result vector `x` returns the approximate solution that minimizes the 2-norm \( || A \cdot x - b ||_2 \), i.e., it contains the least-squares solution to the problem. Matrix `A` may be full-rank, over-determined, or under-determined. The solver is based on LAPACK's `*GELSD` backends.

### Syntax

`x = ` [[stdlib_linalg(module):lstsq(interface)]] `(a, b, [, cond, overwrite_a, rank, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the coefficient matrix. It is an `intent(inout)` argument.

`b`: Shall be a rank-1 or rank-2 array of the same kind as `a`, containing one or more right-hand-side vector(s), each in its leading dimension. It is an `intent(in)` argument. 

`cond` (optional): Shall be a scalar `real` value cut-off threshold for rank evaluation: `s_i >= cond*maxval(s), i=1:rank`. Shall be a scalar, `intent(in)` argument.

`overwrite_a` (optional): Shall be an input `logical` flag. If `.true.`, input matrix `A` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`rank` (optional): Shall be an `integer` scalar value, that contains the rank of input matrix `A`. This is an `intent(out)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Returns an array value of the same kind and rank as `b`, containing the solution(s) to the least squares system. 

Raises `LINALG_ERROR` if the underlying Singular Value Decomposition process did not converge.
Raises `LINALG_VALUE_ERROR` if the matrix and right-hand-side vector have invalid/incompatible sizes.
Exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_lstsq1.f90!}
```

## `solve_lstsq` - Compute the least squares solution to a linear matrix equation (subroutine interface). 

### Status

Stable

### Description

This subroutine computes the least-squares solution to a linear matrix equation \( A \cdot x = b \).

Result vector `x` returns the approximate solution that minimizes the 2-norm \( || A \cdot x - b ||_2 \), i.e., it contains the least-squares solution to the problem. Matrix `A` may be full-rank, over-determined, or under-determined. The solver is based on LAPACK's `*GELSD` backends.

### Syntax

`call ` [[stdlib_linalg(module):solve_lstsq(interface)]] `(a, b, x, [, real_storage, int_storage, [cmpl_storage, ] cond, singvals, overwrite_a, rank, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the coefficient matrix. It is an `intent(inout)` argument.

`b`: Shall be a rank-1 or rank-2 array of the same kind as `a`, containing one or more right-hand-side vector(s), each in its leading dimension. It is an `intent(in)` argument. 

`x`: Shall be an array of same kind and rank as `b`, and leading dimension of at least `n`, containing the solution(s) to the least squares system. It is an `intent(inout)` argument.

`real_storage` (optional): Shall be a `real` rank-1 array of the same kind `a`, providing working storage for the solver. It minimum size can be determined with a call to [[stdlib_linalg(module):lstsq_space(interface)]]. It is an `intent(inout)` argument.

`int_storage` (optional): Shall be an `integer` rank-1 array, providing working storage for the solver. It minimum size can be determined with a call to [[stdlib_linalg(module):lstsq_space(interface)]]. It is an `intent(inout)` argument.

`cmpl_storage` (optional): For `complex` systems, it shall be a `complex` rank-1 array, providing working storage for the solver. It minimum size can be determined with a call to [[stdlib_linalg(module):lstsq_space(interface)]]. It is an `intent(inout)` argument.

`cond` (optional): Shall be a scalar `real` value cut-off threshold for rank evaluation: `s_i >= cond*maxval(s), i=1:rank`. Shall be a scalar, `intent(in)` argument.

`singvals` (optional): Shall be a `real` rank-1 array of the same kind `a` and size at least `min(m,n)`, returning the list of singular values `s(i)>=cond*maxval(s)` from the internal SVD, in descending order of magnitude. It is an `intent(out)` argument.

`overwrite_a` (optional): Shall be an input `logical` flag. If `.true.`, input matrix `A` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`rank` (optional): Shall be an `integer` scalar value, that contains the rank of input matrix `A`. This is an `intent(out)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Returns an array value that represents the solution to the least squares system.

Raises `LINALG_ERROR` if the underlying Singular Value Decomposition process did not converge.
Raises `LINALG_VALUE_ERROR` if the matrix and right-hand-side vector have invalid/incompatible sizes.
Exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_lstsq2.f90!}
```

## `lstsq_space` - Compute internal working space requirements for the least squares solver.

### Status

Stable

### Description

This subroutine computes the internal working space requirements for the least-squares solver, [[stdlib_linalg(module):solve_lstsq(interface)]] .

### Syntax

`call ` [[stdlib_linalg(module):lstsq_space(interface)]] `(a, b, lrwork, liwork [, lcwork])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the linear system coefficient matrix. It is an `intent(in)` argument.

`b`: Shall be a rank-1 or rank-2 array of the same kind as `a`, containing the system's right-hand-side vector(s). It is an `intent(in)` argument. 

`lrwork`: Shall be an `integer` scalar, that returns the minimum array size required for the `real` working storage to this system.

`liwork`: Shall be an `integer` scalar, that returns the minimum array size required for the `integer` working storage to this system.

`lcwork` (`complex` `a`, `b`): For a `complex` system, shall be an `integer` scalar, that returns the minimum array size required for the `complex` working storage to this system.

## `constrained_lstsq` - Compute the solution of the equality-constrained least-squares problem {#constrained-lstsq}

### Status

Experimental

### Description

This function computes the solution \(x\) of the equality-constrained linear least-squares problem
$$
\begin{aligned}
    \mathrm{minimize}   &   \quad \| Ax - b \|^2 \\
    \mathrm{subject~to} &   \quad   Cx = d,
\end{aligned}
$$
where \(A\) is an \( m \times n \) matrix (with \(m \geq n\)) and \(C\) a \( p \times n\) matrix (with \(p \leq n\)). The solver is based on LAPACK's `*GLSE` backends.

### Syntax

`x = ` [[stdlib_linalg(module):constrained_lstsq(interface)]] `(A, b, C, d[, overwrite_matrices, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array used in the definition of the least-squares cost. It is an `intent(inout)` argument.

`b`: Shall be a rank-1 array of the same kind as `a` appearing in the definition of the least-squares cost. It is an `intent(inout)` argument.

`c`: Shall be a rank-2 `real` or `complex` array of the same kind as `a` defining the linear equality constraints. It is an `intent(inout)` argument.

`d`: Shall be a rank-1 array of the same kind as `a` appearing in the definition of the linear equality constraints.

`overwrite_matrices` (optional): Shall be an input `logical` flag. If `.true.`, the input matrices and vectors will be overwritten during the computation of the solution. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Returns an array of the same kind as `a` containing the solution of the equality constrained least-squares problem.

Raises `LINALG_ERROR` if the underlying constrained least-squares solver did not converge.
Raises `LINALG_VALUE_ERROR` if the matrices and vectors have invalid/incompatible dimensions.
Exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_constrained_lstsq1.f90!}
```

## `solve_constrained_lstsq` - Compute the solution of the equality-constrained least squares problem (subroutine interface) {#solve-constrained-lstsq}

### Status

Experimental

### Description

This subroutine computes the solution \(x\) of the equality-constrained linear least-squares problem
$$
\begin{aligned}
    \mathrm{minimize}   &   \quad \| Ax - b \|^2 \\
    \mathrm{subject~to} &   \quad   Cx = d,
\end{aligned}
$$
where \(A\) is an \( m \times n \) matrix (with \(m \geq n\)) and \(C\) a \( p \times n\) matrix (with \(p \leq n\)). The solver is based on LAPACK's `*GLSE` backends.

### Syntax


`call ` [[stdlib_linalg(module):solve_constrained_lstsq(interface)]] `(a, b, c, d, x [, storage, overwrite_matrices, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array used in the definition of the least-squares cost. It is an `intent(inout)` argument.

`b`: Shall be a rank-1 array of the same kind as `a` appearing in the definition of the least-squares cost. It is an `intent(inout)` argument.

`c`: Shall be a rank-2 `real` or `complex` array of the same kind as `a` defining the linear equality constraints. It is an `intent(inout)` argument.

`d`: Shall be a rank-1 array of the same kind as `a` appearing in the definition of the linear equality constraints.

`x`: Shall be a rank-1 array of the same kind as `a`. On exit, it contains the solution of the constrained least-squares problem. It is an `intent(out)` argument.

`storage` (optional): Shall be a rank-1 array of the same kind as `a` providing working storage for the solver. Its minimum size can be determined with a call to [stdlib_linalg(module):constrained_lstsq_space(interface)]. It is an `intent(out)` argument.

`overwrite_matrices` (optional): Shall be an input `logical` flag. If `.true.`, the input matrices and vectors will be overwritten during the computation of the solution. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Example

```fortran
{!example/linalg/example_constrained_lstsq2.f90!}
```

## `constrained_lstsq_space` - Compute internal workspace requirements for the constrained least-square solver {#constrained-lstsq-space}

### Status

Experimental

### Description

This subroutine computes the internal workspace requirements for the constrained least-squares solver, [stdlib_linalg(module):solve_constrained_lstsq(interface)].

### Syntax

call [stdlib_linalg(module):constrained_lstsq_space(interface)]`(a,  c,  lwork [, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array used in the definition of the least-squares cost. It is an `intent(in)` argument.

`c`: Shall be a rank-2 `real` or `complex` array of the same kind as `a` defining the linear equality constraints. It is an `intent(in)` argument.
`lwork`: Shall be an `integer` scalar returning the optimal size required for the workspace array to solve the constrained least-squares problem.

## `det` - Computes the determinant of a square matrix

### Status

Stable

### Description

This function computes the determinant of a `real` or `complex` square matrix.

This interface comes with a `pure` version `det(a)`, and a non-pure version `det(a,overwrite_a,err)` that
allows for more expert control.

### Syntax

`c = ` [[stdlib_linalg(module):det(interface)]] `(a [, overwrite_a, err])`

### Arguments

`a`: Shall be a rank-2 square array

`overwrite_a` (optional): Shall be an input `logical` flag. if `.true.`, input matrix `a` will be used as temporary storage and overwritten. This avoids internal data allocation.
 This is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value.  This is an `intent(out)` argument.

### Return value

Returns a `real` scalar value of the same kind of `a` that represents the determinant of the matrix.

Raises `LINALG_ERROR` if the matrix is singular.
Raises `LINALG_VALUE_ERROR` if the matrix is non-square.
Exceptions are returned to the `err` argument if provided; an `error stop` is triggered otherwise.

### Example

```fortran
{!example/linalg/example_determinant.f90!}
```

## `.det.` - Determinant operator of a square matrix

### Status

Stable

### Description

This operator returns the determinant of a real square matrix.

This interface is equivalent to the `pure` version of determinant [[stdlib_linalg(module):det(interface)]]. 

### Syntax

`c = ` [[stdlib_linalg(module):operator(.det.)(interface)]] `a`

### Arguments

`a`: Shall be a rank-2 square array of any `real` or `complex` kinds. It is an `intent(in)` argument.

### Return value

Returns a real scalar value that represents the determinant of the matrix.

Raises `LINALG_ERROR` if the matrix is singular.
Raises `LINALG_VALUE_ERROR` if the matrix is non-square.
Exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_determinant2.f90!}
```

## `qr` - Compute the QR factorization of a matrix

### Status

Experimental

### Description

This subroutine computes the QR factorization of a `real` or `complex` matrix: \( A = Q R \) where \( Q \) 
is orthonormal and \( R \) is upper-triangular. Matrix \( A \) has size `[m,n]`, with \( m \ge n \). 

The results are returned in output matrices \( Q \) and \(R \), that have the same type and kind as \( A \). 
Given `k = min(m,n)`, one can write \( A = \( Q_1  Q_2 \) \cdot \( \frac{R_1}{0}\) \). 
Because the lower rows of \( R \) are zeros, a reduced problem \( A = Q_1 R_1 \) may be solved. The size of 
the input arguments determines what problem is solved: on full matrices (`shape(Q)==[m,m]`, `shape(R)==[m,n]`), 
the full problem is solved. On reduced matrices (`shape(Q)==[m,k]`, `shape(R)==[k,n]`), the reduced problem is solved.

### Syntax

`call ` [[stdlib_linalg(module):qr(interface)]] `(a, q, r [, pivots] [, overwrite_a] [, storage] [, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the coefficient matrix of size `[m,n]`. It is an `intent(in)` argument, if `overwrite_a=.false.`. Otherwise, it is an `intent(inout)` argument, and is destroyed upon return.

`q`: Shall be a rank-2 array of the same kind as `a`, containing the orthonormal matrix `q`. It is an `intent(out)` argument. It should have a shape equal to either `[m,m]` or `[m,k]`, whether the full or the reduced problem is sought for.

`r`: Shall be a rank-2 array of the same kind as `a`, containing the upper triangular matrix `r`. It is an `intent(out)` argument. It should have a shape equal to either `[m,n]` or `[k,n]`, whether the full or the reduced problem is sought for.

`pivots` (optional): Shall be an `integer` array of size `n`. If provided, QR factorization with column-pivoting is being computed. It is an `intent(out)` argument.

`overwrite_a` (optional): Shall be an input `logical` flag (default: `.false.`). If `.true.`, input matrix `a` will be used as temporary storage and overwritten. This avoids internal data allocation. It is an `intent(in)` argument.

`storage` (optional): Shall be a rank-1 array of the same type and kind as `a`, providing working storage for the solver. Its minimum size can be determined with a call to [[stdlib_linalg(module):qr_space(interface)]]. It is an `intent(out)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument.

### Return value

Returns the QR factorization matrices into the \( Q \) and \( R \) arguments and the optional pivots in `pivots`.

Raises `LINALG_VALUE_ERROR` if any of the matrices has invalid or unsuitable size for the full/reduced problem.
Raises `LINALG_ERROR` on insufficient user storage space.
If the state argument `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_qr.f90!}

{!example/linalg/example_pivoting_qr.f90!}
```

## `qr_space` - Compute internal working space requirements for the QR factorization.

### Status

Experimental

### Description

This subroutine computes the internal working space requirements for the QR factorization, [[stdlib_linalg(module):qr(interface)]] .

### Syntax

`call ` [[stdlib_linalg(module):qr_space(interface)]] `(a, lwork, [, pivoting] [, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the coefficient matrix. It is an `intent(in)` argument.

`lwork`: Shall be an `integer` scalar, that returns the minimum array size required for the working storage in [[stdlib_linalg(module):qr(interface)]] to factorize `a`.

`pivoting` (optional): Shall a `logical` flag (default: `.false.`). If `.true.`, on exit `lwork` is the optimal workspace size for the QR factorization with column pivoting. If `.false.`, `lwork` is the optimal workspace size for the standard QR factorization. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Example

```fortran
{!example/linalg/example_qr_space.f90!}

{!example/linalg/example_pivoting_qr_space.f90!}
```

## `schur` - Compute the Schur decomposition of a matrix

### Status

Experimental

### Description

This subroutine computes the Schur decomposition of a `real` or `complex` matrix: \( A = Z T Z^H \), where \( Z \) is unitary (orthonormal) and \( T \) is upper-triangular (for complex matrices) or quasi-upper-triangular (for real matrices, with possible \( 2 \times 2 \) blocks on the diagonal). Matrix \( A \) has size `[n,n]`.

The results are returned in output matrices \( T \) and \( Z \). Matrix \( T \) is the Schur form, and matrix \( Z \) is the unitary transformation matrix such that \( A = Z T Z^H \). If requested, the eigenvalues of \( T \) can also be returned as a `complex` array of size `[n]`.

### Syntax

`call ` [[stdlib_linalg(module):schur(interface)]] `(a, t [, z,] [, eigvals] [, overwrite_a] [, storage] [, err])`

### Arguments

- `a`: Shall be a rank-2 `real` or `complex` array containing the matrix to be decomposed. It is an `intent(inout)` argument if `overwrite_a = .true.`; otherwise, it is an `intent(in)` argument.

- `t`: Shall be a rank-2 array of the same kind as `a`, containing the Schur form \( T \) of the matrix. It is an `intent(out)` argument and should have a shape of `[n,n]`.

- `z`: Shall be a rank-2 array of the same kind as `a`, containing the unitary matrix \( Z \). It is an `intent(out)` argument and is optional. If provided, it should have the shape `[n,n]`.

- `eigvals` (optional): Shall be a rank-1 `complex` or `real` array of the same kind as `a`, containing the eigenvalues of \( A \) (the diagonal elements of \( T \)), or their `real` component only. The array must be of size `[n]`. If not provided, the eigenvalues are not returned. It is an `intent(out)` argument.

- `overwrite_a` (optional): Shall be a `logical` flag (default: `.false.`). If `.true.`, the input matrix `a` will be overwritten and destroyed upon return, avoiding internal data allocation. It is an `intent(in)` argument.

- `storage` (optional): Shall be a rank-1 array of the same type and kind as `a`, providing working storage for the solver. Its minimum size can be determined with a call to [[stdlib_linalg(module):schur_space(interface)]]. It is an `intent(inout)` argument.

- `err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument. If not provided, exceptions trigger an `error stop`.

### Return value

Returns the Schur decomposition matrices into the \( T \) and \( Z \) arguments. If `eigvals` is provided, it will also return the eigenvalues of the matrix \( A \).

Raises `LINALG_VALUE_ERROR` if any of the matrices have invalid or unsuitable size for the decomposition.  
Raises `LINALG_VALUE_ERROR` if the `real` component is only requested, but the eigenvalues have non-trivial imaginary parts.
Raises `LINALG_ERROR` on insufficient user storage space.  
If the state argument `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_schur_eigvals.f90!}
```

---

## `schur_space` - Compute internal working space requirements for the Schur decomposition

### Status

Experimental

### Description

This subroutine computes the internal working space requirements for the Schur decomposition, [[stdlib_linalg(module):schur(interface)]].

### Syntax

`call ` [[stdlib_linalg(module):schur_space(interface)]] `(a, lwork, [, err])`

### Arguments

- `a`: Shall be a rank-2 `real` or `complex` array containing the matrix to be decomposed. It is an `intent(in)` argument.

- `lwork`: Shall be an `integer` scalar that returns the minimum array size required for the working storage in [[stdlib_linalg(module):schur(interface)]] to decompose `a`. It is an `intent(out)` argument.

- `err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument.

### Return value

Returns the required working storage size `lwork` for the Schur decomposition. This value can be used to pre-allocate a workspace array in case multiple Schur decompositions of the same matrix size are needed. If pre-allocated working arrays are provided, no internal memory allocations will take place during the decomposition.


## `eig` - Eigenvalues and Eigenvectors of a Square Matrix

### Status

Stable

### Description

This subroutine computes the solution to the eigenproblem \( A \cdot \bar{v} - \lambda \cdot \bar{v} \), 
where \( A \) is a square, full-rank, `real` or `complex` matrix, or to the generalized eigenproblem \( A \cdot \bar{v} - \lambda \cdot B \cdot \bar{v} \), 
where \( B \) is a square matrix with the same type, kind and size as \( A \).

Result array `lambda` returns the eigenvalues of \( A \). The user can request eigenvectors to be returned: if provided, on output `left` will contain the left eigenvectors, `right` the right eigenvectors of \( A \).
Both `left` and `right` are rank-2 arrays, where eigenvectors are stored as columns.
The solver is based on LAPACK's `*GEEV` (standard eigenproblem) and `*GGEV` (generalized eigenproblem) backends.

### Syntax

For the standard eigenproblem: 

`call ` [[stdlib_linalg(module):eig(interface)]] `(a, lambda [, right] [,left] [,overwrite_a] [,err])`

For the generalized eigenproblem: 

`call ` [[stdlib_linalg(module):eig(interface)]] `(a, b, lambda [, right] [, left] [, overwrite_a] [, overwrite_b] [, err])

### Arguments

`a` : `real` or `complex` square array containing the coefficient matrix. If `overwrite_a=.false.`, it is an `intent(in)` argument. Otherwise, it is an `intent(inout)` argument and is destroyed by the call. 

`b`: `real` or `complex` square array containing the second coefficient matrix. If `overwrite_b=.false.`, it is an `intent(in)` argument.  Otherwise, it is an `intent(inout)` argument and is destroyed by the call. 

`lambda`: Shall be a `complex` or `real` rank-1 array of the same kind as `a`, containing the eigenvalues, or their `real` component only. It is an `intent(out)` argument.

`right` (optional): Shall be a `complex` rank-2 array of the same size and kind as `a`, containing the right eigenvectors of `a`. It is an `intent(out)` argument.

`left` (optional): Shall be a `complex` rank-2 array of the same size and kind as `a`, containing the left eigenvectors of `a`. It is an `intent(out)` argument.

`overwrite_a` (optional): Shall be an input logical flag. if `.true.`, input matrix `a` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`overwrite_b` (optional): Shall be an input logical flag. If `.true.`, input matrix `b` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Raises `LINALG_ERROR` if the calculation did not converge.
Raises `LINALG_VALUE_ERROR` if any matrix or arrays have invalid/incompatible sizes.
Raises `LINALG_VALUE_ERROR` if the `real` component is only requested, but the eigenvalues have non-trivial imaginary parts.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_eig.f90!}
```

## `eigh` - Eigenvalues and Eigenvectors of a Real symmetric or Complex Hermitian Square Matrix

### Status

Stable

### Description

This subroutine computes the solution to the eigendecomposition \( A \cdot \bar{v} - \lambda \cdot \bar{v} \),
where \( A \) is a square, full-rank, `real` symmetric \( A = A^T \) or `complex` Hermitian \( A = A^H \) matrix.

Result array `lambda` returns the `real` eigenvalues of \( A \). The user can request the orthogonal eigenvectors 
to be returned: on output `vectors` may contain the matrix of eigenvectors, returned as a column.

Normally, only the lower triangular part of \( A \) is accessed. On input, `logical` flag `upper_a` 
allows the user to request what triangular part of the matrix should be used.

The solver is based on LAPACK's `*SYEV` and `*HEEV` backends.

### Syntax

`call ` [[stdlib_linalg(module):eigh(interface)]] `(a, lambda [, vectors] [, upper_a] [, overwrite_a] [,err])`

### Arguments

`a` : `real` or `complex` square array containing the coefficient matrix. It is an `intent(in)` argument. If `overwrite_a=.true.`, it is an `intent(inout)` argument and is destroyed by the call. 

`lambda`: Shall be a `complex` rank-1 array of the same precision as `a`, containing the eigenvalues. It is an `intent(out)` argument. 

`vectors` (optional): Shall be a rank-2 array of the same type, size and kind as `a`, containing the eigenvectors of `a`. It is an `intent(out)` argument.

`upper_a` (optional): Shall be an input `logical` flag. If `.true.`, the upper triangular part of `a` will be accessed. Otherwise, the lower triangular part will be accessed. It is an `intent(in)` argument.

`overwrite_a` (optional): Shall be an input `logical` flag. If `.true.`, input matrix `a` will be used as temporary storage and overwritten. This avoids internal data allocation. This is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Raises `LINALG_ERROR` if the calculation did not converge.
Raises `LINALG_VALUE_ERROR` if any matrix or arrays have invalid/incompatible sizes.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_eigh.f90!}
```

## `eigvals` - Eigenvalues of a Square Matrix

### Status

Stable

### Description

This function computes the eigenvalues for either a standard or generalized eigenproblem:

- **Standard eigenproblem**: \( A \cdot \bar{v} - \lambda \cdot \bar{v} \), where \( A \) is a square, full-rank `real` or `complex` matrix.
- **Generalized eigenproblem**: \( A \cdot \bar{v} - \lambda \cdot B \cdot \bar{v} \), where \( B \) is a square matrix with the same type and kind as \( A \).

The eigenvalues are stored in the result array `lambda`, which is `complex` (even for real input matrices).  
The solver uses LAPACK's `*GEEV` and `*GGEV` backends for the standard and generalized problems, respectively.

### Syntax

For the standard eigenproblem:

`lambda = ` [[stdlib_linalg(module):eigvals(interface)]] `(a [, err])`

For the generalized eigenproblem:

`lambda = ` [[stdlib_linalg(module):eigvals(interface)]] `(a, b [, err])`

### Arguments

`a`:  
Shall be a `real` or `complex` square array containing the coefficient matrix. It is an `intent(in)` argument.

`b` (optional):  
Shall be a `real` or `complex` square array containing the second coefficient matrix for the generalized problem. It is an `intent(in)` argument.

`err` (optional):  
Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return Value

Returns a `complex` rank-1 array containing the eigenvalues of the problem.  

Raises `LINALG_ERROR` if the calculation did not converge.  
Raises `LINALG_VALUE_ERROR` if any matrix or arrays have invalid/incompatible sizes.  
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_eigvals.f90!}
```

## `eigvalsh` - Eigenvalues of a Real Symmetric or Complex Hermitian Square Matrix

### Status

Stable

### Description

This function returns the eigenvalues to matrix \( A \): a where \( A \) is a square, full-rank, 
`real` symmetric \( A = A^T \) or `complex` Hermitian \( A = A^H \) matrix.
The eigenvalues are solutions to the eigenproblem \( A \cdot \bar{v} - \lambda \cdot \bar{v} \).

Result array `lambda` is `real`, and returns the eigenvalues of \( A \). 
The solver is based on LAPACK's `*SYEV` and `*HEEV` backends.

### Syntax

`lambda = ` [[stdlib_linalg(module):eigvalsh(interface)]] `(a, [, upper_a] [,err])`

### Arguments

`a` : `real` or `complex` square array containing the coefficient matrix. It is an `intent(in)` argument.

`upper_a` (optional): Shall be an input logical flag. If `.true.`, the upper triangular part of `a` will be used accessed. Otherwise, the lower triangular part will be accessed (default). It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Returns a `real` array containing the eigenvalues of `a`. 

Raises `LINALG_ERROR` if the calculation did not converge.
Raises `LINALG_VALUE_ERROR` if any matrix or arrays have invalid/incompatible sizes.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_eigvalsh.f90!}
```

## `svd` - Compute the singular value decomposition of a rank-2 array (matrix).

### Status

Stable

### Description

This subroutine computes the singular value decomposition of a `real` or `complex` rank-2 array (matrix) \( A = U \cdot S \cdot \V^T \).
The solver is based on LAPACK's `*GESDD` backends.

Result vector `s` returns the array of singular values on the diagonal of \( S \). 
If requested, `u` contains the left singular vectors, as columns of \( U \).
If requested, `vt` contains the right singular vectors, as rows of \( V^T \).
 
### Syntax

`call ` [[stdlib_linalg(module):svd(interface)]] `(a, s, [, u, vt, overwrite_a, full_matrices, err])`

### Class

Subroutine

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the coefficient matrix of size `[m,n]`. It is an `intent(inout)` argument, but returns unchanged unless `overwrite_a=.true.`.

`s`: Shall be a rank-1 `real` array, returning the list of `k = min(m,n)` singular values. It is an `intent(out)` argument. 

`u` (optional): Shall be a rank-2 array of same kind as `a`, returning the left singular vectors of `a` as columns. Its size should be `[m,m]` unless `full_matrices=.false.`, in which case, it can be `[m,min(m,n)]`. It is an `intent(out)` argument.

`vt` (optional): Shall be a rank-2 array of same kind as `a`, returning the right singular vectors of `a` as rows. Its size should be `[n,n]` unless `full_matrices=.false.`, in which case, it can be `[min(m,n),n]`. It is an `intent(out)` argument.

`overwrite_a` (optional): Shall be an input `logical` flag. If `.true.`, input matrix `A` will be used as temporary storage and overwritten. This avoids internal data allocation. By default, `overwrite_a=.false.`. It is an `intent(in)` argument.

`full_matrices` (optional): Shall be an input `logical` flag. If `.true.` (default), matrices `u` and `vt` shall be full-sized. Otherwise, their secondary dimension can be resized to `min(m,n)`. See `u`, `v` for details.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return values

Returns an array `s` that contains the list of singular values of matrix `a`.
If requested, returns a rank-2 array `u` that contains the left singular vectors of `a` along its columns.
If requested, returns a rank-2 array `vt` that contains the right singular vectors of `a` along its rows.

Raises `LINALG_ERROR` if the underlying Singular Value Decomposition process did not converge.
Raises `LINALG_VALUE_ERROR` if the matrix or any of the output arrays invalid/incompatible sizes.
Exceptions trigger an `error stop`, unless argument `err` is present.

### Example

```fortran
{!example/linalg/example_svd.f90!}
```

## `svdvals` - Compute the singular values of a rank-2 array (matrix).

### Status

Stable

### Description

This subroutine computes the singular values of a `real` or `complex` rank-2 array (matrix) from its singular 
value decomposition \( A = U \cdot S \cdot \V^T \). The solver is based on LAPACK's `*GESDD` backends.

Result vector `s` returns the array of singular values on the diagonal of \( S \). 
 
### Syntax

`s = ` [[stdlib_linalg(module):svdvals(interface)]] `(a [, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the coefficient matrix of size `[m,n]`. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return values

Returns an array `s` that contains the list of singular values of matrix `a`.

Raises `LINALG_ERROR` if the underlying Singular Value Decomposition process did not converge.
Raises `LINALG_VALUE_ERROR` if the matrix or any of the output arrays invalid/incompatible sizes.
Exceptions trigger an `error stop`, unless argument `err` is present.

### Example

```fortran
{!example/linalg/example_svdvals.f90!}
```


## `cholesky` - Compute the Cholesky factorization of a rank-2 square array (matrix)

### Status

Experimental

### Description

This subroutine computes the Cholesky factorization of a `real` or `complex` rank-2 square array (matrix), 
\( A = L \cdot L^T \), or \( A = U^T \cdot U \). \( A \) is symmetric or complex Hermitian, and \( L \), 
\( U \) are lower- or upper-triangular, respectively. 
The solver is based on LAPACK's `*POTRF` backends.
 
### Syntax

`call ` [[stdlib_linalg(module):cholesky(interface)]] `(a, c, lower [, other_zeroed] [, err])`

### Class
Subroutine

### Arguments

`a`: Shall be a rank-2 square `real` or `complex` array containing the coefficient matrix of size `[n,n]`. It is an `intent(inout)` argument, but returns unchanged if the argument `c` is present.

`c` (optional): Shall be a rank-2 square `real` or `complex` of the same size and kind as `a`. It is an `intent(out)` argument, that returns the triangular Cholesky matrix `L` or `U`.

`lower`: Shall be an input `logical` flag. If `.true.`, the lower triangular decomposition \( A = L \cdot L^T \) will be performed. If `.false.`, the upper decomposition \( A = U^T \cdot U \) will be performed.

`other_zeroed` (optional): Shall be an input `logical` flag. If `.true.`, the unused part of the output matrix will contain zeroes. Otherwise, it will not be accessed. This saves cpu time. By default, `other_zeroed=.true.`. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument.

### Return values

The factorized matrix is returned in-place overwriting `a` if no other arguments are provided.
Otherwise, it can be provided as a second argument `c`. In this case, `a` is not overwritten.
The `logical` flag `lower` determines whether the lower- or the upper-triangular factorization should be performed. 

Results are returned on the applicable triangular region of the output matrix, while the unused triangular region 
is filled by zeroes by default. Optional argument `other_zeroed`, if `.false.` allows the expert user to avoid zeroing the unused part; 
however, in this case, the unused region of the matrix is not accessed and will usually contain invalid values. 

Raises `LINALG_ERROR` if the underlying process did not converge.
Raises `LINALG_VALUE_ERROR` if the matrix or any of the output arrays invalid/incompatible sizes.
Exceptions trigger an `error stop`, unless argument `err` is present.

### Example

```fortran
{!example/linalg/example_cholesky.f90!}
```

## `chol` - Compute the Cholesky factorization of a rank-2 square array (matrix)

### Status

Experimental

### Description

This is a `pure` functional interface for the Cholesky factorization of a `real` or
`complex` rank-2 square array (matrix) computed as \( A = L \cdot L^T \), or \( A = U^T \cdot U \). 
\( A \) is symmetric or complex Hermitian, and \( L \), \( U \) are lower- or upper-triangular, respectively. 
The solver is based on LAPACK's `*POTRF` backends.

Result matrix `c` has the same size and kind as `a`, and returns the lower or upper triangular factor. 
 
### Syntax

`c = ` [[stdlib_linalg(module):chol(interface)]] `(a, lower [, other_zeroed])`

### Arguments

`a`: Shall be a rank-2 square `real` or `complex` array containing the coefficient matrix of size `[n,n]`. It is an `intent(inout)` argument, but returns unchanged if argument `c` is present.

`lower`: Shall be an input `logical` flag. If `.true.`, the lower triangular decomposition \( A = L \cdot L^T \) will be performed. If `.false.`, the upper decomposition \( A = U^T \cdot U \) will be performed.

`other_zeroed` (optional): Shall be an input `logical` flag. If `.true.`, the unused part of the output matrix will contain zeroes. Otherwise, it will not be accessed. This saves cpu time. By default, `other_zeroed=.true.`. It is an `intent(in)` argument.

### Return values

Returns a rank-2 array `c` of the same size and kind as `a`, that contains the triangular Cholesky matrix `L` or `U`.

Raises `LINALG_ERROR` if the underlying process did not converge.
Raises `LINALG_VALUE_ERROR` if the matrix or any of the output arrays invalid/incompatible sizes.
Exceptions trigger an `error stop`, unless argument `err` is present.

### Example

```fortran
{!example/linalg/example_chol.f90!}
```


## `.inv.` - Inverse operator of a square matrix

### Status

Stable

### Description

This operator returns the inverse of a `real` or `complex` square matrix \( A \).
The inverse \( A^{-1} \) is defined such that \( A \cdot A^{-1} = A^{-1} \cdot A = I_n \).

This interface is equivalent to the function  [[stdlib_linalg(module):inv(interface)]]. 

### Syntax

`b = ` [[stdlib_linalg(module):operator(.inv.)(interface)]] `a`

### Arguments

`a`: Shall be a rank-2 square array of any `real` or `complex` kinds. It is an `intent(in)` argument.

### Return value

Returns a rank-2 square array with the same type, kind and rank as `a`, that contains the inverse of `a`.

If an exception occurred on input errors, or singular matrix, `NaN`s will be returned.
For fine-grained error control in case of singular matrices prefer the `subroutine` and the `function`
interfaces.

### Example

```fortran
{!example/linalg/example_inverse_operator.f90!}
```

## `invert` - Inversion of a square matrix

### Status

Stable

### Description

This subroutine inverts a square `real` or `complex` matrix in-place.
The inverse \( A^{-1} \) is defined such that \( A \cdot A^{-1} = A^{-1} \cdot A = I_n \).

On return, the input matrix `a` is replaced by its inverse.
The solver is based on LAPACK's `*GETRF` and `*GETRI` backends.

### Syntax

`call ` [[stdlib_linalg(module):invert(interface)]] `(a, [,inva] [, pivot] [, err])`

### Arguments

`a`: Shall be a rank-2, square, `real` or `complex` array containing the coefficient matrix. 
If `inva` is provided, it is an `intent(in)` argument.
If `inva` is not provided, it is an `intent(inout)` argument: on output, it is replaced by the inverse of `a`. 

`inva` (optional): Shall be a rank-2, square, `real` or `complex` array with the same size, and kind as `a`. 
On output, it contains the inverse of `a`.

`pivot` (optional): Shall be a rank-1 array of the same kind and matrix dimension as `a`, that contains the diagonal pivot indices on return. It is an `intent(inout)` argument. 

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument.

### Return value

Computes the inverse of the matrix \( A \), \(A^{-1}\, and returns it either in \( A \) or in another matrix.

Raises `LINALG_ERROR` if the matrix is singular or has invalid size.
Raises `LINALG_VALUE_ERROR` if `inva` and `a` do not have the same size.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_inverse_inplace.f90!}
```

```fortran
{!example/linalg/example_inverse_subroutine.f90!}
```

## `inv` - Inverse of a square matrix. 

### Status

Stable

### Description

This function returns the inverse of a square `real` or `complex` matrix in-place.
The inverse, \( A^{-1} \), is defined such that \( A \cdot A^{-1} = A^{-1} \cdot A = I_n \).

The solver is based on LAPACK's `*GETRF` and `*GETRI` backends.

### Syntax

`b ` [[stdlib_linalg(module):inv(interface)]] `(a, [, err])`

### Arguments

`a`: Shall be a rank-2, square, `real` or `complex` array containing the coefficient matrix. It is an `intent(inout)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument.

### Return value

Returns an array value of the same type, kind and rank as `a`, that contains the inverse matrix \(A^{-1}\).

Raises `LINALG_ERROR` if the matrix is singular or has invalid size.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_inverse_function.f90!}
```

## `pinv` - Moore-Penrose pseudo-inverse of a matrix

### Status

Experimental

### Description

This function computes the Moore-Penrose pseudo-inverse of a `real` or `complex` matrix.  
The pseudo-inverse, \( A^{+} \), generalizes the matrix inverse and satisfies the conditions:
- \( A \cdot A^{+} \cdot A = A \)
- \( A^{+} \cdot A \cdot A^{+} = A^{+} \)
- \( (A \cdot A^{+})^T = A \cdot A^{+} \)
- \( (A^{+} \cdot A)^T = A^{+} \cdot A \)

The computation is based on singular value decomposition (SVD). Singular values below a relative 
tolerance threshold \( \text{rtol} \cdot \sigma_{\max} \), where \( \sigma_{\max} \) is the largest 
singular value, are treated as zero.

### Syntax

`b =` [[stdlib_linalg(module):pinv(interface)]] `(a, [, rtol, err])`

### Arguments

`a`: Shall be a rank-2, `real` or `complex` array of shape `[m, n]` containing the coefficient matrix. 
It is an `intent(in)` argument.

`rtol` (optional): Shall be a scalar `real` value specifying the relative tolerance for singular value cutoff.  
If `rtol` is not provided, the default relative tolerance is \( \text{rtol} = \text{max}(m, n) \cdot \epsilon \),  
where \( \epsilon \) is the machine precision for the element type of `a`. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument.

### Return value

Returns an array value of the same type, kind, and rank as `a` with shape `[n, m]`, that contains the pseudo-inverse matrix \( A^{+} \).

Raises `LINALG_ERROR` if the underlying SVD did not converge.
Raises `LINALG_VALUE_ERROR` if `a` has invalid size.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_pseudoinverse.f90!}
```

## `pseudoinvert` - Moore-Penrose pseudo-inverse of a matrix

### Status

Experimental

### Description

This subroutine computes the Moore-Penrose pseudo-inverse of a `real` or `complex` matrix.
The pseudo-inverse \( A^{+} \) is a generalization of the matrix inverse and satisfies the following properties:
- \( A \cdot A^{+} \cdot A = A \)
- \( A^{+} \cdot A \cdot A^{+} = A^{+} \)
- \( (A \cdot A^{+})^T = A \cdot A^{+} \)
- \( (A^{+} \cdot A)^T = A^{+} \cdot A \)

The computation is based on singular value decomposition (SVD). Singular values below a relative 
tolerance threshold \( \text{rtol} \cdot \sigma_{\max} \), where \( \sigma_{\max} \) is the largest 
singular value, are treated as zero.

On return, matrix `pinva` `[n, m]` will store the pseudo-inverse of `a` `[m, n]`.

### Syntax

`call ` [[stdlib_linalg(module):pseudoinvert(interface)]] `(a, pinva [, rtol] [, err])`

### Arguments

`a`: Shall be a rank-2, `real` or `complex` array containing the coefficient matrix.  
It is an `intent(in)` argument.  

`pinva`: Shall be a rank-2 array of the same kind as `a`, and size equal to that of `transpose(a)`.  
On output, it contains the Moore-Penrose pseudo-inverse of `a`.

`rtol` (optional): Shall be a scalar `real` value specifying the relative tolerance for singular value cutoff.  
If not provided, the default threshold is \( \text{max}(m, n) \cdot \epsilon \), where \( \epsilon \) is the 
machine precision for the element type of `a`.

`err` (optional): Shall be a `type(linalg_state_type)` value. It is an `intent(out)` argument.

### Return value

Computes the Moore-Penrose pseudo-inverse of the matrix \( A \), \( A^{+} \), and returns it in matrix `pinva`.

Raises `LINALG_ERROR` if the underlying SVD did not converge.
Raises `LINALG_VALUE_ERROR` if `pinva` and `a` have degenerate or incompatible sizes.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_pseudoinverse.f90!}
```

## `.pinv.` - Moore-Penrose Pseudo-Inverse operator

### Status

Experimental

### Description

This operator returns the Moore-Penrose pseudo-inverse of a `real` or `complex` matrix \( A \).
The pseudo-inverse \( A^{+} \) is computed using Singular Value Decomposition (SVD), and singular values 
below a given threshold are treated as zero.

This interface is equivalent to the function [[stdlib_linalg(module):pinv(interface)]].

### Syntax

`b = ` [[stdlib_linalg(module):operator(.pinv.)(interface)]] `a`

### Arguments

`a`: Shall be a rank-2 array of any `real` or `complex` kinds, with arbitrary dimensions \( m \times n \). It is an `intent(in)` argument.

### Return value

Returns a rank-2 array with the same type, kind, and rank as `a`, that contains the Moore-Penrose pseudo-inverse of `a`.

If an exception occurs, or if the input matrix is degenerate (e.g., rank-deficient), the returned matrix will contain `NaN`s.
For more detailed error handling, it is recommended to use the `subroutine` or `function` interfaces.

### Example

```fortran
{!example/linalg/example_pseudoinverse.f90!}
```

## `get_norm` - Computes the vector norm of a generic-rank array.

### Status

Experimental

### Description

This `pure subroutine` interface computes one of several vector norms of `real` or `complex` array \( A \), depending on 
the value of the `order` input argument. \( A \) may be an array of any rank. 

Result `nrm` returns a `real`, scalar norm value for the whole array; if `dim` is specified, `nrm` is a rank n-1 
array with the same shape as \(A \) and dimension `dim` dropped, containing all norms evaluated along `dim`.

### Syntax

`call ` [[stdlib_linalg(module):get_norm(interface)]] `(a, nrm, order, [, dim, err])`

### Arguments

`a`: Shall be a rank-n `real` or `complex` array containing the data. It is an `intent(in)` argument.

`nrm`: if `dim` is absent, shall be a scalar with the norm evaluated over all the elements of the array. Otherwise, an array of rank `n-1`, and a shape similar
to that of `a` with dimension `dim` dropped.

`order`: Shall be an `integer` value or a `character` flag that specifies the norm type, as follows. It is an `intent(in)` argument. 

| Integer input    | Character Input  | Norm type                                               |
|------------------|------------------|---------------------------------------------------------|
| `-huge(0)`       | `'-inf', '-Inf'` | Minimum absolute value \( \min_i{ \left|a_i\right| } \) |
| `1`              | `'1'`            | 1-norm \( \sum_i{ \left|a_i\right| } \)                 |
| `2`              | `'2'`            | Euclidean norm \( \sqrt{\sum_i{ a_i^2 }} \)             |
| `>=3`            | `'3','4',...`    | p-norm \( \left( \sum_i{ \left|a_i\right|^p }\right) ^{1/p} \) |
| `huge(0)`        | `'inf', 'Inf'`   | Maximum absolute value \( \max_i{ \left|a_i\right| } \) |

`dim` (optional): Shall be a scalar `integer` value with a value in the range from `1` to `n`, where `n` is the rank of the array. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument. If `err` is not present, the function is `pure`. 

### Return value

By default, the return value `nrm` is a scalar, and contains the norm as evaluated over all elements of the generic-rank array \( A \). 
If the optional `dim` argument is present, `nrm` is a rank `n-1` array with the same shape as \( A \) except 
for dimension `dim`, that is collapsed. Each element of `nrm` contains the 1D norm of the elements of \( A \), 
evaluated along dimension `dim` only.

Raises `LINALG_ERROR` if the requested norm type is invalid.
Raises `LINALG_VALUE_ERROR` if any of the arguments has an invalid size.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_get_norm.f90!}
```

## `norm` - Computes the vector norm of a generic-rank array.

### Status

Experimental

### Description

This function computes one of several vector norms of `real` or `complex` array \( A \), depending on 
the value of the `order` input argument. \( A \) may be an array of any rank. 

### Syntax

`x = ` [[stdlib_linalg(module):norm(interface)]] `(a, order, [, dim, err])`

### Arguments

`a`: Shall be a rank-n `real` or `complex` array containing the data. It is an `intent(in)` argument.

`order`: Shall be an `integer` value or a `character` flag that specifies the norm type, as follows. It is an `intent(in)` argument. 

| Integer input    | Character Input  | Norm type                                               |
|------------------|------------------|---------------------------------------------------------|
| `-huge(0)`       | `'-inf', '-Inf'` | Minimum absolute value \( \min_i{ \left|a_i\right| } \) |
| `1`              | `'1'`            | 1-norm \( \sum_i{ \left|a_i\right| } \)                 |
| `2`              | `'2'`            | Euclidean norm \( \sqrt{\sum_i{ a_i^2 }} \)             |
| `>=3`            | `'3','4',...`    | p-norm \( \left( \sum_i{ \left|a_i\right|^p }\right) ^{1/p} \) |
| `huge(0)`        | `'inf', 'Inf'`   | Maximum absolute value \( \max_i{ \left|a_i\right| } \) |

`dim` (optional): Shall be a scalar `integer` value with a value in the range from `1` to `n`, where `n` is the rank of the array. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument. If `err` is not present, the function is `pure`. 

### Return value

By default, the return value `x` is a scalar, and contains the norm as evaluated over all elements of the generic-rank array \( A \). 
If the optional `dim` argument is present, `x` is a rank `n-1` array with the same shape as \( A \) except 
for dimension `dim`, that is dropped. Each element of `x` contains the 1D norm of the elements of \( A \), 
evaluated along dimension `dim` only.

Raises `LINALG_ERROR` if the requested norm type is invalid.
Raises `LINALG_VALUE_ERROR` if any of the arguments has an invalid size.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_norm.f90!}
```

## `mnorm` - Computes the matrix norm of a generic-rank array.

### Status

Experimental

### Description

This function computes one of several matrix norms of `real` or `complex` array \( A \), depending on 
the value of the `order` input argument. \( A \) must be an array of rank 2 or higher. For arrays of rank > 2,
matrix norms are computed over specified dimensions.

### Syntax

`x = ` [[stdlib_linalg(module):mnorm(interface)]] `(a [, order, dim, err])`

### Arguments

`a`: Shall be a rank-n `real` or `complex` array containing the data, where n >= 2. It is an `intent(in)` argument.

`order` (optional): Shall be an `integer` value or a `character` flag that specifies the norm type, as follows. It is an `intent(in)` argument. 

| Integer input    | Character Input                 | Norm type                                                                   |
|------------------|---------------------------------|-----------------------------------------------------------------------------|
| `1`              | `'1'`                           | 1-norm (maximum column sum) \( \max_j \sum_i{ \left|a_{i,j}\right| } \)     |
| `2`              | `'2'`                           | 2-norm (largest singular value)                                             |
| (not prov.)      | `'Euclidean','Frobenius','Fro'` | Frobenius norm \( \sqrt{\sum_{i,j}{ \left|a_{i,j}\right|^2 }} \)            |
| `huge(0)`        | `'inf', 'Inf', 'INF'`           | Infinity norm (maximum row sum) \( \max_i \sum_j{ \left|a_{i,j}\right| } \) |

`dim` (optional): For arrays of rank > 2, shall be an integer array of size 2 specifying the dimensions over which to compute the matrix norm. Default value is `[1,2]`. It is an `intent(in)` argument.

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument. 

### Return value

For rank-2 input arrays, the return value `x` is a scalar containing the matrix norm.
For arrays of rank > 2, if the optional `dim` argument is present, `x` is a rank `n-2` array with the same shape as \( A \) except 
for dimensions `dim(1)` and `dim(2)`, which are dropped. Each element of `x` contains the matrix norm of the corresponding submatrix of \( A \),
evaluated over the specified dimensions only, with the given order.

If an invalid norm type is provided, defaults to 1-norm and raises `LINALG_ERROR`.
Raises `LINALG_VALUE_ERROR` if any of the arguments has an invalid size.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_mnorm.f90!}
```

## `expm` - Computes the matrix exponential {#expm}

### Status

Experimental

### Description

Given a matrix \(A\), this function computes its matrix exponential \(E = \exp(A)\) using a Pade approximation.

### Syntax

`E = ` [[stdlib_linalg(module):expm(interface)]] `(a [, order])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the data. It is an `intent(in)` argument.

`order` (optional): Shall be a non-negative `integer` value specifying the order of the Pade approximation. By default `order=10`. It is an `intent(in)` argument. 

### Return value

The returned array `E` contains the Pade approximation of \(\exp(A)\).

If `A` is non-square or `order` is negative, it raises a `LINALG_VALUE_ERROR`.

### Example

```fortran
{!example/linalg/example_expm.f90!}
```

## `matrix_exp` - Computes the matrix exponential {#matrix_exp}

### Status

Experimental

### Description

Given a matrix \(A\), this function computes its matrix exponential \(E = \exp(A)\) using a Pade approximation.

### Syntax

`call ` [[stdlib_linalg(module):matrix_exp(interface)]] `(a [, e, order, err])`

### Arguments

`a`: Shall be a rank-2 `real` or `complex` array containing the data. If `e` is not passed, it is an `intent(inout)` argument and is overwritten on exit by the matrix exponential. If `e` is passed, it is an `intent(in)` argument and is left unchanged.

`e` (optional): Shall be a rank-2 `real` or `complex` array with the same dimensions as `a`. It is an `intent(out)` argument. On exit, it contains the matrix exponential of `a`.

`order` (optional): Shall be a non-negative `integer` value specifying the order of the Pade approximation. By default `order=10`. It is an `intent(in)` argument. 

`err` (optional): Shall be a `type(linalg_state_type)` value. This is an `intent(out)` argument. 

### Return value

The returned array `A` (in-place) or `E` (out-of-place) contains the Pade approximation of \(\exp(A)\).

If `A` is non-square or `order` is negative, it raises a `LINALG_VALUE_ERROR`.
If `err` is not present, exceptions trigger an `error stop`.

### Example

```fortran
{!example/linalg/example_matrix_exp.f90!}
```

---
title: bitsets
---

# The `stdlib_bitsets` module

[TOC]

## Introduction

The `stdlib_bitsets` module implements bitset types. A bitset is a
compact representation of a sequence of `bits` binary values. It can
equivalently be considered as a sequence of logical values or as a
subset of the integers 0 ... `bits-1`. For example, the value `1110`
can be considered as defining the subset of integers [1, 2, 3].
The bits are indexed from 0 to `bits(bitset)-1`.
A bitset is used when space savings are critical in applications
that require a large number of closely related logical values.
It may also improve performance by reducing memory traffic. To
implement bitsets the module
defines three bitset types, multiple constants, a character string
literal that can be read to and from strings and formatted files, a
simple character string literal that can be read to and from strings,
assignments, procedures, methods, and operators. Note that the module
assumes two's complement integers, but all current Fortran 95 and later
processors use such integers.

Note that the module defines a number of "binary" procedures,
procedures with two bitset arguments. These arguments must be of the
same type and should have the same number of `bits`. For reasons of
performance the module does not enforce the `bits` constraint, but
failure to obey that constraint results in undefined behavior. This
undefined behavior includes undefined values for those bits that
exceed the defined number of `bits` in the smaller bitset. The
undefined behavior may also include a "segmentation fault" for
attempting to address bits in the smaller bitset, beyond the defined
number of `bits`. Other problems are also possible.


## The module's constants

The module defines several public integer constants, almost all
intended to serve as error codes in reporting problems through an
optional `stat` argument. One constant, `bits_kind` is
the integer kind value for indexing bits and reporting counts of
bits. The other constants that are error codes are summarized below:

|Error Code|Summary|
|----------|-------|
|`success`|No problems found|
|`alloc_fault`|Failure with a memory allocation|
|`array_size_invalid_error`|Attempt to define either negative bits or more than 64 bits in a `bitset_64`|
|`char_string_invalid_error`|Invalid character found in a character string|
|`char_string_too_large_error`|Character string was too large to be encoded in the bitset|
|`char_string_too_small_error`|Character string was too small to hold the expected number of bits|
|`index_invalid_error`|Index to a bitstring was less than zero or greater than the number of bits|
|`integer_overflow_error`|Attempt to define an integer value bigger than `huge(0_bits_kind)`|
|`read_failure`|Failure on a `read` statement|
|`eof_failure`|An unexpected "End-of-File" on a `read` statement|
|`write_failure`|Failure on a `write` statement|


## The `stdlib_bitsets` derived types

The `stdlib_bitsets` module defines three derived types,
`bitset_type`, `bitset_64`, and `bitset_large`. `bitset_type` is an abstract
type that serves as the ancestor of `bitset_64` and
`bitset_large`. `bitset_type` defines one method, `bits`, and all of its
other methods are deferred to its extensions. `bitset_64` is a bitset
that can handle up to 64 bits. `bitset_large` is a bitset that can handle
up `huge(0_bits_kind)` bits. All attributes of the bitset types are
private. The various types each define a sequence of binary values: 0
or 1. In some cases it is useful to associate a logical value, `test`,
for each element of the sequence, where `test` is `.true.` if the value
is 1 and `.false.` otherwise. The number of such values in an entity
of that type is to be termed, `bits`. The bits are ordered in terms of
position, that, in turn, is indexed from 0 to `bits-1`. `bitset_type` is
used only as a `class` to define entities that can be either a `bitset_64` or
a `bitset_large`. The syntax for using the types are:

`class(` [[stdlib_bitsets(module):bitset_type(type)]] `) :: variable`

`type(` [[stdlib_bitsets(module):bitset_64(type)]] `) :: variable`

and

`type(` [[stdlib_bitsets(module):bitset_large(type)]] `) :: variable`

## The *bitset-literal*

A bitset value may be represented as a *bitset-literal-constant*
character string in source code or as a *bitset-literal* in
formatted files and non-constant strings.

*bitset-literal-constant* is ' *bitset-literal* '
                          or " *bitset-literal* "

*bitset-literal* is *bitsize-literal* *binary-literal*

*bitsize-literal* is S *digit* [ *digit* ] ...

*binary-literal* is B *binary-digit* [ *binary-digit* ] ...

*digit* is 0
        or 1
        or 2
        or 3
        or 4
        or 5
        or 6
        or 7
        or 8
        or 9


*binary-digit* is 0
               or 1

The *bitset-literal* consists of two parts: a *bitsize-literal* and a
*binary-literal*. The sequence of decimal digits that is part of the
*bitsize-literal* is interpreted as the decimal value of `bits`.
The *binary-literal* value is interpreted as a sequence of bit
values and there must be as many binary digits in the literal as there
are `bits`. The sequence of binary digits are treated as if they were
an unsigned integer with the i-th digit corresponding to the `bits-i`
bit position.

## The *binary-literal*

In defining the *bitset-literal* we also defined a
*binary-literal*. While not suitable for file I/0, the
*binary-literal* is suitable for transfer to and from character
strings. In that case the length of the string is the number of bits
and all characters in the string must be either "0" or "1".

## Summary of the module's operations

The `stdlib_bitsets` module defines a number of operations:

* "unary" methods of class `bitset_type`,
* "binary" procedure overloads of type `bitset_64` or `bitset_large`,
* assignments, and
* "binary" comparison operators of type `bitset_64` or `bitset_large`.

Each category will be discussed separately.

### Table of the `bitset_type` methods

The `bitset_type` class has a number of methods. All except one, `bits`,
are deferred. The methods consist of all procedures with one argument
of class `bitset_type`. The procedures with two arguments of type
`bitset_64` or `bitset_large` are not methods and are
summarized in a separate table of procedures. The methods are
summarized below:

|Method name|Class|Summary|
|-----------|-----|-------|
|`all`|function|`.true.` if all bits are 1, `.false.` otherwise|
|`any`|function|`.true.` if any bits are 1, `.false.` otherwise|
|`bit_count`|function|returns the number of bits that are 1|
|`bits`|function|returns the number of bits in the bitset|
|`clear`|subroutine|sets a sequence of one or more bits to 0|
|`flip`|subroutine|flips the value of a sequence of one or more bits|
|`from_string`|subroutine|reads the bitset from a string treating it as a binary literal|
|`init`|subroutine|creates a new bitset of size `bits` with no bits set|
|`input`|subroutine|reads a bitset from an unformatted I/O unit|
|`none`|function|`.true.` if no bits are 1, `.false.` otherwise|
|`not`|subroutine|performs a logical `not` operation on all the bits|
|`output`|subroutine|writes a bitset to an unformatted I/O unit|
|`read_bitset`|subroutine|reads a bitset from a bitset literal in a character string or formatted I/O unit|
|`set`|subroutine|sets a sequence of one or more bits to 1|
|`test`|function|`.true.` if the bit at `pos` is 1, `.false.` otherwise|
|`to_string`|subroutine|represents the bitset as a binary literal|
|`value`|function|1 if the bit at `pos` is 1, 0 otherwise|
|`write_bitset`|subroutine|writes a bitset as a bitset literal to a  character string or formatted I/O unit|

### Table of the non-member procedure overloads

The procedures with two arguments of type `bitset_large` or
`bitset_64` must have both arguments of the same known type which
prevents them from being methods. The bitwise "logical" procedures,
`and`, `and_not`, `or`, and `xor`  also require that the two bitset
arguments have the same number of bits, otherwise the results are
undefined. These procedures are summarized in the following table:

|Procedure name|Class|Summary|
|--------------|-----|-------|
|`and`|elemental subroutine|Sets `self` to the bitwise `and` of the original bits in `self` and `set2`|
|`and_not`|elemental subroutine|Sets `self` to the bitwise `and` of the original bits in `self` and the negation of `set2`|
|`extract`|subroutine|creates a new bitset, `new`, from a range in `old`|
|`or`|elemental subroutine|Sets `self` to the bitwise `or` of the original bits in `self` and `set2`|
|`xor`|elemental subroutine|Sets `self` to the bitwise exclusive `or` of the original bits in `self` and `set2`|


### Assignments

The module uses the intrinsic assignment operation, `=`, to create a
duplicate of an original bitset. It additionally defines assignments to and
from rank one arrays of logical type of kinds `int8`, `int16`,
`int32`, and `int64`. In the assignment to and from logical arrays
array index, `i`, is mapped to bit position, `pos=i-1`, and `.true.`
is mapped to a set bit, and `.false.` is mapped to an unset bit.


#### Example

```fortran
{!example/bitsets/example_bitsets_assignment.f90!}
```

### Table of the non-member comparison operations
The comparison operators with two arguments of type `bitset_large` or
`bitset_64` must have both arguments of the same known type which
prevents them from being methods. The operands must also have the same
number of bits otherwise the results are undefined. These operators
are summarized in the following table:

|Operator|Description|
|--------|-----------|
|`==`, `.eq.`|`.true.` if all bits in `set1` and `set2` have the same value, `.false.` otherwise|
|`/=`, `.ne.`|`.true.` if any bits in `set1` and `set2` differ in value, `.false.` otherwise|
|`>`, `.gt.`|`.true.` if the bits in `set1` and `set2` differ in value and the highest order differing bit is 1 in `set1` and 0 in `set2`, `.false.` otherwise|
|`>=`, `.ge.`|`.true.` if the bits in `set1` and `set2` are the same or the highest order differing bit is 1 in `set1` and 0 in `set2`, `.false.` otherwise|
|`<`, `.lt.`|`.true.` if the bits in `set1` and `set2` differ in value and the highest order differing bit is 0 in `set1` and 1 in `set2`, `.false.` otherwise|
|`<=`, `.le.`|`.true.` if the bits in `set1` and `set2` are the same or the highest order differing bit is 0 in `set1` and 1 in `set2`, `.false.` otherwise|


## Specification of the `stdlib_bitsets` methods and procedures

### `all` - determine whether all bits are set in `self`

#### Status

Experimental

#### Description

Determines whether all bits are set to 1 in `self`.

#### Syntax

`result = self % ` [[bitset_type(type):all(bound)]] `()`

#### Class

Elemental function.

#### Argument

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if all bits in `self` are set,
otherwise it is `.false.`.

#### Example

```fortran
{!example/bitsets/example_bitsets_all.f90!}
```

### `and` - bitwise `and` of the bits of two bitsets

#### Status

Experimental

#### Description

Sets the bits in `set1` to the bitwise `and` of the original bits in
`set1` and `set2`. Note that `set1` and `set2` must have the same
number of bits, otherwise the result is undefined.

#### Syntax

`call ` [[stdlib_bitsets(module):and(interface)]] `(set1, set2)`

#### Class

Elemental subroutine.

#### Arguments

`set1`: shall be a `bitset_64` or `bitset_large` scalar variable. It
is an `intent(inout)` argument. On return the values of the bits in
`set1` are the bitwise `and` of the original bits in `set1` with the
corresponding bits in `set2`.

`set2`: shall be a scalar expression of the same type as `set1`. It is
an `intent(in)` argument. Note that `set2` must also have the same
number of bits as `set1`.

#### Example

```fortran
{!example/bitsets/example_bitsets_and.f90!}
```

### `and_not` - Bitwise `and` of one bitset with the negation of another

#### Status

Experimental

#### Description

Sets the bits of `set1` to bitwise `and` of the bits of `set1` with
the bitwise negation of the corresponding bits of `set2`. Note that
`set1` and `set2` must have the same number of bits, otherwise the
result is undefined.

#### Syntax

`call ` [[stdlib_bitsets(module):and_not(interface)]] `(set1, set2)`

#### Class

Elemental subroutine.

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` variable. It
is an `intent(inout)` argument. On return the values of the bits in
`set1` are the bitwise `and` of the original bits in `set1` with the
corresponding negation of the bits in `set2`.

`set2`: shall be a scalar expression of the same type as `set1`. It is
an `intent(in)` argument. Note that it should also have the same
number of bits as `set1`, otherwise the result is undefined.

#### Example

```fortran
{!example/bitsets/example_bitsets_and_not.f90!}
```

### `any` - determine whether any bits are set

#### Status

Experimental

#### Description

Determines whether any bits are set in `self`.

#### Syntax

`result = self % ` [[bitset_type(type):any(bound)]] `()`

#### Class

Elemental function.

#### Argument

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

#### Result value

The result is a default logical scalar. The result is `.true.` if any bits in `self` are set, otherwise it
is `.false.`.

#### Example

```fortran
{!example/bitsets/example_bitsets_any.f90!}
```

### `bit_count` - return the number of bits that are set

#### Status

Experimental

#### Description

Returns the number of bits that are set to one in `self`.

#### Syntax

`result = self % ` [[bitset_type(type):bit_count(bound)]] ` ()`

#### Class

Elemental function.

#### Argument

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

#### Result value

The result is an integer scalar of kind `bits_kind`,
equal to the number of bits that are set in `self`.

#### Example

```fortran
{!example/bitsets/example_bitsets_bit_count.f90!}
```

#### `bits` - returns the number of bits

#### Status

Experimental

#### Description

Reports the number of bits in `self`.

#### Syntax

`result = self % ` [[bitset_type(type):bits(bound)]] ` ()`

#### Class

Elemental function.

#### Argument

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

#### Result value

The result is an integer scalar of kind `bits_kind`, equal to
the number of defined bits in `self`.

#### Example

```fortran
{!example/bitsets/example_bitsets_bits.f90!}
```

### `clear` - clears a sequence of one or more bits

#### Status

Experimental

#### Description

* If only `pos` is present, clears the bit with position `pos` in
`self`.

* If `start_pos` and `end_pos` are present with `end_pos >= start_pos`
clears the bits with positions from `start_pos` to `end_pos` in `self`.

* if `start_pos` and `end_pos` are present with `end_pos < start_pos`
`self` is unmodified.

Note: Positions outside the range 0 to `bits(set) -1` are ignored.

#### Syntax

`call self % ` [[bitset_type(type):clear(bound)]] `(pos)`

or

`call self % ` [[bitset_type(type):clear(bound)]] `(start_pos, end_pos)`

#### Class

Elemental subroutine

#### Arguments

`self`: shall be a scalar variable of class `bitset_type`. It is an
  `intent(inout)` argument.

`pos`: shall be a scalar integer expression of kind `bits_kind`. It is
an `intent(in)` argument.

`start_pos`: shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

`end_pos`: shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

#### Example

```fortran
{!example/bitsets/example_bitsets_clear.f90!}
```

### `extract` - create a new bitset from a range in an old bitset

#### Status

Experimental

#### Description

Creates a new bitset, `new`, from a range, `start_pos` to `stop_pos`,
in bitset `old`. If `start_pos` is greater than `stop_pos` the new
bitset is empty. If `start_pos` is less than zero or `stop_pos` is
greater than `bits(old)-1` then if `status` is present it has the
value `index_invalid_error`, otherwise processing stops with an
informative message.

#### Syntax

`call ` [[stdlib_bitsets(module):extract(interface)]] `(new, old, start_pos, stop_pos, status )`

#### Class

Subroutine

####  Arguments

`new`: shall be a scalar `bitset_64` or  `bitset_large` variable. It
is an `intent(out)` argument. It will be the new bitset.

`old`: shall be a scalar expression of the same type as `new`. It is
an `intent(in)` argument. It will be the source bitset.

`start_pos`: shall be a scalar integer expression of the kind
`bits_kind`. It is an `intent(in)` argument.

`stop_pos`: shall be a scalar integer expression of the kind
`bits_kind`. It is an `intent(in)` argument.

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument. If present it shall have one of the values:

* `success` - no problems found

* `index_invalid_error` - `start_pos` was less than zero or `stop_pos`
  was greater than `bits(old)-1`.

#### Example

```fortran
{!example/bitsets/example_bitsets_extract.f90!}
```

### `flip` - flip the values of a sequence of one or more bits

#### Status

Experimental

#### Description

Flip the values of  a sequence of one or more bits.

* If only `pos` is present flip the bit value with position `pos` in

  `self`.
* If `start_pos` and `end_pos` are present with `end_pos >= start_pos`
flip the bit values with positions from `start_pos` to `end_pos` in
`self`.

* If `end_pos < start_pos` then `self` is unmodified.


#### Syntax

`call self % ` [[bitset_type(type):flip(bound)]] ` (pos)`

or

`call self % ` [[bitset_type(type):flip(bound)]] ` (start_pos, end_pos)`

#### Class

Elemental subroutine.

#### Arguments

`self`: shall be a scalar class `bitset_type` variable It is an
`intent(inout)` argument.

`pos`: shall be a scalar integer expression of kind `bits_kind`. It is
an `intent(in)` argument.

`start_pos`: shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

`end_pos`: shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

#### Example

```fortran
{!example/bitsets/example_bitsets_flip.f90!}
```

### `from_string` - initializes a bitset from a binary literal

#### Status

Experimental

#### Description

Initializes the bitset `self` from `string`, treating `string` as a
binary literal.

#### Syntax

`call self % ` [[bitset_type(type):from_string(bound)]] `(string[, status])`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar class `bitset_type` variable. It is an
`intent(out)` argument.

`string`: shall be a scalar default character expression. It is an
`intent(in)` argument. It shall consist only of the characters "0",
and "1".

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument. If present, on return its value shall be
one of the error codes defined in this module. If absent, and its
value would not have been `success`, then processing will stop with an
informative text as its stop code. It shall have one of the error
codes:

* `success` - if no problems were found,

* `alloc_fault` - if allocation of the bitset failed

* `char_string_too_large_error` - if `string` was too large, or 

* `char_string_invalid_error` - if string had an invalid character.


#### Example

```fortran
{!example/bitsets/example_bitsets_from_string.f90!}
```

### `init` - `bitset_type` initialization routines

#### Status

Experimental

#### Description

`bitset_type` initialization routine.

#### Syntax

`call self % ` [[bitset_type(type):init(bound)]] ` (bits [, status])`

#### Class

Subroutine.

#### Arguments

`self`: shall be a scalar `bitset_64` or `bitset_large` variable. It
is an `intent(out)` argument.

`bits`: shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument that if present
specifies the number of bits in `set`. A negative value, or a value
greater than 64 if `self` is of type `bitset_64`, is an error.

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument that, if present, returns an error code
indicating any problem found in processing `init`, and if absent and
an error was found result in stopping processing with an informative
stop code. It can have any of the following error codes:

* `success` - no problem found

* `alloc_fault` - `self` was of type `bitset_large` and memory
  allocation failed

* `array_size_invalid_error` - bits was present with either a negative
  value, or a value greater than 64 when `self` was of type
  `bitset_64`.

#### Example

```fortran
{!example/bitsets/example_bitsets_init.f90!}
```

### `input` - reads a bitset from an unformatted file

#### Status

Experimental

#### Description

Reads a bitset from its binary representation in an unformatted
file.

#### Syntax

`call self % ` [[bitset_type(type):input(bound)]] ` (unit [, status])`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of class `bitset_64` or
`bitset_large`. It is an `intent(out)` argument.

`unit`: shall be a scalar default integer expression. It is an
`intent(in)` argument. Its value must be that of a logical unit
number for an open unformatted file with `read` or `readwrite`
access positioned at the start of a bitset value written by a
`bitset_type` `output` subroutine by the same processor.

`status` (optional): shall be a scalar default integer variable. If
present its value shall be of one of the error codes defined in this
module. If absent and it would have had a value other than `success`
processing will stop with an informative stop code. Allowed error code
values for this `status` are:

* `success` - no problem found

* `alloc_fault` - `self` was of type `bitset_large` and allocation of
  memory failed.

* `array_size_invalid_error` - if the number of bits read from `unit`
  is either negative or greater than 64, if class of `self` is
  `bitset_64`.

* `read_failure` - failure during a read statement

#### Example

```fortran
{!example/bitsets/example_bitsets_input.f90!}
```

### `none` - determines whether no bits are set

#### Status

Experimental

#### Description

Determines whether no bits are set in `self`.

#### Syntax

`result = self % ` [[bitset_type(type):none(bound)]] ` ()`

#### Class

Elemental function.

#### Argument

`self`: shall be a scalar expression of class `bitset_type`. It is an
  `intent(in)` argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if no bits in `self` are set, otherwise it is
`.false.`.

#### Example

```fortran
{!example/bitsets/example_bitsets_none.f90!}
```

### `not` - Performs the logical complement on a bitset

#### Status

Experimental

#### Description

Performs the logical complement on the bits of `self`.

#### Syntax

`call self % ` [[bitset_type(type):not(bound)]] ` ()`

#### Class

Elemental subroutine.

#### Argument

`self` shall be a scalar variable of class `bitset_type`. It is an
`intent(inout)` argument. On return its bits shall be the logical
complement of their values on input.

#### Example

```fortran
{!example/bitsets/example_bitsets_not.f90!}
```

### `or` - Bitwise OR of the bits of two bitsets

#### Status

Experimental

#### Description

Replaces the original bits of `set1` with the bitwise `or` of those
bits with the bits of `set2`. Note `set1` and `set2` must have the
same number of bits, otherwise the result is undefined.

#### Syntax

`call ` [[stdlib_bitsets(module):or(interface)]] `(set1, set2)`

#### Class

Elemental subroutine.

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` variable. It
is an `intent(inout)` argument. On return the values of the bits in
`setf` are the bitwise `or` of the original bits in `set1` with the
corresponding bits in `set2`.

`set2`: shall be a scalar expression of the same type as `set1`. It is
an `intent(in)` argument. Note `bits(set2)` must equal `bits(set1)`
otherwise the results are undefined.

#### Example

```fortran
{!example/bitsets/example_bitsets_or.f90!}
```

### `output` - Writes a binary representation of a bitset to a file

#### Status

Experimental

#### Description

Writes a binary representation of a bitset to an unformatted file.

#### Syntax

`call self % ` [[bitset_type(type):output(bound)]] ` (unit[, status])`

#### Class

Subroutine.

#### Arguments

`self`: shall be a scalar expression of class `bitset_64` or
`bitset_large`. It is an `intent(in)` argument.

`unit`: shall be a scalar default integer expression. It is an
`intent(in)` argument. Its value must be that of an I/O unit number
for an open unformatted file with `write` or `readwrite` access.

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument. If present on return it will have the value
of `success` or `write_failure`. If absent and it would not have the
value of `success` then processing will stop with an informative stop
code. The two code values have the meaning:

* `success` - no problem found

* `write_failure` - a failure occurred in a write statement.

#### Example

```fortran
{!example/bitsets/example_bitsets_output.f90!}
```

### `read_bitset` - initializes `self` with the value of a *bitset_literal*

#### Status

Experimental

#### Description

Reads a *bitset-literal* and initializes `self` with the corresponding
value.


#### Syntax

`call self % ` [[bitset_type(type):read_bitset(bound)]] `(string[, status])`

or

`call self % ` [[bitset_type(type):read_bitset(bound)]] `(unit[, advance, status])`


#### Class

Subroutine

#### Arguments

`self`: shall be a scalar variable of class `bitset_type`. It is an
`intent(out)` argument. Upon a successful return it is initialized with
the value of a *bitset-literal*.

`string` (optional): shall be a scalar default character
expression. It is an `intent(in)` argument. It will consist of a left 
justified *bitset-literal*, terminated by either the end of the string
or a blank.

`unit` (optional): shall be a scalar default integer expression. It is
an `intent(in)` argument. Its value must be that of an I/O unit number
for an open formatted file with `read` or `readwrite` access
positioned at the start of a *bitset-literal*.

`advance` (optional): shall be a scalar default character
expression. It is an `intent(in)` argument. It is the `advance`
specifier for the final read of `unit`. If present it should have
the value `'yes'` or `'no'`. If absent it has the default value of
`'yes'`.

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument. If present on return it shall have the
value of one of the error codes of this module. If absent and it would
not have had the value `success` processing will stop with a message
as its error code. The possible error codes are:

* `success` - no problems found;

* `alloc_fault` - if `self` is of class `bitset_large` and allocation
  of the bits failed;

* `array_size_invalid_error` - if the *bitset-literal* has a bits
  value greater than 64 and `self` is of class `bitset_64`;

* `char_string_invalid_error` - if the `bitset-literal` has an invalid
  character;

* `char_string_too_small_error` - if `string` ends before all the bits
  are read;

* `eof_failure` -  if a `read` statement reached an end-of-file before
   completing the read of the bitset literal,

* `integer_overflow_error` - if the *bitset-literal* has a `bits`
  value larger than `huge(0_bits_kind)`; or

* `read_failure` - if a read statement failed.

#### Example

```fortran
{!example/bitsets/example_bitsets_read_bitset.f90!}
```

### `set` - sets a sequence of one or more bits to 1

#### Status

Experimental

#### Description

Sets a sequence of one or more bits in `self` to 1.

* If `start_pos` and `end_pos` are absent sets the bit at position
`pos` in `self` to 1.

* If `start_pos` and `end_pos` are present with `end_pos >= start_pos`
set the bits at positions from `start_pos` to `end_pos` in `self` to 1.

* If `start_pos` and `end_pos` are present with `end_pos < start_pos`
`self` is unchanged.

* Positions outside the range 0 to `bits(self)` are ignored.


#### Syntax

`call self % ` [[bitset_type(type):set(bound)]] ` (POS)`

or

`call self % ` [[bitset_type(type):set(bound)]] ` (START_POS, END_POS)`

#### Class

Elemental subroutine

#### Arguments

`self`: shall be a scalar variable of class `bitset_type`. It is an
  `intent(inout)` argument.

`pos` (optional): shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

`start_pos` (optional): shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

`end_pos` (optional): shall be a scalar integer expression of kind
`bits_kind`. It is an `intent(in)` argument.

#### Example

```fortran
{!example/bitsets/example_bitsets_set.f90!}
```

### `test` - determine whether a bit is set

#### Status

Experimental

#### Descriptions

Determine whether the bit at position `pos` is set to 1 in `self`.


#### Syntax

`result = self % ` [[bitset_type(type):test(bound)]] `(pos)`

#### Class

Elemental function.

#### Arguments

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

`pos`: shall be a scalar integer expression of kind `bits_kind`. It is
an `intent(in)` argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if the bit at `pos` in `self` is set,
otherwise it is `.false.`. If `pos` is outside the range
`0... bits(self)-1` the result is `.false.`.

#### Example

```fortran
{!example/bitsets/example_bitsets_test.f90!}
```

### `to_string` - represent a bitset as a binary literal

### Status

Experimental

#### Description

Represents the value of `self` as a binary literal in `string`.

#### Syntax

`call self % ` [[bitset_type(type):to_string(bound)]] `(string[, status])`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

`string`: shall be a scalar default character variable of allocatable
length. It is an `intent(out)` argument. On return it shall have a
*binary-literal* representation of the bitset `self`.

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument. If present it shall have either the value
`success` or `alloc_fault`. If absent and it would have had the value
`alloc_fault` then processing will stop with an informative test as
the stop code. The values have the following meanings:

`success` - no problem found.

`alloc_fault` - allocation of `string` failed.


#### Example

```fortran
{!example/bitsets/example_bitsets_to_string.f90!}
```

### `value` - determine the value of a bit

#### Status

Experimental

#### Description

Determines the value of the bit at position, `pos`, in `self`.

#### Syntax

`result = self % ` [[bitset_type(type):value(bound)]] `(pos)`

#### Class

Elemental function.

#### Arguments

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

`pos`: shall be a scalar integer expression of kind `bits_kind`. It is
an `intent(in)` argument.

#### Result value

The result is a default integer scalar.
The result is one if the bit at `pos` in `self` is set, otherwise it
is zero. If `pos` is outside the range `0... bits(set)-1` the result
is zero.

#### Example

```fortran
{!example/bitsets/example_bitsets_value.f90!}
```

### `write_bitset` - writes a *bitset-literal*

#### Status

Experimental

#### Description

Writes a *bitset-literal* representing `self`'s current value to a
character string or formatted file.


#### Syntax

`call self % ` [[bitset_type(type):write_bitset(bound)]] `(string[, status])`

or

`call self % ` [[bitset_type(type):write_bitset(bound)]] ` (unit[, advance, status])`

#### Class

Subroutine

#### Arguments

`self`: shall be a scalar expression of class `bitset_type`. It is an
`intent(in)` argument.

`string` (optional): shall be a scalar default character variable of
allocatable length. It is an `intent(out)` argument.

`unit` (optional): shall be a scalar default logical expression. It is
an `intent(in)` argument. Its value must be that of a I/O unit number
for an open formatted file with `write` or `readwrite` access.

`advance` (optional): shall be a scalar default character
expression. It is an `intent(in)` argument. It is the `advance` 
specifier for the write to `unit`. If present it must have the value
`'yes'` or `'no'`. It has the default value of `'yes'`.

* if `advance` is not present or is present with a value of `'no'`
  then the bitset's *bitset-literal* is written to `unit`
  followed by a blank, and the current record is not advanced.

* If `advance` is present with a value of `'yes'` then the
  bitset's *bitset-literal* is written to `unit` and the
  record is immediately advanced.

`status` (optional): shall be a scalar default integer variable. It is
an `intent(out)` argument. If present on return it shall have the
value of one of the module's error codes. If absent and a problem was
found processing will stop with an informative stop code. It may have
the following error code values:

* `success` - no problem was found

* `alloc_fault` - allocation of the string failed

* `write_failure` - the `write` to the `unit` failed

#### Example

```fortran
{!example/bitsets/example_bitsets_write_bitset.f90!}
```

### `xor` - bitwise exclusive `or`

#### Status

Experimental

#### Description

Replaces `set1`'s bitset with the bitwise exclusive `or` of the
original bits of `set1` and `set2`. Note `set1` and `set2` must have
the samee number of bits, otherwise the result is undefined.

#### Syntax

`result = ` [[stdlib_bitsets(module):xor(interface)]] ` (set1, set2)`

#### Class

Elemental subroutine

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` variable. It
is an `intent(inout)` argument. On return the values of the bits in
`set1` are the bitwise exclusive `or` of the original bits in `set1`
with the corresponding bits in `set2`.

`set2` shall be a scalar expression of the same type as `set1`. It is
  an `intent(in)` argument. Note `set1` and `set2` must have the
samee number of bits, otherwise the result is undefined.

#### Example

```fortran
{!example/bitsets/example_bitsets_xor.f90!}
```

## Specification of the `stdlib_bitsets` operators

### `==` - compare two bitsets to determine whether the bits have the same value

#### Status

Experimental

#### Description

Returns `.true.` if all bits in `set1` and `set2` have the same value,
`.false.`  otherwise.

#### Syntax

`result = set1 ` [[stdlib_bitsets(module):==(interface)]] ` set2`

or

`result = set1 .EQ. set2`

#### Class

Elemental operator

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` expression. It
is an `intent(in)` argument.

`set2`: shall be a scalar expression of the same type as `self`. It
will have the same number of bits as `set1`. It is an `intent(in)`
argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if the bits in both bitsets are set
to the same value, otherwise the result is `.false.`.

#### Example

```fortran
{!example/bitsets/example_bitsets_equality.f90!}
```

### `/=` - compare two bitsets to determine whether any bits differ in value

#### Status

Experimental

#### Description

Returns `.true.` if any bits in `self` and `set2` differ in value,
`.false.`  otherwise.

#### Syntax

`result = set1 ` [[stdlib_bitsets(module):/=(interface)]] ` set2`

or

`result = set1 .NE. set2`

#### Class

Elemental function

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` expression. It
is an `intent(in)` argument.

`set2`: shall be a scalar expression of the same type as `self`. It
will have the same number of bits as `set1`. It is an `intent(in)`
argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if any bits in both bitsets differ, otherwise
the result is `.false.`.

#### Example

```fortran
{!example/bitsets/example_bitsets_inequality.f90!}
```

### `>=` - compare two bitsets to determine whether the first is greater than or equal to the second

#### Status

Experimental

#### Description

Returns `.true.` if the bits in `set1` and `set2` are the same or the
highest order different bit is set to 1 in `set1` and to 0 in `set2`,
`.false.`.  otherwise. The sets must be the same size otherwise the
results are undefined.

#### Syntax

`result = set1 ` [[stdlib_bitsets(module):>=(interface)]] ` set2`

or

`result = set1 .GE. set2`

#### Class

Elemental operator

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` expression. It
is an `intent(in)` argument.

`set2`: shall be a scalar expression of the same type as `self`. It
will have the same number of bits as `set1`. It is an `intent(in)`
argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if the bits in `set1` and `set2` are the same
or the highest order different bit is set to 1 in `set1` and to 0 in
`set2`, `.false.`  otherwise.

#### Example

```fortran
{!example/bitsets/example_bitsets_ge.f90!}
```

### `>` - compare two bitsets to determine whether the first is greater than the other

#### Status

Experimental

#### Description

Returns `.true.` if the bits in `set1` and `set2` differ and the
highest order different bit is set to 1 in `set1` and to 0 in `set2`,
`.false.` otherwise. The sets must be the same size otherwise the
results are undefined.

#### Syntax

`result = set1 ` [[stdlib_bitsets(module):>(interface)]] ` set2`

or

`result = set1 .GT. set2`

#### Class

Elemental operator

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` expression. It
is an `intent(in)` argument.

`set2`: shall be a scalar expression of the same type as `self`. It
will have the same number of bits as `set1`. It is an `intent(in)`
argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if the bits in `set1` and `set2` differ and the
highest order different bit is set to 1 in `set1` and to 0 in `set2`,
`.false.` otherwise.

#### Example

```fortran
{!example/bitsets/example_bitsets_gt.f90!}
```

### `<=` - compare two bitsets to determine whether the first is less than or equal to the other

#### Status

Experimental

#### Description

Returns `.true.` if the bits in `set1` and `set2` are the same or the
highest order different bit is set to 0 in `set1` and to 1 in `set2`,
`.false.` otherwise. The sets must be the same size otherwise the
results are undefined.

#### Syntax

`result = set1 ` [[stdlib_bitsets(module):<=(interface)]] ` set2`

or

`result = set1 .LE. set2`

#### Class

Elemental operator

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` expression. It
is an `intent(in)` argument.

`set2`: shall be a scalar expression of the same type as `self`. It
will have the same number of bits as `set1`. It is an `intent(in)`
argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if the bits in `set1` and `set2` are the same
or the highest order different bit is set to 0 in `set1` and to 1 in
`set2`, `.false.` otherwise.

#### Example

```fortran
{!example/bitsets/example_bitsets_le.f90!}
```

### `<` - compare two bitsets to determine whether the first is less than the other

#### Status

Experimental

#### Description

Returns `.true.` if the bits in `set1` and `set2` differ and the
highest order different bit is set to 0 in `set1` and to 1 in `set2`,
`.false.`  otherwise. The sets must be the same size otherwise the
results are undefined.

#### Syntax

`result = set1 ` [[stdlib_bitsets(module):<(interface)]] ` set2`

or

`result = set1 .LT. set2

#### Class

Elemental operator

#### Arguments

`set1`: shall be a scalar `bitset_64` or `bitset_large` expression. It
is an `intent(in)` argument.

`set2`: shall be a scalar expression of the same type as `self`. It
will have the same number of bits as `set1`. It is an `intent(in)`
argument.

#### Result value

The result is a default logical scalar.
The result is `.true.` if the bits in `set1` and `set2` differ and the
highest order different bit is set to 0 in `set1` and to 1 in `set2`,
`.false.` otherwise.

#### Example

```fortran
{!example/bitsets/example_bitsets_lt.f90!}
```

---
title: constants
---

[TOC]

## Introduction


The [[stdlib_constants]] module provides mathematical constants and the most common physical constants.

**Warning**: The names of the most common physical constants are kept short as they are inside a dedicated module. 
Nonetheless, in case of overlapping names, they can always be renamed as following:

```fortran
use stdlib_constants, only: clight => c
```

## Codata

The [[stdlib_codata(module)]] module defines all codata (physical) constants as derived 
type. The module is automatically generated with a simple 
[parser written in Python](https://github.com/MilanSkocic/codata/)
The latest codata constants were released in 2022 by the [NIST](http://physics.nist.gov/constants)
All values for the codata constants are provided as double precision reals. 
The names are quite long and can be aliased with shorter names.

The derived type [[stdlib_codata_type(module):codata_constant_type(type)]] defines:

* 4 members:

    * `name` (string)
    * `value` (double precision real)
    * `uncertainty` (double precision real)
    * `unit` (string)

* 2 type-bound procedures:

    * `print`: to print the values of the constant members;
    * `to_real`: to get the value or the uncertainty to the desired precision.

A module level interface [[stdlib_codata_type(module):to_real(interface)]] is 
available for getting the constant value or uncertainty of a constant. 

## `to_real` - Get the constant value or its uncertainty.

### Status

Experimental

### Description

Convert a [[stdlib_codata_type(module):codata_constant_type(type)]] to a `real` (at least `sp`, or `dp`) scalar. 
**Warning**: Some constants cannot be converted to single precision `sp` reals due to the value of the exponents.

### Syntax

`r = ` [[stdlib_codata_type(module):to_real(interface)]] `(c, mold [, uncertainty])`

### Arguments

`c`: argument has `intent(in) ` and shall be of type [[stdlib_codata_type(module):codata_constant_type(type)]].

`mold`: argument has `intent(in)` and shall be of `real` type. 
**Note**: The type of the `mold` argument defines the type of the result.

`uncertainty` (optional): argument has `intent(in)` and shall be of `logical` type. 
It specifies if the uncertainty needs to be returned instead of the value. Default to `.false.`.

### Return value

Returns a scalar of `real` type which is either the value or the uncertainty of a codata constant.

## Example

```fortran
{!example/constants/example_constants.f90!}
```

---
title: hash
---

# The `stdlib_hash_32bit` and `stdlib_hash_64bit` modules

[TOC]

## Overview of hash procedures

The comparison of lexical entities or other objects for equality
can be computationally expensive.
This cost is often reduced by computing a near unique integer value,
termed a hash code, from the structure of the object using a procedure
termed a hash function.
Equality of hash codes is a necessary, but not sufficient, condition
for the original objects to be equal.
As integer comparisons are very efficient, performing an initial
comparison of hash codes and then performing a detailed comparison
only if the hash codes are equal can improve performance.
The hash codes, in turn, can be mapped to a smaller set of integers,
that can be used as an index, termed a hash index, to a rank-1
array, often termed a hash table.
This mapping will be known as a scalar hash.
The use of a hash table reduces the number of hash codes that need to
be compared, further improving performance.
A hash function can also be used to generate a checksum to verify that
data has not changed.
The Fortran Standard Library therefore provides procedures to compute
hash codes and scalar hashes.
This document only discusses the hash codes and scalar hashes in the
library.

## Licensing

The Fortran Standard Library is distributed under the MIT License.
However components of the library may be based on code released under a
different license. In particular, the hash codes are often based
on algorithms considered as public domain (`Fibonacci Hash`, `Universal
Multiplicative Hash)`or released under a different license than the
MIT license (`FNV-1 Hash`, `FNV-1A Hash`, `nmhash32`, `nmhash32x`,
`waterhash`, `pengyhash` and `SpookyHash`)
The licensing status of the algorithms are discussed below.

`fibonacci_hash` is a scalar hash. It is an implementation in Fortran
2008 and signed two's complement integers of the Fibonacci Hash
described in D. E. Knuth, "The Art of
Computer Programming, Second Edition, Volume 3, Sorting and
Searching", Addison-Wesley, Upper Saddle River, NJ,
pp. 517-518, 1998. The algorithms in that source are considered public
domain, and its use is unrestricted.

`universal_mult_hash` is a scalar hash. It is an implementation in
Fortran 2008 and signed two's complement integers of the
universal multiplicative hash algorithm of M. Dietzfelbinger,
T. Hagerup, J. Katajainen, and M. Penttonen, "A Reliable Randomized
Algorithm for the Closest-Pair Problem," J. Algorithms, Vol. 25,
No. 1, Oct. 1997, pp. 19-51. Because of its publication in the Journal
of Algorithms, the universal multiplicative hash algorithm is public
domain.

`fnv_1_hash` and `fnv_1a_hash` are translations to Fortran 2008 and
signed two's complement integers of the
`FNV-1` and `FNV-1a` hash functions of Glenn Fowler, Landon Curt Noll,
and Phong Vo, that has been released into the public
domain. Permission has been granted, by Landon Curt Noll, for the use
of these algorithms in the Fortran Standard Library. A description of
these functions is available at
<https://en.wikipedia.org/wiki/Fowler–Noll–Vo_hash_function>.
These functions have been modified from their normal forms to also
encode the structure size in the output hash.

Similarly `spooky_hash` and associated procedures are translations to
Fortran 2008 and signed two's complement integers of the unsigned 64
bit version 2 `SpookyHash` functions of Bob
Jenkins <https://burtleburtle.net/bob/hash/spooky.html> to signed 64
bit operations. Version 2 was chosen over version 1 as it has better
performance and fewer bad seeds
Bob Jenkins has also put this code in the public
domain and has given permission to treat this code as public domain in
the USA, provided the code can be used under other licenses and he is
given appropriate credit.

`nmhash32` and `nmhash32x` are translations to Fortran 2008 and signed
two's complement integers of the unsigned 32-bit
hashes of James Z. M. Gao's `nmhash32` and `nmhash32x` version of 0.2,
<https://github.com/gzm55/hash-garage/blob/a8913138bdb3b7539c202edee30a7f0794bbd835/nmhash.h>
James Z. M. Gao has released his code under the BSD 2 Clause
License. The BSD 2-Clause license is as follows:

    BSD 2-Clause License

    Copyright (c) 2021, James Z.M. Gao
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
    SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
    INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
    CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
    POSSIBILITY OF SUCH DAMAGE.

`water_hash` is a translation to Fortran 2008  and signed two's
complement integers of the `waterhash` algorithm
of Tommy Ettinger. This algorithm is inspired by the Wy Hash of
Wang Yi. Tommy Ettinger's original C++ code, `waterhash.h`,
is available at URL: <https://github.com/tommyettinger/waterhash> under
the `unlicense`,
<https://github.com/tommyettinger/waterhash/blob/master/LICENSE>.
The `unlicense` reads as follows:

    This is free and unencumbered software released into the public domain.
    Anyone is free to copy, modify, publish, use, compile, sell, or
    distribute this software, either in source code form or as a compiled
    binary, for any purpose, commercial or non-commercial, and by any
    means.

    In jurisdictions that recognize copyright laws, the author or authors
    of this software dedicate any and all copyright interest in the
    software to the public domain. We make this dedication for the benefit
    of the public at large and to the detriment of our heirs and
    successors. We intend this dedication to be an overt act of
    relinquishment in perpetuity of all present and future rights to this
    software under copyright law.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
    OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
    ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
    OTHER DEALINGS IN THE SOFTWARE.

    For more information, please refer to <http://unlicense.org>

`pengy_hash` is a translation to Fortran 2008 and signed two's
complement arithmetic of the `pengyhash` algorithm of Alberto Fajardo,
copyright 2020. Alberto Fajardo's original C code, `pengyhash.c`, is
available at the URL:
https://github.com/tinypeng/pengyhash/blob/master/pengyhash.c
under the BSD 2-Clause License:
https://github.com/tinypeng/pengyhash/blob/master/LICENSE

The BSD 2-Clause license is as follows:

    BSD 2-Clause License

    pengyhash
    Copyright (c) 2020 Alberto Fajardo
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

    1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

    2. Redistributions in binary form must reproduce the above
    copyright notice, this list of conditions and the following
    disclaimer in the documentation and/or other materials provided
    with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
    BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
    EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
    TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

## Glossary

There are a few words used in this document that may not be familiar to
readers of this document:

* Key - a value to be used to find entries in a hash table typically
  using its hashed value for the initial search;

* Salt - see seed, and;

* Seed - an additional argument to a hash function that changes its
  output making some attacks impractical.


## The hash codes modules

### Overview of the modules

The Standard Library provides two modules implementing hash
functions and scalar hashes.
The `stdlib_hash_32bit` module provides procedures to
compute 32-bit integer hash codes and a scalar hash.
The hash codes can be used for tables of up to `2**30` entries, and
for keys with a few hundred elements, but performance has only been
tested for tables up to `2**16` entries and performance may degrade
for larger numbers of entries.
The `stdlib_hash_64bit` module provides hash procedures to
compute 64-bit integer hash codes and a scalar hash.
The hash codes can, in principle, be used for tables of up to `2**62`
entries, and for keys with a few thousand elements, but testing of
performance has only been been for tables up to `2**16`elements and
performance may degrade for larger numbers of entries.
While one of the codes in `stdlib_hash_64bit`,
`SPOOKY_HASH`, can also be used to calculate 128 bit hash codes, none
of the current codes can be used to calculate 256 bit hash codes.
Such larger hash codes are useful for larger hash tables and keys, and
for checksums.
Such larger keys and tables are little used, if used at all, in
current
Fortran codes, but the larger hash codes may be added to the library
if there is a demand for them.

Hash functions are often divided into two categories
"cryptographic" and "non-cryptographic".
Cryptographic hash functions produce codes that are infeasible to
reverse without additional information beyond the identity of
the hash function used to generate the code and the resulting codes.
Non-cryptographic codes, in some circumstances, are believed to be
reversible.
The modules only implement hash
functions that are considered non-cryptographic, with
implementations available in the public domain.

There are a number of algorithms available for the computation of
non-cryptographic 32 and 64-bit hash codes that differ in their
computational complexity,
their relative performance on different size keys, and the
expected uniqueness (randomness) of the resulting hash codes.
Their relative performance in the analysis of text, in particular,
can depend on the compiler, character set, language, and content.
The quality of a hash function is often evaluated using
the SMHasher test suite, originally written by
[Austin Appleby](https://github.com/aappleby/smhasher), but greatly
extended by [Reini Urban](https://github.com/rurban/smhasher).
All except the simplest, `FNV_1` and `FNV_1A`, of the hash functions
defined in the modules perform well on the tests in Reini Urban's
version of SMHasher.

There are two problems in implementing hash functions in Fortran.
First, the static typing of Fortran makes it awkward to define general
purpose hash functions.
Instead hash functions are defined for some of the more common
objects: character strings and rank-1 arrays of integers.
Other objects can, in principle, be hashed by using `transfer` to
map their contents to an integer array, typically one of kind `int8`.
The other problem is that hash codes are typically defined using
modular unsigned integer arithmetic.
As such integers are not part of the current Fortran standard,
workarounds have to be used.
These can take two forms.
In one, the operations are emulated by using an integer of a
larger size, or, for the larger integers, by dividing the integer into
two lower and higher order halves,
and performing the operations on each half separately using
the larger integers.
In the second, the unsigned integers may be replaced directly by
the corresponding signed integers, but
otherwise not modifying the code logic.
The first should be standard conforming on current compilers, but
is more computationally intensive unless the compilers recognize
underlying idioms that are rarely used in Fortran codes. The second is
not standard conforming as bit operations involving the sign are
undefined,
but should yield equivalent results with fewer operations on
compilers with two's complement integers that do not trap on over
or under flow. The codes currently use the second method.

In order to compile the hash function modules, the compilers must
implement much of Fortran 2003, and selected components of Fortran
2008: submodules, 64-bit integers, and some bit intrinsics.
The main limitation on valid compilers is whether they
implement the submodules enhancement of Fortran 2008.
In order to properly run the hash functions, the compilers must
use two's complement integers, and be able to execute them with
wraparound semantics and no integer overflow exceptions.
Current Fortran 2003+ compilers solely use two's complement
integers, and appear to be able to turn off overflow detection,
so the modules use signed integer arithmetic. For that reason
trapping on signed arithmetic must be disabled. The command line
flags to disable overflow detection for compilers implementing
submodules are summarized in the table below.
Note that FLANG, gfortran (since version 10), ifort, and NAG all default to
integer overflow wrapping.

|Compiler|Legal flag|Illegal flag|Default|
|---------|----------|------------|-------|
| ARM Fortran | NA? | NA? | overflow wrapping? |
| Cray Fortran | NA? | NA? | overflow wrapping? |
| FLANG/PGI | -fwrapv | -ftrapv | -fwrapv |
| gfortran | -fwrapv | -ftrapv | -fwrapv |
| IBM Fortran | NA? | NA? | overflow wrapping? |
| ifort| NA? | NA? | overflow wrapping |
| NAG Fortran | -C=none | -C=intovf | -C=none |
| NEC Fortran | NA? | NA? | overflow wrapping? |
| NVIDIA Fortran | NA? | NA? | overflow wrapping? |

All of the modules' hash functions take one or two arguments.
All of them have as their first argument the object to be hashed,
termed a *key*.
Most have a second argument, termed a *seed*, that sets the initial
value of the hash code changing the hash function behavior.
In particular, inputs that hash to the same hash index with a given
seed, will often hash to different indexes with a different seed.
This difference in behavior makes algorithms that use a seed much
more resistant to denial of service attacks that use the properties
of a known hash to increase the number of hash table collisions.
This additional integer must be kept the same for all hashes
in a given hash table, but can be changed and the objects rehashed
if collisions are unusually common.
The *seed* can be either a scalar or a two-element array.
Some of the hash functions have alternatives that allow incremental
hashing.

|Algorithm|Seed|Result|
|---------|----|------|
|FNV-1|None|32 or 64-bit integer|
|FNV-1a|None|32 or 64-bit integer|
|nmhash32 |32-bit scalar integer|32-bit integer|
|nmhash32x |32-bit scalar integer|32-bit integer|
|pengyhash |32-bit scalar integer|64-bit integer|
|Spooky Hash|64-bit two element vector|64-bit two element vector|
|waterhash|64-bit scalar integer|32-bit integer|

The hash function modules each provide at least five algorithms for
hash functions: two optimized for small (< 32 `int8` integer elements)
keys, and three optimized for large (> 100 `int8` integer elements)
keys.
The core implementation for each algorithm is for keys that are
vectors of `int8` integers.
These core implementations are then used in wrappers for keys
that are vectors of `int16`, `int32` and `int64` integers, or default
character strings, in the expectation that inlining will eliminate the
overhead of transferring the other keys to `int8` integer vectors.

The `stdlib_hash_32bit` module provides
implementations of five hash code algorithms:
the *FNV_1* and *FNV_1A* variants of Glenn Fowler,
Landon Curt Noll, and Kiem-Phong Vo;
the *nmhash32* and *nmhash32x* of James Z. M. Gao;
and the *waterhash*  of Tommy Ettinger.
The detailed implementation of each algorithm is handled in a separate
submodule: `stdlib_hash_32bit_fnv`,
`stdlib_hash_32bit_nm`, and `stdlib_hash_32bit_water`,
respectively. The `nmhash32`, `nmhash32x`, and `waterhash` algorithms
require seeds. The submodules provide separate seed generators
for each algorithm.
The module itself
implements two scalar hash functions, `fibonacci_hash` and
`universal_mult_hash`.
It also implements the subroutine, `odd_random_integer`, for
generating seeds for `universal_mult_hash`.
All assume a two's complement sign bit, and no out of
range checks.

The `stdlib_hash_64bit` module also provides
implementations of four hash code algorithms:
the *FNV_1* and *FNV_1A* variants of Glenn Fowler,
Landon Curt Noll, and Kiem-Phong Vo;
the *pengyhash* of Alberto Fajardo;
and the *SpookyHash*  of Bob Jenkins.
The detailed implementation of each algorithm is handled in a separate
submodule: `stdlib_hash_64bit_fnv`,
`stdlib_hash_64bit_pengy`, and `stdlib_hash_64bit_spooky`,
respectively.
The `pengyhash`, and `Spooky Hash` algorithms
require seeds. The submodules provide separate seed generators
for each algorithm.
The module itself implements two scalar hash functions,
`fibonacci_hash` and `universal_mult_hash`.
It also implements the subroutine, `odd_random_integer`, for
generating seeds for `universal_mult_hash`.
All assume a two's complement sign bit, and no out of
range checks.

The `stdlib_hash_32bit_fnv` and `stdlib_hash_64bit_fnv`
submodules each provide implementations of the FNV-1 and FNV-1A
algorithms in the form of two separate overloaded functions: `FNV_1`
and `FNV_1A`.
The FNV-1 and FNV-2 algorithms differ in their order of the
multiplication and exclusive or operations.
They differ from their normal implementation in that they also
encode the structure size in the hash code.
The 32 and 64-bit algorithms differ in their initial offsets and in
their multiplicative constants.
Analysis suggests that `FNV_1A` should be better at randomizing the
input, but tests with hash tables show negligible difference.
These algorithms have the reputation of being particularly useful for
small byte strings, i.e., strings of less than 32 bytes.
While they do not at all perform well on the SMHasher test suite,
usage indicates that this has little impact on the
performance of small hash tables, and the small size of the functions
allows their quick loading and retainment in the instruction cache,
giving a performance boost where the hashing is intermittent.
(See the
[SMHasher discussion](https://github.com/rurban/smhasher/README.md)
and [S. Richter, V. Alvarez, and J. Dittrich. 2015. A Seven-Dimensional Analysis of Hashing Methods and its Implications on Query Processing, Proceedings of the VLDB Endowment, Vol. 9, No. 3.](https://bigdata.uni-saarland.de/publications/p249-richter.pdf) [https://doi.org/10.14778/2850583.2850585](https://doi.org/10.14778/2850583.2850585).

The `stdlib_hash_32bit_nm` submodule provides implementations
of James Z.M. Gao's `nmhash32` and `nmhash32x` algorithms,
version 0.2,
in the form of the overloaded functions, `nmhash32` and `nmhash32x`.
The implementations are based on the scalar versions of Gao's
algorithms and not the vector versions that require access to
the vector instructions of some compilers.
Both algorithms perform well on the SMHasher tests, and have no known
bad seeds. The vector versions of both codes perform well on large
keys, with the `nmhash32x` faster on short keys. To provide randomly
generated seeds for the two functions the submodule also defines the
subroutines `new_nmhash32_seed` and `new_nmhash32x_seed`. Gao claims
that `nmhash32x` is significantly faster than `nmhash32` on short
seeds, but slower on long seeds, but our limited testing so far shows
`nmhash32x` to be significantly faster on short seeds and slightly
faster on long seeds.

The `stdlib_hash_32bit_water` submodule provides implementations
of Tommy Ettinger's `waterhash` algorithm in the form of the overloaded
function, `water_hash`. Water Hash has not been tested by Reini Urban,
but Tommy Ettinger has tested it with Urban's SMHasher and presents
results that shows Water Hash passing all the tests. So far his
testing hasn't found any bad seeds for the algorithm. To provide
randomly generated seeds for the hash function the submodule also
defines the subroutine `new_water_hash_seed`.

The `stdlib_hash_64bit_pengy` submodule provides implementations of
Alberto Fajardo's `pengyhash` in the form of the overloaded function,
`pengy_hash`. Reini Urban's testing shows that PengyHash passes all
the tests and has no bad seeds.  To provide randomly generated seeds
for the hash function the submodule also defines the subroutine
`new_pengy_hash_seed`.

The `stdlib_hash_64bit_spooky` submodule provides implementations
of Bob Jenkins' SpookyHash in the form of the overloaded function,
`spooky_hash`. Future implementations may provide the SpookyHash
incremental hashing procedures.
SpookyHash is optimized for large objects and should give excellent
performance for objects greater than about 96 byes, but has
significant overhead for smaller objects.
The code was designed for little-endian compilers, and will give
different results on big-endian compilers, but the hash quality on
those compilers is probably just as good.
SpookyHash version 2 passes all of Reini Urban's SMHasher tests, and
has one bad seed only when reduced to a 32-bit output.
Its only potential problem is undefined behavior if the key is
misaligned.

## The `stdlib_hash_32bit` module

### Overview of the module

Thirty two bit hash functions are primarily useful for generating hash
codes and hash indices for hash tables.
They tend to be less useful for generating checksums, which generally
benefit from having a larger number of bits.
The `stdlib_hash_32bit` module defines five public overloaded
32-bit hash code functions, `FNV_1`, `FNV-1A`, `nmhash32`, `nmhash32x`
and `water_hash`, two scalar hash functions, `fibonacci_hash` and
`universal_mult_hash`, four seed generators, `odd_random_integer` for
`universal_mult_hash`, and `new_nmhash32_seed`, `new_nmhash32x_seed`,
and `new_water_hash_seed`, for their respective hash code
functions. It also defines the integer kind constant, `int_hash`, and
a logical constant, `little_endian`, used to deal with one aspect of
the machine dependence of the hash codes.

### The `int_hash` parameter

It is necessary to define the kind of integer used to return the hash
code.
As `stdlib_hash_32bit` deals exclusively with 32-bit hash codes,
`int_hash` is an alias for the integer kind `int32`.

### The `little_endian` parameter

In implementing hash functions it is sometimes necessary to know the
"endianess" of the compiler's integers. To this end the
`stdlib_hash_32bit` module defines the logical parameter
`little_endian` that, if true, indicates that the compiler has
little-endian integers, and that if false indicates that the integers
are big-endian.

### Specifications of the `stdlib_hash_32bit` procedures

#### `fibonacci_hash` - maps an integer to a smaller number of bits

##### Status

Experimental

##### Description

Calculates an `nbits` hash code from a 32-bit integer. This is useful
in mapping hash codes into small arrays.

##### Syntax

`code = ` [[stdlib_hash_32bit:fibonacci_hash]] `( key, nbits )`

##### Class

Elemental function

##### Arguments

`key`: Shall be a scalar integer expression of kind `int32`. It is an
`intent(in)` argument.

`nbits` Shall be a scalar default integer expression with `0 < nbits <
32`. It is an `intent(in)` argument.

##### Result

The result is an integer of kind `int32` with at most the lowest
`nbits` nonzero, mapping to a range 0 to `nbits-1`.

##### Note

`fibonacci_hash` is an implementation of the Fibonacci Hash of Donald
E. Knuth. It multiplies the `key` by the odd valued approximation to
`2**32/phi`, where `phi` is the golden ratio 1.618..., and returns the
`nbits` upper bits of the product as the lowest bits of the result.

##### Example

```fortran
{!example/hash_procedures/example_fibonacci_hash.f90!}
```

#### `fnv_1_hash`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32-bit hash code from a rank-1 integer array or a default
character string.

##### Syntax

`code = ` [[stdlib_hash_32bit:fnv_1_hash]] `( key )`

##### Class

Pure/elemental function

##### Argument

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32`.

##### Note

`fnv_1_hash` is an implementation of the original FNV-1 hash code of Glenn
Fowler, Landon Curt Noll, and Phong Vo.
It differs from typical implementations in that it also encodes the
size of the structure in the hash code.
This code is relatively fast on short keys, and is small enough that it
will often be retained in the instruction cache if hashing is
intermittent.
As a result it should give good performance for typical hash table
applications.
This code does not pass any of the SMHasher tests, but the resulting
degradation in performance due to its larger number of collisions is
expected to be minor compared to its faster hashing rate.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.


##### Example

```fortran
{!example/hash_procedures/example_fnv_1_hash.f90!}
```


#### `fnv_1a_hash`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 32-bit hash code from a rank-1 integer array or a default
character string.

##### Syntax

`code = ` [[stdlib_hash_32bit:fnv_1a_hash]] `( key )`

##### Class

Pure/elemental function

##### Argument

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32`.

##### Note

`fnv_1a_hash` is an implementation of the alternative FNV-1a hash code of
Glenn Fowler, Landon Curt Noll, and Phong Vo.
It differs from typical implementations in that it also encodes the
size of the structure in the hash code.
This code is relatively fast on short keys, and is small enough that it
will often be retained in the instruction cache if hashing is
intermittent.
As a result it should give good performance for typical hash table
applications.
This code does not pass any of the SMHasher tests, but the resulting
degradation in performance due to its larger number of collisions is
expected to be minor compared to its faster hashing rate.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.

##### Example

```fortran
{!example/hash_procedures/example_fnv_1a_hash.f90!}
```


#### `new_nmhash32_seed`- returns a valid input seed for `nmhash32`

##### Status

Experimental

##### Description

Calculates a 32-bit "random" integer that is believed to be a valid
seed for `nmhash32` and is also different from the input seed.

##### Syntax

`call ` [[stdlib_hash_32bit:new_nmhash32_seed]] `( seed )`

##### Class

Subroutine

##### Argument

`seed`: shall be a defined integer scalar variable of kind `int32`.
It is an `intent(inout)` argument. On input `seed` should be defined,
and on output it will be different from the input `seed`.

##### Note

Currently there are no known bad seeds for `nmhash32`, but if any are
identified the procedure will be revised so that they cannot be
returned. This subroutine uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.

##### Example

See the example for `nmhash32`.


#### `new_nmhash32x_seed`- returns a valid input seed for `nmhash32x`

##### Status

Experimental

##### Description

Calculates a 32-bit "random" integer that is believed to be a valid
seed for `nmhash32x` and is also different from the input seed.

##### Syntax

`call ` [[stdlib_hash_32bit:new_nmhash32x_seed]] `( seed )`

##### Class

Subroutine

##### Argument

`seed`: shall be a defined integer scalar variable of kind `int32`.
It is an `intent(inout)` argument. On input `seed` should be defined,
and on output it will be different from the input `seed`.

##### Note

Currently there are no known bad seeds for `nmhash32x`, but if any are
identified the procedure will be revised so that they cannot be
returned. This subroutine uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.

##### Example

See the example for `nmhash32x`.


#### `new_water_hash_seed`- returns a valid input seed for `water_hash`

##### Status

Experimental

##### Description

Calculates a 64-bit "random" integer that is believed to be a valid
seed for `water_hash` and is also different from the input seed.

##### Syntax

`call ` [[stdlib_hash_32bit:new_water_hash_seed]] `( seed )`

##### Class

Subroutine

##### Argument

`seed`: shall be a defined integer scalar variable of kind `int64`.
It is an `intent(inout)` argument. On input `seed` should be defined,
and on output it will be different from the input `seed`.

##### Note

Currently there are no known bad seeds for `water_hash`, but if any
are identified the procedure will be revised so that they cannot be
returned. This subroutine uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.


##### Example

See the example for `water_hash`.


#### `nmhash32`- calculates a hash code from a key and a seed

##### Status

Experimental

##### Description

Calculates a 32-bit hash code from a rank-1 integer array or a default
character string, and the input `seed`.

##### Syntax

`code = ` [[stdlib_hash_32bit:nmhash32]] `( key, seed )`

##### Class

Pure/elemental function

##### Arguments

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

`seed`: shall be an integer scalar expression of kind `int32`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32`.

##### Note

`nmhash32` is an implementation of the `nmhash32` hash code of
James Z. M. Gao.
This code has good, but not great, performance on long keys, poorer
performance on short keys.
As a result it should give fair performance for typical hash table
applications.
This code passes the SMHasher tests, and has no known bad seeds.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.

##### Example

```fortran
{!example/hash_procedures/example_nmhash32.f90!}
```


#### `nmhash32x`- calculates a hash code from a key and a seed

##### Status

Experimental

##### Description

Calculates a 32-bit hash code from a rank-1 integer array or a default
character string, and the input `seed`.

##### Syntax

`code = ` [[stdlib_hash_32bit:nmhash32x]] `( key, seed )`

##### Class

Pure/elemental function

##### Arguments

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

`seed`: shall be an integer scalar expression of kind `int32`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32`.

##### Note

`nmhash32x` is an implementation of the `nmhash32x` hash code of
James Z. M. Gao.
This code has good, but not great, performance on long keys, poorer
performance on short keys.
As a result it should give fair performance for typical hash table
applications.
This code passes the SMHasher tests, and has no known bad seeds.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.

##### Example

```fortran
{!example/hash_procedures/example_nmhash32x.f90!}
```

#### `odd_random_integer` - returns an odd integer

##### Status

Experimental

##### Description

Returns a random 32-bit integer distributed uniformly over the odd values.

##### Syntax

`call ` [[stdlib_hash_32bit:odd_random_integer]] `( harvest )`

##### Class

Subroutine

##### Argument

`harvest`: Shall be a scalar integer variable of kind `int32`. It is
an `intent(out)` argument.

##### Note

`odd_random_integer` is intended to generate seeds for
 `universal_mult_hash`. `odd_random_integer` uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.

##### Example

See `universal_mult_hash`.


#### `universal_mult_hash` - maps an integer to a smaller number of bits

##### Status

Experimental

##### Description

Calculates an `nbits` hash code from a 32-bit integer. This is useful
in mapping a hash value to a range 0 to `2**nbits-1`.

##### Syntax

`code = ` [[stdlib_hash_32bit:universal_mult_hash]] `( key, seed, nbits )`

##### Class

Elemental function

##### Arguments

`key`: Shall be a scalar integer expression of kind `int32`. It is an
`intent(in)` argument.

`seed`: Shall be a scalar integer expression of kind `int32`. It is an
`intent(in)` argument. It must have an odd value.

`nbits` Shall be a scalar default integer expression with `0 < nbits <
32`. It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32` with at most the lowest
`nbits` nonzero.

##### Note

`universal_mult_hash` is an implementation of the Universal
Multiplicative Hash of M. Dietzfelbinger, et al.
It multiplies the `key` by `seed`, and returns the
`nbits` upper bits of the product as the lowest bits of the result.

##### Example

```fortran
{!example/hash_procedures/example_universal_mult_hash.f90!}
```

#### `water_hash`- calculates a hash code from a key and a seed

##### Status

Experimental

##### Description

Calculates a 32-bit hash code from a rank-1 integer array or a default
character string, and the input `seed`.

##### Syntax

`code = ` [[stdlib_hash_32bit:water_hash]] `( key, seed )`

##### Class

Pure/elemental function

##### Arguments

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

`seed`: shall be an integer scalar expression of kind `int64`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32`.

##### Note

`water_hash` is an implementation of the `waterhash` hash code of
Tommy Ettinger.
This code has excellent performance on long keys, and good performance
on short keys.
As a result it should give reasonable performance for typical hash
table applications.
This code passes the SMHasher tests.
The `waterhash` is based on the `wyhash` of Wang Yi.
While `wyhash` has a number of bad seeds, where randomization of the
output is poor,
so far testing has not found any bad seeds for `waterhash`.
It can have undefined behavior if the key is not word aligned,
i.e. some computer processors can only process a given size integer if
the address of the integer is a multiple of the integer size.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.

##### Example

```fortran
{!example/hash_procedures/example_water_hash.f90!}
```

## The `stdlib_hash_64bit` module

### Overview of the module

Sixty-four bit hash functions are generally overkill for hash table
applications, and are primarily useful for check sums and related
applications.
As checksums often have to deal with extremely large files or
directories, it is often useful to use incremental hashing as well as
direct hashing, so 64-bit and higher hash algorithms often provide
multiple implementations. The current module, for simplicity of API,
doesn't provide any incremental hashes.
The `stdlib_hash_64bit` module defines several public
overloaded 64-bit hash procedures, `FNV_1`, `FNV-1A`,
`pengy_hash`, and `spooky_hash`, two scalar hash functions,
`fibonacci_hash` and
`universal_mult_hash`, a seed generator, `odd_random_integer`, for the
`universal_mult_hash`, and two seed generators, `new_pengy_hash_seed`
and `new_spooky_hash_seed` for their respective hash functions. It
also defines the integer kind constant, `int_hash`, used to specify
the kind of the hash function results, and a logical constant,
`little_endian`, used to deal with one aspect of the machine
dependence of the hash codes.
Note that while SpookyHash can be used as a sixty-four bit hash
algorithm, its algorithms actually returns two element integer arrays
of kind `int64`, so it can also be used as a 128 bit hash.

### The `int_hash` parameters

It is necessary to define the kind of integer used to return the hash
code.
As `stdlib_haash_64bit` deals exclusively with 64-bit hash codes,
`int_hash` is an alias for the integer kind `int64`.

### The `little_endian` parameter

In implementing hash functions it is sometimes necessary to know the
"endianess" of the compiler's integers. To this end the
`stdlib_hash_64bit` module defines the logical parameter
`little_endian` that if true indicates that the compiler has
little-endian integers, and that if false indicates that the integers
are big-endian.


### Specifications of the `stdlib_hash_64bit` procedures

#### `fibonacci_hash` - maps an integer to a smaller number of bits

##### Status

Experimental

##### Description

Calculates an `nbits` hash code from a 64-bit integer. This is useful
in mapping hash codes into small arrays.

##### Syntax

`code = ` [[stdlib_hash_64bit:fibonacci_hash]] `( key, nbits )`

##### Class

Elemental function

##### Arguments

`key`: Shall be a scalar integer expression of kind `int64`. It is an
`intent(in)` argument.

`nbits` Shall be a scalar default integer expression with `0 < nbits <
64`. It is an `intent(in)` argument.

##### Result

The result is an integer of kind `int64` with at most the lowest
`nbits` nonzero, mapping to a range 0 to `nbits-1`.

##### Note

`fibonacci_hash` is an implementation of the Fibonacci Hash of Donald
E. Knuth. It multiplies the `key` by the odd valued approximation to
`2**64/phi`, where `phi` is the golden ratio 1.618..., and returns the
`nbits` upper bits of the product as the lowest bits of the result.

##### Example

```fortran
{!example/hash_procedures/example_fibonacci_hash_64.f90!}
```

#### `FNV_1`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 64-bit hash code from a rank-1 integer array or a default
character string.

##### Syntax

`code = ` [[stdlib_hash_64bit:fnv_1_hash]] `( key )`

##### Class

Pure/elemental function

##### Argument

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int64`.

##### Note

`FNV_1` is an implementation of the original FNV-1 hash code of Glenn
Fowler, Landon Curt Noll, and Phong Vo.
It differs from typical implementations in that it also ecodes the
size of the structure in the hash code.
This code is relatively fast on short keys, and is small enough that it
will often be retained in the instruction cache if hashing is
intermittent.
As a result it should give good performance for typical hash table
applications, although it is rare for them to need 64 bits.
This code does not pass any of the SMHasher tests, but the resulting
degradation in performance due to its larger number of collisions is
expected to be minor compared to its faster hashing rate.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.


##### Example

```fortran
{!example/hash_procedures/example_fnv_1_hash_64.f90!}
```


#### `FNV_1A`- calculates a hash code from a key

##### Status

Experimental

##### Description

Calculates a 64-bit hash code from a rank-1 integer array or a default
character string.

##### Syntax

`code = ` [[stdlib_hash_64bit:fnv_1a_hash]] `( key )`

##### Class

Pure/elemental function

##### Argument

`key`: Shall be a deferred length default character scalar expression
or a rank-1 integer array expression of kind `int8`, `int16`,
`int32`, or `int64`.
It is an `intent(in)` argument.

##### Result

The result is a scalar integer of kind `int32`.

##### Note

`FNV_1A` is an implementation of the alternative FNV-1a hash code of
Glenn Fowler, Landon Curt Noll, and Phong Vo.
It differs from typical implementations in that it also encodes the
size of the structure in the hash code.
This code is relatively fast on short keys, and is small enough that it
will often be retained in the instruction cache if hashing is
intermittent.
As a result it should give good performance for typical hash table
applications.
This code does not pass any of the SMHasher tests, but the resulting
degradation in performance due to its larger number of collisions is
expected to be minor compared to its faster hashing rate.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.

##### Example

```fortran
{!example/hash_procedures/example_fnv_1a_hash_64.f90!}
```


#### `new_pengy_hash_seed`- returns a valid input seed for `pengy_hash`

##### Status

Experimental

##### Description

Calculates a 32-bit "random" integer that is believed to be a valid
seed for `pengy_hash` and is also different from the input seed.

##### Syntax

`call ` [[stdlib_hash_64bit:new_pengy_hash_seed]] `( seed )`

##### Class

Subroutine

##### Argument

`seed`: shall be a defined integer scalar variable of kind `int32`.
It is an `intent(inout)` argument. On input `seed` should be defined,
and on output it will be different from the input `seed`.

##### Note

Currently there are no known bad seeds for `pengy_hash`, but if any are
identified the procedure will be revised so that they cannot be
returned.  This subroutine uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.

##### Example

See the example for `pengy_hash`.


#### `new_spooky_hash_seed`- returns a valid input seed for `spooky_hash`

##### Status

Experimental

##### Description

Calculates a 32-bit two element vector of "random" integer values that
is believed to be a valid seed for `spooky_hash` and is also different
from the input seed.

##### Syntax

`call ` [[stdlib_hash_64bit:new_spooky_hash_seed]] `( seed )`

##### Class

Subroutine

##### Argument

`seed`: shall be a defined two element integer vector variable of kind
`int32`. It is an `intent(inout)` argument. On input `seed` should be
defined, and on output it will be different from the input `seed`.

##### Note

Currently there are no known bad seeds for `spooky_hash`, but if any are
identified the procedure will be revised so that they cannot be
returned.  This subroutine uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.

##### Example

See the example for `spooky_hash`.


#### `odd_random_integer` - returns odd integer

##### Status

Experimental

##### Description

Returns a random 64-bit integer distributed uniformly over the odd values.

##### Syntax

`call ` [[stdlib_hash_64bit:odd_random_integer]] `( harvest )`

##### Class

Subroutine

##### Argument

`harvest`: Shall be an integer of kind `int64`. It is an `intent(out)`
argument.

##### Note

`odd_random_integer` is intended to generate seeds for
 `universal_mult_hash`. `odd_random_integer` uses Fortran's intrinsic
 `random_number` and the values returned can be changed by calling the
 intrinsic `random_init`.

##### Example

See `universal_mult_hash`.


#### `pengy_hash` - maps a character string or integer vector to an integer

##### Status

Experimental

##### Description

Maps a character string or integer vector to a 64-bit integer whose
value also depends on a scalar 32-bit integer, `seed`.

##### Syntax

`code = ` [[stdlib_hash_64bit:pengy_hash]] `( key, seed )`

#####  Class

Pure/elemental function

##### Arguments

`key`: shall be a scalar  expression of type default character or a
rank-1 integer vector expression of kind `int8`, `int16`, `int32`, or
`int64`. It is an `intent(in)` argument.

`seed`: shall be an integer expression of kind `int64`. It is
an `intent(in)` argument.

##### Result

The result is an integer of kind `int64`.

##### Note

`pengy_hash` is an implementation of the 64-bit `pengyhash` of Alberto
Fajardo. The hash has acceptable performance on small keys, and good
performance on long keys. It passes all the SMHasher tests, and has
no known bad seeds.
It is a *pure* function for integer arrays, and an *elemental*
function for character strings.

##### Example

```fortran
{!example/hash_procedures/example_pengy_hash.f90!}
```


#### `spooky_hash` - maps a character string or integer vector to an integer

##### Status

Experimental

##### Description

Maps a character string or integer vector to a 64-bit integer whose
value also depends on a two element vector,  `seed`.

##### Syntax

`code = ` [[stdlib_hash_64bit:spooky_hash]] `( key, seed )`

#####  Class

Function

##### Arguments

`key`: shall be a scalar of type default character expression or a
rank-1 integer vector expression of kind `int8`, `int16`, `int32`, or
`int64`. It is an `intent(in)` argument.

`seed`: shall be a two element integer vector expression of kind
`int64`. It is an `intent(in)` argument.

##### Result

The result is a two element integer vector of kind `int64`.

##### Note

`spooky_hash` is an implementation of the 64-bit version 2 of
SpookyHash of Bob Jenkins. The code was designed for little-endian
compilers. The output is different on big-endian compilers, but still
probably as good quality. It is often used as a 64-bit hash using the
first element of the returned value, but can be used as a 128 bit
hash. This version of `spooky_hash` has good performance on small keys
and excellent performance on long keys. It passes all the SMHasher tests
and has no known bad seeds.

##### Example

```fortran
{!example/hash_procedures/example_spooky_hash.f90!}
```

#### `universal_mult_hash` - maps an integer to a smaller number of bits

##### Status

Experimental

##### Description

Calculates an `nbits` hash code from a 64-bit integer. This is useful
in mapping a hash value to a range 0 to `2**nbits-1`.

##### Syntax

`code = ` [[stdlib_hash_64bit:universal_mult_hash]] `( key, seed, nbits )`

##### Class

Elemental function

##### Arguments

`key`: Shall be an integer of kind `int64`. It is an `intent(in)`
argument.

`seed`: Shall be an integer of kind `int64`. It is an `intent(in)`
argument. It should be an odd value.

`nbits` Shall be a default integer with `0 < nbits < 64`. It is an
`intent(in)` argument.  It must be an odd integer.

##### Result

The result is an integer of kind `int64` with at most the lowest
`nbits` nonzero.

##### Note

`universal_mult_hash` is an implementation of the Universal
Multiplicative Hash of M. Dietzfelbinger, et al.
It multiplies the `key` by `seed`, and returns the
`nbits` upper bits of the product as the lowest bits of the result.

##### Example


```fortran
{!example/hash_procedures/example_universal_mult_hash_64.f90!}
```


### Test Codes

The Fortran Standard Library provides two categories of test
codes. One category is tests of the relative performance of the
various hash functions. The other is a comparison of the outputs of
the Fortran hash functions, with the outputs of the C and C++ hash
procedures that are the inspiration for the Fortran hash functions.

In the `test/hash_functions_perf` subdirectory, the Fortran Standard
Library provides two performance test codes for
the hash functions of `stdlib_hash_32bit` and
`stdlib_hash_64bit`, `test_32_bit_hash_performance` and
`test_64_bit_hash_performance` respectively. These are primarily set
up to test runtime performance of the functions. They take a sample of
`2**18` integers of kind `int8` and break it up into vectors of size
1, 2, 4, 8, 16, 64,  256, and 1024 elements, yielding `2**18`,
`2**17`, `2**16`, `2**15`, `2**14`, `2**12`, `2**10`, and `2**8`
vectors respectively. These are then processed by the hash functions
4 times, and the time for processing is reported. Testing so far has
been on a MacBook Pro with a 2.3 GHz Quad-Core Intel Core i5 and 8 GB
2133 MHz LPDDR3 of RAM, using GNU Fortran (GCC) 11.1.0 to compile the
code. The results for `test_32_bit_hash_performance` is given by the
following table:

| Algorithm  | Key Size Bytes  | Key #      | Time (s) |
|------------|:---------:|:----------:|:--------:|
|     FNV-1  |       1   |    1048576 |  0.02949 |
|     FNV-1  |       2   |     524288 |  0.02361 |
|     FNV-1  |       4   |     262144 |  0.02016 |
|     FNV-1  |       8   |     131072 |  0.01806 |
|     FNV-1  |      16   |      65536 |  0.01867 |
|     FNV-1  |      64   |      16384 |  0.01717 |
|     FNV-1  |     256   |       4096 |  0.01759 |
|     FNV-1  |    1024   |       1024 |  0.01659 |
|    FNV-1a  |       1   |    1048576 |  0.02897 |
|    FNV-1a  |       2   |     524288 |  0.02472 |
|    FNV-1a  |       4   |     262144 |  0.02025 |
|    FNV-1a  |       8   |     131072 |  0.01901 |
|    FNV-1a  |      16   |      65536 |  0.01898 |
|    FNV-1a  |      64   |      16384 |  0.01784 |
|    FNV-1a  |     256   |       4096 |  0.01723 |
|    FNV-1a  |    1024   |       1024 |  0.01673 |
|  nmhash32  |       1   |    1048576 |  0.31092 |
|  nmhash32  |       2   |     524288 |  0.16230 |
|  nmhash32  |       4   |     262144 |  0.07815 |
|  nmhash32  |       8   |     131072 |  0.04176 |
|  nmhash32  |      16   |      65536 |  0.09261 |
|  nmhash32  |      64   |      16384 |  0.04587 |
|  nmhash32  |     256   |       4096 |  0.07238 |
|  nmhash32  |    1024   |       1024 |  0.07263 |
| nmhash32x  |       1   |    1048576 |  0.04294 |
| nmhash32x  |       2   |     524288 |  0.02937 |
| nmhash32x  |       4   |     262144 |  0.01096 |
| nmhash32x  |       8   |     131072 |  0.00911 |
| nmhash32x  |      16   |      65536 |  0.01291 |
| nmhash32x  |      64   |      16384 |  0.00859 |
| nmhash32x  |     256   |       4096 |  0.07373 |
| nmhash32x  |    1024   |       1024 |  0.07618 |
|     water  |       1   |    1048576 |  0.12560 |
|     water  |       2   |     524288 |  0.06302 |
|     water  |       4   |     262144 |  0.04020 |
|     water  |       8   |     131072 |  0.01999 |
|     water  |      16   |      65536 |  0.01459 |
|     water  |      64   |      16384 |  0.00923 |
|     water  |     256   |       4096 |  0.00816 |
|     water  |    1024   |       1024 |  0.00792 |

while for `test_64_bit_hash_performance` the results are:

| Algorithm  | Key Size Bytes | Key #      | Time (s) |
|------------|:---------:|:----------:|:--------:|
|     FNV-1  |       1   |    1048576 |  0.02981 |
|     FNV-1  |       2   |     524288 |  0.02697 |
|     FNV-1  |       4   |     262144 |  0.02275 |
|     FNV-1  |       8   |     131072 |  0.02431 |
|     FNV-1  |      16   |      65536 |  0.02158 |
|     FNV-1  |      64   |      16384 |  0.02007 |
|     FNV-1  |     256   |       4096 |  0.01932 |
|     FNV-1  |    1024   |       1024 |  0.02089 |
|    FNV-1a  |       1   |    1048576 |  0.03226 |
|    FNV-1a  |       2   |     524288 |  0.03076 |
|    FNV-1a  |       4   |     262144 |  0.02359 |
|    FNV-1a  |       8   |     131072 |  0.02542 |
|    FNV-1a  |      16   |      65536 |  0.02364 |
|    FNV-1a  |      64   |      16384 |  0.02130 |
|    FNV-1a  |     256   |       4096 |  0.01962 |
|    FNV-1a  |    1024   |       1024 |  0.01966 |
|     Pengy  |       1   |    1048576 |  0.24294 |
|     Pengy  |       2   |     524288 |  0.12066 |
|     Pengy  |       4   |     262144 |  0.06205 |
|     Pengy  |       8   |     131072 |  0.03138 |
|     Pengy  |      16   |      65536 |  0.01608 |
|     Pengy  |      64   |      16384 |  0.00669 |
|     Pengy  |     256   |       4096 |  0.00387 |
|     Pengy  |    1024   |       1024 |  0.00295 |
|    Spooky  |       1   |    1048576 |  0.11920 |
|    Spooky  |       2   |     524288 |  0.07478 |
|    Spooky  |       4   |     262144 |  0.03185 |
|    Spooky  |       8   |     131072 |  0.01468 |
|    Spooky  |      16   |      65536 |  0.01503 |
|    Spooky  |      64   |      16384 |  0.00440 |
|    Spooky  |     256   |       4096 |  0.00290 |
|    Spooky  |    1024   |       1024 |  0.00177 |

As the tested function will typically reside in the instruction cache
these results do not include the costs of reloading the procedure if
hashing is intermittent. If hashing is intermittent then that can more
severely impact the performance of  `nmhash32`, `nmhash32x`,
`water_hash`, `pengy_hash`, and `spooky_hash` relative to
`fnv_1_hash` and `fnv_1a_hash`.

In the `test/hash_functions` subdirectory, the Fortran
Standard Library contains codes to test the validity of
the Fortran codes against the original C and C++ codes. It consists of one
executable `test_hash_functions` that
1) generates a random sequence of 2048
integers of kind `int8`, and stores that sequence in the binary file
`key_array.bin`;
2) reads the values in `key_array.bin`, and, for each complicated C/C++-coded
hash procedure, generates a corresponding binary file containing 2049 hash
values generated from the values in `key_array.bin`., and
3) reads the binary files, and, for each complicated C/C++-coded hash procedure,
compares the contents of the binary file
with the results of calculating hash values using the corresponding
Fortran hash procedure on the same keys.

---
title: stats
---

# Descriptive statistics

[TOC]

## `corr` - Pearson correlation of array elements

### Status

Experimental

### Description

Returns the Pearson correlation of the elements of `array` along dimension `dim` if the corresponding element in `mask` is `true`.

The Pearson correlation between two rows (or columns), say `x` and `y`, of `array` is defined as:

```
 corr(x, y) = cov(x, y) / sqrt( var(x) * var(y))
```

### Syntax

`result = ` [[stdlib_stats(module):corr(interface)]] `(array, dim [, mask])`

### Class

Generic subroutine

### Arguments

`array`: Shall be a rank-1 or a rank-2 array of type `integer`, `real`, or `complex`. It is an `intent(in)` argument.

`dim`: Shall be a scalar of type `integer` with a value in the range from 1 to `n`, where `n` is the rank of `array`. It is an `intent(in)` argument.

`mask` (optional): Shall be of type `logical` and either a scalar or an array of the same shape as `array`. It is an `intent(in)` argument.

### Return value

If `array` is of rank 1 and of type `real` or `complex`, the result is of type `real` and has the same kind as `array`.
If `array` is of rank 2 and of type `real` or `complex`, the result is of the same type and kind as `array`.
If `array` is of type `integer`, the result is of type `real(dp)`.

If `array` is of rank 1 and of size larger than 1, a scalar equal to 1 is returned. Otherwise, IEEE `NaN` is returned.
If `array` is of rank 2, a rank-2 array  with the corresponding correlations is returned.

If `mask` is specified, the result is the Pearson correlation of all elements of `array` corresponding to `true` elements of `mask`. If every element of `mask` is `false`, the result is IEEE `NaN`.

### Example

```fortran
{!example/stats/example_corr.f90!}
```

## `cov` - covariance of array elements

### Status

Experimental

### Description

Returns the covariance of the elements of `array` along dimension `dim` if the corresponding element in `mask` is `true`.

Per default, the covariance is defined as:

```
 cov(array) = 1/(n-1) sum_i (array(i) - mean(array) * (array(i) - mean(array)))
```

where `n` is the number of elements.

The scaling can be changed with the logical argument `corrected`. If `corrected` is `.false.`, then the sum is scaled with `n`, otherwise with `n-1`.


### Syntax

`result = ` [[stdlib_stats(module):cov(interface)]] `(array, dim [, mask [, corrected]])`

### Class

Generic subroutine

### Arguments

`array`: Shall be a rank-1 or a rank-2 array of type `integer`, `real`, or `complex`. It is an `intent(in)` argument.

`dim`: Shall be a scalar of type `integer` with a value in the range from 1 to `n`, where `n` is the rank of `array`. It is an `intent(in)` argument.

`mask` (optional): Shall be of type `logical` and either a scalar or an array of the same shape as `array`. It is an `intent(in)` argument.

`corrected` (optional): Shall be a scalar of type `logical`. If `corrected` is `.true.` (default value), the sum is scaled with `n-1`. If `corrected` is `.false.`, then the sum is scaled with `n`. It is an `intent(in)` argument.

### Return value

If `array` is of rank 1 and of type `real` or `complex`, the result is of type `real` corresponding to the type of `array`.
If `array` is of rank 2 and of type `real` or `complex`, the result is of the same type as `array`.
If `array` is of type `integer`, the result is of type `real(dp)`.

If `array` is of rank 1, a scalar with the covariance (that is the variance) of all elements in `array` is returned.
If `array` is of rank 2, a rank-2 array is returned.

If `mask` is specified, the result is the covariance of all elements of `array` corresponding to `true` elements of `mask`. If every element of `mask` is `false`, the result is IEEE `NaN`.

### Example

```fortran
{!example/stats/example_cov.f90!}
```

## `mean` - mean of array elements

### Status

Experimental

### Description

Returns the mean of all the elements of `array`, or of the elements of `array` along dimension `dim` if provided, and if the corresponding element in `mask` is `true`.

### Syntax

`result = ` [[stdlib_stats(module):mean(interface)]] `(array [, mask])`

`result = ` [[stdlib_stats(module):mean(interface)]] `(array, dim [, mask])`

### Class

Generic subroutine

### Arguments

`array`: Shall be an array of type `integer`, `real`, or `complex`. It is an `intent(in)` argument.

`dim`: Shall be a scalar of type `integer` with a value in the range from 1 to `n`, where `n` is the rank of `array`. It is an `intent(in)` argument.

`mask` (optional): Shall be of type `logical` and either a scalar or an array of the same shape as `array`. It is an `intent(in)` argument.

### Return value

If `array` is of type `real` or `complex`, the result is of the same type as `array`.
If `array` is of type `integer`, the result is of type `real(dp)`.

If `dim` is absent, a scalar with the mean of all elements in `array` is returned. Otherwise, an array of rank `n-1`, where `n` equals the rank of `array`, and a shape similar to that of `array` with dimension `dim` dropped is returned.

If `mask` is specified, the result is the mean of all elements of `array` corresponding to `true` elements of `mask`. If every element of `mask` is `false`, the result is IEEE `NaN`.

### Example

```fortran
{!example/stats/example_mean.f90!}
```

## `median` - median of array elements

### Status

Experimental

### Description

Returns the median of all the elements of `array`, or of the elements of `array`
along dimension `dim` if provided, and if the corresponding element in `mask` is
`true`.

The median of the elements of `array` is defined as the "middle"
element, after that the elements are sorted in an increasing order, e.g. `array_sorted =
sort(array)`. If `n = size(array)` is an even number, the median is:

```
median(array) = array_sorted( floor( (n + 1) / 2.))
```

and if `n` is an odd number, the median is:

```
median(array) = mean( array_sorted( floor( (n + 1) / 2.):floor( (n + 1) / 2.) + 1 ) )
```

The current implementation relies on a selection algorithm applied on a copy of
the whole array, using the subroutine [[stdlib_selection(module):select(interface)]]
provided by the [[stdlib_selection(module)]] module.

### Syntax

`result = ` [[stdlib_stats(module):median(interface)]] `(array [, mask])`

`result = ` [[stdlib_stats(module):median(interface)]] `(array, dim [, mask])`

### Class

Generic subroutine

### Arguments

`array`: Shall be an array of type `integer` or `real`. It is an `intent(in)` argument.

`dim`: Shall be a scalar of type `integer` with a value in the range from 1 to `n`, where `n` is the rank of `array`. It is an `intent(in)` argument.

`mask` (optional): Shall be of type `logical` and either a scalar or an array of the same shape as `array`. It is an `intent(in)` argument.

### Return value

If `array` is of type `real`, the result is of type `real` with the same kind as `array`.
If `array` is of type `real` and contains IEEE `NaN`, the result is IEEE `NaN`.
If `array` is of type `integer`, the result is of type `real(dp)`.

If `dim` is absent, a scalar with the median of all elements in `array` is returned. Otherwise, an array of rank `n-1`, where `n` equals the rank of `array`, and a shape similar to that of `array` with dimension `dim` dropped is returned.

If `mask` is specified, the result is the median of all elements of `array` corresponding to `true` elements of `mask`. If every element of `mask` is `false`, the result is IEEE `NaN`.


### Example

```fortran
{!example/stats/example_median.f90!}
```

## `moment` - central moments of array elements

### Status

Experimental

### Description

Returns the _k_-th order central moment of all the elements of `array`, or of the elements of `array` along dimension `dim` if provided, and if the corresponding element in `mask` is `true`.

If a scalar or an array `center` is provided, the function returns the _k_-th order moment about 'center', of all the elements of `array`, or of the elements of `array` along dimension `dim` if provided, and if the corresponding element in `mask` is `true`.


The _k_-th order central moment is defined as :

```
 moment(array) = 1/n sum_i (array(i) - mean(array))^k
```

where `n` is the number of elements.

The _k_-th order moment about `center` is defined as :

```
 moment(array) = 1/n sum_i (array(i) - center)^k
```

### Syntax

`result = ` [[stdlib_stats(module):moment(interface)]] `(array, order [, center [, mask]])`

`result = ` [[stdlib_stats(module):moment(interface)]] `(array, order, dim [, center [, mask]])`

### Class

Generic subroutine

### Arguments

`array`: Shall be an array of type `integer`, `real`, or `complex`.

`order`: Shall be an scalar of type `integer`.

`dim`: Shall be a scalar of type `integer` with a value in the range from 1 to `n`, where `n` is the rank of `array`.

`center` (optional): Shall be a scalar of the same type of `result` if `dim` is not provided. If `dim` is provided, `center` shall be a scalar or an array (with a shape similar to that of `array` with dimension `dim` dropped) of the same type of `result`.

`mask` (optional): Shall be of type `logical` and either a scalar or an array of the same shape as `array`.

### Return value

If `array` is of type `real` or `complex`, the result is of the same type as `array`.
If `array` is of type `integer`, the result is of type `real(dp)`.

If `dim` is absent, a scalar with the _k_-th (central) moment of all elements in `array` is returned. Otherwise, an array of rank `n-1`, where `n` equals the rank of `array`, and a shape similar to that of `array` with dimension `dim` dropped is returned.

If `mask` is specified, the result is the _k_-th  (central) moment of all elements of `array` corresponding to `true` elements of `mask`. If every element of `mask` is `false`, the result is IEEE `NaN`.

### Example

```fortran
{!example/stats/example_moment.f90!}
```

## `var` - variance of array elements

### Status

Experimental

### Description

Returns the variance of all the elements of `array`, or of the elements of `array` along dimension `dim` if provided, and if the corresponding element in `mask` is `true`.

Per default, the variance is defined as the best unbiased estimator and is computed as:

```
 var(array) = 1/(n-1) sum_i (array(i) - mean(array))^2
```

where `n` is the number of elements.

The use of the term `n-1` for scaling is called Bessel 's correction. The scaling can be changed with the logical argument `corrected`. If `corrected` is `.false.`, then the sum is scaled with `n`, otherwise with `n-1`.


### Syntax

`result = ` [[stdlib_stats(module):var(interface)]] `(array [, mask [, corrected]])`

`result = ` [[stdlib_stats(module):var(interface)]] `(array, dim [, mask [, corrected]])`

### Class

Generic subroutine

### Arguments

`array`: Shall be an array of type `integer`, `real`, or `complex`. It is an `intent(in)` argument.

`dim`: Shall be a scalar of type `integer` with a value in the range from 1 to `n`, where `n` is the rank of `array`. It is an `intent(in)` argument.

`mask` (optional): Shall be of type `logical` and either a scalar or an array of the same shape as `array`. It is an `intent(in)` argument.

`corrected` (optional): Shall be a scalar of type `logical`. If `corrected` is `.true.` (default value), the sum is scaled with `n-1`. If `corrected` is `.false.`, then the sum is scaled with `n`. It is an `intent(in)` argument.

### Return value

If `array` is of type `real` or `complex`, the result is of type `real` corresponding to the type of `array`.
If `array` is of type `integer`, the result is of type `real(dp)`.

If `dim` is absent, a scalar with the variance of all elements in `array` is returned. Otherwise, an array of rank `n-1`, where `n` equals the rank of `array`, and a shape similar to that of `array` with dimension `dim` dropped is returned.

If `mask` is specified, the result is the variance of all elements of `array` corresponding to `true` elements of `mask`. If every element of `mask` is `false`, the result is IEEE `NaN`.

If the variance is computed with only one single element, then the result is IEEE `NaN` if `corrected` is `.true.` and is `0.` if `corrected` is `.false.`.

### Example

```fortran
{!example/stats/example_var.f90!}
```

---
title: array
---

# The `stdlib_array` module

[TOC]

## Introduction

Module for index manipulation and array handling tasks.

## Procedures and methods provided


### `trueloc`

#### Status

Experimental

#### Description

Turn a logical mask into an index array by selecting all true values.
Provides similar functionality like the built-in `where` or the intrinsic procedures `merge` and `pack` when working with logical mask.
The built-in / intrinsics are usually preferable to `trueloc`, unless the access to the index array is required.

#### Syntax

`loc =` [[trueloc(function)]] `(array[, lbound])`

#### Class

Pure function.

#### Arguments

`array`: List of default logical arrays. This argument is `intent(in)`.

`lbound`: Lower bound of the array to index. This argument is `optional` and `intent(in)`.

#### Return value

Returns an array of default integer size, with a maximum length of `size(array)` elements.

#### Examples

```fortran
{!example/array/example_trueloc.f90!}
```


### `falseloc`

#### Status

Experimental

#### Description

Turn a logical mask into an index array by selecting all false values.
Provides similar functionality like the built-in `where` or the intrinsic procedures `merge` and `pack` when working with logical mask.
The built-in / intrinsics are usually preferable to `falseloc`, unless the access to the index array is required.

#### Syntax

`loc =` [[falseloc(function)]] `(array[, lbound])`

#### Class

Pure function.

#### Arguments

`array`: List of default logical arrays. This argument is `intent(in)`.

`lbound`: Lower bound of the array to index. This argument is `optional` and `intent(in)`.

#### Return value

Returns an array of default integer size, with a maximum length of `size(array)` elements.

#### Examples

```fortran
{!example/array/example_falseloc.f90!}
```

---
title: error
---

# The `stdlib_error` module

[TOC]

## Introduction

Catching and handling errors.

## Procedures and methods provided


### `check` - Checks the value of a logical condition

#### Status

Experimental

#### Description

Checks the value of a logical condition.

#### Syntax

`call ` [[check(subroutine)]] `(condition, msg, code, warn)`


#### Arguments

`condition`: Shall be a scalar of type `logical`.

`msg` (optional): Shall be a character expression containing the message to be printed to `stderr`. The default `msg` is 'Check failed.'.

`code` (optional): Shall be a scalar of type `integer`. The default `code` is `1`.

`warn` (optional): Shall be a scalar of type `logical`. The default `warn` is `.true.`.

#### Return value

If `condition` is `.false.`, and:

 * no other arguments are provided, this subroutine stops the program with the default message and exit code 1;

 * `msg` is provided, this subroutine stops the program and it prints the value of `msg`;

 * `code` is provided, this subroutine stops the program with the given exit code;

 * `warn` is provided and `warn` is `.true.`, this subroutine doesn't stop the program and prints the message.

#### Examples

```fortran
{!example/error/example_check1.f90!}
```
```fortran
{!example/error/example_check2.f90!}
```
```fortran
{!example/error/example_check3.f90!}
```
```fortran
{!example/error/example_check4.f90!}
```

### `error_stop` - aborts the program

#### Status

Experimental

#### Description

Aborts the program with a message and a nonzero exit code.

#### Syntax

`call ` [[stdlib_error(module):error_stop(interface)]] `(msg, code)`

#### Arguments

`msg`: Shall be a character expression containing the message to be printed to `stderr`.

`code` (optional): Shall be a scalar of type `integer` to be returned as exit code.

#### Output

Aborts the program with printing the message `msg` to `stderr` and a nonzero exit code. The nonzero exit code is equal to `code` if provided, and 1 otherwise.

#### Examples

Without error code:

```fortran
{!example/error/example_error_stop1.f90!}
```

With error code:

```fortran
{!example/error/example_error_stop2.f90!}
```

---
title: selection
---

# The `stdlib_selection` module

[TOC]

## Overview of selection

Suppose you wish to find the value of the k-th smallest entry in an array of size N, or
the index of that value. While it could be done by sorting the whole array
using [[stdlib_sorting(module):sort(interface)]] or 
[[stdlib_sorting(module):sort_index(interface)]] from 
[[stdlib_sorting(module)]] and then finding the k-th entry, that would
require O(N x LOG(N)) time. However selection of a single entry can be done in
O(N) time, which is much faster for large arrays.  This is useful, for example,
to quickly find the median of an array, or some other percentile.

The Fortran Standard Library therefore provides a module, `stdlib_selection`,
which implements selection algorithms.

## Overview of the module

The module `stdlib_selection` defines two generic subroutines:

* `select` is used to find the k-th smallest entry of an array. The input
array is also modified in-place, and on return will be partially sorted
such that `all(array(1:k) <= array(k)))`  and `all(array(k) <= array((k+1):size(array)))` is true.
The user can optionally specify `left` and `right` indices to constrain the search
for the k-th smallest value. This can be useful if you have previously called `select`
to find a smaller or larger rank (that will have led to partial sorting of
`array`, thus implying some constraints on the location).

* `arg_select` is used to find the index of the k-th smallest entry of an array.
In this case the input array is not modified, but the user must provide an
input index array with the same size as `array`, having indices that are a permutation of
`1:size(array)`, which is modified instead. On return the index array is modified
such that `all(array(index(1:k)) <= array(index(k)))` and `all(array(k) <= array(k+1:size(array)))`.
The user can optionally specify `left` and `right` indices to constrain the search
for the k-th smallest value. This can be useful if you have previously called `arg_select`
to find a smaller or larger rank (that will have led to partial sorting of
`index`, thus implying some constraints on the location).


## `select` - find the k-th smallest value in an input array

### Status

Experimental

### Description

Returns the k-th smallest value of `array(:)`, and also partially sorts `array(:)`
such that `all(array(1:k) <= array(k))`  and `all(array(k) <= array((k+1):size(array)))`

### Syntax

`call ` [[stdlib_selection(module):select(interface)]] `( array, k, kth_smallest [, left, right ] )`

### Class

Generic subroutine.

### Arguments

`array` : shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`, `real(xdp)`, `real(qp)`. It is an `intent(inout)` argument. 

`k`: shall be a scalar with any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`. It
is an `intent(in)` argument. We search for the `k`-th smallest entry of `array(:)`.

`kth_smallest`: shall be a scalar with the same type as `array`. It is an
`intent(out)` argument. On return it contains the k-th smallest entry of
`array(:)`.

`left` (optional): shall be a scalar with the same type as `k`. It is an
`intent(in)` argument. If specified then we assume the k-th smallest value is
definitely contained in `array(left:size(array))`. If `left` is not present,
the default is 1. This is typically useful if multiple calls to `select` are
made, because the partial sorting of `array` implies constraints on where we
need to search.

`right` (optional): shall be a scalar with the same type as `k`. It is an
`intent(in)` argument. If specified then we assume the k-th smallest value is
definitely contained in `array(1:right)`. If `right` is not present, the
default is `size(array)`. This is typically useful if multiple calls to
`select` are made, because the partial sorting of `array` implies constraints
on where we need to search.

### Notes

Selection of a single value should have runtime of O(`size(array)`), so it is
asymptotically faster than sorting `array` entirely. The test program at the
end of this document shows that is the case.

The code does not support `NaN` elements in `array`; it will run, but there is
no consistent interpretation given to the order of `NaN` entries of `array`
compared to other entries.

`select` was derived from code in the Coretran library by Leon Foks,
https://github.com/leonfoks/coretran. Leon Foks has given permission for the
code here to be released under stdlib's MIT license.

### Example

```fortran
{!example/selection/example_select.f90!}
```

## `arg_select` - find the index of the k-th smallest value in an input array

### Status

Experimental

### Description

Returns the index of the k-th smallest value of `array(:)`, and also partially sorts
the index-array `indx(:)` such that `all(array(indx(1:k)) <= array(indx(k)))`  and
`all(array(indx(k)) <= array(indx((k+1):size(array))))`

### Syntax

`call ` [[stdlib_selection(module):arg_select(interface)]] `( array, indx, k, kth_smallest [, left, right ] )`

### Class

Generic subroutine.

### Arguments

`array` : shall be a rank one array of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`,
`real(sp)`, `real(dp)`, `real(xdp)`, `real(qp)`. It is an `intent(in)` argument. On input it is
the array in which we search for the k-th smallest entry.

`indx`: shall be a rank one array with the same size as `array`, containing all integers
from `1:size(array)` in any order. It is of any of the types:
`integer(int8)`, `integer(int16)`, `integer(int32)`, `integer(int64)`. It is an
`intent(inout)` argument. On return its elements will define a partial sorting of `array(:)` such that:
 `all( array(indx(1:k-1)) <= array(indx(k)) )` and `all(array(indx(k)) <= array(indx(k+1:size(array))))`.

`k`: shall be a scalar with the same type as `indx`. It is an `intent(in)`
argument. We search for the `k`-th smallest entry of `array(:)`.

`kth_smallest`: a scalar with the same type as `indx`. It is an `intent(out)` argument,
and on return it contains the index of the k-th smallest entry of `array(:)`.

`left` (optional): shall be a scalar with the same type as `k`. It is an `intent(in)`
argument. If specified then we assume the k-th smallest value is definitely contained
in `array(indx(left:size(array)))`. If `left` is not present, the default is 1.
This is typically useful if multiple calls to `arg_select` are made, because
the partial sorting of `indx` implies constraints on where we need to search.

`right` (optional): shall be a scalar with the same type as `k`. It is an `intent(in)`
argument. If specified then we assume the k-th smallest value is definitely contained
in `array(indx(1:right))`. If `right` is not present, the default is
`size(array)`. This is typically useful if multiple calls to `arg_select` are
made, because the reordering of `indx` implies constraints on where we need to
search.

### Notes

`arg_select` does not modify `array`, unlike `select`.

The partial sorting of `indx` is not stable, i.e., indices that map to equal
values of array may be reordered.

The code does not support `NaN` elements in `array`; it will run, but there is
no consistent interpretation given to the order of `NaN` entries of `array`
compared to other entries.

While it is essential that `indx` contains a permutation of the integers `1:size(array)`, 
the code does not check for this. For example if `size(array) == 4`, then we could have 
`indx = [4, 2, 1, 3]` or `indx = [1, 2, 3, 4]`, but not `indx = [2, 1, 2, 4]`. It is the user's
responsibility to avoid such errors.

Selection of a single value should have runtime of O(`size(array)`), so it is
asymptotically faster than sorting `array` entirely. The test program at the end of
these documents confirms that is the case.

`arg_select` was derived using code from the Coretran library by Leon Foks,
https://github.com/leonfoks/coretran. Leon Foks has given permission for the
code here to be released under stdlib's MIT license.

### Example


```fortran
{!example/selection/example_arg_select.f90!}
```

## Comparison with using `sort`

The following program compares the timings of `select` and `arg_select` for
computing the median of an array, vs using `sort` from `stdlib`.  In theory we
should see a speed improvement with the selection routines which grows like
LOG(size(`array`)).

```fortran
{!example/selection/selection_vs_sort.f90!}
```

The results seem consistent with expectations when the `array` is large; the program prints:
```
 select    ; N=           1 ; PASS; Relative-speedup-vs-sort:   1.90928173    
 arg_select; N=           1 ; PASS; Relative-speedup-vs-sort:   1.76875830    
 select    ; N=          11 ; PASS; Relative-speedup-vs-sort:   1.14835048    
 arg_select; N=          11 ; PASS; Relative-speedup-vs-sort:   1.00794709    
 select    ; N=         101 ; PASS; Relative-speedup-vs-sort:   2.31012774    
 arg_select; N=         101 ; PASS; Relative-speedup-vs-sort:   1.92877376    
 select    ; N=        1001 ; PASS; Relative-speedup-vs-sort:   4.24190664    
 arg_select; N=        1001 ; PASS; Relative-speedup-vs-sort:   3.54580402    
 select    ; N=       10001 ; PASS; Relative-speedup-vs-sort:   5.61573362    
 arg_select; N=       10001 ; PASS; Relative-speedup-vs-sort:   4.79348087    
 select    ; N=      100001 ; PASS; Relative-speedup-vs-sort:   7.28823519    
 arg_select; N=      100001 ; PASS; Relative-speedup-vs-sort:   6.03007460    
```

---
title: random
---

# Statistical Distributions -- Pseudorandom Number Generator Module

[TOC]

## `random_seed` - set or get a value of seed to the probability distribution pseudorandom number generator

### Status

Experimental

### Description

Set or get the seed value before calling the probability distribution pseudorandom number generator for variates.

### Syntax

`call ` [[stdlib_random(module):random_seed(interface)]] `(put, get)`

### Arguments

`put`: argument has `intent(in)` and may be a scalar of type `integer`.

`get`: argument has `intent(out)` and is a scalar of type `integer`.

### Return value

Return a scalar of type `integer`.

### Example

```fortran
{!example/random/example_random_seed.f90!}
```

## `dist_rand` - Get a random integer with specified kind

### Status

Experimental

### Description

Generate an integer pseudorandom number in a specific range [-2^k, 2^k - 1] according to the input integer kind n. This pseudorandom number will be operated by bit opeartors instead of normal arithmetic operators.

### Syntax

`result = ` [[stdlib_random(module):dist_rand(interface)]] `(n)`

### Arguments

`n`: argument has `intent(in)` is a scalar of type `integer`.

### Return value

Return a scalar of type `integer`.

### Example

```fortran
{!example/random/example_dist_rand.f90!}
```

---
title: stringlist_type
---

# `stdlib_stringlist_type` module (1-D list of strings)

[TOC]

## Introduction

The `stdlib_stringlist_type` module provides with 2 derived types to deal with lists of strings.
`stringlist_type` derived type represents one-dimensional list of variable-length strings (also referred as one-dimensional stringlist) which is compatible with Fortran intrinsic character and `stringlist_index_type` derived type represents an index to access, modify the elements of a stringlist, insert elements to a stringlist and much more.

## Derived types provided

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stringlist_type` derived type

The `stringlist_type` derived type represents one-dimensional list of strings (also referred as one-dimensional stringlist).  
The internal representation of the list is implementation dependent and is not visible to the user of the module.

Note: _stringlist_ is an abstract concept which is expressed through the derived type `stringlist_type`.

#### Status

Experimental


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### `stringlist_index_type` derived type

An instance of the derived type `stringlist_index_type` represents either a forward index OR a backward index. 
The internal representation is implementation dependent and is not visible to the user of the module.  
`list_head` and `list_tail` are 2 special instances of this type representing the head and the tail of a stringlist respectively.
An index is independent of the stringlist(or `stringlist_type`) it is used with and hence, an index can be used with multiple stringlists in the same program.

#### Status

Experimental


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### fidx/bidx

#### Description

`fidx`: Returns an instance which represents forward index `idx`.  
`bidx`: Returns an instance which represents backward index `idx`.

#### Syntax

For fidx: `res = ` [[stdlib_stringlist_type(module):fidx(interface)]] ` (idx)`
For bidx: `res = ` [[stdlib_stringlist_type(module):bidx(interface)]] ` (idx)`

#### Status

Experimental.

#### Class

Pure function.

#### Argument

- `idx`: Shall be of kind `integer`.
  This argument is `intent(in)`.

#### Result value

The result is of type `stringlist_index_type`.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_fidx_bidx.f90!}
```

<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Constructor for `stringlist_type`(or stringlist)

#### Description

No arguments given: Initializes an empty stringlist(a stringlist containing no elements in it).

With argument: Initializes a stringlist equivalent to the input array `array` i.e. a stringlist containing all elements of the input array `array` in the same order.

#### Syntax

`res = ` [[stdlib_stringlist_type(module):stringlist_type(interface)]] ` ([array])`

#### Status

Experimental

#### Class

Pure function.

#### Argument

- `array`: Shall be an array of `character` scalar or array of [[stdlib_string_type(module):string_type(type)]].
 This argument is `intent(in)` and `optional`.

#### Result value

The result is an instance of type `stringlist_type`.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_constructor.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### insert_at

#### Description

Inserts the string `string` _AT_ the index `idx`, so that the newly added element is present at index `idx` after insertion. Inserting an element _AT_ index beyond `length + 1` inserts the element _AT_ `list_tail`, and likewise inserting _AT_ a non-positive index inserts the element _AT_ `list_head`.

#### Syntax

`call ` [[stdlib_stringlist_type(module):stringlist_type(type)]] `%` [[stringlist_type(type):insert_at(bound)]] ` (idx, string)`

#### Status

Experimental.

#### Class

Pure subroutine.

#### Argument

- `idx`: [[stdlib_stringlist_type(module):stringlist_index_type(type)]].
  This argument is `intent(in)`.

- `string`: Character scalar or [[stdlib_string_type(module):string_type(type)]].
  This argument is `intent(in)`.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_insert_at.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### get

#### Description

Returns the string present currently at the index `idx` in a stringlist. If index `idx` is out of bounds, then an empty string is returned.

#### Syntax

`res = ` [[stdlib_stringlist_type(module):stringlist_type(type)]] `%` [[stringlist_type(type):get(bound)]] ` (idx)`

#### Status

Experimental.

#### Class

Pure function.

#### Argument

- `idx`: [[stdlib_stringlist_type(module):stringlist_index_type(type)]].
  This argument is `intent(in)`.

#### Result value

The result is a string of type `string_type`.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_get.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### len

#### Description

Returns the number of elements present currently in the stringlist.

#### Syntax

`res = ` [[stdlib_stringlist_type(module):stringlist_type(type)]] `%` [[stringlist_type(type):len(bound)]] ` ()`

#### Status

Experimental.

#### Class

Pure function.

#### Argument

No arguments.

#### Result value

The result is of type `integer`.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_len.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### clear

#### Description

Removes all elements from a stringlist.

#### Syntax

`call ` [[stdlib_stringlist_type(module):stringlist_type(type)]] `%` [[stringlist_type(type):clear(bound)]] ` ()`

#### Status

Experimental.

#### Class

Pure subroutine.

#### Argument

No arguments.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_clear.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator equal

#### Description

Compares left hand side (lhs) with right hand side (rhs) for equality.

#### Syntax

`res = lhs == rhs`

`res = lhs .eq. rhs`

#### Status

Experimental.

#### Class

Pure function, `operator(==)` and `operator(.eq.)`.

#### Argument

- `lhs`: Shall be an array of `character` scalar or of [[stdlib_string_type(module):string_type(type)]] OR 
a [[stdlib_stringlist_type(module):stringlist_type(type)]].
 This argument is `intent(in)`.
 
- `rhs`: Shall be an array of `character` scalar or of [[stdlib_string_type(module):string_type(type)]] OR 
a [[stdlib_stringlist_type(module):stringlist_type(type)]].
 This argument is `intent(in)`.

#### Result value

The result is a default `logical` scalar value.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_equality_operator.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Comparison operator not equal

#### Description

Compares left hand side (lhs) with right hand side (rhs) for inequality.

#### Syntax

`res = lhs /= rhs`

`res = lhs .ne. rhs`

#### Status

Experimental.

#### Class

Pure function, `operator(/=)` and `operator(.ne.)`.

#### Argument

- `lhs`: Shall be an array of `character` scalar or of [[stdlib_string_type(module):string_type(type)]] OR 
a [[stdlib_stringlist_type(module):stringlist_type(type)]].
 This argument is `intent(in)`.
 
- `rhs`: Shall be an array of `character` scalar or of [[stdlib_string_type(module):string_type(type)]] OR 
a [[stdlib_stringlist_type(module):stringlist_type(type)]].
 This argument is `intent(in)`.

#### Result value

The result is a default `logical` scalar value.

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_inequality_operator.f90!}
```


<!-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -->
### Concatenation operator(//)

#### Description

Returns the concatenated output of left hand side (lhs) and right hand side (rhs).

#### Syntax

`res = lhs // rhs`

#### Status

Experimental.

#### Class

Pure function, `operator(//)`.

#### Argument

- `lhs`: Shall be a `character` scalar or [[stdlib_string_type(module):string_type(type)]] OR an array of `character` scalar or of [[stdlib_string_type(module):string_type(type)]] OR 
a [[stdlib_stringlist_type(module):stringlist_type(type)]].
 This argument is `intent(in)`.
 
- `rhs`: Shall be a `character` scalar or [[stdlib_string_type(module):string_type(type)]] OR an array of `character` scalar or of [[stdlib_string_type(module):string_type(type)]] OR 
a [[stdlib_stringlist_type(module):stringlist_type(type)]].
 This argument is `intent(in)`.

#### Result value

The result is an instance of [[stdlib_stringlist_type(module):stringlist_type(type)]].

#### Example

```fortran
{!example/stringlist_type/example_stringlist_type_concatenate_operator.f90!}
```

---
title: stats_distribution_normal
---

# Statistical Distributions -- Normal Distribution Module

[TOC]

## `rvs_normal` - normal distribution random variates

### Status

Experimental

### Description

A normal continuous random variate distribution, also known as Gaussian, or Gauss or Laplace-Gauss distribution.
The location `loc` specifies the mean or expectation (\(\mu\)). The `scale` specifies the standard deviation (\(\sigma\)).

Without argument, the function returns a standard normal distributed random variate \(N(0,1)\).

With two arguments, the function returns a normal distributed random variate \(N(\mu=\text{loc}, \sigma^2=\text{scale}^2)\). For complex arguments, the real and imaginary parts are independent of each other.

With three arguments, the function returns a rank-1 array of normal distributed random variates.

With one or two arguments where the first is `array_size`, the function returns a rank-1 array of standard normal distributed random variates \(N(0,1)\). The `mold` argument determines the output type and kind; it is optional only for `real(dp)` (and defaults to `real(dp)` when omitted), but required for all other types.

@note
The algorithm used for generating exponential random variates is fundamentally limited to double precision.[^1]

### Syntax

`result = ` [[stdlib_stats_distribution_normal(module):rvs_normal(interface)]] `([loc, scale] [[, array_size]])`

`result = ` [[stdlib_stats_distribution_normal(module):rvs_normal(interface)]] `(array_size [, mold])`

### Class

Elemental function (passing both `loc` and `scale`).

### Arguments

`loc`: optional argument has `intent(in)` and is a scalar of type `real` or `complex`.

`scale`: optional argument has `intent(in)` and is a positive scalar of type `real` or `complex`.

`array_size`: optional argument has `intent(in)` and is a scalar of type `integer`. When used with `loc` and `scale`, specifies the size of the output array. When used alone or with `mold`, must be provided as the first argument.

`mold`: optional argument (only for `real(dp)`; required for other types) has `intent(in)` and is a scalar of type `real` or `complex`. Used only to determine the type and kind of the output; its value is not referenced. When omitted (only allowed for `real(dp)`), defaults to `real(dp)`. When provided, generates standard normal variates \(N(0,1)\) of the specified type and kind.

`loc` and `scale` arguments must be of the same type.

### Return value

The result is a scalar or rank-1 array, with a size of `array_size`, and the same type as `scale` and `loc` (or same type and kind as `mold` when using the `array_size [, mold]` form; defaults to `real(dp)` when `mold` is omitted). If `scale` is non-positive, the result is `NaN`.

### Example

```fortran
{!example/stats_distribution_normal/example_normal_rvs.f90!}
```

## `pdf_normal` - normal distribution probability density function

### Status

Experimental

### Description

The probability density function (pdf) of the single real variable normal distribution:

$$f(x) = \frac{1}{\sigma \sqrt{2\pi}} \exp{\left[-\frac{1}{2}\left(\frac{x-\mu}{\sigma}\right)^{2}\right]}$$

For a complex varible \( z=(x + y i) \) with independent real \( x \) and imaginary \( y \) parts, the joint probability density function is the product of the the corresponding real and imaginary marginal pdfs:[^2]

$$f(x + y \mathit{i}) = f(x) f(y) = \frac{1}{2\pi\sigma_{x}\sigma_{y}} \exp{\left[-\frac{1}{2}\left(\left(\frac{x-\mu_x}{\sigma_{x}}\right)^{2}+\left(\frac{y-\mu_y}{\sigma_{y}}\right)^{2}\right)\right]}$$

### Syntax

`result = ` [[stdlib_stats_distribution_normal(module):pdf_normal(interface)]] `(x, loc, scale)`

### Class

Elemental function

### Arguments

`x`: has `intent(in)` and is a scalar of type `real` or `complex`.

`loc`: has `intent(in)` and is a scalar of type `real` or `complex`.

`scale`: has `intent(in)` and is a positive scalar of type `real` or `complex`.

All three arguments must have the same type.

### Return value

The result is a scalar or an array, with a shape conformable to the arguments, and the same type as the input arguments. If `scale` is non-positive, the result is `NaN`.

### Example

```fortran
{!example/stats_distribution_normal/example_normal_pdf.f90!}
```

## `cdf_normal` - normal distribution cumulative distribution function

### Status

Experimental

### Description

Cumulative distribution function of the single real variable normal distribution:

$$F(x) = \frac{1}{2}\left [ 1+\text{erf}\left(\frac{x-\mu}{\sigma \sqrt{2}}\right) \right ]$$

For the complex variable \( z=(x + y i) \) with independent real \( x \) and imaginary \( y \) parts, the joint cumulative distribution function is the product of the corresponding real and imaginary marginal cdfs:[^2]

$$ F(x+y\mathit{i})=F(x)F(y)=\frac{1}{4} \
\left[ 1+\text{erf}\left(\frac{x-\mu_x}{\sigma_x \sqrt{2}}\right) \right] \
\left[ 1+\text{erf}\left(\frac{y-\mu_y}{\sigma_y \sqrt{2}}\right) \right] $$

### Syntax

`result = ` [[stdlib_stats_distribution_normal(module):cdf_normal(interface)]] `(x, loc, scale)`

### Class

Elemental function

### Arguments

`x`: has `intent(in)` and is a scalar of type `real` or `complex`.

`loc`: has `intent(in)` and is a scalar of type `real` or `complex`.

`scale`: has `intent(in)` and is a positive scalar of type `real` or `complex`.

All three arguments must have the same type.

### Return value

The result is a scalar or an array, with a shape conformable to the arguments, and the same type as the input arguments. If `scale` is non-positive, the result is `NaN`.

### Example

```fortran
{!example/stats_distribution_normal/example_normal_cdf.f90!}
```

[^1]: Marsaglia, George, and Wai Wan Tsang. "The ziggurat method for generating random variables." _Journal of statistical software_ 5 (2000): 1-7.

[^2]: Miller, Scott, and Donald Childers. _Probability and random processes: With applications to signal processing and communications_. Academic Press, 2012 (p. 197).
